﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace DMS
{
    public partial class DCDataInfo : Form
    {
        public DCDataInfo()
        {
            InitializeComponent();
        }
        /// <summary>
        /// 窗体初始化的相关函数
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void DCDataInfo_Load(object sender, EventArgs e)
        {

            //datagridview中字体显示设置
            Font font = new Font("Times New Roman", 12);//UTF-8是字体的编码格式，2是字体大小
            dataGridView1.Font = font;


            DataTable dt = new DataTable();//建立个数据表
            dt.Columns.Add(new DataColumn("通道号", typeof(string)));//在表中添加int类型的列
            dt.Columns.Add(new DataColumn("设备名称", typeof(string)));//在表中添加string类型的Name列
            dt.Columns.Add(new DataColumn("采集值1", typeof(string)));
            dt.Columns.Add(new DataColumn("采集值2", typeof(string)));
            dt.Columns.Add(new DataColumn("采集值3", typeof(string)));
            dt.Columns.Add(new DataColumn("采集时间", typeof(string)));

            listBCabinFaultData(dt);
        }



        /// <summary>
        ///   2.2在平台状态信息页--列表实时显示B舱故障值表格
        ///   这个相当于可以初始化datagridview初始化的时候可以初始化多少行空格
        /// </summary>
        /// <param name="dt"></param>
        public  void listBCabinFaultData(DataTable dt)
        {
            try
            {
                dataGridView1.Columns.Clear();
                dataGridView1.DataSource = dt;
                dataGridView1.ColumnHeadersDefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleCenter;
                dataGridView1.ReadOnly = true;
                dataGridView1.AllowUserToAddRows = false;
                dataGridView1.AllowUserToDeleteRows = false;
                dataGridView1.Columns[1].Width = 150;

                //Application.DoEvents();

                while (dataGridView1.Rows.Count < 5)
                    ((DataTable)dataGridView1.DataSource).Rows.Add();

                for (int i = 0; i < dataGridView1.Columns.Count; i++)
                {
                    dataGridView1.Columns[i].SortMode = DataGridViewColumnSortMode.NotSortable;
                }

            }
            catch (Exception exp)
            {
                LogClass.WriteLogFile("数据采集器传感器采集值数据加载异常！" + exp.Message);
            }
        }
    }
}
