﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.IO;
using System.Runtime.InteropServices;

namespace DMS
{
    public partial class Main : Form
    {
        private MyServerClass exp;
        public Main()
        {
            InitializeComponent();
            SqlHelper.initCon();
            
            dcfrm = new DCDataInfo();
            exp = new MyServerClass(dcfrm);
            exp.StartListener();

        }


       public  GPSInfo frm;
       public DCDataInfo dcfrm;


        /// <summary>
        /// 窗体初始化加载的东西
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void Main_Load(object sender, EventArgs e)
        {

            try
            {
                //1.将动态配置表格中的内容读出来以动态拓扑图的形式显示
                Inittopologicalstructure();

                //2.加载出记录GPS位置的百度地图
                frm = new GPSInfo();
                frm.TopLevel = false;//添加该句话解决无法将顶级控件添加到控件问题
                frm.Parent = this.panel2;
                frm.Dock = DockStyle.Fill;
                frm.Show();
                frm.BringToFront();
            }
            catch (Exception exp)
            {
                MessageBox.Show("初始化加载窗体时出现异常！" + exp.Message);
            }
        }

        /// <summary>
        /// 通过读取海底网的动态配置数据库表格，将海底观测网络拓扑结构显示出来-------初始化海底网拓扑结构
        /// </summary>
        public void Inittopologicalstructure()
        {
            try
            {


                tVMap.Nodes.Clear();


                string sql2 = "select code from tb_config where level = 1;";

                DataTable tTable2 = SqlHelper.ExecuteDataTable(sql2);
                DataView dv2 = tTable2.DefaultView;
                DataTable tempTable2 = dv2.ToTable();



                for (int i = 0; i < tempTable2.Rows.Count; i++)
                {
                    TreeNode node = new TreeNode();


                    DataRow row2 = tempTable2.Rows[i];
                    //得到第一层级主接驳盒的编码，然后按照编码条件去主接驳盒元数据表查询主接驳盒相应的信息
                    string code = Convert.ToString(row2["code"].ToString().Trim());
                    string sql3 = "select jbCode,jbType,jbSrcNum from tb_jbinfo where jbCode = '" + code + "' and isDelete = 0;";//查询接驳盒的编码，类型以及所包含的通道个数，按照上面查询出来的编码作为条件，去接驳盒信息表查找详细信息

                   
                    node.Text = getCode(sql3, "jbType") + getCode(sql3, "jbCode");
                    tVMap.Nodes.Add(node);//至此已经建立好一级目录

                    //设置第一层级几点的颜色为红色
                    tVMap.Nodes[i].BackColor = Color.FromArgb(176,224,230);


                    //2.接下来需要确定主接驳盒下面有几路通道 
                    int MJBChlNum = getNum(sql3, "jbSrcNum");
                    for (int j = 0; j < MJBChlNum; j++)
                    {
                        TreeNode secondNode = new TreeNode();
                        tVMap.Nodes[i].Nodes.Add(secondNode);
                        secondNode.Text = "通道" + (j + 1).ToString();


                        //设置第二级节点的颜色为绿色
                        tVMap.Nodes[i].Nodes[j].BackColor = Color.FromArgb(146,208,252);


                        //找一下父节点为为上一层级查出来的节点
                        string sql4 = "select * from tb_config where parentCode ='" + code + "' and  level = 2 and parentChlNum = '" + (j + 1) + "' ";
                        
                        //以下条件的执行必须得是有才行，也就是说必须sql4条件查询能够查询出符合要求的数据才能执行,否则不能执行
                        /*******************************/
                        string code2 = getCode(sql4, "code");//得到二级节点的名称

                        if (code2 != null)
                        {
                            //二级节点继续作为条件查询的条件，去查询符合要求的次接驳盒
                            string sql5 = "select jbCode,jbType,jbSrcNum from tb_jbinfo where jbCode = '" + code2 + "' and isDelete = 0;";

                            TreeNode thirdNode = new TreeNode();

                            thirdNode.Text = getCode(sql5, "jbType") + getCode(sql5, "jbCode");//第三层节点的名称是类型+编号 次接驳盒SJB-001
                            tVMap.Nodes[i].Nodes[j].Nodes.Add(thirdNode);//已经建立好二级目录


                            tVMap.Nodes[i].Nodes[j].Nodes[0].BackColor = Color.Yellow;


                            int PJBChlNum = getNum(sql5, "jbSrcNum");//次级接驳盒几路通道个数
                            for (int m = 0; m < PJBChlNum; m++)
                            {
                                TreeNode fourthNode = new TreeNode();
                                tVMap.Nodes[i].Nodes[j].Nodes[0].Nodes.Add(fourthNode);
                                fourthNode.Text = "通道" + (m + 1).ToString();

                                //添加颜色
                                tVMap.Nodes[i].Nodes[j].Nodes[0].Nodes[m].BackColor = Color.Moccasin;


                                string sql6 = "select code from tb_config where parentCode = '" + code2 + "' and level = 3 and parentChlNum = '" + (m + 1) + "'";

                                string code3 = getCode(sql6, "code");

                                if (code3 != null)
                                {

                                    string sql7 = "select srcCode,srcType,srcDeviceNum from tb_srcinfo where srcCode = '" + code3 + "' and isDelete = 0";//查找数据采集器的相关信息
                                    TreeNode fifthNode = new TreeNode();

                                    fifthNode.Text = getCode(sql7, "srcType") + getCode(sql7, "srcCode");
                                    tVMap.Nodes[i].Nodes[j].Nodes[0].Nodes[m].Nodes.Add(fifthNode);//建立好数据采集器这一级的目录


                                    //这一级添加颜色
                                    tVMap.Nodes[i].Nodes[j].Nodes[0].Nodes[m].Nodes[0].BackColor = Color.Thistle;//数据采集器DC-001



                                    int DCNum = getNum(sql7, "srcDeviceNum");

                                    for (int n = 0; n < DCNum; n++)
                                    {
                                        TreeNode sixNode = new TreeNode();
                                        tVMap.Nodes[i].Nodes[j].Nodes[0].Nodes[m].Nodes[0].Nodes.Add(sixNode);

                                        sixNode.Text = "com" + (n + 1).ToString();

                                        tVMap.Nodes[i].Nodes[j].Nodes[0].Nodes[m].Nodes[0].Nodes[n].BackColor = Color.PaleGoldenrod;


                                        string sql8 = "select code from tb_config where parentCode = '" + code3 + "' and level =4 and parentChlNum = '" + (n + 1) + "'";

                                        string code4 = getCode(sql8, "code");

                                        if (code4 != null)
                                        {
                                            string sql9 = "select deviceCode,deviceName from tb_deviceinfo where deviceCode = '" + code4 + "' and isDelete = 0";
                                            TreeNode sevenCode = new TreeNode();


                                            sevenCode.Text ="设备"+ getCode(sql9, "deviceCode");
                                            tVMap.Nodes[i].Nodes[j].Nodes[0].Nodes[m].Nodes[0].Nodes[n].Nodes.Add(sevenCode);
                                            tVMap.Nodes[i].Nodes[j].Nodes[0].Nodes[m].Nodes[0].Nodes[n].Nodes[0].BackColor = Color.SpringGreen;
                                        }
                                    }
                                }
                            }
                        }
                    }
                }

                tVMap.ExpandAll();

            }
            catch(Exception exp)
            {
                MessageBox.Show("读海底网络拓扑结构出现异常！"+exp.Message);
            }
        }



        /// <summary>
        /// 通过查询数据库，得到最终编码的函数，这样查询出来的是行只有一行，是唯一的
        /// </summary>
        /// <returns></returns>
        public static  string getCode(string sql,string name)
        {
            string strName = null;
            try
            {
                DataTable tTable = SqlHelper.ExecuteDataTable(sql);
                DataView dv = tTable.DefaultView;
                DataTable tempTable = dv.ToTable();


                if (tempTable.Rows.Count > 0)
                {
                    DataRow row = tempTable.Rows[0];
                    strName = Convert.ToString(row[name].ToString().Trim());
                }
                return strName;
            }
            catch(Exception exp)
            {
                MessageBox.Show("查询操作数据库出现异常！"+exp.Message);
                return strName;
            }
        }



        /// <summary>
        /// 通过查询数据库，得到个数，这样查询出来的是行只有一行，是唯一的
        /// </summary>
        /// <returns></returns>
        private int getNum(string sql, string name)
        {
            int num = 0;
            try
            {
                DataTable tTable = SqlHelper.ExecuteDataTable(sql);
                DataView dv = tTable.DefaultView;
                DataTable tempTable = dv.ToTable();
                DataRow row = tempTable.Rows[0];



                num = Convert.ToInt32(row[name].ToString());

                return num;
            }
            catch (Exception exp)
            {
                MessageBox.Show("查询操作2数据库出现异常！" + exp.Message);
               

                return num;
            }
        }

       /********节点选中的相关操作*************/
      

        /// <summary>
        /// 取消节点选中状态之后，取消所有父节点的选中状态
        /// </summary>
        /// <param name="currNode"></param>
        /// <param name="state"></param>
        private void setParentNodeCheckedState(TreeNode currNode, bool state)
        {
            TreeNode parentNode = currNode.Parent;
            parentNode.Checked = state;
            if (currNode.Parent.Parent != null)
            {
                setParentNodeCheckedState(currNode.Parent, state);
            }
        }

        /// <summary>
        /// 选中节点之后，选中节点的所有子节点
        /// </summary>
        /// <param name="currNode"></param>
        /// <param name="state"></param>
        private void setChildNodeCheckedState(TreeNode currNode, bool state)
        {
            TreeNodeCollection nodes = currNode.Nodes;
            if (nodes.Count > 0)
            {
                foreach (TreeNode tn in nodes)
                {
                    tn.Checked = state;
                    setChildNodeCheckedState(tn, state);
                }
            }
        }
        /// <summary>
        /// 右击显示海底网络拓扑结构的按键
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void tVMap_NodeMouseClick(object sender, TreeNodeMouseClickEventArgs e)
        {
            //判定一下是否是鼠标右键按下，鼠标右键按下的话弹出右键相关菜单
            if (e.Button == MouseButtons.Right)
            {
                tVMap.SelectedNode = tVMap.GetNodeAt(e.X, e.Y);
                Point pos = new Point(e.Node.Bounds.X + e.Node.Bounds.Width, e.Node.Bounds.Y + e.Node.Bounds.Height / 2);
                this.menuNode.Show(this.tVMap, pos);
            }
        }
        /// <summary>
        /// 右键treeview控件的刷新海底网络拓扑结构树形图
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void 刷新ToolStripMenuItem_Click(object sender, EventArgs e)
        {
            try 
            {
                Inittopologicalstructure();//重新初始化加载一遍拓扑结构
            }
            catch(Exception exp)
            {
                MessageBox.Show("刷新异常！"+exp.Message);
            }
            
        }
        /// <summary>
        /// 删除该节点及以下节点，在动态配置表中及时更新，并且删除完成之后及时刷新一遍海底网络拓扑结构
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void 删除ToolStripMenuItem_Click(object sender, EventArgs e)
        {
            try
            {
                DialogResult result = MessageBox.Show("是否确认删除该节点以及子节点", "提示", MessageBoxButtons.YesNo, MessageBoxIcon.Warning);

                if (result == DialogResult.Yes)//如果点击了是，则执行删除节点的操作
                {
                    //1.获取鼠标当前选中的节点的层级；

                    int depth = tVMap.SelectedNode.Level;

                    if (depth == 0)//如果是第一层节点
                    {
                        //（1）得到主接驳盒的编码
                        string code = tVMap.SelectedNode.Text.Remove(0,4);//得到主接驳盒的编码

                        //（2）在动态配置表中删除编码符合要求的主接驳盒
                        string sql1 = "delete from tb_config where code = '" + code + "'";
                        SqlHelper.ExecuteNonQuery(sql1);//执行删除指令


                        //（3）查找父节点为满足要求的节点函数
                        string sql2 = "select * from tb_config where parentCode = '"+code+"'";
                        DataTable tTable = SqlHelper.ExecuteDataTable(sql2);
                        DataView dv = tTable.DefaultView;
                        DataTable tempTable = dv.ToTable();

                        for (int i = 0; i < tempTable.Rows.Count; i++)
                        {
                            DataRow row = tempTable.Rows[i];
                            string code2 = Convert.ToString(row["code"].ToString().Trim());
                            string sql3 = "delete from tb_config where code = '"+code2+"'";
                            SqlHelper.ExecuteNonQuery(sql3);//执行删除指令



                            string sql4 = "select * from tb_config where parentCode = '"+code2+"'";

                            DataTable tTable2 = SqlHelper.ExecuteDataTable(sql4);
                            DataView dv2 = tTable2.DefaultView;
                            DataTable tempTable2 = dv2.ToTable();


                            for (int j = 0; j < tempTable2.Rows.Count; j++)
                            {
                                DataRow row2 = tempTable2.Rows[j];
                                string code3 = Convert.ToString(row2["code"].ToString().Trim());

                                string sql5 = "delete  from tb_config where code='"+code3+"'";
                                SqlHelper.ExecuteNonQuery(sql5);//执行删除指令

                                string sql6 = "select * from tb_config where parentCode = '"+code3+"'";

                                DataTable tTable3 = SqlHelper.ExecuteDataTable(sql6);
                                DataView dv3 = tTable3.DefaultView;
                                DataTable tempTable3 = dv3.ToTable();

                                for (int m = 0; m < tempTable3.Rows.Count; m++)
                                {
                                    DataRow row3 = tempTable3.Rows[m];
                                    string code4 = Convert.ToString(row3["code"].ToString().Trim());

                                    string sql7 = "delete from tb_config where code = '"+code4+"'";
                                    SqlHelper.ExecuteNonQuery(sql7);
                                }
                            }
                        }

                    }



                    else if (depth == 1)//如果是第一层，要就是仅仅删除的是主接驳盒通道后面所接的各种设备,例如此处选中的是主接驳盒的通道1
                    {

                        //（1）得到主接驳盒的编码
                        string code = tVMap.SelectedNode.Parent.Text.Remove(0,4);//得到主接驳盒的编码
                        string chlNum = tVMap.SelectedNode.Text.Remove(0,2);

                       


                        //（3）查找父节点为满足要求的节点函数
                        string sql2 = "select * from tb_config where parentCode = '" + code + "' and parentChlNum = '"+chlNum+"'";
                        DataTable tTable = SqlHelper.ExecuteDataTable(sql2);
                        DataView dv = tTable.DefaultView;
                        DataTable tempTable = dv.ToTable();

                        for (int i = 0; i < tempTable.Rows.Count; i++)
                        {
                            DataRow row = tempTable.Rows[i];
                            string code2 = Convert.ToString(row["code"].ToString().Trim());
                            string sql3 = "delete from tb_config where code = '" + code2 + "'";
                            SqlHelper.ExecuteNonQuery(sql3);//执行删除指令



                            string sql4 = "select * from tb_config where parentCode = '" + code2 + "'";

                            DataTable tTable2 = SqlHelper.ExecuteDataTable(sql4);
                            DataView dv2 = tTable2.DefaultView;
                            DataTable tempTable2 = dv2.ToTable();


                            for (int j = 0; j < tempTable2.Rows.Count; j++)
                            {
                                DataRow row2 = tempTable2.Rows[j];
                                string code3 = Convert.ToString(row2["code"].ToString().Trim());

                                string sql5 = "delete  from tb_config where code='" + code3 + "'";
                                SqlHelper.ExecuteNonQuery(sql5);//执行删除指令

                                string sql6 = "select * from tb_config where parentCode = '" + code3 + "'";

                                DataTable tTable3 = SqlHelper.ExecuteDataTable(sql6);
                                DataView dv3 = tTable3.DefaultView;
                                DataTable tempTable3 = dv3.ToTable();

                                for (int m = 0; m < tempTable3.Rows.Count; m++)
                                {
                                    DataRow row3 = tempTable3.Rows[m];
                                    string code4 = Convert.ToString(row3["code"].ToString().Trim());

                                    string sql7 = "delete from tb_config where code = '" + code4 + "'";
                                    SqlHelper.ExecuteNonQuery(sql7);
                                }
                            }
                        }

                    }

                    else if (depth == 2)//如果是第二层，从次级接驳盒开始
                    {
                        string code = tVMap.SelectedNode.Text.Remove(0, 4);//得到次级接驳盒的编码

                        //（2）在动态配置表中删除编码符合要求的主接驳盒
                        string sql1 = "delete from tb_config where code = '" + code + "'";
                        SqlHelper.ExecuteNonQuery(sql1);//执行删除指令



                        //（3）查找父节点为满足要求的节点函数
                        string sql2 = "select * from tb_config where parentCode = '" + code + "'";
                        DataTable tTable = SqlHelper.ExecuteDataTable(sql2);
                        DataView dv = tTable.DefaultView;
                        DataTable tempTable = dv.ToTable();


                        for (int i = 0; i < tempTable.Rows.Count; i++)
                        {
                            DataRow row = tempTable.Rows[i];
                            string code2 = Convert.ToString(row["code"].ToString().Trim());
                            string sql3 = "delete from tb_config where code = '" + code2 + "'";
                            SqlHelper.ExecuteNonQuery(sql3);//执行删除指令



                            string sql4 = "select * from tb_config where parentCode = '" + code2 + "'";

                            DataTable tTable2 = SqlHelper.ExecuteDataTable(sql4);
                            DataView dv2 = tTable2.DefaultView;
                            DataTable tempTable2 = dv2.ToTable();


                            for (int j = 0; j < tempTable2.Rows.Count; j++)
                            {

                                DataRow row2 = tempTable2.Rows[j];
                                string code3 = Convert.ToString(row2["code"].ToString().Trim());

                                string sql5 = "delete  from tb_config where code='" + code3 + "'";
                                SqlHelper.ExecuteNonQuery(sql5);//执行删除指令
                            }
                        }
                    }

                    else if (depth == 3)//如果是第三层，则选中的是次接驳盒的某一个通道
                    {
                        string code = tVMap.SelectedNode.Parent.Text.Remove(0, 4);//得到次级接驳盒的编码

                        string chlNum = tVMap.SelectedNode.Text.Remove(0,2);



                        //（3）查找父节点为满足要求的节点函数
                        string sql2 = "select * from tb_config where parentCode = '" + code + "' and parentChlNum = '"+chlNum+"'";
                        DataTable tTable = SqlHelper.ExecuteDataTable(sql2);
                        DataView dv = tTable.DefaultView;
                        DataTable tempTable = dv.ToTable();


                        for (int i = 0; i < tempTable.Rows.Count; i++)
                        {
                            DataRow row = tempTable.Rows[i];
                            string code2 = Convert.ToString(row["code"].ToString().Trim());
                            string sql3 = "delete from tb_config where code = '" + code2 + "'";
                            SqlHelper.ExecuteNonQuery(sql3);//执行删除指令



                            string sql4 = "select * from tb_config where parentCode = '" + code2 + "'";

                            DataTable tTable2 = SqlHelper.ExecuteDataTable(sql4);
                            DataView dv2 = tTable2.DefaultView;
                            DataTable tempTable2 = dv2.ToTable();


                            for (int j = 0; j < tempTable2.Rows.Count; j++)
                            {

                                DataRow row2 = tempTable2.Rows[j];
                                string code3 = Convert.ToString(row2["code"].ToString().Trim());

                                string sql5 = "delete  from tb_config where code='" + code3 + "'";
                                SqlHelper.ExecuteNonQuery(sql5);//执行删除指令
                            }
                        }
                    }
                    else if (depth == 4)//如果是第四层
                    {
                        string code = tVMap.SelectedNode.Text.Remove(0, 5);//得到数据采集器的编码

                        //（2）在动态配置表中删除编码符合要求的数据采集器
                        string sql1 = "delete from tb_config where code = '" + code + "'";
                        SqlHelper.ExecuteNonQuery(sql1);//执行删除指令


                        //（3）查找父节点为满足要求的节点函数
                        string sql2 = "select * from tb_config where parentCode = '" + code + "'";
                        DataTable tTable = SqlHelper.ExecuteDataTable(sql2);
                        DataView dv = tTable.DefaultView;
                        DataTable tempTable = dv.ToTable();


                        for (int i = 0; i < tempTable.Rows.Count; i++)
                        {
                            DataRow row = tempTable.Rows[i];
                            string code2 = Convert.ToString(row["code"].ToString().Trim());
                            string sql3 = "delete from tb_config where code = '" + code2 + "'";
                            SqlHelper.ExecuteNonQuery(sql3);//执行删除指令
                        }

                    }
                    else if (depth == 5)//如果是第五层，则是数据采集器的某一个通道口
                    {
                        string code = tVMap.SelectedNode.Parent.Text.Remove(0, 5);//得到数据采集器的编码
                        string chlNum = tVMap.SelectedNode.Text.Remove(0,3);
                        


                        //（3）查找父节点为满足要求的节点函数
                        string sql2 = "select * from tb_config where parentCode = '" + code + "' and parentChlNum = '"+chlNum+"'";
                        DataTable tTable = SqlHelper.ExecuteDataTable(sql2);
                        DataView dv = tTable.DefaultView;
                        DataTable tempTable = dv.ToTable();


                        for (int i = 0; i < tempTable.Rows.Count; i++)
                        {
                            DataRow row = tempTable.Rows[i];
                            string code2 = Convert.ToString(row["code"].ToString().Trim());
                            string sql3 = "delete from tb_config where code = '" + code2 + "'";
                            SqlHelper.ExecuteNonQuery(sql3);//执行删除指令
                        }
                    }

                    else if (depth == 6)//设备层
                    {
                        string code = tVMap.SelectedNode.Text.Remove(0, tVMap.SelectedNode.Text.Length - 10);//得到设备的编码

                        //（2）在动态配置表中删除编码符合要求的设备
                        string sql1 = "delete from tb_config where code = '" + code + "'";
                        SqlHelper.ExecuteNonQuery(sql1);//执行删除指令

                    }

                    Inittopologicalstructure(); //删除操作执行完成之后，要有刷新指令执行
                    MessageBox.Show("删除成功！");
                }
                else//如果点击否，则该对话框取消
                {
                    
                }

            }
            catch(Exception exp)
            {
                MessageBox.Show("删除节点出现异常！"+exp.Message);
            }

        }
        /// <summary>
        /// 设置菜单下面-点击主接驳盒维护，相当于对主接驳盒的元数据表进行维护，对主接驳盒的元数据表进行增删改等操作
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void 主接驳盒ToolStripMenuItem_Click(object sender, EventArgs e)
        {
            try
            {
                jbInfo mySensorConfig = new jbInfo("tb_jbinfo","jbCode","jbType","jbIP","jbPort","jbSrcNum","主接驳盒","主接驳盒信息维护");
                mySensorConfig.Show();
            }
            catch (Exception exp)
            {
                //LogClass.WriteLogFile("配置节点信息出现异常！" + exp.Message);
                MessageBox.Show("加载主接驳盒维护出现异常！"+exp.Message);
            }
        }
        /// <summary>
        /// 加载次级接驳盒的元数据表
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void 次接驳盒维护ToolStripMenuItem_Click(object sender, EventArgs e)
        {
            try
            {
                jbInfo mySensorConfig = new jbInfo("tb_jbinfo", "jbCode", "jbType", "jbIP", "jbPort", "jbSrcNum", "次接驳盒","次接驳盒信息维护");
                mySensorConfig.Show();
            }
            catch (Exception exp)
            {
                //LogClass.WriteLogFile("配置节点信息出现异常！" + exp.Message);
                MessageBox.Show("加载次接驳盒维护出现异常！" + exp.Message);
            }
        }
        /// <summary>
        /// 加载数据采集器的元数据表
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void 数据采集器维护ToolStripMenuItem_Click(object sender, EventArgs e)
        {
            try
            {
                jbInfo mySensorConfig = new jbInfo("tb_srcinfo", "srcCode", "srcType", "srcIP", "srcPort", "srcDeviceNum", "数据采集器","数据采集器信息维护");
                mySensorConfig.Show();
            }
            catch (Exception exp)
            {
                //LogClass.WriteLogFile("配置节点信息出现异常！" + exp.Message);
                MessageBox.Show("加载数据采集器维护出现异常！" + exp.Message);
            }
        }
        /// <summary>
        /// 弹出关于设备维护的信息表格
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void 设备维护ToolStripMenuItem_Click(object sender, EventArgs e)
        {
            deviceInfo mycmd = new deviceInfo();
            mycmd.Show();
        }
        /// <summary>
        /// 右击treeview控件对应管理
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void 新增ToolStripMenuItem_Click(object sender, EventArgs e)
        {
            try
            {
                //1.获取鼠标当前选中的节点的层级
                int depth = tVMap.SelectedNode.Level;

                //2.如果是第0层，也就是对于主接驳盒进行添加
                if (depth == 0)
                {
                    MjbManagement cmd = new MjbManagement(this);
                    cmd.Show();
                }
                else if (depth == 1)//主接驳盒下面的通道，该通道处只能添加次级接驳盒
                {
                    if (tVMap.SelectedNode.IsExpanded)//判断该节点是否是最后一个节点
                    {
                        MessageBox.Show("该通道下已有节点，无法新增！");
                    }
                    else//通道后面没有接任何东西，表明可以进行节点设置
                    {
                        NodeManagement cmd = new NodeManagement(tVMap.SelectedNode.Parent.Text.ToString(),tVMap.SelectedNode.Text.ToString(),this,1);
                        cmd.Show();
                    }
                }
                else if(depth == 2)
                {
                    MessageBox.Show("此处无法新增，请右键选择相应通道或者com！");
                }
                else if (depth == 3)//右键选择次级接驳盒的相应通道，次级接驳盒后面可以添加数据采集器以及设备
                {
                    if (tVMap.SelectedNode.IsExpanded)//判断该节点是否是最后一个节点
                    {
                        MessageBox.Show("该通道下已有节点，无法新增！");
                    }
                    else//通道后面没有接任何东西，表明可以进行节点设置
                    {
                        NodeManagement cmd = new NodeManagement(tVMap.SelectedNode.Parent.Text.ToString(), tVMap.SelectedNode.Text.ToString(), this,2);
                        cmd.Show();
                    }
                }
                else if(depth == 4)//此处为数据采集器
                {
                    MessageBox.Show("此处无法新增，请右键选择相应通道或者com");
                }
                else if(depth == 5)//数据采集器的相应com口
                {
                    if (tVMap.SelectedNode.IsExpanded)//判断该节点是否是最后一个节点
                    {
                        MessageBox.Show("该通道下已有节点，无法新增！");
                    }
                    else//通道后面没有接任何东西，表明可以进行节点设置
                    {
                        NodeManagement cmd = new NodeManagement(tVMap.SelectedNode.Parent.Text.ToString(), tVMap.SelectedNode.Text.ToString(), this,3);
                        cmd.Show();
                    }
                }
                else if(depth == 6)//对应的实际的设备
                {
                    MessageBox.Show("此处无法新增，请右键选择相应通道或者com");
                }
            }
            catch(Exception exp)
            {
                MessageBox.Show("管理异常！"+exp.Message);
            }
        }

        /// <summary>
        /// 显示树状拓扑图中相关的信息
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void 显示ToolStripMenuItem_Click(object sender, EventArgs e)
        {
            try 
            {
                 //1.获取鼠标当前选中的节点的层级
                int depth = tVMap.SelectedNode.Level;
                if(depth == 4)//选中的是数据采集器的那一列
                {
                    //显示数据采集的相关信息
                    if (frm != null)
                    {
                        frm.Close();
                    }
                    //if (dcfrm != null)
                    //{
                    //    dcfrm.Close();
                    //}

                    ////将数据采集器的相关信息显示出来
                    //dcfrm = new DCDataInfo();
                    dcfrm.TopLevel = false;//添加该句话解决无法将顶级控件添加到控件问题
                    dcfrm.Parent = this.panel2;
                    dcfrm.Dock = DockStyle.Fill;
                    dcfrm.Show();
                    dcfrm.BringToFront();


                }
            }
            catch(Exception exp)
            {
                MessageBox.Show("显示异常！"+exp.Message);
            }

        }



        #region 内存回收
        [DllImport("kernel32.dll", EntryPoint = "SetProcessWorkingSetSize")]
        public static extern int SetProcessWorkingSetSize(IntPtr process, int minSize, int maxSize);
        /// <summary> 
        /// 用于清空内存占用的函数
        /// </summary> 
        public static void ClearMemory()
        {
            GC.Collect();
            GC.WaitForPendingFinalizers();
            if (Environment.OSVersion.Platform == PlatformID.Win32NT)
            {
                SetProcessWorkingSetSize(System.Diagnostics.Process.GetCurrentProcess().Handle, -1, -1);
            }
        }
        #endregion

        /// <summary>
        /// 点击关闭窗口之后彻底退出软件
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void Main_FormClosing(object sender, FormClosingEventArgs e)
        {
            System.Environment.Exit(0);//彻底退出软件
        }


    }
}
