﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace DMS
{
    public partial class MjbManagement : Form
    {
        Main f;
        public MjbManagement(Main exp)
        {
            InitializeComponent();
            f = exp;
        }
        /// <summary>
        /// 主接驳盒添加界面中对主接驳盒窗口初始化进行加载
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void MjbManagement_Load(object sender, EventArgs e)
        {
            //查找主接驳盒信息表中主接驳盒的相关信息
            string sql = "select * from tb_jbinfo where jbType = '主接驳盒' and isDelete = 0";
            DataTable tTable = SqlHelper.ExecuteDataTable(sql);
            DataView dv = tTable.DefaultView;
            DataTable tempTable = dv.ToTable();

            for (int i = 0; i < tempTable.Rows.Count; i++)
            {
                DataRow row = tempTable.Rows[i];
                MjbList.Items.Add(row["jbCode"].ToString().Trim());
            }

            MjbList.SelectedIndex = 0;

        }
        /// <summary>
        /// 在整个海底网络的拓扑结构中添加主接驳盒
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void btnAddMjb_Click(object sender, EventArgs e)
        {
            try
            {
                if (MjbList.Text.ToString() != "")
                {
                    string tempCode = MjbList.Text.ToString().Trim();//获取选择的下拉框的内容
                    //然后查询一下数据库的配置表格中是否已经存在了他的配置
                    string sql = "select * from tb_config where code = '"+tempCode+"'";
                    DataTable tTable = SqlHelper.ExecuteDataTable(sql);
                    DataView dv = tTable.DefaultView;
                    DataTable tempTable = dv.ToTable();

                    if (tempTable.Rows.Count > 0)
                    {
                        MessageBox.Show("该主接驳盒已经存在在拓扑图中！");
                    }
                    else
                    {
                        string sql2 = "insert into tb_config (code,type,level,parentCode,parentChlNum) values('" + tempCode + "','主接驳盒','1','-','-')";//包编号存入数据库
                        SqlHelper.ExecuteNonQuery(sql2);
                        //在动态配置表中添加完成之后，还需要重新刷新一遍拓扑图中的结构
                        MessageBox.Show("添加成功");
                        this.Close();
                        f.Inittopologicalstructure();
                    }
                }
            }
            catch(Exception exp)
            {
                MessageBox.Show("在拓扑结构中添加主接驳盒异常！"+exp.Message);
            }

        }
    }
}
