﻿/*
 * 时间：2021年6月9日15:15:16
 * 功能：典型的socket服务器建立过程，主要功能：1）开始监听；2）接收客户端的连接；
 */
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Net.Sockets;
using System.Data;
using System.Net;
using System.Threading;
using System.IO;

namespace DMS
{
    class MyServerClass
    {
        private TcpListener tcpListener;//用于监听客户端连接请求
        private DCDataInfo f;

        /// <summary>
        /// 该类的构造函数
        /// </summary>
        public MyServerClass(DCDataInfo frm)
        {
            f = frm;
        }


        /// <summary>
        /// 1.开始监听的函数
        /// </summary>
        public void StartListener()
        {
            try
            {
                //IPAddress IP = getIP();
                //int port = 8000;//上位机服务器用于监听下位机数据采集器的端口


                //(1).在文件中读取需要建立的本机服务器地址以及端口
                DataSet ds = new DataSet();
                ds.ReadXml(@".\LocalIPandPort.xml");
                IPAddress IP = IPAddress.Parse(ds.Tables[0].Rows[0]["srvIP"].ToString());
                int port = Convert.ToInt32(ds.Tables[0].Rows[0]["srvDataCollectPort"].ToString());

                //(2).绑定IP以及端口建立监听对象,并开启监听
                tcpListener = new TcpListener(IP, port);//创建侦听对象

                tcpListener.Start();//开始侦听


                //(3).抛出线程接收客户端的连接
                Thread threadAccepTcpClient = new Thread(AcceptClient);//启动一个线程，接收客户端的连接请求
                threadAccepTcpClient.Start();

            }
            catch (Exception e)
            {
                LogClass.WriteLogFile("建立本地socket侦听对象出现异常！" + e.Message);
            }
        }



        /// <summary>
        /// 2.接收客户端的连接
        /// </summary>
        private void AcceptClient()
        {
            try
            {
                while (true)
                {
                    TcpClient tcpClient = tcpListener.AcceptTcpClient();//用在同步阻塞方式下，阻塞在此处，等待客户端的连接，连接建立之后，再继续进行

                    if (tcpClient != null)
                    {
                        NetworkStream networkStream = tcpClient.GetStream();
                        BinaryReader br = new BinaryReader(networkStream);
                        BinaryWriter bw = new BinaryWriter(networkStream);

                        ReceiveMsgClass receiveMsg = new ReceiveMsgClass(tcpClient, br, bw, networkStream,f);

                        Thread threadReceiveMessage = new Thread(receiveMsg.ReceiveMessage);//每次得到一个TcpClient对象，就创建一个与该客户对应的线程接收信息
                        threadReceiveMessage.Start();


                    }

                    Main.ClearMemory();//此处添加清空线程内存   测试一个连接建立完成之后  再有新的连接进来之后
                }
            }
            catch (Exception e)
            {
                Main.ClearMemory();
                LogClass.WriteLogFile("接收客户端连接线程出现异常！" + e.Message);
            }
        }

    }
}
