﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace DMS
{
    public partial class NodeManagement : Form
    {
        string nodeParent;
        string chlParent;
        Main f;
        int flag;

        public NodeManagement(string str1,string str2,Main exp,int flag1)
        {
            InitializeComponent();
            nodeParent = str1;
            chlParent = str2;
            f = exp;
            flag = flag1;
        }
        /// <summary>
        /// 节点选择的初始化加载函数
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void NodeManagement_Load(object sender, EventArgs e)
        {
            try
            {
                parentNode.Text = nodeParent;
                chl.Text = chlParent;

                ////1.初始化加载节点选择下拉列表中内容
                ////先把设备信息表中的设备加到下拉列表中
                //string sql = "select * from tb_deviceinfo where isDelete = 0";
                //DataTable tTable = SqlHelper.ExecuteDataTable(sql);
                //DataView dv = tTable.DefaultView;
                //DataTable tempTable = dv.ToTable();


                //for (int i = 0; i < tempTable.Rows.Count; i++)
                //{
                //    DataRow row = tempTable.Rows[i];
                //    nodeList.Items.Add(row["deviceCode"].ToString().Trim());
                //}



                //string sql2 = "select * from tb_srcinfo where isDelete = 0";
                //DataTable tTable2 = SqlHelper.ExecuteDataTable(sql2);
                //DataView dv2 = tTable2.DefaultView;
                //DataTable tempTable2 = dv2.ToTable();


                //for (int i = 0; i < tempTable2.Rows.Count; i++)
                //{
                //    DataRow row = tempTable2.Rows[i];
                //    nodeList.Items.Add(row["srcCode"].ToString().Trim());
                //}

                if (flag == 1)//标志位flag=1，代表的是主接驳盒下面的呃通道，主接驳盒下面的通道只能接次接驳盒
                {
                    string sql3 = "select * from tb_jbinfo where jbType = '次接驳盒' and isDelete = 0";
                    DataTable tTable3 = SqlHelper.ExecuteDataTable(sql3);
                    DataView dv3 = tTable3.DefaultView;
                    DataTable tempTable3 = dv3.ToTable();

                    for (int i = 0; i < tempTable3.Rows.Count; i++)
                    {
                        DataRow row = tempTable3.Rows[i];
                        nodeList.Items.Add(row["jbCode"].ToString().Trim());
                    }
                }
                else if(flag == 2)//标志位flag==2 ，则代表的是次级接驳盒下面的通道，简单情况下考虑只能接数据采集器
                {


                    string sql2 = "select * from tb_srcinfo where isDelete = 0";
                    DataTable tTable2 = SqlHelper.ExecuteDataTable(sql2);
                    DataView dv2 = tTable2.DefaultView;
                    DataTable tempTable2 = dv2.ToTable();


                    for (int i = 0; i < tempTable2.Rows.Count; i++)
                    {
                        DataRow row = tempTable2.Rows[i];
                        nodeList.Items.Add(row["srcCode"].ToString().Trim());
                    }

                    ////1.初始化加载节点选择下拉列表中内容
                    ////先把设备信息表中的设备加到下拉列表中
                    //string sql = "select * from tb_deviceinfo where isDelete = 0";
                    //DataTable tTable = SqlHelper.ExecuteDataTable(sql);
                    //DataView dv = tTable.DefaultView;
                    //DataTable tempTable = dv.ToTable();


                    //for (int i = 0; i < tempTable.Rows.Count; i++)
                    //{
                    //    DataRow row = tempTable.Rows[i];
                    //    nodeList.Items.Add(row["deviceCode"].ToString().Trim());
                    //}



                    
                }

                else if (flag == 3)//标志位flag == 3，则代表的数据采集器的通道，后面只能添加设备的相关信息
                {

                    //1.初始化加载节点选择下拉列表中内容
                    //先把设备信息表中的设备加到下拉列表中
                    string sql = "select * from tb_deviceinfo where isDelete = 0";
                    DataTable tTable = SqlHelper.ExecuteDataTable(sql);
                    DataView dv = tTable.DefaultView;
                    DataTable tempTable = dv.ToTable();


                    for (int i = 0; i < tempTable.Rows.Count; i++)
                    {
                        DataRow row = tempTable.Rows[i];
                        nodeList.Items.Add(row["deviceCode"].ToString().Trim());
                    }
                }
               


                nodeList.SelectedIndex = 0;//默认选择第一个作为下拉菜单

            }
            catch(Exception exp)
            {
                MessageBox.Show("加载节点管理界面出现异常！"+exp.Message);
            }
            

        }
        /// <summary>
        /// 在主接驳盒下面的通道处添加节点
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void button1_Click(object sender, EventArgs e)
        {
            try
            {
                string tempCode = nodeList.Text.ToString();//首先获取所选中的下拉选项的节点的编码
                //查询一下该编码是否已经在动态配置表中存在，如果在动态配置表中存在的话则无法添加

                string sql = "select * from tb_config where code = '"+tempCode+"'";
                DataTable tTable = SqlHelper.ExecuteDataTable(sql);
                DataView dv = tTable.DefaultView;
                DataTable tempTable = dv.ToTable();

                if (tempTable.Rows.Count > 0)//查询结果大于0行，说明动态配置表中已经配置过了
                {
                    MessageBox.Show("该节点已存在在海底网络拓扑结构中，如需重新添加，请先删除！");
                }
                else
                {
                    string tempCode2 = tempCode.Substring(0,3);//分割获取类型；
                    string strType = null;//通过编码，获取是什么类型的节点存入动态配置表格中，比如是主接驳盒，次接驳盒，数据采集器，设备等类型
                    int level = 0;
                    switch(tempCode2)
                    {
                        case"PJB":
                            strType = "主接驳盒";
                            break;
                        case "SJB":
                            strType = "次接驳盒";
                            break;
                        case "DC-":
                            strType = "数据采集器";
                            break;
                        case "Dev":
                            strType = "设备";
                            break;
                    }
                    string parentCode = nodeParent.Remove(0,4);
                    string parentChlNum = chlParent.Remove(0,2);


                    if (flag == 3)
                    {
                        parentCode = nodeParent.Remove(0,5);
                        parentChlNum = chlParent.Remove(0,3);
                    }

                    
                    switch(flag)
                    {
                        case 1:
                            level = 2;
                            break;
                        case 2:
                            level = 3;
                            break;
                        case 3:
                            level = 4;
                            break;
                    }
                    string sql2 = "insert into tb_config (code,type,level,parentCode,parentChlNum) values('" + tempCode + "','"+strType+"','"+level+"','"+parentCode+"','"+parentChlNum+"')";//包编号存入数据库
                    SqlHelper.ExecuteNonQuery(sql2);
                    //在动态配置表中添加完成之后，还需要重新刷新一遍拓扑图中的结构
                    MessageBox.Show("添加成功");
                    this.Close();
                    f.Inittopologicalstructure();
                }
            }
            catch(Exception exp)
            {
                MessageBox.Show("添加出现异常！"+exp.Message);
            }
        }
    }
}
