﻿/*
 * 时间：2021年6月9日15:32:54
 * 功能：接收客户端的连接之后，抛出线程来处理接收到的数据
 */

using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Net.Sockets;
using System.IO;
using System.Threading;
using System.Text.RegularExpressions;
using System.Collections;

namespace DMS
{
    class ReceiveMsgClass
    {
        //该类几个重要的成员函数
        private TcpClient tcpClient;
        private BinaryReader br;
        private BinaryWriter bw;
        private NetworkStream networkStream;
        DCDataInfo f;




        private string DOVol = "-1";//首页显示溶解氧电压
        private string DOCur = "-1";//首页显示溶解氧电流
        private string DOPower = "-1";//首页显示溶解氧功率
        private string DOTime = "";//首页显示溶解氧采集时间


        private string JWVol = "-1";//首页显示甲烷电压
        private string JWCur = "-1";//首页显示甲烷电流
        private string JWPower = "-1";//首页显示甲烷功率
        private string JWTime = "";//首页显示甲烷采集时间

        private string YLSVol = "-1";//首页显示叶绿素电压
        private string YLSCur = "-1";//首页显示叶绿素电流
        private string YLSPower = "-1";//首页显示叶绿素功率
        private string YLSTime = "";//首页显示叶绿素采集时间

        private string ZDVol = "-1";//首页显示浊度电压
        private string ZDCur = "-1";//首页显示浊度电流
        private string ZDPower = "-1";//首页显示浊度功率
        private string ZDTime = "";//首页显示浊度采集时间

        private string CDOMVol = "-1";//首页显示cdom电压
        private string CDOMCur = "-1";//首页显示cdom电流
        private string CDOMPower = "-1";//首页显示cdom功率
        private string CDOMTime = "";//首页显示cdom采集时间





        /// <summary>
        /// 1.该类的构造函数
        /// </summary>
        /// <param name="tcpClient1"></param>
        /// <param name="br1"></param>
        /// <param name="bw1"></param>
        /// <param name="networkStream1"></param>
        public ReceiveMsgClass(TcpClient tcpClient1, BinaryReader br1, BinaryWriter bw1, NetworkStream networkStream1,DCDataInfo frm)
        {
            tcpClient = tcpClient1;
            br = br1;
            bw = bw1;
            networkStream = networkStream1;
            f = frm;
            showElectricalcallback = new delShowElectrical(ShowElectricalMethod);
            showSensorcallback = new delShowSensor(ShowSensorMethod);
        }


        /*******以下是几类重要的委托回调函数*********/
        private delegate void delShowElectrical(int i);
        private delShowElectrical showElectricalcallback;
        /// <summary>
        /// 显示数据采集器各路通道的委托回调函数
        /// </summary>
        /// <param name="i"></param>
        private void ShowElectricalMethod(int i)
        {
            switch (i)
            {
                case 1:
                    //数据采集器1通道1电参数状态液晶字体设置
                    FontClass fontType = new FontClass();
                    f.sensorOneVol.Font = fontType.fontLed;
                    f.sensorOneCur.Font = fontType.fontLed;
                    f.sensorOnePower.Font = fontType.fontLed;
                    f.sensorOneTime.Font = fontType.fontLed;
                    //数据采集器1通道1电参数状态液晶字体设置

                    f.sensorOneVol.Text = DOVol;
                    f.sensorOneCur.Text = DOCur;
                    f.sensorOnePower.Text = DOPower;
                    f.sensorOneTime.Text = DOTime;
                    break;
                case 2:
                    //数据采集器1通道2电参数状态液晶字体设置
                    FontClass fontType2 = new FontClass();
                    f.sensorTwoVol.Font = fontType2.fontLed;
                    f.sensorTwoCur.Font = fontType2.fontLed;
                    f.sensorTwoPower.Font = fontType2.fontLed;
                    f.sensorTwoTime.Font = fontType2.fontLed;
                    //数据采集器1通道2电参数状态液晶字体设置

                    f.sensorTwoVol.Text = JWVol;
                    f.sensorTwoCur.Text = JWCur;
                    f.sensorTwoPower.Text = JWPower;
                    f.sensorTwoTime.Text = JWTime;
                    break;
                case 3:
                    //数据采集器1通道3电参数状态液晶字体设置
                    FontClass fontType3 = new FontClass();
                    f.sensorThreeVol.Font = fontType3.fontLed;
                    f.sensorThreeCur.Font = fontType3.fontLed;
                    f.sensorThreePower.Font = fontType3.fontLed;
                    f.sensorThreeTime.Font = fontType3.fontLed;
                    //数据采集器1通道3电参数状态液晶字体设置

                    f.sensorThreeVol.Text = YLSVol;
                    f.sensorThreeCur.Text = YLSCur;
                    f.sensorThreePower.Text = YLSPower;
                    f.sensorThreeTime.Text = YLSTime;
                    break;
                case 4:
                    //数据采集器1通道4电参数状态液晶字体设置
                    FontClass fontType4 = new FontClass();
                    f.sensorFourVol.Font = fontType4.fontLed;
                    f.sensorFourCur.Font = fontType4.fontLed;
                    f.sensorFourPower.Font = fontType4.fontLed;
                    f.sensorFourTime.Font = fontType4.fontLed;
                    //数据采集器1通道4电参数状态液晶字体设置

                    f.sensorFourVol.Text = ZDVol;
                    f.sensorFourCur.Text = ZDCur;
                    f.sensorFourPower.Text = ZDPower;
                    f.sensorFourTime.Text = ZDTime;
                    break;
                case 5:
                    //数据采集器1通道5电参数状态液晶字体设置
                    FontClass fontType5 = new FontClass();
                    f.sensorFiveVol.Font = fontType5.fontLed;
                    f.sensorFiveCur.Font = fontType5.fontLed;
                    f.sensorFivePower.Font = fontType5.fontLed;
                    f.sensorFiveTime.Font = fontType5.fontLed;
                    //数据采集器1通道5电参数状态液晶字体设置

                    f.sensorFiveVol.Text = CDOMVol;
                    f.sensorFiveCur.Text = CDOMCur;
                    f.sensorFivePower.Text = CDOMPower;
                    f.sensorFiveTime.Text = CDOMTime;
                    break;
                //case 6:
                //    f.canTemp.Text = showTemp;
                //    break;

                //case 7:
                //    f.txtCollectErrorTime.Text = Convert.ToDateTime(showFaultTime).ToString();//故障时间的显示
                //    break;
            }
        }


        /*******以下是几类重要的委托回调函数*********/
        private delegate void delShowSensor(int i, string deviceName, string collectDataName1, string collectData1, string collectDataName2, string collectData2, string collectDataName3, string collectData3, DateTime time);
        private delShowSensor showSensorcallback;
        /// <summary>
        /// 显示数据采集器各路通道的委托回调函数
        /// </summary>
        /// <param name="i"></param>
        private void ShowSensorMethod(int i,string deviceName,string collectDataName1 ,string collectData1,string collectDataName2,string collectData2, string collectDataName3,string collectData3,DateTime time)
        {

            switch (i)
            {
                case 1://通道1所接传感器的相关采集数据显示
                    f.dataGridView1.Rows[0].Cells["通道号"].Value = "通道1";
                    f.dataGridView1.Rows[0].Cells["设备名称"].Value = deviceName;
                    f.dataGridView1.Rows[0].Cells["采集值1"].Value = collectDataName1 + ":  " + collectData1;//dataGridView行从0开始
                    f.dataGridView1.Rows[0].Cells["采集值2"].Value = collectDataName2 + ":  " + collectData2;
                    f.dataGridView1.Rows[0].Cells["采集值3"].Value = collectDataName3 + ":  " + collectData3;
                    f.dataGridView1.Rows[0].Cells["采集时间"].Value = time.ToString("yyyy-MM-dd HH:mm:ss");

                    break;
                case 2:
                    f.dataGridView1.Rows[1].Cells["通道号"].Value = "通道2";
                    f.dataGridView1.Rows[1].Cells["设备名称"].Value = deviceName;
                    f.dataGridView1.Rows[1].Cells["采集值1"].Value = collectDataName1 + ":  " + collectData1;//dataGridView行从0开始
                    f.dataGridView1.Rows[1].Cells["采集值2"].Value = collectDataName2 + ":  " + collectData2;
                    f.dataGridView1.Rows[1].Cells["采集值3"].Value = collectDataName3 + ":  " + collectData3;
                    f.dataGridView1.Rows[1].Cells["采集时间"].Value = time.ToString("yyyy-MM-dd HH:mm:ss");
                    break;
                case 3:
                    f.dataGridView1.Rows[2].Cells["通道号"].Value = "通道3";
                    f.dataGridView1.Rows[2].Cells["设备名称"].Value = deviceName;
                    f.dataGridView1.Rows[2].Cells["采集值1"].Value = collectDataName1 + ":  " + collectData1;//dataGridView行从0开始
                    f.dataGridView1.Rows[2].Cells["采集值2"].Value = collectDataName2 + ":  " + collectData2;
                    f.dataGridView1.Rows[2].Cells["采集值3"].Value = collectDataName3 + ":  " + collectData3;
                    f.dataGridView1.Rows[2].Cells["采集时间"].Value = time.ToString("yyyy-MM-dd HH:mm:ss");

                    break;
                case 4:
                    f.dataGridView1.Rows[3].Cells["通道号"].Value = "通道4";
                    f.dataGridView1.Rows[3].Cells["设备名称"].Value = deviceName;
                    f.dataGridView1.Rows[3].Cells["采集值1"].Value = collectDataName1 + ":  " + collectData1;//dataGridView行从0开始
                    f.dataGridView1.Rows[3].Cells["采集值2"].Value = collectDataName2 + ":  " + collectData2;
                    f.dataGridView1.Rows[3].Cells["采集值3"].Value = collectDataName3 + ":  " + collectData3;
                    f.dataGridView1.Rows[3].Cells["采集时间"].Value = time.ToString("yyyy-MM-dd HH:mm:ss");

                    break;
                case 5:
                    f.dataGridView1.Rows[4].Cells["通道号"].Value = "通道5";
                    f.dataGridView1.Rows[4].Cells["设备名称"].Value = deviceName;
                    f.dataGridView1.Rows[4].Cells["采集值1"].Value = collectDataName1 + ":  " + collectData1;//dataGridView行从0开始
                    f.dataGridView1.Rows[4].Cells["采集值2"].Value = collectDataName2 + ":  " + collectData2;
                    f.dataGridView1.Rows[4].Cells["采集值3"].Value = collectDataName3 + ":  " + collectData3;
                    f.dataGridView1.Rows[4].Cells["采集时间"].Value = time.ToString("yyyy-MM-dd HH:mm:ss");

                    break;
            }
        }






        /// <summary>
        /// 2.网络连接建立之后，接收信息的处理
        /// </summary>
        public void ReceiveMessage()
        {

            bool keepalive = true;//该标志是个局部变量，一个连接的断开不会影响这个连接的标志
            //后续可能需要添加连接标志变为连接的显示
            try
            {
                while (keepalive)
                {

                    if (tcpClient == null || !tcpClient.Connected)//判断连接是否还存在
                    {
                        keepalive = false;

                       //后续可能需要添加连接标志显示为断开
                        CloseSocket();
                        //2021年5月21日11:37:28  添加新的清空内存的方式
                        Main.ClearMemory();
                        Thread.CurrentThread.Abort();
                        GC.Collect();
                        break;//跳出循环
                    }
                    else
                    {
                        byte[] bytes = new byte[8192];
                        int readBytes = 0;

                        tcpClient.ReceiveTimeout = 60000;//将等待时间设置成1min，1min之后没有收到数据就认为连接断开，对非法关机的有效处理
                        //NetworkStream networkStream = tcpClient.GetStream();
                        //BinaryReader br = new BinaryReader(networkStream);


                        readBytes = br.Read(bytes, 0, 8192);

                        //只要执行到该步骤，就说明有接收到数据，连接标志显示为连接
                      //  f.Invoke(showCanConnectcallback, 1);//后续可能需要添加连接标志设置为连接的显示
                        string content = null;
                        if (readBytes > 0)
                        {

                            string chOnOffMsg = Encoding.ASCII.GetString(bytes, 0, readBytes);//接收到的下位机发送来的通道开关信息

                            //1.增加对甲烷信息的格外判断
                            if ((bytes[2] == 2) && (bytes[3] == 0) && (bytes[4] == 1) && (bytes[5] == 0))//如果甲烷是小端字节数组
                            {
                                Array.Reverse(bytes, 0, 2);//翻转协议头55 AA的字节序
                                Array.Reverse(bytes, 2, 4);//翻转协议编号00 01 00 02字节序
                                Array.Reverse(bytes, 29, 4);//翻转包编号
                                Array.Reverse(bytes, 33, 4);//翻转包体长度
                                Array.Reverse(bytes, 37, 4);//翻转校验和
                                Array.Reverse(bytes, 50, 2);//翻转传感器标识
                            }

                            //2.对甲烷信息格外判断之后，将字节类型处理成十六进制对应的字符串类型
                            for (int k = 0; k < readBytes; k++)
                                content += String.Format("{0:X2}", bytes[k]);

                            if (content.StartsWith("55AA") && content.EndsWith("23"))//接收到发送的传感器和监测数据，完成，发送ok后关闭连接，对接收到的数据进行处理
                            {
                                //对正常接收到的信息进行处理,防止沾包处理
                                string[] sArray = Regex.Split(content, "55AA", RegexOptions.IgnoreCase); //将字符串按照55AA进行分割


                                for (int i = 0; i <= sArray.Length - 2; i++)
                                {

                                    content = ("55AA" + sArray[i + 1]).Trim();//放到后面线程中进行修改

                                    ThreadPool.QueueUserWorkItem(new WaitCallback(DealMessage), content);//将处理函数放入线程池中处理分割完成之后的每条数据

                                    DateTime dt = DateTime.Now;
                                    string sql = "insert into seafloor_allData (saveDate,collectRawInfo) values('" + dt + "','" + content + "')";
                                    SqlHelper.ExecuteNonQuery(sql);
                                }

                            }
                            else if (chOnOffMsg == "$ch1 power off#")
                            {
                               // f.Invoke(showChOnOffcallback, 1);
                              //  LogCommand.WriteLogFile("通道1关断！");
                            }
                            else if (chOnOffMsg == "$ch5 power off#")
                            {
                               // f.Invoke(showChOnOffcallback, 2);

                                //LogCommand.WriteLogFile("通道2关断！");
                            }
                            else if (chOnOffMsg == "$ch2 power off#")
                            {
                               // f.Invoke(showChOnOffcallback, 3);
                                //LogCommand.WriteLogFile("通道3关断！");
                            }
                            else if (chOnOffMsg == "$ch3 power off#")
                            {
                                //f.Invoke(showChOnOffcallback, 4);
                               // LogCommand.WriteLogFile("通道4关断！");
                            }
                            else if (chOnOffMsg == "$ch4 power off#")
                            {
                                //f.Invoke(showChOnOffcallback, 5);
                                //LogCommand.WriteLogFile("通道5关断！");
                            }




                        }
                        else
                        {
                            keepalive = false;
                            //f.Invoke(showCanConnectcallback, 2);
                            CloseSocket();

                        }
                    }
                }


                CloseSocket();

                //2021年5月21日11:38:27
                Main.ClearMemory();

                Thread.CurrentThread.Abort();
                GC.Collect();
            }

            catch (SocketException exp)
            {
                keepalive = false;
                //f.Invoke(showCanConnectcallback, 2);

                CloseSocket();

                //2021年5月21日11:38:51
                Main.ClearMemory();

                Thread.CurrentThread.Abort();
                GC.Collect();
                LogClass.WriteLogFile("接收信息出现异常！" + exp.Message);
            }

            catch (Exception e)
            {
                keepalive = false;
               // f.Invoke(showCanConnectcallback, 2);

                CloseSocket();

                //2021年5月21日11:39:14
                Main.ClearMemory();

                Thread.CurrentThread.Abort();
                GC.Collect();
                LogClass.WriteLogFile("接收信息出现异常！" + e.Message);

            }
        }



        /// <summary>
        /// 3.放入线程池中处理具体函数的操作
        /// 具体包括：1）解析完成每一部分操作；2）将解析完成之后的数据送到控件进行画图；3）送到控件相应位置进行显示；4）存储数据库
        /// </summary>
        /// <param name="tempMessage"></param>
        private void DealMessage(object tempMessage)
        {
            string message = tempMessage.ToString();

            string srcId = null;//新增数据采集器的ID编号

            string strProtocolID = null;//协议编号
            string strProtocolName = null;//协议名字
            string strNumber = null;//包编号
            string strTime = null;//时间戳
            string strLength = null;//包体长度
            string strCRC = null;//校验和
            /**以上定义的是协议部分中的相关信息截取**/

            string sqlError = null;//将错误信息存储数据库的SQL语句
            string strCollectDate = null;//时间戳按照格式要求变换成“2017-05-02 13:38:15”格式,采集时间
            UInt32 packageNumber = 0;

            string chMark = null;
            string chFlag = null;

            try
            {
                //解析任何信息之前，先将所有的公有信息提取出来
                srcId = message.Substring(4, 4);//数据采集器的ID编号为0001
                strProtocolID = message.Substring(8, 4);
                strTime = message.Substring(12, 46);
                strNumber = message.Substring(58, 8);
                strLength = message.Substring(66, 8);
                packageNumber = Convert.ToUInt32(strNumber, 16);//将包编号转换成对应的十六进制数

                if (message.Length < 104)//1.判断整个包体长度是否符合要求
                {
                    DateTime dt = DateTime.Now;
                    sqlError = "insert into seafloor_srcErrorMesg (srcId,saveDate,errorProtocol) values('" + srcId + "','" + dt + "','" + message + "')";
                    SqlHelper.ExecuteNonQuery(sqlError);
                    return;
                }
                else//包体长度正确，依次往下判断
                {
                    strCRC = message.Substring(0, 4) + message.Substring(100, 4);
                    UInt32 CRCvalue1 = CRC32.GetCrc32(StrToHexByte(strCRC));//实际计算的CRC32校验值
                    UInt32 CRCvalue2 = Convert.ToUInt32(message.Substring(74, 8), 16);//给定的CRC32校验值

                    if (CRCvalue1 != CRCvalue2)//2.判断校验值是否正确，校验值直接结束
                    {
                        DateTime dt = DateTime.Now;
                        sqlError = "insert into seafloor_srcErrorMesg (srcId,saveDate,errorProtocol) values('" + srcId + "','" + dt + "','" + message + "')";
                        SqlHelper.ExecuteNonQuery(sqlError);

                        Main.ClearMemory();
                        GC.Collect();
                        Thread.CurrentThread.Abort();//结束当前线程

                        return;
                    }
                    else//校验和正确，往下执行
                    {
                        //3.解析时间，判断时间是否存在乱码
                        string Time = System.Text.Encoding.ASCII.GetString(StrToHexByte(strTime));//将字节流中信息（十六进制ASCII码）转换成对应的字符
                        string expTime = "^\\d{4}(:\\d{2}){5}:\\d{3}$";//时间正则表达式

                        if (!QuickValidate(expTime, Time))//时间格式错误，直接返回
                        {
                            DateTime dt = DateTime.Now;
                            sqlError = "insert into seafloor_srcErrorMesg (srcId,saveDate,errorProtocol) values('" + srcId + "','" + dt + "','" + message + "')";
                            SqlHelper.ExecuteNonQuery(sqlError);

                            Main.ClearMemory();

                            GC.Collect();
                            Thread.CurrentThread.Abort();//结束当前线程

                            //2021年5月21日11:40:03清空内存新方式
                            // Main.ClearMemory();

                            return;
                        }
                        else//时间格式正确，继续往下执行
                        {

                            string dataTime = dealTime(Time);

                            char separator = ':';
                            string[] splitStrings = new string[7];
                            splitStrings = Time.Split(separator);
                            strCollectDate = splitStrings[0] + "-" + splitStrings[1] + "-" + splitStrings[2] + " " + splitStrings[3] + ":" + splitStrings[4] + ":" + splitStrings[5];

                            //4.解析包体长度
                            string expLength = "^[\\d|a-f|A-F]{8}$";//包体长度正则表达式
                            if (!QuickValidate(expLength, strLength))//包体长度不匹配的话,返回结束
                            {
                                DateTime dt = DateTime.Now;
                                sqlError = "insert into seafloor_srcErrorMesg (srcId,saveDate,errorProtocol) values('" + srcId + "','" + dt + "','" + message + "')";
                                SqlHelper.ExecuteNonQuery(sqlError);

                                Main.ClearMemory();


                                GC.Collect();
                                Thread.CurrentThread.Abort();//结束当前线程

                                // Main.ClearMemory();

                                return;
                            }
                            else
                            {
                                UInt32 length = Convert.ToUInt32(strLength, 16);//协议中给定的长度（字符串转换成对应的十六进制数）
                                if (length != message.Length / 2)//包体长度与实际长度不一致，结束返回
                                {
                                    DateTime dt = DateTime.Now;
                                    sqlError = "insert into seafloor_srcErrorMesg (srcId,saveDate,errorProtocol) values('" + srcId + "','" + dt + "','" + message + "')";
                                    SqlHelper.ExecuteNonQuery(sqlError);

                                    Main.ClearMemory();

                                    GC.Collect();
                                    Thread.CurrentThread.Abort();//结束当前线程
                                    return;
                                }
                                else//包体长度正确，将剩余信息解析出来
                                {
                                    //5.依据协议编号，从数据库中解析出协议名字
                                    //strProtocolName = GetKeyValue(strProtocolID);


                                    ///*此处添加通道发送个数增加显示*/
                                    //chMark = message.Substring(10, 1);//哪个通道发来的标识
                                    //chFlag = message.Substring(10, 2);

                                    //if (chMark == "1" || chFlag == "01")
                                    //{
                                    //    s1++;
                                    //}
                                    //else if (chMark == "2" || chFlag == "02")
                                    //{
                                    //    s2++;
                                    //}
                                    //else if (chMark == "3" || chFlag == "03")
                                    //{
                                    //    s3++;
                                    //}
                                    //else if (chMark == "4" || chFlag == "04")
                                    //{
                                    //    s4++;
                                    //}
                                    //else if (chMark == "5" || chFlag == "05")
                                    //{
                                    //    s5++;
                                    //}

                                    //sum = s1 + s2 + s3 + s4 + s5;

                                    ////将通道个数送入主界面进行显示
                                    //f.Invoke(showChNumcallback, null);


                                    //不能通过协议名字是不是为空来判断是不是否和
                                    //if (strProtocolName == null)//数据库中没有该协议编号，返回结束
                                    //{
                                    //    DateTime dt = DateTime.Now;
                                    //    sqlError = "insert into seafloor_srcErrorMesg (srcId,saveDate,errorProtocol) values('" + srcId + "','" + dt + "','" + message + "')";
                                    //    SqlHelper.ExecuteNonQuery(sqlError);

                                    //    Main.ClearMemory();

                                    //    GC.Collect();
                                    //    Thread.CurrentThread.Abort();//结束当前线程

                                    //    //Main.ClearMemory();

                                    //    return;
                                    //}
                                    //else//按照不同的协议类型进行数据解析
                                    //{
                                        switch (message.Substring(8, 2))
                                        {
                                            case "00":

                                                dealSensorMessage(srcId, strProtocolID, message, strProtocolName, message.Length / 2, packageNumber, strCollectDate);
                                                break;

                                            case "20":

                                                dealCabinMessage(srcId, message, strProtocolName, packageNumber, strCollectDate);
                                                break;

                                            case "40":

                                                //string faultTime = dealFaultTime(dataTime);
                                                //string protocolHeadFault = "55AA11110001" + faultTime + strNumber + "00000059" + "01" + "00000000" + "00000000";//上传故障服务器的协议头

                                                //dealFaultMessage(srcId, message, strProtocolID, strProtocolName, packageNumber, strCollectDate, protocolHeadFault, faultTime);
                                                break;
                                        }
                                   // }
                                }
                            }

                        }

                    }
                }

                Main.ClearMemory();
            }
            catch (Exception exp)
            {
                Main.ClearMemory();
                GC.Collect();
                Thread.CurrentThread.Abort();//结束当前线程

                LogClass.WriteLogFile("解析下位机数据时出现错误！" + "原始信息包：" + message + "异常信息：" + exp.Message);


            }
        }

        /// <summary>
        /// 4.1体现设备动态管理重要的部分，传感器数据解析
        /// </summary>
        /// <param name="srcId"></param>数据采集器编码
        /// <param name="strCom"></param>数据采集器对应的那个com口
        /// <param name="message"></param>原始信息
        /// <param name="strProtocolName"></param>协议名字，此处为空
        /// <param name="tempLength"></param>包体长度
        /// <param name="packageNumber"></param>包编号
        /// <param name="strCollectDate"></param>采集时间
        private void dealSensorMessage(string srcId, string strCom, string message, string strProtocolName, int tempLength, UInt32 packageNumber, string strCollectDate)
        {
            try
            {
                string strSensorContent = null;//传感器原始数据对应的是16进制的字符串
                string sensorContent = null;//将传感器数据信息转换成ASCII码对应的字符信息，好用于正则表达式的匹配
                DateTime? collectTime1 = Convert.ToDateTime(null);//溶解氧单独的采集时间(不止溶解氧采集时间，所有传感器的采集时间)

                string dcCode = Convert.ToUInt32(srcId,16).ToString("000");
                dcCode = "DC-" + dcCode;//此处得到数据采集器的编码;
                string dcChlNum = Convert.ToUInt32(strCom,16).ToString();
                ArrayList arrayCollectData = new ArrayList();//用于存放传感器的多个采集数据的
                string collectData1 = null;
                string collectData2 = null;
                string collectData3 = null;

                string collectDataName1 = null;
                string collectDataName2 = null;
                string collectDataName3 = null;

                //根据接在哪个数据采集器上对应哪个口的设备，数据库联查到对应的设备信息表中，将设备相关信息调取出来

                string sql = "select * from tb_config where parentCode ='" + dcCode + "' and  level = 4 and parentChlNum = '" + dcChlNum + "' ";//查询得到对应的设备信息
                string deviceCode = Main.getCode(sql,"code");//得到对应的设备信息


                string sql1 = "select * from tb_deviceinfo where deviceCode = '"+deviceCode+"' and isDelete = 0";
                string expression = Main.getCode(sql1,"deviceExpression");
                string deviceName = Main.getCode(sql1,"deviceName");

                string deviceProtocol = Main.getCode(sql1,"deviceProtocol");//得到传感器采集值数据的意义


                if (message.Length >= (2 * tempLength - 2))
                {
                    strSensorContent = message.Substring(104, 2 * tempLength - 106);

                    if (strSensorContent.Length > 2)
                    {
                        sensorContent = System.Text.Encoding.ASCII.GetString(StrToHexByte(strSensorContent));
                        string collectTime = strCollectDate;
                        collectTime1 = Convert.ToDateTime(collectTime);


                        /**以下核心是正则表达式匹配过程***/
                        Regex reg = new Regex(expression, RegexOptions.None);//写好的正则表达式
                        Match match = reg.Match(sensorContent);


                        int keyNum = SubstringCount(expression, "key");//确定该传感器设备中含有科学数据的个数

                        for (int i = 0; i < keyNum; i++)
                        {
                            arrayCollectData.Add(match.Groups["key" + (i + 1).ToString()].Value);//将匹配完成的数据添加到动态数组中去
                        }


                        string[] strArr = deviceProtocol.Split(';');//将其按照；进行分割

                        switch (strArr.Length)
                        {
                            case 1:
                                collectDataName1 = strArr[0].Remove(0, 5);
                                break;
                            case 2:
                                collectDataName1 = strArr[0].Remove(0, 5);
                                collectDataName2 = strArr[1].Remove(0, 5);
                                break;
                            case 3:
                                collectDataName1 = strArr[0].Remove(0, 5);
                                collectDataName2 = strArr[1].Remove(0, 5);
                                collectDataName3 = strArr[2].Remove(0, 5);
                                break;
                        }



                        /**以下是将匹配完成的数据存储到数据库服务器中**/
                        switch (keyNum)
                        {
                            case 1:
                                collectData1 = Convert.ToDouble(arrayCollectData[0]).ToString("00.00");
                                break;
                            case 2:
                                collectData1 = Convert.ToDouble(arrayCollectData[0]).ToString("00.00");
                                collectData2 = Convert.ToDouble(arrayCollectData[1]).ToString("00.00");
                                break;
                            case 3:
                                collectData1 = Convert.ToDouble(arrayCollectData[0]).ToString("00.00");
                                collectData2 = Convert.ToDouble(arrayCollectData[1]).ToString("00.00");
                                collectData3 = Convert.ToDouble(arrayCollectData[2]).ToString("00.00");
                                break;
                        }
                        DateTime dt = DateTime.Now;
                        string sql3 = "insert into seafloor_srcsensordata (deviceCode,deviceName, collectData1,collectData2,collectData3, collectDate,saveDate, collectRawInfo, sensorRawInfo, pkgNum,isDelete) values('"+deviceCode+"','"+deviceName+"','"+collectData1+"','"+collectData2+"','"+collectData3+"','"+collectTime1+"','"+dt+"','"+message+"','"+sensorContent+"','"+packageNumber+"','0')";
                        SqlHelper.ExecuteNonQuery(sql3);


                        /**以下是将数据送到界面动态显示**/
                        if (f.IsHandleCreated)
                        {
                            f.Invoke(showSensorcallback,Convert.ToInt32(dcChlNum),deviceName,collectDataName1,collectData1,collectDataName2,collectData2,collectDataName3,collectData3,collectTime1);//委托显示

                        }

                    }
                    else
                    {
                        DateTime dt0 = DateTime.Now;
                        string sql0 = "insert into seafloor_srcErrorMesg (srcId,saveDate,errorProtocol) values('" + srcId + "','" + dt0 + "','" + message + "')";
                        SqlHelper.ExecuteNonQuery(sql0);
                    }

                }
                else
                {
                    DateTime dt0 = DateTime.Now;
                    string sql0 = "insert into seafloor_srcErrorMesg (srcId,saveDate,errorProtocol) values('" + srcId + "','" + dt0 + "','" + message + "')";
                    SqlHelper.ExecuteNonQuery(sql0);
                }



 
            }
            catch(Exception exp)
            {
                LogClass.WriteLogFile("解析传感器数据异常！"+exp.Message);
            }

        }




        /// <summary>
        /// 4.2具体解析舱内电参数温度等状态数据
        /// </summary>
        /// <param name="message"></param>原始信息串
        /// <param name="strProtocolName"></param>协议名字
        /// <param name="packageNumber"></param>包编号
        /// <param name="strCollectDate"></param>按照时间格式要求转换完成的采集时间
        private void dealCabinMessage(string srcId, string message, string strProtocolName, UInt32 packageNumber, string strCollectDate)
        {
            try
            {
                if ((message.Length == 134) || (message.Length == 120))
                {
                    if ((message.Substring(10, 2) == "10") || (message.Substring(10, 2) == "20") || (message.Substring(10, 2) == "30") || (message.Substring(10, 2) == "40") || (message.Substring(10, 2) == "50"))//电参数的解析
                    {
                        string tempNum = message.Substring(10,1);
                       // UInt32 num = Convert.ToUInt32(tempNum);

                        string sensorType = "通道"+tempNum+"电参数";
                        string sensorCurrent = "-1";//解析不正确就将-1存入数据库
                        string sensorVol = "-1";
                        string sensorPower = "-1";
                        double current = 0;
                        double vol = 0;
                        string sqlElectrical = null;//存入电参数表的SQL语句
                        string strSensorCurrent = message.Substring(104, 14);
                        string strSensorVol = message.Substring(118, 14);

                        // showTime = strCollectDate;//额外添加，回调函数中需要使用

                        if (strSensorCurrent.StartsWith("43"))
                        {
                            sensorCurrent = System.Text.Encoding.ASCII.GetString(StrToHexByte(message.Substring(106, 12)));
                            current = Convert.ToDouble(sensorCurrent);

                            //额外添加
                            //showCur = sensorCurrent;

                        }
                        if (strSensorVol.StartsWith("56"))
                        {
                            sensorVol = System.Text.Encoding.ASCII.GetString(StrToHexByte(message.Substring(120, 12)));
                            vol = Convert.ToDouble(sensorVol);


                            sensorPower = (current * vol).ToString("f3");
                            //额外添加，回调函数使用
                            //showVol = sensorVol;
                            // showPower = sensorPower;


                        }

                        //基本信息解析完成，信息存数据库并在界面显示
                        DateTime dt = DateTime.Now;
                        sqlElectrical = "insert into seafloor_srcElecData (srcId,statusType,current,voltage,power,saveDate,collectDate,collectRawInfo,pkgNum,isDelete) values ('" + srcId + "','" + sensorType + "','" + sensorCurrent + "','" + sensorVol + "','" + sensorPower + "','" + dt + "','" + strCollectDate + "','" + message + "','" + packageNumber + "','0')";//将包编号信息存入所有传感器电参数表格
                        SqlHelper.ExecuteNonQuery(sqlElectrical);

                        switch (sensorType)
                        {
                            case "通道1电参数":
                                //DateTime dt1 = DateTime.Now;
                                //sqlElectrical = "insert into sensorelectricaldo (sensortype,current,voltage,power,savetime,collecttime) values ('" + sensorType + "','" + sensorCurrent + "','" + sensorVol + "','" + sensorPower + "','" + dt1 + "','" + strCollectDate + "')";
                                //SqlHelper.ExecuteNonQuery(sqlElectrical);

                                /**后面待补充送界面显示(送入界面响应位置显示，使用委托实现直接送界面)，以及画图**/
                                // showElectricalcallback = new delShowElectrical(ShowElectricalMethod);

                                DOCur = sensorCurrent;
                                DOVol = sensorVol;
                                DOPower = sensorPower;
                                DOTime = strCollectDate;


                                if(f.IsHandleCreated)//解决办法是让线程等待，直到窗口句柄创建完成
                                {
                                    f.Invoke(showElectricalcallback, 1);//委托显示
                                }

                              


                                ////将相应数据存储到数组中，方便后面图上label显示
                                //draw.arrayCurrentDO.Add(sensorCurrent);
                                //draw.arrayVoltageDO.Add(sensorVol);
                                //draw.arrayStatusSaveDateDO.Add(Convert.ToDateTime(strCollectDate).ToString());


                                //将最新获取的电压数据加入到动态数组中
                                //draw.arrayDCCh1Vol.Add(DOVol);
                                //draw.arrayDCCh1Cur.Add(DOCur);


                                //lock (lockDOE)
                                //{
                                //    // f.Invoke(showElectricalcallback, 1);//委托显示
                                //    drawExp6.refreshDrawElectricalArray(dt1.ToString(), Convert.ToDouble(sensorCurrent), Convert.ToDouble(sensorVol), 6, f);//动态画状态图1，加锁
                                //}
                                break;
                            case "通道2电参数":
                                //DateTime dt2 = DateTime.Now;
                                //sqlElectrical = "insert into sensorelectricaljw (sensortype,current,voltage,power,savetime,collecttime) values ('" + sensorType + "','" + sensorCurrent + "','" + sensorVol + "','" + sensorPower + "','" + dt2 + "','" + strCollectDate + "')";
                                //SqlHelper.ExecuteNonQuery(sqlElectrical);
                                /**后面待补充送界面显示(送入界面响应位置显示，使用委托实现直接送界面)，以及画图**/

                                JWCur = sensorCurrent;
                                JWVol = sensorVol;
                                JWPower = sensorPower;
                                JWTime = strCollectDate;

                                if (f.IsHandleCreated)
                                {
                                    f.Invoke(showElectricalcallback, 2);//委托显示

                                }

                                
                                //将相应数据存储到数组中，方便后面图上label显示
                                //draw.arrayCurrentJW.Add(sensorCurrent);
                                //draw.arrayVoltageJW.Add(sensorVol);
                                //draw.arrayStatusSaveDateJW.Add(Convert.ToDateTime(strCollectDate).ToString());

                                //draw.arrayDCCh2Vol.Add(JWVol);//
                                //draw.arrayDCCh2Cur.Add(JWCur);//

                                //lock (lockJWE)
                                //{
                                //    //f.Invoke(showElectricalcallback, 2);//委托显示
                                //    drawExp7.refreshDrawElectricalArray(dt2.ToString(), Convert.ToDouble(sensorCurrent), Convert.ToDouble(sensorVol), 7, f);//动态画状态图2，加锁
                                //}

                                break;
                            case "通道3电参数":
                                //DateTime dt3 = DateTime.Now;
                                //sqlElectrical = "insert into sensorelectricalyls (sensortype,current,voltage,power,savetime,collecttime) values ('" + sensorType + "','" + sensorCurrent + "','" + sensorVol + "','" + sensorPower + "','" + dt3 + "','" + strCollectDate + "')";
                                //SqlHelper.ExecuteNonQuery(sqlElectrical);
                                /**后面待补充送界面显示(送入界面响应位置显示，使用委托实现直接送界面)，以及画图**/

                                YLSCur = sensorCurrent;
                                YLSVol = sensorVol;
                                YLSPower = sensorPower;
                                YLSTime = strCollectDate;

                                if (f.IsHandleCreated)
                                {
                                    f.Invoke(showElectricalcallback, 3);//委托显示
                                }
                                //draw.arrayCurrentYLS.Add(sensorCurrent);
                                //draw.arrayVoltageYLS.Add(sensorVol);
                                //draw.arrayStatusSaveDateYLS.Add(Convert.ToDateTime(strCollectDate).ToString());

                                //draw.arrayDCCh3Vol.Add(YLSVol);
                                //draw.arrayDCCh3Cur.Add(YLSCur);


                                //lock (lockYLSE)
                                //{
                                //    // f.Invoke(showElectricalcallback, 3);//委托显示
                                //    drawExp8.refreshDrawElectricalArray(dt3.ToString(), Convert.ToDouble(sensorCurrent), Convert.ToDouble(sensorVol), 8, f);//动态画状态图3，加锁
                                //}
                                break;
                            case "通道4电参数":
                                //DateTime dt4 = DateTime.Now;
                                //sqlElectrical = "insert into sensorelectricalzd (sensortype,current,voltage,power,savetime,collecttime) values ('" + sensorType + "','" + sensorCurrent + "','" + sensorVol + "','" + sensorPower + "','" + dt4 + "','" + strCollectDate + "')";
                                //SqlHelper.ExecuteNonQuery(sqlElectrical);
                                /**后面待补充送界面显示(送入界面响应位置显示，使用委托实现直接送界面)，以及画图**/

                                ZDCur = sensorCurrent;
                                ZDVol = sensorVol;
                                ZDPower = sensorPower;
                                ZDTime = strCollectDate;


                                if (f.IsHandleCreated)
                                {
                                    f.Invoke(showElectricalcallback, 4);//委托显示
                                }
                            

                                //draw.arrayCurrentZD.Add(sensorCurrent);
                                //draw.arrayVoltageZD.Add(sensorVol);
                                //draw.arrayStatusSaveDateZD.Add(Convert.ToDateTime(strCollectDate).ToString());


                                //draw.arrayDCCh4Cur.Add(ZDCur);
                                //draw.arrayDCCh4Vol.Add(ZDVol);


                                //lock (lockZDE)
                                //{
                                //    //f.Invoke(showElectricalcallback, 4);//委托显示
                                //    drawExp9.refreshDrawElectricalArray(dt4.ToString(), Convert.ToDouble(sensorCurrent), Convert.ToDouble(sensorVol), 9, f);//动态画状态图2，加锁
                                //}

                                break;
                            case "通道5电参数":
                                //DateTime dt5 = DateTime.Now;
                                //sqlElectrical = "insert into sensorelectricalcdom (sensortype,current,voltage,power,savetime,collecttime) values ('" + sensorType + "','" + sensorCurrent + "','" + sensorVol + "','" + sensorPower + "','" + dt5 + "','" + strCollectDate + "')";
                                //SqlHelper.ExecuteNonQuery(sqlElectrical);
                                /**后面待补充送界面显示(送入界面响应位置显示，使用委托实现直接送界面)，以及画图**/

                                CDOMCur = sensorCurrent;
                                CDOMVol = sensorVol;
                                CDOMPower = sensorPower;
                                CDOMTime = strCollectDate;


                                if (f.IsHandleCreated)
                                {
                                    f.Invoke(showElectricalcallback, 5);//委托显示
                                }
                                //draw.arrayCurrentCDOM.Add(sensorCurrent);
                                //draw.arrayVoltageCDOM.Add(sensorVol);
                                //draw.arrayStatusSaveDateCDOM.Add(Convert.ToDateTime(strCollectDate).ToString());

                                //draw.arrayDCCh5Cur.Add(CDOMCur);
                                //draw.arrayDCCh5Vol.Add(CDOMVol);


                                //lock (lockCDOME)
                                //{
                                //    //f.Invoke(showElectricalcallback, 5);//委托显示
                                //    drawExp10.refreshDrawElectricalArray(dt5.ToString(), Convert.ToDouble(sensorCurrent), Convert.ToDouble(sensorVol), 10, f);//动态画状态图2，加锁
                                //}
                                break;

                        }
                    }

                    /*2021年6月15日09:40:45暂时屏蔽掉解析漏水等信息**/
                    //else//以上解析的是电参数，后面解析温度信息，没有漏水信息
                    //{
                    //    string temperature = null;
                    //    string sqlCabin = null;
                    //    if (message.Substring(10, 2) == "60")//温度数据
                    //    {
                    //        temperature = System.Text.Encoding.ASCII.GetString(StrToHexByte(message.Substring(104, 14)));

                    //        showTemp = temperature;

                    //        f.Invoke(showElectricalcallback, 6);//将温度信息送到首页进行显示

                    //        DateTime dt1 = DateTime.Now;
                    //        sqlCabin = "insert into seafloor_srcTempData (srcId,statusType, temp,saveDate,collectDate,collectRawInfo,pkgNum,isDelete) values ('" + srcId + "','" + strProtocolName + "','" + temperature + "','" + dt1 + "','" + strCollectDate + "','" + message + "','" + packageNumber + "','0')";
                    //        //string sqlCabinTemp = "insert into cabinstatustemp (statusinfo, statusdata,savedate,collectdate,collectrawinfo) values ('" + strProtocolName + "','" + temperature + "','" + dt1 + "','" + strCollectDate + "','" + message + "')";
                    //        SqlHelper.ExecuteNonQuery(sqlCabin);
                    //        //SqlHelper.ExecuteNonQuery(sqlCabinTemp);

                    //        draw.arrayDCTemp.Add(Convert.ToDouble(temperature).ToString("00.000"));//将数据采集器最新的温度数据添加到动态数组中


                    //        draw.arrayTemp.Add(temperature);//将收到的温度数据动态添加到动态数组中,为了后面方便温度状态数据上传至数据库服务器中
                    //        draw.arraySaveDateTemp.Add(Convert.ToDateTime(strCollectDate).ToString());


                    //    }


                    //}
                }
            }

            catch (Exception exp)
            {
                string exception = "解析数据采集器1下位机环境参数程序出现异常:" + exp.Message + "接收到的内容:" + message;
                LogClass.WriteLogFile(exception);
            }
        }






        /// <summary>
        /// 5.关闭连接
        /// </summary>
        public void CloseSocket()
        {
            if (br != null)
            {
                br.Close();
            }
            if (bw != null)
            {
                bw.Close();
            }
            if (tcpClient != null)
            {
                tcpClient.Close();
            }

        }

        /*************中间需要使用的一些过程函数******************/

        /// <summary>
        /// 1.将十六进制字符串转换成字节类型存储在数组中
        /// </summary>
        /// <param name="val"></param>
        /// <returns></returns>
        private byte[] StrToHexByte(string val)
        {
            byte[] bytes = new byte[val.Length / 2];

            for (int i = 0; i < bytes.Length; i++)
            {
                bytes[i] = Convert.ToByte(val.Substring(i * 2, 2), 16);
            }
            return bytes;
        }


        /// <summary>
        /// 2.判断给定的字符串是否符合特定的格式，即是否有乱码出现
        /// </summary>
        /// <param name="_express"></param>给定的正则表达式
        /// <param name="_value"></param>需要验证的字符串
        /// <returns></returns>
        private bool QuickValidate(string _express, string _value)
        {
            if (_value == null) return false;
            Regex myRegex = new Regex(_express);
            if (_value.Length == 0)
            {
                return false;
            }
            return myRegex.IsMatch(_value);
        }


        /// <summary>
        /// 3.将下位机发送过来的时间格式处理成上传数据库服务器需要的格式要求
        /// </summary>
        /// <returns></returns>
        private string dealTime(string Time)
        {
            string dataTime = null;

            char[] separator = { ':' };

            string[] splitTime = new string[7];

            splitTime = Time.Split(separator);

            for (int i = 0; i < splitTime.Length - 1; i++)
            {
                dataTime += splitTime[i];
            }

            dataTime = dataTime + '0' + splitTime[6];

            return dataTime;
        }
        /// <summary>
        /// 查询指定字符串在字符串中出现的次数
        /// </summary>
        /// <param name="str"></param>
        /// <param name="substring"></param>
        /// <returns></returns>
        public static int SubstringCount(string str, string substring)
        {
            if (str.Contains(substring))
            {
                string strReplaced = str.Replace(substring, "");
                return (str.Length - strReplaced.Length) / substring.Length;
            }

            return 0;
        }


    }
}
