﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace DMS
{
    public partial class deviceInfo : Form
    {
        public deviceInfo()
        {
            InitializeComponent();
        }
        /// <summary>
        /// 初始化加载设备信息维护表
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void deviceInfo_Load(object sender, EventArgs e)
        {
            listDeviceInfo(searchDeviceInfo());
        }


        /// <summary>
        /// 初始化加载时将设备元数据表的信息显示出来
        /// </summary>
        /// <param name="dt"></param>
        public void listDeviceInfo(DataTable dt)
        {
            try
            {
                dgMjbInfo.Columns.Clear();
                dgMjbInfo.DataSource = dt;
                dgMjbInfo.ColumnHeadersDefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleCenter;
                dgMjbInfo.ReadOnly = true;
                dgMjbInfo.AllowUserToAddRows = false;
                dgMjbInfo.AllowUserToDeleteRows = false;
                dgMjbInfo.Columns[1].Width = 150;

                //Application.DoEvents();

                //while (dataGridView1.Rows.Count < 5)
                //    ((DataTable)dataGridView1.DataSource).Rows.Add();

                for (int i = 0; i < dgMjbInfo.Columns.Count; i++)
                {
                    dgMjbInfo.Columns[i].SortMode = DataGridViewColumnSortMode.NotSortable;
                }

            }
            catch (Exception exp)
            {
                //LogClass.WriteLogFile("海底观测网拓扑图设备信息表显示异常！" + exp.Message);
                MessageBox.Show("设备元信息表加载异常！" + exp.Message);
            }
        }


        /// <summary>
        /// 2.查询后台设备元数据表格加载在datagridview中
        /// </summary>
        /// <returns></returns>
        public DataTable searchDeviceInfo()
        {
            string strsql = null;
            try
            {
                DataTable dtDeviceData = null;
                //1.查询所有设备信息
                strsql = "(select deviceCode as '编码',";
                strsql += "deviceName as '设备名称',";
                strsql += "deviceIntfc  as '接口通信方式', deviceElec as '电气参数', deviceExpression as '协议正则表达式' , deviceProtocol as '采集值含义' from tb_deviceinfo where isDelete = '0' )";

                dtDeviceData = SqlHelper.ExecuteDataTable(strsql);
                return dtDeviceData.Copy();
            }
            catch (Exception exp)
            {
                MessageBox.Show("加载设备元数据表出现异常！！" + exp.Message);
                return null;
            }
        }
        /// <summary>
        /// 添加行数
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void dgMjbInfo_RowPostPaint(object sender, DataGridViewRowPostPaintEventArgs e)
        {
            Color color = dgMjbInfo.RowHeadersDefaultCellStyle.ForeColor;
            if (dgMjbInfo.Rows[e.RowIndex].Selected)
                color = dgMjbInfo.RowHeadersDefaultCellStyle.SelectionForeColor;
            else
                color = dgMjbInfo.RowHeadersDefaultCellStyle.ForeColor;

            using (SolidBrush b = new SolidBrush(color))
            {
                e.Graphics.DrawString((e.RowIndex + 1).ToString(), e.InheritedRowStyle.Font, b, e.RowBounds.Location.X + 20, e.RowBounds.Location.Y + 6);
            }
        }
        /// <summary>
        /// 设备信息增加
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void 增加ToolStripMenuItem1_Click(object sender, EventArgs e)
        {
            addDeviceInfo cmd = new addDeviceInfo(this);
            cmd.Show();

        }
        /// <summary>
        /// 设备信息的修改
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void 修改ToolStripMenuItem_Click(object sender, EventArgs e)
        {
            string deviceCode = dgMjbInfo.CurrentRow.Cells[0].Value.ToString(); //获取选中的设备的编码
            modifyDeviceInfo cmd = new modifyDeviceInfo(deviceCode,this);
            cmd.Show();             
        }
        /// <summary>
        /// 删除
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void 删除ToolStripMenuItem_Click(object sender, EventArgs e)
        {
            try
            {

                DialogResult result = MessageBox.Show("是否确认删除该条信息", "提示", MessageBoxButtons.YesNo, MessageBoxIcon.Warning);

                if (result == DialogResult.Yes)//如果点击了是，则执行删除该条元数据信息
                {
                    string deviceCode = dgMjbInfo.CurrentRow.Cells[0].Value.ToString(); //获取选中的主接驳盒的编码，然后在弹出的修改界面中，编码是锁定的不能更改的
                    string sql = "update tb_deviceinfo set isDelete='1'  where deviceCode = '" + deviceCode + "'";
                    SqlHelper.ExecuteNonQuery(sql);
                    MessageBox.Show("删除成功！");
                    //listMjbInfo(searchMjbInfo());
                    listDeviceInfo(searchDeviceInfo());
                }
                else
                {

                }

            }
            catch (Exception exp)
            {
                MessageBox.Show("删除出现异常！" + exp.Message);
            }
        }



    }
}
