﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace DMS
{
    public partial class jbInfo : Form
    {
        string serarchTable;//代表要查询后台的数据库表格

        string searchCode;//代表要查询的编码 
        string searchType;//要查询的类型
        string searchIP;//代表要查询的IP地址；
        string searchPort;//代表要查询的端口
        string searchChlNum;//代表要查询的通道个数；

        string searchType2;

        string showText;

        public jbInfo(string str1, string str2, string str3, string str4, string str5, string str6,string str7,string str8)
        {
            InitializeComponent();
            serarchTable = str1;

            searchCode = str2;//代表要查询的编码 
            searchType = str3;//要查询的类型
            searchIP = str4;//代表要查询的IP地址；
            searchPort = str5;//代表要查询的端口
            searchChlNum = str6;//代表要查询的通道个数；
            searchType2 = str7;
            showText = str8;
        }
        /// <summary>
        /// 主接驳盒状态信息维护表主要的维护内容
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void jbInfo_Load(object sender, EventArgs e)
        {
            //1.加载主接驳盒的信息表，查询主接驳盒的信息，在界面上显示出来
            this.Text = showText;
            listMjbInfo(searchMjbInfo());

        }
        /// <summary>
        /// 1.初始化加载的时候将主接驳盒的信息表显示出来
        /// </summary>
        public void listMjbInfo(DataTable dt)
        {
            try
            {
                dgMjbInfo.Columns.Clear();
                dgMjbInfo.DataSource = dt;
                dgMjbInfo.ColumnHeadersDefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleCenter;
                dgMjbInfo.ReadOnly = true;
                dgMjbInfo.AllowUserToAddRows = false;
                dgMjbInfo.AllowUserToDeleteRows = false;
                dgMjbInfo.Columns[1].Width = 150;

                //Application.DoEvents();

                //while (dataGridView1.Rows.Count < 5)
                //    ((DataTable)dataGridView1.DataSource).Rows.Add();

                for (int i = 0; i < dgMjbInfo.Columns.Count; i++)
                {
                    dgMjbInfo.Columns[i].SortMode = DataGridViewColumnSortMode.NotSortable;
                }

            }
            catch (Exception exp)
            {
                //LogClass.WriteLogFile("海底观测网拓扑图设备信息表显示异常！" + exp.Message);
                MessageBox.Show("主接驳盒元信息表加载异常！"+exp.Message);
            }
        }


        /// <summary>
        /// 2.查询后台主接驳盒元数据表格加载在datagridview中
        /// </summary>
        /// <returns></returns>
        public  DataTable searchMjbInfo()
        {
            string strsql = null;
            try
            {
                DataTable dtDeviceData = null;
                //1.查询所有设备信息
                strsql = "(select "+searchCode+" as '编码',";
                strsql += ""+searchType+" as '类型',";
                strsql += ""+searchIP+"  as 'IP', "+searchPort+" as '端口', "+searchChlNum+" as '通道数量' from " + serarchTable + " where "+searchType+" = '" + searchType2 + "' and isDelete = '0' )";

                dtDeviceData = SqlHelper.ExecuteDataTable(strsql);
                return dtDeviceData.Copy();
            }
            catch (Exception exp)
            {
                MessageBox.Show("加载主接驳盒元数据表出现异常！"+exp.Message);
                return null;
            }
        }
        /// <summary>
        /// 主接驳盒元信息表加载行号事件
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void dgMjbInfo_RowPostPaint(object sender, DataGridViewRowPostPaintEventArgs e)
        {
            Color color = dgMjbInfo.RowHeadersDefaultCellStyle.ForeColor;
            if (dgMjbInfo.Rows[e.RowIndex].Selected)
                color = dgMjbInfo.RowHeadersDefaultCellStyle.SelectionForeColor;
            else
                color = dgMjbInfo.RowHeadersDefaultCellStyle.ForeColor;

            using (SolidBrush b = new SolidBrush(color))
            {
                e.Graphics.DrawString((e.RowIndex + 1).ToString(), e.InheritedRowStyle.Font, b, e.RowBounds.Location.X + 20, e.RowBounds.Location.Y + 6);
            }
        }
        /// <summary>
        /// 点了主菜单中的设置按钮-增加菜单，则需要在主接驳盒元数据表中增加内容
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void 增加ToolStripMenuItem1_Click(object sender, EventArgs e)
        {
            try
            {
                addMjbInfo mySensorConfig = new addMjbInfo(serarchTable,searchCode,searchType,searchIP,searchPort,searchChlNum,this);
                mySensorConfig.Show();
            }
            catch (Exception exp)
            {
                //LogClass.WriteLogFile("配置节点信息出现异常！" + exp.Message);
                MessageBox.Show("加载主接驳盒添加界面出现异常！" + exp.Message);
            }

        }
        /// <summary>
        /// 将加载的主接驳盒元数据表格刷新一遍
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void 刷新ToolStripMenuItem_Click(object sender, EventArgs e)
        {
            listMjbInfo(searchMjbInfo());
        }
        /// <summary>
        /// 修改datagridview中所选中的行的信息
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void 修改ToolStripMenuItem_Click(object sender, EventArgs e)
        {

            try
            {
                //1.首先要先获取选中行的信息
                string jbCode = dgMjbInfo.CurrentRow.Cells[0].Value.ToString(); //获取选中的主接驳盒的编码，然后在弹出的修改界面中，编码是锁定的不能更改的
                modifyMjbInfo CMD = new modifyMjbInfo(serarchTable,searchCode,searchType,searchIP,searchPort,searchChlNum, this,jbCode);
                CMD.Show();

            }
            catch(Exception exp)
            {
                MessageBox.Show("修改主接驳盒信息变出现异常！"+exp.Message);
            }
            
        }
        /// <summary>
        /// 删除则是将数据表中某个删除标志置为1，查询的时候查不出来
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void 删除ToolStripMenuItem_Click(object sender, EventArgs e)
        {
            try
            {

                DialogResult result = MessageBox.Show("是否确认删除该条信息", "提示", MessageBoxButtons.YesNo, MessageBoxIcon.Warning);

                if (result == DialogResult.Yes)//如果点击了是，则执行删除该条元数据信息
                {
                    string jbCode = dgMjbInfo.CurrentRow.Cells[0].Value.ToString(); //获取选中的主接驳盒的编码，然后在弹出的修改界面中，编码是锁定的不能更改的
                    string sql = "update "+serarchTable+" set isDelete='1'  where "+searchCode+" = '" + jbCode + "'";
                    SqlHelper.ExecuteNonQuery(sql);
                    MessageBox.Show("删除成功！");
                    listMjbInfo(searchMjbInfo());
                }
                else
                {
 
                }
                
            }
            catch(Exception exp)
            {
                MessageBox.Show("删除出现异常！"+exp.Message);
            }
        }

    }
}
