﻿/*
 * 时间：2017年5月4日09:49:08
 * 功能：典型socket服务器建立过程，主要功能：1)开始侦听；2)接收客户端的连接；
 * 功能：主要是监听次级接驳盒的连接，使用8087监听次级接驳盒的连接
 */
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Net.Sockets;
using System.IO;
using System.Windows.Forms;
using System.Net;
using System.Threading;
using System.Text.RegularExpressions;
using System.Drawing;
using MySql.Data.MySqlClient;
using System.Data;

namespace OSNSystem
{
    class _1MySerClass
    {
        private Socket tcpListener;//用于监听客户端连接请求       
        private Main f;//将窗体对象定义成该类的私有变量，使用构造函数来初始化该私有变量

        /*****************将远程连接过来的客户端信息，放入userList中，保存连接信息，后期确定从该连接中找到所需的连接发送出去********************/
        public static List<_3ReceieveMsgClass> userList = new List<_3ReceieveMsgClass>();


        public static string BJunctionIP;//次接驳盒串口服务器IP地址
        public static int BPort;

        private Dictionary<string, string> mydic;//读入次级接驳盒信息的相关词典，只为读入一次数据库使用


        /// <summary>
        /// 类_1MySerClass构造函数
        /// </summary>
        /// <param name="frm"></param>
        public _1MySerClass(Main frm)
        {
            f = frm;
            showIPandPortcallback = new delShowIPandPort(ShowIPandPortMethod);
            mydic = SetFaultKeyValue();

        }


        /******************2017.10.25增加项目，接驳盒添加客户端连接窗口的显示*******************/
        private delegate void delShowIPandPort(string IP,string port,int i);
        private delShowIPandPort showIPandPortcallback;
        private void ShowIPandPortMethod(string IP,string port, int i)
        {
            if (i == 1)//次级接驳盒远程连接的信息
            {
                f.txtBIP.Text = IP.Trim();
                f.txtBPort.Text = port.Trim();
            }
            else//主接驳盒远程连接的信息
            {
                f.txtAIP.Text = IP.Trim();
                f.txtAPort.Text = port.Trim();
            }
            
        }





        


        /// <summary>
        /// 1.开始侦听函数
        /// </summary>
        public void StartListener()
        {
            try
            {
               // IPAddress IP = IPAddress.Parse("200.1.1.33");//上位机最终固定的IP地址，将IP地址写死，若是自动获取本机IP，则使用函数getIP
                //IPAddress IP = getIP();
                //int port = 8087;//用于监听下位机STM32 socket连接的端口号



                DataSet ds = new DataSet();
                ds.ReadXml(@".\LocalIPandPort.xml");
                IPAddress IP = IPAddress.Parse(ds.Tables[0].Rows[0]["srvIP"].ToString());
                int port = Convert.ToInt32(ds.Tables[0].Rows[0]["srvJunctionBoxBPort"].ToString());

                BJunctionIP = ds.Tables[0].Rows[0]["BJunctionIP"].ToString();//txt文档中次接驳盒串口服务器IP地址读入
                BPort = port;


                tcpListener = new Socket(AddressFamily.InterNetwork, SocketType.Stream, ProtocolType.Tcp); ;//创建侦听对象

                tcpListener.Bind(new IPEndPoint(IP, port));//绑定IP地址以及端口，开始监听

                tcpListener.Listen(100);//设置可以连接的数目为100个


                Thread threadAccept = new Thread(AcceptClient);
                threadAccept.Start();


            }
            catch (Exception e)
            {             
                LogClass.WriteLogFile("建立本地socket侦听对象出现异常！"+e.Message);
            }


        }

        /// <summary>
        /// 2.接收客户端的连接
        /// </summary>
        private void AcceptClient()
        {
            try
            {
                while (true)
                {
                    Socket tcpClient = tcpListener.Accept();//用在同步阻塞方式下，通过AcceptTcpClient（）函数的返回值区分不同的客户端连接

                    if (tcpClient != null)
                    {

                        _3ReceieveMsgClass receiveMsg = new _3ReceieveMsgClass(tcpClient, f,BPort,mydic);//定义_3ReceiveMsgClass的对象，调用构造函数


                        userList.Add(receiveMsg);//将接受的客户端的连接存储在数组中

                        //客户端的连接，分成主接驳盒以及次接驳盒的连接,不同的连接使用IP地址来区分
                        if (receiveMsg.nodeIP == BJunctionIP)
                        {
                            f.Invoke(showIPandPortcallback, receiveMsg.nodeIP, receiveMsg.port.ToString(),1);//次级接驳盒的连接，将连接的远程客户端的相应信息显示出来
                        }
                        

                        Thread threadReceiveMessage = new Thread(receiveMsg.ReceiveMessage);//每次得到一个TcpClient对象，就创建一个与该客户对应的线程接收信息
                        threadReceiveMessage.Start();

                    }

                    Main.ClearMemory();

                }
            }
            catch (Exception e)
            {
                Main.ClearMemory();
                LogClass.WriteLogFile("接收客户端连接线程出现异常！" + e.Message);
            }


            //Main.ClearMemory();

        }




        ///*******************************额外用到的一些函数***************************/

        ///// <summary>
        ///// 自动获取本机IP地址，额外函数
        ///// </summary>
        ///// <returns></returns>
        private IPAddress getIP()
        {
            string AddressIP = string.Empty;
            try
            {
                foreach (IPAddress _IPAddress in Dns.GetHostEntry(Dns.GetHostName()).AddressList)
                {
                    if (_IPAddress.AddressFamily.ToString() == "InterNetwork")
                    {
                        AddressIP = _IPAddress.ToString();//"127.0.0.1";
                    }
                }
                return IPAddress.Parse(AddressIP);
            }
            catch (Exception e)
            {
                LogClass.WriteLogFile("自动获取本机IP地址异常！" + e.Message);
                return null;
            }

        }




        /// <summary>
        ///读入次级接驳盒故障码与故障类型对应的编号
        /// </summary>
        /// <returns></returns>
        public static Dictionary<string, string> SetFaultKeyValue()
        {
            Dictionary<string, string> dic = new Dictionary<string, string>();
            //从数据库中读到相应数据，然后将对应的Key以及value填充到字典中

            try
            {
                MySqlDataReader reader = SqlHelper.ExecuteReader("select * from seafloor_jBConfigInfo");
                while (reader.Read())
                {
                    dic.Add(reader.GetString(2), reader.GetString(1));
                }
                reader.Close();
                reader.Dispose();
            }
            catch (Exception exp)
            {
                //MessageBox.Show("读入数据库时出现异常！"+exp.Message);
                LogClass.WriteLogFile("读入数据库seafloor_jBConfigInfo时出现异常！" + exp.Message);
            }
            return dic;

        }


    }
}
