﻿/*
 * 时间：2018年3月14日13:39:46
 * 功能：典型的SOCKET服务器建立过程，主要功能：1)开始侦听；2)接收客户端的连接（侦听数据采集器1的连接）
 */
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Net;
using System.Net.Sockets;
using System.Threading;
//using MySql.Data.MySqlClient;
using System.IO;
using System.Data;
using MySql.Data.MySqlClient;

namespace OSNSystem
{
    class _1MySerClass2
    {
        private TcpListener tcpListener;//用于监听客户端连接请求       
        private Main f;//将窗体对象定义成该类的私有变量，使用构造函数来初始化该私有变量

        /*********根据具体实际情况，增加的额外私有变量***************/
        private Dictionary<string, string> mydic;
        /// <summary>
        /// 类_1MyserClass构造函数
        /// </summary>
        /// <param name="frm"></param>
        public _1MySerClass2(Main frm)
        {
            f = frm;
            mydic = SetKeyValue();//这样只需要读入一次数据库就可以了，否则在使用中每次需要重新读入数据库
        }


        /// <summary>
        /// 1.开始侦听函数
        /// </summary>
        public void StartListener()
        {
            try
            {
                //IPAddress IP = getIP();
                //int port = 8000;//上位机服务器用于监听下位机数据采集器的端口

                DataSet ds = new DataSet();
                ds.ReadXml(@".\LocalIPandPort.xml");
                IPAddress IP = IPAddress.Parse(ds.Tables[0].Rows[0]["srvIP"].ToString());
                int port = Convert.ToInt32(ds.Tables[0].Rows[0]["srvDataCollectPort"].ToString());


                tcpListener = new TcpListener(IP, port);//创建侦听对象

                tcpListener.Start();//开始侦听

                Thread threadAccepTcpClient = new Thread(AcceptClient);//启动一个线程，接收客户端的连接请求
                threadAccepTcpClient.Start();

            }
            catch (Exception e)
            {
                LogClass.WriteLogFile("建立本地socket侦听对象出现异常！" + e.Message);
            }


        }

        /// <summary>
        /// 2.接收客户端的连接
        /// </summary>
        private void AcceptClient()
        {
            try
            {
                while (true)
                {
                    TcpClient tcpClient = tcpListener.AcceptTcpClient();//用在同步阻塞方式下，阻塞在此处，等待客户端的连接，连接建立之后，再继续进行

                    if (tcpClient != null)
                    {
                        NetworkStream networkStream = tcpClient.GetStream();
                        BinaryReader br = new BinaryReader(networkStream);
                        BinaryWriter bw = new BinaryWriter(networkStream);

                        _3ReceieveMsgClass2 receiveMsg = new _3ReceieveMsgClass2(tcpClient, br, bw, networkStream, f,mydic);

                        Thread threadReceiveMessage = new Thread(receiveMsg.ReceiveMessage);//每次得到一个TcpClient对象，就创建一个与该客户对应的线程接收信息
                        threadReceiveMessage.Start();


                    }


                    Main.ClearMemory();//此处添加清空线程内存   测试一个连接建立完成之后  再有新的连接进来之后


                }
            }
            catch (Exception e)
            {
                Main.ClearMemory();
                LogClass.WriteLogFile("接收客户端连接线程出现异常！" + e.Message);
            }

            

        }




        ///*******************************额外用到的一些函数***************************/

        ///// <summary>
        ///// 自动获取本机IP地址，额外函数
        ///// </summary>
        ///// <returns></returns>
        private IPAddress getIP()
        {
            string AddressIP = string.Empty;
            try
            {
                foreach (IPAddress _IPAddress in Dns.GetHostEntry(Dns.GetHostName()).AddressList)
                {
                    if (_IPAddress.AddressFamily.ToString() == "InterNetwork")
                    {
                        AddressIP = _IPAddress.ToString();//"127.0.0.1";
                    }
                }
                return IPAddress.Parse(AddressIP);
            }
            catch (Exception e)
            {
                LogClass.WriteLogFile("自动获取本机IP地址异常！" + e.Message);
                return null;
            }

        }



        ///// <summary>
        ///// 相当于从数据库读到了协议编号与对应的协议含义的关系
        ///// </summary>
        ///// <returns></returns>
        public Dictionary<string, string> SetKeyValue()
        {
            Dictionary<string, string> dic = new Dictionary<string, string>();
            //从数据库中读到相应数据，然后将对应的Key以及value填充到字典中

            try
            {
                MySqlDataReader reader = SqlHelper.ExecuteReader("select * from seafloor_srcConfigInfo");
                while (reader.Read())
                {
                    dic.Add(reader.GetString(2), reader.GetString(1));
                }
                //不能在ExecuteReader中使用using，因为这样执行完成之后与数据库的连接自然会进行关闭，而实际后面一步还需要再继续在连接中读取相应数据
                reader.Close();//保证所有操作彻底完成之后再进行连接关闭操作
                reader.Dispose();
               
            
            }
            catch (Exception exp)
            {
                //MessageBox.Show("读入数据库时出现异常！"+exp.Message);
                LogClass.WriteLogFile("读入数据库seafloor_srcConfigInfo时出现异常！" + exp.Message);
            }
            return dic;

        }


        ///// <summary>
        ///// 类型于查字典，由相应的协议编号（相当于键值）得到对应的协议名称（Value值）
        ///// </summary>
        ///// <param name="message"></param>
        ///// <returns></returns>

        private string GetKeyValue(string message)
        {
            string value = null;
            if (mydic.TryGetValue(message, out value))
            {
                return value;
            }
            else
            {
                return null;
            }
        }
        
    }
}
