﻿/*
 * 时间：2017年5月5日13:49:30
 * 功能：对数据曲线界面以及状态曲线界面进行画图，将所有的操作封装成一个类
 * 具体功能：1）在画图控件上初始化加载出1000个点(采集值以及电参数值)；2）对于采集值以及状态曲线动态画图
 */
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Data;

namespace OSNSystem
{
    class _2DrawClass
    {

        private  string[,] drawdataTime = new string[15, 1000];//画图用缓存空间，保存时间信息
        private  double[,] drawdata=new double[15, 1000];//画图用缓存空间，保存数据信息
        private  int[,] drawIndex = new int[15, 2];//画图用，保存画图用的结束指示[0,0]代表了下一个需要更新的数组下标，[0，1]代表数组一共有多少个数据，最大1000

        /// <summary>
        /// 构造函数
        /// </summary>
        public _2DrawClass()
        {
            drawdataTime = new string[15, 1000];//将画图的数据暂时设置成1000个数据
            drawdata = new double[15, 1000];//画图数据暂时设定成1000个数据
            drawIndex = new int[15, 2];
        }




        /// <summary>
        /// 画线，在图版上进行操作，Load中调用的初始化画图函数
        /// </summary>
        /// <param name="strSql"></param>
        /// <param name="myChart1"></param>通道1画图控件
        /// <param name="myChart2"></param>通道2画图控件
        /// <param name="myChart3"></param>温度画图控件
        /// <param name="index"></param>
        public void drawLine(string strSql, Steema.TeeChart.TChart myChart1, Steema.TeeChart.TChart myChart2, Steema.TeeChart.TChart myChart3, Steema.TeeChart.TChart myChart4, Steema.TeeChart.TChart myChart5, Steema.TeeChart.TChart myChart6, int index)
        {
            try
            {


                DataTable tTable = SqlHelper.ExecuteDataTable(strSql);
                DataView dv = tTable.DefaultView;             
                dv.Sort = "saveDate asc";
                DataTable tempTable = dv.ToTable();//处理得到的tempTable是按照数据库中查询得到的最新数据，按照savedate升序排列

                switch (index)
                {
                    case 1://画接驳盒五路通道电压电流参数以及温度参数曲线
                        if (tempTable.Rows.Count > 0)//从数据库查出值，才重新画图
                        {
                            
                            int i = 0;

                            //1.初始化画图之前先将曲线上所有的点清空
                            myChart1.Series[0].Clear();
                            myChart2.Series[0].Clear();
                            myChart3.Series[0].Clear();
                            myChart4.Series[0].Clear();
                            myChart5.Series[0].Clear();
                            myChart6.Series[0].Clear();

                            myChart1.Series[1].Clear();
                            myChart2.Series[1].Clear();
                            myChart3.Series[1].Clear();
                            myChart4.Series[1].Clear();
                            myChart5.Series[1].Clear();


                            //坐标轴范围
                            //myChart1.Axes.Left.Maximum = Main.maxA1Value;
                            //myChart1.Axes.Left.Minimum = Main.minA1Value;

                            //myChart3.Axes.Left.Maximum = Main.maxATemp;
                            //myChart3.Axes.Left.Minimum = Main.minATemp;
                            //double maxValue = Convert.ToDouble(tempTable.Rows[0]["ch1vol"].ToString());//将第一行的A舱通道1电压值赋值成最大值
                            //double minValue = Convert.ToDouble(tempTable.Rows[0]["ch1vol"].ToString());

                            //double maxTempValue = Convert.ToDouble(tempTable.Rows[0]["temp"].ToString());//将第一行的A舱通道1温度值赋值成最大值
                            //double minTempValue = Convert.ToDouble(tempTable.Rows[0]["temp"].ToString());

                            for (; i < tempTable.Rows.Count; i++)
                            {
                                DataRow row = tempTable.Rows[i];
                                drawdata[index - 1, i] = Convert.ToDouble(row["ch1Cur"].ToString());
                                drawdata[index - 1 + 1, i] = Convert.ToDouble(row["ch1Vol"].ToString());//将通道1电压电流放入数组中保存

                                drawdata[index - 1 + 2, i] = Convert.ToDouble(row["ch2Cur"].ToString());//
                                drawdata[index - 1 + 3, i] = Convert.ToDouble(row["ch2Vol"].ToString());//通道2电压电流放入数组中保存

                                drawdata[index - 1 + 4, i] = Convert.ToDouble(row["ch3Cur"].ToString());
                                drawdata[index - 1 + 5, i] = Convert.ToDouble(row["ch3Vol"].ToString());//通道3电压电流放入数组中保存

                                drawdata[index - 1 + 6, i] = Convert.ToDouble(row["ch4Cur"].ToString());
                                drawdata[index - 1 + 7, i] = Convert.ToDouble(row["ch4Vol"].ToString());//通道4电压电流放入数组中保存

                                drawdata[index - 1 + 8, i] = Convert.ToDouble(row["ch5Cur"].ToString());
                                drawdata[index - 1 + 9, i] = Convert.ToDouble(row["ch5Vol"].ToString());//通道5电压电流放入数组中保存

                                drawdata[index - 1 + 10, i] = Convert.ToDouble(row["temp"].ToString());//温度
                                drawdataTime[index - 1+1, i] = Convert.ToString(row["saveDate"]);

                                //为后面画图方便，将数据值以及采集时间放在可变数组中
                                draw.arrayACh1Cur.Add(Convert.ToDouble(row["ch1Cur"].ToString()));
                                draw.arrayACh1Vol.Add(Convert.ToDouble(row["ch1Vol"].ToString()));



                                draw.arrayACh2Cur.Add(Convert.ToDouble(row["ch2Cur"].ToString()));
                                draw.arrayACh2Vol.Add(Convert.ToDouble(row["ch2Vol"].ToString()));


                                draw.arrayACh3Cur.Add(Convert.ToDouble(row["ch3Cur"].ToString()));
                                draw.arrayACh3Vol.Add(Convert.ToDouble(row["ch3Vol"].ToString()));



                                draw.arrayACh4Cur.Add(Convert.ToDouble(row["ch4cur"].ToString()));
                                draw.arrayACh4Vol.Add(Convert.ToDouble(row["ch4vol"].ToString()));



                                draw.arrayACh5Cur.Add(Convert.ToDouble(row["ch5Cur"].ToString()));
                                draw.arrayACh5Vol.Add(Convert.ToDouble(row["ch5Vol"].ToString()));

                                draw.arrayATemp.Add(Convert.ToDouble(row["temp"].ToString()));

                                draw.arrayACollectDate.Add(Convert.ToDateTime(row["saveDate"].ToString()));

                                //补充在控件上画线
                                myChart1.Series[0].Add(i + 1, drawdata[index - 1, i]);//通道1电流
                                myChart1.Series[1].Add(i + 1, drawdata[index - 1 + 1, i]);//通道1电压

                                myChart2.Series[0].Add(i + 1, drawdata[index - 1 + 2, i]);//2电流
                                myChart2.Series[1].Add(i + 1, drawdata[index - 1 + 3, i]);//2电压


                                myChart3.Series[0].Add(i + 1, drawdata[index - 1 + 4, i]);//3电流
                                myChart3.Series[1].Add(i + 1, drawdata[index - 1 + 5, i]);//3电压


                                myChart4.Series[0].Add(i + 1, drawdata[index - 1 + 6, i]);//4电流
                                myChart4.Series[1].Add(i + 1, drawdata[index - 1 + 7, i]);//4电压


                                myChart5.Series[0].Add(i + 1, drawdata[index - 1 + 8, i]);//5电流
                                myChart5.Series[1].Add(i + 1, drawdata[index - 1 + 9, i]);//5电压


                                myChart6.Series[0].Add(i + 1, drawdata[index - 1 + 10, i]);

                                //if (Convert.ToDouble(row["ch1vol"].ToString()) > maxValue)
                                //    maxValue = Convert.ToDouble(row["ch1vol"].ToString());
                                //if (Convert.ToDouble(row["ch1vol"].ToString()) < minValue)
                                //    minValue = Convert.ToDouble(row["ch1vol"].ToString());

                                //if (Convert.ToDouble(row["temp"].ToString()) > maxTempValue)
                                //    maxTempValue = Convert.ToDouble(row["temp"].ToString());
                                //if (Convert.ToDouble(row["temp"].ToString()) < minTempValue)
                                //    minTempValue = Convert.ToDouble(row["temp"].ToString());

                            }
                            drawIndex[index - 1, 0] = (int)(i % 1000);
                            drawIndex[index - 1 + 1, 0] = (int)(i % 1000);
                            drawIndex[index - 1 + 2, 0] = (int)(i % 1000);
                            drawIndex[index - 1 + 3, 0] = (int)(i % 1000);
                            drawIndex[index - 1 + 4, 0] = (int)(i % 1000);

                            drawIndex[index - 1 + 5, 0] = (int)(i % 1000);
                            drawIndex[index - 1 + 6, 0] = (int)(i % 1000);
                            drawIndex[index - 1 + 7, 0] = (int)(i % 1000);
                            drawIndex[index - 1 + 8, 0] = (int)(i % 1000);
                            drawIndex[index - 1 + 9, 0] = (int)(i % 1000);
                            drawIndex[index - 1 + 10, 0] = (int)(i % 1000);

                            drawIndex[index - 1, 1] = i;

                            //Main.maxA1Value = (int)(maxValue + (maxValue + minValue) / 2);
                            //Main.minA1Value = (int)(minValue - (maxValue + minValue) / 2);
                            //myChart1.Axes.Left.Maximum = Main.maxA1Value;
                            //myChart1.Axes.Left.Minimum = Main.minA1Value;

                            //Main.maxATemp = (int)(maxTempValue + (maxTempValue + minTempValue) / 2);
                            //Main.minATemp = (int)(minTempValue - (maxTempValue + minTempValue) / 2);

                            //myChart3.Axes.Left.Maximum = Main.maxATemp;
                            //myChart3.Axes.Left.Minimum = Main.minATemp;
                        }
                        break;
                    case 6://溶解氧
                        if (tempTable.Rows.Count > 0)//从数据库查出值，才重新画图
                        {
                            //int i = 0;
                            int i = 0;
                            myChart1.Series[0].Clear();
                            myChart2.Series[0].Clear();
                            myChart3.Series[0].Clear();

                            double maxTempValue = Convert.ToDouble(tempTable.Rows[0]["temp"].ToString());//将第一行的B舱通道1温度值赋值成最大值
                            double minTempValue = Convert.ToDouble(tempTable.Rows[0]["temp"].ToString());

                            for (; i < tempTable.Rows.Count; i++)
                            {
                                DataRow row = tempTable.Rows[i];
                                drawdata[index - 1, i] = Convert.ToDouble(row["ch1cur"].ToString());//将A舱通道1电流值放入数组中保存
                                drawdata[index - 1 + 1, i] = Convert.ToDouble(row["ch1vol"].ToString());//将A舱通道1电压
                                drawdata[index - 1 + 2, i] = Convert.ToDouble(row["ch2cur"].ToString());//A舱通道2电流
                                drawdata[index - 1 + 3, i] = Convert.ToDouble(row["ch2vol"].ToString());//A舱通道2电压
                                drawdata[index - 1 + 4, i] = Convert.ToDouble(row["temp"].ToString());//A舱温度
                                drawdataTime[index - 1 + 1, i] = Convert.ToString(row["collectdate"]);

                                //为后面画图方便，将数据值以及采集时间放在可变数组中
                                draw.arrayBCh1Cur.Add(Convert.ToDouble(row["ch1cur"].ToString()));
                                draw.arrayBCh1Vol.Add(Convert.ToDouble(row["ch1vol"].ToString()));
                                draw.arrayBCh2Cur.Add(Convert.ToDouble(row["ch2cur"].ToString()));
                                draw.arrayBCh2Vol.Add(Convert.ToDouble(row["ch2vol"].ToString()));
                                draw.arrayBTemp.Add(Convert.ToDouble(row["temp"].ToString()));

                                draw.arrayBCollectDate.Add(Convert.ToString(row["collectdate"]));

                                //补充在控件上画线
                                myChart1.Series[0].Add(i + 1, drawdata[index - 1, i]);//通道1电流
                                myChart1.Series[1].Add(i + 1, drawdata[index - 1 + 1, i]);//通道1电压
                                myChart2.Series[0].Add(i + 1, drawdata[index - 1 + 2, i]);//2电流
                                myChart2.Series[1].Add(i + 1, drawdata[index - 1 + 3, i]);//2电压

                                myChart3.Series[0].Add(i + 1, drawdata[index - 1 + 4, i]);

                                if (Convert.ToDouble(row["temp"].ToString()) > maxTempValue)
                                    maxTempValue = Convert.ToDouble(row["temp"].ToString());
                                if (Convert.ToDouble(row["temp"].ToString()) < minTempValue)
                                    minTempValue = Convert.ToDouble(row["temp"].ToString());

                                //Main.maxBTemp = (int)(maxTempValue + (maxTempValue + minTempValue) / 2);
                                //Main.minBTemp = (int)(minTempValue - (maxTempValue + minTempValue) / 2);
                                //myChart3.Axes.Left.Maximum = Main.maxBTemp;
                                //myChart3.Axes.Left.Minimum = Main.minBTemp;

                            }

                            int num = myChart1.Series[1].Count;

                            drawIndex[index - 1, 0] = (int)(i % 1000);
                            drawIndex[index - 1 + 1, 0] = (int)(i % 1000);
                            drawIndex[index - 1 + 2, 0] = (int)(i % 1000);
                            drawIndex[index - 1 + 3, 0] = (int)(i % 1000);
                            drawIndex[index - 1 + 4, 0] = (int)(i % 1000);
                            drawIndex[index - 1, 1] = i;
                        }
                        break;
                    
                }
            }
            catch (Exception exp)
            {
                //MessageBox.Show("画采集值图出现异常！"+exp.Message);
                LogClass.WriteLogFile("Load加载1000点出现异常！" + exp.Message);
            }

        }


       /// <summary>
       /// 每次获得一个数据，更新到缓存中
       /// </summary>
       /// <param name="datatime">采集时间</param>
       /// <param name="data">采集值</param>
       /// <param name="arrayIndex">数据类型指示</param>
       public  void refreshDrawDataArray(string datatime, double data, int arrayIndex, Main f)
       {
           int j;

           if (drawIndex[arrayIndex - 1, 1] < 1000)//针对数据库中已存数据不满1000个点情况
           {
               j = drawIndex[arrayIndex - 1, 1];
               drawdata[arrayIndex - 1, j] = data;
               drawdataTime[arrayIndex - 1, j] = datatime;
               drawIndex[arrayIndex - 1, 1]++;//曲线上点的个数++
               drawIndex[arrayIndex - 1, 0] = 0;//曲线上个数不足1000时，曲线上点全部从0开始绘图
               //drawSignal = 1;

           }
           else
           {
               j = drawIndex[arrayIndex - 1, 0];
               drawdata[arrayIndex - 1, j] = data;
               drawdataTime[arrayIndex - 1, j] = datatime;
               drawIndex[arrayIndex - 1, 0] = (int)(++j % 1000);//曲线上
           }

           realTimeDrawLine(f, arrayIndex);//数据更新缓存完成之后，将数据实时绘制到控件上面形成曲线

       }


       /// <summary>
       ///1.实时画画高压舱状态图时将数据更新到数组中
       /// </summary>
       /// <param name="datatime"></param>时间
       /// <param name="current0"></param>前端电流
       /// <param name="voltage0"></param>前端电压
       /// <param name="current1"></param>后端1路电流
       /// <param name="voltage1"></param>后端1路电压
       /// <param name="current2"></param>后端2路电流
       /// <param name="voltage2"></param>后端2路电压
       /// <param name="temp"></param>主接驳盒高压舱内温度
       /// <param name="arrayIndex"></param>
       /// <param name="f"></param>
       public void refreshDrawHighStsArray(string datatime, double current0, double voltage0, double current1, double voltage1, double current2, double voltage2, double temp, int arrayIndex, Main f)
       {
           int j;
           if (drawIndex[arrayIndex - 1, 1] < 1000)//保存数据中数据的个数
           {
               j = drawIndex[arrayIndex - 1, 1];//下次更新坐标值

               drawdata[arrayIndex - 1, j] = current0;//通道1电流值更新缓存
               drawdata[arrayIndex - 1 + 1, j] = voltage0;//通道1 电压值更新缓存

               drawdata[arrayIndex - 1 + 2, j] = current1;//通道2电流值更新缓存
               drawdata[arrayIndex - 1 + 3, j] = voltage1;//通道2电压值更新缓存


               drawdata[arrayIndex - 1 + 4, j] = current2;
               drawdata[arrayIndex - 1 + 5, j] = voltage2;//通道3

               drawdata[arrayIndex - 1 + 6, j] = temp;//温度值更新缓存

               drawdataTime[arrayIndex - 1, j] = datatime;
               drawIndex[arrayIndex - 1, 1]++;//保存曲线上点的个数，最大为1000
               drawIndex[arrayIndex - 1, 0] = 0;//下次画图更新的起点
           }
           else
           {
               j = drawIndex[arrayIndex - 1, 0];

               drawdata[arrayIndex - 1, j] = current0;//通道1电流值更新缓存
               drawdata[arrayIndex - 1 + 1, j] = voltage0;//通道1电压值更新缓存

               drawdata[arrayIndex - 1 + 2, j] = current1;//通道2电流值更新缓存
               drawdata[arrayIndex - 1 + 3, j] = voltage1;//通道2电压值更新缓存

               drawdata[arrayIndex - 1 + 4, j] = current2;
               drawdata[arrayIndex - 1 + 5, j] = voltage2;//通道3

               drawdata[arrayIndex - 1 + 10, j] = temp;//温度值更新缓存

               drawdataTime[arrayIndex - 1, j] = datatime;
               drawIndex[arrayIndex - 1, 0] = (int)(++j % 1000);
           }
           realTimeDrawLine(f, arrayIndex);//数据缓存更新完成，将电压电流数据实时绘制到图上控件中相应位置
       }


       /// <summary>
       /// 2.实时画低压舱次级接驳盒状态图时将数据更新到数组中
       /// </summary>
       /// <param name="datatime"></param>时间
       /// <param name="current1"></param>通道1电流
       /// <param name="voltage1"></param>通道1电压
       /// <param name="current2"></param>通道2电流
       /// <param name="voltage2"></param>通道2电压
       /// <param name="temp"></param>温度
       /// <param name="arrayIndex"></param>
       /// <param name="f"></param>
       public void refreshDrawLowStsArray(string datatime,double current1, double voltage1, double current2, double voltage2, double temp, int arrayIndex, Main f)
       {
           int j;
           if (drawIndex[arrayIndex - 1, 1] < 1000)//保存数据中数据的个数
           {
               j = drawIndex[arrayIndex - 1, 1];//下次更新坐标值

               drawdata[arrayIndex - 1, j] = current1;//通道1电流值更新缓存
               drawdata[arrayIndex - 1 + 1, j] = voltage1;//通道1 电压值更新缓存

               drawdata[arrayIndex - 1 + 2, j] = current2;//通道2电流值更新缓存
               drawdata[arrayIndex - 1 + 3, j] = voltage2;//通道2电压值更新缓存

               drawdata[arrayIndex - 1 + 4, j] = temp;//温度值更新缓存

               drawdataTime[arrayIndex - 1, j] = datatime;
               drawIndex[arrayIndex - 1, 1]++;//保存曲线上点的个数，最大为1000
               drawIndex[arrayIndex - 1, 0] = 0;//下次画图更新的起点
           }
           else
           {
               j = drawIndex[arrayIndex - 1, 0];

               drawdata[arrayIndex - 1, j] = current1;//通道1电流值更新缓存
               drawdata[arrayIndex - 1 + 1, j] = voltage1;//通道1电压值更新缓存

               drawdata[arrayIndex - 1 + 2, j] = current2;//通道2电流值更新缓存
               drawdata[arrayIndex - 1 + 3, j] = voltage2;//通道2电压值更新缓存
            
               drawdata[arrayIndex - 1 + 4, j] = temp;//温度值更新缓存

               drawdataTime[arrayIndex - 1, j] = datatime;
               drawIndex[arrayIndex - 1, 0] = (int)(++j % 1000);
           }
           realTimeDrawLine(f, arrayIndex);//数据缓存更新完成，将电压电流数据实时绘制到图上控件中相应位置
       }


       /// <summary>
       /// 3.实时更新曲线
       /// </summary>
       /// <param name="myChart"></param>
       /// <param name="index"></param>
       private  void realTimeDrawLine(Main f, int index)
       {
           try
           {
               switch (index)
               {                 
                   case 1://高压舱所有参数更新（前端电压、电流以及后端1路电压电流后端2路电压电流）
                       {
                           int i = drawIndex[index - 1, 0];//电压电流每次需要更新的坐标值相同
                          
                           int j = 0;
                           //画图始终是从第0个点开始画至第1000个，只不过从哪开始画的起点不一样
                           if (drawIndex[index - 1, 1] < 1000)
                           {
                               f.picACh0.Series[0].Clear();//主接驳盒高压舱前端电流曲线
                               f.picACh0.Series[1].Clear();//主接驳盒高压舱前端电压曲线

                               f.picACh1.Series[0].Clear();//主接驳盒高压舱后端1路电流曲线
                               f.picACh1.Series[1].Clear();//主接驳盒高压舱后端1路电压曲线

                               f.picACh2.Series[0].Clear();//主接驳盒高压舱后端2路电流曲线
                               f.picACh2.Series[1].Clear();//主接驳盒高压舱后端2路电压曲线

                              // f.picTemp.Series[0].Clear();//温度曲线


                               //改变A舱通道1曲线的坐标轴范围
                               //f.picACh1.Axes.Left.Maximum = Main.maxA1Value;
                               //f.picACh1.Axes.Left.Minimum = Main.minA1Value;

                               //f.picATemp.Axes.Left.Maximum = Main.maxATemp;
                               //f.picATemp.Axes.Left.Minimum = Main.minATemp;

                               for (; j < drawIndex[index - 1, 1]; j++)
                               {
                                   f.picACh0.Series[0].Add(j + 1, drawdata[index - 1, i]);//主接驳盒前端电流控件画线                                   
                                   f.picACh0.Series[1].Add(j + 1, drawdata[index - 1 + 1, i]);//主接驳盒前端电压控件画线

                                   f.picACh1.Series[0].Add(j + 1, drawdata[index - 1 + 2, i]);//主接驳盒后端1路电流控件画线                                   
                                   f.picACh1.Series[1].Add(j + 1, drawdata[index - 1 + 3, i]);//主接驳盒后端1路电压控件画线


                                   f.picACh2.Series[0].Add(j + 1, drawdata[index - 1 + 4, i]);//主接驳盒后端2路电流控件画线                                   
                                   f.picACh2.Series[1].Add(j + 1, drawdata[index - 1 + 5, i]);//主接驳盒后端2路电压控件画线
                                  
                                  // f.picTemp.Series[0].Add(j + 1, drawdata[index - 1 + 6, i]);//温度曲线控件画线
                                   
                                   i = (int)(++i % 1000);
                               }

                               if (drawIndex[index - 1, 1] == 999)
                               {
                                   f.picACh0.Series[0].Add(1000, null);
                                   f.picACh0.Series[1].Add(1000, null);

                                   f.picACh1.Series[0].Add(1000, null);
                                   f.picACh1.Series[1].Add(1000, null);

                                   f.picACh2.Series[0].Add(1000, null);
                                   f.picACh2.Series[1].Add(1000, null);


                                  // f.picTemp.Series[0].Add(1000,null);

                               }

                           }
                           else//若更新曲线超过1000个数据点之后
                           {
                               f.picACh0.Series[0].SetNull(f.picACh0.Series[0].Count);//前端电流曲线
                               f.picACh0.Series[1].SetNull(f.picACh0.Series[1].Count);//前端电压曲线

                               f.picACh1.Series[0].SetNull(f.picACh1.Series[0].Count);//后端1路电流曲线赋空值
                               f.picACh1.Series[1].SetNull(f.picACh1.Series[1].Count);//后端1路电压曲线

                               f.picACh2.Series[0].SetNull(f.picACh2.Series[0].Count);//后端2路电流曲线赋空值
                               f.picACh2.Series[1].SetNull(f.picACh2.Series[1].Count);//后端2路电压曲线


                              // f.picTemp.Series[0].SetNull(f.picTemp.Series[0].Count);//温度曲线赋空值

                               //曲线更新更新超过1000个点之后坐标轴范围还是能自动调整
                               //f.picACh1.Axes.Left.Maximum = Main.maxA1Value;
                               //f.picACh1.Axes.Left.Minimum = Main.minA1Value;

                               //f.picATemp.Axes.Left.Maximum = Main.maxATemp;
                               //f.picATemp.Axes.Left.Minimum = Main.minATemp;

                               for (; j < drawIndex[index - 1, 1]; j++)
                               {

                                   f.picACh0.Series[0].XValues[j] = j + 1;//前端电流曲线赋值
                                   f.picACh0.Series[0].YValues[j] = drawdata[index - 1, i];

                                   f.picACh0.Series[1].XValues[j] = j + 1;//前端电压曲线赋值
                                   f.picACh0.Series[1].YValues[j] = drawdata[index - 1 + 1, i];


                                   f.picACh1.Series[0].XValues[j] = j + 1;//后端1路电流曲线赋值
                                   f.picACh1.Series[0].YValues[j] = drawdata[index - 1 + 2, i];

                                   f.picACh1.Series[1].XValues[j] = j + 1;//后端1路电压曲线赋值
                                   f.picACh1.Series[1].YValues[j] = drawdata[index - 1 + 3, i];



                                   f.picACh2.Series[0].XValues[j] = j + 1;//后端2段电流曲线赋值
                                   f.picACh2.Series[0].YValues[j] = drawdata[index - 1 + 4, i];

                                   f.picACh2.Series[1].XValues[j] = j + 1;//后端2路电压曲线赋值
                                   f.picACh2.Series[1].YValues[j] = drawdata[index - 1 + 5, i];


                                 //  f.picTemp.Series[0].XValues[j] = j + 1;
                                  // f.picTemp.Series[0].YValues[j] = drawdata[index - 1 + 6, i];


                                   i = (int)(++i % 1000);
                               }
                           }

                           f.picACh0.Series[0].BeginUpdate();
                           f.picACh0.Series[0].EndUpdate();
                           f.picACh0.Series[1].BeginUpdate();
                           f.picACh0.Series[1].EndUpdate();

                           f.picACh1.Series[0].BeginUpdate();
                           f.picACh1.Series[0].EndUpdate();
                           f.picACh1.Series[1].BeginUpdate();
                           f.picACh1.Series[1].EndUpdate();

                           f.picACh2.Series[0].BeginUpdate();
                           f.picACh2.Series[0].EndUpdate();
                           f.picACh2.Series[1].BeginUpdate();
                           f.picACh2.Series[1].EndUpdate();


                           //f.picTemp.Series[0].BeginUpdate();
                           //f.picTemp.Series[0].EndUpdate();

                       }
                       break;                  
                   case 8://实时画次级接驳盒状态曲线
                       {
                           int i = drawIndex[index - 1, 0];//电压电流每次需要更新的坐标值相同

                           int j = 0;

                           if (drawIndex[index - 1, 1] < 1000)
                           {
                               f.picBCh1.Series[0].Clear();//低压舱次级接驳盒通道1电流曲线
                               f.picBCh1.Series[1].Clear();//低压舱次级接驳盒通道1电压曲线

                               f.picBCh2.Series[0].Clear();//低压舱次级接驳盒通道2电流曲线
                               f.picBCh2.Series[1].Clear();//低压舱次级接驳盒通道2电压曲线

                               f.picTemp.Series[0].Clear();//低压舱次级接驳盒温度曲线

                               for (; j < drawIndex[index - 1, 1]; j++)
                               {
                                   f.picBCh1.Series[0].Add(j + 1, drawdata[index - 1, i]);//通道1电流控件画线                            
                                   f.picBCh1.Series[1].Add(j + 1, drawdata[index - 1 + 1, i]);//通道1电压控件画线

                                   f.picBCh2.Series[0].Add(j + 1, drawdata[index - 1+2, i]);//通道2电流控件画线
                                   f.picBCh2.Series[1].Add(j + 1, drawdata[index - 1 + 3, i]);//通道2电压控件画线

                                   f.picTemp.Series[0].Add(j+1,drawdata[index-1+4,i]);//温度曲线控件画线
                                   
                                   i = (int)(++i % 1000);
                               }

                               if (drawIndex[index - 1, 1] == 999)
                               {
                                   f.picBCh1.Series[0].Add(1000, null);
                                   f.picBCh1.Series[1].Add(1000, null);

                                   f.picBCh2.Series[0].Add(1000,null);
                                   f.picBCh2.Series[1].Add(1000,null);

                                   f.picTemp.Series[0].Add(1000,null);

                               }


                           }
                           else
                           {
                               f.picBCh1.Series[0].SetNull(1000);
                               f.picBCh1.Series[1].SetNull(1000);

                               f.picBCh2.Series[0].SetNull(1000);
                               f.picBCh2.Series[1].SetNull(1000);

                               f.picTemp.Series[0].SetNull(1000);

                               for (; j < drawIndex[index - 1, 1]; j++)
                               {

                                   f.picBCh1.Series[0].XValues[j] = j + 1;//通道1电流曲线赋值
                                   f.picBCh1.Series[0].YValues[j] = drawdata[index - 1, i];

                                   f.picBCh1.Series[1].XValues[j] = j + 1;//通道1电压曲线赋值
                                   f.picBCh1.Series[1].YValues[j] = drawdata[index - 1 + 1, i];

                                   f.picBCh2.Series[0].XValues[j] = j + 1;//通道2电流曲线赋值
                                   f.picBCh2.Series[0].YValues[j] = drawdata[index - 1+2, i];

                                   f.picBCh2.Series[1].XValues[j] = j + 1;//通道2电压曲线赋值
                                   f.picBCh2.Series[1].YValues[j] = drawdata[index - 1 + 3, i];

                                   f.picTemp.Series[0].XValues[j] = j + 1;//温度曲线赋值
                                   f.picTemp.Series[0].YValues[j] = drawdata[index - 1 + 4, i];

                                   i = (int)(++i % 1000);
                               }
                           }

                           f.picBCh1.Series[0].BeginUpdate();//通道1电流曲线
                           f.picBCh1.Series[0].EndUpdate();
                           f.picBCh1.Series[1].BeginUpdate();//通道1电压曲线
                           f.picBCh1.Series[1].EndUpdate();

                           f.picBCh2.Series[0].BeginUpdate();//通道2电流曲线
                           f.picBCh2.Series[0].EndUpdate();
                           f.picBCh2.Series[1].BeginUpdate();//通道2电压曲线
                           f.picBCh2.Series[1].EndUpdate();

                           f.picTemp.Series[0].BeginUpdate();//通道温度曲线
                           f.picTemp.Series[0].EndUpdate();
                       }
                       break;                  
               }
           }
           catch (Exception exp)
           {
               LogClass.WriteLogFile("画采集值图" + index + "出现异常！" + exp.Message.ToString());
           }

       }

        /// <summary>
        /// 画主接驳盒高压舱电参数状态曲线
        /// </summary>
        /// <param name="strSql"></param>//查询前端电流电压、后端输出1路2路的电流以及电压
        /// <param name="myChart1"></param>前端电流电压
        /// <param name="myChart2"></param>后端1路电流电压
        /// <param name="myChart3"></param>后端2路电流电压
        /// <param name="index"></param>
       public void drawJbHighStsLine(string strSql, Steema.TeeChart.TChart myChart1, Steema.TeeChart.TChart myChart2, Steema.TeeChart.TChart myChart3, Steema.TeeChart.TChart myChart4, int index)
       {

           try
           {


               DataTable tTable = SqlHelper.ExecuteDataTable(strSql);
               DataView dv = tTable.DefaultView;
               dv.Sort = "saveDate asc";
               DataTable tempTable = dv.ToTable();//处理得到的tempTable是按照数据库中查询得到的最新数据，按照savedate升序排列

               switch (index)
               {
                   case 1://画主接驳盒高压舱前端电流电压，以及后端输出1路，2路电流电流曲线
                       if (tempTable.Rows.Count > 0)//从数据库查出值，才重新画图
                       {

                           int i = 0;

                           //1.初始化画图之前先将曲线上所有的点清空
                           myChart1.Series[0].Clear();
                           myChart2.Series[0].Clear();
                           myChart3.Series[0].Clear();
                           //myChart4.Series[0].Clear();
                           

                           myChart1.Series[1].Clear();
                           myChart2.Series[1].Clear();
                           myChart3.Series[1].Clear();
                          

                           
                           for (; i < tempTable.Rows.Count; i++)
                           {
                               DataRow row = tempTable.Rows[i];
                               drawdata[index - 1, i] = Convert.ToDouble(row["fCur"].ToString());
                               drawdata[index - 1 + 1, i] = Convert.ToDouble(row["fVol"].ToString());//将前端电压电流放入数组中保存

                               drawdata[index - 1 + 2, i] = Convert.ToDouble(row["bCur1"].ToString());//
                               drawdata[index - 1 + 3, i] = Convert.ToDouble(row["bVol1"].ToString());//后端1路电压电流放入数组中保存

                               drawdata[index - 1 + 4, i] = Convert.ToDouble(row["bCur2"].ToString());
                               drawdata[index - 1 + 5, i] = Convert.ToDouble(row["bVol2"].ToString());//后端2路电压电流放入数组中保存


                               drawdata[index - 1 + 6, i] = Convert.ToDouble(row["temp"].ToString());//将主接驳盒舱内温度存入可变数组中
                             
                               drawdataTime[index - 1 + 1, i] = Convert.ToString(row["saveDate"]);

                               //为后面画图方便，将数据值以及采集时间放在可变数组中
                               draw.arrayHCh0Cur.Add(Convert.ToDouble(row["fCur"].ToString()));
                               draw.arrayHCh0Vol.Add(Convert.ToDouble(row["fVol"].ToString()));



                               draw.arrayHCh1Cur.Add(Convert.ToDouble(row["bCur1"].ToString()));
                               draw.arrayHCh1Vol.Add(Convert.ToDouble(row["bVol1"].ToString()));


                               draw.arrayHCh2Cur.Add(Convert.ToDouble(row["bCur2"].ToString()));
                               draw.arrayHCh2Vol.Add(Convert.ToDouble(row["bVol2"].ToString()));

                               draw.arrayHTemp.Add(Convert.ToDouble(row["temp"].ToString()));
                               //draw.arrayACollectDate.Add(Convert.ToDateTime(row["saveDate"].ToString()));

                               draw.arrayHSaveDate.Add(Convert.ToDateTime(row["saveDate"].ToString()));

                               //补充在控件上画线
                               myChart1.Series[0].Add(i + 1, drawdata[index - 1, i]);//通道1电流
                               myChart1.Series[1].Add(i + 1, drawdata[index - 1 + 1, i]);//通道1电压

                               myChart2.Series[0].Add(i + 1, drawdata[index - 1 + 2, i]);//2电流
                               myChart2.Series[1].Add(i + 1, drawdata[index - 1 + 3, i]);//2电压

                               myChart3.Series[0].Add(i + 1, drawdata[index - 1 + 4, i]);//3电流
                               myChart3.Series[1].Add(i + 1, drawdata[index - 1 + 5, i]);//3电压

                              // myChart4.Series[0].Add(i + 1, drawdata[index - 1 + 6, i]);//主接驳盒舱内温度



                           }

                           drawIndex[index - 1, 0] = (int)(i % 1000);
                           drawIndex[index - 1 + 1, 0] = (int)(i % 1000);
                           drawIndex[index - 1 + 2, 0] = (int)(i % 1000);
                           drawIndex[index - 1 + 3, 0] = (int)(i % 1000);
                           drawIndex[index - 1 + 4, 0] = (int)(i % 1000);
                           drawIndex[index - 1 + 5, 0] = (int)(i % 1000);
                           drawIndex[index - 1 + 6, 0] = (int)(i % 1000);
                           

                           drawIndex[index - 1, 1] = i;
                         
                       }
                       break;
               }
           }
           catch (Exception exp)
           {
               LogClass.WriteLogFile("Load加载主接驳盒高压舱电电参数1000点出现异常！" + exp.Message);
           }
 
       }


        /// <summary>
        /// 画次接驳盒低压舱状态参数曲线
        /// </summary>
        /// <param name="strSql"></param>//查询次接驳盒低压舱通道1以及通道2以及温度的sql语句
        /// <param name="myChart1"></param>
        /// <param name="myChart2"></param>
        /// <param name="myChart3"></param>
        /// <param name="index"></param>
       public void drawJbLowStsLine(string strSql, Steema.TeeChart.TChart myChart1, Steema.TeeChart.TChart myChart2, Steema.TeeChart.TChart myChart3,int index)
       {
           try
           {


               DataTable tTable = SqlHelper.ExecuteDataTable(strSql);
               DataView dv = tTable.DefaultView;
               dv.Sort = "saveDate asc";
               DataTable tempTable = dv.ToTable();//处理得到的tempTable是按照数据库中查询得到的最新数据，按照savedate升序排列

               switch (index)
               {
                   case 8://画次接驳盒低压舱通道1，2电压电流曲线以及温度曲线
                       if (tempTable.Rows.Count > 0)//从数据库查出值，才重新画图
                       {

                           int i = 0;

                           //1.初始化画图之前先将曲线上所有的点清空
                           myChart1.Series[0].Clear();//次接驳盒通道1电流曲线清空
                           myChart2.Series[0].Clear();//次接驳盒通道2电流曲线清空

                          


                           myChart1.Series[1].Clear();//次接驳盒通道1电压曲线清空
                           myChart2.Series[1].Clear();//次接驳盒通道2电压曲线清空
                           myChart3.Series[0].Clear();//次接驳盒舱内温度曲线清空



                           for (; i < tempTable.Rows.Count; i++)
                           {
                               DataRow row = tempTable.Rows[i];
                               drawdata[index - 1, i] = Convert.ToDouble(row["ch1Cur"].ToString());
                               drawdata[index - 1 + 1, i] = Convert.ToDouble(row["ch1Vol"].ToString());//将通道1电路电压放入数组中保存

                               drawdata[index - 1 + 2, i] = Convert.ToDouble(row["ch2Cur"].ToString());
                               drawdata[index - 1 + 3, i] = Convert.ToDouble(row["ch2Vol"].ToString());//将通道2电路电压放入数组中保存

                               drawdata[index - 1 + 4, i] = Convert.ToDouble(row["temp"].ToString());//将次接驳盒舱内温度存入可变数组中


                               drawdataTime[index - 1 + 1, i] = Convert.ToString(row["saveDate"]);

                               //为后面画图方便，将数据值以及采集时间放在可变数组中
                               draw.arrayLCh1Cur.Add(Convert.ToDouble(row["ch1Cur"].ToString()).ToString("00.000"));
                               draw.arrayLCh1Vol.Add(Convert.ToDouble(row["ch1Vol"].ToString()).ToString("00.000"));



                               draw.arrayLCh2Cur.Add(Convert.ToDouble(row["ch2Cur"].ToString()).ToString("00.000"));
                               draw.arrayLCh2Vol.Add(Convert.ToDouble(row["ch2Vol"].ToString()).ToString("00.000"));

                               draw.arrayLTemp.Add(Convert.ToDouble(row["temp"].ToString()).ToString("00.000"));
                               
                               draw.arrayLSaveDate.Add(Convert.ToDateTime(row["saveDate"].ToString()));



                               //为了后面传输给计算中心次级接驳盒的状态，将通道3、4、5的电压电流信息也存入动态数组中去
                               draw.arrayLCh3Cur.Add(Convert.ToDouble(row["ch3Cur"].ToString()).ToString("00.000"));
                               draw.arrayLCh3Vol.Add(Convert.ToDouble(row["ch3Vol"].ToString()).ToString("00.000"));

                               draw.arrayLCh4Cur.Add(Convert.ToDouble(row["ch4Cur"].ToString()).ToString("00.000"));
                               draw.arrayLCh4Vol.Add(Convert.ToDouble(row["ch4Vol"].ToString()).ToString("00.000"));

                               draw.arrayLCh5Cur.Add(Convert.ToDouble(row["ch5Cur"].ToString()).ToString("00.000"));
                               draw.arrayLCh5Vol.Add(Convert.ToDouble(row["ch5Vol"].ToString()).ToString("00.000"));


                               //补充在控件上画线
                               myChart1.Series[0].Add(i + 1, drawdata[index - 1, i]);//通道1电流
                               myChart1.Series[1].Add(i + 1, drawdata[index - 1 + 1, i]);//通道1电压

                               myChart2.Series[0].Add(i + 1, drawdata[index - 1 + 2, i]);//2电流
                               myChart2.Series[1].Add(i + 1, drawdata[index - 1 + 3, i]);//2电压

                             
                               myChart3.Series[0].Add(i + 1, drawdata[index - 1 + 4, i]);//3温度

                               


                           }

                           drawIndex[index - 1, 0] = (int)(i % 1000);
                           drawIndex[index - 1 + 1, 0] = (int)(i % 1000);
                           drawIndex[index - 1 + 2, 0] = (int)(i % 1000);
                           drawIndex[index - 1 + 3, 0] = (int)(i % 1000);
                           drawIndex[index - 1 + 4, 0] = (int)(i % 1000);
           
                           drawIndex[index - 1, 1] = i;

                       }
                       break;
               }
           }
           catch (Exception exp)
           {
               LogClass.WriteLogFile("Load加载次接驳盒低压舱状态参数1000点出现异常！" + exp.Message);
           }
       }


    /// <summary>
    /// 将数据采集器各个通道电压电流以及温度状态数据添加到动态数组中
    /// </summary>
    /// <param name="strSql"></param>
    /// <param name="index"></param>
       public void addDynamicArray(string strSql,int index)
       {

           try
           {
               DataTable tTable = SqlHelper.ExecuteDataTable(strSql);
               DataView dv = tTable.DefaultView;
               dv.Sort = "saveDate asc";
               DataTable tempTable = dv.ToTable();//处理得到的tempTable是按照数据库中查询得到的最新数据，按照savedate升序排列

               switch (index)
               {
                   case 1://将数据采集器通道1电压电流值存入动态数组中
                       if (tempTable.Rows.Count > 0)//从数据库查出值，才重新画图
                       {

                           //int i = 0;
                           //for (; i < tempTable.Rows.Count; i++)
                           //{
                               DataRow row = tempTable.Rows[0];

                               draw.arrayDCCh1Cur.Add(Convert.ToDouble(row["current"].ToString()).ToString("00.000"));
                               draw.arrayDCCh1Vol.Add(Convert.ToDouble(row["voltage"].ToString()).ToString("00.000"));
                           //}

                       }
                       break;
                   case 2://将数据采集器通道2电压电流值存入动态数组中
                       if (tempTable.Rows.Count > 0)//从数据库查出值，才重新画图
                       {

                           //int i = 0;
                           //for (; i < tempTable.Rows.Count; i++)
                           //{
                               DataRow row = tempTable.Rows[0];

                               draw.arrayDCCh2Cur.Add(Convert.ToDouble(row["current"].ToString()).ToString("00.000"));
                               draw.arrayDCCh2Vol.Add(Convert.ToDouble(row["voltage"].ToString()).ToString("00.000"));
                           //}

                       }
                       break;
                   case 3://将数据采集器通道3电压电流值存入动态数组中
                       if (tempTable.Rows.Count > 0)//从数据库查出值，才重新画图
                       {

                           //int i = 0;
                           //for (; i < tempTable.Rows.Count; i++)
                           //{
                               DataRow row = tempTable.Rows[0];

                               draw.arrayDCCh3Cur.Add(Convert.ToDouble(row["current"].ToString()).ToString("00.000"));
                               draw.arrayDCCh3Vol.Add(Convert.ToDouble(row["voltage"].ToString()).ToString("00.000"));
                           //}

                       }
                       break;
                   case 4://将数据采集器通道4电压电流值存入动态数组中
                       if (tempTable.Rows.Count > 0)//从数据库查出值，才重新画图
                       {

                           //int i = 0;
                           //for (; i < tempTable.Rows.Count; i++)
                           //{
                               DataRow row = tempTable.Rows[0];
                              
                               draw.arrayDCCh4Cur.Add(Convert.ToDouble(row["current"].ToString()).ToString("00.000"));
                               draw.arrayDCCh4Vol.Add(Convert.ToDouble(row["voltage"].ToString()).ToString("00.000"));
                          // }

                       }
                       break;
                   case 5://将数据采集器通道5电压电流值存入动态数组中
                       if (tempTable.Rows.Count > 0)//从数据库查出值，才重新画图
                       {
                           //int i = 0;
                           //for (; i < tempTable.Rows.Count; i++)
                           //{
                               DataRow row = tempTable.Rows[0];
                              
                               draw.arrayDCCh5Cur.Add(Convert.ToDouble(row["current"].ToString()).ToString("00.000"));
                               draw.arrayDCCh5Vol.Add(Convert.ToDouble(row["voltage"].ToString()).ToString("00.000"));
                           //}
                       }
                       break;
                   case 6:
                       if(tempTable.Rows.Count > 0)
                       {
                           //int i = 0;
                           //for (; i < tempTable.Rows.Count; i++ )
                           
                           //{
                               DataRow row = tempTable.Rows[0];
                               draw.arrayDCTemp.Add(Convert.ToDouble(row["temp"].ToString()).ToString("00.000"));
                           //}
                       }
                       break;
               }
           }
           catch (Exception exp)
           {
               LogClass.WriteLogFile("将数据采集器状态数据添加到动态数组中出现异常！" + exp.Message);
           }
       }




       

    }
}
