﻿/*
 * 时间：将接收到的信息单独封装
 * 功能：3）连接建立完成之后，接收客户端传递过来的信息；4)处理接收到的信息
 * 改进：将原来送到界面显示的信息使用委托回调函数的形式代替原来Timer刷新static全局变量
 * Tcpclient等变量使用构造函数传递进来，支持多个客户端进行连接
 */
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Net.Sockets;
using System.IO;
using System.Drawing;
using System.Threading;
using System.Text.RegularExpressions;
using MySql.Data.MySqlClient;
using System.Net;
using System.Data;
using System.Windows.Forms;
using System.Security.Permissions;
using System.Runtime.Serialization.Formatters.Binary;
using System.Xml.Linq;

namespace OSNSystem
{

   


    class _3ReceieveMsgClass
    {

        /**增加的关于舱内状态数据的正则表达式形式***/
        static string exp1 = "(\\$)(Data)(\\+01)(\\+Temp:)(\\+)(\\d{2})(\\.)(\\d{3})(\\+LeakA:)(\\d{3})(\\.)(\\d{2})(\\+LeakB:)(\\d{3})(\\.)(\\d{2})";
        static string exp2 = "(\\+CurA:)(\\d{2})(\\.)(\\d{3})(\\+VolA:)(\\d{2})(\\.)(\\d{3})(\\+CurB:)(\\d{2})(\\.)(\\d{3})(\\+VolB:)(\\d{2})(\\.)(\\d{3})(\\+CurC:)(\\d{2})(\\.)(\\d{3})(\\+VolC:)(\\d{2})(\\.)(\\d{3})(\\+CurD:)(\\d{2})(\\.)(\\d{3})(\\+VolD:)(\\d{2})(\\.)(\\d{3})(\\+CurE:)(\\d{2})(\\.)(\\d{3})(\\+VolE:)(\\d{2})(\\.)(\\d{3})(\\#)";

        static string exp3 = "(\\$)(Data)(\\+01)(\\+Temp:)(\\-)(\\d{2})(\\.)(\\d{3})(\\+LeakA:)(\\d{3})(\\.)(\\d{2})(\\+LeakB:)(\\d{3})(\\.)(\\d{2})";
        

        string expCabin = exp1 + exp2;//舱内正常返回的状态数据的正则表达式，温度前面为正号

        string expCabin2 = exp3 + exp2;//舱内正常返回的状态数据的正则表达式，温度前面为负号

        /***************接驳盒增加的实际变量*****************/

        public static int i = 0;

        public static int flagOnA1 = 0;//通道1打开标志位
        public static int flagOffA1 = 0;//通道1关闭标志位

        public static int flagOnA2 = 0;//通道2打开标志位
        public static int flagOffA2 = 0;//通道2关闭标志位

        public static int flagOnA3 = 0;//通道3打开标志位
        public static int flagOffA3 = 0;//通道3关闭标志位

        public static int flagOnA4 = 0;//通道4打开标志位
        public static int flagOffA4 = 0;//通道4关闭标志位

        public static int flagOnA5 = 0;//通道5打开标志位
        public static int flagOffA5 = 0;//通道5关闭标志位


        public static int flagTime = 0;//下位机校时指令执行成功反馈

        public static int flagOpen = 0;//打开摄像头的标志位
        public static int flagClose = 0;//关闭摄像头的标志位


        public static int flagA1 = 0;//次接驳盒通道1电压电流界限设置成功标志
        public static int flagA2 = 0;//次接驳盒通道2电压电流界限设置成功标志
        public static int flagA3 = 0;//次接驳盒通道3电压电流界限设置成功标志
        public static int flagA4 = 0;//次接驳盒通道4电压电流界限设置成功标志
        public static int flagA5 = 0;//次接驳盒通道5电压电流界限设置成功标志




        public static int flagOnHighPower = 0;//高压舱电源整体打开标志
        public static int flagOffHighPower = 0;//高压舱电源整体关机标志
        public static int flagOnHighB1 = 0;//高压舱后端第一路开机成功标志
        public static int flagOffHighB1 = 0;//高压舱后端第一路关机成功标志
        public static int flagOnHighB2 = 0;//高压舱后端第2路开机成功标志
        public static int flagOffHighB2 = 0;//高压舱后端第2路关机成功标志





        public static int flagATemp = 0;//A舱温度上下限指令返回标志


       // public static int flagB1 = 0;//B舱通道1电压电流界限设置成功标志

        //public static int flagB2 = 0;//B舱通道2电压电流界限设置成功标志

       // public static int flagBTemp = 0;//B舱温度上下限指令返回标志

        public static int flagInterval = 0;//次接驳盒电压电流状态信息采集时间间隔改变

        //新增溶解氧指令标志-2018-01-30 
        public static int flagDOMeasure = 0;//溶解氧单次测量以及多次测量指令的返回标志
        public static int flagDOTime = 0;//溶解氧校时指令成功的返回标志
        public static int flagDOInterval = 0;//溶解氧设置时间间隔指令成功的返回标志
        public static int flagDOErase = 0;//溶解氧芯片擦除指令成功的返回标志
        //新增主次接驳盒芯片擦除指令
        public static int flagAErase = 0;//主接驳盒擦除指令成功标记
        public static int flagBErase = 0;//次接驳盒擦除指令成功标记

        private Dictionary<string, string> myFaultDic;//读入故障码使用的字典

        private static UInt32 numa, numb, num = 0;//定义变量存储A舱、B舱以及总的接收数据包个数 

        public static UInt32 numCommand = 0;//定义总的指令发送的个数



        /*********根据具体实际情况，增加的额外私有变量***************/

        Main f;

        private static int intFrequency;//溶解氧平滑频率，要设置成静态变量

        public static int flag = 0; //溶解氧存储buffer标识位

        private static int[] buffer = new int[4];//溶解氧频率buffer



       

        private string showFaultTime = null;//首页显示故障时间



        private _2DrawClass drawExp1;//画采集值图1实例
        private _2DrawClass drawExp2;//画采集值图2实例
        private _2DrawClass drawExp3;//画采集值图3实例
        private _2DrawClass drawExp4;//画采集值图4实例
        private _2DrawClass drawExp5;//画采集值图5实例

        private _2DrawClass drawExp6;//画电参数图1实例
        private _2DrawClass drawExp7;//画电参数图2实例
        private _2DrawClass drawExp8;//画电参数图3实例
        private _2DrawClass drawExp9;//画电参数图4实例
        private _2DrawClass drawExp10;//画电参数图5实例

        


        


        /*********根据具体实际情况，额外增加的委托以及回调函数********/
        private delegate void delShowCanConnect(int i);
        private delShowCanConnect showCanConnectcallback;
        /// <summary>
        /// 1.与下位机连接标识显示状态的回调函数，回调函数中不牵扯变量关系
        /// </summary>
        /// <param name="i"></param>1,3分别为次接驳盒，主接驳盒的连接状态
        private void ShowCanConnectMethod(int i)//
        {
            //if (i == 1)
            //{
            //    f.canBConnect.Text = "连接";
            //    f.canBConnect.ForeColor = Color.Green;

            //}
            //else if (i == 2)
            //{
            //    f.canBConnect.Text = "断开";
            //    f.canBConnect.ForeColor = Color.Red;
            //    LogConnect.WriteLogFile("断开！");

            //   // f.serverConnet.Text = "断开";//与下位机的连接断开后，与数据库服务器连接断开
            //  //  f.serverConnet.ForeColor = Color.Red;

            //}
            switch(i)
            {
                case 1:
                    f.canBConnect.Text = "连接";
                    f.canBConnect.ForeColor = Color.Green;
                    break;
                case 2:
                    f.canBConnect.Text = "断开";
                    f.canBConnect.ForeColor = Color.Red;
                    
                    //同时将次接驳盒断开作为短信发送给指定手机号
                    SendMessageClass expB = new SendMessageClass();
                    string urlB = expB.GetPostUrl("15265210541","通信异常报警-次接驳盒断开");
                    string s1B = expB.PostSmsInfo(urlB);
                    string s2B = expB.GetResult(s1B);
                    LogConnect.WriteLogFile("次接驳盒断开！"+"短信发送情况："+s2B);

                    break;
                case 3://主接驳盒连接
                    f.canAConnect.Text = "连接";
                    f.canAConnect.ForeColor = Color.Green;
                    break;
                case 4:
                    f.canAConnect.Text = "断开";
                    f.canAConnect.ForeColor = Color.Red;
                   

                    SendMessageClass expA = new SendMessageClass();
                    string urlA = expA.GetPostUrl("15265210541","通信异常报警-次接驳盒断开");
                    string s1A = expA.PostSmsInfo(urlA);
                    string s2A = expA.GetResult(s1A);
                    LogConnect.WriteLogFile("主接驳盒断开！"+"短信发送情况："+s2A);

                    break;

            }
            
        }

        private delegate void delShowChOnOff(int i);
        private delShowChOnOff showChOnOffcallback;
        /// <summary>
        /// 2.显示各个通道开关的回调函数
        /// </summary>
        /// <param name="i"></param>
        private void ShowChOnOffMethod(int i)
        {
            switch (i)
            {
                case 1:
                    //f.ACh1Close.Enabled = false;
                    //f.ACh1Open.Enabled = true;
                    //f.txtACh1Status.Text = "关闭";
                    //f.txtACh1Status.ForeColor = Color.White;
                    //f.txtACh1Status.BackColor = Color.Red;
                    break;
                case 2:
                    //f.ACh2Close.Enabled = false;
                    //f.ACh2Open.Enabled = true;
                    //f.txtACh2Status.Text = "关闭";
                    //f.txtACh2Status.BackColor = Color.Red;
                    //f.txtACh2Status.ForeColor = Color.White;
                    break;
                case 3:
                    f.Ch1Close.Enabled = false;
                    f.Ch1Open.Enabled = true;
                    f.txtBCh1Status.Text = "关闭";
                    f.txtBCh1Status.BackColor = Color.Red;
                    f.txtBCh1Status.ForeColor = Color.White;
                    break;
                case 4:
                    f.Ch2Close.Enabled = false;
                    f.Ch2Open.Enabled = true;
                    f.txtBCh2Status.Text = "关闭";
                    f.txtBCh2Status.BackColor = Color.Red;
                    f.txtBCh2Status.ForeColor = Color.White;
                    break;
                case 5:
                    //f.chFiveClose.Enabled = false;
                    //f.chFiveOpen.Enabled = true;
                    //f.sensorFiveStatus.Text = "关闭";
                   // f.sensorFiveStatus.BackColor = Color.Red;
                  //  f.sensorFiveStatus.ForeColor = Color.White;
                    break;

            }
        }

        

        

        //2017-10-24接驳盒项目修改委托
        private delegate void delShowCabinFaultData(string name, string data, DateTime time, int i);
        private delShowCabinFaultData showCabinFaultDatacallback;

        /// <summary>
        /// 5.定义首页实时显示A、B两个舱的故障
        /// </summary>
        /// <param name="name"></param>
        /// <param name="data"></param>
        /// <param name="time"></param>
        /// <param name="i"></param>
        private void ShowCabinFaultDataMethod(string name,string data,DateTime time,int i)
        {
            switch (i)
            {
                    /*A舱故障值表格更新*/
                //case 1://A舱通道1电压问题更新

                    
                //    f.dataGridView1.Rows[0].Cells["故障名称"].Value = name;
                //    f.dataGridView1.Rows[0].Cells["报警数据"].Value = data;
                //    f.dataGridView1.Rows[0].Cells["采集时间"].Value = time.ToString("yyyy-MM-dd HH:mm:ss");//dataGridView行从0开始
                //    break;
                //case 2://A舱通道1电流问题更新

                //    f.dataGridView1.Rows[1].Cells["故障名称"].Value = name;
                //    f.dataGridView1.Rows[1].Cells["报警数据"].Value = data;
                //    f.dataGridView1.Rows[1].Cells["采集时间"].Value = time.ToString("yyyy-MM-dd HH:mm:ss");//dataGridView行从0开始
                //    break;
                //case 3://A舱通道2电压问题更新
                //    f.dataGridView1.Rows[2].Cells["故障名称"].Value = name;
                //    f.dataGridView1.Rows[2].Cells["报警数据"].Value = data;
                //    f.dataGridView1.Rows[2].Cells["采集时间"].Value = time.ToString("yyyy-MM-dd HH:mm:ss");//dataGridView行从0开始                   
                //    break;
                //case 4://A舱通道2电流问题更新
                //    f.dataGridView1.Rows[3].Cells["故障名称"].Value = name;
                //    f.dataGridView1.Rows[3].Cells["报警数据"].Value = data;
                //    f.dataGridView1.Rows[3].Cells["采集时间"].Value = time.ToString("yyyy-MM-dd HH:mm:ss");//dataGridView行从0开始                  
                //    break;
                //case 5://A舱温度故障更新
                //    f.dataGridView1.Rows[4].Cells["故障名称"].Value = name;
                //    f.dataGridView1.Rows[4].Cells["报警数据"].Value = data;
                //    f.dataGridView1.Rows[4].Cells["采集时间"].Value = time.ToString("yyyy-MM-dd HH:mm:ss");//dataGridView行从0开始                  
                //    break;

                    /*******************************B舱故障值表格更新***********************************/
                case 1://通道1电压问题显示
                    f.dataGridView2.Rows[7].Cells["故障名称"].Value = name;
                    f.dataGridView2.Rows[7].Cells["报警数据"].Value = data;
                    f.dataGridView2.Rows[7].Cells["故障时间"].Value = time.ToString("yyyy-MM-dd HH:mm:ss");

                    break;
                case 2://通道1电流问题显示
                    f.dataGridView2.Rows[8].Cells["故障名称"].Value = name;
                    f.dataGridView2.Rows[8].Cells["报警数据"].Value = data;
                    f.dataGridView2.Rows[8].Cells["故障时间"].Value = time.ToString("yyyy-MM-dd HH:mm:ss");

                    break;
                case 3://通道2电压问题显示
                    f.dataGridView2.Rows[9].Cells["故障名称"].Value = name;
                    f.dataGridView2.Rows[9].Cells["报警数据"].Value = data;
                    f.dataGridView2.Rows[9].Cells["故障时间"].Value = time.ToString("yyyy-MM-dd HH:mm:ss");

                    break;
                case 4://通道2电流问题显示
                    f.dataGridView2.Rows[10].Cells["故障名称"].Value = name;
                    f.dataGridView2.Rows[10].Cells["报警数据"].Value = data;
                    f.dataGridView2.Rows[10].Cells["故障时间"].Value = time.ToString("yyyy-MM-dd HH:mm:ss");
                    break;

                case 5://通道3电压问题显示
                    f.dataGridView2.Rows[11].Cells["故障名称"].Value = name;
                    f.dataGridView2.Rows[11].Cells["报警数据"].Value = data;
                    f.dataGridView2.Rows[11].Cells["故障时间"].Value = time.ToString("yyyy-MM-dd HH:mm:ss");

                    break;
                case 6://通道3电流问题显示
                    f.dataGridView2.Rows[12].Cells["故障名称"].Value = name;
                    f.dataGridView2.Rows[12].Cells["报警数据"].Value = data;
                    f.dataGridView2.Rows[12].Cells["故障时间"].Value = time.ToString("yyyy-MM-dd HH:mm:ss");
                    break;


                case 7://通道4电压问题显示
                    f.dataGridView2.Rows[13].Cells["故障名称"].Value = name;
                    f.dataGridView2.Rows[13].Cells["报警数据"].Value = data;
                    f.dataGridView2.Rows[13].Cells["故障时间"].Value = time.ToString("yyyy-MM-dd HH:mm:ss");

                    break;
                case 8://通道4电流问题显示
                    f.dataGridView2.Rows[14].Cells["故障名称"].Value = name;
                    f.dataGridView2.Rows[14].Cells["报警数据"].Value = data;
                    f.dataGridView2.Rows[14].Cells["故障时间"].Value = time.ToString("yyyy-MM-dd HH:mm:ss");
                    break;



                case 9://通道4电压问题显示
                    f.dataGridView2.Rows[15].Cells["故障名称"].Value = name;
                    f.dataGridView2.Rows[15].Cells["报警数据"].Value = data;
                    f.dataGridView2.Rows[15].Cells["故障时间"].Value = time.ToString("yyyy-MM-dd HH:mm:ss");

                    break;
                case 10://通道4电流问题显示
                    f.dataGridView2.Rows[16].Cells["故障名称"].Value = name;
                    f.dataGridView2.Rows[16].Cells["报警数据"].Value = data;
                    f.dataGridView2.Rows[16].Cells["故障时间"].Value = time.ToString("yyyy-MM-dd HH:mm:ss");
                    break;



                case 11://温度报警显示
                    f.dataGridView2.Rows[17].Cells["故障名称"].Value = name;
                    f.dataGridView2.Rows[17].Cells["报警数据"].Value = data;
                    f.dataGridView2.Rows[17].Cells["故障时间"].Value = time.ToString("yyyy-MM-dd HH:mm:ss");

                    break;




                case 12://首页故障时间显示
                    f.canErrortime.Text = Convert.ToDateTime(showFaultTime).ToString();//显示故障出现的时间
                    break;
            }

        }
        /******************2017-09-20接驳盒增加委托回调用于跨线程显示************************/
        private delegate void delShowJunctionStatus(int i, string strCh1Vol, string strCh2Vol, string strCh3Vol, string strCh4Vol, string strCh5Vol, string strCh1Cur, string strCh2Cur, string strCh3Cur, string strCh4Cur, string strCh5Cur, string Temp, string strCollectDate, string strPower1, string strPower2, string strPower3, string strPower4, string strPower5);
        private delShowJunctionStatus showJunctionStatuscallback;
        /// <summary>
        /// 1.舱内状态信息的回调函数（包含通道电压、电流、舱内温度以及采集时间信息）
        /// </summary>
        /// <param name="i"></param>
        /// <param name="strCh1Vol"></param>
        /// <param name="strCh2Vol"></param>
        /// <param name="strCh1Cur"></param>
        /// <param name="strCh2Cur"></param>
        /// <param name="Temp"></param>
        /// <param name="strCollectDate"></param>
        /// <param name="strPower1"></param>
        /// <param name="strPower2"></param>
        private void ShowJunctionStatusMethod(int i, string strCh1Vol, string strCh2Vol, string strCh3Vol, string strCh4Vol, string strCh5Vol, string strCh1Cur, string strCh2Cur, string strCh3Cur, string strCh4Cur, string strCh5Cur, string Temp, string strCollectDate, string strPower1, string strPower2, string strPower3, string strPower4, string strPower5)
        {
            switch(i)
            {
                case 1:
                    //对A舱的字体进行显示设置
                    FontClass fontType = new FontClass();
                    //f.txtACh1Vol.Font = fontType.fontLed;
                    //f.txtACh1Cur.Font = fontType.fontLed;
                    //f.txtACh1Power.Font = fontType.fontLed;
                    //f.txtACh1Time.Font = fontType.fontLed;
                    //f.txtACh2Vol.Font = fontType.fontLed;
                    //f.txtACh2Cur.Font = fontType.fontLed;
                    //f.txtACh2Power.Font = fontType.fontLed;
                    //f.txtACh1Time.Font = fontType.fontLed;
                    //f.txtACh2Time.Font = fontType.fontLed;
                    //f.txtATemp.Font = fontType.fontLed;
                    //f.txtAHumity.Font = fontType.fontLed;
                    //对A舱字体进行显示

                    //f.txtACh1Vol.Text = strCh1Vol;
                    //f.txtACh1Cur.Text = strCh1Cur;
                    //f.txtACh1Time.Text = strCollectDate;
                    //f.txtATemp.Text = Temp;
                  

                    //f.txtACh2Vol.Text = strCh2Vol;
                    //f.txtACh2Cur.Text = strCh2Cur;
                    //f.txtACh2Time.Text = strCollectDate;
                    //f.txtACh1Power.Text = strPower1;
                    //f.txtACh2Power.Text = strPower2;

                  //  f.txtAHumity.Text = strHum;
                    break;
                case 2:
                    //对B舱字体进行显示
                    FontClass fontType2 = new FontClass();

                    //通道1字体设置
                    f.txtCh1Vol.Font = fontType2.fontLed;
                    f.txtCh1Cur.Font = fontType2.fontLed;
                    f.txtCh1Power.Font = fontType2.fontLed;
                    f.txtCh1Time.Font = fontType2.fontLed;
                    f.txtBTemp.Font = fontType2.fontLed;

                    //通道2字体设置
                    f.txtCh2Vol.Font = fontType2.fontLed;
                    f.txtCh2Cur.Font = fontType2.fontLed;
                    f.txtCh2Power.Font = fontType2.fontLed;
                    f.txtCh2Time.Font = fontType2.fontLed;

                    //通道3字体设置
                    f.txtCh3Vol.Font = fontType2.fontLed;
                    f.txtCh3Cur.Font = fontType2.fontLed;
                    f.txtCh3Power.Font = fontType2.fontLed;
                    f.txtCh3Time.Font = fontType2.fontLed;

                    //通道4字体设置
                    f.txtCh4Vol.Font = fontType2.fontLed;
                    f.txtCh4Cur.Font = fontType2.fontLed;
                    f.txtCh4Power.Font = fontType2.fontLed;
                    f.txtCh4Time.Font = fontType2.fontLed;

                    //通道5字体设置
                    f.txtCh5Vol.Font = fontType2.fontLed;
                    f.txtCh5Cur.Font = fontType2.fontLed;
                    f.txtCh5Power.Font = fontType2.fontLed;
                    f.txtCh5Time.Font = fontType2.fontLed;

                   // f.txtBHumity.Font = fontType2.fontLed;
                    //对B舱字体进行显示


                    //通道1相应信息显示
                    f.txtCh1Vol.Text = strCh1Vol;
                    f.txtCh1Cur.Text = strCh1Cur;
                    f.txtCh1Time.Text = strCollectDate;
                    f.txtCh1Power.Text = strPower1;
                    f.txtBTemp.Text = Temp;
                  
                    //通道2相应信息显示
                    f.txtCh2Vol.Text = strCh2Vol;
                    f.txtCh2Cur.Text = strCh2Cur;
                    f.txtCh2Time.Text = strCollectDate;                  
                    f.txtCh2Power.Text = strPower2;

                    //通道3相应信息显示
                    f.txtCh3Vol.Text = strCh3Vol;
                    f.txtCh3Cur.Text = strCh3Cur;
                    f.txtCh3Time.Text = strCollectDate;
                    f.txtCh3Power.Text = strPower3;


                    //通道4相应信息显示
                    f.txtCh4Vol.Text = strCh4Vol;
                    f.txtCh4Cur.Text = strCh4Cur;
                    f.txtCh4Time.Text = strCollectDate;
                    f.txtCh4Power.Text = strPower4;


                    //通道5相应信息显示
                    f.txtCh5Vol.Text = strCh5Vol;
                    f.txtCh5Cur.Text = strCh5Cur;
                    f.txtCh5Time.Text = strCollectDate;
                    f.txtCh5Power.Text = strPower5;

                   // f.txtBHumity.Text = strHum;

                    break;
                
            }
        }

        private delegate void delShowJunctionCh(int i);
        private delShowJunctionCh showJunctionChcallback;
        /// <summary>
        /// 2.下位机主动发回舱内通道关闭信息的回调函数
        /// </summary>
        /// <param name="i"></param>
        private void ShowJunctionChMethod(int i)
        {
            switch (i)
            {
                case 1://A舱通道1关闭状态更新
                    f.Ch1Close.Enabled = false;
                    f.Ch1Open.Enabled = true;
                    f.txtBCh1Status.Text = "关闭";
                    f.txtBCh1Status.BackColor = Color.Red;
                    f.txtBCh1Status.ForeColor = Color.White;
                    break;
                case 2://A舱通道2关闭状态更新
                    f.Ch2Close.Enabled = false;
                    f.Ch2Open.Enabled = true;
                    f.txtBCh2Status.Text = "关闭";
                    f.txtBCh2Status.BackColor = Color.Red;
                    f.txtBCh2Status.ForeColor = Color.White;
                    break;
                case 3://B舱通道1关闭状态更新
                    f.Ch3Close.Enabled = false;
                    f.Ch3Open.Enabled = true;
                    f.txtBCh3Status.Text = "关闭";
                    f.txtBCh3Status.BackColor = Color.Red;
                    f.txtBCh3Status.ForeColor = Color.White;
                    break;
                case 4://B舱通道2关闭状态更新
                    f.Ch4Close.Enabled = false;
                    f.Ch4Open.Enabled = true;
                    f.txtBCh4Status.Text = "关闭";
                    f.txtBCh4Status.BackColor = Color.Red;
                    f.txtBCh4Status.ForeColor = Color.White;
                    break;

                case 5:
                    f.Ch5Close.Enabled = false;
                    f.Ch5Open.Enabled = true;
                    f.txtBCh5Status.Text = "关闭";
                    f.txtBCh5Status.BackColor = Color.Red;
                    f.txtBCh5Status.ForeColor = Color.White;
                    break;
            }
        }

        //显示A舱以及B舱接收数据个数的总数，以及发送的总的指令个数统计
        private delegate void delShowCabinNum();
        private delShowCabinNum showCabinNumcallback;

        private void ShowCabinNumMethod()
        {
            //f.txtACabinNum.Text = numa.ToString();//A舱接收数据个数显示
            //f.txtBCabinNum.Text = numb.ToString();//B舱接收数据个数显示
            f.txtTotalNum.Text = num.ToString();//总的接收数据个数显示
            f.txtCommandNum.Text = numCommand.ToString();//总的指令包发送个数
        }


        //显示A舱以及B舱通道1，2接收到故障信号显示
        private delegate void delShowErrorSignal(int i);
        private delShowErrorSignal showErrorSignalcallback;
        /// <summary>
        /// 显示异常
        /// </summary>
        private void ShowErrorSignalMethod(int i)
        {
            switch(i)
            {
                case 1:
                    f.txtBCh1Logo.Text = "异常";
                    f.txtBCh1Logo.BackColor = Color.Red;
                    f.txtBCh1Logo.ForeColor = Color.White;
                    break;
                case 2:
                    f.txtBCh2Logo.Text = "异常";
                    f.txtBCh2Logo.BackColor = Color.Red;
                    f.txtBCh2Logo.ForeColor = Color.White;
                    break;
                case 3:
                    f.txtBCh3Logo.Text = "异常";
                    f.txtBCh3Logo.BackColor = Color.Red;
                    f.txtBCh3Logo.ForeColor = Color.White;
                    break;
                case 4:
                    f.txtBCh4Logo.Text = "异常";
                    f.txtBCh4Logo.BackColor = Color.Red;
                    f.txtBCh4Logo.ForeColor = Color.White;
                    break;
                case 5:
                    f.txtBCh5Logo.Text = "异常";
                    f.txtBCh5Logo.BackColor = Color.Red;
                    f.txtBCh5Logo.ForeColor = Color.White;
                    break;
            }
        }

        /*********************2018-01-29新增加的传感器信息页传感器信息显示的委托回调函数**********************/
        private delegate void delShowSensorMessage(int i,string data,DateTime time);
        private delShowSensorMessage showSensorMessagecallback;
        /// <summary>
        /// 在传感器信息页上显示各个传感器的采集值以及采集时间 
        /// </summary>
        /// <param name="i"></param>
        /// <param name="data"></param>
        /// <param name="time"></param>
        private void showSensorMessageMethod(int i,string data,DateTime time)
        {
            switch(i)
            {
                case 1:
                    f.txtDOValue.Text = data;
                    f.txtDODate.Text = time.ToString("yyyy-MM-dd HH:mm:ss");
                    break;
                case 2:
                    f.txtADLValue.Text = data;
                    f.txtADLDate.Text = time.ToString("yyyy-MM-dd HH:mm:ss");
                    break;
                case 3:
                    f.txtCTDValue.Text = data;
                    f.txtCTDDate.Text = time.ToString("yyyy-MM-dd HH:mm:ss");
                    break;
                case 4:
                    f.txtM_Chl.Text = data;
                    f.txtMultiDate.Text = time.ToString("yyyy-MM-dd HH:mm:ss");
                    break;

            }
        }

        /********************2020年7月7日13:30:48新增界面百度地图图标闪烁委托回调************************/
        //private delegate void delShowBaidu(string a, string b);
        //private delShowBaidu showBaiducallback;

        ///// <summary>
        ///// 按照上传上来的经纬度信息，将经纬度信息定位点显示在百度地图对应位置
        ///// </summary>
        ///// <param name="a"></param>经度信息
        ///// <param name="b"></param>纬度信息
        //private void showBaiduMethod(string a,string b)
        //{
        //    try 
        //    {
        //        f.webGPS.Document.InvokeScript("clear");
        //        f.webGPS.Document.InvokeScript("setLocation", new object[] { a, b });//在对应位置显示坐标
        //        f.txtLongitude.Text = a;
        //        f.txtLatitude.Text = b;

        //    }
        //    catch(Exception exp)
        //    {
        //        MessageBox.Show("在百度地图上进行图标显示异常！"+exp.Message);
        //    }
        //}







        /****************2017.09.26增加的接驳盒画图实例及锁*****************/
        private _2DrawClass drawExpACh1;
        private _2DrawClass drawExpACh2;
        private _2DrawClass drawExpATemp;

        private _2DrawClass drawExpBCh1;
        private _2DrawClass drawExpBCh2;
        private _2DrawClass drawExpBTemp;

        private object lockACh1 = new object();

        //private object lockHCh = new object();//
        private object lockATemp = new object();

        private object lockBCh1 = new object();
        private object lockBCh2 = new object();
        private object lockBTemp = new object();

        //2018-01-30为画传感器曲线新增的锁
        private object lockDO = new object();
        private object lockYLS = new object();
        private object lockZD = new object();
        private object lockCDOM = new object();

        private _4DrawSensor drawExpDO;
        private _4DrawSensor drawExpYLS;
        private _4DrawSensor drawExpZD;
        private _4DrawSensor drawExpCDOM;

        /***********类_3ReceieveMsgClass类中主要的成员变量***********/
        public Socket tcpClient;

        public string nodeIP;//设置存储远程连接过来的客户端的IP地址


        public int port;//临时加,//后面委托回调显示连接情况的时候远程连接的端口号，显示实时变化

        public int listenPort;//监听端口，用于具体区分连接
        //private NetworkStream networkStream;
        /// <summary>
        /// 类_3ReceiveMsgClass的构造函数
        /// </summary>
        /// <param name="tcpClient1"></param>
        /// <param name="br1"></param>
        /// <param name="bw1"></param>
        /// <param name="networkStream1"></param>
        /// <param name="frm"></param>
        public _3ReceieveMsgClass(Socket tcpClient1, Main frm, int tempPort, Dictionary<string, string> dic)
        {
            tcpClient = tcpClient1;

            string[] IPArray = tcpClient1.RemoteEndPoint.ToString().Split(':');

            nodeIP = IPArray[0];//远程客户端的IP地址


            port = Convert.ToInt32(IPArray[1]);

            listenPort = tempPort;

            f = frm;


            //string nodeIP = tcpClient1.



            showCanConnectcallback = new delShowCanConnect(ShowCanConnectMethod);//几个需要跨线程访问控件的委托回调初始化
            showChOnOffcallback = new delShowChOnOff(ShowChOnOffMethod);            
            showCabinFaultDatacallback = new delShowCabinFaultData(ShowCabinFaultDataMethod);
            showSensorMessagecallback = new delShowSensorMessage(showSensorMessageMethod);
            //showBaiducallback = new delShowBaidu(showBaiduMethod);

            drawExp1 = frm.drawExp;
            drawExp2 = frm.drawExp;
            drawExp3 = frm.drawExp;
            drawExp4 = frm.drawExp;
            drawExp5 = frm.drawExp;


            drawExp6 = frm.drawExp;
            drawExp7 = frm.drawExp;
            drawExp8 = frm.drawExp;
            drawExp9 = frm.drawExp;
            drawExp10 = frm.drawExp;


            /*********接驳盒项目新增*************/
            //myFaultDic = SetFaultKeyValue();//将故障码与对应的故障类型读入数据库
            myFaultDic = dic;
            showJunctionStatuscallback = new delShowJunctionStatus(ShowJunctionStatusMethod);
            showJunctionChcallback = new delShowJunctionCh(ShowJunctionChMethod);

            drawExpACh1 = frm.drawExp;
            drawExpACh2 = frm.drawExp;
            drawExpATemp = frm.drawExp;

            drawExpBCh1 = frm.drawExp;
            drawExpBCh2 = frm.drawExp;
            drawExpBTemp = frm.drawExp;

            drawExpDO = frm.drawSensorExp;
            drawExpYLS = frm.drawSensorExp;
            drawExpZD = frm.drawSensorExp;
            drawExpCDOM = frm.drawSensorExp;


            showCabinNumcallback = new delShowCabinNum(ShowCabinNumMethod);
            showErrorSignalcallback = new delShowErrorSignal(ShowErrorSignalMethod);
        }


        public void ReceiveMessage()
        {

            bool keepalive = true;//该标志是个局部变量，一个连接的断开不会影响这个连接的标志

            if (nodeIP == _1MySerClass.BJunctionIP && listenPort == _1MySerClass.BPort)
            {
                f.Invoke(showCanConnectcallback, 1);//次接驳盒连接标识显示为连接
            }
            else if(nodeIP == _1MySerClass3.AJunctionIP && listenPort == _1MySerClass3.APort)
            {
                f.Invoke(showCanConnectcallback,3);//主接驳盒连接标志显示
            }
            

            try
            {

                while (keepalive)
                {

                    if (tcpClient == null || !tcpClient.Connected)//判断连接是否还存在
                    {
                        keepalive = false;

                        if (nodeIP == _1MySerClass.BJunctionIP && listenPort == _1MySerClass.BPort)
                        {
                            f.Invoke(showCanConnectcallback, 2);//连接标识显示为断开
                        }
                        else if (nodeIP == _1MySerClass3.AJunctionIP && listenPort == _1MySerClass3.APort)
                        {
                            f.Invoke(showCanConnectcallback, 4);//主接驳盒显示断开
                        }
                        
                        CloseSocket();

                        Main.ClearMemory();

                        Thread.CurrentThread.Abort();
                        GC.Collect();

                        break;//跳出循环
                    }

                    else
                    {

                        byte[] bytes = new byte[8192];
                        int readBytes = 0;

                        tcpClient.ReceiveTimeout = 60000;//将等待时间设置成1min，1min之后没有收到数据就认为连接断开，对非法关机的有效处理

                        readBytes = tcpClient.Receive(bytes, 0, 8192, SocketFlags.None);

                        //只要执行导致该步骤，就说明有接收到数据，连接标志显示为连接
                        if (nodeIP == _1MySerClass.BJunctionIP && listenPort == _1MySerClass.BPort)
                        {
                            f.Invoke(showCanConnectcallback, 1);//连接标识显示为连接
                        }
                        else if (nodeIP == _1MySerClass3.AJunctionIP && listenPort == _1MySerClass3.APort)
                        {
                            f.Invoke(showCanConnectcallback, 3);//连接标识显示为连接
                        }
                        

                        string content = null;

                        if (readBytes > 0)
                        {                          
                            content = Encoding.ASCII.GetString(bytes, 0, readBytes).Trim();//将接受到的字符串信息进行处理（接收到的下位机信息除了指令的返回信息外，主动发来的信息全部以$开头，以#结束）

                            if (content.StartsWith("$") && content.EndsWith("#")) //接收上来的数据无论是主动发送上来的状态数据、故障数据以及、指令执行反馈全部以$开头，以#结束
                            {
                                //对正常接收到的信息进行处理,防止沾包处理
                                string[] sArray = content.Split('#'); //将字符串按照结束符“&”进行分割，每一项分割完成后添加&


                                for (int i = 0; i <= sArray.Length - 2; i++)
                                {

                                    content =( sArray[i] + "#").Trim();//放到后面线程中进行修改

                                    ThreadPool.QueueUserWorkItem(new WaitCallback(DealNewMessage), content);//将经过粘包处理之后的信息放入线程池中进行解析

                                    DateTime dt0 = DateTime.Now;
                                    string sql3 = "insert into seafloor_allData (saveDate,collectRawInfo) values('" + dt0 + "','" + content + "')";//alldata为数据库数据表格用来存储所有接驳盒STM32上传上来的所有原始数据包，不做任何处理，备份
                                    SqlHelper.ExecuteNonQuery(sql3); 

                                }

                            }

                           
                            //将串口误发送上来的3F信号屏蔽掉
                            else if(bytes[0] == 0x3F)
                            {
                                //忽略啥也不做
                            }

                                
                             //以下所有的处理都不是来自接驳盒控制舱STM32串口1或者串口2的数据，而是直接来自接驳盒本身


                                //2020年7月6日15:57:42添加接驳盒上加的GPS位置信息的处理，test用
                            //else if (content.Trim().Substring(0, 3) == "LON")//接收到的均是字符串信息，将字符串信息进行处理
                            //{
                            //    dealGPS(content);
                            //}

                            else if(content.StartsWith("$") && content.EndsWith("@"))//发送的校时时间
                            {
                                flagTime = 1;
                            }
                            else if (content.Trim() == "$OPEN%")
                            {
                                flagOpen = 1;//摄像头打开标志位
                            }
                            else if (content.Trim() == "$CLOSE%")
                            {
                                flagClose = 1;//关闭摄像头标志位
                            }
                            //else if(content.Trim() == "$intervalok%")
                            //{
                            //    flagInterval = 1;
                            //}

                            else if (bytes[0] == 0x04 && bytes[1] == 0x03 && bytes[2] == 0x12)//通过485转网口串口服务器读到的鑫宇航电源的信息
                            {
                                num++;//收到高压舱数据，接收数据包个数加1
                                f.Invoke(showCabinNumcallback, null);

                                ThreadProcessHighPower tt = new ThreadProcessHighPower(bytes, readBytes,f);
                                Thread thread = new Thread(new ThreadStart(tt.DealHighPowerMessage));//处理高压舱电源函数
                                thread.Start();
                            }

                            else if(bytes[0] ==0x04 && bytes[1] ==0x05 && bytes[2] ==0x00 && bytes[3]==0x00 && bytes[4]==0xFF && bytes[5] ==0x00 && bytes[6] == 0x8C && bytes[7] ==0x6F )
                            {
                                _3ReceieveMsgClass.flagOnHighPower = 1;//高压舱电源整体开机
                            }
                            else if (bytes[0] == 0x04 && bytes[1] == 0x05 && bytes[2] == 0x00 && bytes[3] == 0x00 && bytes[4] == 0x00 && bytes[5] == 0x00 && bytes[6] == 0xCD && bytes[7] == 0x9F)
                            {
                                _3ReceieveMsgClass.flagOffHighPower = 1;//高压舱电源整体关机
                            }
                            else if (bytes[0] == 0x04 && bytes[1] == 0x05 && bytes[2] == 0x00 && bytes[3] == 0x01 && bytes[4] == 0xFF && bytes[5] == 0x00 && bytes[6] == 0xDD && bytes[7] == 0xAF)
                            {
                                _3ReceieveMsgClass.flagOnHighB1 = 1;//高压舱后端第一路开机
                            }
                            else if (bytes[0] == 0x04 && bytes[1] == 0x05 && bytes[2] == 0x00 && bytes[3] == 0x01 && bytes[4] == 0x00 && bytes[5] == 0x00 && bytes[6] == 0x9C && bytes[7] == 0x5F)
                            {
                                _3ReceieveMsgClass.flagOffHighB1 = 1;//高压舱后端第一路关机
                            }
                            else if (bytes[0] == 0x04 && bytes[1] == 0x05 && bytes[2] == 0x00 && bytes[3] == 0x02 && bytes[4] == 0xFF && bytes[5] == 0x00 && bytes[6] == 0x2D && bytes[7] == 0xAF)
                            {
                                _3ReceieveMsgClass.flagOnHighB2 = 1;//高压舱后端第2路开机
                            }
                            else if (bytes[0] == 0x04 && bytes[1] == 0x05 && bytes[2] == 0x00 && bytes[3] == 0x02 && bytes[4] == 0x00 && bytes[5] == 0x00 && bytes[6] == 0x6C && bytes[7] == 0x5F)
                            {
                                _3ReceieveMsgClass.flagOffHighB2 = 1;//高压舱后端第2路关机
                            }

                            else if (content.Trim().Substring(0, 21) == "Time set successfully")
                            {
                                flagDOTime = 1;//溶解氧校时指令成功的标志
                            }
                            else if (content.Trim().Substring(0,30) == "Set time interval successfully")
                            {
                                flagDOInterval = 1;//溶解氧设置时间间隔指令成功的标志
                            }
                            else if (content.Trim().Substring(0,24) == "Erase flash successfully")
                            {
                                flagDOErase = 1;//溶解氧芯片擦除指令成功的标志
                            }
                            else if (content.Trim().Substring(0,26) == "A Erase flash successfully")
                            {
                                flagAErase = 1;
                            }
                            else if (content.Trim().Substring(0,26) == "B Erase flash successfully")
                            {
                                flagBErase = 1;
                            }

                            



                            else//如果上述协议都不是，则认为是收到的错误数据，放入错误数据库中
                            {
                                //DateTime dt = DateTime.Now;
                                //string sql = "insert into troubledata (savedate,collectrawinfo) values('" + dt + "','" + content + "')";//包编号存入数据库
                                //SqlHelper.ExecuteNonQuery(sql);

                                DateTime dt = DateTime.Now;
                                string sql = "insert into seafloor_jBErrorMesg (jBId,saveDate,errorProtocol) values('1','" + dt + "','" + content + "')";//通过接驳盒Id来判断错误的信息是主接驳盒高压舱的信息还是次接驳盒低压舱的信息
                                SqlHelper.ExecuteNonQuery(sql);
                            }

                        }
                        else
                        {
                            keepalive = false;
                            if (nodeIP == _1MySerClass.BJunctionIP && listenPort == _1MySerClass.BPort)
                            {
                                f.Invoke(showCanConnectcallback, 2);//连接标识显示为断开
                            }
                            else if (nodeIP == _1MySerClass3.AJunctionIP && listenPort == _1MySerClass3.APort)
                            {
                                f.Invoke(showCanConnectcallback, 4);//连接标识显示为断开
                            }
                            

                            CloseSocket();

                        }
                    }
                }

                CloseSocket();

                Main.ClearMemory();

                Thread.CurrentThread.Abort();
                GC.Collect();

            }

            catch(SocketException exp)
            {
                keepalive = false;
                if (nodeIP == _1MySerClass.BJunctionIP && listenPort == _1MySerClass.BPort)
                {
                    f.Invoke(showCanConnectcallback, 2);//连接标识显示为断开
                }
                else if (nodeIP == _1MySerClass3.AJunctionIP && listenPort == _1MySerClass3.APort)
                {
                    f.Invoke(showCanConnectcallback, 4);//连接标识显示为断开
                }
                


                CloseSocket();

                Main.ClearMemory();

                Thread.CurrentThread.Abort();
                GC.Collect();
                LogClass.WriteLogFile("接收信息出现异常！" + exp.Message);

            }

            catch (Exception e)
            {
                keepalive = false;

                if (nodeIP == _1MySerClass.BJunctionIP && listenPort == _1MySerClass.BPort)
                {
                    f.Invoke(showCanConnectcallback, 2);//连接标识显示为断开
                }
                else if (nodeIP == _1MySerClass3.AJunctionIP && listenPort == _1MySerClass3.APort)
                {
                    f.Invoke(showCanConnectcallback, 4);//连接标识显示为断开
                }

                CloseSocket();


                Main.ClearMemory();

                Thread.CurrentThread.Abort();
                GC.Collect();
                LogClass.WriteLogFile("接收信息出现异常！" + e.Message);
            }


        }
        /// <summary>
        /// 5.关闭连接
        /// </summary>
        public void CloseSocket()
        {          
     
            if (tcpClient != null)
            {
                tcpClient.Close();
            }

        }
        
       
        /// <summary>
        /// 使用同一个连接将指令或者反馈信息发送出去的函数
        /// </summary>
        public void SendMessage(string msg, int i)
        {
            try
            {
                if (i == 1)//将十六进制字符串转换成对应的字节数组发送出去
                {
                    tcpClient.Send(StrToHexByte(msg));


                }
                else//否则的话将原样的字符串发送出去
                {
                    tcpClient.Send(Encoding.ASCII.GetBytes(msg));
                    //tcpClient.ReceiveTimeout = 2000;
                    
                }

                numCommand++;
                //真正发送完成之后，将指令下发个数增加1
                f.Invoke(showCabinNumcallback,null);//发送个数增加之后，将发送数据包个数加1

            }
            catch(Exception exp)
            {
                LogClass.WriteLogFile("上位机给远程客户端发送信息异常！"+exp.Message);
            }
        }




        /*******************************额外用到的一些函数***************************/

        /// <summary>
        /// 自动获取本机IP地址，额外函数
        /// </summary>
        /// <returns></returns>
        private IPAddress getIP()
        {
            string AddressIP = string.Empty;
            try
            {
                foreach (IPAddress _IPAddress in Dns.GetHostEntry(Dns.GetHostName()).AddressList)
                {
                    if (_IPAddress.AddressFamily.ToString() == "InterNetwork")
                    {
                        AddressIP = _IPAddress.ToString();//"127.0.0.1";
                    }
                }
                return IPAddress.Parse(AddressIP);
            }
            catch (Exception e)
            {
                LogClass.WriteLogFile("自动获取本机IP地址异常！" + e.Message);
                return null;
            }

        }


        /// <summary>
        /// 将十六进制字符串转换成字节类型存储在数组中
        /// </summary>
        /// <param name="val"></param>
        /// <returns></returns>
        private byte[] StrToHexByte(string val)
        {
            byte[] bytes = new byte[val.Length / 2];

            for (int i = 0; i < bytes.Length; i++)
            {
                bytes[i] = Convert.ToByte(val.Substring(i * 2, 2), 16);
            }
            return bytes;
        }


        /// <summary>
        /// 判断给定的字符串是否符合特定的格式，即是否有乱码出现
        /// </summary>
        /// <param name="_express"></param>给定的正则表达式
        /// <param name="_value"></param>需要验证的字符串
        /// <returns></returns>
        private bool QuickValidate(string _express, string _value)
        {
            if (_value == null) return false;
            Regex myRegex = new Regex(_express);
            if (_value.Length == 0)
            {
                return false;
            }
            return myRegex.IsMatch(_value);
        }



        /// <summary>
        /// 相当于从数据库读到了协议编号与对应的协议含义的关系
        /// </summary>
        /// <returns></returns>
        public Dictionary<string, string> SetKeyValue()
        {
            Dictionary<string, string> dic = new Dictionary<string, string>();
            //从数据库中读到相应数据，然后将对应的Key以及value填充到字典中

            try
            {
                MySqlDataReader reader = SqlHelper.ExecuteReader("select * from protocolinfo");
                while (reader.Read())
                {
                    dic.Add(reader.GetString(2), reader.GetString(1));
                }
            }
            catch (Exception exp)
            {
                //MessageBox.Show("读入数据库时出现异常！"+exp.Message);
                LogClass.WriteLogFile("读入数据库时出现异常！" + exp.Message);
            }
            return dic;

        }


        /// <summary>
        /// 类型于查字典，由相应的协议编号（相当于键值）得到对应的协议名称（Value值）
        /// </summary>
        /// <param name="message"></param>
        /// <returns></returns>

        //private string GetKeyValue(string message)
        //{
        //    string value = null;
        //    if (mydic.TryGetValue(message, out value))
        //    {
        //        return value;
        //    }
        //    else
        //    {
        //        return null;
        //    }
        //}




        /// <summary>
        /// 将下位机发送过来的时间格式处理成上传数据库服务器需要的格式要求
        /// </summary>
        /// <returns></returns>
        private  string dealTime(string Time)
        {
            string dataTime = null;

            char[] separator = { ':' };

            string[] splitTime = new string[7];

            splitTime = Time.Split(separator);

            for (int i = 0; i < splitTime.Length - 1; i++)
            {
                dataTime += splitTime[i];
            }

            dataTime = dataTime + '0' + splitTime[6];

            return dataTime;
        }


        /// <summary>
        /// 将时间戳处理成上传故障服务器需要的格式23位BCD码形式
        /// </summary>
        /// <param name="Time"></param>
        /// <returns></returns>
        private string dealFaultTime(string Time)
        {
            string tempTime = Time.Substring(0, 14) + Time.Substring(15, 3);
            string result1 = null;
            string result = null;
            for (int i = 0; i < tempTime.Length; i++)
            {
                result1 += "0" + tempTime.Substring(i, 1);
            }
            result = result1.Substring(0, 8) + "3A" + result1.Substring(8, 4) + "3A" + result1.Substring(12, 4) + "3A" + result1.Substring(16, 4) + "3A" + result1.Substring(20, 4) + "3A" + result1.Substring(24, 4) + "3A" + result1.Substring(28, 6);
            return result;
        }


        /// <summary>
        /// 根据不同的故障信息获取相应的故障码编号
        /// </summary>
        /// <returns></returns>
        private string dealFaultCode(string message)
        {
            string strFaultCode = null;
            switch (message.Substring(6, 2))
            {
                case "11"://溶解氧停止工作
                    strFaultCode = "0003000810FF";
                    break;
                case "12"://欠流溶解氧工作异常
                    strFaultCode = "000300081100";
                    break;
                case "13"://溶解氧停止工作
                    strFaultCode = "0003000810FF";
                    break;
                case "14"://欠压溶解氧工作异常
                    strFaultCode = "000300081100";
                    break;
                case "21"://甲烷过流,停止工作
                    strFaultCode = "000300091131";
                    break;
                case "22"://甲烷欠流，工作异常
                    strFaultCode = "000300091132";
                    break;
                case "23"://甲烷过压,停止工作
                    strFaultCode = "000300091131";
                    break;
                case "24"://甲烷欠压，工作异常
                    strFaultCode = "000300091132";
                    break;
                case "31"://叶绿素过流，停止工作
                    strFaultCode = "0003000A1163";
                    break;
                case "32"://叶绿素欠流，工作异常
                    strFaultCode = "0003000A1164";
                    break;
                case "33"://叶绿素过压，停止工作
                    strFaultCode = "0003000A1163";
                    break;
                case "34"://叶绿素欠压，工作异常
                    strFaultCode = "0003000A1164";
                    break;
                case "41"://浊度过流，停止工作
                    strFaultCode = "0003000B1195";
                    break;
                case "42"://浊度欠流，工作异常
                    strFaultCode = "0003000B1196";
                    break;
                case "43"://浊度过压，停止工作
                    strFaultCode = "0003000B1195";
                    break;
                case "44"://浊度欠压，工作异常
                    strFaultCode = "0003000B1196";
                    break;

                case "51"://CDOM过流，停止工作
                    strFaultCode = "0003000C11C7";
                    break;
                case "52"://CDOM欠流，工作异常
                    strFaultCode = "0003000C11C8";
                    break;
                case "53"://CDOM过压，停止工作
                    strFaultCode = "0003000C11C7";
                    break;
                case "54"://CDOM欠压，工作异常
                    strFaultCode = "0003000C11C8";
                    break;
                case "61"://控制舱温度异常
                    strFaultCode = "0003000D11F9";
                    break;
                case "62"://控制舱温度异常
                    strFaultCode = "0003000D11F9";
                    break;
                case "71"://控制舱漏水异常
                    strFaultCode = "0003000D11FA";
                    break;
                case "72"://控制舱漏水异常
                    strFaultCode = "0003000D11FA";
                    break;
            }
            return strFaultCode;
        }

        /// <summary>
        /// 读取溶解氧公式配置，若读出来的值是1则选用公式1，分段公式，否则选用公式2
        /// </summary>
        /// <returns></returns>
        private int ReadDOFormula()
        {
            DataSet ds = new DataSet();
            ds.ReadXml(@".\Formula.xml");
            int number = Convert.ToInt32(ds.Tables[0].Rows[0]["number"].ToString());
            return number;
        }

        /// <summary>
        /// 放入线程池中处理的新的信息的内容
        /// </summary>
        /// <param name="tempMessage"></param>
        private void DealNewMessage(object tempMessage)
        {
            try
            {
                string message = tempMessage.ToString();//信息转换成string类型信息，没有次级接驳盒，目前接收到的只有一种
                 

                string mark1 = message.Substring(0,3);//状态信息第三位为A
                string mark2 = message.Substring(0,3);//故障信息第地位为A，个数的统计仅仅是统计的是发送上来的状态数据包以及故障数据包,不包括指令的反馈信息，指令的反馈信息体现在指令是否成功的结果上

                if (mark1 == "$Da" || mark2 == "$Er")
                {
                    numa++;
                }


                num = numa;

                f.Invoke(showCabinNumcallback,null);

                switch(message.Substring(0,3))
                {
                    case"$Da"://返回的舱内正常信息
                        DealStatusMessage(message);//返回舱内状态信息，调用函数处理舱内电压电流信息
                        break;
                    case "$Er"://返回的舱内故障信息(故障信息连包发送，需要处理成一条一条的)                       
                        DealFaultMessage(message);
                        //处理完成之后，并给PIC单片机发送收到故障的提示
                        //DealFaultFeedback("$OK#");
                        break;
                    case "$SI"://主动返回的是指令的一些反馈信息（此处返回的就是次级接驳盒通道开关的指令返回信息）
                        if (message.Trim() == "$SIIM1 Power Close!#")//通道1关闭
                        {
                            f.Invoke(showJunctionChcallback, 1);
                            flagOffA1 = 1;
                        }
                        else if (message.Trim() == "$SIIM2 Power Close!#")//通道2关闭
                        {
                            f.Invoke(showJunctionChcallback, 2);
                            flagOffA2 = 1;
                        }
                        else if (message.Trim() == "$SIIM3 Power Close!#")//通道3关闭
                        {
                            f.Invoke(showJunctionChcallback, 3);
                            flagOffA3 = 1;
                        }
                        else if (message.Trim() == "$SIIM4 Power Close!#")//通道4关闭
                        {
                            f.Invoke(showJunctionChcallback, 4);
                            flagOffA4 = 1;
                        }
                        else if (message.Trim() == "$SIIM5 Power Close!#")//通道5关闭
                        {
                            f.Invoke(showJunctionChcallback, 5);
                            flagOffA5 = 1;
                        }
                        else if (message.Trim() == "$SIIM1 Power 12V OK!#")//次接驳盒通道1打开
                        {
                            flagOnA1 = 1;//次接驳盒通道打开标志位
                        }
                        else if (message.Trim() == "$SIIM2 Power 12V OK!#")//次接驳盒通道2打开
                        {
                            flagOnA2 = 1;
                        }
                        else if (message.Trim() == "$SIIM3 Power 12V OK!#")//次接驳盒通道3打开
                        {
                            flagOnA3 = 1;
                        }
                        else if (message.Trim() == "$SIIM4 Power 12V OK!#")//次接驳盒通道4打开
                        {
                            flagOnA4 = 1;
                        }
                        else if (message.Trim() == "$SIIM5 Power 12V OK!#")//次接驳盒通道5打开
                        {
                            flagOnA5 = 1;
                        }
                        break;
                    case "$Se":
                        if (message.Trim() == "$Set SIIM1 Current and Voltage Alarm Data Interval OK!#")//次级接驳盒通道1电压电流上下限设置成功
                        {
                            flagA1 = 1;
                        }
                        else if (message.Trim() == "$Set SIIM2 Current and Voltage Alarm Data Interval OK!#")//次级接驳盒通道2电压电流上下限设置成功反馈
                        {
                            flagA2 = 1;
                        }
                        else if (message.Trim() == "$Set SIIM3 Current and Voltage Alarm Data Interval OK!#")//次级接驳盒通道3电压电流上下限设置成功反馈
                        {
                            flagA3 = 1;
                        }
                        else if (message.Trim() == "$Set SIIM4 Current and Voltage Alarm Data Interval OK!#")//次级接驳盒通道4电压电流上下限设置成功反馈
                        {
                            flagA4 = 1;
                        }
                        else if (message.Trim() == "$Set SIIM5 Current and Voltage Alarm Data Interval OK!#")//次级接驳盒通道5电压电流上下限设置成功反馈
                        {
                            flagA5 = 1;
                        }

                        else if (message.Trim() == "$Set Control Cabin Temperature Alarm Data Interval OK!#")//次级接驳盒温度上下限设置成功
                        {
                            flagATemp = 1;
                        }
                        else if (message.Trim() == "$Set Control Cabin sending data time interval OK!#")//次级接驳盒状态信息采样时间间隔设置指令的反馈信息
                        {
                            flagInterval = 1;
                        }
                        
                        break;
                    case "D20"://溶解氧传感器数据解析//之前方案，STM32溶解氧数据通过STM32串口接，后来使用数据采集器统一接
                       // DealSensorMessage(message);
                        break;
                    default:
                        //MessageBox.Show("格式乱码");
                        //添加格式乱码数据库

                        //DateTime dt = DateTime.Now;
                        //string sql = "insert into troubledata (savedate,collectrawinfo) values('"+dt+"','"+message+"')";//包编号存入数据库
                        //SqlHelper.ExecuteNonQuery(sql);

                        DateTime dt = DateTime.Now;
                        string sql = "insert into seafloor_jBErrorMesg (jBId,saveDate,errorProtocol) values('1','" + dt + "','" + message + "')";//通过接驳盒Id来判断错误的信息是主接驳盒高压舱的信息还是次接驳盒低压舱的信息
                        SqlHelper.ExecuteNonQuery(sql);


                        break;


                }

                Main.ClearMemory();

            }
            catch(Exception exp)
            {
                Main.ClearMemory();
                LogClass.WriteLogFile("处理信息异常！"+exp.Message);
            }
            

        }
        /// <summary>
        /// 用于给PIC单片机发送收到故障的反馈
        /// </summary>
        /// <param name="message"></param>
        private void DealFaultFeedback(string message)
        {
            try
            {
                if (f.canBConnect.Text == "连接")
                {
                    for (int i = _1MySerClass.userList.Count - 1; i >= 0; i--)
                    {
                        _3ReceieveMsgClass ct = _1MySerClass.userList[i];
                        if (!ct.tcpClient.Connected || ((ct.tcpClient.Poll(1000, SelectMode.SelectRead)) && (ct.tcpClient.Available == 0)))
                        {
                            _1MySerClass.userList.Remove(ct);
                            continue;
                        }
                        else if (ct.nodeIP == f.txtBIP.Text.Trim())
                        {
                            ct.SendMessage(message, 2);
                        }
                        else
                        {
                            MessageBox.Show("无有效连接！");
                        }
                    }
                }
                else
                {
                    MessageBox.Show("无可用连接！");
                }
            }
            catch(Exception exp)
            {
                MessageBox.Show("给PIC单片机发送故障收到反馈异常！"+exp.Message);
            }
 
        }



        /// <summary>
        /// 1.处理状态数据的函数（返回的是正常的电压以及电流数据）
        /// </summary>
        /// <param name="message"></param>
        private void DealStatusMessage(string message)
        {
            try
            {
                string strCabin = null;//所在舱的信息
                string strCh1Vol = null;//通道1电压值
                string strCh2Vol = null;//通道2电压值
                string strCh3Vol = null;//通道3电压值
                string strCh4Vol = null;//通道4电压值
                string strCh5Vol = null;//通道5电压值

                string strCh1Cur = null;//通道1电流值
                string strCh2Cur = null;//通道2电流值
                string strCh3Cur = null;//通道3电流值
                string strCh4Cur = null;//通道4电流值
                string strCh5Cur = null;//通道5电流值


                string strTemp = null;//舱内温度值


                string strHum = null;//舱内湿度值
                string strLeak = null;//舱内漏水值



                string strCollectDate = null;
                string strNum = null;

                string strPower1 = null;//通道1功率值
                string strPower2 = null;//通道2功率值
                string strPower3 = null;//通道3功率值
                string strPower4 = null;//通道4功率值
                string strPower5 = null;//通道5功率值




                if ((message.StartsWith("$Data") && QuickValidate(expCabin, message)) || (message.StartsWith("$Data") && QuickValidate(expCabin2, message)))//使用正则表达式匹配一下状态数据格式是否满足要求，后面使用正则表达式框出对应数据
                {
                    //numa++;
                    strCabin = "次接驳盒舱内状态信息";
                    strCh1Vol = message.Substring(65,6);//通道1电压
                    strCh2Vol = message.Substring(89,6);//通道2电压
                    strCh3Vol = message.Substring(113,6);//通道3电压
                    strCh4Vol = message.Substring(137,6);//通道4电压
                    strCh5Vol = message.Substring(161,6);//通道5电压

                   

             

                    //if (ch1vol > Main.maxA1Value)
                    //{
                    //    Main.maxA1Value = (int)(ch1vol + (ch1vol + Main.minA1Value) / 2);
                    //    Main.minA1Value = (int)(Main.minA1Value - (ch1vol + Main.minA1Value) / 2);
                    //}
                    //if(ch1vol < Main.minA1Value)
                    //{
                    //    Main.maxA1Value = (int)(Main.maxA1Value+(Main.maxA1Value+ch1vol)/2);
                    //    Main.minA1Value = (int)(ch1vol - (Main.maxA1Value + ch1vol) / 2);
                    //}

                    strCh1Cur = message.Substring(53,6);//通道1电流
                    strCh2Cur = message.Substring(77,6);//通道2电流
                    strCh3Cur = message.Substring(101,6);//通道3电流
                    strCh4Cur = message.Substring(125,6);//通道4电流
                    strCh5Cur = message.Substring(149,6);//通道5电流

                    strTemp = message.Substring(14, 7);//舱内温度

                   // double temp = Convert.ToDouble(strTemp);//舱内温度转换成double类型

                    //if (temp > Main.maxATemp)
                    //{
                    //    Main.maxATemp = (int)(temp+(temp+Main.minATemp)/2);
                    //    Main.minATemp = (int)(Main.minATemp -(temp+Main.minATemp)/2);
                    //}
                    //if (temp < Main.minATemp)
                    //{
                    //    Main.maxATemp = (int)(Main.maxATemp+(Main.maxATemp+temp)/2);
                    //    Main.minATemp = (int)(temp - (Main.maxATemp + temp) / 2);
                    //}



                   // strCollectDate = message.Substring(127, 4) + "-" + message.Substring(131, 2) + "-" + message.Substring(133, 2) + " " + message.Substring(135, 2) + ":" + message.Substring(137,2)+":"+message.Substring(139,2);//采集时间取上位机此时解析的时间即可
                   // strNum = message.Substring(143,message.Length-144);//包编号

                    strCollectDate = DateTime.Now.ToString("yyyy-MM-dd HH:mm:ss");

                    strPower1 = (Convert.ToDouble(strCh1Vol) * Convert.ToDouble(strCh1Cur)).ToString("0.00");//次级接驳盒舱内通道1的功率
                    strPower2 = (Convert.ToDouble(strCh2Vol) * Convert.ToDouble(strCh2Cur)).ToString("0.00");//次级接驳盒舱内通道2的功率
                    strPower3 = (Convert.ToDouble(strCh3Vol) * Convert.ToDouble(strCh3Cur)).ToString("0.00");//通道3功率
                    strPower4 = (Convert.ToDouble(strCh4Vol) * Convert.ToDouble(strCh4Cur)).ToString("0.00");//通道4功率
                    strPower5 = (Convert.ToDouble(strCh5Vol) * Convert.ToDouble(strCh5Cur)).ToString("0.00");//通道5功率


                    //解析完成之后，使用回调形式显示高压舱状态数据
                    f.Invoke(showJunctionStatuscallback,2,strCh1Vol,strCh2Vol,strCh3Vol,strCh4Vol,strCh5Vol,strCh1Cur,strCh2Cur,strCh3Cur,strCh4Cur,strCh5Cur,strTemp,strCollectDate,strPower1,strPower2,strPower3,strPower4,strPower5);


                    if (Main.draw1000flag == 1)
                    {
                        draw.arrayLCh1Vol.Add(strCh1Vol);//通道1电压电流值将数据加入到数组中以便实现图形绘制时移动标签显示
                        draw.arrayLCh1Cur.Add(strCh1Cur);

                        draw.arrayLCh2Vol.Add(strCh2Vol);//通道2电压电流值数据加入到数组中以便实现图形绘制时移动标签显示
                        draw.arrayLCh2Cur.Add(strCh2Cur);


                        //2021年5月13日09:41:13，为计算中心存储文件，将通道3，4，5的电压以及电流存入动态数组中
                        draw.arrayLCh3Vol.Add(strCh3Vol);
                        draw.arrayLCh3Cur.Add(strCh3Cur);


                        draw.arrayLCh4Vol.Add(strCh4Vol);
                        draw.arrayLCh4Cur.Add(strCh4Cur);


                        draw.arrayLCh5Vol.Add(strCh5Vol);
                        draw.arrayLCh5Cur.Add(strCh5Cur);


                        //draw.arrayACh3Vol.Add(strCh3Vol);//3
                        //draw.arrayACh3Cur.Add(strCh3Cur);


                        //draw.arrayACh4Vol.Add(strCh4Vol);//4
                        //draw.arrayACh4Cur.Add(strCh4Cur);

                        //draw.arrayACh5Vol.Add(strCh5Vol);//5
                        //draw.arrayACh5Cur.Add(strCh5Cur);



                        draw.arrayLTemp.Add(Convert.ToDouble(strTemp).ToString("00.000"));//将次级接驳盒温度值加入可变数组，实现标签显示

                        draw.arrayLSaveDate.Add(Convert.ToDateTime(strCollectDate).ToString());

                        lock (lockACh1)
                        {
                            //将A舱通道1电压电流，通道2电压电流以及温度一起更新到数组中
                           // drawExpACh1.refreshDrawElectricalArray(Convert.ToDateTime(strCollectDate).ToString(), Convert.ToDouble(strCh1Cur), Convert.ToDouble(strCh1Vol), Convert.ToDouble(strCh2Cur), Convert.ToDouble(strCh2Vol), Convert.ToDouble(strCh3Cur), Convert.ToDouble(strCh3Vol), Convert.ToDouble(strCh4Cur), Convert.ToDouble(strCh4Vol), Convert.ToDouble(strCh5Cur), Convert.ToDouble(strCh5Vol), Convert.ToDouble(strTemp), 1, f);//动态画状态图2，加锁
                            drawExpACh1.refreshDrawLowStsArray(strCollectDate, Convert.ToDouble(strCh1Cur), Convert.ToDouble(strCh1Vol), Convert.ToDouble(strCh2Cur), Convert.ToDouble(strCh2Vol), Convert.ToDouble(strTemp), 8, f);
                        }
                    }


                    DateTime dt = DateTime.Now;
                    string sql = "insert into seafloor_jBLowStsData (statusType,ch1Vol,ch2Vol,ch3Vol,ch4Vol,ch5Vol,ch1Cur,ch2Cur,ch3Cur,ch4Cur,ch5Cur,temp,saveDate,collectRawInfo,isDelete,ch1Power,ch2Power,ch3Power,ch4Power,ch5Power) values('" + strCabin + "','" + strCh1Vol + "','" + strCh2Vol + "','" + strCh3Vol + "','" + strCh4Vol + "','" + strCh5Vol + "','" + strCh1Cur + "','" + strCh2Cur + "','" + strCh3Cur + "','" + strCh4Cur + "','" + strCh5Cur + "','" + strTemp + "','" + dt + "','" + message + "','0','" + strPower1 + "','" + strPower2 + "','" + strPower3 + "','" + strPower4 + "','" + strPower5 + "')";//包编号存入数据库
                    SqlHelper.ExecuteNonQuery(sql);

                }
                
                
            }
            catch(Exception exp)
            {

                LogClass.WriteLogFile("处理舱内正常状态数据异常！"+exp.Message);
            }
        }

        /// <summary>
        /// 2.处理各个舱报警故障信息
        /// </summary>
        /// <param name="message"></param>
        private void DealFaultMessage(object content)
        {
            try
            {
                string message = content.ToString();

                string temp = message.Substring(4,3);//判断错误数据占几位的信息
                string strFaultHead = message.Substring(0,17);//故障码
                string strFaultName = GetFaultKeyValue(strFaultHead);//故障名
                string strFaultData = null;//故障数据
                string strCollectDate = null;//采集时间
                string strNum = null;//包编号

                strFaultData = message.Substring(18, 6);//故障值

                strCollectDate = DateTime.Now.ToString("yyyy-MM-dd HH:mm:ss");

                //委托回调的形式显示故障发生时间
                showFaultTime = strCollectDate;
                f.Invoke(showCabinFaultDatacallback, strFaultName, strFaultData, Convert.ToDateTime(strCollectDate), 12);

                switch(message.Substring(10,7))
                {
                    case "VolA+VH"://通道1过压问题显示
                        //DealFaultFeedback("$SET+01+VolA+VH+OK#");
                        f.Invoke(showCabinFaultDatacallback, strFaultName, strFaultData, Convert.ToDateTime(strCollectDate), 1);//电压问题都在datagridview的表格中的同一行显示
                        f.Invoke(showErrorSignalcallback,1);
                        break;
                    case "VolA+VL"://通道1欠压问题
                        //DealFaultFeedback("$SET+01+VolA+VL+OK#");
                        f.Invoke(showCabinFaultDatacallback, strFaultName, strFaultData, Convert.ToDateTime(strCollectDate), 1);
                        f.Invoke(showErrorSignalcallback, 1);
                        break;
                    case "CurA+AH"://通道1过流
                        //DealFaultFeedback("$SET+01+CurA+AH+OK#");
                        f.Invoke(showCabinFaultDatacallback, strFaultName, strFaultData, Convert.ToDateTime(strCollectDate), 2);
                        f.Invoke(showErrorSignalcallback, 1);
                        break;
                    case "CurA+AL"://通道1欠流
                        //DealFaultFeedback("$SET+01+CurA+AL+OK#");
                        f.Invoke(showCabinFaultDatacallback, strFaultName, strFaultData, Convert.ToDateTime(strCollectDate), 2);
                        f.Invoke(showErrorSignalcallback, 1);
                        break;
                    case "VolB+VH"://通道2过压
                        //DealFaultFeedback("$SET+01+VolB+VH+OK#");
                        f.Invoke(showCabinFaultDatacallback, strFaultName, strFaultData, Convert.ToDateTime(strCollectDate), 3);
                        f.Invoke(showErrorSignalcallback, 2);
                        break;
                    case "VolB+VL"://通道2欠压
                        //DealFaultFeedback("$SET+01+VolB+VL+OK#");
                        f.Invoke(showCabinFaultDatacallback, strFaultName, strFaultData, Convert.ToDateTime(strCollectDate), 3);
                        f.Invoke(showErrorSignalcallback, 2);
                        break;
                    case "CurB+AH"://通道2过流
                        //DealFaultFeedback("$SET+01+CurB+AH+OK#");
                        f.Invoke(showCabinFaultDatacallback, strFaultName, strFaultData, Convert.ToDateTime(strCollectDate), 4);
                        f.Invoke(showErrorSignalcallback, 2);
                        break;
                    case "CurB+AL"://通道2欠流
                        //DealFaultFeedback("$SET+01+CurB+AL+OK#");
                        f.Invoke(showCabinFaultDatacallback, strFaultName, strFaultData, Convert.ToDateTime(strCollectDate), 4);
                        f.Invoke(showErrorSignalcallback, 2);
                        break;

                        /*******新增的通道3至通道5*********/
                    case "VolC+VH"://通道3过压
                        //DealFaultFeedback("$SET+01+VolC+VH+OK#");
                        f.Invoke(showCabinFaultDatacallback, strFaultName, strFaultData, Convert.ToDateTime(strCollectDate), 5);
                        f.Invoke(showErrorSignalcallback, 3);
                        break;
                    case "VolC+VL"://通道3欠压
                        //DealFaultFeedback("$SET+01+VolC+VL+OK#");
                        f.Invoke(showCabinFaultDatacallback, strFaultName, strFaultData, Convert.ToDateTime(strCollectDate), 5);
                        f.Invoke(showErrorSignalcallback, 3);
                        break;
                    case "CurC+AH"://通道3过流
                        //DealFaultFeedback("$SET+01+CurC+AH+OK#");
                        f.Invoke(showCabinFaultDatacallback, strFaultName, strFaultData, Convert.ToDateTime(strCollectDate), 6);
                        f.Invoke(showErrorSignalcallback, 3);
                        break;
                    case "CurC+AL"://通道3欠流
                        //DealFaultFeedback("$SET+01+CurC+AL+OK#");
                        f.Invoke(showCabinFaultDatacallback, strFaultName, strFaultData, Convert.ToDateTime(strCollectDate), 6);
                        f.Invoke(showErrorSignalcallback, 3);
                        break;
                    case "VolD+VH"://通道4过压
                        //DealFaultFeedback("$SET+01+VolD+VH+OK#");
                        f.Invoke(showCabinFaultDatacallback, strFaultName, strFaultData, Convert.ToDateTime(strCollectDate), 7);
                        f.Invoke(showErrorSignalcallback, 4);
                        break;
                    case "VolD+VL"://通道4欠压
                        //DealFaultFeedback("$SET+01+VolD+VL+OK#");
                        f.Invoke(showCabinFaultDatacallback, strFaultName, strFaultData, Convert.ToDateTime(strCollectDate), 7);
                        f.Invoke(showErrorSignalcallback, 4);
                        break;
                    case "CurD+AH"://通道4过流
                        //DealFaultFeedback("$SET+01+CurD+AH+OK#");
                        f.Invoke(showCabinFaultDatacallback, strFaultName, strFaultData, Convert.ToDateTime(strCollectDate), 8);
                        f.Invoke(showErrorSignalcallback, 4);
                        break;
                    case "CurD+AL"://通道4欠流
                        //DealFaultFeedback("$SET+01+CurD+AL+OK#");
                        f.Invoke(showCabinFaultDatacallback, strFaultName, strFaultData, Convert.ToDateTime(strCollectDate), 8);
                        f.Invoke(showErrorSignalcallback, 4);
                        break;

                    case "VolE+VH"://通道5过压
                        //DealFaultFeedback("$SET+01+VolE+VH+OK#");
                        f.Invoke(showCabinFaultDatacallback, strFaultName, strFaultData, Convert.ToDateTime(strCollectDate), 9);
                        f.Invoke(showErrorSignalcallback, 5);
                        break;
                    case "VolE+VL"://通道5欠压
                        //DealFaultFeedback("$SET+01+VolE+VL+OK#");
                        f.Invoke(showCabinFaultDatacallback, strFaultName, strFaultData, Convert.ToDateTime(strCollectDate), 9);
                        f.Invoke(showErrorSignalcallback, 5);
                        break;
                    case "CurE+AH"://通道5过流
                        //DealFaultFeedback("$SET+01+CurE+AH+OK#");
                        f.Invoke(showCabinFaultDatacallback, strFaultName, strFaultData, Convert.ToDateTime(strCollectDate), 10);
                        f.Invoke(showErrorSignalcallback, 5);
                        break;
                    case "CurE+AL"://通道5欠流
                        //DealFaultFeedback("$SET+01+CurE+AL+OK#");
                        f.Invoke(showCabinFaultDatacallback, strFaultName, strFaultData, Convert.ToDateTime(strCollectDate), 10);
                        f.Invoke(showErrorSignalcallback, 5);
                        break;




                    /*****温度故障******/
                    case "Temp+TH"://舱内温度过高
                        //DealFaultFeedback("$SET+01+Temp+TH+OK#");
                        f.Invoke(showCabinFaultDatacallback, strFaultName, strFaultData, Convert.ToDateTime(strCollectDate), 11);
                        break;
                    case "Temp+TL"://舱内温度过低
                        //DealFaultFeedback("$SET+01+Temp+TL+OK#");
                        f.Invoke(showCabinFaultDatacallback, strFaultName, strFaultData, Convert.ToDateTime(strCollectDate), 11);
                        break;

   

                }

                //如果有故障生产，就随时生成故障文件
                XDocument document = new XDocument();
                XElement root = new XElement("SeafloorObservatoryNetWorkFaultFile-JiaozhouBay");//海底观测网故障文件
                XElement jBFaultData = new XElement("SecondaryJunctionBoxFaultData");//二级标签次级接驳盒故障数据

                jBFaultData.SetElementValue("FaultType", strFaultName);
                jBFaultData.SetElementValue("FaultData", strFaultData);
                root.Add(jBFaultData);


                DateTime dt = DateTime.Now;
                string sql = "insert into seafloor_jBFaultData (faultType,faultData,saveDate,collectRawInfo,isDelete) values('" + strFaultName + "','" + strFaultData + "','" + dt + "','" + message + "','0')";//包编号存入数据库
                SqlHelper.ExecuteNonQuery(sql);

                root.Save(@"D:\SONFault\" + dt.ToString("yyyy-MM-dd HHmmss") + "SONFault" + ".xml");

                string sql1 = "insert into faultlog (faultType,faultData,time) values('" + strFaultName + "','" + strFaultData + "','" + dt + "')";//将接驳盒出现异常的数据存入到数据库中
                SqlHelper.ExecuteNonQuery(sql1);


            }
            catch(Exception exp)
            {
                LogClass.WriteLogFile("处理故障信息异常！"+exp.Message);
            }
        }
        

        ///********编写接驳盒测试软件额外增添的协议*********/
        ///// <summary>
        /////读入故障码与故障类型对应的编号
        ///// </summary>
        ///// <returns></returns>
        //public Dictionary<string, string> SetFaultKeyValue()
        //{
        //    Dictionary<string, string> dic = new Dictionary<string, string>();
        //    //从数据库中读到相应数据，然后将对应的Key以及value填充到字典中

        //    try
        //    {
        //        MySqlDataReader reader = SqlHelper.ExecuteReader("select * from seafloor_jBConfigInfo");
        //        while (reader.Read())
        //        {
        //            dic.Add(reader.GetString(2), reader.GetString(1));
        //        }
        //    }
        //    catch (Exception exp)
        //    {
        //        //MessageBox.Show("读入数据库时出现异常！"+exp.Message);
        //        LogClass.WriteLogFile("读入数据库seafloor_jBConfigInfo时出现异常！" + exp.Message);
        //    }
        //    return dic;

        //}

        /// <summary>
        /// 类型于查字典，由相应的故障码（相当于键值）得到对应的故障类型（Value值）
        /// </summary>
        /// <param name="message"></param>
        /// <returns></returns>

        private string GetFaultKeyValue(string message)
        {
            string value = null;
            if (myFaultDic.TryGetValue(message, out value))
            {
                return value;
            }
            else
            {
                return null;
            }
        }


        ///// <summary>
        ///// 新增处理GPS位置信息函数
        ///// </summary>
        //public   static void dealGPS(object tempMessage)
        //{
        //    try
        //    {
        //        string message = tempMessage.ToString();
        //        byte[] data = Encoding.Default.GetBytes(message);//转换成对应的字节
                

        //        string content = null;
        //        for (int k = 0; k < data.Length; k++)
        //            content += String.Format("{0:X2}", data[k]);//转换成对应的16进制的字符串

        //        //1.利用16进制字符串判断长度是否符合要求
        //        int length = Convert.ToInt32(content.Substring(10, 4), 16);//从数据包中截取出自带的长度信息；

        //        if (length != content.Length / 2)//判断数据包中带的长度信息与实际的长度信息是否一致
        //        {
        //            //若是长度信息不一致，则认为错误
        //        }
        //        else//长度信息一致，判断校验值是否正确
        //        {
        //            byte[] tempData = new byte[data.Length - 1];
        //            for (int i = 0; i < data.Length - 1; i++)
        //            {
        //                tempData[i] = data[i];
        //            }
        //            string xorHex = HexXorByte(tempData);
        //            if (xorHex == content.Substring(content.Length - 2, 2))//如果异或校验值通过
        //            {
        //                int lon1 = Convert.ToInt32(content.Substring(40,2),16);//经度部分的整数部分
        //                int lon2 = Convert.ToInt32(content.Substring(42,8),16);//经度部分的小数部分

        //                byte[] L = new byte[1];
        //                L[0] = data[25];
        //                string longitude = lon1.ToString() + "." + lon2.ToString().ToString();//经度值显示

        //                int lat1 = Convert.ToInt32(content.Substring(52,2),16);//纬度部分的整数部分
        //                int lat2 = Convert.ToInt32(content.Substring(54,8),16);//纬度部分的小数部分


        //                string latitude = lat1.ToString() + "." + lat2.ToString();//纬度值显示




        //                f.Invoke(showBaiducallback, longitude, latitude);


        //            }
        //            else //异或校验值不通过
        //            {
        //                //直接舍弃不做任何处理
        //            }
        //        }

        //        //以下是将经纬度点加载到百度地图中
        //       //f.webGPS.Document.InvokeScript("setLocation", new object[] { lon, lat });//创建标记
        //       //f.webGPS.Document.InvokeScript("clear");//清除标记
               
        //        //f.Invoke(showBaiducallback,lon,lat);//c#与js交互代码，其中js交互部分一定要放到委托中使用，否则程序异常！
               
                
        //    }
        //    catch (Exception exp)
        //    {
        //        LogClass.WriteLogFile("处理GPS位置信息出现异常！" + exp.Message);
        //    }
        //}
        


    }
}
