﻿/*
 * 时间：2018年3月28日13:19:22
 * 功能：数据采集器1上面所接的传感器数据解析处理程序
 * 说明：数据采集器1上面所接的传感器主要包括,山仪所溶解氧,安德拉溶解氧,CTD，多参数（主要测量叶绿素，浊度，藻红蛋白）
 */
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Net.Sockets;
using System.IO;
//using MySql.Data.MySqlClient;
using System.Threading;
using System.Text.RegularExpressions;
using System.Data;
using System.Windows.Forms;
using System.Drawing;
using System.Xml.Linq;
using MySql.Data.MySqlClient;

namespace OSNSystem
{
    class _3ReceieveMsgClass2
    {

        private TcpClient tcpClient;
        private BinaryReader br;
        private BinaryWriter bw;
        private NetworkStream networkStream;

        private _4DrawSensor drawExpDO;//画溶解氧传感器曲线实例
        private _4DrawSensor drawExpADL;//画安德拉溶解氧曲线实例
        private _4DrawSensor drawExpCTD;//画CTD曲线实例
        private _4DrawSensor drawExpMultiPara;//画多参数曲线实例
        private static int intFrequency;//溶解氧平滑频率，要设置成静态变量

        private static int flag = 0; //溶解氧存储buffer标识位

        private static int[] buffer = new int[4];//溶解氧频率buffer
        private object lockDO = new object();//数据采集器1溶解氧画图所加的锁
        private object lockADL = new object();//数据采集器1安德拉溶解氧画图所加的锁
        private object lockCTD = new object();//数据采集器1 CTD传感器画图所加的锁
        private object lockMultiPara = new object();//数据采集器1 多参数传感器画图所加的锁
        private Main f;
        private Dictionary<string, string> mydic;



        private string DOVol = "-1";//首页显示溶解氧电压
        private string DOCur = "-1";//首页显示溶解氧电流
        private string DOPower = "-1";//首页显示溶解氧功率
        private string DOTime = "";//首页显示溶解氧采集时间


        private string JWVol = "-1";//首页显示甲烷电压
        private string JWCur = "-1";//首页显示甲烷电流
        private string JWPower = "-1";//首页显示甲烷功率
        private string JWTime = "";//首页显示甲烷采集时间

        private string YLSVol = "-1";//首页显示叶绿素电压
        private string YLSCur = "-1";//首页显示叶绿素电流
        private string YLSPower = "-1";//首页显示叶绿素功率
        private string YLSTime = "";//首页显示叶绿素采集时间

        private string ZDVol = "-1";//首页显示浊度电压
        private string ZDCur = "-1";//首页显示浊度电流
        private string ZDPower = "-1";//首页显示浊度功率
        private string ZDTime = "";//首页显示浊度采集时间

        private string CDOMVol = "-1";//首页显示cdom电压
        private string CDOMCur = "-1";//首页显示cdom电流
        private string CDOMPower = "-1";//首页显示cdom功率
        private string CDOMTime = "";//首页显示cdom采集时间

        private string showTemp = "";//首页显示温度
        private string showFaultTime = null;//首页显示故障时间

        private static UInt32 s1, s2, s3, s4, s5, sum = 0;//下位机各个通道发送个数统计

        //public static UInt32 collectCommandNum = 0;//数据采集器相关指令的发送条数统计

        public static double latitude;


        public string strMultiParameter = null;


        private int doflag = 0;//溶解氧数据是否出现错误的标志位
        private int andelaflag = 0;//安德拉数据是否出现错误的标志位
        private int ctdflag = 0;//ctd是否出现错误的标志位
        /// <summary>
        /// 类_3ReceieveMsgClass2的构造函数
        /// </summary>
        /// <param name="tcpClient1"></param>
        /// <param name="br1"></param>
        /// <param name="bw1"></param>
        /// <param name="networkStream1"></param>
        /// <param name="frm"></param>
        public _3ReceieveMsgClass2(TcpClient tcpClient1, BinaryReader br1, BinaryWriter bw1, NetworkStream networkStream1, Main frm,Dictionary<string, string> dic)
        {
            tcpClient = tcpClient1;
            br = br1;
            bw = bw1;
            networkStream = networkStream1;
            f = frm;

           // mydic = SetKeyValue();
            mydic = dic;//只在最开始的时候读入一次数据库

            drawExpDO = frm.drawSensorExp;
            drawExpADL = frm.drawSensorExp;
            drawExpCTD = frm.drawSensorExp;
            drawExpMultiPara = frm.drawSensorExp;

            showSensorMessagecallback = new delShowSensorMessage(showSensorMessageMethod);
            showCanConnectcallback = new delShowCanConnect(ShowCanConnectMethod);//几个需要跨线程访问控件的委托回调初始化
            showChOnOffcallback = new delShowChOnOff(ShowChOnOffMethod);
            showElectricalcallback = new delShowElectrical(ShowElectricalMethod);
            showChNumcallback = new delShowChNum(showChNumMethod);
            showSensorFaultcallback = new delShowSensorFault(ShowSensorFaultMethod);
        }


        private delegate void delShowSensorMessage(int i, string data,string data2,string data3, DateTime time);
        private delShowSensorMessage showSensorMessagecallback;
        /// <summary>
        /// 数据采集器1上面挂载的传感器信息显示在传感器信息页上显示各个传感器的采集值以及采集时间 
        /// </summary>
        /// <param name="i"></param>
        /// <param name="data"></param>
        /// <param name="time"></param>
        private void showSensorMessageMethod(int i, string data,string data2,string data3 ,DateTime time)
        {
           
            switch (i)
            {
                case 1:
                    //对溶解氧的字体进行设置
                    FontClass fontType = new FontClass();
                    f.txtDOValue.Font = fontType.fontCollectorData;
                    f.txtDODate.Font = fontType.fontCollectorData;
                    //对传感器信息页溶解氧显示的字体进行设置



                    f.txtDOValue.Text = data;
                    f.txtDODate.Text = time.ToString("yyyy-MM-dd HH:mm:ss");
                    break;
                case 2:
                    //安德拉溶解氧数值液晶字体显示
                    FontClass fontType2 = new FontClass();
                    f.txtADLValue.Font = fontType2.fontCollectorData;
                    f.txtADLDate.Font = fontType2.fontCollectorData;
                    //叶绿素液晶字体显示

                    f.txtADLValue.Text = data;
                    f.txtADLDate.Text = time.ToString("yyyy-MM-dd HH:mm:ss");
                    break;
                case 3:
                    //CTD液晶字体显示
                    FontClass fontType3 = new FontClass();
                    f.txtCTDValue.Font = fontType3.fontCollectorData;
                    f.txtCTDDate.Font = fontType3.fontCollectorData;
                    f.txtCTD_Depth.Font = fontType3.fontCollectorData;
                    f.txtCTD_Temp.Font = fontType3.fontCollectorData;
                    //浊度液晶字体显示


                   // f.txtCTDValue.Text = data;
                    f.txtCTD_Temp.Text = data;
                    f.txtCTD_Depth.Text = data2;
                    f.txtCTDValue.Text = data3;
                    f.txtCTDDate.Text = time.ToString("yyyy-MM-dd HH:mm:ss");
                    break;
                case 4:
                    //多参数液晶字体显示
                    FontClass fontType4 = new FontClass();
                    f.txtM_Chl.Font = fontType4.fontCollectorData;
                    f.txtM_Tur.Font = fontType4.fontCollectorData;
                    f.txtM_Phy.Font = fontType4.fontCollectorData;
                    f.txtMultiDate.Font = fontType4.fontCollectorData;
                    //CDOM液晶字体显示

                    f.txtM_Chl.Text = data;//叶绿素显示
                    f.txtM_Tur.Text = data2;//浊度显示
                    f.txtM_Phy.Text = data3;//温度显示

                    f.txtMultiDate.Text = time.ToString("yyyy-MM-dd HH:mm:ss");
                    break;

            }
        }


        /*********根据具体实际情况，额外增加的委托以及回调函数********/
        private delegate void delShowCanConnect(int i);
        private delShowCanConnect showCanConnectcallback;
        /// <summary>
        /// 1.与下位机连接标识显示状态的回调函数，回调函数中不牵扯变量关系
        /// </summary>
        /// <param name="i"></param>
        private void ShowCanConnectMethod(int i)//
        {
            if (i == 1)
            {
                f.datacollectflag.Text = "连接";
                f.datacollectflag.ForeColor = Color.Green;

            }
            else if (i == 2)
            {
                f.datacollectflag.Text = "断开";
                f.datacollectflag.ForeColor = Color.Red;

                SendMessageClass expD = new SendMessageClass();
                string url = expD.GetPostUrl("15265210541","通信异常报警—数据采集器断开！");
                string s1 = expD.PostSmsInfo(url);
                string s2 = expD.GetResult(s1);



                LogConnect.WriteLogFile("数据采集器1断开！"+"短信发送情况"+s2);

                f.serverConnet.Text = "断开";//与下位机的连接断开后，与数据库服务器连接断开
                f.serverConnet.ForeColor = Color.Red;

            }
        }

        private delegate void delShowChOnOff(int i);
        private delShowChOnOff showChOnOffcallback;
        /// <summary>
        /// 2.显示各个通道开关的回调函数
        /// </summary>
        /// <param name="i"></param>
        private void ShowChOnOffMethod(int i)
        {
            switch (i)
            {
                case 1:
                    f.chOneClose.Enabled = false;
                    f.chOneOpen.Enabled = true;
                    f.sensorOneStatus.Text = "关闭";
                    f.sensorOneStatus.ForeColor = Color.White;
                    f.sensorOneStatus.BackColor = Color.Red;
                    break;
                case 2:
                    f.chTwoClose.Enabled = false;
                    f.chTwoOpen.Enabled = true;
                    f.sensorTwoStatus.Text = "关闭";
                    f.sensorTwoStatus.BackColor = Color.Red;
                    f.sensorTwoStatus.ForeColor = Color.White;
                    break;
                case 3:
                    f.chThreeClose.Enabled = false;
                    f.chThreeOpen.Enabled = true;
                    f.sensorThreeStatus.Text = "关闭";
                    f.sensorThreeStatus.BackColor = Color.Red;
                    f.sensorThreeStatus.ForeColor = Color.White;
                    break;
                case 4:
                    f.chFourClose.Enabled = false;
                    f.chFourOpen.Enabled = true;
                    f.sensorFourStatus.Text = "关闭";
                    f.sensorFourStatus.BackColor = Color.Red;
                    f.sensorFourStatus.ForeColor = Color.White;
                    break;
                case 5:
                    f.chFiveClose.Enabled = false;
                    f.chFiveOpen.Enabled = true;
                    f.sensorFiveStatus.Text = "关闭";
                    f.sensorFiveStatus.BackColor = Color.Red;
                    f.sensorFiveStatus.ForeColor = Color.White;
                    break;

            }
        }

        private delegate void delShowElectrical(int i);
        private delShowElectrical showElectricalcallback;
        /// <summary>
        /// 3.定义主界面显示电参数,及温度，以及故障时间,回调函数
        /// </summary>
        /// <param name="i"></param>
        private void ShowElectricalMethod(int i)
        {
            switch (i)
            {
                case 1:
                    //数据采集器1通道1电参数状态液晶字体设置
                    FontClass fontType = new FontClass();
                    f.sensorOneVol.Font = fontType.fontLed;
                    f.sensorOneCur.Font = fontType.fontLed;
                    f.sensorOnePower.Font = fontType.fontLed;
                    f.sensorOneTime.Font = fontType.fontLed;
                    //数据采集器1通道1电参数状态液晶字体设置

                    f.sensorOneVol.Text = DOVol;
                    f.sensorOneCur.Text = DOCur;
                    f.sensorOnePower.Text = DOPower;
                    f.sensorOneTime.Text = DOTime;
                    break;
                case 2:
                    //数据采集器1通道2电参数状态液晶字体设置
                    FontClass fontType2 = new FontClass();
                    f.sensorTwoVol.Font = fontType2.fontLed;
                    f.sensorTwoCur.Font = fontType2.fontLed;
                    f.sensorTwoPower.Font = fontType2.fontLed;
                    f.sensorTwoTime.Font = fontType2.fontLed;
                    //数据采集器1通道2电参数状态液晶字体设置

                    f.sensorTwoVol.Text = JWVol;
                    f.sensorTwoCur.Text = JWCur;
                    f.sensorTwoPower.Text = JWPower;
                    f.sensorTwoTime.Text = JWTime;
                    break;
                case 3:
                    //数据采集器1通道3电参数状态液晶字体设置
                    FontClass fontType3 = new FontClass();
                    f.sensorThreeVol.Font = fontType3.fontLed;
                    f.sensorThreeCur.Font = fontType3.fontLed;
                    f.sensorThreePower.Font = fontType3.fontLed;
                    f.sensorThreeTime.Font = fontType3.fontLed;
                    //数据采集器1通道3电参数状态液晶字体设置

                    f.sensorThreeVol.Text = YLSVol;
                    f.sensorThreeCur.Text = YLSCur;
                    f.sensorThreePower.Text = YLSPower;
                    f.sensorThreeTime.Text = YLSTime;
                    break;
                case 4:
                    //数据采集器1通道4电参数状态液晶字体设置
                    FontClass fontType4 = new FontClass();
                    f.sensorFourVol.Font = fontType4.fontLed;
                    f.sensorFourCur.Font = fontType4.fontLed;
                    f.sensorFourPower.Font = fontType4.fontLed;
                    f.sensorFourTime.Font = fontType4.fontLed;
                    //数据采集器1通道4电参数状态液晶字体设置

                    f.sensorFourVol.Text = ZDVol;
                    f.sensorFourCur.Text = ZDCur;
                    f.sensorFourPower.Text = ZDPower;
                    f.sensorFourTime.Text = ZDTime;
                    break;
                case 5:
                    //数据采集器1通道5电参数状态液晶字体设置
                    FontClass fontType5 = new FontClass();
                    f.sensorFiveVol.Font = fontType5.fontLed;
                    f.sensorFiveCur.Font = fontType5.fontLed;
                    f.sensorFivePower.Font = fontType5.fontLed;
                    f.sensorFiveTime.Font = fontType5.fontLed;
                    //数据采集器1通道5电参数状态液晶字体设置

                    f.sensorFiveVol.Text = CDOMVol;
                    f.sensorFiveCur.Text = CDOMCur;
                    f.sensorFivePower.Text = CDOMPower;
                    f.sensorFiveTime.Text = CDOMTime;
                    break;
                case 6:
                    f.canTemp.Text = showTemp;
                    break;

                case 7:
                    f.txtCollectErrorTime.Text = Convert.ToDateTime(showFaultTime).ToString();//故障时间的显示
                    break;
            }
        }

        private delegate void delShowChNum();
        private delShowChNum showChNumcallback;
        /// <summary>
        /// 4.定义界面通道个数显示的回调函数
        /// </summary>
        private void showChNumMethod()
        {
            f.sensorOneSendNum.Text = s1.ToString();
            f.sensorTwoSendNum.Text = s2.ToString();
            f.sensorThreeSendNum.Text = s3.ToString();
            f.sensorFourSendNum.Text = s4.ToString();
            f.sensorFiveSendNum.Text = s5.ToString();
            f.canReceiveNum.Text = sum.ToString();
            //f.canSendNum.Text = collectCommandNum.ToString();



        }


        private delegate void delShowSensorFault(string name, string data, DateTime time, int i);
        private delShowSensorFault showSensorFaultcallback;

        /// <summary>
        /// 5.定义首页实时显示传感器采集值以及故障值得委托回调函数
        /// </summary>
        /// <param name="name"></param>
        /// <param name="data"></param>
        /// <param name="time"></param>
        /// <param name="i"></param>
        private void ShowSensorFaultMethod(string name, string data, DateTime time, int i)
        {
            switch (i)
            {
                /*传感器采集值表格更新*/
                case 1://CTD-电导率所在行更新
                    f.dataGridView3.Rows[0].Cells["传感器名称"].Value = name;
                    f.dataGridView3.Rows[0].Cells["采集值"].Value = data;
                    f.dataGridView3.Rows[0].Cells["采集时间"].Value = time.ToString("yyyy-MM-dd HH:mm:ss");//dataGridView行从0开始
                    //f.dataGridView1.Rows[0].Cells["采集时间"].Value = time;//采用这种方式，在表格中时间显示的格式是2017/05/12 
                    break;
                case 2://CTD-温度值所在行更新
                    f.dataGridView3.Rows[1].Cells["传感器名称"].Value = name;
                    f.dataGridView3.Rows[1].Cells["采集值"].Value = data;
                    f.dataGridView3.Rows[1].Cells["采集时间"].Value = time.ToString("yyyy-MM-dd HH:mm:ss");//dataGridView行从0开始
                    break;
                case 3://CTD-盐度值所在行更新
                    f.dataGridView3.Rows[2].Cells["传感器名称"].Value = name;
                    f.dataGridView3.Rows[2].Cells["采集值"].Value = data;
                    f.dataGridView3.Rows[2].Cells["采集时间"].Value = time.ToString("yyyy-MM-dd HH:mm:ss");//dataGridView行从0开始                   
                    break;
                case 4://CTD-深度所在行更新
                    f.dataGridView3.Rows[3].Cells["传感器名称"].Value = name;
                    f.dataGridView3.Rows[3].Cells["采集值"].Value = data;
                    f.dataGridView3.Rows[3].Cells["采集时间"].Value = time.ToString("yyyy-MM-dd HH:mm:ss");//dataGridView行从0开始                  
                    break;
                case 5://PH传感器所在更新
                    f.dataGridView3.Rows[4].Cells["传感器名称"].Value = name;
                    f.dataGridView3.Rows[4].Cells["采集值"].Value = data;
                    f.dataGridView3.Rows[4].Cells["采集时间"].Value = time.ToString("yyyy-MM-dd HH:mm:ss");//dataGridView行从0开始                  
                    break;

                /*******************************故障值表格更新***********************************/
                case 6://更新溶解氧故障值
                    f.dataGridView4.Rows[0].Cells["故障名称"].Value = name;
                    f.dataGridView4.Rows[0].Cells["报警数据"].Value = data;
                    f.dataGridView4.Rows[0].Cells["故障时间"].Value = time.ToString("yyyy-MM-dd HH:mm:ss");

                    break;
                case 7://更新甲烷故障值
                    f.dataGridView4.Rows[1].Cells["故障名称"].Value = name;
                    f.dataGridView4.Rows[1].Cells["报警数据"].Value = data;
                    f.dataGridView4.Rows[1].Cells["故障时间"].Value = time.ToString("yyyy-MM-dd HH:mm:ss");

                    break;
                case 8://更新叶绿素故障值
                    f.dataGridView4.Rows[2].Cells["故障名称"].Value = name;
                    f.dataGridView4.Rows[2].Cells["报警数据"].Value = data;
                    f.dataGridView4.Rows[2].Cells["故障时间"].Value = time.ToString("yyyy-MM-dd HH:mm:ss");

                    break;
                case 9://更新浊度故障值
                    f.dataGridView4.Rows[3].Cells["故障名称"].Value = name;
                    f.dataGridView4.Rows[3].Cells["报警数据"].Value = data;
                    f.dataGridView4.Rows[3].Cells["故障时间"].Value = time.ToString("yyyy-MM-dd HH:mm:ss");

                    break;
                case 10://更新CDOM
                    f.dataGridView4.Rows[4].Cells["故障名称"].Value = name;
                    f.dataGridView4.Rows[4].Cells["报警数据"].Value = data;
                    f.dataGridView4.Rows[4].Cells["故障时间"].Value = time.ToString("yyyy-MM-dd HH:mm:ss");

                    break;
                case 11://更新温度报警故障值
                    f.dataGridView4.Rows[5].Cells["故障名称"].Value = name;
                    f.dataGridView4.Rows[5].Cells["报警数据"].Value = data;
                    f.dataGridView4.Rows[5].Cells["故障时间"].Value = time.ToString("yyyy-MM-dd HH:mm:ss");

                    break;

                //20180416新增传感器数据更新
                case 12://山仪所溶解氧所在行更新
                    f.dataGridView3.Rows[5].Cells["传感器名称"].Value = name;
                    f.dataGridView3.Rows[5].Cells["采集值"].Value = data;
                    f.dataGridView3.Rows[5].Cells["采集时间"].Value = time.ToString("yyyy-MM-dd HH:mm:ss");//dataGridView行从0开始                  
                    break;

                case 13://叶绿素浊度-叶绿素所在行更新
                    f.dataGridView3.Rows[6].Cells["传感器名称"].Value = name;
                    f.dataGridView3.Rows[6].Cells["采集值"].Value = data;
                    f.dataGridView3.Rows[6].Cells["采集时间"].Value = time.ToString("yyyy-MM-dd HH:mm:ss");
                    break;
                case 14://叶绿素浊度-浊度所在行更新
                    f.dataGridView3.Rows[7].Cells["传感器名称"].Value = name;
                    f.dataGridView3.Rows[7].Cells["采集值"].Value = data;
                    f.dataGridView3.Rows[7].Cells["采集时间"].Value = time.ToString("yyyy-MM-dd HH:mm:ss");
                    break;
                case 15://叶绿素浊度-温度所在行更新
                    f.dataGridView3.Rows[8].Cells["传感器名称"].Value = name;
                    f.dataGridView3.Rows[8].Cells["采集值"].Value = data;
                    f.dataGridView3.Rows[8].Cells["采集时间"].Value = time.ToString("yyyy-MM-dd HH:mm:ss");
                    break;

            }

        }



        /// <summary>
        /// 
        /// </summary>
        public void ReceiveMessage()
        {

            bool keepalive = true;//该标志是个局部变量，一个连接的断开不会影响这个连接的标志
            f.Invoke(showCanConnectcallback,1);//数据采集器信息页连接标志显示为连接
            try
            {
                
                while (keepalive)
                {

                    if (tcpClient == null || !tcpClient.Connected)//判断连接是否还存在
                    {
                        keepalive = false;

                        f.Invoke(showCanConnectcallback,2);//连接标志显示为断开
                        CloseSocket();


                        //2021年5月21日11:37:28  添加新的清空内存的方式
                        Main.ClearMemory();

                        Thread.CurrentThread.Abort();
                        GC.Collect();

                        break;//跳出循环
                    }

                    else
                    {
                        byte[] bytes = new byte[8192];
                        int readBytes = 0;

                        tcpClient.ReceiveTimeout = 60000;//将等待时间设置成1min，1min之后没有收到数据就认为连接断开，对非法关机的有效处理
                        //NetworkStream networkStream = tcpClient.GetStream();
                        //BinaryReader br = new BinaryReader(networkStream);


                        readBytes = br.Read(bytes, 0, 8192);

                        //只要执行到该步骤，就说明有接收到数据，连接标志显示为连接
                        f.Invoke(showCanConnectcallback,1);

                        string content = null;

                        if (readBytes > 0)
                        {

                            string chOnOffMsg = Encoding.ASCII.GetString(bytes, 0, readBytes);//接收到的下位机发送来的通道开关信息


                            //1.增加对甲烷信息的格外判断
                            if ((bytes[2] == 2) && (bytes[3] == 0) && (bytes[4] == 1) && (bytes[5] == 0))//如果甲烷是小端字节数组
                            {
                                Array.Reverse(bytes, 0, 2);//翻转协议头55 AA的字节序
                                Array.Reverse(bytes, 2, 4);//翻转协议编号00 01 00 02字节序
                                Array.Reverse(bytes, 29, 4);//翻转包编号
                                Array.Reverse(bytes, 33, 4);//翻转包体长度
                                Array.Reverse(bytes, 37, 4);//翻转校验和
                                Array.Reverse(bytes, 50, 2);//翻转传感器标识
                            }

                            //2.对甲烷信息格外判断之后，将字节类型处理成十六进制对应的字符串类型
                            for (int k = 0; k < readBytes; k++)
                                content += String.Format("{0:X2}", bytes[k]);


                            if (content.StartsWith("55AA") && content.EndsWith("23"))//接收到发送的传感器和监测数据，完成，发送ok后关闭连接，对接收到的数据进行处理
                            {
                                //对正常接收到的信息进行处理,防止沾包处理
                                string[] sArray = Regex.Split(content, "55AA", RegexOptions.IgnoreCase); //将字符串按照55AA进行分割


                                for (int i = 0; i <= sArray.Length - 2; i++)
                                {

                                    content = ("55AA"+sArray[i+1]).Trim();//放到后面线程中进行修改

                                    ThreadPool.QueueUserWorkItem(new WaitCallback(DealMessage), content);//将处理函数放入线程池中处理分割完成之后的每条数据
                                    
                                    DateTime dt= DateTime.Now;
                                    string sql = "insert into seafloor_allData (saveDate,collectRawInfo) values('" + dt + "','" + content + "')";
                                    SqlHelper.ExecuteNonQuery(sql);
                                }

                            }
                            else if (chOnOffMsg == "$ch1 power off#")
                            {
                                f.Invoke(showChOnOffcallback,1);
                                LogCommand.WriteLogFile("通道1关断！");
                            }
                            else if (chOnOffMsg == "$ch2 power off#")
                            {
                                f.Invoke(showChOnOffcallback, 2);

                                LogCommand.WriteLogFile("通道2关断！");
                            }
                            else if (chOnOffMsg == "$ch3 power off#")
                            {
                                f.Invoke(showChOnOffcallback, 3);
                                LogCommand.WriteLogFile("通道3关断！");
                            }
                            else if (chOnOffMsg == "$ch4 power off#")
                            {
                                f.Invoke(showChOnOffcallback, 4);
                                LogCommand.WriteLogFile("通道4关断！");
                            }
                            else if (chOnOffMsg == "$ch5 power off#")
                            {
                                f.Invoke(showChOnOffcallback, 5);
                                LogCommand.WriteLogFile("通道5关断！");
                            }
                        }
                        else
                        {
                            keepalive = false;
                            f.Invoke(showCanConnectcallback,2);
                            CloseSocket();

                        }
                    }
                }

                
                CloseSocket();

                //2021年5月21日11:38:27
                Main.ClearMemory();

                Thread.CurrentThread.Abort();
                GC.Collect();
            }

            catch (SocketException exp)
            {
                keepalive = false;
                f.Invoke(showCanConnectcallback,2);

                CloseSocket();

                //2021年5月21日11:38:51
                Main.ClearMemory();

                Thread.CurrentThread.Abort();
                GC.Collect();
                LogClass.WriteLogFile("接收信息出现异常！" + exp.Message);

            }

            catch (Exception e)
            {
                keepalive = false;
                f.Invoke(showCanConnectcallback,2);

                CloseSocket();

                //2021年5月21日11:39:14
                Main.ClearMemory();

                Thread.CurrentThread.Abort();
                GC.Collect();
                LogClass.WriteLogFile("接收信息出现异常！" + e.Message);

                
            }


        }
        /// <summary>
        /// 4.放入线程池中处理具体函数的操作
        /// 具体包括：1）解析完成每一部分操作；2）将解析完成之后的数据送到控件进行画图；3）送到控件相应位置进行显示；4）存储数据库
        /// </summary>
        /// <param name="tempMessage"></param>
        private void DealMessage(object tempMessage)
        {
            string message = tempMessage.ToString();

            string srcId = null;//新增数据采集器的ID编号

            string strProtocolID = null;//协议编号
            string strProtocolName = null;//协议名字
            string strNumber = null;//包编号
            string strTime = null;//时间戳
            string strLength = null;//包体长度
            string strCRC = null;//校验和
            /**以上定义的是协议部分中的相关信息截取**/

            string sqlError = null;//将错误信息存储数据库的SQL语句
            string strCollectDate = null;//时间戳按照格式要求变换成“2017-05-02 13:38:15”格式,采集时间
            UInt32 packageNumber = 0;

            string chMark = null;
            string chFlag = null;

            try
            {
                //解析任何信息之前，先将所有的公有信息提取出来
                srcId = message.Substring(4,4);//数据采集器的ID编号为0001
                strProtocolID = message.Substring(8, 4);
                strTime = message.Substring(12, 46);
                strNumber = message.Substring(58, 8);
                strLength = message.Substring(66, 8);
                packageNumber = Convert.ToUInt32(strNumber, 16);//将包编号转换成对应的十六进制数

                if (message.Length < 104)//1.判断整个包体长度是否符合要求
                {
                    DateTime dt = DateTime.Now;
                    sqlError = "insert into seafloor_srcErrorMesg (srcId,saveDate,errorProtocol) values('"+srcId+"','" + dt + "','" + message + "')";
                    SqlHelper.ExecuteNonQuery(sqlError);
                    return;
                }
                else//包体长度正确，依次往下判断
                {
                    strCRC = message.Substring(0, 4) + message.Substring(100, 4);
                    UInt32 CRCvalue1 = CRC32.GetCrc32(StrToHexByte(strCRC));//实际计算的CRC32校验值
                    UInt32 CRCvalue2 = Convert.ToUInt32(message.Substring(74, 8), 16);//给定的CRC32校验值

                    if (CRCvalue1 != CRCvalue2)//2.判断校验值是否正确，校验值直接结束
                    {
                        DateTime dt = DateTime.Now;
                        sqlError = "insert into seafloor_srcErrorMesg (srcId,saveDate,errorProtocol) values('" + srcId + "','" + dt + "','" + message + "')";
                        SqlHelper.ExecuteNonQuery(sqlError);

                        Main.ClearMemory();

                        GC.Collect();
                        Thread.CurrentThread.Abort();//结束当前线程

                        //2021年5月21日11:39:41 清空内存新方式
                        //Main.ClearMemory();

                        return;
                    }
                    else//校验和正确，往下执行
                    {
                        //3.解析时间，判断时间是否存在乱码
                        string Time = System.Text.Encoding.ASCII.GetString(StrToHexByte(strTime));//将字节流中信息（十六进制ASCII码）转换成对应的字符
                        string expTime = "^\\d{4}(:\\d{2}){5}:\\d{3}$";//时间正则表达式

                        if (!QuickValidate(expTime, Time))//时间格式错误，直接返回
                        {
                            DateTime dt = DateTime.Now;
                            sqlError = "insert into seafloor_srcErrorMesg (srcId,saveDate,errorProtocol) values('" + srcId + "','" + dt + "','" + message + "')";
                            SqlHelper.ExecuteNonQuery(sqlError);

                            Main.ClearMemory();

                            GC.Collect();
                            Thread.CurrentThread.Abort();//结束当前线程

                            //2021年5月21日11:40:03清空内存新方式
                           // Main.ClearMemory();

                            return;
                        }
                        else//时间格式正确，继续往下执行
                        {

                            string dataTime = dealTime(Time);

                            char separator = ':';
                            string[] splitStrings = new string[7];
                            splitStrings = Time.Split(separator);
                            strCollectDate = splitStrings[0] + "-" + splitStrings[1] + "-" + splitStrings[2] + " " + splitStrings[3] + ":" + splitStrings[4] + ":" + splitStrings[5];

                            //4.解析包体长度
                            string expLength = "^[\\d|a-f|A-F]{8}$";//包体长度正则表达式
                            if (!QuickValidate(expLength, strLength))//包体长度不匹配的话,返回结束
                            {
                                DateTime dt = DateTime.Now;
                                sqlError = "insert into seafloor_srcErrorMesg (srcId,saveDate,errorProtocol) values('" + srcId + "','" + dt + "','" + message + "')";
                                SqlHelper.ExecuteNonQuery(sqlError);

                                Main.ClearMemory();


                                GC.Collect();
                                Thread.CurrentThread.Abort();//结束当前线程

                               // Main.ClearMemory();

                                return;
                            }
                            else
                            {
                                UInt32 length = Convert.ToUInt32(strLength, 16);//协议中给定的长度（字符串转换成对应的十六进制数）
                                if (length != message.Length / 2)//包体长度与实际长度不一致，结束返回
                                {
                                    DateTime dt = DateTime.Now;
                                    sqlError = "insert into seafloor_srcErrorMesg (srcId,saveDate,errorProtocol) values('" + srcId + "','" + dt + "','" + message + "')";
                                    SqlHelper.ExecuteNonQuery(sqlError);

                                    Main.ClearMemory();

                                    GC.Collect();
                                    Thread.CurrentThread.Abort();//结束当前线程

                                   // Main.ClearMemory();

                                    return;
                                }
                                else//包体长度正确，将剩余信息解析出来
                                {
                                    //5.依据协议编号，从数据库中解析出协议名字
                                    strProtocolName = GetKeyValue(strProtocolID);


                                    /*此处添加通道发送个数增加显示*/
                                    chMark = message.Substring(10, 1);//哪个通道发来的标识
                                    chFlag = message.Substring(10, 2);

                                    if (chMark == "1" || chFlag == "01")
                                    {
                                        s1++;
                                    }
                                    else if (chMark == "2" || chFlag == "02")
                                    {
                                        s2++;
                                    }
                                    else if (chMark == "3" || chFlag == "03")
                                    {
                                        s3++;
                                    }
                                    else if (chMark == "4" || chFlag == "04")
                                    {
                                        s4++;
                                    }
                                    else if (chMark == "5" || chFlag == "05")
                                    {
                                        s5++;
                                    }

                                    sum = s1 + s2 + s3 + s4 + s5;

                                    //将通道个数送入主界面进行显示
                                    f.Invoke(showChNumcallback, null);


                                    if (strProtocolName == null)//数据库中没有该协议编号，返回结束
                                    {
                                        DateTime dt = DateTime.Now;
                                        sqlError = "insert into seafloor_srcErrorMesg (srcId,saveDate,errorProtocol) values('" + srcId + "','" + dt + "','" + message + "')";
                                        SqlHelper.ExecuteNonQuery(sqlError);

                                        Main.ClearMemory();

                                        GC.Collect();
                                        Thread.CurrentThread.Abort();//结束当前线程

                                        //Main.ClearMemory();

                                        return;
                                    }
                                    else//按照不同的协议类型进行数据解析
                                    {
                                        switch (message.Substring(8, 2))
                                        {
                                            case "00":

                                                dealSensorMessage(srcId, strProtocolID, message, strProtocolName, message.Length / 2, packageNumber, strCollectDate);
                                                break;

                                            case "20":

                                                dealCabinMessage(srcId,message, strProtocolName, packageNumber, strCollectDate);
                                                break;

                                            case "40":

                                                string faultTime = dealFaultTime(dataTime);
                                                string protocolHeadFault = "55AA11110001" + faultTime + strNumber + "00000059" + "01" + "00000000" + "00000000";//上传故障服务器的协议头

                                                dealFaultMessage(srcId,message, strProtocolID, strProtocolName, packageNumber, strCollectDate, protocolHeadFault, faultTime);
                                                break;
                                        }
                                    }
                                }
                            }

                        }

                    }
                }

                Main.ClearMemory();
            }
            catch (Exception exp)
            {
                Main.ClearMemory();
                GC.Collect();
                Thread.CurrentThread.Abort();//结束当前线程

                LogClass.WriteLogFile("解析下位机数据时出现错误！" + "原始信息包：" + message + "异常信息：" + exp.Message);

                
            }
        }
        /// <summary>
        /// 4.1具体解析传感器信息函数
        /// </summary>
        /// <param name="message"></param>原始信息
        /// <param name="strProtocolName"></param>协议名字
        /// <param name="tempLength"></param>包体长度
        /// <param name="packageNumber"></param>包编号
        /// <param name="strCollectDate"></param>时间格式转换完成之后的采集时间
        private void dealSensorMessage(string srcId,string deviceId,string message, string strProtocolName, int tempLength, UInt32 packageNumber, string strCollectDate)
        {
            string sensorType = strProtocolName;//传感器类型
            string sensorOnlyData = null;//传感器纯数值
            string sensorContentData = null;//带单位的传感器数据
            string sensorContentID = null;//传感器ID
            string strSensorContent = null;//字串中完整的传感器包
            string sensorContent = null;//将传感器包转换成ASCII码对应的字符
            DateTime? collectTime1 = Convert.ToDateTime(null);//溶解氧单独的采集时间(不止溶解氧采集时间，所有传感器的采集时间)

            string strFrequency = null;//溶解氧频率
            string strTemperature = null;//溶解氧温度

            int Fre = 0;//存储溶解氧原始频率（下位机发来）

            //2018-04-08新增变量
            string value1 = null;//安德拉溶解氧浓度绝对值
            string value2 = null;//浓度百分比
            string value3 = null;//温度值

            //CTD传感器有四个参数，所以增添另外三个
            string collectdata2 = null;
            //double temp = Convert.ToDouble(collectdata2);
            string collectdata3 = null;
            string collectdata4 = null;

            try
            {
                if (message.Length >= (2 * tempLength - 2))
                {
                    strSensorContent = message.Substring(104, 2 * tempLength - 106);

                    if (strSensorContent.Length > 2)
                    {
                        if (sensorType == "山仪所溶解氧")//以下程序为解析山仪所溶解氧的程序
                        {
                            strSensorContent = message.Substring(104, 2 * tempLength - 106);//传感器信息完整部分截取
                            sensorContent = System.Text.Encoding.ASCII.GetString(StrToHexByte(strSensorContent));//原始信息包

                            ////1.解析溶解氧采集时间
                            //string DOYear = System.Text.Encoding.ASCII.GetString(StrToHexByte(strSensorContent.Substring(2, 8)));
                            //string DOMonth = System.Text.Encoding.ASCII.GetString(StrToHexByte(strSensorContent.Substring(10, 4)));
                            //string DODay = System.Text.Encoding.ASCII.GetString(StrToHexByte(strSensorContent.Substring(14, 4)));
                            //string DOHour = System.Text.Encoding.ASCII.GetString(StrToHexByte(strSensorContent.Substring(18, 4)));
                            //string DOMin = System.Text.Encoding.ASCII.GetString(StrToHexByte(strSensorContent.Substring(22, 4)));
                            //string DOSec = System.Text.Encoding.ASCII.GetString(StrToHexByte(strSensorContent.Substring(26, 4)));

                            string collectTime = strCollectDate;
                                //DOYear + "-" + DOMonth + "-" + DODay + " " + DOHour + ":" + DOMin + ":" + DOSec;
                            collectTime1 = Convert.ToDateTime(collectTime);

                            ////4.解析溶解温度
                            //strTemperature = System.Text.Encoding.ASCII.GetString(StrToHexByte(strSensorContent.Substring(56, 8))).Trim();//溶解氧温度

                            //strFrequency = System.Text.Encoding.ASCII.GetString(StrToHexByte(strSensorContent.Substring(32, 8)));

                            //Fre = Convert.ToInt32(strFrequency);//存储下位机发送上来的原始频率

                            //int tempFrequency = Convert.ToInt32(strFrequency);//此时tempFrequency与Fre一样存储的是下位机发送的原始频率

                            ////剔除频率小值
                            //if ((tempFrequency < 3200) && (flag == 0))
                            //{
                            //    tempFrequency = 3980;
                            //}
                            //else if (tempFrequency < 3200)
                            //{
                            //    tempFrequency = intFrequency;
                            //}

                            ////前20次频率，只要不是一个小于3200的频率，都会参与到实际运算中

                            //if (flag > 19)
                            //{
                            //    if ((Math.Abs(tempFrequency - intFrequency) <= 100) && (Fre > 3200))//频率与上一次平滑之后的频率差别较小，实际采样频率可用  // 前20次不参与频率差异比较，只要是个好值，都将真实频率参与平滑-溶解氧改变极限情况2018-05-09
                            //    {
                            //        tempFrequency = Fre;//原始频率赋给tempFrequency，后面平滑使用tempFrequency
                            //    }
                            //    else
                            //        tempFrequency = intFrequency;
                            //}


                            //if (flag == 0)
                            //{
                            //    for (int i = 0; i <= 3; i++)
                            //    {
                            //        buffer[i] = tempFrequency;
                            //    }

                            //    flag++;
                            //}
                            //else
                            //{
                            //    buffer[0] = intFrequency;
                            //    for (int j = 3; j > 0; j--)
                            //    {
                            //        buffer[j] = buffer[j - 1];
                            //    }
                            //    flag++;
                            //}


                            //intFrequency = Convert.ToInt32(0.4 * tempFrequency + 0.3 * buffer[1] + 0.2 * buffer[2] + 0.1 * buffer[3]);//平滑频率加入权值计算

                            double density = 0;//最终公式计算得到的浓度值

                            density = Convert.ToDouble(sensorContent.Substring(5, 5));
                            //if (ReadDOFormula() == 1)//读取配置文件，配置文件中number是1，则采用公式1分段公式，若number是2则采用不分段公式，系数全部由陪值文件中读取
                            //{
                            //    //公式1-对应2号筒子,分段情况
                            //    if (intFrequency < 3933)
                            //    {
                            //        density = 4.3970 * 0.00000001 * intFrequency * intFrequency * intFrequency - 4.4138 * 0.0001 * intFrequency * intFrequency + 1.48 * intFrequency - 1657.4;
                            //    }
                            //    else
                            //    {
                            //        double dTemp = Convert.ToDouble(strTemperature);
                            //        double C_t = 0.001004800474098 * dTemp * dTemp - 0.019594199644525 * dTemp + 1.047149014757149;//与温度相关的一个系数
                            //        density = 8.409198 * 0.0000001 * intFrequency * intFrequency * intFrequency - 0.01008224 * intFrequency * intFrequency + 40.30929 * intFrequency - 53727.95;
                            //        density = C_t * density;
                            //    }
                            //}
                            //else
                            //{
                            //    // 暂时注释-公式2 
                            //    //density = 1.629715583535520 * 0.00000001 * intFrequency * intFrequency * intFrequency - 0.0001 * 1.576926444273443 * intFrequency * intFrequency + 0.513171543893112 * intFrequency - 561.8478475121085;
                            //    DataSet ds = new DataSet();
                            //    ds.ReadXml(@".\Formula.xml");

                            //    double c1 = Convert.ToDouble(ds.Tables[0].Rows[0]["coefficient1"].ToString());

                            //    double c2 = Convert.ToDouble(ds.Tables[0].Rows[0]["coefficient2"].ToString());

                            //    double c3 = Convert.ToDouble(ds.Tables[0].Rows[0]["coefficient3"].ToString());

                            //    double c4 = Convert.ToDouble(ds.Tables[0].Rows[0]["coefficient4"].ToString());

                            //    density = c1 * intFrequency * intFrequency * intFrequency + c2 * intFrequency * intFrequency + c3 * intFrequency + c4;

                            //}






                            //3.解析溶解氧浓度
                            sensorOnlyData = density.ToString("00.00");
                            sensorContentData = density.ToString("00.00");

                            //如果是符合要求的正确的溶解氧数据则存入sensordata数据表中
                            DateTime dt = DateTime.Now;
                            string sql = "insert into seafloor_srcSensorData (srcId,deviceId,sensorType,collectData,collectDate,saveDate,collectRawInfo,sensorRawInfo,pkgNum,isDelete) values('" + srcId + "','" + deviceId + "','" + sensorType + "','" + sensorContentData + "','" + collectTime1 + "','" + dt + "','" + message + "','" + sensorContent + "','" + packageNumber + "','0')";//包编号存入数据库
                            SqlHelper.ExecuteNonQuery(sql);



                        }

                        else if (sensorType == "PH")
                        {
                            strSensorContent = message.Substring(104, 2 * tempLength - 106);//获取有用部分的传感器信息-----即仪器自身上传上来的纯粹传感器协议部分

                            if (strSensorContent.EndsWith("0D0A"))
                            {
                                sensorContent = System.Text.Encoding.ASCII.GetString(StrToHexByte(strSensorContent));

                                string strN = sensorContent.Substring(0, 5);//获取原始传感器输出的字符串

                                int digits = Convert.ToInt32(strN);//PH传感器输出的数字量部分

                                //计算PH传感器需要温度，此温度值读取道万CTD测得的温度值
                                double temperature = Convert.ToDouble(draw.arrayCTD_TValue[draw.arrayCTD_TValue.Count - 1]);//读取CTD最新的温度数据作为计算ph值的温度数据,水德PH传感器本身不带有温度传感器

                                double f_T = 1.0732 - 0.0039093 * temperature + 0.000012333 * temperature * temperature;


                                string sql_co = "select a0,a1 from programconfig";
                                DataTable dt_Table = SqlHelper.ExecuteDataTable(sql_co);


                                double a0 = Convert.ToDouble(dt_Table.Rows[0]["a0"]);
                                double a1 = Convert.ToDouble(dt_Table.Rows[0]["a1"]);


                                double pH = f_T * (digits - a0) / a1 + 7;//最终计算得到的PH数值
                          
                                sensorContentData = pH.ToString("0.000");
                                collectTime1 = Convert.ToDateTime(strCollectDate);

                                //如果是正确的符合要求的PH传感器数据，则存入数据表sensordata中
                                DateTime dt = DateTime.Now;
                                string sql = "insert into seafloor_srcSensorData (srcId,deviceId,sensorType,collectData,collectDate,saveDate,collectRawInfo,sensorRawInfo,pkgNum,isDelete) values('" + srcId + "','" + deviceId + "','" + sensorType + "','" + sensorContentData + "','" + collectTime1 + "','" + dt + "','" + message + "','" + sensorContent + "','" + packageNumber + "','0')";//包编号存入数据库
                                SqlHelper.ExecuteNonQuery(sql);

                            }
                            else//不符合安德拉溶解氧协议格式的存入错误信息表中
                            {
                                andelaflag = 1;//安德拉数据解析出现错误
                                DateTime dt0 = DateTime.Now;
                                string sql0 = "insert into seafloor_srcErrorMesg (srcId,saveDate,errorProtocol) values('" + srcId + "','" + dt0 + "','" + message + "')";
                                SqlHelper.ExecuteNonQuery(sql0);
                            }

                        }
                        else if (sensorType == "CTD")//发送过来的为CTD数据
                        {
                            strSensorContent = message.Substring(104, 2 * tempLength - 106);
                            if ((strSensorContent.StartsWith("24") && strSensorContent.EndsWith("0D0A")) || (strSensorContent.StartsWith("43") && strSensorContent.EndsWith("0A0A")))
                            {
                                sensorContent = System.Text.Encoding.ASCII.GetString(StrToHexByte(strSensorContent));//将传感器自身协议部分对应的十六进制ASCII码转成对应的字符串形式

                                string[] sArray = Regex.Split(strSensorContent, "20", RegexOptions.IgnoreCase);

                                //string temp = sArray[0].Substring(2,sArray[0].Length-2);

                                double conductance1 = Convert.ToDouble(System.Text.Encoding.ASCII.GetString(StrToHexByte(sArray[7].Substring(4, sArray[7].Length - 10))));//电导率
                                double temperature = Convert.ToDouble(System.Text.Encoding.ASCII.GetString(StrToHexByte(sArray[0].Substring(6, sArray[0].Length - 6))));//温度
                                double pressure_kpa = Convert.ToDouble(System.Text.Encoding.ASCII.GetString(StrToHexByte(sArray[4].Substring(4, sArray[4].Length - 6))));//压力，单位是kpa
                              //  double pressure_dbar = pressure_kpa * 0.1;//转换成另一种压力单位分巴，以前贺工的CTD传感器的压力单位为Kpa
                                
                                double pressure_dbar = pressure_kpa;//道万CTD上传上来的压力数据的单位就是分巴

                                //1.利用获取到的压力求解深度
                                // double x = Math.Sin(Math.PI*0.00291);




                                double x = Math.Sin(latitude / 57.29578);//纬度选用30度,//将选用的纬度值存入数据库表格中，每次从表格中读取
                                x = x * x;

                                double GR = 9.780318 * (1.0 + (0.0052788 + 0.0000236 * x) * x) + 0.000001092 * pressure_dbar;
                                double depth = (((-0.00000000000000182 * pressure_dbar + 0.0000000002279) * pressure_dbar - 0.000022512) * pressure_dbar + 9.72659) * pressure_dbar;

                                depth = depth / GR;

                                if (depth < 0)
                                    depth = 0;//如果深度小于0，那么将深度置为0

                                //2.求取盐度公式(利用读取上来的数据，电导率，温度，压力求取最终的盐度)
                                double DT = temperature - 15;
                                double conductance = conductance1 / 42.914;

                                double Rt = conductance / (RT35(temperature) * (1.0 + C(pressure_dbar) / (B(temperature) + A(temperature) * conductance)));
                                Rt = Math.Sqrt(Math.Abs(Rt));
                                double salinity = SAL(Rt, DT);


                                //double salinity = Convert.ToDouble(System.Text.Encoding.ASCII.GetString(StrToHexByte(sArray[3].Substring(2, sArray[3].Length - 6))));//盐度值

                                sensorContentData = conductance1.ToString("00.00");//电导率，小数点后保留3位
                                collectdata2 = temperature.ToString("00.00");//温度，小数点后保留3位
                                collectdata3 = depth.ToString("00.00");//深度，小数点后保留两位
                                collectdata4 = salinity.ToString("00.00");//盐度，小数点后保留4位

                                collectTime1 = Convert.ToDateTime(strCollectDate);//采集时间


                                //将正确的符合要求的CTD数据存入数据表sensordata中
                                DateTime dt = DateTime.Now;
                                string sql = "insert into seafloor_srcSensorData (srcId,deviceId,sensorType,collectData,collectData1,collectData2,collectData3,collectDate,saveDate,collectRawInfo,sensorRawInfo,pkgNum,isDelete) values('"+srcId+"','"+deviceId+"','" + sensorType + "','" + sensorContentData + "','" + collectdata2 + "','" + collectdata3 + "','" + collectdata4 + "','" + collectTime1 + "','" + dt + "','"+message+"','" + sensorContent + "','" + packageNumber + "','0')";//包编号存入数据库
                                SqlHelper.ExecuteNonQuery(sql);


                            }
                            else//不符合协议要求的存入错误信息表中
                            {
                                ctdflag = 1;//ctd数据解析出现错误
                                DateTime dt0 = DateTime.Now;
                                string sql0 = "insert into seafloor_srcErrorMesg (srcId,saveDate,errorProtocol) values('" + srcId + "','" + dt0 + "','" + message + "')";
                                SqlHelper.ExecuteNonQuery(sql0);
                            }
                        }
                        else if (sensorType == "叶绿素浊度")
                        {
                            strSensorContent = message.Substring(104, 2 * tempLength - 106);

                            sensorContent = System.Text.Encoding.ASCII.GetString(StrToHexByte(strSensorContent));//原始信息包

                            //使用正则表达式形式解析叶绿素浊度传感器数据

                            if(sensorContent.StartsWith("&A102"))
                            {
                                Regex reg = new Regex("(\\&)A102(\\@)(?<key1>.*?),(?<key2>.*?),(?<key3>.*?)(\r)", RegexOptions.None);//写好的正则表达式
                                Match match = reg.Match(sensorContent);
                                collectTime1 = Convert.ToDateTime(strCollectDate);//采集时间

                                DateTime dt = DateTime.Now;
                                string sql = "insert into seafloor_srcSensorData (srcId,deviceId,sensorType,collectData,collectData1,collectData2,collectDate,saveDate,collectRawInfo,sensorRawInfo,pkgNum,isDelete) values('" + srcId + "','" + deviceId + "','" + sensorType + "','" + match.Groups["key1"].Value + "','" + match.Groups["key2"].Value + "','" + match.Groups["key3"].Value + "','" + collectTime1 + "','" + dt + "','" + message + "','" + sensorContent + "','" + packageNumber + "','0')";//包编号存入数据库
                                SqlHelper.ExecuteNonQuery(sql);



                                double chl = Convert.ToDouble(match.Groups["key1"].Value);//叶绿素数据
                                double tur = Convert.ToDouble(match.Groups["key2"].Value);//浊度数据
                                double phy = Convert.ToDouble(match.Groups["key3"].Value);//叶绿素浊度传感器获取的温度数据

                                if (Main.draw1000SensorFlag == 1)
                                {


                                    draw.arrayChlValue.Add(chl.ToString("000.00"));
                                    draw.arrayTurValue.Add(tur.ToString("000.00"));
                                    draw.arrayCTTemp.Add(phy);

                                    draw.arrayChlTurDate.Add(collectTime1.ToString());

                                    lock (lockMultiPara)//添加画图的锁
                                    {
                                        drawExpMultiPara.refreshDrawMultiDataArray(collectTime1.ToString(), Convert.ToDouble(chl), Convert.ToDouble(tur), Convert.ToDouble(phy), 2, f.picMultiPara);

                                    }


                                    f.Invoke(showSensorMessagecallback, 4, chl.ToString(), tur.ToString(), phy.ToString(), collectTime1);//将多参数传感器的数据显示到界面上
                                    f.Invoke(showSensorFaultcallback, "叶绿素(μg/L)", chl.ToString(), collectTime1, 13);//将多参数传感器的数值送到数据采集器首页采集值表格中进行显示
                                    f.Invoke(showSensorFaultcallback, "浊度(μg/L)", tur.ToString(), collectTime1, 14);
                                    f.Invoke(showSensorFaultcallback, "温度(℃)", phy.ToString(), collectTime1, 15);
                                }

                            }

                        }
                        else//如果都不是上述传感器，说明上传的信息为错误信息存入错误信息表中
                        {
                            DateTime dt0 = DateTime.Now;
                            string sql0 = "insert into seafloor_srcErrorMesg (srcId,saveDate,errorProtocol) values('" + srcId + "','" + dt0 + "','" + message + "')";
                            SqlHelper.ExecuteNonQuery(sql0);
                        }


                        switch (sensorType)
                        {
                            case "山仪所溶解氧":

                                //现在所有传感器数据共同存放在一个数据库表格中，并没有为每一种单独的传感器创建表格
                                //DateTime dt1 = DateTime.Now;
                                //string sql1 = "insert into sensordatado (serial,collectdata,collectdate,savedate,collectrawinfo,temperature,frequency,truefrequency,platname) values('1','" + sensorContentData + "','" + collectTime1 + "','" + dt1 + "','" + message + "','" + strTemperature + "','" + intFrequency + "','" + Fre + "','山仪所溶解氧(mg/L)')";
                                //SqlHelper.ExecuteNonQuery(sql1);

                                /************************补充完成画图，送界面显示************************/
                                if (Main.draw1000SensorFlag == 1)
                                {
                                    draw.arrayDOValue.Add(sensorContentData);
                                    draw.arrayDODate.Add(collectTime1.ToString());
                                    lock (lockDO)
                                    {
                                        drawExpDO.refreshDrawDataArray(collectTime1.ToString(), Convert.ToDouble(sensorContentData), 1, f.picDO);
                                    }
                                }
                                f.Invoke(showSensorMessagecallback, 1, sensorContentData, null,null,collectTime1);//山仪所溶解氧采集值显示在传感器信息页上面

                                f.Invoke(showSensorFaultcallback, "山仪所溶解氧(mg/L)", sensorContentData, collectTime1, 12);//补充收到的新数据填充到数据采集器页采集值表格

                                break;
                            case "PH":

                                if(andelaflag == 0)
                                {
                                    //现在没有给每个传感器单独建立一个数据库表格
                                    //DateTime dt2 = DateTime.Now;
                                    //string sql2 = "insert into sensordataandela(serial,absolute,percent,temp,collectdata,collectdate,savedate,collectrawinfo,platname) values('1','" + value1 + "','" + value2 + "','" + value3 + "','" + sensorContentData + "','" + collectTime1 + "','" + dt2 + "','" + message + "','安德拉溶解氧(mg/L)')";
                                    //SqlHelper.ExecuteNonQuery(sql2);

                                    /**********安德拉溶解氧浓度值画图待完成************/
                                    if (Main.draw1000SensorFlag == 1)
                                    {
                                        draw.arrayADLValue.Add(sensorContentData);
                                        draw.arrayADLDate.Add(collectTime1.ToString());

                                        lock (lockADL)
                                        {
                                            drawExpADL.refreshDrawDataArray(collectTime1.ToString(), Convert.ToDouble(sensorContentData), 9, f.picPH);
                                        }

                                    }

                                    f.Invoke(showSensorMessagecallback, 2, sensorContentData, null, null, collectTime1);//计算得到的PH数值采集值显示在传感器信息页上面

                                    f.Invoke(showSensorFaultcallback, "PH", sensorContentData, collectTime1, 5);//将收到的数据更新到数据采集器1采集值表格里面
                                
                                }
                                andelaflag = 0;
                                break;
                            case "CTD":
                                if (ctdflag == 0)
                                {
                                    //DateTime dt3 = DateTime.Now;
                                    //string sql3 = "insert into sensordatactd(serial,conductance,temperature,depth,salinity,collectdate,savedate,collectrawinfo,platname1,platname2,platname3,platname4) values('1','" + sensorContentData + "','" + collectdata2 + "','" + collectdata3 + "','" + collectdata4 + "','" + collectTime1 + "','" + dt3 + "','" + message + "','CTD-电导率(mS/cm)','CTD-温度(℃)','CTD-深度(m)','CTD-盐度') ";
                                    //SqlHelper.ExecuteNonQuery(sql3);


                                    if (Main.draw1000SensorFlag == 1)
                                    {
                                        draw.arrayCTD_CValue.Add(sensorContentData);
                                        draw.arrayCTD_TValue.Add(collectdata2);
                                        draw.arrayCTD_DValue.Add(collectdata3);
                                        draw.arrayCTD_SValue.Add(collectdata4);
                                        draw.arrayCTDDate.Add(collectTime1.ToString());

                                        lock (lockCTD)
                                        {
                                            drawExpCTD.refreshDrawCTDDataArray(collectTime1.ToString(), Convert.ToDouble(sensorContentData), Convert.ToDouble(collectdata2), Convert.ToDouble(collectdata3), Convert.ToDouble(collectdata4), 5, f.picCTD);
                                        }

                                    }

                                    f.Invoke(showSensorMessagecallback, 3, collectdata2, collectdata3, collectdata4, collectTime1);
                                    f.Invoke(showSensorFaultcallback, "CTD-电导率(mS/cm)", sensorContentData, collectTime1, 1);//CTD-电导率更新
                                    f.Invoke(showSensorFaultcallback, "CTD-温度(℃)", collectdata2, collectTime1, 2);
                                    f.Invoke(showSensorFaultcallback, "CTD-深度(m)", collectdata3, collectTime1, 3);
                                    f.Invoke(showSensorFaultcallback, "CTD-盐度", collectdata4, collectTime1, 4);

                                }
                                ctdflag = 0;
                                break;
                            case "多参数":
                               // DateTime dt4 = DateTime.Now;
                                break;

                        }


                    }

                    else
                    {
                        DateTime dt0 = DateTime.Now;
                        string sql0 = "insert into errorprotocol (savedate,errorprotocol) values('" + dt0 + "','" + message + "')";
                        SqlHelper.ExecuteNonQuery(sql0);
                    }


                }
                else//不符合要求的错误信息存入错误信息表中
                {
                    DateTime dt0 = DateTime.Now;
                    string sql0 = "insert into errorprotocol (savedate,errorprotocol) values('" + dt0 + "','" + message + "')";
                    SqlHelper.ExecuteNonQuery(sql0);
                }






            }
            catch (Exception exp)
            {

                string exception = "解析数据采集器1下位机传感器数据程序出现异常:" + exp.Message + "接收到的内容:" + message;

                LogClass.WriteLogFile(exception);
            }

        }

        /// <summary>
        /// 1.求取CTD盐度公式中所用的第一个过度公式
        /// </summary>
        /// <param name="XT"></param>
        /// <returns></returns>
        private double RT35(double XT)
        {
            double RT35= 0;
            RT35 = (((0.0000000010031 * XT - 0.00000069698) * XT + 0.0001104259)*XT+0.0200564)*XT+0.6766097;
            return RT35;
        }
        /// <summary>
        /// 2.求取CTD盐度公式中第2个过度公式
        /// </summary>
        /// <param name="xp"></param>
        /// <returns></returns>
        private double C(double XP)
        {
            double C = 0;
            C = ((0.000000000000003989 * XP - 0.000000000637) * XP + 0.0000207) * XP;
            return C;
        }
        /// <summary>
        /// 3.求取CTD盐度公式中第3个过度公式
        /// </summary>
        /// <param name="XT"></param>
        /// <returns></returns>
        private double B(double XT)
        {
            double B = 0;
            B = (0.0004464 * XT + 0.03426) * XT + 1.0;
            return B;
        }
        /// <summary>
        /// 4.求取CTD盐度公式中第4个过度公式
        /// </summary>
        /// <param name="XT"></param>
        /// <returns></returns>
        private double A(double XT)
        {
            double A = 0;
            A = -0.003107 * XT + 0.4215;
            return A;
        }
        /// <summary>
        /// 5.求取CTD盐度公式中第5个过度公式
        /// </summary>
        /// <param name="XR"></param>
        /// <param name="XT"></param>
        /// <returns></returns>
        private double SAL(double XR,double XT)
        {
            double SAL = 0;
            SAL = ((((2.7081 * XR - 7.0261) * XR + 14.0941) * XR + 25.3851) * XR - 0.1692) * XR + 0.0080 + (XT / (1.0 + 0.0162 * XT)) * (((((-0.0144 * XR + 0.0636) * XR - 0.0375) * XR - 0.0066) * XR - 0.0056) * XR + 0.0005);
            return SAL;
        }

        /// <summary>
        /// 4.2具体解析舱内电参数温度等状态数据
        /// </summary>
        /// <param name="message"></param>原始信息串
        /// <param name="strProtocolName"></param>协议名字
        /// <param name="packageNumber"></param>包编号
        /// <param name="strCollectDate"></param>按照时间格式要求转换完成的采集时间
        private void dealCabinMessage(string srcId,string message, string strProtocolName, UInt32 packageNumber, string strCollectDate)
        {
            try
            {
                if ((message.Length == 134) || (message.Length == 120))
                {
                    if ((message.Substring(10, 2) == "10") || (message.Substring(10, 2) == "20") || (message.Substring(10, 2) == "30") || (message.Substring(10, 2) == "40") || (message.Substring(10, 2) == "50"))//电参数的解析
                    {
                        string sensorType = strProtocolName;
                        string sensorCurrent = "-1";//解析不正确就将-1存入数据库
                        string sensorVol = "-1";
                        string sensorPower = "-1";
                        double current = 0;
                        double vol = 0;
                        string sqlElectrical = null;//存入电参数表的SQL语句
                        string strSensorCurrent = message.Substring(104, 14);
                        string strSensorVol = message.Substring(118, 14);

                        // showTime = strCollectDate;//额外添加，回调函数中需要使用

                        if (strSensorCurrent.StartsWith("43"))
                        {
                            sensorCurrent = System.Text.Encoding.ASCII.GetString(StrToHexByte(message.Substring(106, 12)));
                            current = Convert.ToDouble(sensorCurrent);

                            //额外添加
                            //showCur = sensorCurrent;

                        }
                        if (strSensorVol.StartsWith("56"))
                        {
                            sensorVol = System.Text.Encoding.ASCII.GetString(StrToHexByte(message.Substring(120, 12)));
                            vol = Convert.ToDouble(sensorVol);


                            sensorPower = (current * vol).ToString("f3");
                            //额外添加，回调函数使用
                            //showVol = sensorVol;
                            // showPower = sensorPower;


                        }

                        //基本信息解析完成，信息存数据库并在界面显示
                        DateTime dt = DateTime.Now;
                        sqlElectrical = "insert into seafloor_srcElecData (srcId,statusType,current,voltage,power,saveDate,collectDate,collectRawInfo,pkgNum,isDelete) values ('"+srcId+"','" + sensorType + "','" + sensorCurrent + "','" + sensorVol + "','" + sensorPower + "','" + dt + "','" + strCollectDate + "','" + message + "','" + packageNumber + "','0')";//将包编号信息存入所有传感器电参数表格
                        SqlHelper.ExecuteNonQuery(sqlElectrical);

                        switch (sensorType)
                        {
                            case "通道1电参数":
                                //DateTime dt1 = DateTime.Now;
                                //sqlElectrical = "insert into sensorelectricaldo (sensortype,current,voltage,power,savetime,collecttime) values ('" + sensorType + "','" + sensorCurrent + "','" + sensorVol + "','" + sensorPower + "','" + dt1 + "','" + strCollectDate + "')";
                                //SqlHelper.ExecuteNonQuery(sqlElectrical);

                                /**后面待补充送界面显示(送入界面响应位置显示，使用委托实现直接送界面)，以及画图**/
                                // showElectricalcallback = new delShowElectrical(ShowElectricalMethod);

                                DOCur = sensorCurrent;
                                DOVol = sensorVol;
                                DOPower = sensorPower;
                                DOTime = strCollectDate;

                                f.Invoke(showElectricalcallback, 1);//委托显示


                                ////将相应数据存储到数组中，方便后面图上label显示
                                //draw.arrayCurrentDO.Add(sensorCurrent);
                                //draw.arrayVoltageDO.Add(sensorVol);
                                //draw.arrayStatusSaveDateDO.Add(Convert.ToDateTime(strCollectDate).ToString());
                                

                                //将最新获取的电压数据加入到动态数组中
                                draw.arrayDCCh1Vol.Add(DOVol);
                                draw.arrayDCCh1Cur.Add(DOCur);


                                //lock (lockDOE)
                                //{
                                //    // f.Invoke(showElectricalcallback, 1);//委托显示
                                //    drawExp6.refreshDrawElectricalArray(dt1.ToString(), Convert.ToDouble(sensorCurrent), Convert.ToDouble(sensorVol), 6, f);//动态画状态图1，加锁
                                //}
                                break;
                            case "通道2电参数":
                                //DateTime dt2 = DateTime.Now;
                                //sqlElectrical = "insert into sensorelectricaljw (sensortype,current,voltage,power,savetime,collecttime) values ('" + sensorType + "','" + sensorCurrent + "','" + sensorVol + "','" + sensorPower + "','" + dt2 + "','" + strCollectDate + "')";
                                //SqlHelper.ExecuteNonQuery(sqlElectrical);
                                /**后面待补充送界面显示(送入界面响应位置显示，使用委托实现直接送界面)，以及画图**/

                                JWCur = sensorCurrent;
                                JWVol = sensorVol;
                                JWPower = sensorPower;
                                JWTime = strCollectDate;

                                f.Invoke(showElectricalcallback, 2);//委托显示

                                //将相应数据存储到数组中，方便后面图上label显示
                                //draw.arrayCurrentJW.Add(sensorCurrent);
                                //draw.arrayVoltageJW.Add(sensorVol);
                                //draw.arrayStatusSaveDateJW.Add(Convert.ToDateTime(strCollectDate).ToString());

                                draw.arrayDCCh2Vol.Add(JWVol);//
                                draw.arrayDCCh2Cur.Add(JWCur);//

                                //lock (lockJWE)
                                //{
                                //    //f.Invoke(showElectricalcallback, 2);//委托显示
                                //    drawExp7.refreshDrawElectricalArray(dt2.ToString(), Convert.ToDouble(sensorCurrent), Convert.ToDouble(sensorVol), 7, f);//动态画状态图2，加锁
                                //}

                                break;
                            case "通道3电参数":
                                //DateTime dt3 = DateTime.Now;
                                //sqlElectrical = "insert into sensorelectricalyls (sensortype,current,voltage,power,savetime,collecttime) values ('" + sensorType + "','" + sensorCurrent + "','" + sensorVol + "','" + sensorPower + "','" + dt3 + "','" + strCollectDate + "')";
                                //SqlHelper.ExecuteNonQuery(sqlElectrical);
                                /**后面待补充送界面显示(送入界面响应位置显示，使用委托实现直接送界面)，以及画图**/

                                YLSCur = sensorCurrent;
                                YLSVol = sensorVol;
                                YLSPower = sensorPower;
                                YLSTime = strCollectDate;

                                f.Invoke(showElectricalcallback, 3);//委托显示

                                //draw.arrayCurrentYLS.Add(sensorCurrent);
                                //draw.arrayVoltageYLS.Add(sensorVol);
                                //draw.arrayStatusSaveDateYLS.Add(Convert.ToDateTime(strCollectDate).ToString());

                                draw.arrayDCCh3Vol.Add(YLSVol);
                                draw.arrayDCCh3Cur.Add(YLSCur);


                                //lock (lockYLSE)
                                //{
                                //    // f.Invoke(showElectricalcallback, 3);//委托显示
                                //    drawExp8.refreshDrawElectricalArray(dt3.ToString(), Convert.ToDouble(sensorCurrent), Convert.ToDouble(sensorVol), 8, f);//动态画状态图3，加锁
                                //}
                                break;
                            case "通道4电参数":
                                //DateTime dt4 = DateTime.Now;
                                //sqlElectrical = "insert into sensorelectricalzd (sensortype,current,voltage,power,savetime,collecttime) values ('" + sensorType + "','" + sensorCurrent + "','" + sensorVol + "','" + sensorPower + "','" + dt4 + "','" + strCollectDate + "')";
                                //SqlHelper.ExecuteNonQuery(sqlElectrical);
                                /**后面待补充送界面显示(送入界面响应位置显示，使用委托实现直接送界面)，以及画图**/

                                ZDCur = sensorCurrent;
                                ZDVol = sensorVol;
                                ZDPower = sensorPower;
                                ZDTime = strCollectDate;


                                f.Invoke(showElectricalcallback, 4);//委托显示

                                //draw.arrayCurrentZD.Add(sensorCurrent);
                                //draw.arrayVoltageZD.Add(sensorVol);
                                //draw.arrayStatusSaveDateZD.Add(Convert.ToDateTime(strCollectDate).ToString());


                                draw.arrayDCCh4Cur.Add(ZDCur);
                                draw.arrayDCCh4Vol.Add(ZDVol);


                                //lock (lockZDE)
                                //{
                                //    //f.Invoke(showElectricalcallback, 4);//委托显示
                                //    drawExp9.refreshDrawElectricalArray(dt4.ToString(), Convert.ToDouble(sensorCurrent), Convert.ToDouble(sensorVol), 9, f);//动态画状态图2，加锁
                                //}

                                break;
                            case "通道5电参数":
                                //DateTime dt5 = DateTime.Now;
                                //sqlElectrical = "insert into sensorelectricalcdom (sensortype,current,voltage,power,savetime,collecttime) values ('" + sensorType + "','" + sensorCurrent + "','" + sensorVol + "','" + sensorPower + "','" + dt5 + "','" + strCollectDate + "')";
                                //SqlHelper.ExecuteNonQuery(sqlElectrical);
                                /**后面待补充送界面显示(送入界面响应位置显示，使用委托实现直接送界面)，以及画图**/

                                CDOMCur = sensorCurrent;
                                CDOMVol = sensorVol;
                                CDOMPower = sensorPower;
                                CDOMTime = strCollectDate;

                                f.Invoke(showElectricalcallback, 5);//委托显示

                                //draw.arrayCurrentCDOM.Add(sensorCurrent);
                                //draw.arrayVoltageCDOM.Add(sensorVol);
                                //draw.arrayStatusSaveDateCDOM.Add(Convert.ToDateTime(strCollectDate).ToString());

                                draw.arrayDCCh5Cur.Add(CDOMCur);
                                draw.arrayDCCh5Vol.Add(CDOMVol);


                                //lock (lockCDOME)
                                //{
                                //    //f.Invoke(showElectricalcallback, 5);//委托显示
                                //    drawExp10.refreshDrawElectricalArray(dt5.ToString(), Convert.ToDouble(sensorCurrent), Convert.ToDouble(sensorVol), 10, f);//动态画状态图2，加锁
                                //}
                                break;

                        }



                    }
                    else//以上解析的是电参数，后面解析温度信息，没有漏水信息
                    {
                        string temperature = null;
                        string sqlCabin = null;
                        if (message.Substring(10, 2) == "60")//温度数据
                        {
                            temperature = System.Text.Encoding.ASCII.GetString(StrToHexByte(message.Substring(104, 14)));

                            showTemp = temperature;

                            f.Invoke(showElectricalcallback, 6);//将温度信息送到首页进行显示

                            DateTime dt1 = DateTime.Now;
                            sqlCabin = "insert into seafloor_srcTempData (srcId,statusType, temp,saveDate,collectDate,collectRawInfo,pkgNum,isDelete) values ('"+srcId+"','" + strProtocolName + "','" + temperature + "','" + dt1 + "','" + strCollectDate + "','" + message + "','"+packageNumber+"','0')";
                            //string sqlCabinTemp = "insert into cabinstatustemp (statusinfo, statusdata,savedate,collectdate,collectrawinfo) values ('" + strProtocolName + "','" + temperature + "','" + dt1 + "','" + strCollectDate + "','" + message + "')";
                            SqlHelper.ExecuteNonQuery(sqlCabin);
                            //SqlHelper.ExecuteNonQuery(sqlCabinTemp);

                            draw.arrayDCTemp.Add(Convert.ToDouble(temperature).ToString("00.000"));//将数据采集器最新的温度数据添加到动态数组中


                            draw.arrayTemp.Add(temperature);//将收到的温度数据动态添加到动态数组中,为了后面方便温度状态数据上传至数据库服务器中
                            draw.arraySaveDateTemp.Add(Convert.ToDateTime(strCollectDate).ToString());


                        }


                    }
                }
            }

            catch (Exception exp)
            {
                string exception = "解析数据采集器1下位机环境参数程序出现异常:" + exp.Message + "接收到的内容:" + message;
                LogClass.WriteLogFile(exception);
            }
        }

        /// <summary>
        /// 4.3具体解析下位机发送故障信息函数
        /// </summary>
        /// <param name="message"></param>
        /// <param name="strProtocolID"></param>
        /// <param name="strProtocolName"></param>
        /// <param name="packageNumber"></param>
        /// <param name="strCollectDate"></param>
        /// <param name="protocolHeadFault"></param>接收下位机的故障信息之后，还要将数据实时上传至故障服务器,为方便上传，将故障协议头作为参数传递，最后一个参数faultTime也是为了方便上传故障服务器定义
        private void dealFaultMessage(string srcId,string message, string strProtocolID, string strProtocolName, UInt32 packageNumber, string strCollectDate, string protocolHeadFault, string faultTime)
        {
            string strFaultID = strProtocolID;
            string strFaultInfo = strProtocolName;

            string sqlFault = null;//存入错误数据库表格语句
            string strFaultData = null;//报警数值

            string strDeviceNum = null;//上传故障服务器时，消息包体，设备编号定义
            string strFaultCode = null;//上传故障服务器时，消息包体，故障码编号定义
            string strFaultType = null;//上传故障服务器时，故障类型



            try
            {
                strFaultData = System.Text.Encoding.ASCII.GetString(StrToHexByte(message.Substring(104, 12)));

                //将最新的故障时间送入控件进行显示
                showFaultTime = strCollectDate;

                f.Invoke(showElectricalcallback, 7);

                DateTime dt = DateTime.Now;
                sqlFault = "insert into seafloor_srcFaultData (srcId,srcInfoCode,srcInfoName,collectDate,saveDate,collectRawInfo,faultData,pkgNum,isDelete) values('"+srcId+"','" + strFaultID + "','" + strProtocolName + "','" + strCollectDate + "','" + dt + "','" + message + "','" + strFaultData + "','" + packageNumber + "','0')";
                SqlHelper.ExecuteNonQuery(sqlFault);//故障信息表的存储没有存采集时间


                //将数据采集器的故障生成文件
                XDocument document = new XDocument();
                XElement root = new XElement("SeafloorObservatoryNetWorkFaultFile-JiaozhouBay");//海底观测网故障文件
                XElement dCFaultData = new XElement("DataCollectorFaultData");//二级标签数据采集器故障数据

                dCFaultData.SetElementValue("FaultType", strProtocolName);
                dCFaultData.SetElementValue("FaultData", strFaultData);
                root.Add(dCFaultData);

                root.Save(@"D:\SONFault\" + dt.ToString("yyyy-MM-dd HHmmss") + "SONFault" + ".xml");

                string sql1 = "insert into faultlog (faultType,faultData,time) values('" + strProtocolName + "','" + strFaultData + "','" + dt + "')";//将接驳盒出现异常的数据存入到数据库中
                SqlHelper.ExecuteNonQuery(sql1);


                switch (strFaultID.Substring(2, 1))
                {
                    case "1"://溶解氧故障

                        strDeviceNum = "000100010001000300080001";
                        strFaultType = "0202";
                        strFaultCode = dealFaultCode(strFaultID);//下位机故障信息上传至故障服务器进行的操作

                        //DateTime dt1 = DateTime.Now;
                        //sqlFault = "insert into faultinfodo (faultid,faultinfo,collectdate,savedate,collectrawinfo,faultdata) values('" + strFaultID + "','" + strProtocolName + "','" + strCollectDate + "','" + dt1 + "','" + message + "','" + strFaultData + "')";
                        //SqlHelper.ExecuteNonQuery(sqlFault);

                        //使用委托方式，将溶解氧故障值直接放到首页故障值表格显示

                        DateTime? collectTime1 = Convert.ToDateTime(null);//定义时间格式的时间，用于给回调函数传参数
                        collectTime1 = Convert.ToDateTime(strCollectDate);
                        f.Invoke(showSensorFaultcallback, strProtocolName, strFaultData, collectTime1, 6);

                        break;
                    case "2"://甲烷故障

                        strDeviceNum = "000100010001000300090001";
                        strFaultType = "0202";
                        strFaultCode = dealFaultCode(strFaultID);

                        //DateTime dt2 = DateTime.Now;
                        //sqlFault = "insert into faultinfojw (faultid,faultinfo,collectdate,savedate,collectrawinfo,faultdata) values('" + strFaultID + "','" + strProtocolName + "','" + strCollectDate + "','" + dt2 + "','" + message + "','" + strFaultData + "')";
                        //SqlHelper.ExecuteNonQuery(sqlFault);

                        //使用委托方式，将甲烷故障值直接放到首页故障值表格显示

                        DateTime? collectTime2 = Convert.ToDateTime(null);//定义时间格式的时间，用于给回调函数传参数
                        collectTime2 = Convert.ToDateTime(strCollectDate);
                        f.Invoke(showSensorFaultcallback, strProtocolName, strFaultData, collectTime2, 7);

                        break;
                    case "3"://叶绿素故障

                        strDeviceNum = "0001000100010003000A0001";
                        strFaultType = "0202";
                        strFaultCode = dealFaultCode(strFaultID);

                        //DateTime dt3 = DateTime.Now;
                        //sqlFault = "insert into faultinfoyls (faultid,faultinfo,collectdate,savedate,collectrawinfo,faultdata) values('" + strFaultID + "','" + strProtocolName + "','" + strCollectDate + "','" + dt3 + "','" + message + "','" + strFaultData + "')";
                        //SqlHelper.ExecuteNonQuery(sqlFault);

                        //使用委托方式，将叶绿素报警故障值直接放到首页故障值表格显示
                        DateTime? collectTime3 = Convert.ToDateTime(null);//定义时间格式的时间，用于给回调函数传参数
                        collectTime3 = Convert.ToDateTime(strCollectDate);
                        f.Invoke(showSensorFaultcallback, strProtocolName, strFaultData, collectTime3, 8);


                        break;
                    case "4"://浊度故障

                        strDeviceNum = "0001000100010003000B0001";
                        strFaultType = "0202";
                        strFaultCode = dealFaultCode(strFaultID);

                        //DateTime dt4 = DateTime.Now;
                        //sqlFault = "insert into faultinfozd (faultid,faultinfo,collectdate,savedate,collectrawinfo,faultdata) values('" + strFaultID + "','" + strProtocolName + "','" + strCollectDate + "','" + dt4 + "','" + message + "','" + strFaultData + "')";
                        //SqlHelper.ExecuteNonQuery(sqlFault);

                        //使用委托方式，将浊度报警故障值直接放到首页故障值表格显示
                        DateTime? collectTime4 = Convert.ToDateTime(null);//定义时间格式的时间，用于给回调函数传参数
                        collectTime4 = Convert.ToDateTime(strCollectDate);
                        f.Invoke(showSensorFaultcallback, strProtocolName, strFaultData, collectTime4, 9);


                        break;
                    case "5"://CDOM故障

                        strDeviceNum = "0001000100010003000C0001";
                        strFaultType = "0202";
                        strFaultCode = dealFaultCode(strFaultID);

                        //DateTime dt5 = DateTime.Now;
                        //sqlFault = "insert into faultinfocdom (faultid,faultinfo,collectdate,savedate,collectrawinfo,faultdata) values('" + strFaultID + "','" + strProtocolName + "','" + strCollectDate + "','" + dt5 + "','" + message + "','" + strFaultData + "')";
                        //SqlHelper.ExecuteNonQuery(sqlFault);

                        //使用委托方式，将CDOM报警故障值直接放到首页故障值表格显示
                        DateTime? collectTime5 = Convert.ToDateTime(null);//定义时间格式的时间，用于给回调函数传参数
                        collectTime5 = Convert.ToDateTime(strCollectDate);
                        f.Invoke(showSensorFaultcallback, strProtocolName, strFaultData, collectTime5, 10);


                        break;
                    case "6"://温度故障

                        strDeviceNum = "0001000100010003000D0001";
                        strFaultType = "0101";
                        strFaultCode = dealFaultCode(strFaultID);

                        //DateTime dt6 = DateTime.Now;
                        //sqlFault = "insert into faultinfotemp (faultid,faultinfo,collectdate,savedate,collectrawinfo,faultdata) values('" + strFaultID + "','" + strProtocolName + "','" + strCollectDate + "','" + dt6 + "','" + message + "','" + strFaultData + "')";
                        //SqlHelper.ExecuteNonQuery(sqlFault);

                        //使用委托方式，将温度报警故障值直接放到首页故障值表格显示
                        DateTime? collectTime6 = Convert.ToDateTime(null);//定义时间格式的时间，用于给回调函数传参数
                        collectTime6 = Convert.ToDateTime(strCollectDate);
                        f.Invoke(showSensorFaultcallback, strProtocolName, strFaultData, collectTime6, 11);

                        break;
                    case "7":

                        strDeviceNum = "0001000100010003000D0001";
                        strFaultType = "0101";
                        strFaultCode = dealFaultCode(strFaultID);

                        //DateTime dt7 = DateTime.Now;
                        //sqlFault = "insert into faultinfoleak (faultid,faultinfo,collectdate,savedate,collectrawinfo,faultdata) values('" + strFaultID + "','" + strProtocolName + "','" + strCollectDate + "','" + dt7 + "','" + message + "','" + strFaultData + "')";
                        //SqlHelper.ExecuteNonQuery(sqlFault);
                        break;
                    case "8":
                        //DateTime dt8 = DateTime.Now;
                        //sqlFault = "insert into faultinfonone (faultid,faultinfo,collectdate,savedate,collectrawinfo,faultdata) values('" + strFaultID + "','" + strProtocolName + "','" + strCollectDate + "','" + dt8 + "','" + message + "','" + strFaultData + "')";
                        //SqlHelper.ExecuteNonQuery(sqlFault);
                        break;
                }

                //2018-02-05暂时注释
                //string protocolPackageFault = "7E" + "00030003" + strDeviceNum + faultTime + strFaultType + strFaultCode + "FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF" + "2F";
                //UInt32 dataCRCValueFault = CRC32.GetCrc32(StrToHexByte(protocolHeadFault + protocolPackageFault));//求解协议包头以及协议包体的CRC32校验值
                //string protocolCRCFault = dataCRCValueFault.ToString("X8");

                //string faultPackage = protocolHeadFault + protocolPackageFault + protocolCRCFault;//最终故障服务器的故障信息

                //开启线程将故障数据上传至故障服务器，且在线程中将上传信息存储至数据库中-2018-02-05暂时注销故障上传故障服务器的线程
                //Thread clientSendToFault;

                //_5MyClientThread faultExp = new _5MyClientThread(faultPackage, strCollectDate, strProtocolName);

                //clientSendToFault = new Thread(new ThreadStart(faultExp.UploadFault));
                //clientSendToFault.Start();
            }
            catch (Exception exp)
            {
                string exception = "解析下位机故障信息程序出现异常:" + exp.Message + "接收到的内容:" + message;
                LogClass.WriteLogFile(exception);
            }
        }
        /// <summary>
        /// 5.关闭连接
        /// </summary>
        public void CloseSocket()
        {
            if (br != null)
            {
                br.Close();
            }
            if (bw != null)
            {
                bw.Close();
            }
            if (tcpClient != null)
            {
                tcpClient.Close();
            }

        }

        /// <summary>
        /// 相当于从数据库读到了协议编号与对应的协议含义的关系
        /// </summary>
        /// <returns></returns>
        public Dictionary<string, string> SetKeyValue()
        {
            Dictionary<string, string> dic = new Dictionary<string, string>();
            //从数据库中读到相应数据，然后将对应的Key以及value填充到字典中

            try
            {
                MySqlDataReader reader = SqlHelper.ExecuteReader("select * from seafloor_srcConfigInfo");
                while (reader.Read())
                {
                    dic.Add(reader.GetString(2), reader.GetString(1));
                }
            }
            catch (Exception exp)
            {
                //MessageBox.Show("读入数据库时出现异常！"+exp.Message);
                LogClass.WriteLogFile("读入数据库seafloor_srcConfigInfo时出现异常！" + exp.Message);
            }
            return dic;

        }

        /// <summary>
        /// 将十六进制字符串转换成字节类型存储在数组中
        /// </summary>
        /// <param name="val"></param>
        /// <returns></returns>
        private byte[] StrToHexByte(string val)
        {
            byte[] bytes = new byte[val.Length / 2];

            for (int i = 0; i < bytes.Length; i++)
            {
                bytes[i] = Convert.ToByte(val.Substring(i * 2, 2), 16);
            }
            return bytes;
        }


        /// <summary>
        /// 判断给定的字符串是否符合特定的格式，即是否有乱码出现
        /// </summary>
        /// <param name="_express"></param>给定的正则表达式
        /// <param name="_value"></param>需要验证的字符串
        /// <returns></returns>
        private bool QuickValidate(string _express, string _value)
        {
            if (_value == null) return false;
            Regex myRegex = new Regex(_express);
            if (_value.Length == 0)
            {
                return false;
            }
            return myRegex.IsMatch(_value);
        }

        /// <summary>
        /// 将下位机发送过来的时间格式处理成上传数据库服务器需要的格式要求
        /// </summary>
        /// <returns></returns>
        private string dealTime(string Time)
        {
            string dataTime = null;

            char[] separator = { ':' };

            string[] splitTime = new string[7];

            splitTime = Time.Split(separator);

            for (int i = 0; i < splitTime.Length - 1; i++)
            {
                dataTime += splitTime[i];
            }

            dataTime = dataTime + '0' + splitTime[6];

            return dataTime;
        }

        /// <summary>
        /// 类型于查字典，由相应的协议编号（相当于键值）得到对应的协议名称（Value值）
        /// </summary>
        /// <param name="message"></param>
        /// <returns></returns>

        private string GetKeyValue(string message)
        {
            string value = null;
            if (mydic.TryGetValue(message, out value))
            {
                return value;
            }
            else
            {
                return null;
            }
        }

        /// <summary>
        /// 读取溶解氧公式配置，若读出来的值是1则选用公式1，分段公式，否则选用公式2
        /// </summary>
        /// <returns></returns>
        private int ReadDOFormula()
        {
            DataSet ds = new DataSet();
            ds.ReadXml(@".\Formula.xml");
            int number = Convert.ToInt32(ds.Tables[0].Rows[0]["number"].ToString());
            return number;
        }


        /// <summary>
        /// 将时间戳处理成上传故障服务器需要的格式23位BCD码形式
        /// </summary>
        /// <param name="Time"></param>
        /// <returns></returns>
        private string dealFaultTime(string Time)
        {
            string tempTime = Time.Substring(0, 14) + Time.Substring(15, 3);
            string result1 = null;
            string result = null;
            for (int i = 0; i < tempTime.Length; i++)
            {
                result1 += "0" + tempTime.Substring(i, 1);
            }
            result = result1.Substring(0, 8) + "3A" + result1.Substring(8, 4) + "3A" + result1.Substring(12, 4) + "3A" + result1.Substring(16, 4) + "3A" + result1.Substring(20, 4) + "3A" + result1.Substring(24, 4) + "3A" + result1.Substring(28, 6);
            return result;
        }


        /// <summary>
        /// 根据不同的故障信息获取相应的故障码编号
        /// </summary>
        /// <returns></returns>
        private string dealFaultCode(string message)
        {
            string strFaultCode = null;
            switch (message.Substring(2, 2))
            {
                case "11"://溶解氧停止工作
                    strFaultCode = "0003000810FF";
                    break;
                case "12"://欠流溶解氧工作异常
                    strFaultCode = "000300081100";
                    break;
                case "13"://溶解氧停止工作
                    strFaultCode = "0003000810FF";
                    break;
                case "14"://欠压溶解氧工作异常
                    strFaultCode = "000300081100";
                    break;
                case "21"://甲烷过流,停止工作
                    strFaultCode = "000300091131";
                    break;
                case "22"://甲烷欠流，工作异常
                    strFaultCode = "000300091132";
                    break;
                case "23"://甲烷过压,停止工作
                    strFaultCode = "000300091131";
                    break;
                case "24"://甲烷欠压，工作异常
                    strFaultCode = "000300091132";
                    break;
                case "31"://叶绿素过流，停止工作
                    strFaultCode = "0003000A1163";
                    break;
                case "32"://叶绿素欠流，工作异常
                    strFaultCode = "0003000A1164";
                    break;
                case "33"://叶绿素过压，停止工作
                    strFaultCode = "0003000A1163";
                    break;
                case "34"://叶绿素欠压，工作异常
                    strFaultCode = "0003000A1164";
                    break;
                case "41"://浊度过流，停止工作
                    strFaultCode = "0003000B1195";
                    break;
                case "42"://浊度欠流，工作异常
                    strFaultCode = "0003000B1196";
                    break;
                case "43"://浊度过压，停止工作
                    strFaultCode = "0003000B1195";
                    break;
                case "44"://浊度欠压，工作异常
                    strFaultCode = "0003000B1196";
                    break;

                case "51"://CDOM过流，停止工作
                    strFaultCode = "0003000C11C7";
                    break;
                case "52"://CDOM欠流，工作异常
                    strFaultCode = "0003000C11C8";
                    break;
                case "53"://CDOM过压，停止工作
                    strFaultCode = "0003000C11C7";
                    break;
                case "54"://CDOM欠压，工作异常
                    strFaultCode = "0003000C11C8";
                    break;
                case "61"://控制舱温度异常
                    strFaultCode = "0003000D11F9";
                    break;
                case "62"://控制舱温度异常
                    strFaultCode = "0003000D11F9";
                    break;
                case "71"://控制舱漏水异常
                    strFaultCode = "0003000D11FA";
                    break;
                case "72"://控制舱漏水异常
                    strFaultCode = "0003000D11FA";
                    break;
            }
            return strFaultCode;
        }
    }
}
