﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Steema.TeeChart;
using System.Data;

namespace OSNSystem
{
    class _4DrawSensor
    {
        private string[,] drawdataTime = new string[9,1000];
        private double[,] drawdata = new double[9,1000];
        private int[,] drawIndex = new int[9,2];

        public _4DrawSensor()
        {
            drawdataTime= new string[9,1000];
            drawdata= new double[9,1000];
            drawIndex = new int[9,1000];
        }
        /// <summary>
        /// 初始化Load中加载数据库中存储的传感器最新的1000个数据点
        /// </summary>
        /// <param name="strSql"></param>
        /// <param name="myChart"></param>
        /// <param name="index"></param>
        public void drawSensorLine(string strSql, TChart myChart,int index)
        {
            try 
            {
                DataTable tTable = SqlHelper.ExecuteDataTable(strSql);
                DataView dv = tTable.DefaultView;
                dv.Sort = "savedate asc";
                DataTable tempTable = dv.ToTable();


                switch (index)
                {
                    case 1://溶解氧
                        if (tempTable.Rows.Count > 0)
                        {
                            int i = 0;
                            myChart.Series[0].Clear();//曲线清空
                            for (; i < tempTable.Rows.Count; i++)
                            {
                                DataRow row = tempTable.Rows[i];
                                drawdata[index - 1, i] = Convert.ToDouble(row["collectData"].ToString().Trim());
                                drawdataTime[index - 1, i] = Convert.ToString(row["collectDate"]);

                                draw.arrayDOValue.Add(Convert.ToDouble(row["collectData"].ToString().Trim()).ToString("00.00"));
                                draw.arrayDODate.Add(Convert.ToString(row["collectDate"]));

                                myChart.Series[0].Add(i + 1, drawdata[index - 1, i]);
                            }
                            drawIndex[index - 1, 0] = (int)(i % 1000);
                            drawIndex[index - 1, 1] = i;
                        }
                        break;
                    case 2://叶绿素数据

                        if(tempTable.Rows.Count > 0)
                        {
                            int i = 0;
                            myChart.Series[0].Clear();
                            for (; i < tempTable.Rows.Count; i++)
                            {
                                DataRow row = tempTable.Rows[i];
                                drawdata[index - 1, i] = Convert.ToDouble(row["collectData"].ToString().Trim());
                                drawdataTime[index - 1, i] = Convert.ToString(row["collectDate"]);

                                draw.arrayChlValue.Add(Convert.ToDouble(row["collectData"].ToString().Trim()).ToString("000.00"));
                                draw.arrayChlTurDate.Add(Convert.ToString(row["collectDate"]));//叶绿素浊度传感器的时间只加入一次可变数组即可

                                myChart.Series[0].Add(i + 1, drawdata[index - 1, i]);
                            }
                            drawIndex[index - 1, 0] = (int)(i % 1000);//代表下一个需要更新的数组坐标
                            drawIndex[index - 1, 1] = i;//代表一共有多少个数据
                        }

                        break;
                    case 3://浊度

                        if (tempTable.Rows.Count > 0)
                        {
                            int i = 0;
                            myChart.Series[1].Clear();

                            for (; i < tempTable.Rows.Count; i++)
                            {
                                DataRow row = tempTable.Rows[i];
                                drawdata[index - 1, i] = Convert.ToDouble(row["collectData1"].ToString().Trim());
                                drawdataTime[index - 1, i] = Convert.ToString(row["collectDate"]);

                                draw.arrayTurValue.Add(Convert.ToDouble(row["collectData1"].ToString().Trim()).ToString("000.00"));//为了后面方便显示可移动标签使用
                               // draw.arrayTurDate.Add(Convert.ToString(row["collectDate"]));//CTD的时间只加入一次可变数组中即可

                                myChart.Series[1].Add(i + 1, drawdata[index - 1, i]);
                            }

                            drawIndex[index - 1, 0] = (int)(i % 1000);
                            drawIndex[index - 1, 1] = i;
                        }
                        break;
                    case 4://叶绿素浊度传感器所测的温度数据
                        if (tempTable.Rows.Count > 0)
                        {
                            int i = 0;
                            myChart.Series[2].Clear();

                            for (; i < tempTable.Rows.Count; i++)
                            {
                                DataRow row = tempTable.Rows[i];
                                drawdata[index - 1, i] = Convert.ToDouble(row["collectData2"].ToString().Trim());
                                drawdataTime[index - 1, i] = Convert.ToString(row["collectDate"]);

                                draw.arrayCTTemp.Add(Convert.ToDouble(row["collectData2"].ToString().Trim()));//为了后面方便显示可移动标签使用
                                myChart.Series[2].Add(i + 1, drawdata[index - 1, i]);

                            }

                            drawIndex[index - 1, 0] = (int)(i % 1000);
                            drawIndex[index - 1, 1] = i;
                        }
                        break;
                    case 5://CTD-电导率

                        if (tempTable.Rows.Count > 0)
                        {
                            int i = 0;
                            myChart.Series[0].Clear();

                            for (; i < tempTable.Rows.Count; i++)
                            {
                                DataRow row = tempTable.Rows[i];
                                drawdata[index - 1, i] = Convert.ToDouble(row["collectData"].ToString().Trim());
                                drawdataTime[index - 1, i] = Convert.ToString(row["collectDate"]);

                                draw.arrayCTD_CValue.Add(Convert.ToDouble(row["collectData"].ToString().Trim()).ToString("00.00"));//为了后面方便显示可移动标签使用
                                draw.arrayCTDDate.Add(Convert.ToString(row["collectDate"]));//CTD的时间只加入一次可变数组中即可

                                myChart.Series[0].Add(i + 1, drawdata[index - 1, i]);
                            }

                            drawIndex[index - 1, 0] = (int)(i % 1000);
                            drawIndex[index - 1, 1] = i;
                        }
                        break;
                    case 6://CTD-温度

                        if (tempTable.Rows.Count > 0)
                        {
                            int i = 0;
                            myChart.Series[1].Clear();

                            for (; i < tempTable.Rows.Count; i++)
                            {
                                DataRow row = tempTable.Rows[i];
                                drawdata[index - 1, i] = Convert.ToDouble(row["collectData1"].ToString().Trim());
                                drawdataTime[index - 1, i] = Convert.ToString(row["collectDate"]);

                                draw.arrayCTD_TValue.Add(Convert.ToDouble(row["collectData1"].ToString().Trim()).ToString("00.00"));

                                myChart.Series[1].Add(i+1,drawdata[index-1,i]);
                            }
                            drawIndex[index-1,0] = (int)(i%1000);
                            drawIndex[index - 1, 1] = i;
                        }

                        break;
                    case 7://CTD-深度
                        if (tempTable.Rows.Count > 0)
                        {
                            int i = 0;
                            myChart.Series[2].Clear();

                            for (; i < tempTable.Rows.Count; i++)
                            {
                                DataRow row = tempTable.Rows[i];
                                drawdata[index - 1, i] = Convert.ToDouble(row["collectData2"].ToString().Trim());
                                drawdataTime[index - 1, i] = Convert.ToString(row["collectDate"]);

                                draw.arrayCTD_DValue.Add(Convert.ToDouble(row["collectData2"].ToString().Trim()).ToString("00.00"));

                                myChart.Series[2].Add(i+1,drawdata[index-1,i]);
                            }
                            drawIndex[index - 1, 0] = (int)(i % 1000);
                            drawIndex[index - 1, 1] = i;
                        }
                        break;
                    case 8://CTD-盐度

                        if (tempTable.Rows.Count > 0)
                        {
                            int i = 0;
                            myChart.Series[3].Clear();

                            for (; i < tempTable.Rows.Count;i++)
                            {
                                DataRow row = tempTable.Rows[i];
                                drawdata[index - 1, i] = Convert.ToDouble(row["collectData3"].ToString().Trim());
                                drawdataTime[index - 1, i] = Convert.ToString(row["collectDate"]);

                                draw.arrayCTD_SValue.Add(Convert.ToDouble(row["collectData3"].ToString().Trim()).ToString("00.00"));

                                myChart.Series[3].Add(i+1,drawdata[index-1,i]);

                            }
                            drawIndex[index - 1, 0] = (int)(i % 1000);
                            drawIndex[index - 1, 1] = i;
                        }

                        break;
                    case 9://PH
                        if (tempTable.Rows.Count > 0)
                        {
                            int i = 0;
                            myChart.Series[0].Clear();

                            for (; i < tempTable.Rows.Count; i++)
                            {
                                DataRow row = tempTable.Rows[i];
                                drawdata[index - 1, i] = Convert.ToDouble(row["collectData"].ToString().Trim());
                                drawdataTime[index - 1, i] = Convert.ToString(row["collectDate"]);

                                draw.arrayADLValue.Add(Convert.ToDouble(row["collectData"].ToString().Trim()));
                                draw.arrayADLDate.Add(Convert.ToString(row["collectDate"]));//多参数传感器的时间只加入一次就可以

                                myChart.Series[0].Add(i + 1, drawdata[index - 1, i]);

                            }
                            drawIndex[index - 1, 0] = (int)(i % 1000);
                            drawIndex[index - 1, 1] = i;
                        }
                        break;
                    
                }


            }
            catch(Exception exp) 
            {
                LogClass.WriteLogFile("Load加载传感器1000个点出现异常！"+exp.Message);
            }
        }
        /// <summary>
        /// 每获得一个数据更新值缓存中去
        /// </summary>
        /// <param name="datatime"></param>
        /// <param name="data"></param>
        /// <param name="arrayIndex"></param>
        /// <param name="f"></param>
        public void refreshDrawDataArray(string datatime,double data, int arrayIndex,TChart myChart)
        {
            int j;

            if (drawIndex[arrayIndex - 1, 1] < 1000)
            {
                j = drawIndex[arrayIndex - 1, 1];
                drawdata[arrayIndex - 1, j] = data;
                drawdataTime[arrayIndex - 1, j] = datatime;
                drawIndex[arrayIndex - 1, 1]++;
                drawIndex[arrayIndex - 1, 0] = 0;
            }
            else
            {
                j = drawIndex[arrayIndex-1,0];
                drawdata[arrayIndex-1,j] = data;
                drawdataTime[arrayIndex - 1, j] = datatime;
                drawIndex[arrayIndex-1,0] = (int)(++j % 1000);

            }

            realTimeDrawLine(myChart,arrayIndex);
        }

        /// <summary>
        /// 更新CTD传感器序列数据
        /// </summary>
        /// <param name="datatime"></param>
        /// <param name="conductance"></param>
        /// <param name="temperature"></param>
        /// <param name="depth"></param>
        /// <param name="salinity"></param>
        /// <param name="arrayIndex"></param>
        /// <param name="mychart"></param>
        public void refreshDrawCTDDataArray(string datatime,double conductance,double temperature,double depth,double salinity,int arrayIndex,TChart mychart)
        {
            int j;
            if (drawIndex[arrayIndex - 1, 1] < 1000)//保存数据中数据的个数
            {
                j = drawIndex[arrayIndex - 1, 1];//下次更新坐标值
                drawdata[arrayIndex - 1, j] = conductance;//更新CTD-电导率
                drawdata[arrayIndex - 1 + 1, j] = temperature;//更新CTD-温度
                drawdata[arrayIndex - 1 + 2, j] = depth;//更新CTD-深度
                drawdata[arrayIndex - 1 + 3, j] = salinity;//更新CTD-盐度

                drawdataTime[arrayIndex - 1, j] = datatime;
                drawIndex[arrayIndex - 1, 1]++;//保存曲线上点的个数，最大为1000
                drawIndex[arrayIndex - 1, 0] = 0;//下次画图更新的起点
            }
            else
            {
                j = drawIndex[arrayIndex - 1, 0];

                drawdata[arrayIndex - 1, j] = conductance;//通道1电流值更新缓存
                drawdata[arrayIndex - 1 + 1, j] = temperature;//通道1电压值更新缓存
                drawdata[arrayIndex - 1 + 2, j] = depth;//通道2电流值更新缓存
                drawdata[arrayIndex - 1 + 3, j] = salinity;//通道2电压值更新缓存


                drawdataTime[arrayIndex - 1, j] = datatime;
                drawIndex[arrayIndex - 1, 0] = (int)(++j % 1000);
            }

            realTimeDrawLine(mychart,arrayIndex);
        }

        /// <summary>
        /// 多参数序列更新
        /// </summary>
        /// <param name="datatime"></param>
        /// <param name="conductance"></param>
        /// <param name="temperature"></param>
        /// <param name="depth"></param>
        /// <param name="salinity"></param>
        /// <param name="arrayIndex"></param>
        /// <param name="mychart"></param>
        public void refreshDrawMultiDataArray(string datatime, double chl, double tur, double phy,  int arrayIndex, TChart mychart)
        {
            int j;
            if (drawIndex[arrayIndex - 1, 1] < 1000)//保存数据中数据的个数
            {
                j = drawIndex[arrayIndex - 1, 1];//下次更新坐标值
                drawdata[arrayIndex - 1, j] = chl;//更新CTD-电导率
                drawdata[arrayIndex - 1 + 1, j] = tur;//更新CTD-温度
                drawdata[arrayIndex - 1 + 2, j] = phy;//更新CTD-深度
               

                drawdataTime[arrayIndex - 1, j] = datatime;
                drawIndex[arrayIndex - 1, 1]++;//保存曲线上点的个数，最大为1000
                drawIndex[arrayIndex - 1, 0] = 0;//下次画图更新的起点
            }
            else
            {
                j = drawIndex[arrayIndex - 1, 0];

                drawdata[arrayIndex - 1, j] = chl;//通道1电流值更新缓存
                drawdata[arrayIndex - 1 + 1, j] = tur;//通道1电压值更新缓存
                drawdata[arrayIndex - 1 + 2, j] = phy;//通道2电流值更新缓存
               


                drawdataTime[arrayIndex - 1, j] = datatime;
                drawIndex[arrayIndex - 1, 0] = (int)(++j % 1000);
            }

            realTimeDrawLine(mychart, arrayIndex);
        }



        /// <summary>
        /// 实时绘制曲线
        /// </summary>
        /// <param name="myChart"></param>
        /// <param name="index"></param>
        private void realTimeDrawLine(TChart myChart,int index)
        {
            try
            {
                if (index == 1 || index == 9 )
                {
                    int i = drawIndex[index - 1, 0];
                    int j = 0;

                    if (drawIndex[index - 1, 1] < 1000)
                    {
                        myChart.Series[0].Clear();

                        for (; j < drawIndex[index - 1, 1]; j++)
                        {
                            myChart.Series[0].Add(j + 1, drawdata[index - 1, i]);
                            i = (int)(++i % 1000);
                        }

                        if (drawIndex[index - 1, 1] == 999)
                            myChart.Series[0].Add(1000, null);
                    }
                    else
                    {
                        myChart.Series[0].SetNull(myChart.Series[0].Count);

                        for (; j < drawIndex[index - 1, 1]; j++)
                        {
                            myChart.Series[0].XValues[j] = j + 1;
                            myChart.Series[0].YValues[j] = drawdata[index - 1, i];
                            i = (int)(++i % 1000);
                        }
                    }

                    myChart.Series[0].BeginUpdate();
                    myChart.Series[0].EndUpdate();
                }

                else
                {
                    switch(index)
                    {
                        case 5://ctd-温度曲线实时绘制
                            {
                                int i = drawIndex[index - 1, 0];
                                int j = 0;

                                if (drawIndex[index - 1, 1] < 1000)
                                {
                                    myChart.Series[0].Clear();//CTD-电导率曲线清空
                                    myChart.Series[1].Clear();//CTD-温度曲线清空
                                    myChart.Series[2].Clear();//CTD-深度曲线清空
                                    myChart.Series[3].Clear();//CTD-盐度曲线清空

                                    for (; j < drawIndex[index - 1, 1]; j++)
                                    {
                                        myChart.Series[0].Add(j + 1, drawdata[index - 1, i]);
                                        myChart.Series[1].Add(j + 1, drawdata[index - 1+1, i]);
                                        myChart.Series[2].Add(j + 1, drawdata[index - 1+2, i]);
                                        myChart.Series[3].Add(j + 1, drawdata[index - 1+3, i]);
                                        i = (int)(++i % 1000);
                                    }

                                    if (drawIndex[index - 1, 1] == 999)
                                    {
                                        myChart.Series[0].Add(1000, null);
                                        myChart.Series[1].Add(1000,null);
                                        myChart.Series[2].Add(1000,null);
                                        myChart.Series[3].Add(1000,null);
                                    }
                                        
                                }
                                else
                                {
                                    myChart.Series[0].SetNull(myChart.Series[0].Count);
                                    myChart.Series[1].SetNull(myChart.Series[1].Count);
                                    myChart.Series[2].SetNull(myChart.Series[2].Count);
                                    myChart.Series[3].SetNull(myChart.Series[3].Count);

                                    for (; j < drawIndex[index - 1, 1]; j++)
                                    {
                                        myChart.Series[0].XValues[j] = j + 1;
                                        myChart.Series[0].YValues[j] = drawdata[index - 1, i];

                                        myChart.Series[1].XValues[j] = j + 1;
                                        myChart.Series[1].YValues[j] = drawdata[index-1+1,i];

                                        myChart.Series[2].XValues[j] = j + 1;
                                        myChart.Series[2].YValues[j] = drawdata[index - 1 + 2, i];

                                        myChart.Series[3].XValues[j] = j + 1;
                                        myChart.Series[3].YValues[j] = drawdata[index - 1 + 3, i];
                                        i = (int)(++i % 1000);
                                    }
                                }

                                myChart.Series[0].BeginUpdate();
                                myChart.Series[0].EndUpdate();

                                myChart.Series[1].BeginUpdate();
                                myChart.Series[1].EndUpdate();

                                myChart.Series[2].BeginUpdate();
                                myChart.Series[2].EndUpdate();

                                myChart.Series[3].BeginUpdate();
                                myChart.Series[3].EndUpdate();
                            }
                            break;
                        
                        case 2://叶绿素-浊度曲线实时绘制
                            {
                                int i = drawIndex[index - 1, 0];
                                int j = 0;

                                if (drawIndex[index - 1, 1] < 1000)
                                {
                                    myChart.Series[0].Clear();//多参数-叶绿素曲线清空
                                    myChart.Series[1].Clear();//多参数-浊度曲线清空
                                    myChart.Series[2].Clear();//多参数-藻红蛋白曲线清空
                                    

                                    for (; j < drawIndex[index - 1, 1]; j++)
                                    {
                                        myChart.Series[0].Add(j + 1, drawdata[index - 1, i]);
                                        myChart.Series[1].Add(j + 1, drawdata[index - 1 + 1, i]);
                                        myChart.Series[2].Add(j + 1, drawdata[index - 1 + 2, i]);
                                        i = (int)(++i % 1000);
                                    }

                                    if (drawIndex[index - 1, 1] == 999)
                                    {
                                        myChart.Series[0].Add(1000, null);
                                        myChart.Series[1].Add(1000, null);
                                        myChart.Series[2].Add(1000, null);
                                    }

                                }
                                else
                                {
                                    myChart.Series[0].SetNull(myChart.Series[0].Count);
                                    myChart.Series[1].SetNull(myChart.Series[1].Count);
                                    myChart.Series[2].SetNull(myChart.Series[2].Count);

                                    for (; j < drawIndex[index - 1, 1]; j++)
                                    {
                                        myChart.Series[0].XValues[j] = j + 1;
                                        myChart.Series[0].YValues[j] = drawdata[index - 1, i];

                                        myChart.Series[1].XValues[j] = j + 1;
                                        myChart.Series[1].YValues[j] = drawdata[index - 1 + 1, i];

                                        myChart.Series[2].XValues[j] = j + 1;
                                        myChart.Series[2].YValues[j] = drawdata[index - 1 + 2, i];

                                        i = (int)(++i % 1000);
                                    }
                                }

                                myChart.Series[0].BeginUpdate();
                                myChart.Series[0].EndUpdate();

                                myChart.Series[1].BeginUpdate();
                                myChart.Series[1].EndUpdate();

                                myChart.Series[2].BeginUpdate();
                                myChart.Series[2].EndUpdate();

                            }


                            break;

                    }
                }

               
            }

            catch(Exception exp)
            {
                LogClass.WriteLogFile("实时更新传感器采集值曲线异常！"+exp.Message);
            }
        }


    }
}
