﻿/*
 * 时间：2021年9月24日15:12:27
 * 功能：与云服务器建立相关的类的实现
 * 说明：该客户端程序比较特殊，只需要（1）服务器建立连接，（2）循环接收服务器发来的信息（3）循环检测与服务器之间建立的这个连接是否存在，存在的话则抛出线程进行数据接收
 * 若是连接不存在或者连接无效，应该重新建立与服务器的连接
 */
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Net.Sockets;
using System.Data;
using System.Net;
using System.Threading;
using System.Drawing;

namespace OSNSystem
{
    class ECSSocket
    {
        private Socket ECSClient;//与云服务器相关的客户端连接
        bool isExist = false;//判断与服务器连接是否存在的标志
        System.Timers.Timer Timer_Check = new System.Timers.Timer();//定时检测与云服务器连接是否存在的定时器

        public Main f;
        public ECSSocket(Main frm)
        {
            Timer_Check.Interval = 30000;//默认为30s
            Timer_Check.Enabled = true;
            Timer_Check.Elapsed += new System.Timers.ElapsedEventHandler(Timer_Check_Elapsed);
            f = frm;
            showJBInfocallback = new delShowJBInfo(ShowJBInfoMethod);
            showDataInfocallback = new delShowDataInfo(ShowDataInfoMethod);
        }

        /*关于收到接驳盒指令反馈相关信息的委托回调显示*/

        private delegate void delShowJBInfo(int i);
        private delShowJBInfo showJBInfocallback;
        /// <summary>
        /// 1.显示接驳盒相关信息的委托回调显示
        /// </summary>
        private void ShowJBInfoMethod(int i)
        {
            try
            {
                switch (i)
                {
                    case 1://通道1打开成功
                        f.txtBCh1Status.Text = "打开";
                        f.txtBCh1Status.BackColor = Color.DarkSeaGreen;
                        f.txtBCh1Status.ForeColor = Color.White;

                        f.Ch1Open.Enabled = false;
                        f.Ch1Close.Enabled = true;
                        break;
                    case 2://通道2打开成功
                        f.txtBCh2Status.Text = "打开";
                        f.txtBCh2Status.BackColor = Color.DarkSeaGreen;
                        f.txtBCh2Status.ForeColor = Color.White;

                        f.Ch2Open.Enabled = false;
                        f.Ch2Close.Enabled = true;
                        break;
                    case 3://通道3打开成功
                        f.txtBCh3Status.Text = "打开";
                        f.txtBCh3Status.BackColor = Color.DarkSeaGreen;
                        f.txtBCh3Status.ForeColor = Color.White;

                        f.Ch3Open.Enabled = false;
                        f.Ch3Close.Enabled = true;
                        break;
                    case 4://通道4打开成功
                        f.txtBCh4Status.Text = "打开";
                        f.txtBCh4Status.BackColor = Color.DarkSeaGreen;
                        f.txtBCh4Status.ForeColor = Color.White;

                        f.Ch4Open.Enabled = false;
                        f.Ch4Close.Enabled = true;
                        break;
                    case 5://通道5打开成功
                        f.txtBCh5Status.Text = "打开";
                        f.txtBCh5Status.BackColor = Color.DarkSeaGreen;
                        f.txtBCh5Status.ForeColor = Color.White;

                        f.Ch5Open.Enabled = false;
                        f.Ch5Close.Enabled = true;
                        break;
                    case 6://通道1打开失败

                        f.Ch1Open.Enabled = true;
                        f.Ch1Close.Enabled = false;
                        f.txtBCh1Status.Text = "打开失败";
                        f.txtBCh1Status.ForeColor = Color.Black;
                        f.txtBCh1Status.BackColor = Color.Yellow;

                        break;
                    case 7://通道2打开失败

                        f.Ch2Open.Enabled = true;
                        f.Ch2Close.Enabled = false;
                        f.txtBCh2Status.Text = "打开失败";
                        f.txtBCh2Status.ForeColor = Color.Black;
                        f.txtBCh2Status.BackColor = Color.Yellow;

                        break;
                    case 8://通道3打开失败

                        f.Ch3Open.Enabled = true;
                        f.Ch3Close.Enabled = false;
                        f.txtBCh3Status.Text = "打开失败";
                        f.txtBCh3Status.ForeColor = Color.Black;
                        f.txtBCh3Status.BackColor = Color.Yellow;

                        break;
                    case 9://通道4打开失败

                        f.Ch4Open.Enabled = true;
                        f.Ch4Close.Enabled = false;
                        f.txtBCh4Status.Text = "打开失败";
                        f.txtBCh4Status.ForeColor = Color.Black;
                        f.txtBCh4Status.BackColor = Color.Yellow;


                        break;
                    case 10://通道5打开失败

                        f.Ch5Open.Enabled = true;
                        f.Ch5Close.Enabled = false;
                        f.txtBCh5Status.Text = "打开失败";
                        f.txtBCh5Status.ForeColor = Color.Black;
                        f.txtBCh5Status.BackColor = Color.Yellow;


                        break;
                    case 11://通道1关闭成功
                        f.Ch1Close.Enabled = false;
                        f.Ch1Open.Enabled = true;
                        f.txtBCh1Status.Text = "关闭";
                        f.txtBCh1Status.BackColor = Color.Red;
                        f.txtBCh1Status.ForeColor = Color.White;

                        f.txtBCh1Logo.Text = "正常";
                        f.txtBCh1Logo.BackColor = Color.DarkSeaGreen;
                        f.txtBCh1Logo.ForeColor = Color.White;
                        break;
                    case 12://通道2关闭成功
                        f.Ch2Close.Enabled = false;
                        f.Ch2Open.Enabled = true;
                        f.txtBCh2Status.Text = "关闭";
                        f.txtBCh2Status.BackColor = Color.Red;
                        f.txtBCh2Status.ForeColor = Color.White;

                        f.txtBCh2Logo.Text = "正常";
                        f.txtBCh2Logo.BackColor = Color.DarkSeaGreen;
                        f.txtBCh2Logo.ForeColor = Color.White;
                        break;
                    case 13://通道3关闭成功
                        f.Ch3Close.Enabled = false;
                        f.Ch3Open.Enabled = true;
                        f.txtBCh3Status.Text = "关闭";
                        f.txtBCh3Status.BackColor = Color.Red;
                        f.txtBCh3Status.ForeColor = Color.White;

                        f.txtBCh3Logo.Text = "正常";
                        f.txtBCh3Logo.BackColor = Color.DarkSeaGreen;
                        f.txtBCh3Logo.ForeColor = Color.White;
                        break;
                    case 14://通道4关闭成功
                        f.Ch4Close.Enabled = false;
                        f.Ch4Open.Enabled = true;
                        f.txtBCh4Status.Text = "关闭";
                        f.txtBCh4Status.BackColor = Color.Red;
                        f.txtBCh4Status.ForeColor = Color.White;

                        f.txtBCh4Logo.Text = "正常";
                        f.txtBCh4Logo.BackColor = Color.DarkSeaGreen;
                        f.txtBCh4Logo.ForeColor = Color.White;
                        break;
                    case 15://通道5关闭成功
                        f.Ch5Close.Enabled = false;
                        f.Ch5Open.Enabled = true;
                        f.txtBCh5Status.Text = "关闭";
                        f.txtBCh5Status.BackColor = Color.Red;
                        f.txtBCh5Status.ForeColor = Color.White;

                        f.txtBCh5Logo.Text = "正常";
                        f.txtBCh5Logo.BackColor = Color.DarkSeaGreen;
                        f.txtBCh5Logo.ForeColor = Color.White;
                        break;
                    case 16://通道1关闭失败
                        f.txtBCh1Status.Text = "关闭失败";
                        f.txtBCh1Status.ForeColor = Color.Black;
                        f.txtBCh1Status.BackColor = Color.Yellow;
                        f.Ch1Close.Enabled = true;
                        f.Ch1Open.Enabled = false;
                        break;
                    case 17://通道2关闭失败
                        f.txtBCh2Status.Text = "关闭失败";
                        f.txtBCh2Status.ForeColor = Color.Black;
                        f.txtBCh2Status.BackColor = Color.Yellow;
                        f.Ch2Close.Enabled = true;
                        f.Ch2Open.Enabled = false;
                        break;
                    case 18://通道3关闭失败
                        f.txtBCh3Status.Text = "关闭失败";
                        f.txtBCh3Status.ForeColor = Color.Black;
                        f.txtBCh3Status.BackColor = Color.Yellow;
                        f.Ch3Close.Enabled = true;
                        f.Ch3Open.Enabled = false;
                        break;
                    case 19://通道4关闭失败
                        f.txtBCh4Status.Text = "关闭失败";
                        f.txtBCh4Status.ForeColor = Color.Black;
                        f.txtBCh4Status.BackColor = Color.Yellow;
                        f.Ch4Close.Enabled = true;
                        f.Ch4Open.Enabled = false;
                        break;
                    case 20://通道5关闭失败
                        f.txtBCh5Status.Text = "关闭失败";
                        f.txtBCh5Status.ForeColor = Color.Black;
                        f.txtBCh5Status.BackColor = Color.Yellow;
                        f.Ch5Close.Enabled = true;
                        f.Ch5Open.Enabled = false;
                        break;

                }
            }
            catch
            {

            }

        }


        /*关于收到数据采集器通道打开或者关闭指令反馈信息的委托回调显示*/
        private delegate void delShowDataInfo(int i);
        private delShowDataInfo showDataInfocallback;

        /// <summary>
        /// 2.显示数据采集器通道通断相关信息的委托回调显示
        /// </summary>
        /// <param name="i"></param>
        private void ShowDataInfoMethod(int i)
        {
            try
            {
                switch(i)
                {
                    case 1://数据采集器通道1打开成功的委托回调显示
                        f.sensorOneStatus.Text = "打开";
                        f.sensorOneStatus.BackColor = Color.DarkSeaGreen;
                        f.sensorOneStatus.ForeColor = Color.White;

                        f.chOneOpen.Enabled = false;
                        f.chOneClose.Enabled = true;
                        break;
                    case 2://数据采集器通道2打开成功
                        f.sensorTwoStatus.Text = "打开";
                        f.sensorTwoStatus.BackColor = Color.DarkSeaGreen;
                        f.sensorTwoStatus.ForeColor = Color.White;

                        f.chTwoOpen.Enabled = false;
                        f.chTwoClose.Enabled = true;
                        break;
                    case 3://数据采集器通道3打开成功
                        f.sensorThreeStatus.Text = "打开";
                        f.sensorThreeStatus.BackColor = Color.DarkSeaGreen;
                        f.sensorThreeStatus.ForeColor = Color.White;

                        f.chThreeOpen.Enabled = false;
                        f.chThreeClose.Enabled = true;
                        break;
                    case 4://数据采集器通道4打开成功
                        f.sensorFourStatus.Text = "打开";
                        f.sensorFourStatus.BackColor = Color.DarkSeaGreen;
                        f.sensorFourStatus.ForeColor = Color.White;

                        f.chFourOpen.Enabled = false;
                        f.chFourClose.Enabled = true;
                        break;
                    case 5://数据采集器通道5打开成功
                        f.sensorFiveStatus.Text = "打开";
                        f.sensorFiveStatus.BackColor = Color.DarkSeaGreen;
                        f.sensorFiveStatus.ForeColor = Color.White;

                        f.chFiveOpen.Enabled = false;
                        f.chFiveClose.Enabled = true;
                        break;
                    case 6://数据采集器通道1打开失败
                        f.chOneOpen.Enabled = true;
                        f.chOneClose.Enabled = false;
                        f.sensorOneStatus.Text = "打开失败";
                        f.sensorOneStatus.ForeColor = Color.Black;
                        f.sensorOneStatus.BackColor = Color.Yellow;
                        break;
                    case 7://数据采集器通道2打开失败
                        f.chTwoOpen.Enabled = true;
                        f.chTwoClose.Enabled = false;
                        f.sensorTwoStatus.Text = "打开失败";
                        f.sensorTwoStatus.ForeColor = Color.Black;
                        f.sensorTwoStatus.BackColor = Color.Yellow;
                        break;
                    case 8://数据采集器通道3打开失败
                        f.chThreeOpen.Enabled = true;
                        f.chThreeClose.Enabled = false;
                        f.sensorThreeStatus.Text = "打开失败";
                        f.sensorThreeStatus.ForeColor = Color.Black;
                        f.sensorThreeStatus.BackColor = Color.Yellow;
                        break;
                    case 9://数据采集器通道4打开失败
                        f.chFourOpen.Enabled = true;
                        f.chFourClose.Enabled = false;
                        f.sensorFourStatus.Text = "打开失败";
                        f.sensorFourStatus.ForeColor = Color.Black;
                        f.sensorFourStatus.BackColor = Color.Yellow;
                        break;
                    case 10://数据采集器通道5打开失败
                        f.chFiveOpen.Enabled = true;
                        f.chFiveClose.Enabled = false;
                        f.sensorFiveStatus.Text = "打开失败";
                        f.sensorFiveStatus.ForeColor = Color.Black;
                        f.sensorFiveStatus.BackColor = Color.Yellow;
                        break;
                    case 11://数据采集器通道1关闭成功的委托回调显示
                        f.chOneClose.Enabled = false;
                        f.chOneOpen.Enabled = true;
                        f.sensorOneStatus.Text = "关闭";
                        f.sensorOneStatus.BackColor = Color.Red;
                        f.sensorOneStatus.ForeColor = Color.White;
                        break;
                    case 12://数据采集器通道2关闭成功
                        f.chTwoClose.Enabled = false;
                        f.chTwoOpen.Enabled = true;
                        f.sensorTwoStatus.Text = "关闭";
                        f.sensorTwoStatus.BackColor = Color.Red;
                        f.sensorTwoStatus.ForeColor = Color.White;
                        break;
                    case 13://数据采集器通道3关闭成功
                        f.chThreeClose.Enabled = false;
                        f.chThreeOpen.Enabled = true;
                        f.sensorThreeStatus.Text = "关闭";
                        f.sensorThreeStatus.BackColor = Color.Red;
                        f.sensorThreeStatus.ForeColor = Color.White;
                        break;
                    case 14://数据采集器通道4关闭成功
                        f.chFourClose.Enabled = false;
                        f.chFourOpen.Enabled = true;
                        f.sensorFourStatus.Text = "关闭";
                        f.sensorFourStatus.BackColor = Color.Red;
                        f.sensorFourStatus.ForeColor = Color.White;
                        break;
                    case 15://数据采集器通道5关闭成功
                        f.chFiveClose.Enabled = false;
                        f.chFiveOpen.Enabled = true;
                        f.sensorFiveStatus.Text = "关闭";
                        f.sensorFiveStatus.BackColor = Color.Red;
                        f.sensorFiveStatus.ForeColor = Color.White;
                        break;
                    case 16://数据采集器通道1关闭失败
                        f.sensorOneStatus.Text = "关闭失败";
                        f.sensorOneStatus.ForeColor = Color.Black;
                        f.sensorOneStatus.BackColor = Color.Yellow;
                        f.chOneClose.Enabled = true;
                        f.chOneOpen.Enabled = false;
                        break;
                    case 17://数据采集器通道2关闭失败
                        f.sensorTwoStatus.Text = "关闭失败";
                        f.sensorTwoStatus.ForeColor = Color.Black;
                        f.sensorTwoStatus.BackColor = Color.Yellow;
                        f.chTwoClose.Enabled = true;
                        f.chTwoOpen.Enabled = false;
                        break;
                    case 18://数据采集器通道3关闭失败
                        f.sensorThreeStatus.Text = "关闭失败";
                        f.sensorThreeStatus.ForeColor = Color.Black;
                        f.sensorThreeStatus.BackColor = Color.Yellow;
                        f.chThreeClose.Enabled = true;
                        f.chThreeOpen.Enabled = false;
                        break;
                    case 19://数据采集器通道4关闭失败
                        f.sensorFourStatus.Text = "关闭失败";
                        f.sensorFourStatus.ForeColor = Color.Black;
                        f.sensorFourStatus.BackColor = Color.Yellow;
                        f.chFourClose.Enabled = true;
                        f.chFourOpen.Enabled = false;
                        break;
                    case 20://数据采集器通道5关闭失败
                        f.sensorFiveStatus.Text = "关闭失败";
                        f.sensorFiveStatus.ForeColor = Color.Black;
                        f.sensorFiveStatus.BackColor = Color.Yellow;
                        f.chFiveClose.Enabled = true;
                        f.chFiveOpen.Enabled = false;
                        break;
                }
            }
            catch
            {
 
            }
        }









        /// <summary>
        /// 需要定时器定时检查与云服务器连接是否存在的代码
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        void Timer_Check_Elapsed(object sender, System.Timers.ElapsedEventArgs e)
        {
            Thread.CurrentThread.IsBackground = true;
            Timer_Check.Enabled = false;
            try
            {
                if ((ECSClient.Connected == false) || ((ECSClient.Poll(1000, SelectMode.SelectRead)) && (ECSClient.Available == 0)))//连接不存在判断，若是连接不存在则需要重新连接
                {
                    if (ConnectToServer())
                        isExist = true;
                    else
                        isExist = false;
                }
                else
                {
                    isExist = true;//这样代表的是连接存在
                }
            }
            catch
            {

            }
            Main.ClearMemory();
            Timer_Check.Enabled = true;
        }



        /// <summary>
        /// 1.连接云服务器
        /// </summary>
        /// <returns></returns>
        public bool ConnectToServer()
        {
            try
            {
                ECSClient = new Socket(AddressFamily.InterNetwork, SocketType.Stream, ProtocolType.Tcp);//1.c初始化客户端，创建客户端对象

                //2.更新本地变量,从配置文件中读取下位机的IP地址以及端口
                DataSet ds = new DataSet();

                ds.ReadXml(@".\IPandPortConfig.xml");//读取配置文件，在配置文件中找到云服务器的IP地址以及端口号
                string dataSrvIP = ds.Tables[0].Rows[0]["ECSSrvIP"].ToString();
                int dataSrvPort = Convert.ToInt32(ds.Tables[0].Rows[0]["ECSSrvPort"].ToString());
                IPAddress IP = IPAddress.Parse(dataSrvIP);

                ECSClient.Connect(IP, dataSrvPort);//3.使用Connect方法与服务器建立连接

                DateTime nowtime = DateTime.Now;//4.间歇延时
                while (nowtime.AddSeconds(1) > DateTime.Now)
                { }

                if (ECSClient != null)
                {
                    //Console.WriteLine("连接服务器成功！");
                    isExist = true;


                    //只要服务器连接成功，就创建接收数据的线程
                    //2.开启接收服务器信息的线程
                    Thread thEcsReceiveMesg = new Thread(ReceiveMessage);//接收云数据库服务器信息的线程
                    thEcsReceiveMesg.Start();

                    return true;

                }

                else
                {
                    //Console.WriteLine("连接服务器失败！");
                    isExist = false;
                    return false;
                }


            }
            catch (Exception ex)
            {
                //Console.WriteLine("连接服务器函数ConnectToServer出现异常！" + ex.Message);
                LogClass.WriteLogFile("连接云服务器出现异常！" + ex.Message);
                return false;
            }
        }


        /// <summary>
        /// 2.接收服务器发过来的数据，并作出相应的处理,接收数据应该是处在一个循环接收过程中，只要连接存在就应该一直接收
        /// </summary>
        public void ReceiveMessage()
        {
            //ECSClient.ReceiveTimeout = 3000;
            try
            {
                while (isExist == true)//判断只有在服务器连接存在下才进行数据的接收，该连接可以一直接收数据
                {
                    byte[] bytes = new byte[8192];
                    int readBytes = 0;

                    readBytes = ECSClient.Receive(bytes, 0, 8192, SocketFlags.None);

                    string content = null;

                    content = Encoding.ASCII.GetString(bytes, 0, readBytes);//这样直接接收到的是字符串信息

                    content = content.Trim();
                    
                    //然后将该字符串作为指令信息发送给接驳盒或者数据采集器，----------------------
                    //1.如果首字母是以B开头的，代表需要将指令发送给接驳盒
                    if (content.StartsWith("B"))
                    {
                        content = content.Substring(1, content.Length - 1);//将指令串中的第一个字符去掉
                        if (content.Length < 56)//若指令长度小于56个字节，代表该指令是发送的接驳盒的通断指令
                        {
                            switch (content)
                            {
                                //以下都是对于接驳盒发送指令的下发
                                case "$SET+01+SIIM1+Power12V#":
                                    ExecuteJbChnl(content, 1);
                                    break;
                                case "$SET+01+SIIM2+Power12V#":
                                    ExecuteJbChnl(content, 2);
                                    break;
                                case "$SET+01+SIIM3+Power12V#":
                                    ExecuteJbChnl(content, 3);
                                    break;
                                case "$SET+01+SIIM4+Power12V#":
                                    ExecuteJbChnl(content, 4);
                                    break;
                                case "$SET+01+SIIM5+Power12V#":
                                    ExecuteJbChnl(content, 5);
                                    break;
                                //以下指令是对于接驳盒关闭指令的执行
                                case "$SET+01+SIIM1+Close#":
                                    ExecuteJbChnl(content, 11);
                                    break;
                                case "$SET+01+SIIM2+Close#":
                                    ExecuteJbChnl(content, 12);
                                    break;
                                case "$SET+01+SIIM3+Close#":
                                    ExecuteJbChnl(content, 13);
                                    break;
                                case "$SET+01+SIIM4+Close#":
                                    ExecuteJbChnl(content, 14);
                                    break;
                                case "$SET+01+SIIM5+Close#":
                                    ExecuteJbChnl(content, 15);
                                    break;

                            }
                        }
                        else if (content.Length >= 56)//这种情况发送的是接驳盒设置上下限的指令
                        {
                            switch(content.Substring(0,13))
                            {
                                case "$SET+01+CurAH":
                                    ExecuteJBLimits(content,1);
                                    break;
                                case "$SET+01+CurBH":
                                    ExecuteJBLimits(content, 2);
                                    break;
                                case "$SET+01+CurCH":
                                    ExecuteJBLimits(content, 3);
                                    break;
                                case "$SET+01+CurDH":
                                    ExecuteJBLimits(content, 4);
                                    break;
                                case "$SET+01+CurEH":
                                    ExecuteJBLimits(content, 5);
                                    break;
                            }

                        }

                    }
                    else if (content.StartsWith("A"))//如果接收到的云服务器发送过来的指令是以字母A开头的话，代表是将指令发送给数据采集器
                    {

                        content = content.Substring(1, content.Length - 1);//将指令串中的第一个字符去掉
                        _4MyClientClass3 expCmd = new _4MyClientClass3(f);

                        if (content.Length < 56)
                        {
                            switch (content)
                            {

                                case "$SET+01+SIIM1+Power12V#"://通道1打开指令
                                    if (expCmd.ExecuteCmd("$SET+01+SIIM1+Power12V#", 2, 1))//按照字符串指令形式发送给MIO板子
                                    {
                                        LogCommand.WriteLogFile("云服务器远程执行数据采集器通道1打开成功！");
                                        f.Invoke(showDataInfocallback, 1);
                                    }
                                    else
                                    {
                                        LogCommand.WriteLogFile("云服务器远程执行数据采集器通道1打开失败！");
                                        f.Invoke(showDataInfocallback, 6);

                                    }
                                    break;
                                case "$SET+01+SIIM2+Power12V#"://通道2打开指令
                                    if (expCmd.ExecuteCmd("$SET+01+SIIM2+Power12V#", 2, 1))//按照字符串指令形式发送给MIO板子
                                    {
                                        LogCommand.WriteLogFile("云服务器远程执行数据采集器通道2打开成功！");
                                        f.Invoke(showDataInfocallback, 2);
                                    }
                                    else
                                    {
                                        LogCommand.WriteLogFile("云服务器远程执行数据采集器通道2打开失败！");
                                        f.Invoke(showDataInfocallback, 7);

                                    }

                                    break;
                                case "$SET+01+SIIM3+Power12V#"://通道3打开指令
                                    if (expCmd.ExecuteCmd("$SET+01+SIIM3+Power12V#", 2, 1))//按照字符串指令形式发送给MIO板子
                                    {
                                        LogCommand.WriteLogFile("云服务器远程执行数据采集器通道3打开成功！");
                                        f.Invoke(showDataInfocallback, 3);
                                    }
                                    else
                                    {
                                        LogCommand.WriteLogFile("云服务器远程执行数据采集器通道3打开失败！");
                                        f.Invoke(showDataInfocallback, 8);

                                    }
                                    break;
                                case "$SET+01+SIIM4+Power12V#"://通道4打开指令
                                    if (expCmd.ExecuteCmd("$SET+01+SIIM4+Power12V#", 2, 1))//按照字符串指令形式发送给MIO板子
                                    {
                                        LogCommand.WriteLogFile("云服务器执行数据采集器通道4打开成功！");
                                        f.Invoke(showDataInfocallback, 4);
                                    }
                                    else
                                    {
                                        LogCommand.WriteLogFile("云服务器远程执行数据采集器通道4打开失败！");
                                        f.Invoke(showDataInfocallback, 9);

                                    }
                                    break;
                                case "$SET+01+SIIM5+Power12V#"://通道5打开指令
                                    if (expCmd.ExecuteCmd("$SET+01+SIIM5+Power12V#", 2, 1))//按照字符串指令形式发送给MIO板子
                                    {
                                        LogCommand.WriteLogFile("云服务器远程执行数据采集器通道5打开成功！");
                                        f.Invoke(showDataInfocallback, 5);
                                    }
                                    else
                                    {
                                        LogCommand.WriteLogFile("云服务器远程执行数据采集器通道5打开失败！");
                                        f.Invoke(showDataInfocallback, 10);

                                    }
                                    break;
                                case "$SET+01+SIIM1+Close#"://数据采集器通道1关闭指令
                                    if (expCmd.ExecuteCmd("$SET+01+SIIM1+Close#", 2, 1))
                                    {
                                        LogCommand.WriteLogFile("云服务器远程执行数据采集器通道1关闭成功！");
                                        f.Invoke(showDataInfocallback, 11);

                                    }
                                    else
                                    {
                                        LogCommand.WriteLogFile("云服务器远程执行数据采集器通道1关闭失败！");
                                        f.Invoke(showDataInfocallback, 16);
                                    }
                                    break;
                                case "$SET+01+SIIM2+Close#"://数据采集器通道2关闭指令
                                    if (expCmd.ExecuteCmd("$SET+01+SIIM2+Close#", 2, 1))
                                    {
                                        LogCommand.WriteLogFile("云服务器远程执行数据采集器通道2关闭成功！");
                                        f.Invoke(showDataInfocallback, 12);

                                    }
                                    else
                                    {
                                        LogCommand.WriteLogFile("云服务器远程执行数据采集器通道2关闭失败！");
                                        f.Invoke(showDataInfocallback, 17);
                                    }
                                    break;
                                case "$SET+01+SIIM3+Close#"://数据采集器通道3关闭指令
                                    if (expCmd.ExecuteCmd("$SET+01+SIIM3+Close#", 2, 1))
                                    {
                                        LogCommand.WriteLogFile("云服务器远程执行数据采集器通道3关闭成功！");
                                        f.Invoke(showDataInfocallback, 13);

                                    }
                                    else
                                    {
                                        LogCommand.WriteLogFile("云服务器远程执行数据采集器通道3关闭失败！");
                                        f.Invoke(showDataInfocallback, 18);
                                    }
                                    break;
                                case "$SET+01+SIIM4+Close#"://数据采集器通道4关闭指令
                                    if (expCmd.ExecuteCmd("$SET+01+SIIM4+Close#", 2, 1))
                                    {
                                        LogCommand.WriteLogFile("云服务器远程执行数据采集器通道4关闭成功！");
                                        f.Invoke(showDataInfocallback, 14);

                                    }
                                    else
                                    {
                                        LogCommand.WriteLogFile("云服务器远程执行数据采集器通道4关闭失败！");
                                        f.Invoke(showDataInfocallback, 19);
                                    }
                                    break;
                                case "$SET+01+SIIM5+Close#"://数据采集器通道5关闭指令
                                    if (expCmd.ExecuteCmd("$SET+01+SIIM5+Close#", 2, 1))
                                    {
                                        LogCommand.WriteLogFile("云服务器远程执行数据采集器通道5关闭成功！");
                                        f.Invoke(showDataInfocallback, 15);

                                    }
                                    else
                                    {
                                        LogCommand.WriteLogFile("云服务器远程执行数据采集器通道5关闭失败！");
                                        f.Invoke(showDataInfocallback, 20);
                                    }
                                    break;
                            }                           
                        }
                        else if (content.Length >= 56)//发送的是数据采集器的上下限的指令
                        {

                            switch (content.Substring(0, 13))
                            {
                                case "$SET+01+CurAH":
                                    if (expCmd.ExecuteCmd(content, 2, 1))//函数ExecuteCmd()已经默认包含重发三次的指令
                                    {
                                        LogCommand.WriteLogFile("云服务器远程执行设置数据采集器通道1报警阈值成功！");

                                        string sql = "update seafloor_elecLimits  set limitsCurHigh = '" + content.Substring(13,6) + "',limitsCurLow = '" + content.Substring(25,6) + "',limitsVolHigh = '" + content.Substring(37,6) + "', limitsVolLow = '" + content.Substring(49,6) + "' where limitsType = '数据采集器' and limitsNum = 1";
                                        SqlHelper.ExecuteNonQuery(sql);
                                    }

                                    else
                                        LogCommand.WriteLogFile("云服务器执行设置数据采集器通道1报警阈值失败！");
                                    break;
                                case "$SET+01+CurBH":

                                    if (expCmd.ExecuteCmd(content, 2, 1))//函数ExecuteCmd()已经默认包含重发三次的指令
                                    {
                                        LogCommand.WriteLogFile("云服务器远程执行设置数据采集器通道2报警阈值成功！");

                                        string sql = "update seafloor_elecLimits  set limitsCurHigh = '" + content.Substring(13,6) + "',limitsCurLow = '" + content.Substring(25,6) + "',limitsVolHigh = '" + content.Substring(37,6) + "', limitsVolLow = '" + content.Substring(49,6) + "' where limitsType = '数据采集器' and limitsNum = 2";
                                        SqlHelper.ExecuteNonQuery(sql);
                                    }

                                    else
                                        LogCommand.WriteLogFile("云服务器执行设置数据采集器通道2报警阈值失败！");
                                    break;
                                    
                                case "$SET+01+CurCH":
                                    if (expCmd.ExecuteCmd(content, 2, 1))//函数ExecuteCmd()已经默认包含重发三次的指令
                                    {
                                        LogCommand.WriteLogFile("云服务器远程执行设置数据采集器通道3报警阈值成功！");

                                        string sql = "update seafloor_elecLimits  set limitsCurHigh = '" + content.Substring(13,6) + "',limitsCurLow = '" + content.Substring(25,6) + "',limitsVolHigh = '" + content.Substring(37,6) + "', limitsVolLow = '" + content.Substring(49,6) + "' where limitsType = '数据采集器' and limitsNum = 3";
                                        SqlHelper.ExecuteNonQuery(sql);
                                    }

                                    else
                                        LogCommand.WriteLogFile("云服务器执行设置数据采集器通道3报警阈值失败！");
                                    break;
                                case "$SET+01+CurDH":
                                    if (expCmd.ExecuteCmd(content, 2, 1))//函数ExecuteCmd()已经默认包含重发三次的指令
                                    {
                                        LogCommand.WriteLogFile("云服务器远程执行设置数据采集器通道4报警阈值成功！");

                                        string sql = "update seafloor_elecLimits  set limitsCurHigh = '" + content.Substring(13,6) + "',limitsCurLow = '" + content.Substring(25,6) + "',limitsVolHigh = '" + content.Substring(37,6) + "', limitsVolLow = '" + content.Substring(49,6) + "' where limitsType = '数据采集器' and limitsNum = 4";
                                        SqlHelper.ExecuteNonQuery(sql);
                                    }

                                    else
                                        LogCommand.WriteLogFile("云服务器执行设置数据采集器通道4报警阈值失败！");
                                    break;
                                case "$SET+01+CurEH":
                                   if (expCmd.ExecuteCmd(content, 2, 1))//函数ExecuteCmd()已经默认包含重发三次的指令
                                    {
                                        LogCommand.WriteLogFile("云服务器远程执行设置数据采集器通道5报警阈值成功！");

                                        string sql = "update seafloor_elecLimits  set limitsCurHigh = '" + content.Substring(13,6) + "',limitsCurLow = '" + content.Substring(25,6) + "',limitsVolHigh = '" + content.Substring(37,6) + "', limitsVolLow = '" + content.Substring(49,6) + "' where limitsType = '数据采集器' and limitsNum = 5";
                                        SqlHelper.ExecuteNonQuery(sql);
                                    }
                                    else
                                        LogCommand.WriteLogFile("云服务器执行设置数据采集器通道5报警阈值失败！");
                                    break;
                            }

                        }
                        
                    }
                }

            }
            catch (SocketException exp)
            {
                //LogClass.WriteLogFile("上位机客户端接收反馈信息异常！"+exp.Message);
                LogClass.WriteLogFile("上位机超时没有接到反馈！" + exp.Message);
                //return "1";//注意当出现超时接收异常时不能返回NULL，返回NULL之后，求解.trim()出现新的异常，导致不能重发
            }
        }

        /// <summary>
        /// 用于处理接驳盒指令执行的函数（接驳盒的指令主要涉及的通道打开、通道关闭指令）
        /// </summary>
        /// <param name="content"></param>
        /// <param name="flagOn"></param>
        /// <param name="showFlag"></param>
        public void ExecuteJbChnl(string content, int showFlag)
        {


            switch (showFlag)
            {
                case 1://次级接驳盒通道1打开标志
                    _3ReceieveMsgClass.flagOnA1 = 0;
                    break;
                case 2://次级接驳盒通道2打开标志
                    _3ReceieveMsgClass.flagOnA2 = 0;
                    break;
                case 3://次级接驳盒通道3打开标志
                    _3ReceieveMsgClass.flagOnA3 = 0;
                    break;
                case 4://次级接驳盒通道4打开标志
                    _3ReceieveMsgClass.flagOnA4 = 0;
                    break;
                case 5://次级接驳盒通道5打开标志
                    _3ReceieveMsgClass.flagOnA5 = 0;
                    break;
                case 11://次级接驳盒通道1关闭标志
                    _3ReceieveMsgClass.flagOffA1 = 0;
                    break;
                case 12://次级接驳盒通道2关闭标志
                    _3ReceieveMsgClass.flagOffA2 = 0;
                    break;
                case 13://次级接驳盒通道3关闭标志
                    _3ReceieveMsgClass.flagOffA3 = 0;
                    break;
                case 14://次级接驳盒通道4关闭标志
                    _3ReceieveMsgClass.flagOffA4 = 0;
                    break;
                case 15://次级接驳盒通道5关闭标志
                    _3ReceieveMsgClass.flagOffA5 = 0;
                    break;
            }
            try
            {
                if ((showFlag >= 1) && (showFlag <= 5))
                {
                    LogCommand.WriteLogFile("云服务器远程执行接驳盒通道" + showFlag.ToString() + "打开！");
                }
                else if (showFlag >= 11 && showFlag <= 15)
                {
                    LogCommand.WriteLogFile("云服务器远程执行接驳盒通道" + (showFlag - 10).ToString() + "关闭！");
                }

                if (f.canBConnect.Text == "连接")
                {
                    for (int i = _1MySerClass.userList.Count - 1; i >= 0; i--)
                    {
                        _3ReceieveMsgClass ct = _1MySerClass.userList[i];
                        if (!ct.tcpClient.Connected || ((ct.tcpClient.Poll(1000, SelectMode.SelectRead)) && (ct.tcpClient.Available == 0)))
                        {
                            _1MySerClass.userList.Remove(ct);
                            continue;
                        }
                        else if (ct.nodeIP == f.txtBIP.Text.Trim())
                        {
                            ct.SendMessage(content, 2);

                            if (Main.Delay(1))//延时10s
                            {
                                int flagOn = 0;
                                switch (showFlag)
                                {
                                    case 1:
                                        flagOn = _3ReceieveMsgClass.flagOnA1;
                                        break;
                                    case 2:
                                        flagOn = _3ReceieveMsgClass.flagOnA2;
                                        break;
                                    case 3:
                                        flagOn = _3ReceieveMsgClass.flagOnA3;
                                        break;
                                    case 4:
                                        flagOn = _3ReceieveMsgClass.flagOnA4;
                                        break;
                                    case 5:
                                        flagOn = _3ReceieveMsgClass.flagOnA5;
                                        break;
                                    case 11:
                                        flagOn = _3ReceieveMsgClass.flagOffA1;
                                        break;
                                    case 12:
                                        flagOn = _3ReceieveMsgClass.flagOffA2;
                                        break;
                                    case 13:
                                        flagOn = _3ReceieveMsgClass.flagOffA3;
                                        break;
                                    case 14:
                                        flagOn = _3ReceieveMsgClass.flagOffA4;
                                        break;
                                    case 15:
                                        flagOn = _3ReceieveMsgClass.flagOffA5;
                                        break;
                                }

                                if (flagOn == 1)
                                {
                                    if (showFlag >= 1 && showFlag <= 5)
                                    {
                                        LogCommand.WriteLogFile("云服务器远程执行接驳盒通道" + showFlag.ToString() + "打开成功！");
                                        f.Invoke(showJBInfocallback, showFlag);
                                    }
                                    else if (showFlag >= 11 && showFlag <= 15)
                                    {
                                        LogCommand.WriteLogFile("云服务器远程执行接驳盒通道" + (showFlag - 10).ToString() + "关闭成功！");
                                        f.Invoke(showJBInfocallback, showFlag);
                                    }

                                }
                                else
                                {
                                    ct.SendMessage(content, 2);//第二次重发
                                    Main.Delay(2);

                                    //int flagOn = 0;
                                    switch (showFlag)
                                    {
                                        case 1:
                                            flagOn = _3ReceieveMsgClass.flagOnA1;
                                            break;
                                        case 2:
                                            flagOn = _3ReceieveMsgClass.flagOnA2;
                                            break;
                                        case 3:
                                            flagOn = _3ReceieveMsgClass.flagOnA3;
                                            break;
                                        case 4:
                                            flagOn = _3ReceieveMsgClass.flagOnA4;
                                            break;
                                        case 5:
                                            flagOn = _3ReceieveMsgClass.flagOnA5;
                                            break;
                                        case 11:
                                            flagOn = _3ReceieveMsgClass.flagOffA1;
                                            break;
                                        case 12:
                                            flagOn = _3ReceieveMsgClass.flagOffA2;
                                            break;
                                        case 13:
                                            flagOn = _3ReceieveMsgClass.flagOffA3;
                                            break;
                                        case 14:
                                            flagOn = _3ReceieveMsgClass.flagOffA4;
                                            break;
                                        case 15:
                                            flagOn = _3ReceieveMsgClass.flagOffA5;
                                            break;
                                    }

                                    if (flagOn == 1)
                                    {

                                        if (showFlag >= 1 && showFlag <= 5)
                                        {
                                            LogCommand.WriteLogFile("云服务器远程执行接驳盒通道" + showFlag.ToString() + "打开成功！");
                                            f.Invoke(showJBInfocallback, showFlag);
                                        }
                                        else if (showFlag >= 11 && showFlag <= 15)
                                        {
                                            LogCommand.WriteLogFile("云服务器远程执行接驳盒通道" + (showFlag - 10).ToString() + "关闭成功！");
                                            f.Invoke(showJBInfocallback, showFlag);
                                        }
                                    }
                                    else
                                    {
                                        ct.SendMessage(content, 2);//第3次重发
                                        Main.Delay(2);

                                        //int flagOn = 0;
                                        switch (showFlag)
                                        {
                                            case 1:
                                                flagOn = _3ReceieveMsgClass.flagOnA1;
                                                break;
                                            case 2:
                                                flagOn = _3ReceieveMsgClass.flagOnA2;
                                                break;
                                            case 3:
                                                flagOn = _3ReceieveMsgClass.flagOnA3;
                                                break;
                                            case 4:
                                                flagOn = _3ReceieveMsgClass.flagOnA4;
                                                break;
                                            case 5:
                                                flagOn = _3ReceieveMsgClass.flagOnA5;
                                                break;
                                            case 11:
                                                flagOn = _3ReceieveMsgClass.flagOffA1;
                                                break;
                                            case 12:
                                                flagOn = _3ReceieveMsgClass.flagOffA2;
                                                break;
                                            case 13:
                                                flagOn = _3ReceieveMsgClass.flagOffA3;
                                                break;
                                            case 14:
                                                flagOn = _3ReceieveMsgClass.flagOffA4;
                                                break;
                                            case 15:
                                                flagOn = _3ReceieveMsgClass.flagOffA5;
                                                break;
                                        }

                                        if (flagOn == 1)
                                        {
                                            if (showFlag >= 1 && showFlag <= 5)
                                            {
                                                LogCommand.WriteLogFile("云服务器远程执行接驳盒通道" + showFlag.ToString() + "打开成功！");
                                                f.Invoke(showJBInfocallback, showFlag);
                                            }
                                            else if (showFlag >= 11 && showFlag <= 15)
                                            {
                                                LogCommand.WriteLogFile("云服务器远程执行接驳盒通道" + (showFlag - 10).ToString() + "关闭成功！");
                                                f.Invoke(showJBInfocallback, showFlag);
                                            }

                                        }
                                        else
                                        {
                                            if (showFlag >= 1 && showFlag <= 5)
                                            {
                                                LogCommand.WriteLogFile("云服务器远程执行接驳盒执行通道" + showFlag.ToString() + "打开失败！");
                                                f.Invoke(showJBInfocallback, showFlag + 5);
                                            }
                                            else if (showFlag >= 11 && showFlag <= 15)
                                            {
                                                LogCommand.WriteLogFile("云服务器远程执行接驳盒通道" + (showFlag - 10).ToString() + "关闭失败！");
                                                f.Invoke(showJBInfocallback, showFlag + 5);
                                            }


                                        }
                                    }
                                }
                            }
                            break;
                        }
                    }
                }
                else
                {
                    //MessageBox.Show("无可用连接！");
                }
            }
            catch (Exception exp)
            {
                LogClass.WriteLogFile("云服务器远程执行接驳盒执行通道" + showFlag.ToString() + "异常！" + exp.Message);
            }
            switch (showFlag)
            {
                case 1:
                    _3ReceieveMsgClass.flagOnA1 = 0;
                    break;
                case 2:
                    _3ReceieveMsgClass.flagOnA2 = 0;
                    break;
                case 3:
                    _3ReceieveMsgClass.flagOnA3 = 0;
                    break;
                case 4:
                    _3ReceieveMsgClass.flagOnA4 = 0;
                    break;
                case 5:
                    _3ReceieveMsgClass.flagOnA5 = 0;
                    break;
            }
        }


        /// <summary>
        /// 设置接驳盒各个通道上下限的指令
        /// </summary>
        /// <param name="content"></param>
        /// <param name="showFlag"></param>
        public void ExecuteJBLimits(string content,int showFlag)
        {

            //1.先从content指令串中，将电压电流的上下限取出来
            string txtAH = content.Substring(13,6);//电流值上限
            string txtAL = content.Substring(25,6);//电流值下限
            string txtVH = content.Substring(37,6);//电压值上限
            string txtVL = content.Substring(49,6);//电压值下限


            switch(showFlag)
            {
                case 1:
                    _3ReceieveMsgClass.flagA1 = 0;
                    break;
                case 2:
                    _3ReceieveMsgClass.flagA2 = 0;
                    break;
                case 3:
                    _3ReceieveMsgClass.flagA3 = 0;
                    break;
                case 4:
                    _3ReceieveMsgClass.flagA4 = 0;
                    break;
                case 5:
                    _3ReceieveMsgClass.flagA5 = 0;
                    break;
            }

            try
            {

                if (f.canBConnect.Text == "连接")
                {
                    for (int i = _1MySerClass.userList.Count - 1; i >= 0; i--)
                    {
                        _3ReceieveMsgClass ct = _1MySerClass.userList[i];
                        if (!ct.tcpClient.Connected || ((ct.tcpClient.Poll(1000, SelectMode.SelectRead)) && (ct.tcpClient.Available == 0)))
                        {
                            _1MySerClass.userList.Remove(ct);
                            continue;
                        }
                        else if (ct.nodeIP == f.txtBIP.Text.Trim())
                        {
                            ct.SendMessage(content, 2);

                            if (Main.Delay(1))//延时10s
                            {
                                int flagOn = 0;
                                switch (showFlag)
                                {
                                    case 1:
                                        flagOn = _3ReceieveMsgClass.flagA1;
                                        break;
                                    case 2:
                                        flagOn = _3ReceieveMsgClass.flagA2;
                                        break;
                                    case 3:
                                        flagOn = _3ReceieveMsgClass.flagA3;
                                        break;
                                    case 4:
                                        flagOn = _3ReceieveMsgClass.flagA4;
                                        break;
                                    case 5:
                                        flagOn = _3ReceieveMsgClass.flagA5;
                                        break;
                                }

                                if (flagOn == 1)//执行成功！
                                {
                                    LogCommand.WriteLogFile("云服务器远程设置通道"+showFlag.ToString()+"上下限指令成功！");

                                    string sql = "update seafloor_elecLimits set limitsCurHigh='" + txtAH.ToString() + "' ,limitsCurLow='" + txtAL.ToString() + "', limitsVolHigh='" + txtVH.ToString() + "',limitsVolLow='" + txtVL.ToString() + "' where limitsNum = '"+showFlag+"' and limitsType = '次级接驳盒'";
                                    SqlHelper.ExecuteNonQuery(sql);

                                }
                                else
                                {
                                    ct.SendMessage(content, 2);//第二次重发
                                    Main.Delay(2);

                                    //int flagOn = 0;
                                    switch (showFlag)
                                    {
                                        case 1:
                                            flagOn = _3ReceieveMsgClass.flagA1;
                                            break;
                                        case 2:
                                            flagOn = _3ReceieveMsgClass.flagA2;
                                            break;
                                        case 3:
                                            flagOn = _3ReceieveMsgClass.flagA3;
                                            break;
                                        case 4:
                                            flagOn = _3ReceieveMsgClass.flagA4;
                                            break;
                                        case 5:
                                            flagOn = _3ReceieveMsgClass.flagA5;
                                            break;
                                    }

                                    if (flagOn == 1)//第二遍上下限设置执行成功
                                    {

                                        LogCommand.WriteLogFile("云服务器远程设置通道" + showFlag.ToString() + "上下限指令成功！");

                                        string sql = "update seafloor_elecLimits set limitsCurHigh='" + txtAH.ToString() + "' ,limitsCurLow='" + txtAL.ToString() + "', limitsVolHigh='" + txtVH.ToString() + "',limitsVolLow='" + txtVL.ToString() + "' where limitsNum = '" + showFlag + "' and limitsType = '次级接驳盒'";
                                        SqlHelper.ExecuteNonQuery(sql);

                                    }
                                    else
                                    {
                                        ct.SendMessage(content, 2);//第3次重发
                                        Main.Delay(2);

                                        //int flagOn = 0;
                                        switch (showFlag)
                                        {
                                            case 1:
                                                flagOn = _3ReceieveMsgClass.flagA1;
                                                break;
                                            case 2:
                                                flagOn = _3ReceieveMsgClass.flagA2;
                                                break;
                                            case 3:
                                                flagOn = _3ReceieveMsgClass.flagA3;
                                                break;
                                            case 4:
                                                flagOn = _3ReceieveMsgClass.flagA4;
                                                break;
                                            case 5:
                                                flagOn = _3ReceieveMsgClass.flagA5;
                                                break;
                                        }

                                        if (flagOn == 1)
                                        {
                                            LogCommand.WriteLogFile("云服务器远程设置通道" + showFlag.ToString() + "上下限指令成功！");

                                            string sql = "update seafloor_elecLimits set limitsCurHigh='" + txtAH.ToString() + "' ,limitsCurLow='" + txtAL.ToString() + "', limitsVolHigh='" + txtVH.ToString() + "',limitsVolLow='" + txtVL.ToString() + "' where limitsNum = '" + showFlag + "' and limitsType = '次级接驳盒'";
                                            SqlHelper.ExecuteNonQuery(sql);
                                        }
                                        else
                                        {
                                            LogCommand.WriteLogFile("云服务器远程设置接驳盒通道" + showFlag.ToString() + "上下限失败！");
                                        }
                                    }
                                }
                            }
                            break;
                        }
                    }
                }
                else
                {
                    //MessageBox.Show("无可用连接！");
                }
            }
            catch(Exception exp)
            {
                LogClass.WriteLogFile("云服务器远程执行接驳盒通道上下限设置异常！"+exp.Message);
            }

            switch (showFlag)
            {
                case 1:
                    _3ReceieveMsgClass.flagA1 = 0;
                    break;
                case 2:
                    _3ReceieveMsgClass.flagA2 = 0;
                    break;
                case 3:
                    _3ReceieveMsgClass.flagA3 = 0;
                    break;
                case 4:
                    _3ReceieveMsgClass.flagA4 = 0;
                    break;
                case 5:
                    _3ReceieveMsgClass.flagA5 = 0;
                    break;
            }




 
        }



    }
}
