﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace OSNSystem
{
    public partial class SetCTD : Form
    {
        private int serial;
        private string commandHead;

        private int configMark;

        private Main f;

        /// <summary>
        /// CTD窗体的构造函数
        /// </summary>
        /// <param name="j"></param>
        public SetCTD(int j,Main frm)
        {
            InitializeComponent();
            serial = j;
            commandHead = null;
            configMark = 0;//进入配置模式的标志位
            f = frm;
        }     
        
        /// <summary>
        /// CTD窗体的加载函数
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void SetCTD_Load(object sender, EventArgs e)
        {
            try
            {
                if (Main.mark == 1)//如果这个mark标志为1代表更新了PC104的程序，PC104针对溶解氧指令的反馈也会更改
                {
                    string sql = "select commandhead from config where protocolname = 'CTD' and serial = '" + serial + "'";
                    DataTable dtTable = SqlHelper.ExecuteDataTable(sql);
                    commandHead = dtTable.Rows[0]["commandhead"].ToString();
                }
            }
            catch(Exception exp)
            {
                LogClass.WriteLogFile("CTD指令窗口加载异常！"+exp.Message);
            }
        }
        /// <summary>
        /// 1.CTD配置模式指令
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void button3_Click(object sender, EventArgs e)
        {
            this.Cursor = Cursors.WaitCursor;//设置鼠标等待箭头 
            configMark = 0;
            try
            {
                string cmdTotal = commandHead + "SET";
                LogCommand.WriteLogFile("执行CTD配置模式指令！");

                _4MyClientClass exp = new _4MyClientClass(f);

                if (exp.ExecuteCmd(cmdTotal, 2, serial))
                {
                    LogCommand.WriteLogFile("CTD配置模式执行成功！");
                    configMark = 1;//成功进入配置模式
                }

                else
                {
                    LogCommand.WriteLogFile("CTD配置模式执行失败！");
                    configMark = 0; //未进入配置模式
                }
                    
            }
            catch (Exception exp)
            {
                LogClass.WriteLogFile("CTD配置模式执行异常！" + exp.Message);
                configMark = 0;
            }

            this.Cursor = Cursors.Default;
        }
        /// <summary>
        /// 2.CTD锚系模式指令执行
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void button2_Click(object sender, EventArgs e)
        {
            this.Cursor = Cursors.WaitCursor;//设置鼠标等待箭头  
            try
            {
                string cmdTotal = commandHead + "MM";
                LogCommand.WriteLogFile("执行CTD锚系模式指令！");

                _4MyClientClass exp = new _4MyClientClass(f);

                if (exp.ExecuteCmd(cmdTotal, 2, serial))
                {
                    LogCommand.WriteLogFile("CTD锚系模式执行成功！");
                    configMark = 0;//未进入配置模式
                }
                    
                else
                    LogCommand.WriteLogFile("CTD锚系模式执行失败！");
            }
            catch (Exception exp)
            {
                LogClass.WriteLogFile("CTD锚系模式执行异常！" + exp.Message);
            }

            this.Cursor = Cursors.Default;
        }
        /// <summary>
        /// 3.执行CTD时间间隔设置
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void button1_Click(object sender, EventArgs e)
        {
            this.Cursor = Cursors.WaitCursor;
            try
            {
                if (configMark == 0)
                {
                    MessageBox.Show("请先执行1.配置模式");
                }
                else
                {
                    if (txtInterval.Text.ToString() == "")
                    {
                        MessageBox.Show("请输入正确的时间间隔：1-60");
                    }
                    else
                    {
                        string cmdTotal = commandHead + "SI=" + txtInterval.Text.ToString();
                        LogCommand.WriteLogFile("执行CTD设置时间间隔:" + txtInterval.Text.ToString());

                        _4MyClientClass exp = new _4MyClientClass(f);

                        if (exp.ExecuteCmd(cmdTotal, 2, serial))
                        {
                            LogCommand.WriteLogFile("CTD设置时间间隔执行成功！");
                        }

                        else
                            LogCommand.WriteLogFile("CTD设置时间间隔执行失败！");
                    }
                    
                }
            }
            catch(Exception exp)
            {
                LogClass.WriteLogFile("CTD设置时间间隔异常！"+exp.Message);
            }
            this.Cursor = Cursors.Default;
        }
    }
}
