﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Net.Sockets;

namespace OSNSystem
{
    public partial class SetCamera : Form
    {
        private Main f;
        public SetCamera(Main exp)
        {
            InitializeComponent();
            f = exp;
        }

        

        

        /// <summary>
        /// 摄像头打开
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void button1_Click(object sender, EventArgs e)
        {
            this.Cursor = Cursors.WaitCursor;
            _3ReceieveMsgClass.flagOpen = 0;
            try
            {
                if (f.canBConnect.Text == "连接")
                {
                    for (int i = _1MySerClass.userList.Count - 1; i >= 0; i--)
                    {
                        _3ReceieveMsgClass ct = _1MySerClass.userList[i];
                        if (!ct.tcpClient.Connected || ((ct.tcpClient.Poll(1000, SelectMode.SelectRead)) && (ct.tcpClient.Available == 0)))
                        {
                            _1MySerClass.userList.Remove(ct);
                            continue;
                        }
                        else if (ct.nodeIP == f.txtBIP.Text.Trim())
                        {

                            ct.SendMessage("D", 2);

                            if (Delay(1))//延时1s
                            {
                                if (_3ReceieveMsgClass.flagOpen == 1)
                                {
                                    MessageBox.Show("执行成功！");
                                    LogCommand.WriteLogFile("摄像头打开成功！");
                                }
                                else
                                {

                                    ct.SendMessage("D", 2);//第二次重发
                                    Delay(2);

                                    if (_3ReceieveMsgClass.flagOpen == 1)
                                    {
                                        MessageBox.Show("执行成功！");
                                        LogCommand.WriteLogFile("摄像头打开成功！");
                                    }
                                    else
                                    {
                                        ct.SendMessage("D", 2);//第3次重发
                                        Delay(2);

                                        if (_3ReceieveMsgClass.flagOpen == 1)
                                        {
                                            MessageBox.Show("执行成功！");
                                            LogCommand.WriteLogFile("摄像头打开成功！");
                                        }
                                        else
                                        {
                                            MessageBox.Show("执行失败！");
                                            LogCommand.WriteLogFile("摄像头打开失败！");
                                        }

                                    }
                                }

                            }

                            break;

                        }
                        else
                        {
                            MessageBox.Show("无有效连接！");
                        }
                    }
                }
                else
                {
                    MessageBox.Show("无可用连接！");
                }

            }
            catch (Exception exp)
            {
                LogClass.WriteLogFile("测试指令异常！" + exp.Message);
            }

            _3ReceieveMsgClass.flagOpen = 0;

            this.Cursor = Cursors.Default;
        }
        /// <summary>
        /// 自定义的延时函数
        /// </summary>
        /// <param name="delayTime"></param>
        /// <returns></returns>
        public bool Delay(int delayTime)
        {
            DateTime now = DateTime.Now;
            int s;
            do
            {
                TimeSpan spand = DateTime.Now - now;
                s = spand.Seconds;
                Application.DoEvents();
            }
            while (s < delayTime);
            return true;

        }
        /// <summary>
        /// 摄像头关闭
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void button2_Click(object sender, EventArgs e)
        {
            this.Cursor = Cursors.WaitCursor;
            _3ReceieveMsgClass.flagClose = 0;
            try
            {
                if (f.canBConnect.Text == "连接")
                {
                    for (int i = _1MySerClass.userList.Count - 1; i >= 0; i--)
                    {
                        _3ReceieveMsgClass ct = _1MySerClass.userList[i];
                        if (!ct.tcpClient.Connected || ((ct.tcpClient.Poll(1000, SelectMode.SelectRead)) && (ct.tcpClient.Available == 0)))
                        {
                            _1MySerClass.userList.Remove(ct);
                            continue;
                        }
                        else if (ct.nodeIP == f.txtBIP.Text.Trim())
                        {

                            ct.SendMessage("E", 2);

                            if (Delay(1))//延时1s
                            {
                                if (_3ReceieveMsgClass.flagClose == 1)
                                {
                                    MessageBox.Show("执行成功！");
                                    LogCommand.WriteLogFile("摄像头关闭成功！");
                                }
                                else
                                {

                                    ct.SendMessage("E", 2);//第二次重发
                                    Delay(2);

                                    if (_3ReceieveMsgClass.flagClose == 1)
                                    {
                                        MessageBox.Show("执行成功！");
                                        LogCommand.WriteLogFile("摄像头关闭成功！");
                                    }
                                    else
                                    {
                                        ct.SendMessage("E", 2);//第3次重发
                                        Delay(2);

                                        if (_3ReceieveMsgClass.flagClose == 1)
                                        {
                                            MessageBox.Show("执行成功！");
                                            LogCommand.WriteLogFile("摄像头关闭成功！");
                                        }
                                        else
                                        {
                                            MessageBox.Show("执行失败！");
                                            LogCommand.WriteLogFile("摄像头关闭失败！");
                                        }

                                    }
                                }

                            }

                            break;

                        }
                        else
                        {
                            MessageBox.Show("无有效连接！");
                        }
                    }
                }
                else
                {
                    MessageBox.Show("无可用连接！");
                }

            }
            catch (Exception exp)
            {
                LogClass.WriteLogFile("测试指令异常！" + exp.Message);
            }

            _3ReceieveMsgClass.flagClose = 0;

            this.Cursor = Cursors.Default;
        }
    }
}
