﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Net.Sockets;
using System.Threading;

namespace OSNSystem
{
    public partial class SetDO : Form
    {
        private int serial;//数据采集器所属的序列号
        private string commandHead;//下发指令所属的协议头
        private Main f;

        
        public SetDO(int j,Main frm)
        {
            InitializeComponent();
            serial = j;
            commandHead = null;
            f = frm;
        }
      
        /// <summary>
        /// 溶解氧指令设置窗体初始化加载
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void SetDO_Load(object sender, EventArgs e)
        {
            try
            {
                
                //Timer_Command.Elapsed += new System.Timers.ElapsedEventHandler(Timer_Command_Elapsed);
                //Timer_Command.Interval = 5000;//默认为5s
                //Timer_Command.Enabled = true;


            }
            catch (Exception exp)
            {
                LogClass.WriteLogFile("加载溶解氧指令设置界面异常！" + exp.Message);
            }

        }

        /// <summary>
        /// 将字符转换成其ASCII码对应的字符
        /// </summary>
        /// <param name="input"></param>
        /// <returns></returns>
        private string StrToASCII(string input)
        {
            StringBuilder sb = new StringBuilder(input.Length * 2);
            for (int i = 0; i < input.Length; i++)
            {
                sb.Append(((int)input[i]).ToString("X2"));
            }
            return sb.ToString();
        }
        /// <summary>
        /// 输入盐度值，通过MIO板发送给溶解氧传感器
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void button1_Click(object sender, EventArgs e)
        {
            this.Cursor = Cursors.WaitCursor;
            try
            {
                string cmd1 = txtSal.Text.ToString().Trim();                
                string cmdTotal = "$SETSal:" + cmd1 +"#";
                LogCommand.WriteLogFile("设置溶解氧计算所需要的盐度值为：" + txtSal.Text.ToString().Trim());//溶解氧计算所需的盐度值计入log文件中

                _4MyClientClass exp = new _4MyClientClass(f);

                if (exp.ExecuteCmd(cmdTotal, 2, serial))//已经包含三次重发机制
                {
                    LogCommand.WriteLogFile("设置溶解氧计算所需要的盐度数值成功！");               
                }
                else
                    LogCommand.WriteLogFile("设置溶解氧计算所需要的盐度数值失败！");
            }
            catch(Exception exp)
            {
                LogClass.WriteLogFile("设置溶解氧计算所需要的盐度数值指令执行异常！"+exp.Message);
            }
            this.Cursor = Cursors.Default;

        }
        /// <summary>
        /// 改变溶解氧的要数时间间隔
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void button2_Click(object sender, EventArgs e)
        {
            this.Cursor = Cursors.WaitCursor;
            try
            {
                Main.Timer_Command.Enabled = false;
                string tempMessage = txtInterval.Text.Trim().ToString();
                int interval = Convert.ToInt32(tempMessage);
                Main.Timer_Command.Interval = interval * 1000;//定时器的时间间隔单位为ms
                Main.Timer_Command.Enabled = true;
                Main.Timer_Command.AutoReset = true;
                MessageBox.Show("执行成功！");
            }
            catch(Exception exp)
            {
                LogClass.WriteLogFile("改变溶解氧的要数时间间隔指令异常！"+exp.Message);
            }

            this.Cursor = Cursors.Default;
        }

    
    }
}
