﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace OSNSystem
{
    public partial class SetChlTur : Form
    {

        private string commandHead;//下发指令所属的协议头
        private Main f;
        public SetChlTur(Main frm)
        {
            InitializeComponent();
            commandHead = null;
            f = frm;
        }
        /// <summary>
        /// 多参数指令界面初始化操作
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void SetMulti_Load(object sender, EventArgs e)
        {
            try
            {
                //if (Main.mark == 1)//如果这个mark标志为1代表更新了PC104的程序，PC104针对溶解氧指令的反馈也会更改
                //{
                //    string sql = "select commandhead from config where protocolname = '多参数'";
                //    DataTable dtTable = SqlHelper.ExecuteDataTable(sql);
                //    commandHead = dtTable.Rows[0]["commandhead"].ToString();
                //    comboBox1.Text = "0.2Hz";
                //}
            }
            catch(Exception exp)
            {
                LogClass.WriteLogFile("多参数传感器指令界面初始化异常！"+exp.Message);
            }
            
        }
        /// <summary>
        /// 多参数指令-改变采样频率
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void button1_Click(object sender, EventArgs e)
        {

            this.Cursor = Cursors.WaitCursor;//设置鼠标等待箭头  
            try
            {
                Main.Timer_ChlTur.Enabled = false;

                int interval = 0;

                switch (comboBox1.Text.ToString())
                {
                    case "5s":
                        interval = 5;
                        break;
                    case "10s":
                        interval = 10;
                        break;
                    case "15s":
                        interval = 15;
                        break;
                    case "20s":
                        interval = 20;
                        break;
                    case "30s":
                        interval = 30;
                        break;
                    case "40s":
                        interval = 40;
                        break;
                }
                Main.Timer_ChlTur.Interval = interval * 1000;
                Main.Timer_ChlTur.Enabled = true;
                Main.Timer_ChlTur.AutoReset = true;
                MessageBox.Show("执行成功！");

                LogCommand.WriteLogFile("执行多参数改变采样间隔指令！");
            }
            catch (Exception exp)
            {
                LogClass.WriteLogFile("多参数改变采样间隔执行异常！" + exp.Message);
            }

            this.Cursor = Cursors.Default;

        }
        /********额外用到的函数********/
        /// <summary>
        /// 将字符串转换成对应的ascii码，仍旧是字符串的形式
        /// </summary>
        /// <param name="input"></param>
        /// <returns></returns>
        public static string StrToASCII(string input)
        {
            StringBuilder sb = new StringBuilder(input.Length * 2);
            for (int i = 0; i < input.Length; i++)
            {
                sb.Append(((int)input[i]).ToString("X2"));
            }
            return sb.ToString();
        }
        /// <summary>
        /// 叶绿素浊度传感器转动清洁电刷指令，该指令为有反馈的指令，因此对于有反馈的指令应该使用短连接的方式建立与MIO的连接
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void button2_Click(object sender, EventArgs e)
        {
            this.Cursor = Cursors.WaitCursor;
            try
            {
                string cmd = "#A0105\r\n";

                _4MyClientClass exp = new _4MyClientClass(f);

                if (exp.ExecuteCmd(cmd, 2, 1))//已经包含三次重发机制
                {
                    LogCommand.WriteLogFile("执行叶绿素浊度传感器转动清洁电刷指令成功！");
                }
                else
                    LogCommand.WriteLogFile("执行叶绿素浊度传感器转动清洁电刷指令失败！");
                   
            }
            catch(Exception exp)
            {
                LogClass.WriteLogFile("开启叶绿素浊度传感器清洁电刷指令异常！"+exp.Message);
            }
            this.Cursor = Cursors.Default;
        }
        /// <summary>
        /// 叶绿素浊度传感器急停指令
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void button4_Click(object sender, EventArgs e)
        {
            this.Cursor = Cursors.WaitCursor;
            try
            {
                string cmd = "#A0104\r\n";

                _4MyClientClass exp = new _4MyClientClass(f);

                if (exp.ExecuteCmd(cmd, 2, 1))//已经包含三次重发机制
                {
                    LogCommand.WriteLogFile("执行叶绿素浊度传感器急停指令成功！");
                }
                else
                    LogCommand.WriteLogFile("执行叶绿素浊度传感器急停指令失败！");

            }
            catch (Exception exp)
            {
                LogClass.WriteLogFile("开启叶绿素浊度传感器急停指令异常！" + exp.Message);
            }
            this.Cursor = Cursors.Default;
        }
        
    }
}
