﻿/*
 * 时间：2020年9月21日11:29:01
 * 功能：处理高压舱电源电源参数以及界面显示
 */
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Drawing;

namespace OSNSystem
{
    class ThreadProcessHighPower
    {

        
        private object lockHCh = new object();//画高压舱状态参数图添加的锁
        private _2DrawClass drawExpHCh ;//画高压舱电状态添加实例，千万注意不能在此处进行初始化，否则窗体实例中的不是一个
        
        //1.类中的主要成员
        private byte[] receiveData;//用于接收原始读到的内容
        private int length;//接收原始读到的内容的长度
        Main f;//用于委托回调显示


        //2.显示高压舱电源相应的参数信息以及故障信息添加的回调函数

        //2.1显示高压舱相应故障信息的委托以及回调函数
        private delegate void delShowHighCabinFaultData(string name, string data, DateTime time, int i);
        private delShowHighCabinFaultData showHighCabinFaultDatacallback;

        /// <summary>
        /// 2.1高压舱7种故障类型显示
        /// </summary>
        /// <param name="name"></param>
        /// <param name="data"></param>
        /// <param name="time"></param>
        /// <param name="i"></param>
        private void ShowHighCabinFaultDataMethod(string name, string data, DateTime time, int i)
        {
            switch (i)
            {
                case 1://高压舱前端电流故障
                    f.dataGridView2.Rows[0].Cells["故障名称"].Value = name;
                    f.dataGridView2.Rows[0].Cells["报警数据"].Value = data;
                    f.dataGridView2.Rows[0].Cells["故障时间"].Value = time.ToString("yyyy-MM-dd HH:mm:ss");
                    break;
                case 2://高压舱电源前端电压故障
                    f.dataGridView2.Rows[1].Cells["故障名称"].Value = name;
                    f.dataGridView2.Rows[1].Cells["报警数据"].Value = data;
                    f.dataGridView2.Rows[1].Cells["故障时间"].Value = time.ToString("yyyy-MM-dd HH:mm:ss");
                    break;
                case 3://高压舱电源后端第一路电流故障
                    f.dataGridView2.Rows[2].Cells["故障名称"].Value = name;
                    f.dataGridView2.Rows[2].Cells["报警数据"].Value = data;
                    f.dataGridView2.Rows[2].Cells["故障时间"].Value = time.ToString("yyyy-MM-dd HH:mm:ss");
                    break;
                case 4://高压舱电源后端第1路电压故障
                    f.dataGridView2.Rows[3].Cells["故障名称"].Value = name;
                    f.dataGridView2.Rows[3].Cells["报警数据"].Value = data;
                    f.dataGridView2.Rows[3].Cells["故障时间"].Value = time.ToString("yyyy-MM-dd HH:mm:ss");
                    break;
                case 5://高压舱电源后端第2路电流故障
                    f.dataGridView2.Rows[4].Cells["故障名称"].Value = name;
                    f.dataGridView2.Rows[4].Cells["报警数据"].Value = data;
                    f.dataGridView2.Rows[4].Cells["故障时间"].Value = time.ToString("yyyy-MM-dd HH:mm:ss");
                    break;
                case 6://高压舱电源后端第2路电压故障
                    f.dataGridView2.Rows[5].Cells["故障名称"].Value = name;
                    f.dataGridView2.Rows[5].Cells["报警数据"].Value = data;
                    f.dataGridView2.Rows[5].Cells["故障时间"].Value = time.ToString("yyyy-MM-dd HH:mm:ss");
                    break;
                case 7://高压舱电源温度故障
                    f.dataGridView2.Rows[6].Cells["故障名称"].Value = name;
                    f.dataGridView2.Rows[6].Cells["报警数据"].Value = data;
                    f.dataGridView2.Rows[6].Cells["故障时间"].Value = time.ToString("yyyy-MM-dd HH:mm:ss");
                    break;
            }
        }


        //2.2显示高压舱主接驳盒通道异常 委托回调函数
        private delegate void delShowHighErrorSignal(int i);
        private delShowHighErrorSignal showHighErrorSignalcallback;

        private void ShowHighErrorSignalMethod(int i)
        {
            switch (i)
            {
                case 1:
                    f.txtACh0Logo.Text = "异常";
                    f.txtACh0Logo.BackColor = Color.Red;
                    f.txtACh0Logo.ForeColor = Color.White;
                    break;
                case 2:
                    f.txtACh1Logo.Text = "异常";
                    f.txtACh1Logo.BackColor = Color.Red;
                    f.txtACh1Logo.ForeColor = Color.White;
                    break;
                case 3:
                    f.txtACh2Logo.Text = "异常";
                    f.txtACh2Logo.BackColor = Color.Red;
                    f.txtACh2Logo.ForeColor = Color.White;
                    break;
            }
        }

        //2.3显示高压舱电源主接驳盒参数信息委托回调
        private delegate void delShowHighStatus(string strFVol,string strFCur,string strBVol1,string strBCur1,string strBVol2,string strBCur2,string strTemp,string strFPow,string strBPow1,string strBPow2,DateTime dt);
        private delShowHighStatus showHighStatuscallback;
        /// <summary>
        /// 
        /// </summary>
        /// <param name="strFVol"></param>前端电压
        /// <param name="strFCur"></param>前端电流
        /// <param name="strBVol1"></param>后端第1路电压
        /// <param name="strBCur1"></param>后端第1路电流
        /// <param name="strBVol2"></param>后端第2路电压
        /// <param name="strBCur2"></param>后端第2路电流
        /// <param name="strTemp"></param>舱内温度
        /// <param name="strFPow"></param>前端功率
        /// <param name="strBPow1"></param>后端第一路功率
        /// <param name="strBPow2"></param>后端第2路功率
        private void ShowHighStatusMethod(string strFVol, string strFCur, string strBVol1, string strBCur1, string strBVol2, string strBCur2, string strTemp, string strFPow, string strBPow1, string strBPow2,DateTime dt)
        {
            //参数显示的字体设置
            FontClass fontType = new FontClass();


            f.txtACh0Vol.Font = fontType.fontLed;
            f.txtACh1Vol.Font = fontType.fontLed;
            f.txtACh2Vol.Font = fontType.fontLed;


            f.txtACh0Cur.Font = fontType.fontLed;
            f.txtACh1Cur.Font = fontType.fontLed;
            f.txtACh2Cur.Font = fontType.fontLed;

            f.txtATemp.Font = fontType.fontLed;

            f.txtACh0Power.Font = fontType.fontLed;
            f.txtACh1Power.Font = fontType.fontLed;
            f.txtACh2Power.Font = fontType.fontLed;

            f.txtACh0Time.Font = fontType.fontLed;
            f.txtACh1Time.Font = fontType.fontLed;
            f.txtACh2Time.Font = fontType.fontLed;


            /***************************************/


            f.txtACh0Vol.Text = strFVol;
            f.txtACh1Vol.Text = strBVol1;
            f.txtACh2Vol.Text = strBVol2;


            f.txtACh0Cur.Text = strFCur;
            f.txtACh1Cur.Text = strBCur1;
            f.txtACh2Cur.Text = strBCur2;

            f.txtATemp.Text = strTemp;

            f.txtACh0Power.Text = strFPow;
            f.txtACh1Power.Text = strBPow1;
            f.txtACh2Power.Text = strBPow2;

            f.txtACh0Time.Text = dt.ToString("yyyy-MM-dd HH:mm:ss");
            f.txtACh1Time.Text = dt.ToString("yyyy-MM-dd HH:mm:ss");
            f.txtACh2Time.Text = dt.ToString("yyyy-MM-dd HH:mm:ss");

        }

        


        /// <summary>
        /// 处理高压舱状态参数类的构造函数
        /// </summary>
        /// <param name="data"></param>
        /// <param name="c"></param>
        /// <param name="frm"></param>
        public ThreadProcessHighPower(byte[] data, int c,Main frm)
        {
            receiveData = data;
            length = c;
            f = frm;
            showHighCabinFaultDatacallback = new delShowHighCabinFaultData(ShowHighCabinFaultDataMethod);//在首页故障表格中显示主接驳盒故障信息回调
            showHighErrorSignalcallback = new delShowHighErrorSignal(ShowHighErrorSignalMethod);//通道故障异常标志的回调
            showHighStatuscallback = new delShowHighStatus(ShowHighStatusMethod);//显示主接驳盒状态信息回调
            drawExpHCh = frm.drawExp;//画图实例初始化
        }
        /// <summary>
        /// 处理高压舱电源函数
        /// </summary>
        public void DealHighPowerMessage()
        {
            try
            {
                string content = null;
                for (int k = 0; k < length; k++)
                    content += String.Format("{0:X2}", receiveData[k]);//转换成对应的16进制的字符串

                //1.首先进行校验和计算，校验正确，则进行电源数据的解析，否则认为错位，记录相应数据库表格中
                byte[] bytes = new byte[length - 2];

                for (int i = 0; i < length - 2; i++)
                {
                    bytes[i] = receiveData[i];
                }


                byte[] crc_16 = new byte[2];//用于存储计算的CRC16校验值；

                crc_16 = CRC32.CRC16(bytes);

                if (crc_16[0] == receiveData[length-1] && crc_16[1] == receiveData[length-2])//校验值正确，进行解析
                {
                    string strFVol = content.Substring(6, 4);//前端电压16进制字符串部分
                    int fVol = Convert.ToInt32(strFVol, 16);//前端电压值

                    string strFcur = content.Substring(10, 4);
                    int fCur = Convert.ToInt32(strFcur, 16);//转换成电流值；
                    double ffCur = fCur / 1000.0;//最终显示的前端电流值


                    double fPow = ffCur * fVol;//前端功率


                    string strBVol1 = content.Substring(14, 4);//后端第一路电压的16进制字符串部分
                    int bVol1 = Convert.ToInt32(strBVol1, 16);//转换成后端第一路电压值

                    string strBCur1 = content.Substring(18, 4);
                    int bCur1 = Convert.ToInt32(strBCur1, 16);
                    double fbCur1 = bCur1 / 1000.0;//最终显示的后端第一路电流数值


                    double bPow1 = fbCur1 * bVol1;//后端第一路功率

                    string strBVol2 = content.Substring(22, 4);//后端第2路电压的16进制字符串部分
                    int bVol2 = Convert.ToInt32(strBVol2, 16);//转换成后端第2路电压值

                    string strBCur2 = content.Substring(26, 4);
                    int bCur2 = Convert.ToInt32(strBCur2, 16);
                    double fbCur2 = bCur2 / 1000.0;//最终显示的后端第2路电流数值



                    double bPow2 = fbCur2 * bVol2;//后端第二路功率


                    string strPowTemp = content.Substring(30, 4);
                    int powTemp = Convert.ToInt32(strPowTemp, 16);

                    double fpowTemp = powTemp / 100.0; //最终显示的电源温度

                    //存入数据库之前，先将主接驳盒高压舱状态值送到界面显示

                    DateTime dt1 = DateTime.Now;

                    if (Main.draw1000flag == 1)
                    {
                        draw.arrayHCh0Cur.Add(ffCur);//主接驳盒高压舱前端电流电压值存入可变数组中
                        draw.arrayHCh0Vol.Add(fVol);

                        draw.arrayHCh1Cur.Add(fbCur1);//将后端1路电参数放入可变数组
                        draw.arrayHCh1Vol.Add(bVol1);

                        draw.arrayHCh2Cur.Add(fbCur2);//将后端2路电参数放入可变数组
                        draw.arrayHCh2Vol.Add(bVol2);

                        draw.arrayHTemp.Add(fpowTemp);//将温度值存入动态数组

                        draw.arrayHSaveDate.Add(dt1);//时间存入动态数组

                        lock(lockHCh)
                        {
                            //drawExpHCh.refreshDrawElectricalArray(Convert.ToDateTime(strCollectDate).ToString(), Convert.ToDouble(strCh1Cur), Convert.ToDouble(strCh1Vol), Convert.ToDouble(strCh2Cur), Convert.ToDouble(strCh2Vol), Convert.ToDouble(strCh3Cur), Convert.ToDouble(strCh3Vol), Convert.ToDouble(strCh4Cur), Convert.ToDouble(strCh4Vol), Convert.ToDouble(strCh5Cur), Convert.ToDouble(strCh5Vol), Convert.ToDouble(strTemp), 1, f);//动态画状态图2，加锁
                            drawExpHCh.refreshDrawHighStsArray(dt1.ToString(), ffCur, fVol, fbCur1, bVol1, fbCur2, bVol2, fpowTemp, 1, f);
                        }




                    }




                    

                    //解析完成的状态信息存入数据库highcabinstatusmesg表格中
                    string sql1 = "insert into seafloor_jBHighStsData (statusType,fVol,fCur,bVol1,bCur1,bVol2,bCur2,temp,collectRawInfo,saveDate,fPower,bPower1,bPower2,isDelete) values('主接驳盒状态信息','" + fVol + "','" +ffCur + "','"+bVol1+"','" + fbCur1 + "','"+bVol2+"','"+fbCur2+"','"+fpowTemp+"','"+content+"','"+dt1+"','"+fPow+"','"+bPow1+"','"+bPow2+"','0')";//包编号存入数据库
                    SqlHelper.ExecuteNonQuery(sql1);


                    f.Invoke(showHighStatuscallback, fVol.ToString("0.00"), ffCur.ToString("0.00"), bVol1.ToString("0.00"), fbCur1.ToString("0.00"), bVol2.ToString("0.00"), fbCur2.ToString("0.00"), fpowTemp.ToString("0.00"), fPow.ToString("0.00"), bPow1.ToString("0.00"), bPow2.ToString("0.00"), dt1);//高压舱电源参数委托回调显示





                    //处理故障信息
                    string s1 = System.Convert.ToString(receiveData[17], 2).PadLeft(8,'0');//处理故障信息，将byte类型转换成对应的二进制字符串
                    if (s1.Substring(4, 1) == "1")//1.前端电流故障---前端短路故障
                    {
                        DateTime dt = DateTime.Now;
                        f.Invoke(showHighCabinFaultDatacallback, "主接驳盒前端短路故障", ffCur.ToString(), dt, 1);//前端短路故障，并且将前端电流数据显示出来
                        f.Invoke(showHighErrorSignalcallback,1);
                        string sql = "insert into seafloor_jBFaultData (faultType,faultData,saveDate,collectRawInfo,isDelete) values('主接驳盒前端短路故障','" + ffCur.ToString() + "','" + dt + "','" + content+ "','0')";//包编号存入数据库
                        SqlHelper.ExecuteNonQuery(sql);
                    }
                    if (s1.Substring(5, 1) == "1")//1.前端电流故障---前端过流故障
                    {
                        DateTime dt = DateTime.Now;
                        f.Invoke(showHighCabinFaultDatacallback, "主接驳盒前端过流故障", ffCur.ToString(), DateTime.Now, 1);
                        f.Invoke(showHighErrorSignalcallback, 1);
                        string sql = "insert into seafloor_jBFaultData (faultType,faultData,saveDate,collectRawInfo,isDelete) values('主接驳盒前端过流故障','" + ffCur.ToString() + "','" + dt + "','" + content + "','0')";//包编号存入数据库
                        SqlHelper.ExecuteNonQuery(sql);

                    }
                    if (s1.Substring(6, 1) == "1")//2.前端电压故障---前端欠压故障
                    {
                        DateTime dt = DateTime.Now;
                        f.Invoke(showHighCabinFaultDatacallback, "主接驳盒前端欠压故障", fVol.ToString(), DateTime.Now, 2);
                        f.Invoke(showHighErrorSignalcallback, 1);
                        string sql = "insert into seafloor_jBFaultData (faultType,faultData,saveDate,collectRawInfo,isDelete) values('主接驳盒前端欠压故障','" + fVol.ToString() + "','" + dt + "','" + content + "','0')";//包编号存入数据库
                        SqlHelper.ExecuteNonQuery(sql);
                    }
                    if (s1.Substring(7, 1) == "1")//2.前端电压故障---前端过压故障
                    {
                        DateTime dt = DateTime.Now;
                        f.Invoke(showHighCabinFaultDatacallback, "主接驳盒前端过压故障", fVol.ToString(), DateTime.Now, 2);
                        f.Invoke(showHighErrorSignalcallback, 1);
                        string sql = "insert into seafloor_jBFaultData (faultType,faultData,saveDate,collectRawInfo,isDelete) values('主接驳盒前端过压故障','" + fVol.ToString() + "','" + dt + "','" + content + "','0')";//包编号存入数据库
                        SqlHelper.ExecuteNonQuery(sql);
                    }



                    string s2 = Convert.ToString(receiveData[18], 2).PadLeft(8,'0'); ;
                    if (s2.Substring(4, 1) == "1")//3.后端第一路电流故障-----后端第一路短路故障
                    {
                        DateTime dt = DateTime.Now;
                        f.Invoke(showHighCabinFaultDatacallback, "主接驳盒后端1路短路故障", fbCur1.ToString(), DateTime.Now, 3);
                        f.Invoke(showHighErrorSignalcallback, 2);
                        string sql = "insert into seafloor_jBFaultData (faultType,faultData,saveDate,collectRawInfo,isDelete) values('主接驳盒后端1路短路故障','" + fbCur1.ToString() + "','" + dt + "','" + content + "','0')";//包编号存入数据库
                        SqlHelper.ExecuteNonQuery(sql);
                    }
                    if (s2.Substring(5, 1) == "1")//3.后端第一路电流故障---后端第一路过流故障
                    {
                        DateTime dt = DateTime.Now;
                        f.Invoke(showHighCabinFaultDatacallback, "主接驳盒后端1路过流故障", fbCur1.ToString(), DateTime.Now, 3);
                        f.Invoke(showHighErrorSignalcallback, 2);
                        string sql = "insert into seafloor_jBFaultData (faultType,faultData,saveDate,collectRawInfo,isDelete) values('主接驳盒后端1路过流故障','" + fbCur1.ToString() + "','" + dt + "','" + content + "','0')";//包编号存入数据库
                        SqlHelper.ExecuteNonQuery(sql);
                    }
                    if (s2.Substring(6, 1) == "1")//4.后端第一路电压故障----后端第1路欠压故障
                    {
                        DateTime dt = DateTime.Now;
                        f.Invoke(showHighCabinFaultDatacallback, "主接驳盒后端1路欠压故障", bVol1.ToString(), DateTime.Now, 4);
                        f.Invoke(showHighErrorSignalcallback, 2);
                        string sql = "insert into seafloor_jBFaultData (faultType,faultData,saveDate,collectRawInfo,isDelete) values('主接驳盒后端1路欠压故障','" + bVol1.ToString() + "','" + dt + "','" + content + "','0')";//包编号存入数据库
                        SqlHelper.ExecuteNonQuery(sql);
                    }
                    if (s2.Substring(7, 1) == "1")//4.后端第1路电压故障----后端1路过压故障
                    {
                        DateTime dt = DateTime.Now;
                        f.Invoke(showHighCabinFaultDatacallback, "主接驳盒后端1路过压故障", bVol1.ToString(), DateTime.Now, 4);
                        f.Invoke(showHighErrorSignalcallback, 2);
                        string sql = "insert into seafloor_jBFaultData (faultType,faultData,saveDate,collectRawInfo,isDelete) values('主接驳盒后端1路过压故障','" + bVol1.ToString() + "','" + dt + "','" + content + "','0')";//包编号存入数据库
                        SqlHelper.ExecuteNonQuery(sql);
                    }


                    string s3 = Convert.ToString(receiveData[19], 2).PadLeft(8,'0');
                    if (s3.Substring(4, 1) == "1")//5.后端第2路电流故障---后端第2路短路故障
                    {
                        DateTime dt = DateTime.Now;
                        f.Invoke(showHighCabinFaultDatacallback, "主接驳盒后端2路短路故障", fbCur2.ToString(), DateTime.Now, 5);
                        f.Invoke(showHighErrorSignalcallback, 3);
                        string sql = "insert into seafloor_jBFaultData (faultType,faultData,saveDate,collectRawInfo,isDelete) values('主接驳盒后端2路短路故障','" + fbCur2.ToString() + "','" + dt + "','" + content + "','0')";//包编号存入数据库
                        SqlHelper.ExecuteNonQuery(sql);
                    }
                    if (s3.Substring(5, 1) == "1")//5.后端第2路电流故障----后端第2路过流故障
                    {
                        DateTime dt = DateTime.Now;
                        f.Invoke(showHighCabinFaultDatacallback, "主接驳盒后端2路过流故障", fbCur2.ToString(), DateTime.Now, 5);
                        f.Invoke(showHighErrorSignalcallback, 3);
                        string sql = "insert into seafloor_jBFaultData (faultType,faultData,saveDate,collectRawInfo,isDelete) values('主接驳盒后端2路过流故障','" + fbCur2.ToString() + "','" + dt + "','" + content + "','0')";//包编号存入数据库
                        SqlHelper.ExecuteNonQuery(sql);
                    }
                    if (s3.Substring(6, 1) == "1")//6.后端2路电压故障---后端2路欠压故障
                    {
                        DateTime dt = DateTime.Now;
                        f.Invoke(showHighCabinFaultDatacallback, "主接驳盒后端2路欠压故障", bVol2.ToString(), DateTime.Now, 6);
                        f.Invoke(showHighErrorSignalcallback, 3);
                        string sql = "insert into seafloor_jBFaultData (faultType,faultData,saveDate,collectRawInfo,isDelete) values('主接驳盒后端2路欠压故障','" + bVol2.ToString() + "','" + dt + "','" + content + "','0')";//包编号存入数据库
                        SqlHelper.ExecuteNonQuery(sql);
                    }
                    if (s3.Substring(7, 1) == "1")//6.后端2路电压故障----后端2路过压故障
                    {
                        DateTime dt = DateTime.Now;
                        f.Invoke(showHighCabinFaultDatacallback, "主接驳盒后端2路过压故障", bVol2.ToString(), DateTime.Now, 6);
                        f.Invoke(showHighErrorSignalcallback, 3);
                        string sql = "insert into seafloor_jBFaultData (faultType,faultData,saveDate,collectRawInfo,isDelete) values('主接驳盒后端2路过压故障','" + bVol2.ToString() + "','" + dt + "','" + content + "','0')";//包编号存入数据库
                        SqlHelper.ExecuteNonQuery(sql);
                    }


                    if (s1.Substring(3, 1) == "1")//7.电源温度故障----高压舱电源温度过高故障
                    {
                        DateTime dt = DateTime.Now;
                        f.Invoke(showHighCabinFaultDatacallback, "主接驳盒舱内温度过高故障", fpowTemp.ToString(), DateTime.Now, 7);
                        string sql = "insert into seafloor_jBFaultData (faultType,faultData,saveDate,collectRawInfo,isDelete) values('主接驳盒舱内温度过高故障','" + fpowTemp.ToString() + "','" + dt + "','" + content + "','0')";//包编号存入数据库
                        SqlHelper.ExecuteNonQuery(sql);
                    }

                }
                else//校验值不正确，将数据存入数据库专门存放错误数据的表格中
                {

                    DateTime dt = DateTime.Now;
                    string sql = "insert into seafloor_jBErrorMesg (jBId,saveDate,errorProtocol) values('1','" + dt + "','" + content + "')";//通过接驳盒Id来判断错误的信息是主接驳盒高压舱的信息还是次接驳盒低压舱的信息
                    SqlHelper.ExecuteNonQuery(sql);
                }


                Main.ClearMemory();

            }
            catch(Exception exp)
            {
                LogClass.WriteLogFile("处理高压舱电源参数出现异常！" + exp.Message);
                Main.ClearMemory();
            }
            

            



        }
    }
}
