﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace OSNSystem
{
    public partial class cmdCollectSet : Form
    {
        private int serial;//选择给哪个数据采集器下达指令,数据采集器序列号,数据采集器有两个,分别编号为1和2   
        private Main f;
        public cmdCollectSet(int j,Main frm)
        {
            InitializeComponent();
            serial = j;
            f = frm;
        }
        /// <summary>
        /// 数据采集器的校准时钟指令，数据采集器的校准时间是发送给MIO板的，MIO板接收到指令后改变自身的时间，并不会继续发送给AD采集板
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void btnTimer_Click(object sender, EventArgs e)
        {
            this.Cursor = Cursors.WaitCursor;//设置鼠标等待箭头
            try
            {
                string cmdTotal = "T" + tbxTime.Text.ToString().Trim();//这部分可以优化成存储在数据库中，每次协议更改时，只需要更改数据库中存储的内容

                _4MyClientClass exp = new _4MyClientClass(f);
                if (exp.ExecuteCmd(cmdTotal, 2, serial))
                    LogCommand.WriteLogFile("执行校时指令成功！");
                else
                    LogCommand.WriteLogFile("执行校时指令失败！");
            }
            catch(Exception exp)
            {
                LogClass.WriteLogFile("设置数据采集器校准时间指令异常！"+exp.Message);
            }
           // string cmd = StrToASCII(tbxTime.Text.ToString().Trim());
            
            this.Cursor = Cursors.Default;
        }

        /// <summary>
        /// 将字符转换成其ASCII码对应的字符
        /// </summary>
        /// <param name="input"></param>
        /// <returns></returns>
        private string StrToASCII(string input)
        {
            StringBuilder sb = new StringBuilder(input.Length * 2);
            for (int i = 0; i < input.Length; i++)
            {
                sb.Append(((int)input[i]).ToString("X2"));
            }
            return sb.ToString();
        }
        /// <summary>
        /// 溶解氧时间间隔设置
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void btnDO_Click(object sender, EventArgs e)
        {
            this.Cursor = Cursors.WaitCursor;
            try
            {
                string cmd = StrToASCII(tbxRJY.Text.ToString().Trim());

                string cmdTotal = "55BB0001304100000016A443A9A6494E54" + cmd + "23";
                LogCommand.WriteLogFile("执行设置溶解氧时间间隔：" + tbxRJY.Text.ToString().Trim());

                _4MyClientClass exp = new _4MyClientClass(f);

                if (exp.ExecuteCmd(cmdTotal, 1,serial))
                {
                    LogCommand.WriteLogFile("执行设置溶解氧时间间隔成功！");
                    string sql = "update datacollectorelselimits set doInterval = '" + tbxRJY.Text.ToString() + "' where serial = '"+serial+"'";
                    SqlHelper.ExecuteNonQuery(sql);
                }
                else
                    LogCommand.WriteLogFile("执行设置溶解氧时间间隔失败！");

            }
            catch (Exception exp)
            {
                LogClass.WriteLogFile("设置溶解氧时间间隔异常！" + exp.Message);
            }
            this.Cursor = Cursors.Default; 
        }
        /// <summary>
        /// AD板温度以及漏水时间间隔设置
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void btnTemp_Click(object sender, EventArgs e)
        {
            this.Cursor = Cursors.WaitCursor;
            try
            {
                string cmd = tbxTemp.Text.ToString().Trim();
                string cmdTotal = "$SET+01+INT" + cmd + "#";

                LogCommand.WriteLogFile("执行设置数据采集器AD板时间间隔：" + tbxTemp.Text.ToString().Trim());

                _4MyClientClass exp = new _4MyClientClass(f);

                if (exp.ExecuteCmd(cmdTotal, 2,serial))//该指令默认包含发三遍的操作
                {
                    LogCommand.WriteLogFile("执行设置数据采集器AD板时间间隔成功！");
                    string sql = "update seafloor_otherlimits set adInterval = '" + tbxTemp.Text.ToString() + "' where limitsType = '数据采集器'";
                    SqlHelper.ExecuteNonQuery(sql);
                }
                else
                    LogCommand.WriteLogFile("执行设置数据采集器AD板时间间隔失败！");

            }
            catch (Exception exp)
            {
                LogClass.WriteLogFile("设置数据采集器AD板时间间隔异常！" + exp.Message);
            }
            this.Cursor = Cursors.Default;   
        }
        /// <summary>
        /// 数据采集器通道1电压电流上下限设置
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void btnRJWSet_Click(object sender, EventArgs e)
        {
            this.Cursor = Cursors.WaitCursor;
            try
            {
                string cmd1 = txt1CurHigh.Text.ToString().Trim();
                string cmd2 = txt1CurLow.Text.ToString().Trim();
                string cmd3 = txt1VolHigh.Text.ToString().Trim();
                string cmd4 = txt1VolLow.Text.ToString().Trim();
                string cmdTotal = "$SET+01+CurAH" + cmd1 + "+CurAL" + cmd2 + "+VolAH" + cmd3 + "+VolAL" + cmd4 + "#";
                LogCommand.WriteLogFile("执行设置数据采集器通道1报警阈值，电流上限:" + txt1CurHigh.Text.ToString().Trim() + "电流下限:" + txt1CurLow.Text.ToString().Trim() + "电压上限:" + txt1VolHigh.Text.ToString().Trim() + "电压下限:" + txt1VolLow.Text.ToString().Trim());

                
                _4MyClientClass exp = new _4MyClientClass(f);

                if (exp.ExecuteCmd(cmdTotal, 2,serial))//函数ExecuteCmd()已经默认包含重发三次的指令
                {
                    LogCommand.WriteLogFile("执行设置数据采集器通道1报警阈值成功！");

                    string sql = "update seafloor_elecLimits  set limitsCurHigh = '" + txt1CurHigh.Text.ToString() + "',limitsCurLow = '" + txt1CurLow.Text.ToString() + "',limitsVolHigh = '" + txt1VolHigh.Text.ToString() + "', limitsVolLow = '" + txt1VolLow.Text.ToString() + "' where limitsType = '数据采集器' and limitsNum = 1";
                    SqlHelper.ExecuteNonQuery(sql);

                }
                   
                else
                    LogCommand.WriteLogFile("执行设置数据采集器通道1报警阈值失败！");
            }
            catch (Exception exp)
            {
                LogClass.WriteLogFile("设置数据采集器通道1报警阈值异常" + exp.Message);
            }

            this.Cursor = Cursors.Default;
        }
        /// <summary>
        /// 通道2电压电流上下限设置
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void btnJWSet_Click(object sender, EventArgs e)
        {
            this.Cursor = Cursors.WaitCursor;
            try
            {
                string cmd1 = txt2CurHigh.Text.ToString().Trim();
                string cmd2 = txt2CurLow.Text.ToString().Trim();
                string cmd3 = txt2VolHigh.Text.ToString().Trim();
                string cmd4 = txt2VolLow.Text.ToString().Trim();

                string cmdTotal = "$SET+01+CurBH" + cmd1 + "+CurBL" + cmd2 + "+VolBH" + cmd3 + "+VolBL" + cmd4 + "#";

                LogCommand.WriteLogFile("执行设置数据采集器通道2报警阈值，电流上限:" + txt2CurHigh.Text.ToString().Trim() + "电流下限:" + txt2CurLow.Text.ToString().Trim() + "电压上限:" + txt2VolHigh.Text.ToString().Trim() + "电压下限:" + txt2VolLow.Text.ToString().Trim());

                _4MyClientClass exp = new _4MyClientClass(f);

                if (exp.ExecuteCmd(cmdTotal, 2,serial))
                {
                    LogCommand.WriteLogFile("执行设置数据采集器通道2报警阈值成功！");
                    string sql = "update seafloor_elecLimits  set limitsCurHigh = '" + txt2CurHigh.Text.ToString() + "',limitsCurLow = '" + txt2CurLow.Text.ToString() + "',limitsVolHigh = '" + txt2VolHigh.Text.ToString() + "', limitsVolLow = '" + txt2VolLow.Text.ToString() + "' where limitsType = '数据采集器' and limitsNum = 2";
                    SqlHelper.ExecuteNonQuery(sql);
                }
                    
                else
                    LogCommand.WriteLogFile("执行设置数据采集器通道2报警阈值失败！");
            }
            catch (Exception exp)
            {
                LogClass.WriteLogFile("设置数据采集器通道2报警阈值异常！" + exp.Message);
            }

            this.Cursor = Cursors.Default;   
        }
        /// <summary>
        /// 数据采集器通道3电压电流上下限设置
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void btnYLSSet_Click(object sender, EventArgs e)
        {
            this.Cursor = Cursors.WaitCursor;
            try
            {               
                string cmd1 = txt3CurHigh.Text.ToString().Trim();
                string cmd2 = txt3CurLow.Text.ToString().Trim();
                string cmd3 = txt3VolHigh.Text.ToString().Trim();
                string cmd4 = txt3VolLow.Text.ToString().Trim();

                string cmdTotal = "$SET+01+CurCH" + cmd1 + "+CurCL" + cmd2 + "+VolCH" + cmd3 + "+VolCL" + cmd4 + "#";

                LogCommand.WriteLogFile("执行设置数据采集器通道3报警阈值，电流上限:" + txt3CurHigh.Text.ToString().Trim() + "电流下限:" + txt3CurLow.Text.ToString().Trim() + "电压上限:" + txt3VolHigh.Text.ToString().Trim() + "电压下限:" + txt3VolLow.Text.ToString().Trim());

                _4MyClientClass exp = new _4MyClientClass(f);

                if (exp.ExecuteCmd(cmdTotal, 2,serial))
                {
                    LogCommand.WriteLogFile("执行设置数据采集器通道3报警阈值成功！");
                    string sql = "update seafloor_elecLimits  set limitsCurHigh = '" + txt3CurHigh.Text.ToString() + "',limitsCurLow = '" + txt3CurLow.Text.ToString() + "',limitsVolHigh = '" + txt3VolHigh.Text.ToString() + "', limitsVolLow = '" + txt3VolLow.Text.ToString() + "' where limitsType = '数据采集器' and limitsNum = 3";
                    SqlHelper.ExecuteNonQuery(sql);
                }
                    
                else
                    LogCommand.WriteLogFile("执行设置数据采集器通道3报警阈值失败！");
            }
            catch (Exception exp)
            {
                LogClass.WriteLogFile("设置数据采集器通道3报警阈值异常！" + exp.Message);
            }

            this.Cursor = Cursors.Default;  
        }
        /// <summary>
        /// 数据采集器通道4电压电流上下限设置
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void btnZDSet_Click(object sender, EventArgs e)
        {
            this.Cursor = Cursors.WaitCursor;
            try
            {
                string cmd1 = txt4CurHigh.Text.ToString().Trim();
                string cmd2 = txt4CurLow.Text.ToString().Trim();
                string cmd3 = txt4VolHigh.Text.ToString().Trim();
                string cmd4 = txt4VolLow.Text.ToString().Trim();

                string cmdTotal = "$SET+01+CurDH" + cmd1 + "+CurDL" + cmd2 + "+VolDH" + cmd3 + "+VolDL" + cmd4 + "#";
                LogCommand.WriteLogFile("执行设置数据采集器通道4报警阈值，电流上限:" + txt4CurHigh.Text.ToString().Trim() + "电流下限:" + txt4CurLow.Text.ToString().Trim() + "电压上限:" + txt4VolHigh.Text.ToString().Trim() + "电压下限:" + txt4VolLow.Text.ToString().Trim());

                _4MyClientClass exp = new _4MyClientClass(f);

                if (exp.ExecuteCmd(cmdTotal, 2,serial))
                {
                    LogCommand.WriteLogFile("执行设置数据采集器通道4报警阈值成功！");
                    string sql = "update seafloor_elecLimits  set limitsCurHigh = '" + txt4CurHigh.Text.ToString() + "',limitsCurLow = '" + txt4CurLow.Text.ToString() + "',limitsVolHigh = '" + txt4VolHigh.Text.ToString() + "', limitsVolLow = '" + txt4VolLow.Text.ToString() + "' where limitsType = '数据采集器' and limitsNum = 4";
                    SqlHelper.ExecuteNonQuery(sql);
                }
                else
                    LogCommand.WriteLogFile("执行设置数据采集器通道4报警阈值失败！");
            }
            catch (Exception exp)
            {
                LogClass.WriteLogFile("设置数据采集器通道4报警阈值异常！" + exp.Message);
            }

            this.Cursor = Cursors.Default; 
        }
        /// <summary>
        /// 数据采集器通道5电压电流上下限设置
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void btnCDOMSet_Click(object sender, EventArgs e)
        {
            this.Cursor = Cursors.WaitCursor;
            try
            {
                string cmd1 = txt5CurHigh.Text.ToString().Trim();
                string cmd2 = txt5CurLow.Text.ToString().Trim();
                string cmd3 = txt5VolHigh.Text.ToString().Trim();
                string cmd4 = txt5VolLow.Text.ToString().Trim();

                string cmdTotal = "$SET+01+CurEH" + cmd1 + "+CurEL" + cmd2 + "+VolEH" + cmd3 + "+VolEL" + cmd4 + "#";
                LogCommand.WriteLogFile("执行设置数据采集器通道5报警阈值，电流上限:" + txt5CurHigh.Text.ToString().Trim() + "电流下限:" + txt5CurLow.Text.ToString().Trim() + "电压上限:" + txt5VolHigh.Text.ToString().Trim() + "电压下限:" + txt5VolLow.Text.ToString().Trim());

                _4MyClientClass exp = new _4MyClientClass(f);

                if (exp.ExecuteCmd(cmdTotal, 2,serial))
                {
                    LogCommand.WriteLogFile("执行设置数据采集器通道5报警阈值成功！");
                    string sql = "update seafloor_elecLimits  set limitsCurHigh = '" + txt5CurHigh.Text.ToString() + "',limitsCurLow = '" + txt5CurLow.Text.ToString() + "',limitsVolHigh = '" + txt5VolHigh.Text.ToString() + "', limitsVolLow = '" + txt5VolLow.Text.ToString() + "' where limitsType = '数据采集器' and limitsNum = 5";
                    SqlHelper.ExecuteNonQuery(sql);
                }
                else
                    LogCommand.WriteLogFile("执行设置数据采集器通道5报警阈值失败！");
            }
            catch (Exception exp)
            {
                LogClass.WriteLogFile("设置数据采集器通道5报警阈值异常！" + exp.Message);
            }

            this.Cursor = Cursors.Default;
        }
        /// <summary>
        /// 数据采集器温度上下限设置
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void btnTempSet_Click(object sender, EventArgs e)
        {
            this.Cursor = Cursors.WaitCursor;
            try
            {
                string cmd1 = tbxTemp1.Text.ToString().Trim();
                string cmd2 = tbxTemp2.Text.ToString().Trim();
                string cmd3 = tbxLeak1.Text.ToString().Trim();
                string cmd4 = tbxLeak2.Text.ToString().Trim();

                string cmdTotal = "$SET+01+TempH" + cmd1 + "+TempL" + cmd2 + "#";
                LogCommand.WriteLogFile("执行设置数据采集器温度报警阈值，温度上限:" + tbxTemp1.Text.ToString().Trim() + "温度下限:" + tbxTemp2.Text.ToString().Trim());

                _4MyClientClass exp = new _4MyClientClass(f);

                if (exp.ExecuteCmd(cmdTotal, 2,serial))
                {
                    LogCommand.WriteLogFile("执行设置数据采集器温度报警阈值成功！");
                    string sql = "update seafloor_otherlimits set limitsTempHigh = '"+tbxTemp1.Text.ToString()+"',limitsTempLow = '"+tbxTemp2.Text.ToString()+"' where limitsType = '数据采集器'";
                    SqlHelper.ExecuteNonQuery(sql);
                }
                else
                    LogCommand.WriteLogFile("执行设置数据采集器温度报警阈值失败！");
            }
            catch (Exception exp)
            {
                LogClass.WriteLogFile("设置数据采集器温度报警阈值异常！" + exp.Message);
            }

            this.Cursor = Cursors.Default; 
        }

        private void cmdCollectSet_Load(object sender, EventArgs e)
        {
            this.tbxTime.Text = DateTime.Now.ToString("yyyy-MM-dd HH:mm:ss");//大写的HH是24小时制
            this.timer1.Start();

            string sql = "select * from seafloor_elecLimits where limitsType = '数据采集器' order by Id asc ";
            ReadElectricalLimits(sql);//读取通道电参数上下限的数值并且在相应的控件位置进行显示，通道电参数上下限数值保存在数据库中

            string sql2 = "select * from seafloor_otherLimits where limitsType = '数据采集器' order by Id asc ";
            ReadOtherLimits(sql2);//读取其它参数的上下限数值，温度上下限，溶解氧采集时间间隔，AD采集时间间隔

            //设置控件显示的液晶字体
            FontClass fontType = new FontClass();

            tbxTime.Font = fontType.fontCollectorData;
            tbxRJY.Font = fontType.fontCollectorData;
            tbxJW.Font = fontType.fontCollectorData;
            tbxYLS.Font = fontType.fontCollectorData;
            tbxZD.Font = fontType.fontCollectorData;
            tbxTemp.Font = fontType.fontCollectorData;
            tbxCDOM.Font = fontType.fontCollectorData;

            txt1CurHigh.Font = fontType.fontCollectorData;
            txt1CurLow.Font = fontType.fontCollectorData;
            txt1VolHigh.Font = fontType.fontCollectorData;
            txt1VolLow.Font = fontType.fontCollectorData;

            txt2CurHigh.Font = fontType.fontCollectorData;
            txt2CurLow.Font = fontType.fontCollectorData;
            txt2VolHigh.Font = fontType.fontCollectorData;
            txt2VolLow.Font = fontType.fontCollectorData;

            txt3CurHigh.Font = fontType.fontCollectorData;
            txt3CurLow.Font = fontType.fontCollectorData;
            txt3VolHigh.Font = fontType.fontCollectorData;
            txt3VolLow.Font = fontType.fontCollectorData;

            txt4CurHigh.Font = fontType.fontCollectorData;
            txt4CurLow.Font = fontType.fontCollectorData;
            txt4VolHigh.Font = fontType.fontCollectorData;
            txt4VolLow.Font = fontType.fontCollectorData;

            txt5CurHigh.Font = fontType.fontCollectorData;
            txt5CurLow.Font = fontType.fontCollectorData;
            txt5VolHigh.Font = fontType.fontCollectorData;
            txt5VolLow.Font = fontType.fontCollectorData;

            tbxTemp1.Font = fontType.fontCollectorData;
            tbxTemp2.Font = fontType.fontCollectorData;
        }
        /// <summary>
        /// 定时器更新系统当前时钟
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void timer1_Tick(object sender, EventArgs e)
        {
            this.tbxTime.Text = DateTime.Now.ToString("yyyy-MM-dd HH:mm:ss");
        }
        /// <summary>
        /// 溶解氧指令设置界面
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void button1_Click(object sender, EventArgs e)
        {
            SetDO mySetDO = new SetDO(serial,f);
           
            mySetDO.BackColor = this.BackColor;
            

            mySetDO.Show();
        }

       /*********额外用到的读取上下限的函数***********/
        /// <summary>
        /// 1.读取电参数的上下限数值，将其显示在界面上的对应的控件位置上
        /// </summary>
        /// <param name="sql"></param>
        public void ReadElectricalLimits(string sql)
        {
            try
            {
                DataTable tTable = SqlHelper.ExecuteDataTable(sql);
    
                txt1CurHigh.Text = tTable.Rows[0]["limitsCurHigh"].ToString();
                txt1CurLow.Text = tTable.Rows[0]["limitsCurLow"].ToString();
                txt1VolHigh.Text = tTable.Rows[0]["limitsVolHigh"].ToString();
                txt1VolLow.Text = tTable.Rows[0]["limitsVolLow"].ToString();

                txt2CurHigh.Text = tTable.Rows[1]["limitsCurHigh"].ToString();
                txt2CurLow.Text = tTable.Rows[1]["limitsCurLow"].ToString();
                txt2VolHigh.Text = tTable.Rows[1]["limitsVolHigh"].ToString();
                txt2VolLow.Text = tTable.Rows[1]["limitsVolLow"].ToString();

                txt3CurHigh.Text = tTable.Rows[2]["limitsCurHigh"].ToString();
                txt3CurLow.Text = tTable.Rows[2]["limitsCurLow"].ToString(); ;
                txt3VolHigh.Text = tTable.Rows[2]["limitsVolHigh"].ToString();
                txt3VolLow.Text = tTable.Rows[2]["limitsVolLow"].ToString();

                txt4CurHigh.Text = tTable.Rows[3]["limitsCurHigh"].ToString();
                txt4CurLow.Text = tTable.Rows[3]["limitsCurLow"].ToString(); ;
                txt4VolHigh.Text = tTable.Rows[3]["limitsVolHigh"].ToString();
                txt4VolLow.Text = tTable.Rows[3]["limitsVolLow"].ToString();

                txt5CurHigh.Text = tTable.Rows[4]["limitsCurHigh"].ToString();
                txt5CurLow.Text = tTable.Rows[4]["limitsCurLow"].ToString(); ;
                txt5VolHigh.Text = tTable.Rows[4]["limitsVolHigh"].ToString();
                txt5VolLow.Text = tTable.Rows[4]["limitsVolLow"].ToString();

            }
            catch(Exception exp)
            {
                LogClass.WriteLogFile("读入数据采集器电参数上下限数值时存在异常！"+exp.Message);
            }
        }
        /// <summary>
        /// 2.读取其它参数的上下限数值
        /// </summary>
        /// <param name="sql"></param>
        public void ReadOtherLimits(string sql)
        {
            try
            {
                DataTable tTable = SqlHelper.ExecuteDataTable(sql);

                tbxTemp1.Text = tTable.Rows[0]["limitsTempHigh"].ToString();
                tbxTemp2.Text = tTable.Rows[0]["limitsTempLow"].ToString();

               // tbxRJY.Text = tTable.Rows[0]["doInterval"].ToString();
                tbxTemp.Text = tTable.Rows[0]["adInterval"].ToString();
            }
            catch(Exception exp)
            {
                LogClass.WriteLogFile("读入其它参数上下限数值时存在异常！"+exp.Message);
            }
        }

        private void button2_Click(object sender, EventArgs e)
        {

        }
        /// <summary>
        /// CTD指令弹出窗口
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void button3_Click(object sender, EventArgs e)
        {
            SetCTD mySetCTD = new SetCTD(serial,f);
            mySetCTD.BackColor = this.BackColor;
            mySetCTD.Show();
        }

        private void button4_Click(object sender, EventArgs e)
        {
            SetChlTur mySetMulti = new SetChlTur(f);

            mySetMulti.BackColor = this.BackColor;


            mySetMulti.Show();
        }
        


    }
}
