﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Net.Sockets;
using System.Diagnostics;
using System.Reflection;
using System.Runtime.InteropServices;

namespace OSNSystem
{
    public partial class cmdSet : Form
    {

      //  public static int IntervalDO = 10;

        //设置静态变量，用于记录指令设置的上下限数值

       

        private Main f;


        public cmdSet(Main exp)
        {
            InitializeComponent();
            f = exp;
        }
        /// <summary>
        /// 指令设置界面，设置校准时钟执行按钮响应函数，指令下达要有超时重发的机制
        /// 校时指令是发送给STM32，STM32并不发送给下一级
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void btnTimer_Click(object sender, EventArgs e)
        {
            this.Cursor = Cursors.WaitCursor;
            _3ReceieveMsgClass.flagTime = 0;
            try
            {
                if (f.canBConnect.Text == "连接")
                {
                    for (int i = _1MySerClass.userList.Count - 1; i >= 0; i--)
                    {
                        _3ReceieveMsgClass ct = _1MySerClass.userList[i];
                        if (!ct.tcpClient.Connected || ((ct.tcpClient.Poll(1000, SelectMode.SelectRead)) && (ct.tcpClient.Available == 0)))
                        {
                            _1MySerClass.userList.Remove(ct);
                            continue;
                        }
                        else if (ct.nodeIP == f.txtBIP.Text.Trim())
                        {

                            ct.SendMessage("C" + tbxTime.Text.ToString(), 2);
                            //ct.SendMessage("C" + tbxTime.Text.ToString(), 2);
                           // ct.SendMessage("C" + tbxTime.Text.ToString(), 2);

                            if (Delay(1))//延时1s
                            {
                                if (_3ReceieveMsgClass.flagTime == 1)
                                {
                                    MessageBox.Show("执行成功！");
                                    LogCommand.WriteLogFile("校时指令执行成功！");
                                }
                                else
                                {

                                    ct.SendMessage("C" + tbxTime.Text.ToString(), 2);//第二次重发
                                    Delay(2);

                                    if (_3ReceieveMsgClass.flagTime == 1)
                                    {
                                        MessageBox.Show("执行成功！");
                                        LogCommand.WriteLogFile("校时指令执行成功！");
                                    }
                                    else
                                    {
                                        ct.SendMessage("C" + tbxTime.Text.ToString(), 2);//第3次重发
                                        Delay(2);

                                        if (_3ReceieveMsgClass.flagTime == 1)
                                        {
                                            MessageBox.Show("执行成功！");
                                            LogCommand.WriteLogFile("校时指令执行成功！");
                                        }
                                        else
                                        {
                                            MessageBox.Show("执行失败！");
                                            LogCommand.WriteLogFile("校时指令执行失败！");
                                        }

                                    }                                   
                                }
                                    
                            }

                            break;

                        }
                        else
                        {
                            MessageBox.Show("无有效连接！");
                        }
                    }
                }
                else
                {
                    MessageBox.Show("无可用连接！");
                }

            }
            catch (Exception exp)
            {
                LogClass.WriteLogFile("测试指令异常！" + exp.Message);
            }

            _3ReceieveMsgClass.flagTime = 0;

            this.Cursor = Cursors.Default;
        }
        /// <summary>
        /// 设置次级接驳盒电压电流状态数据的采集时间间隔
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void btnDO_Click(object sender, EventArgs e)
        {
            this.Cursor = Cursors.WaitCursor;
            _3ReceieveMsgClass.flagInterval = 0;
            try
            {
                if (f.canBConnect.Text == "连接")
                {
                    for (int i = _1MySerClass.userList.Count - 1; i >= 0; i--)
                    {
                        _3ReceieveMsgClass ct = _1MySerClass.userList[i];
                        if (!ct.tcpClient.Connected || ((ct.tcpClient.Poll(1000, SelectMode.SelectRead)) && (ct.tcpClient.Available == 0)))
                        {
                            _1MySerClass.userList.Remove(ct);
                            continue;
                        }
                        else if (ct.nodeIP == f.txtBIP.Text.Trim())
                        {


                            string cmd = "$SET+01+INT" + txtInterval.Text.ToString().Trim() + "#";

                            //通过STM32透传给下一级单片机的指令发送三遍
                            ct.SendMessage(cmd, 2);
                            
                            if (Delay(1))
                            {
                                if (_3ReceieveMsgClass.flagInterval == 1)
                                {
                                    MessageBox.Show("执行成功！");
                                    LogCommand.WriteLogFile("次级接驳盒状态信息采样时间间隔设置成功！");

                                    string sql = "update seafloor_otherLimits set adInterval = '" + txtInterval.Text.ToString() + "' where limitsType = '次级接驳盒'";
                                    SqlHelper.ExecuteNonQuery(sql);
                                }
                                else
                                {

                                    ct.SendMessage(cmd, 2);//第二次重发
                                    Delay(2);

                                    if (_3ReceieveMsgClass.flagInterval == 1)
                                    {
                                        MessageBox.Show("执行成功！");
                                        LogCommand.WriteLogFile("次级接驳盒状态信息采样时间间隔设置成功！");
                                        // WriteLimits("A1VoltageHigh", "A1VoltageLow", "A1CurrentHigh", "A1CurrentLow", "A1CabinLimitsConfig.xml", txtA1VH, txtA1VL, txtA1AH, txtA1AL);

                                        string sql = "update seafloor_otherLimits set adInterval = '" + txtInterval.Text.ToString() + "' where limitsType = '次级接驳盒'";
                                        SqlHelper.ExecuteNonQuery(sql);
                                    }
                                    else
                                    {
                                        ct.SendMessage(cmd, 2);//第二次重发
                                        Delay(2);

                                        if (_3ReceieveMsgClass.flagInterval == 1)
                                        {
                                            MessageBox.Show("执行成功！");
                                            LogCommand.WriteLogFile("次级接驳盒状态信息采样时间间隔设置成功！");
                                            //WriteLimits("A1VoltageHigh", "A1VoltageLow", "A1CurrentHigh", "A1CurrentLow", "A1CabinLimitsConfig.xml", txtA1VH, txtA1VL, txtA1AH, txtA1AL);

                                            string sql = "update seafloor_otherLimits set adInterval = '" + txtInterval.Text.ToString() + "' where limitsType = '次级接驳盒'";
                                            SqlHelper.ExecuteNonQuery(sql);
                                        }
                                        else
                                        {
                                            MessageBox.Show("执行失败！");
                                            LogCommand.WriteLogFile("次级接驳盒状态信息采样时间间隔设置失败！");
                                        }

                                    }
                                }

                            }
                            break;

                        }
                        else
                        {
                            MessageBox.Show("无有效连接！");
                        }
                    }
                }
                else
                {
                    MessageBox.Show("无可用连接！");
                }

            }
            catch (Exception exp)
            {
                LogClass.WriteLogFile("次级接驳盒状态信息采样时间间隔设置指令异常！" + exp.Message);
            }

            _3ReceieveMsgClass.flagInterval = 0;

            this.Cursor = Cursors.Default;   


        }
             
        /// <summary>
        /// 设置通道1电压电流上下限
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void btnRJWSet_Click(object sender, EventArgs e)
        {
            this.Cursor = Cursors.WaitCursor;
            _3ReceieveMsgClass.flagA1 = 0;
            try
            {
                if (f.canBConnect.Text == "连接")
                {
                    for (int i = _1MySerClass.userList.Count - 1; i >= 0; i--)
                    {
                        _3ReceieveMsgClass ct = _1MySerClass.userList[i];
                        if (!ct.tcpClient.Connected || ((ct.tcpClient.Poll(1000, SelectMode.SelectRead)) && (ct.tcpClient.Available == 0)))
                        {
                            _1MySerClass.userList.Remove(ct);
                            continue;
                        }
                        else if (ct.nodeIP == f.txtBIP.Text.Trim())
                        {

                            //string sql = "update junctionboxelectricallimits set currentHigh='" + txtA1AH.Text.ToString() + "' ,currentLow='" + txtA1AL.Text.ToString() + "', voltageHigh='" + txtA1VH.Text.ToString() + "',voltageLow='" + txtA1VL.Text.ToString() + "' where serial = 1 and channelNumber = 1";
                            //SqlHelper.ExecuteNonQuery(sql);


                            string cmd = "$SET+01+CurAH" + txt1AH.Text.ToString() + "+CurAL" + txt1AL.Text.ToString() + "+VolAH" + txt1VH.Text.ToString() + "+VolAL" + txt1VL.Text.ToString() + "#";

                            //通过STM32透传给下一级单片机的指令发送三遍
                            ct.SendMessage(cmd, 2);
                            //ct.SendMessage(cmd, 2);
                            //ct.SendMessage(cmd, 2);
                            if (Delay(1))
                            {
                                if (_3ReceieveMsgClass.flagA1 == 1)
                                {
                                    MessageBox.Show("执行成功！");
                                    LogCommand.WriteLogFile("次级接驳盒通道1电压电流上下限设置成功！");

                                    string sql = "update seafloor_elecLimits set limitsCurHigh='" + txt1AH.Text.ToString() + "' ,limitsCurLow='" + txt1AL.Text.ToString() + "', limitsVolHigh='" + txt1VH.Text.ToString() + "',limitsVolLow='" + txt1VL.Text.ToString() + "' where limitsNum = 1 and limitsType = '次级接驳盒'";
                                    SqlHelper.ExecuteNonQuery(sql);
                                }
                                else
                                {

                                    ct.SendMessage(cmd, 2);//第二次重发
                                    Delay(2);

                                    if (_3ReceieveMsgClass.flagA1 == 1)
                                    {
                                        MessageBox.Show("执行成功！");
                                        LogCommand.WriteLogFile("次级接驳盒通道1电压电流上下限设置成功！");
                                       // WriteLimits("A1VoltageHigh", "A1VoltageLow", "A1CurrentHigh", "A1CurrentLow", "A1CabinLimitsConfig.xml", txtA1VH, txtA1VL, txtA1AH, txtA1AL);

                                        string sql = "update seafloor_elecLimits set limitsCurHigh='" + txt1AH.Text.ToString() + "' ,limitsCurLow='" + txt1AL.Text.ToString() + "', limitsVolHigh='" + txt1VH.Text.ToString() + "',limitsVolLow='" + txt1VL.Text.ToString() + "' where limitsNum = 1 and limitsType = '次级接驳盒'";
                                        SqlHelper.ExecuteNonQuery(sql);
                                    }
                                    else
                                    {
                                        ct.SendMessage(cmd, 2);//第二次重发
                                        Delay(2);

                                        if (_3ReceieveMsgClass.flagA1 == 1)
                                        {
                                            MessageBox.Show("执行成功！");
                                            LogCommand.WriteLogFile("次级接驳盒通道1电压电流上下限设置成功！");
                                            //WriteLimits("A1VoltageHigh", "A1VoltageLow", "A1CurrentHigh", "A1CurrentLow", "A1CabinLimitsConfig.xml", txtA1VH, txtA1VL, txtA1AH, txtA1AL);

                                            string sql = "update seafloor_elecLimits set limitsCurHigh='" + txt1AH.Text.ToString() + "' ,limitsCurLow='" + txt1AL.Text.ToString() + "', limitsVolHigh='" + txt1VH.Text.ToString() + "',limitsVolLow='" + txt1VL.Text.ToString() + "' where limitsNum = 1 and limitsType = '次级接驳盒'";
                                            SqlHelper.ExecuteNonQuery(sql);
                                        }
                                        else
                                        {
                                            MessageBox.Show("执行失败！");
                                            LogCommand.WriteLogFile("次级接驳盒通道1电压电流上下限设置失败！");
                                        }

                                    }                                   
                                }

                            }
                            break;

                        }
                        else
                        {
                            MessageBox.Show("无有效连接！");
                        }
                    }
                }
                else
                {
                    MessageBox.Show("无可用连接！");
                }

            }
            catch (Exception exp)
            {
                LogClass.WriteLogFile("设置次级接驳盒通道1电压电流上下限指令异常！" + exp.Message);
            }

            _3ReceieveMsgClass.flagA1 = 0;

            this.Cursor = Cursors.Default;
                          
        }
        /// <summary>
        /// 通道2电压电流上限下限设置
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void btnJWSet_Click(object sender, EventArgs e)
        {
            this.Cursor = Cursors.WaitCursor;
            _3ReceieveMsgClass.flagA2 = 0;
            try
            {
                if (f.canBConnect.Text == "连接")
                {
                    for (int i = _1MySerClass.userList.Count - 1; i >= 0; i--)
                    {
                        _3ReceieveMsgClass ct = _1MySerClass.userList[i];
                        if (!ct.tcpClient.Connected || ((ct.tcpClient.Poll(1000, SelectMode.SelectRead)) && (ct.tcpClient.Available == 0)))
                        {
                            _1MySerClass.userList.Remove(ct);
                            continue;
                        }
                        else if (ct.nodeIP == f.txtBIP.Text.Trim())
                        {

                            string cmd = "$SET+01+CurBH" + txt2AH.Text.ToString() + "+CurBL" + txt2AL.Text.ToString() + "+VolBH" + txt2VH.Text.ToString() + "+VolBL" + txt2VL.Text.ToString() + "#";

                            //通过STM32透传给下一级单片机的指令发送三遍
                            ct.SendMessage(cmd, 2);
                            //ct.SendMessage(cmd, 2);
                            //ct.SendMessage(cmd, 2);
                            if (Delay(1))
                            {
                                if (_3ReceieveMsgClass.flagA2 == 1)
                                {
                                    MessageBox.Show("执行成功！");
                                    LogCommand.WriteLogFile("次级接驳盒通道2电压电流上下限设置成功！");
                                   // WriteLimits("A2VoltageHigh", "A2VoltageLow", "A2CurrentHigh", "A2CurrentLow", "A2CabinLimitsConfig.xml",txtA2VH,txtA2VL,txtA2AH,txtA2AL);

                                    string sql = "update seafloor_elecLimits set limitsCurHigh='" + txt2AH.Text.ToString() + "' ,limitsCurLow='" + txt2AL.Text.ToString() + "', limitsVolHigh='" + txt2VH.Text.ToString() + "',limitsVolLow='" + txt2VL.Text.ToString() + "' where limitsNum = 2 and limitsType = '次级接驳盒'";
                                    SqlHelper.ExecuteNonQuery(sql);
                                }
                                else
                                {

                                    ct.SendMessage(cmd, 2);
                                    Delay(2);

                                    if (_3ReceieveMsgClass.flagA2 == 1)
                                    {
                                        MessageBox.Show("执行成功！");
                                        LogCommand.WriteLogFile("次级接驳盒通道2电压电流上下限设置成功！");

                                        string sql = "update seafloor_elecLimits set limitsCurHigh='" + txt2AH.Text.ToString() + "' ,limitsCurLow='" + txt2AL.Text.ToString() + "', limitsVolHigh='" + txt2VH.Text.ToString() + "',limitsVolLow='" + txt2VL.Text.ToString() + "' where limitsNum = 2 and limitsType = '次级接驳盒'";
                                        SqlHelper.ExecuteNonQuery(sql);
                                        //WriteLimits("A2VoltageHigh", "A2VoltageLow", "A2CurrentHigh", "A2CurrentLow", "A2CabinLimitsConfig.xml", txtA2VH, txtA2VL, txtA2AH, txtA2AL);
                                    }
                                    else
                                    {
                                        ct.SendMessage(cmd, 2);
                                        Delay(2);
                                        if (_3ReceieveMsgClass.flagA2 == 1)
                                        {
                                            MessageBox.Show("执行成功！");
                                            LogCommand.WriteLogFile("次级接驳盒通道2电压电流上下限设置成功！");
                                            string sql = "update seafloor_elecLimits set limitsCurHigh='" + txt2AH.Text.ToString() + "' ,limitsCurLow='" + txt2AL.Text.ToString() + "', limitsVolHigh='" + txt2VH.Text.ToString() + "',limitsVolLow='" + txt2VL.Text.ToString() + "' where limitsNum = 2 and limitsType = '次级接驳盒'";
                                            SqlHelper.ExecuteNonQuery(sql);
                                            // WriteLimits("A2VoltageHigh", "A2VoltageLow", "A2CurrentHigh", "A2CurrentLow", "A2CabinLimitsConfig.xml", txtA2VH, txtA2VL, txtA2AH, txtA2AL);
                                        }
                                        else
                                        {
                                            MessageBox.Show("执行失败！");
                                            LogCommand.WriteLogFile("次级接驳盒通道2电压电流上下限设置失败！");
                                        }
                                    }                                   
                                }
                            }

                            break;

                        }
                        else
                        {
                            MessageBox.Show("无有效连接！");
                        }
                    }
                }
                else
                {
                    MessageBox.Show("无可用连接！");
                }

            }
            catch (Exception exp)
            {
                LogClass.WriteLogFile("设置次级接驳盒通道2电压电流上下限指令异常！" + exp.Message);
            }

            _3ReceieveMsgClass.flagA2 = 0;
            this.Cursor = Cursors.Default;      
        }
       
        /// <summary>
        /// A舱温度上下限设定指令执行
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void btnTempSet_Click(object sender, EventArgs e)
        {
            this.Cursor = Cursors.WaitCursor;
            _3ReceieveMsgClass.flagATemp = 0;
            try
            {
                if (f.canBConnect.Text == "连接")
                {
                    for (int i = _1MySerClass.userList.Count - 1; i >= 0; i--)
                    {
                        _3ReceieveMsgClass ct = _1MySerClass.userList[i];
                        if (!ct.tcpClient.Connected || ((ct.tcpClient.Poll(1000, SelectMode.SelectRead)) && (ct.tcpClient.Available == 0)))
                        {
                            _1MySerClass.userList.Remove(ct);
                            continue;
                        }
                        else if (ct.nodeIP == f.txtBIP.Text.Trim())
                        {
                            //string sql = "update junctionboxotherlimits set tempHigh='" + txtATH.Text.ToString() + "',tempLow='" + txtATL.Text.ToString() + "' where serial = 1";
                            //SqlHelper.ExecuteNonQuery(sql);

                            string cmd = "$SET+01+TempH" + txtTH.Text.ToString() + "+TempL" + txtTL.Text.ToString() + "#";
                            //通过STM32透传给下一级单片机的发送三遍
                            ct.SendMessage(cmd, 2);
                            //ct.SendMessage(cmd, 2);
                            //ct.SendMessage(cmd, 2);
                            if (Delay(1))
                            {
                                if (_3ReceieveMsgClass.flagATemp == 1)
                                {
                                    MessageBox.Show("执行成功！");
                                    LogCommand.WriteLogFile("次级接驳盒舱内温度上下限设置成功！");
                                   // WriteTempLimits("ATempHigh", "ATempLow", "ATempConfig.xml", txtATH, txtATL);
                                    string sql = "update seafloor_otherlimits set limitsTempHigh='" + txtTH.Text.ToString() + "',limitsTempLow='" + txtTL.Text.ToString() + "' where limitsType = '次级接驳盒'";
                                    SqlHelper.ExecuteNonQuery(sql);
                                }
                                else
                                {

                                    ct.SendMessage(cmd, 2);//第二次重发
                                    Delay(2);

                                    if (_3ReceieveMsgClass.flagATemp == 1)
                                    {
                                        MessageBox.Show("执行成功！");
                                        LogCommand.WriteLogFile("次级接驳盒舱内温度上下限设置成功！");

                                        string sql = "update seafloor_otherLimits set limitsTempHigh='" + txtTH.Text.ToString() + "',limitsTempLow='" + txtTL.Text.ToString() + "' where limitsType = '次级接驳盒'";
                                        SqlHelper.ExecuteNonQuery(sql);
                                        
                                        // WriteTempLimits("ATempHigh", "ATempLow", "ATempConfig.xml", txtATH, txtATL);
                                    }
                                    else
                                    {
                                        ct.SendMessage(cmd, 2);//第三次重发
                                        Delay(2);

                                        if (_3ReceieveMsgClass.flagATemp == 1)
                                        {
                                            MessageBox.Show("执行成功！");
                                            LogCommand.WriteLogFile("次级接驳盒舱内温度上下限设置成功！");

                                            string sql = "update seafloor_otherlimits set limitsTempHigh='" + txtTH.Text.ToString() + "',limitsTempLow='" + txtTL.Text.ToString() + "' where limitsType = '次级接驳盒'";
                                            SqlHelper.ExecuteNonQuery(sql);
                                            
                                            //WriteTempLimits("ATempHigh", "ATempLow", "ATempConfig.xml", txtATH, txtATL);
                                        }
                                        else
                                        {
                                            MessageBox.Show("执行失败！");
                                            LogCommand.WriteLogFile("次级接驳盒舱内温度上下限设置失败！");
                                        }
                                    }                                   
                                }
                            }
                            break;
                        }
                        else
                        {
                            MessageBox.Show("无有效连接！");
                        }
                    }
                }
                else
                {
                    MessageBox.Show("无可用连接！");
                }

            }
            catch (Exception exp)
            {
                LogClass.WriteLogFile("设置次级接驳盒舱内温度上下限指令异常！" + exp.Message);
            }

            _3ReceieveMsgClass.flagATemp = 0;
            this.Cursor = Cursors.Default;
        }

       
        /// <summary>
        /// 指令设置窗口初始化加载函数，每次弹出执行指令界面时，出现的是上次设置的上下限
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void cmdSet_Load(object sender, EventArgs e)
        {
            this.tbxTime.Text = DateTime.Now.ToString("yyyy-MM-dd HH:mm:ss");//大写的HH是24小时制，精确到s就可以了，如需精确到ms则在后面加fff
            this.timer1.Start();

            //将接驳盒 通道1、通道2、通道3、通道4、通道5的电压电流上下限数值以及温度上下限数值的字体设置成液晶字体
            FontClass fontType = new FontClass();
            txt1AH.Font = fontType.fontLed;
            txt1AL.Font = fontType.fontLed;
            txt1VH.Font = fontType.fontLed;
            txt1VL.Font = fontType.fontLed;

            txt2AH.Font = fontType.fontLed;
            txt2AL.Font = fontType.fontLed;
            txt2VH.Font = fontType.fontLed;
            txt2VL.Font = fontType.fontLed;

            txt3AH.Font = fontType.fontLed;
            txt3AL.Font = fontType.fontLed;
            txt3VH.Font = fontType.fontLed;
            txt3VL.Font = fontType.fontLed;

            txt4AH.Font = fontType.fontLed;
            txt4AL.Font = fontType.fontLed;
            txt4VH.Font = fontType.fontLed;
            txt4VL.Font = fontType.fontLed;

            txt5AH.Font = fontType.fontLed;
            txt5AL.Font = fontType.fontLed;
            txt5VH.Font = fontType.fontLed;
            txt5VL.Font = fontType.fontLed;


            txtTH.Font = fontType.fontLed;
            txtTL.Font = fontType.fontLed;

            //txtB1AH.Font = fontType.fontLed;
            //txtB1AL.Font = fontType.fontLed;
            //txtB1VH.Font = fontType.fontLed;
            //txtB1VL.Font = fontType.fontLed;

            //txtB2AH.Font = fontType.fontLed;
            //txtB2AL.Font = fontType.fontLed;
            //txtB2VH.Font = fontType.fontLed;
            //txtB2VL.Font = fontType.fontLed;

            //txtBTH.Font = fontType.fontLed;
            //txtBTL.Font = fontType.fontLed;


            txtInterval.Font = fontType.fontLed;
            tbxTime.Font = fontType.fontLed;

            

            //读取次接驳盒通道的电参数上下数值
            string sql = "select * from seafloor_elecLimits where limitsType = '次级接驳盒' order by Id asc";
            ReadJunctionBoxElectricalLimits(sql);

            //读取次接驳盒温度上下限数值
            string sql1 = "select * from seafloor_otherLimits where limitsType = '次级接驳盒' order by Id asc";
            ReadJunctionboxOtherLimits(sql1);
            



        }

        /// <summary>
        /// 读取主次接驳盒不同通道电流电压上下限值
        /// </summary>
        /// <param name="sql"></param>
        private void ReadJunctionBoxElectricalLimits(string sql)
        {
            try
            {
                DataTable tTable = SqlHelper.ExecuteDataTable(sql);

                txt1AH.Text = tTable.Rows[0]["limitsCurHigh"].ToString();
                txt1AL.Text = tTable.Rows[0]["limitsCurLow"].ToString();
                txt1VH.Text = tTable.Rows[0]["limitsVolHigh"].ToString();
                txt1VL.Text = tTable.Rows[0]["limitsVolLow"].ToString();

                txt2AH.Text = tTable.Rows[1]["limitsCurHigh"].ToString();
                txt2AL.Text = tTable.Rows[1]["limitsCurLow"].ToString();
                txt2VH.Text = tTable.Rows[1]["limitsVolHigh"].ToString();
                txt2VL.Text = tTable.Rows[1]["limitsVolLow"].ToString();

                txt3AH.Text = tTable.Rows[2]["limitsCurHigh"].ToString();
                txt3AL.Text = tTable.Rows[2]["limitsCurLow"].ToString();
                txt3VH.Text = tTable.Rows[2]["limitsVolHigh"].ToString();
                txt3VL.Text = tTable.Rows[2]["limitsVolLow"].ToString();


                txt4AH.Text = tTable.Rows[3]["limitsCurHigh"].ToString();
                txt4AL.Text = tTable.Rows[3]["limitsCurLow"].ToString();
                txt4VH.Text = tTable.Rows[3]["limitsVolHigh"].ToString();
                txt4VL.Text = tTable.Rows[3]["limitsVolLow"].ToString();


                txt5AH.Text = tTable.Rows[4]["limitsCurHigh"].ToString();
                txt5AL.Text = tTable.Rows[4]["limitsCurLow"].ToString();
                txt5VH.Text = tTable.Rows[4]["limitsVolHigh"].ToString();
                txt5VL.Text = tTable.Rows[4]["limitsVolLow"].ToString();

                               
            }
            catch(Exception exp)
            {
                LogClass.WriteLogFile("读取次级接驳盒电参数上下限异常！"+exp.Message);
            }
        }
        /// <summary>
        /// 读取接驳盒温度上下限以及采集时间间隔
        /// </summary>
        /// <param name="sql"></param>
        private void ReadJunctionboxOtherLimits(string sql)
        {
            try
            {
                DataTable tTable = SqlHelper.ExecuteDataTable(sql);

                txtTH.Text = tTable.Rows[0]["limitsTempHigh"].ToString();
                txtTL.Text = tTable.Rows[0]["limitsTempLow"].ToString();
                txtInterval.Text = tTable.Rows[0]["adInterval"].ToString();
            }
            catch(Exception exp)
            {
                LogClass.WriteLogFile("读取次级接驳盒温度上下限异常！"+exp.Message);
            }

        }



        /// <summary>
        /// 从记录的文件中读取记录的上下限
        /// </summary>
        /// <param name="VH"></param>
        /// <param name="VL"></param>
        /// <param name="AH"></param>
        /// <param name="AL"></param>
        /// <param name="fileName"></param>
        /// <param name="txtVH"></param>
        /// <param name="txtVL"></param>
        /// <param name="txtAH"></param>
        /// <param name="txtAL"></param>
        private void ReadLimits(string VH,string VL,string AH,string AL,string fileName,TextBox txtVH,TextBox txtVL,TextBox txtAH,TextBox txtAL)
        {
            DataSet ds = new DataSet();
            ds.ReadXml(@fileName);

            txtVH.Text = ds.Tables[0].Rows[0][VH].ToString();
            txtVL.Text = ds.Tables[0].Rows[0][VL].ToString();
            txtAH.Text = ds.Tables[0].Rows[0][AH].ToString();
            txtAL.Text = ds.Tables[0].Rows[0][AL].ToString();
        }

        private void ReadTempLimits(string TH,string TL,string fileName,TextBox txtTH,TextBox txtTL)
        {
            DataSet ds = new DataSet();
            ds.ReadXml(@fileName);

            txtTH.Text = ds.Tables[0].Rows[0][TH].ToString();
            txtTL.Text = ds.Tables[0].Rows[0][TL].ToString();
        }




        private void timer1_Tick(object sender, EventArgs e)
        {
            this.tbxTime.Text = DateTime.Now.ToString("yyyy-MM-dd HH:mm:ss");
        }

        /// <summary>
        /// 将字符转换成其ASCII码对应的字符
        /// </summary>
        /// <param name="input"></param>
        /// <returns></returns>
        private string StrToASCII(string input)
        {
            StringBuilder sb = new StringBuilder(input.Length * 2);
            for (int i = 0; i < input.Length; i++)
            {
                sb.Append(((int)input[i]).ToString("X2"));
            }
            return sb.ToString();
        }


        public bool Delay(int delayTime)
        {
            DateTime now = DateTime.Now;
            int s;
            do
            {
                TimeSpan spand = DateTime.Now - now;
                s = spand.Seconds;
                Application.DoEvents();
            }
            while (s < delayTime);
            return true;

        }
       
        /// <summary>
        /// 记录上下限到文件中
        /// </summary>
        private void WriteLimits(string VH,string VL,string AH,string AL,string fileName,TextBox txtVH,TextBox txtVL,TextBox txtAH,TextBox txtAL)
        {
            try
            {
                DataTable dtConfig = new DataTable();

                dtConfig.Columns.Add(VH);//A1通道电压上限
                dtConfig.Columns.Add(VL);//A1通道电压下限
                dtConfig.Columns.Add(AH);//A1通道电流上限
                dtConfig.Columns.Add(AL);//A1通道电流下限
                DataRow rowConfig = dtConfig.NewRow();

                rowConfig[VH] = txtVH.Text.Trim();
                rowConfig[VL] = txtVL.Text.Trim();
                rowConfig[AH] = txtAH.Text.Trim();
                rowConfig[AL] = txtAL.Text.Trim();

                dtConfig.Rows.Add(rowConfig);
                DataSet dsConfig = new DataSet();
                dsConfig.Tables.Add(dtConfig);
                dsConfig.WriteXml(@fileName);
            }
            catch(Exception exp)
            {
                LogClass.WriteLogFile("记录接驳盒通道上下限存在异常！"+exp.Message);
            }
            
        }


        /// <summary>
        /// 记录温度上下限到文件中
        /// </summary>
        private void WriteTempLimits(string TH, string TL,string fileName, TextBox txtTH, TextBox txtTL)
        {
            try
            {
                DataTable dtConfig = new DataTable();

                dtConfig.Columns.Add(TH);//A1通道电压上限
                dtConfig.Columns.Add(TL);//A1通道电压下限

                DataRow rowConfig = dtConfig.NewRow();

                rowConfig[TH] = txtTH.Text.Trim();
                rowConfig[TL] = txtTL.Text.Trim();

                dtConfig.Rows.Add(rowConfig);
                DataSet dsConfig = new DataSet();
                dsConfig.Tables.Add(dtConfig);
                dsConfig.WriteXml(@fileName);
            }
            catch (Exception exp)
            {
                LogClass.WriteLogFile("记录上下限存在异常！" + exp.Message);
            }

        }

        private void 打开_Click(object sender, EventArgs e)
        {
            this.Cursor = Cursors.WaitCursor;
            _3ReceieveMsgClass.flagOpen = 0;
            try
            {
                if (f.canBConnect.Text == "连接")
                {
                    for (int i = _1MySerClass.userList.Count - 1; i >= 0; i--)
                    {
                        _3ReceieveMsgClass ct = _1MySerClass.userList[i];
                        if (!ct.tcpClient.Connected || ((ct.tcpClient.Poll(1000, SelectMode.SelectRead)) && (ct.tcpClient.Available == 0)))
                        {
                            _1MySerClass.userList.Remove(ct);
                            continue;
                        }
                        else if (ct.nodeIP == f.txtBIP.Text.Trim())
                        {

                            ct.SendMessage("D", 2);
                           
                            if (Delay(1))//延时1s
                            {
                                if (_3ReceieveMsgClass.flagOpen == 1)
                                {
                                    MessageBox.Show("执行成功！");
                                    LogCommand.WriteLogFile("校时指令执行成功！");
                                }
                                else
                                {

                                    ct.SendMessage("D", 2);//第二次重发
                                    Delay(2);

                                    if (_3ReceieveMsgClass.flagOpen == 1)
                                    {
                                        MessageBox.Show("执行成功！");
                                        LogCommand.WriteLogFile("校时指令执行成功！");
                                    }
                                    else
                                    {
                                        ct.SendMessage("D", 2);//第3次重发
                                        Delay(2);

                                        if (_3ReceieveMsgClass.flagOpen == 1)
                                        {
                                            MessageBox.Show("执行成功！");
                                            LogCommand.WriteLogFile("摄像头打开成功！");
                                        }
                                        else
                                        {
                                            MessageBox.Show("执行失败！");
                                            LogCommand.WriteLogFile("摄像头打开失败！");
                                        }

                                    }
                                }

                            }

                            break;

                        }
                        else
                        {
                            MessageBox.Show("无有效连接！");
                        }
                    }
                }
                else
                {
                    MessageBox.Show("无可用连接！");
                }

            }
            catch (Exception exp)
            {
                LogClass.WriteLogFile("测试指令异常！" + exp.Message);
            }

            _3ReceieveMsgClass.flagOpen = 0;

            this.Cursor = Cursors.Default;
        }

        private void button2_Click(object sender, EventArgs e)
        {
            this.Cursor = Cursors.WaitCursor;
            _3ReceieveMsgClass.flagClose = 0;
            try
            {
                if (f.canBConnect.Text == "连接")
                {
                    for (int i = _1MySerClass.userList.Count - 1; i >= 0; i--)
                    {
                        _3ReceieveMsgClass ct = _1MySerClass.userList[i];
                        if (!ct.tcpClient.Connected || ((ct.tcpClient.Poll(1000, SelectMode.SelectRead)) && (ct.tcpClient.Available == 0)))
                        {
                            _1MySerClass.userList.Remove(ct);
                            continue;
                        }
                        else if (ct.nodeIP == f.txtBIP.Text.Trim())
                        {

                            ct.SendMessage("E", 2);

                            if (Delay(1))//延时1s
                            {
                                if (_3ReceieveMsgClass.flagClose == 1)
                                {
                                    MessageBox.Show("执行成功！");
                                    LogCommand.WriteLogFile("校时指令执行成功！");
                                }
                                else
                                {

                                    ct.SendMessage("E", 2);//第二次重发
                                    Delay(2);

                                    if (_3ReceieveMsgClass.flagClose == 1)
                                    {
                                        MessageBox.Show("执行成功！");
                                        LogCommand.WriteLogFile("校时指令执行成功！");
                                    }
                                    else
                                    {
                                        ct.SendMessage("E", 2);//第3次重发
                                        Delay(2);

                                        if (_3ReceieveMsgClass.flagClose == 1)
                                        {
                                            MessageBox.Show("执行成功！");
                                            LogCommand.WriteLogFile("摄像头关闭成功！");
                                        }
                                        else
                                        {
                                            MessageBox.Show("执行失败！");
                                            LogCommand.WriteLogFile("摄像头关闭失败！");
                                        }

                                    }
                                }

                            }

                            break;

                        }
                        else
                        {
                            MessageBox.Show("无有效连接！");
                        }
                    }
                }
                else
                {
                    MessageBox.Show("无可用连接！");
                }

            }
            catch (Exception exp)
            {
                LogClass.WriteLogFile("测试指令异常！" + exp.Message);
            }

            _3ReceieveMsgClass.flagClose = 0;

            this.Cursor = Cursors.Default;
        }
        /// <summary>
        /// 溶解氧单独指令界面
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void btnDOCmd_Click(object sender, EventArgs e)
        {
            //SetDO mySetDO = new SetDO(f);
            //mySetDO.Show();
        }
        /// <summary>
        /// 摄像头单独指令界面
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void btnCameraCmd_Click(object sender, EventArgs e)
        {
            SetCamera mySetCamera = new SetCamera(f);
            mySetCamera.Show();
        }
        /// <summary>
        /// 主接驳盒芯片擦除指令
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void button1_Click(object sender, EventArgs e)
        {
            this.Cursor = Cursors.WaitCursor;
            _3ReceieveMsgClass.flagAErase = 0;
            try
            {
                if (f.canBConnect.Text == "连接")
                {
                    for (int i = _1MySerClass.userList.Count - 1; i >= 0; i--)
                    {
                        _3ReceieveMsgClass ct = _1MySerClass.userList[i];
                        if (!ct.tcpClient.Connected || ((ct.tcpClient.Poll(1000, SelectMode.SelectRead)) && (ct.tcpClient.Available == 0)))
                        {
                            _1MySerClass.userList.Remove(ct);
                            continue;
                        }
                        else if (ct.nodeIP == f.txtBIP.Text.Trim())
                        {

                            ct.SendMessage("A$Erase chip#", 2);

                            if (Delay(1))//延时1s
                            {
                                if (_3ReceieveMsgClass.flagAErase == 1)
                                {
                                    MessageBox.Show("执行成功！");
                                    LogCommand.WriteLogFile("主接驳盒芯片擦除指令执行成功！");
                                }
                                else
                                {

                                    ct.SendMessage("A$Erase chip#", 2);//第二次重发
                                    Delay(2);

                                    if (_3ReceieveMsgClass.flagAErase == 1)
                                    {
                                        MessageBox.Show("执行成功！");
                                        LogCommand.WriteLogFile("主接驳盒芯片擦除指令执行成功！");
                                    }
                                    else
                                    {
                                        ct.SendMessage("A$Erase chip#", 2);//第3次重发
                                        Delay(2);

                                        if (_3ReceieveMsgClass.flagAErase == 1)
                                        {
                                            MessageBox.Show("执行成功！");
                                            LogCommand.WriteLogFile("主接驳盒芯片擦除指令执行成功！");
                                        }
                                        else
                                        {
                                            MessageBox.Show("执行失败！");
                                            LogCommand.WriteLogFile("主接驳盒芯片擦除指令执行失败！");
                                        }

                                    }
                                }

                            }

                            break;

                        }
                        else
                        {
                            MessageBox.Show("无有效连接！");
                        }
                    }
                }
                else
                {
                    MessageBox.Show("无可用连接！");
                }

            }
            catch (Exception exp)
            {
                LogClass.WriteLogFile("主接驳盒芯片擦除指令执行异常！" + exp.Message);
            }

            _3ReceieveMsgClass.flagAErase = 0;

            this.Cursor = Cursors.Default;
        }

        private void button2_Click_1(object sender, EventArgs e)
        {
            this.Cursor = Cursors.WaitCursor;
            _3ReceieveMsgClass.flagBErase = 0;
            try
            {
                if (f.canBConnect.Text == "连接")
                {
                    for (int i = _1MySerClass.userList.Count - 1; i >= 0; i--)
                    {
                        _3ReceieveMsgClass ct = _1MySerClass.userList[i];
                        if (!ct.tcpClient.Connected || ((ct.tcpClient.Poll(1000, SelectMode.SelectRead)) && (ct.tcpClient.Available == 0)))
                        {
                            _1MySerClass.userList.Remove(ct);
                            continue;
                        }
                        else if (ct.nodeIP == f.txtBIP.Text.Trim())
                        {

                            ct.SendMessage("B$Erase chip#", 2);

                            if (Delay(1))//延时1s
                            {
                                if (_3ReceieveMsgClass.flagBErase == 1)
                                {
                                    MessageBox.Show("执行成功！");
                                    LogCommand.WriteLogFile("次接驳盒芯片擦除指令执行成功！");
                                }
                                else
                                {

                                    ct.SendMessage("B$Erase chip#", 2);//第二次重发
                                    Delay(2);

                                    if (_3ReceieveMsgClass.flagBErase == 1)
                                    {
                                        MessageBox.Show("执行成功！");
                                        LogCommand.WriteLogFile("次接驳盒芯片擦除指令执行成功！");
                                    }
                                    else
                                    {
                                        ct.SendMessage("B$Erase chip#", 2);//第3次重发
                                        Delay(2);

                                        if (_3ReceieveMsgClass.flagBErase == 1)
                                        {
                                            MessageBox.Show("执行成功！");
                                            LogCommand.WriteLogFile("次接驳盒芯片擦除指令执行成功！");
                                        }
                                        else
                                        {
                                            MessageBox.Show("执行失败！");
                                            LogCommand.WriteLogFile("主接驳盒芯片擦除指令执行失败！");
                                        }

                                    }
                                }

                            }

                            break;

                        }
                        else
                        {
                            MessageBox.Show("无有效连接！");
                        }
                    }
                }
                else
                {
                    MessageBox.Show("无可用连接！");
                }

            }
            catch (Exception exp)
            {
                LogClass.WriteLogFile("次接驳盒芯片擦除指令执行异常！" + exp.Message);
            }

            _3ReceieveMsgClass.flagBErase = 0;

            this.Cursor = Cursors.Default;
        }
        /// <summary>
        /// 设置通道3电压电流上下限
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void btnSet3_Click(object sender, EventArgs e)
        {
            this.Cursor = Cursors.WaitCursor;
            _3ReceieveMsgClass.flagA3 = 0;
            try
            {
                if (f.canBConnect.Text == "连接")
                {
                    for (int i = _1MySerClass.userList.Count - 1; i >= 0; i--)
                    {
                        _3ReceieveMsgClass ct = _1MySerClass.userList[i];
                        if (!ct.tcpClient.Connected || ((ct.tcpClient.Poll(1000, SelectMode.SelectRead)) && (ct.tcpClient.Available == 0)))
                        {
                            _1MySerClass.userList.Remove(ct);
                            continue;
                        }
                        else if (ct.nodeIP == f.txtBIP.Text.Trim())
                        {

                            string cmd = "$SET+01+CurCH" + txt3AH.Text.ToString() + "+CurCL" + txt3AL.Text.ToString() + "+VolCH" + txt3VH.Text.ToString() + "+VolCL" + txt3VL.Text.ToString() + "#";

                            //通过STM32透传给下一级单片机的指令发送三遍
                            ct.SendMessage(cmd, 2);
                            //ct.SendMessage(cmd, 2);
                            //ct.SendMessage(cmd, 2);
                            if (Delay(1))
                            {
                                if (_3ReceieveMsgClass.flagA3 == 1)
                                {
                                    MessageBox.Show("执行成功！");
                                    LogCommand.WriteLogFile("次级接驳盒通道3电压电流上下限设置成功！");
                                    // WriteLimits("A2VoltageHigh", "A2VoltageLow", "A2CurrentHigh", "A2CurrentLow", "A2CabinLimitsConfig.xml",txtA2VH,txtA2VL,txtA2AH,txtA2AL);

                                    string sql = "update seafloor_elecLimits set limitsCurHigh='" + txt3AH.Text.ToString() + "' ,limitsCurLow='" + txt3AL.Text.ToString() + "', limitsVolHigh='" + txt3VH.Text.ToString() + "',limitsVolLow='" + txt3VL.Text.ToString() + "' where limitsNum = 3 and limitsType = '次级接驳盒'";
                                    SqlHelper.ExecuteNonQuery(sql);
                                }
                                else
                                {

                                    ct.SendMessage(cmd, 2);
                                    Delay(2);

                                    if (_3ReceieveMsgClass.flagA3 == 1)
                                    {
                                        MessageBox.Show("执行成功！");
                                        LogCommand.WriteLogFile("次级接驳盒通道3电压电流上下限设置成功！");

                                        string sql = "update seafloor_elecLimits set limitsCurHigh='" + txt3AH.Text.ToString() + "' ,limitsCurLow='" + txt3AL.Text.ToString() + "', limitsVolHigh='" + txt3VH.Text.ToString() + "',limitsVolLow='" + txt3VL.Text.ToString() + "' where limitsNum = 3 and limitsType = '次级接驳盒'";
                                        SqlHelper.ExecuteNonQuery(sql);
                                        //WriteLimits("A2VoltageHigh", "A2VoltageLow", "A2CurrentHigh", "A2CurrentLow", "A2CabinLimitsConfig.xml", txtA2VH, txtA2VL, txtA2AH, txtA2AL);
                                    }
                                    else
                                    {
                                        ct.SendMessage(cmd, 2);
                                        Delay(2);
                                        if (_3ReceieveMsgClass.flagA3 == 1)
                                        {
                                            MessageBox.Show("执行成功！");
                                            LogCommand.WriteLogFile("次级接驳盒通道3电压电流上下限设置成功！");
                                            string sql = "update seafloor_elecLimits set limitsCurHigh='" + txt3AH.Text.ToString() + "' ,limitsCurLow='" + txt3AL.Text.ToString() + "', limitsVolHigh='" + txt3VH.Text.ToString() + "',limitsVolLow='" + txt3VL.Text.ToString() + "' where limitsNum = 3 and limitsType = '次级接驳盒'";
                                            SqlHelper.ExecuteNonQuery(sql);
                                            // WriteLimits("A2VoltageHigh", "A2VoltageLow", "A2CurrentHigh", "A2CurrentLow", "A2CabinLimitsConfig.xml", txtA2VH, txtA2VL, txtA2AH, txtA2AL);
                                        }
                                        else
                                        {
                                            MessageBox.Show("执行失败！");
                                            LogCommand.WriteLogFile("次级接驳盒通道3电压电流上下限设置失败！");
                                        }
                                    }
                                }
                            }

                            break;

                        }
                        else
                        {
                            MessageBox.Show("无有效连接！");
                        }
                    }
                }
                else
                {
                    MessageBox.Show("无可用连接！");
                }

            }
            catch (Exception exp)
            {
                LogClass.WriteLogFile("设置次级接驳盒通道3电压电流上下限指令异常！" + exp.Message);
            }

            _3ReceieveMsgClass.flagA3 = 0;
            this.Cursor = Cursors.Default;  
        }
        /// <summary>
        /// 通道4电压电流上下限设置指令
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void btnSet4_Click(object sender, EventArgs e)
        {
            this.Cursor = Cursors.WaitCursor;
            _3ReceieveMsgClass.flagA4 = 0;
            try
            {
                if (f.canBConnect.Text == "连接")
                {
                    for (int i = _1MySerClass.userList.Count - 1; i >= 0; i--)
                    {
                        _3ReceieveMsgClass ct = _1MySerClass.userList[i];
                        if (!ct.tcpClient.Connected || ((ct.tcpClient.Poll(1000, SelectMode.SelectRead)) && (ct.tcpClient.Available == 0)))
                        {
                            _1MySerClass.userList.Remove(ct);
                            continue;
                        }
                        else if (ct.nodeIP == f.txtBIP.Text.Trim())
                        {

                            string cmd = "$SET+01+CurDH" + txt4AH.Text.ToString() + "+CurDL" + txt4AL.Text.ToString() + "+VolDH" + txt4VH.Text.ToString() + "+VolDL" + txt4VL.Text.ToString() + "#";

                            //通过STM32透传给下一级单片机的指令发送三遍
                            ct.SendMessage(cmd, 2);
                            //ct.SendMessage(cmd, 2);
                            //ct.SendMessage(cmd, 2);
                            if (Delay(1))
                            {
                                if (_3ReceieveMsgClass.flagA4 == 1)
                                {
                                    MessageBox.Show("执行成功！");
                                    LogCommand.WriteLogFile("次级接驳盒通道4电压电流上下限设置成功！");

                                    string sql = "update seafloor_elecLimits set limitsCurHigh='" + txt4AH.Text.ToString() + "' ,limitsCurLow='" + txt4AL.Text.ToString() + "', limitsVolHigh='" + txt4VH.Text.ToString() + "',limitsVolLow='" + txt4VL.Text.ToString() + "' where limitsNum = 4 and limitsType = '次级接驳盒'";
                                    SqlHelper.ExecuteNonQuery(sql);
                                }
                                else
                                {

                                    ct.SendMessage(cmd, 2);
                                    Delay(2);

                                    if (_3ReceieveMsgClass.flagA4 == 1)
                                    {
                                        MessageBox.Show("执行成功！");
                                        LogCommand.WriteLogFile("次级接驳盒通道4电压电流上下限设置成功！");

                                        string sql = "update seafloor_elecLimits set limitsCurHigh='" + txt4AH.Text.ToString() + "' ,limitsCurLow='" + txt4AL.Text.ToString() + "', limitsVolHigh='" + txt4VH.Text.ToString() + "',limitsVolLow='" + txt4VL.Text.ToString() + "' where limitsNum = 4 and limitsType = '次级接驳盒'";
                                        SqlHelper.ExecuteNonQuery(sql);
                                        
                                    }
                                    else
                                    {
                                        ct.SendMessage(cmd, 2);
                                        Delay(2);
                                        if (_3ReceieveMsgClass.flagA4 == 1)
                                        {
                                            MessageBox.Show("执行成功！");
                                            LogCommand.WriteLogFile("次级接驳盒通道4电压电流上下限设置成功！");
                                            string sql = "update seafloor_elecLimits set limitsCurHigh='" + txt4AH.Text.ToString() + "' ,limitsCurLow='" + txt4AL.Text.ToString() + "', limitsVolHigh='" + txt4VH.Text.ToString() + "',limitsVolLow='" + txt4VL.Text.ToString() + "' where limitsNum = 4 and limitsType = '次级接驳盒'";
                                            SqlHelper.ExecuteNonQuery(sql);
                                            
                                        }
                                        else
                                        {
                                            MessageBox.Show("执行失败！");
                                            LogCommand.WriteLogFile("次级接驳盒通道4电压电流上下限设置失败！");
                                        }
                                    }
                                }
                            }

                            break;

                        }
                        else
                        {
                            MessageBox.Show("无有效连接！");
                        }
                    }
                }
                else
                {
                    MessageBox.Show("无可用连接！");
                }

            }
            catch (Exception exp)
            {
                LogClass.WriteLogFile("设置次级接驳盒通道4电压电流上下限指令异常！" + exp.Message);
            }

            _3ReceieveMsgClass.flagA4 = 0;
            this.Cursor = Cursors.Default;  
        }
        /// <summary>
        /// 通道5电压电流上下限指令设置
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void btnSet5_Click(object sender, EventArgs e)
        {
            this.Cursor = Cursors.WaitCursor;
            _3ReceieveMsgClass.flagA5 = 0;
            try
            {
                if (f.canBConnect.Text == "连接")
                {
                    for (int i = _1MySerClass.userList.Count - 1; i >= 0; i--)
                    {
                        _3ReceieveMsgClass ct = _1MySerClass.userList[i];
                        if (!ct.tcpClient.Connected || ((ct.tcpClient.Poll(1000, SelectMode.SelectRead)) && (ct.tcpClient.Available == 0)))
                        {
                            _1MySerClass.userList.Remove(ct);
                            continue;
                        }
                        else if (ct.nodeIP == f.txtBIP.Text.Trim())
                        {

                            string cmd = "$SET+01+CurEH" + txt5AH.Text.ToString() + "+CurEL" + txt5AL.Text.ToString() + "+VolEH" + txt5VH.Text.ToString() + "+VolEL" + txt5VL.Text.ToString() + "#";

                            //通过STM32透传给下一级单片机的指令发送三遍
                            ct.SendMessage(cmd, 2);
                            //ct.SendMessage(cmd, 2);
                            //ct.SendMessage(cmd, 2);
                            if (Delay(1))
                            {
                                if (_3ReceieveMsgClass.flagA5 == 1)
                                {
                                    MessageBox.Show("执行成功！");
                                    LogCommand.WriteLogFile("次级接驳盒通道5电压电流上下限设置成功！");

                                    string sql = "update seafloor_elecLimits set limitsCurHigh='" + txt5AH.Text.ToString() + "' ,limitsCurLow='" + txt5AL.Text.ToString() + "', limitsVolHigh='" + txt5VH.Text.ToString() + "',limitsVolLow='" + txt5VL.Text.ToString() + "' where limitsNum = 5 and limitsType = '次级接驳盒'";
                                    SqlHelper.ExecuteNonQuery(sql);
                                }
                                else
                                {

                                    ct.SendMessage(cmd, 2);
                                    Delay(2);

                                    if (_3ReceieveMsgClass.flagA5 == 1)
                                    {
                                        MessageBox.Show("执行成功！");
                                        LogCommand.WriteLogFile("次级接驳盒通道5电压电流上下限设置成功！");

                                        string sql = "update seafloor_elecLimits set limitsCurHigh='" + txt5AH.Text.ToString() + "' ,limitsCurLow='" + txt5AL.Text.ToString() + "', limitsVolHigh='" + txt5VH.Text.ToString() + "',limitsVolLow='" + txt5VL.Text.ToString() + "' where limitsNum = 5 and limitsType = '次级接驳盒'";
                                        SqlHelper.ExecuteNonQuery(sql);

                                    }
                                    else
                                    {
                                        ct.SendMessage(cmd, 2);
                                        Delay(2);
                                        if (_3ReceieveMsgClass.flagA5 == 1)
                                        {
                                            MessageBox.Show("执行成功！");
                                            LogCommand.WriteLogFile("次级接驳盒通道5电压电流上下限设置成功！");
                                            string sql = "update seafloor_elecLimits set limitsCurHigh='" + txt5AH.Text.ToString() + "' ,limitsCurLow='" + txt5AL.Text.ToString() + "', limitsVolHigh='" + txt5VH.Text.ToString() + "',limitsVolLow='" + txt5VL.Text.ToString() + "' where limitsNum = 5 and limitsType = '次级接驳盒'";
                                            SqlHelper.ExecuteNonQuery(sql);

                                        }
                                        else
                                        {
                                            MessageBox.Show("执行失败！");
                                            LogCommand.WriteLogFile("次级接驳盒通道5电压电流上下限设置失败！");
                                        }
                                    }
                                }
                            }

                            break;

                        }
                        else
                        {
                            MessageBox.Show("无有效连接！");
                        }
                    }
                }
                else
                {
                    MessageBox.Show("无可用连接！");
                }

            }
            catch (Exception exp)
            {
                LogClass.WriteLogFile("设置次级接驳盒通道5电压电流上下限指令异常！" + exp.Message);
            }

            _3ReceieveMsgClass.flagA5 = 0;
            this.Cursor = Cursors.Default;
        }
        ///// <summary>
        ///// 1.校准时钟分组框控件颜色重绘
        ///// </summary>
        ///// <param name="sender"></param>
        ///// <param name="e"></param>
        //private void groupBox1_Paint(object sender, PaintEventArgs e)
        //{
        //    e.Graphics.Clear(groupBox1.BackColor);
        //    e.Graphics.DrawString(groupBox1.Text, groupBox1.Font, Brushes.Orange, 10, 1);
        //    e.Graphics.DrawLine(Pens.Orange, 1, 7, 8, 7);
        //    e.Graphics.DrawLine(Pens.Orange, e.Graphics.MeasureString(groupBox1.Text, groupBox1.Font).Width + 8, 7, groupBox1.Width - 2, 7);
        //    e.Graphics.DrawLine(Pens.Orange, 1, 7, 1, groupBox1.Height - 2);
        //    e.Graphics.DrawLine(Pens.Orange, 1, groupBox1.Height - 2, groupBox1.Width - 2, groupBox1.Height - 2);
        //    e.Graphics.DrawLine(Pens.Orange, groupBox1.Width - 2, 7, groupBox1.Width - 2, groupBox1.Height - 2); 
        //}
        ///// <summary>
        ///// 2.设置数据发送时间间隔分组框颜色重新绘制
        ///// </summary>
        ///// <param name="sender"></param>
        ///// <param name="e"></param>
        //private void groupBox2_Paint(object sender, PaintEventArgs e)
        //{
        //    e.Graphics.Clear(groupBox2.BackColor);
        //    e.Graphics.DrawString(groupBox2.Text, groupBox2.Font, Brushes.Orange, 10, 1);
        //    e.Graphics.DrawLine(Pens.Orange, 1, 7, 8, 7);
        //    e.Graphics.DrawLine(Pens.Orange, e.Graphics.MeasureString(groupBox2.Text, groupBox2.Font).Width + 8, 7, groupBox2.Width - 2, 7);
        //    e.Graphics.DrawLine(Pens.Orange, 1, 7, 1, groupBox2.Height - 2);
        //    e.Graphics.DrawLine(Pens.Orange, 1, groupBox2.Height - 2, groupBox2.Width - 2, groupBox2.Height - 2);
        //    e.Graphics.DrawLine(Pens.Orange, groupBox2.Width - 2, 7, groupBox2.Width - 2, groupBox2.Height - 2);
        //}
        ///// <summary>
        ///// 3.主接驳盒报警阈值分组框重新绘制
        ///// </summary>
        ///// <param name="sender"></param>
        ///// <param name="e"></param>
        //private void groupBox3_Paint(object sender, PaintEventArgs e)
        //{
        //    e.Graphics.Clear(groupBox3.BackColor);
        //    e.Graphics.DrawString(groupBox3.Text, groupBox3.Font, Brushes.Orange, 10, 1);
        //    e.Graphics.DrawLine(Pens.Orange, 1, 7, 8, 7);
        //    e.Graphics.DrawLine(Pens.Orange, e.Graphics.MeasureString(groupBox3.Text, groupBox3.Font).Width + 8, 7, groupBox3.Width - 2, 7);
        //    e.Graphics.DrawLine(Pens.Orange, 1, 7, 1, groupBox3.Height - 2);
        //    e.Graphics.DrawLine(Pens.Orange, 1, groupBox3.Height - 2, groupBox3.Width - 2, groupBox3.Height - 2);
        //    e.Graphics.DrawLine(Pens.Orange, groupBox3.Width - 2, 7, groupBox3.Width - 2, groupBox3.Height - 2);
        //}

        //private void groupBox4_Paint(object sender, PaintEventArgs e)
        //{
        //    e.Graphics.Clear(groupBox4.BackColor);
        //    e.Graphics.DrawString(groupBox4.Text, groupBox4.Font, Brushes.Orange, 10, 1);
        //    e.Graphics.DrawLine(Pens.Orange, 1, 7, 8, 7);
        //    e.Graphics.DrawLine(Pens.Orange, e.Graphics.MeasureString(groupBox4.Text, groupBox4.Font).Width + 8, 7, groupBox4.Width - 2, 7);
        //    e.Graphics.DrawLine(Pens.Orange, 1, 7, 1, groupBox4.Height - 2);
        //    e.Graphics.DrawLine(Pens.Orange, 1, groupBox4.Height - 2, groupBox4.Width - 2, groupBox4.Height - 2);
        //    e.Graphics.DrawLine(Pens.Orange, groupBox4.Width - 2, 7, groupBox4.Width - 2, groupBox4.Height - 2);
        //}

        //private void groupBox5_Paint(object sender, PaintEventArgs e)
        //{
        //    e.Graphics.Clear(groupBox5.BackColor);
        //    e.Graphics.DrawString(groupBox5.Text, groupBox5.Font, Brushes.Orange, 10, 1);
        //    e.Graphics.DrawLine(Pens.Orange, 1, 7, 8, 7);
        //    e.Graphics.DrawLine(Pens.Orange, e.Graphics.MeasureString(groupBox5.Text, groupBox5.Font).Width + 8, 7, groupBox5.Width - 2, 7);
        //    e.Graphics.DrawLine(Pens.Orange, 1, 7, 1, groupBox5.Height - 2);
        //    e.Graphics.DrawLine(Pens.Orange, 1, groupBox5.Height - 2, groupBox5.Width - 2, groupBox5.Height - 2);
        //    e.Graphics.DrawLine(Pens.Orange, groupBox5.Width - 2, 7, groupBox5.Width - 2, groupBox5.Height - 2);
        //}

        //private void groupBox9_Paint(object sender, PaintEventArgs e)
        //{
        //    e.Graphics.Clear(groupBox9.BackColor);
        //    e.Graphics.DrawString(groupBox9.Text, groupBox9.Font, Brushes.Orange, 10, 1);
        //    e.Graphics.DrawLine(Pens.Orange, 1, 7, 8, 7);
        //    e.Graphics.DrawLine(Pens.Orange, e.Graphics.MeasureString(groupBox9.Text, groupBox9.Font).Width + 8, 7, groupBox9.Width - 2, 7);
        //    e.Graphics.DrawLine(Pens.Orange, 1, 7, 1, groupBox9.Height - 2);
        //    e.Graphics.DrawLine(Pens.Orange, 1, groupBox9.Height - 2, groupBox9.Width - 2, groupBox9.Height - 2);
        //    e.Graphics.DrawLine(Pens.Orange, groupBox9.Width - 2, 7, groupBox9.Width - 2, groupBox9.Height - 2);
        //}

        //private void groupBox12_Paint(object sender, PaintEventArgs e)
        //{
        //    e.Graphics.Clear(groupBox12.BackColor);
        //    e.Graphics.DrawString(groupBox12.Text, groupBox12.Font, Brushes.Orange, 10, 1);
        //    e.Graphics.DrawLine(Pens.Orange, 1, 7, 8, 7);
        //    e.Graphics.DrawLine(Pens.Orange, e.Graphics.MeasureString(groupBox12.Text, groupBox12.Font).Width + 8, 7, groupBox12.Width - 2, 7);
        //    e.Graphics.DrawLine(Pens.Orange, 1, 7, 1, groupBox12.Height - 2);
        //    e.Graphics.DrawLine(Pens.Orange, 1, groupBox12.Height - 2, groupBox12.Width - 2, groupBox12.Height - 2);
        //    e.Graphics.DrawLine(Pens.Orange, groupBox12.Width - 2, 7, groupBox12.Width - 2, groupBox12.Height - 2);
        //}

        //private void groupBox10_Paint(object sender, PaintEventArgs e)
        //{
        //    e.Graphics.Clear(groupBox10.BackColor);
        //    e.Graphics.DrawString(groupBox10.Text, groupBox10.Font, Brushes.Orange, 10, 1);
        //    e.Graphics.DrawLine(Pens.Orange, 1, 7, 8, 7);
        //    e.Graphics.DrawLine(Pens.Orange, e.Graphics.MeasureString(groupBox10.Text, groupBox10.Font).Width + 8, 7, groupBox10.Width - 2, 7);
        //    e.Graphics.DrawLine(Pens.Orange, 1, 7, 1, groupBox10.Height - 2);
        //    e.Graphics.DrawLine(Pens.Orange, 1, groupBox10.Height - 2, groupBox10.Width - 2, groupBox10.Height - 2);
        //    e.Graphics.DrawLine(Pens.Orange, groupBox10.Width - 2, 7, groupBox10.Width - 2, groupBox10.Height - 2);
        //}

        //private void groupBox7_Paint(object sender, PaintEventArgs e)
        //{
        //    e.Graphics.Clear(groupBox7.BackColor);
        //    e.Graphics.DrawString(groupBox7.Text, groupBox7.Font, Brushes.Orange, 10, 1);
        //    e.Graphics.DrawLine(Pens.Orange, 1, 7, 8, 7);
        //    e.Graphics.DrawLine(Pens.Orange, e.Graphics.MeasureString(groupBox7.Text, groupBox7.Font).Width + 8, 7, groupBox7.Width - 2, 7);
        //    e.Graphics.DrawLine(Pens.Orange, 1, 7, 1, groupBox7.Height - 2);
        //    e.Graphics.DrawLine(Pens.Orange, 1, groupBox7.Height - 2, groupBox7.Width - 2, groupBox7.Height - 2);
        //    e.Graphics.DrawLine(Pens.Orange, groupBox7.Width - 2, 7, groupBox7.Width - 2, groupBox7.Height - 2);
        //}

        //private void groupBox8_Paint(object sender, PaintEventArgs e)
        //{
        //    e.Graphics.Clear(groupBox8.BackColor);
        //    e.Graphics.DrawString(groupBox8.Text, groupBox8.Font, Brushes.Orange, 10, 1);
        //    e.Graphics.DrawLine(Pens.Orange, 1, 7, 8, 7);
        //    e.Graphics.DrawLine(Pens.Orange, e.Graphics.MeasureString(groupBox8.Text, groupBox8.Font).Width + 8, 7, groupBox8.Width - 2, 7);
        //    e.Graphics.DrawLine(Pens.Orange, 1, 7, 1, groupBox8.Height - 2);
        //    e.Graphics.DrawLine(Pens.Orange, 1, groupBox8.Height - 2, groupBox8.Width - 2, groupBox8.Height - 2);
        //    e.Graphics.DrawLine(Pens.Orange, groupBox8.Width - 2, 7, groupBox8.Width - 2, groupBox8.Height - 2);
        //}

        //private void groupBox13_Paint(object sender, PaintEventArgs e)
        //{
        //    e.Graphics.Clear(groupBox13.BackColor);
        //    e.Graphics.DrawString(groupBox13.Text, groupBox13.Font, Brushes.Orange, 10, 1);
        //    e.Graphics.DrawLine(Pens.Orange, 1, 7, 8, 7);
        //    e.Graphics.DrawLine(Pens.Orange, e.Graphics.MeasureString(groupBox13.Text, groupBox13.Font).Width + 8, 7, groupBox13.Width - 2, 7);
        //    e.Graphics.DrawLine(Pens.Orange, 1, 7, 1, groupBox13.Height - 2);
        //    e.Graphics.DrawLine(Pens.Orange, 1, groupBox13.Height - 2, groupBox13.Width - 2, groupBox13.Height - 2);
        //    e.Graphics.DrawLine(Pens.Orange, groupBox13.Width - 2, 7, groupBox13.Width - 2, groupBox13.Height - 2);
        //}

        //private void groupBox11_Paint(object sender, PaintEventArgs e)
        //{
        //    e.Graphics.Clear(groupBox11.BackColor);
        //    e.Graphics.DrawString(groupBox11.Text, groupBox11.Font, Brushes.Orange, 10, 1);
        //    e.Graphics.DrawLine(Pens.Orange, 1, 7, 8, 7);
        //    e.Graphics.DrawLine(Pens.Orange, e.Graphics.MeasureString(groupBox11.Text, groupBox11.Font).Width + 8, 7, groupBox11.Width - 2, 7);
        //    e.Graphics.DrawLine(Pens.Orange, 1, 7, 1, groupBox11.Height - 2);
        //    e.Graphics.DrawLine(Pens.Orange, 1, groupBox11.Height - 2, groupBox11.Width - 2, groupBox11.Height - 2);
        //    e.Graphics.DrawLine(Pens.Orange, groupBox11.Width - 2, 7, groupBox11.Width - 2, groupBox11.Height - 2);
        //}







       




    }
}
