﻿/*
 * 时间：2017年10月25日16:35:45
 * 功能：主界面-数据列表界面对后台数据库操作的一系列封装，主要包括主接驳盒以及次接驳盒状态信息
 */
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Data;
using System.Windows.Forms;

namespace OSNSystem
{
    class dataList
    {
        /// <summary>
        /// 主接驳盒状态信息表格
        /// </summary>
        /// <returns></returns>
        public static DataTable SearchACabinStatusData(Main f)
        {
            string strsql = null;
            string beginTime = f.searchStartTime.Value.ToString();//查询起始时间
            string endTime = f.searchEndTime.Value.ToString();//查询终止时间

            if (f.searchStartTime.Value > f.searchEndTime.Value)
            {
                string tempTime = null;
                tempTime = beginTime;
                beginTime = endTime;
                endTime = tempTime;
            }

            try
            {
                DataTable dtSensor = null;
                strsql = "select statusType as '信息类型'";
                strsql += ",fvol as '前端电压/V',fcur as '前端电流/A',bVol1 as '后端1路电压/V',bCur1 as '后端1路电流/A',bVol2 as '后端2路电压/V',bCur2 as '后端2路电流/A' ,temp as '舱体温度/℃' ";
                strsql += ",date_format(saveDate,'%Y-%m-%d %H:%i:%s')  as '保存时间' from seafloor_jBHighStsData  where saveDate >= '" + beginTime + "' and saveDate <= '" + endTime + "' and isDelete = 0 ";
                strsql += "order by saveDate;";
                dtSensor = SqlHelper.ExecuteDataTable(strsql);
                return dtSensor.Copy();
            }
            catch (Exception exp)
            {
                // MessageBox.Show("查询采集数据出现异常！" + exp.Message);
                LogClass.WriteLogFile("查询主接驳盒状态数据数据出现异常！" + exp.Message);
                return null;
            }

        }

        /// <summary>
        /// 次接驳盒状态数据表格
        /// </summary>
        /// <returns></returns>
        public static DataTable SearchBCabinStatusData(Main f)
        {
            string strsql = null;

            string beginTime = f.searchStartTime.Value.ToString();//查询起始时间
            string endTime = f.searchEndTime.Value.ToString();//查询终止时间

            if (f.searchStartTime.Value > f.searchEndTime.Value)
            {
                string tempTime = null;
                tempTime = beginTime;
                beginTime = endTime;
                endTime = tempTime;
            }

            try
            {
                DataTable dtFault = null;
                strsql = "select statusType as '信息类型'";
                strsql += ",ch1Vol as '通道1电压/V',ch1Cur as '通道1电流/A',ch2Vol as '通道2电压',ch2Cur as '通道2电流',temp as '舱体温度/℃' ";
                strsql += ",date_format(saveDate,'%Y-%m-%d %H:%i:%s')  as '保存时间' from seafloor_jBLowStsData  where saveDate >= '" + beginTime + "' and saveDate <= '" + endTime + "'  and isDelete = 0 ";
                strsql += "order by saveDate;";
                dtFault = SqlHelper.ExecuteDataTable(strsql);
                return dtFault.Copy();
            }
            catch (Exception exp)
            {
                // MessageBox.Show("查询故障数据出现异常！" + exp.Message);
                LogClass.WriteLogFile("查询次接驳盒状态数据出现异常！" + exp.Message);
                return null;
            }
        }
        /// <summary>
        /// 查询数据采集器采集值数据
        /// </summary>
        /// <param name="f"></param>
        /// <param name="serial"></param>数据采集器序列号
        /// <returns></returns>
        public static DataTable SearchDOSensorData(Main f,int serial)
        {
            string strsql = null;

            string beginTime = f.searchStartTime.Value.ToString();//查询起始时间
            string endTime = f.searchEndTime.Value.ToString();//查询终止时间

            if (f.searchStartTime.Value > f.searchEndTime.Value)
            {
                string tempTime = null;
                tempTime = beginTime;
                beginTime = endTime;
                endTime = tempTime;
            }

            try
            {
                DataTable dtFault = null;
                strsql = "select platname as '平台名称'";
                strsql += ",collectdata as '采集值'";
                strsql += ",date_format(collectdate,'%Y-%m-%d %H:%i:%s')  as '采集时间', date_format(savedate,'%Y-%m-%d %H:%i:%s') as '保存时间' from sensordata  where collectdate >= '" + beginTime + "' and collectdate <= '" + endTime + "' and serial = '"+serial+"'";
                strsql += "order by collectdate ;";
                dtFault = SqlHelper.ExecuteDataTable(strsql);
                return dtFault.Copy();
            }
            catch (Exception exp)
            {
                // MessageBox.Show("查询故障数据出现异常！" + exp.Message);
                LogClass.WriteLogFile("查询溶解氧传感器数据出现异常！" + exp.Message);
                return null;
            }
        }

        /// <summary>
        /// 查询主接驳盒故障数据
        /// </summary>
        /// <param name="f"></param>
        /// <returns></returns>
        public static DataTable SearchACabinFaultData(Main f)
        {
            string strsql = null;
            string beginTime = f.searchStartTime.Value.ToString();//查询起始时间
            string endTime = f.searchEndTime.Value.ToString();//查询终止时间

            if (f.searchStartTime.Value > f.searchEndTime.Value)
            {
                string tempTime = null;
                tempTime = beginTime;
                beginTime = endTime;
                endTime = tempTime;
            }

            try
            {
                DataTable dtSensor = null;
                strsql = "select faultType as '故障类型'";
                strsql += ",faultData as '报警数据'";
                strsql += ",date_format(saveDate,'%Y-%m-%d %H:%i:%s') as '保存时间' from seafloor_jBFaultData  where saveDate >= '" + beginTime + "' and saveDate <= '" + endTime + "' and  faultType like '主接驳盒%' and isDelete = 0 ";
                strsql += "order by saveDate;";
                dtSensor = SqlHelper.ExecuteDataTable(strsql);
                return dtSensor.Copy();
            }
            catch (Exception exp)
            {
                // MessageBox.Show("查询采集数据出现异常！" + exp.Message);
                LogClass.WriteLogFile("查询主接驳盒故障数据数据出现异常！" + exp.Message);
                return null;
            }
        }
        /// <summary>
        /// 查询次接驳盒数据
        /// </summary>
        /// <param name="f"></param>
        /// <returns></returns>
        public static DataTable SearchBCabinFaultData(Main f)
        {
            string strsql = null;
            string beginTime = f.searchStartTime.Value.ToString();//查询起始时间
            string endTime = f.searchEndTime.Value.ToString();//查询终止时间

            if (f.searchStartTime.Value > f.searchEndTime.Value)
            {
                string tempTime = null;
                tempTime = beginTime;
                beginTime = endTime;
                endTime = tempTime;
            }

            try
            {
                DataTable dtSensor = null;
                strsql = "select faultType as '故障类型'";
                strsql += ",faultData as '报警数据'";
                strsql += ", date_format(saveDate,'%Y-%m-%d %H:%i:%s') as '保存时间' from seafloor_jBFaultData where saveDate >= '" + beginTime + "' and saveDate <= '" + endTime + "' and faultType like '次接驳盒%' and isDelete = 0 ";
                strsql += "order by saveDate;";
                dtSensor = SqlHelper.ExecuteDataTable(strsql);
                return dtSensor.Copy();
            }
            catch (Exception exp)
            {
                // MessageBox.Show("查询采集数据出现异常！" + exp.Message);
                LogClass.WriteLogFile("查询次接驳盒故障数据数据出现异常！" + exp.Message);
                return null;
            }
        }

        /// <summary>
        /// 查询数据采集器故障数据
        /// </summary>
        /// <param name="f"></param>
        /// <param name="serial"></param>数据采集器序列号
        /// <returns></returns>
        public static DataTable SearchCollectFaultData(Main f,int serial)
        {
            string strsql = null;
            string beginTime = f.searchStartTime.Value.ToString();//查询起始时间
            string endTime = f.searchEndTime.Value.ToString();//查询终止时间

            if (f.searchStartTime.Value > f.searchEndTime.Value)
            {
                string tempTime = null;
                tempTime = beginTime;
                beginTime = endTime;
                endTime = tempTime;
            }

            try
            {
                DataTable dtSensor = null;
                strsql = "select srcInfoName as '故障类型'";
                strsql += ",faultData as '报警数据'";
                strsql += ",date_format(collectDate,'%Y-%m-%d %H:%i:%s')  as '采集时间', date_format(saveDate,'%Y-%m-%d %H:%i:%s') as '保存时间' from seafloor_srcFaultData  where saveDate >= '" + beginTime + "' and saveDate <= '" + endTime + "' and isDelete = 0 ";
                strsql += "order by saveDate;";
                dtSensor = SqlHelper.ExecuteDataTable(strsql);
                return dtSensor.Copy();
            }
            catch (Exception exp)
            {                
                LogClass.WriteLogFile("查询数据采集器故障数据数据出现异常！" + exp.Message);
                return null;
            }
        }
        /// <summary>
        /// 查询数据采集器舱内温度数据
        /// </summary>
        /// <param name="f"></param>
        /// <param name="serial"></param>数据采集器所在序列号
        /// <returns></returns>
        public static DataTable SearchCollectStatusData(Main f,int serial)
        {
            string strsql = null;
            string beginTime = f.searchStartTime.Value.ToString();//查询起始时间
            string endTime = f.searchEndTime.Value.ToString();//查询终止时间

            if (f.searchStartTime.Value > f.searchEndTime.Value)
            {
                string tempTime = null;
                tempTime = beginTime;
                beginTime = endTime;
                endTime = tempTime;
            }

            try
            {
                DataTable dtSensor = null;
                strsql = "select statusType as '信息类型'";
                strsql += ",temp as '温度值/℃'";
                strsql += ",date_format(collectDate,'%Y-%m-%d %H:%i:%s')  as '采集时间', date_format(saveDate,'%Y-%m-%d %H:%i:%s') as '保存时间' from seafloor_srcTempData  where saveDate >= '" + beginTime + "' and saveDate <= '" + endTime + "' and isDelete = 0 ";
                strsql += "order by saveDate;";
                dtSensor = SqlHelper.ExecuteDataTable(strsql);
                return dtSensor.Copy();
            }
            catch (Exception exp)
            {
                LogClass.WriteLogFile("查询数据采集器舱内状态数据出现异常！" + exp.Message);
                return null;
            }
        }
        /// <summary>
        /// 查询数据采集器各个通道电参数信息
        /// </summary>
        /// <param name="f"></param>
        /// <param name="serial"></param>数据采集器所在序列号
        /// <returns></returns>
        public static DataTable SearchCollectElectricalData(Main f,int serial)
        {
            string strsql = null;
            string beginTime = f.searchStartTime.Value.ToString();//查询起始时间
            string endTime = f.searchEndTime.Value.ToString();//查询终止时间

            if (f.searchStartTime.Value > f.searchEndTime.Value)
            {
                string tempTime = null;
                tempTime = beginTime;
                beginTime = endTime;
                endTime = tempTime;
            }

            try
            {
                DataTable dtSensor = null;
                strsql = "select statusType as '电参数类型'";
                strsql += ",current as '电流值/A', voltage as '电压值/V', power as '功率值/W'";
                strsql += ",date_format(collectDate,'%Y-%m-%d %H:%i:%s')  as '采集时间', date_format(saveDate,'%Y-%m-%d %H:%i:%s') as '保存时间' from seafloor_srcElecData  where saveDate >= '" + beginTime + "' and saveDate <= '" + endTime + "' and isDelete = 0 ";
                strsql += "order by saveDate;";
                dtSensor = SqlHelper.ExecuteDataTable(strsql);
                return dtSensor.Copy();
            }
            catch (Exception exp)
            {
                LogClass.WriteLogFile("查询数据采集器各个通道电参数数据出现异常！" + exp.Message);
                return null;
            }
        }

        /// <summary>
        /// 数据列表页----查询溶解氧传感器数据
        /// </summary>
        /// <returns></returns>
        public static DataTable SearchCollectDOData(Main f)
        {
            string strsql = null;
            string beginTime = f.searchStartTime.Value.ToString();//查询起始时间
            string endTime = f.searchEndTime.Value.ToString();//查询终止时间

            if (f.searchStartTime.Value > f.searchEndTime.Value)
            {
                string tempTime = null;
                tempTime = beginTime;
                beginTime = endTime;
                endTime = tempTime;
            }

            try
            {
                DataTable dtSensor = null;
                strsql = "select sensorType as '传感器类型'";
                strsql += ",collectData as '采集值(mg/L)'";
                strsql += ",date_format(collectDate,'%Y-%m-%d %H:%i:%s')  as '采集时间', date_format(saveDate,'%Y-%m-%d %H:%i:%s') as '保存时间' from seafloor_srcsensordata  where saveDate >= '" + beginTime + "' and saveDate <= '" + endTime + "' and  isDelete = 0 and deviceID = '0001'";
                strsql += "order by saveDate;";
                dtSensor = SqlHelper.ExecuteDataTable(strsql);
                return dtSensor.Copy();
            }
            catch (Exception exp)
            {
                LogClass.WriteLogFile("查询溶解氧传感器数据出现异常！" + exp.Message);
                return null;
            }
        }


        /// <summary>
        /// 数据列表页---查询PH数据
        /// </summary>
        /// <param name="f"></param>
        /// <returns></returns>
        public static DataTable SearchCollectPHData(Main f)
        {
            string strsql = null;
            string beginTime = f.searchStartTime.Value.ToString();//查询起始时间
            string endTime = f.searchEndTime.Value.ToString();//查询终止时间

            if (f.searchStartTime.Value > f.searchEndTime.Value)
            {
                string tempTime = null;
                tempTime = beginTime;
                beginTime = endTime;
                endTime = tempTime;
            }

            try
            {
                DataTable dtSensor = null;
                strsql = "select sensorType as '传感器类型'";
                strsql += ",collectData as '采集值'";
                strsql += ",date_format(collectDate,'%Y-%m-%d %H:%i:%s')  as '采集时间', date_format(saveDate,'%Y-%m-%d %H:%i:%s') as '保存时间' from seafloor_srcsensordata  where saveDate >= '" + beginTime + "' and saveDate <= '" + endTime + "' and  isDelete = 0 and deviceID = '0002'";
                strsql += "order by saveDate;";
                dtSensor = SqlHelper.ExecuteDataTable(strsql);
                return dtSensor.Copy();
            }
            catch (Exception exp)
            {
                LogClass.WriteLogFile("查询PH传感器数据出现异常！" + exp.Message);
                return null;
            }
        }


        /// <summary>
        /// 数据列表---查询叶绿素浊度传感器数据
        /// </summary>
        /// <param name="f"></param>
        /// <returns></returns>
        public static DataTable SearchCollectChlTurData(Main f)
        {
            string strsql = null;
            string beginTime = f.searchStartTime.Value.ToString();//查询起始时间
            string endTime = f.searchEndTime.Value.ToString();//查询终止时间

            if (f.searchStartTime.Value > f.searchEndTime.Value)
            {
                string tempTime = null;
                tempTime = beginTime;
                beginTime = endTime;
                endTime = tempTime;
            }

            try
            {
                DataTable dtSensor = null;
                strsql = "select sensorType as '传感器类型'";
                strsql += ",collectData as '叶绿素(μg/L)', collectData1 as '浊度(μg/L)', collectData2 as '温度(℃)'";
                strsql += ",date_format(collectDate,'%Y-%m-%d %H:%i:%s')  as '采集时间', date_format(saveDate,'%Y-%m-%d %H:%i:%s') as '保存时间' from seafloor_srcsensordata  where saveDate >= '" + beginTime + "' and saveDate <= '" + endTime + "' and  isDelete = 0 and deviceID = '0003'";
                strsql += "order by saveDate;";
                dtSensor = SqlHelper.ExecuteDataTable(strsql);
                return dtSensor.Copy();
            }
            catch (Exception exp)
            {
                LogClass.WriteLogFile("查询叶绿素浊度传感器数据出现异常！" + exp.Message);
                return null;
            }
        }

        /// <summary>
        /// 数据列表-查询CTD传感器数据
        /// </summary>
        /// <param name="f"></param>
        /// <returns></returns>
        public static DataTable SearchCollectCTDData(Main f)
        {
            string strsql = null;
            string beginTime = f.searchStartTime.Value.ToString();//查询起始时间
            string endTime = f.searchEndTime.Value.ToString();//查询终止时间

            if (f.searchStartTime.Value > f.searchEndTime.Value)
            {
                string tempTime = null;
                tempTime = beginTime;
                beginTime = endTime;
                endTime = tempTime;
            }

            try
            {
                DataTable dtSensor = null;
                strsql = "select sensorType as '传感器类型'";
                strsql += ",collectData as '电导率(mS/cm)', collectData1 as '温度(℃)', collectData2 as '深度(m)', collectData3 as '盐度'";
                strsql += ",date_format(collectDate,'%Y-%m-%d %H:%i:%s')  as '采集时间', date_format(saveDate,'%Y-%m-%d %H:%i:%s') as '保存时间' from seafloor_srcsensordata  where saveDate >= '" + beginTime + "' and saveDate <= '" + endTime + "' and  isDelete = 0 and deviceID = '0004'";
                strsql += "order by saveDate;";
                dtSensor = SqlHelper.ExecuteDataTable(strsql);
                return dtSensor.Copy();
            }
            catch (Exception exp)
            {
                LogClass.WriteLogFile("查询CTD传感器数据出现异常！" + exp.Message);
                return null;
            }
        }

        /// <summary>
        /// 在数据列表页---列表显示数据
        /// </summary>
        /// <param name="dt"></param>
        public static void listData(DataTable dt, Main f)
        {
            f.dgwData.Columns.Clear();
            f.dgwData.DataSource = dt;

            f.dgwData.ColumnHeadersDefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleCenter;
            f.dgwData.ReadOnly = true;
            f.dgwData.AllowUserToAddRows = false;
            f.dgwData.AllowUserToDeleteRows = false;
        }

        
    }
}
