﻿/*
 * 时间：2017年10月24日09:19:08
 * 功能：界面初始化加载时，将数据库中的故障值表格加载在首页datagridview控件中
 */
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Data;
using System.Windows.Forms;

namespace OSNSystem
{
    class platformStatus
    {
        /// <summary>
        /// 1.1实时A舱故障值显示，查询后台数据库存入datatable表格中
        /// </summary>
        /// <returns></returns>
        public static DataTable searchAFaultData()
        {
            string strsql = null;
            try
            {
                DataTable dtAFaultData = null;
               
                //1.A舱通道1电压问题显示
                strsql = "(select faultname as '故障名称',";
                strsql += "faultdata as '报警数据',";
                strsql += "date_format(collectdate,'%Y-%m-%d %H:%i:%s')  as '采集时间'from faultdata where faulthead = '$ErrA+1+1' or faulthead = '$ErrA+1+2' order by id desc limit 0,1)";

                //2.A舱通道1电流问题显示
                strsql += "union (select faultname as '故障名称',";
                strsql += "faultdata as '报警数据',";
                strsql += "date_format(collectdate,'%Y-%m-%d %H:%i:%s')  as '采集时间'from faultdata where faulthead = '$ErrA+1+3' or faulthead = '$ErrA+1+4' order by id desc limit 0,1)";

                //3.A舱通道2电压问题显示
                strsql += "union (select faultname as '故障名称',";
                strsql += "faultdata as '采集值',";
                strsql += "date_format(collectdate,'%Y-%m-%d %H:%i:%s')  as '采集时间'from faultdata where faulthead = '$ErrA+2+1' or faulthead = '$ErrA+2+2' order by id desc limit 0,1)";

                //4.A舱通道2电流问题显示
                strsql += "union (select faultname as '故障名称',";
                strsql += "faultdata as '采集值',";
                strsql += "date_format(collectdate,'%Y-%m-%d %H:%i:%s')  as '采集时间'from faultdata where faulthead = '$ErrA+2+3' or faulthead = '$ErrA+2+4' order by id desc limit 0,1)";

                //5.A舱温度问题显示
                strsql += "union (select faultname as '故障名称',";
                strsql += "faultdata as '采集值',";
                strsql += "date_format(collectdate,'%Y-%m-%d %H:%i:%s')  as '采集时间'from faultdata where faulthead = '$ErrA+0+5' or faulthead = '$ErrA+0+6' order by id desc limit 0,1)";
                dtAFaultData = SqlHelper.ExecuteDataTable(strsql);
                
                return dtAFaultData.Copy();
            }
            catch (Exception exp)
            {
                //MessageBox.Show("查询采集数据出现异常！" + exp.Message);
                LogClass.WriteLogFile("查询A舱故障值数据出现异常！" + exp.Message);
                return null;
            }
        }

        ///// <summary>
        ///// 1.2在平台状态信息页--列表实时显示A舱故障值表格
        ///// </summary>
        ///// <param name="dt"></param>
        //public static void listACabinFaultData(DataTable dt, Main f)
        //{
        //    try
        //    {
        //        f.dataGridView1.Columns.Clear();
        //        f.dataGridView1.DataSource = dt;//将数据表格绑定到控件中去
        //        f.dataGridView1.ColumnHeadersDefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleCenter;
        //        f.dataGridView1.ReadOnly = true;
        //        f.dataGridView1.AllowUserToAddRows = false;
        //        f.dataGridView1.AllowUserToDeleteRows = false;
        //        f.dataGridView1.Columns[1].Width = 150;

        //        //Application.DoEvents();

        //        while (f.dataGridView1.Rows.Count < 5)
        //            ((DataTable)f.dataGridView1.DataSource).Rows.Add();

        //        for (int i = 0; i < f.dataGridView1.Columns.Count; i++)
        //        {
        //            f.dataGridView1.Columns[i].SortMode = DataGridViewColumnSortMode.NotSortable;
        //        }

        //    }
        //    catch (Exception exp)
        //    {
        //        LogClass.WriteLogFile("首页A舱故障值显示异常！" + exp.Message);
        //    }

        //}

        /// <summary>
        /// 2.1实时A舱故障值显示，查询后台数据库存入datatable表格中
        /// </summary>
        /// <returns></returns>
        public static DataTable searchBFaultData()
        {
            string strsql = null;
            try
            {
                DataTable dtBFaultData = null;

                //1.主接驳盒前端电流故障
                strsql = "(select faultType as '故障名称',";
                strsql += "faultData as '报警数据',";
                strsql += "date_format(saveDate,'%Y-%m-%d %H:%i:%s')  as '故障时间'from seafloor_jBFaultData where faultType = '主接驳盒前端短路故障' or faultType = '主接驳盒前端过流故障' and isDelete = 0 order by Id desc limit 0,1)";

                //2.主接驳盒前端电压故障
                strsql += "union (select faultType as '故障名称',";
                strsql += "faultData as '报警数据',";
                strsql += "date_format(saveDate,'%Y-%m-%d %H:%i:%s')  as '故障时间'from seafloor_jBFaultData where faultType = '主接驳盒前端欠压故障' or faultType = '主接驳盒前端过压故障' and isDelete = 0 order by Id desc limit 0,1)";

                //3.主接驳盒后端1路电流故障
                strsql += "union (select faultType as '故障名称',";
                strsql += "faultData as '报警数据',";
                strsql += "date_format(saveDate,'%Y-%m-%d %H:%i:%s')  as '故障时间'from seafloor_jBFaultData where faultType = '主接驳盒后端1路短路故障' or faultType = '主接驳盒后端1路过流故障' and isDelete =0 order by Id desc limit 0,1)";

                //4.主接驳盒后端1路电压故障
                strsql += "union (select faultType as '故障名称',";
                strsql += "faultData as '报警数据',";
                strsql += "date_format(saveDate,'%Y-%m-%d %H:%i:%s')  as '故障时间'from seafloor_jBFaultData where faultType = '主接驳盒后端1路欠压故障' or faultType = '主接驳盒后端1路过压故障' and isDelete = 0 order by Id desc limit 0,1)";

                //5.主接驳盒后端2路电流故障
                strsql += "union (select faultType as '故障名称',";
                strsql += "faultData as '报警数据',";
                strsql += "date_format(saveDate,'%Y-%m-%d %H:%i:%s')  as '故障时间'from seafloor_jBFaultData where faultType = '主接驳盒后端2路短路故障' or faultType = '主接驳盒后端2路过流故障' and isDelete = 0 order by Id desc limit 0,1)";

                //6.主接驳盒后端2路电压故障
                strsql += "union (select faultType as '故障名称',";
                strsql += "faultData as '报警数据',";
                strsql += "date_format(saveDate,'%Y-%m-%d %H:%i:%s')  as '故障时间'from seafloor_jBFaultData where faultType = '主接驳盒后端2路欠压故障' or faultType = '主接驳盒后端2路过压故障' and isDelete = 0 order by Id desc limit 0,1)";

                //7.主接驳盒舱内温度过高故障
                strsql += "union (select faultType as '故障名称',";
                strsql += "faultData as '报警数据',";
                strsql += "date_format(saveDate,'%Y-%m-%d %H:%i:%s')  as '故障时间'from seafloor_jBFaultData where faultType = '主接驳盒舱内温度过高故障' and isDelete = 0 order by Id desc limit 0,1)";

                //8.次接驳盒通道1电压故障
                strsql += "union (select faultType as '故障名称',";
                strsql += "faultData as '报警数据',";
                strsql += "date_format(saveDate,'%Y-%m-%d %H:%i:%s')  as '故障时间'from seafloor_jBFaultData where faultType = '次接驳盒通道1过压故障' or faultType = '次接驳盒通道1欠压故障' and isDelete = 0 order by Id desc limit 0,1)";

                //9.次接驳盒通道1电流故障
                strsql += "union (select faultType as '故障名称',";
                strsql += "faultData as '报警数据',";
                strsql += "date_format(saveDate,'%Y-%m-%d %H:%i:%s')  as '故障时间'from seafloor_jBFaultData where faultType = '次接驳盒通道1过流故障' or faultType = '次接驳盒通道1欠流故障' and isDelete = 0 order by Id desc limit 0,1)";

                //10.次接驳盒通道2电压故障
                strsql += "union (select faultType as '故障名称',";
                strsql += "faultData as '报警数据',";
                strsql += "date_format(saveDate,'%Y-%m-%d %H:%i:%s')  as '故障时间'from seafloor_jBFaultData where faultType = '次接驳盒通道2过压故障' or faultType = '次接驳盒通道2欠压故障' and isDelete = 0 order by Id desc limit 0,1)";


                //11.次接驳盒通道2电流故障
                strsql += "union (select faultType as '故障名称',";
                strsql += "faultData as '报警数据',";
                strsql += "date_format(saveDate,'%Y-%m-%d %H:%i:%s')  as '故障时间'from seafloor_jBFaultData where faultType = '次接驳盒通道2过流故障' or faultType = '次接驳盒通道2欠流故障' and isDelete = 0 order by Id desc limit 0,1)";


                //12.次接驳盒通道3电压故障
                strsql += "union (select faultType as '故障名称',";
                strsql += "faultData as '报警数据',";
                strsql += "date_format(saveDate,'%Y-%m-%d %H:%i:%s')  as '故障时间'from seafloor_jBFaultData where faultType = '次接驳盒通道3过压故障' or faultType = '次接驳盒通道3欠压故障' and isDelete = 0 order by Id desc limit 0,1)";


                //13.次接驳盒通道3电流故障
                strsql += "union (select faultType as '故障名称',";
                strsql += "faultData as '报警数据',";
                strsql += "date_format(saveDate,'%Y-%m-%d %H:%i:%s')  as '故障时间'from seafloor_jBFaultData where faultType = '次接驳盒通道3过流故障' or faultType = '次接驳盒通道3欠流故障' and isDelete = 0 order by Id desc limit 0,1)";


                //14.次接驳盒通道4电压故障
                strsql += "union (select faultType as '故障名称',";
                strsql += "faultData as '报警数据',";
                strsql += "date_format(saveDate,'%Y-%m-%d %H:%i:%s')  as '故障时间'from seafloor_jBFaultData where faultType = '次接驳盒通道4过压故障' or faultType = '次接驳盒接驳盒通道4欠压故障' and isDelete = 0 order by Id desc limit 0,1)";


                //15.次接驳盒通道4电流故障
                strsql += "union (select faultType as '故障名称',";
                strsql += "faultData as '报警数据',";
                strsql += "date_format(saveDate,'%Y-%m-%d %H:%i:%s')  as '故障时间'from seafloor_jBFaultData where faultType = '次接驳盒通道4过流故障' or faultType = '次接驳盒通道4欠流故障' and isDelete = 0 order by Id desc limit 0,1)";


                //16.次接驳盒通道5电压故障
                strsql += "union (select faultType as '故障名称',";
                strsql += "faultData as '报警数据',";
                strsql += "date_format(saveDate,'%Y-%m-%d %H:%i:%s')  as '故障时间'from seafloor_jBFaultData where faultType = '次接驳盒通道5过压故障' or faultType = '次接驳盒通道5欠压故障' and isDelete = 0 order by Id desc limit 0,1)";


                //17.次接驳盒通道5电流故障
                strsql += "union (select faultType as '故障名称',";
                strsql += "faultData as '报警数据',";
                strsql += "date_format(saveDate,'%Y-%m-%d %H:%i:%s')  as '故障时间'from seafloor_jBFaultData where faultType = '次接驳盒通道5过流故障' or faultType = '次接驳盒通道5欠流故障' and isDelete = 0 order by Id desc limit 0,1)";


                //18.次接驳盒温度故障
                strsql += "union (select faultType as '故障名称',";
                strsql += "faultData as '报警数据',";
                strsql += "date_format(saveDate,'%Y-%m-%d %H:%i:%s')  as '故障时间'from seafloor_jBFaultData where faultType = '次接驳盒舱内温度过高故障' or faultType = '次接驳盒舱内温度过低故障' and isDelete = 0 order by Id desc limit 0,1)";





                dtBFaultData = SqlHelper.ExecuteDataTable(strsql);
                return dtBFaultData.Copy();
            }
            catch (Exception exp)
            {
                // MessageBox.Show("查询采集数据出现异常！" + exp.Message);
                LogClass.WriteLogFile("查询B舱故障值数据出现异常！" + exp.Message);
                return null;
            }
        }
        /// <summary>
        ///   2.2在平台状态信息页--列表实时显示B舱故障值表格
        ///   这个相当于可以初始化datagridview初始化的时候可以初始化多少行空格
        /// </summary>
        /// <param name="dt"></param>
        public static void listBCabinFaultData(DataTable dt, Main f)
        {
            try
            {
                f.dataGridView2.Columns.Clear();
                f.dataGridView2.DataSource = dt;
                f.dataGridView2.ColumnHeadersDefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleCenter;
                f.dataGridView2.ReadOnly = true;
                f.dataGridView2.AllowUserToAddRows = false;
                f.dataGridView2.AllowUserToDeleteRows = false;
                f.dataGridView2.Columns[1].Width = 150;

                //Application.DoEvents();

                while (f.dataGridView2.Rows.Count < 18)
                    ((DataTable)f.dataGridView2.DataSource).Rows.Add();

                for (int i = 0; i < f.dataGridView2.Columns.Count; i++)
                {
                    f.dataGridView2.Columns[i].SortMode = DataGridViewColumnSortMode.NotSortable;
                }

            }
            catch (Exception exp)
            {
                LogClass.WriteLogFile("首页B舱故障值显示异常！" + exp.Message);
            }
        }
        /// <summary>
        ///  3.1实时故障值结果，查询得到相应的故障表格-在数据采集器平台页显示
        /// </summary>
        /// <returns></returns>
        public static DataTable searchRealTimeFault(int serial)
        {
            string strsql = null;
            try
            {
                DataTable dtRealTimeFault = null;
                //strsql = "select faultinfo as '故障名称' ,faultdata as '报警数据'";
                //strsql += ",date_format(collectdate,'%Y-%m-%d %H:%i:%s') as '采集时间', date_format(savedate,'%Y-%m-%d %H:%i:%s') as '保存时间' from faultinfo order by Id desc limit 0,1;";


                strsql = "(select srcInfoName as '故障名称' ,faultData as '报警数据'";
                strsql += ",date_format(collectDate,'%Y-%m-%d %H:%i:%s') as '故障时间'from seafloor_srcFaultData where (srcInfoName = '通道1过压故障' or srcInfoName = '通道1欠压故障' or srcInfoName = '通道1过流故障' or srcInfoName = '通道1欠流故障') and srcId = 0001 order by Id desc limit 0,1)";

                strsql += "union (select srcInfoName as '故障名称' ,faultData as '报警数据'";
                strsql += ",date_format(collectDate,'%Y-%m-%d %H:%i:%s') as '故障时间'from seafloor_srcFaultData where (srcInfoName = '通道2过压故障' or srcInfoName = '通道2欠压故障' or srcInfoName = '通道2过流故障' or srcInfoName = '通道2欠流故障') and srcId = 0001 order by Id desc limit 0,1)";

                strsql += "union (select srcInfoName as '故障名称' ,faultData as '报警数据'";
                strsql += ",date_format(collectDate,'%Y-%m-%d %H:%i:%s') as '故障时间'from seafloor_srcFaultData where (srcInfoName = '通道3过压故障' or srcInfoName = '通道3欠压故障' or srcInfoName = '通道3过流故障' or srcInfoName = '通道3欠流故障') and srcId = 0001 order by Id desc limit 0,1)";

                strsql += "union (select srcInfoName as '故障名称' ,faultData as '报警数据'";
                strsql += ",date_format(collectDate,'%Y-%m-%d %H:%i:%s') as '故障时间'from seafloor_srcFaultData where (srcInfoName = '通道4过压故障' or srcInfoName = '通道4欠压故障' or srcInfoName = '通道4过流故障' or srcInfoName = '通道4欠流故障') and srcId = 0001 order by Id desc limit 0,1)";

                strsql += "union (select srcInfoName as '故障名称' ,faultData as '报警数据'";
                strsql += ",date_format(collectDate,'%Y-%m-%d %H:%i:%s') as '故障时间'from seafloor_srcFaultData where (srcInfoName = '通道5过压故障' or srcInfoName = '通道5欠压故障' or srcInfoName = '通道5过流故障' or srcInfoName = '通道5欠流故障') and srcId = 0001 order by Id desc limit 0,1)";

                strsql += "union (select srcInfoName as '故障名称' ,faultData as '报警数据'";
                strsql += ",date_format(collectDate,'%Y-%m-%d %H:%i:%s') as '故障时间'from seafloor_srcFaultData where (srcInfoName = '温度过高故障' or srcInfoName = '温度过低故障') and srcId = 0001 order by Id desc limit 0,1)";

                

                dtRealTimeFault = SqlHelper.ExecuteDataTable(strsql);
                return dtRealTimeFault.Copy();
            }
            catch (Exception exp)
            {
                // MessageBox.Show("查询采集数据出现异常！" + exp.Message);
                LogClass.WriteLogFile("查询采集数据出现异常！" + exp.Message);
                return null;
            }
        }


        /// <summary>
        ///  3.2在平台状态信息页--列表实时显示故障值，将故障表格与界面中的控件绑定在一起
        /// </summary>
        /// <param name="dt"></param>
        public static void listRealTimeFault(DataTable dt, DataGridView dataGridView)
        {
            try
            {
                dataGridView.Columns.Clear();
                dataGridView.DataSource = dt;
                dataGridView.ColumnHeadersDefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleCenter;
                dataGridView.ReadOnly = true;
                dataGridView.AllowUserToAddRows = false;
                dataGridView.AllowUserToDeleteRows = false;
                //f.dataGridView4.Columns[1].Width = 150;

                //Application.DoEvents();
                while (dataGridView.Rows.Count < 6)//保证datagridview表格有6行
                    ((DataTable)dataGridView.DataSource).Rows.Add();

                for (int i = 0; i < dataGridView.Columns.Count; i++)
                {
                    dataGridView.Columns[i].SortMode = DataGridViewColumnSortMode.NotSortable;
                }
            }
            catch (Exception exp)
            {
                LogClass.WriteLogFile("数据采集器首页故障值表格异常" + exp.Message);
            }
        }
        /// <summary>
        /// 4.1实时采集值结果显示
        /// </summary>
        /// <returns></returns>
        public static DataTable searchRealTimeSensor(int serial)
        {
            string strsql = null;
            try
            {
                DataTable dtRealTimeSensor = null;
                
                //5个通道若同时发送数据，多个通道的数据可以同时显示
                strsql = "(select sensorType as '传感器名称',";
                strsql += "collectData as '采集值',";
                strsql += "date_format(collectDate,'%Y-%m-%d %H:%i:%s')  as '采集时间'from seafloor_srcSensorData where deviceId = 0004 and isDelete = 0 order by Id desc limit 0,1)";//CTD-电导率数据

                strsql += "union (select sensorType as '传感器名称',";
                strsql += "collectData1 as '采集值',";
                strsql += "date_format(collectDate,'%Y-%m-%d %H:%i:%s')  as '采集时间'from seafloor_srcSensorData where deviceId = 0004 and isDelete = 0 order by Id desc limit 0,1)";//CTD-温度数据

                strsql += "union (select sensorType as '传感器名称',";
                strsql += "collectData2 as '采集值',";
                strsql += "date_format(collectDate,'%Y-%m-%d %H:%i:%s')  as '采集时间'from seafloor_srcSensorData where deviceId = 0004 and isDelete = 0 order by Id desc limit 0,1)";//CTD-盐度数据

                strsql += "union (select sensorType as '传感器名称',";
                strsql += "collectData3 as '采集值',";
                strsql += "date_format(collectDate,'%Y-%m-%d %H:%i:%s')  as '采集时间'from seafloor_srcSensorData where deviceId = 0004 and isDelete = 0 order by Id desc limit 0,1)";//CTD-深度数据

                strsql += "union (select sensorType as '传感器名称',";
                strsql += "collectData as '采集值',";
                strsql += "date_format(collectDate,'%Y-%m-%d %H:%i:%s')  as '采集时间'from seafloor_srcSensorData where deviceId = 0002 and isDelete = 0 order by Id desc limit 0,1)";//PH数据

                strsql += "union (select sensorType as '传感器名称',";
                strsql += "collectData as '采集值',";
                strsql += "date_format(collectDate,'%Y-%m-%d %H:%i:%s')  as '采集时间'from seafloor_srcSensorData where deviceId = 0001 and isDelete = 0 order by Id desc limit 0,1)";//溶解氧数据


                strsql += "union (select sensorType as '传感器名称',";
                strsql += "collectData as '采集值',";
                strsql += "date_format(collectDate,'%Y-%m-%d %H:%i:%s')  as '采集时间'from seafloor_srcSensorData where deviceId = 0003 and isDelete = 0 order by Id desc limit 0,1)";//叶绿素浊度传感器-叶绿素数据

                strsql += "union (select sensorType as '传感器名称',";
                strsql += "collectData1 as '采集值',";
                strsql += "date_format(collectDate,'%Y-%m-%d %H:%i:%s')  as '采集时间'from seafloor_srcSensorData where deviceId = 0003 and isDelete = 0 order by Id desc limit 0,1)";//叶绿素浊度传感器-浊度数据


                strsql += "union (select sensorType as '传感器名称',";
                strsql += "collectData2 as '采集值',";
                strsql += "date_format(collectDate,'%Y-%m-%d %H:%i:%s')  as '采集时间'from seafloor_srcSensorData where deviceId = 0003 and isDelete = 0 order by Id desc limit 0,1)";//叶绿素浊度传感器-温度数据

                


                dtRealTimeSensor = SqlHelper.ExecuteDataTable(strsql);
                return dtRealTimeSensor.Copy();
            }
            catch (Exception exp)
            {
                //MessageBox.Show("查询采集数据出现异常！" + exp.Message);
                LogClass.WriteLogFile("查询采集数据出现异常！" + exp.Message);
                return null;
            }
        }

        /// <summary>
        /// 4.2在平台状态信息页--列表实时显示采集值,与相应的控件进行绑定
        /// </summary>
        /// <param name="dt"></param>
        public static void listRealTimeData(DataTable dt, DataGridView dataGridView)
        {
            try
            {
                dataGridView.Columns.Clear();
                dataGridView.DataSource = dt;//将数据表格绑定到控件中去
                dataGridView.ColumnHeadersDefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleCenter;
                dataGridView.ReadOnly = true;
                dataGridView.AllowUserToAddRows = false;
                dataGridView.AllowUserToDeleteRows = false;
               // f.dataGridView3.Columns[1].Width = 150;

                //Application.DoEvents();
                while (dataGridView.Rows.Count < 9)//保证datagridview表格有8行
                    ((DataTable)dataGridView.DataSource).Rows.Add();

                for (int i = 0; i < dataGridView.Columns.Count; i++)
                {
                    dataGridView.Columns[i].SortMode = DataGridViewColumnSortMode.NotSortable;
                }
            }
            catch (Exception exp)
            {
                LogClass.WriteLogFile("首页采集值表格异常" + exp.Message);
            }

        }


    }
}
