﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Net.Sockets;
using System.Net;
using System.Threading;
using System.Text.RegularExpressions;
using MySql.Data.MySqlClient;
using System.IO;
using Microsoft.Win32;
using System.Diagnostics;
using System.Security.Permissions;
using System.Runtime.InteropServices;
using System.IO.Ports;
using System.Xml.Linq;
namespace OSNSystem
{

    [PermissionSet(SecurityAction.Demand, Name = "FullTrust")]

    [System.Runtime.InteropServices.ComVisibleAttribute(true)] 


    public partial class Main : Form
    {

       // public static Dictionary<string, string> mydic;
        internal _2DrawClass drawExp = new _2DrawClass();//定义成internal访问级别
        internal _4DrawSensor drawSensorExp = new _4DrawSensor();

        private _1MySerClass exp;//侦听接驳盒控制舱的网络连接
        private _1MySerClass2 exp2;//侦听数据采集器1的网络连接
        private _1MySerClass3 exp3;

        private ECSSocket exp4;

        /*2020年9月16日09:50:41*嵌入已经写好的exe程序**/

        [DllImport("user32.dll")]
        private static extern int SetParent(IntPtr hWndChild, IntPtr hWndParent);

        [DllImport("user32.dll")]
        private static extern bool ShowWindowAsync(IntPtr hWnd, int nCmdShow);

        [DllImport("user32.dll", SetLastError = true)]
        private static extern bool PostMessage(IntPtr hWnd, uint Msg, int wParam, int lParam);

        [DllImport("user32.dll", EntryPoint = "SetWindowPos")]
        private static extern bool SetWindowPos(IntPtr hWnd, int hWndInsertAfter, int X, int Y, int cx, int cy, uint uFlags);

        [DllImport("user32.dll")]
        private static extern int SendMessage(IntPtr hWnd, uint Msg, int wParam, int lParam);

        [DllImport("user32.dll", SetLastError = true, CharSet = CharSet.Auto)]
        private static extern uint SetWindowLong(IntPtr hwnd, int nIndex, uint newLong);

        [DllImport("user32.dll", SetLastError = true, CharSet = CharSet.Auto)]
        private static extern uint GetWindowLong(IntPtr hwnd, int nIndex);

        [DllImport("user32.dll", CharSet = CharSet.Auto)]
        private static extern bool ShowWindow(IntPtr hWnd, short State);


        private Process p = new Process();

        private bool camera = false;//用于标记摄像头软件exe软件是否启动的标志

        private const int HWND_TOP = 0x0;
        private const int WM_COMMAND = 0x0112;
        private const int WM_QT_PAINT = 0xC2DC;
        private const int WM_PAINT = 0x000F;
        private const int WM_SIZE = 0x0005;
        private const int SWP_FRAMECHANGED = 0x0020;
        public enum ShowWindowStyles : short
        {
            SW_HIDE = 0,
            SW_SHOWNORMAL = 1,
            SW_NORMAL = 1,
            SW_SHOWMINIMIZED = 2,
            SW_SHOWMAXIMIZED = 3,
            SW_MAXIMIZE = 3,
            SW_SHOWNOACTIVATE = 4,
            SW_SHOW = 5,
            SW_MINIMIZE = 6,
            SW_SHOWMINNOACTIVE = 7,
            SW_SHOWNA = 8,
            SW_RESTORE = 9,
            SW_SHOWDEFAULT = 10,
            SW_FORCEMINIMIZE = 11,
            SW_MAX = 11
        }

        /*****************************/

       
        public Main()
        {

           

            InitializeComponent();
            SqlHelper.initCon();

            exp = new _1MySerClass(this);
            exp.StartListener();//监听对次级接驳盒的连接

            exp2 = new _1MySerClass2(this);
            exp2.StartListener();//监听数据采集器1的socket网络连接

            exp3 = new _1MySerClass3(this);
            exp3.StartListener();//监听对主接驳盒的连接
            //窗口一启动就默认最大化--2020年10月27日13:48:24
            this.WindowState = FormWindowState.Maximized;
            expDO = new _4MyClientClass2();
            expChlTur = new _4MyClientClass2();
            expClean = new _4MyClientClass2();


            //2021年9月24日14:32:56  建立与云服务器进行指令交互的长连接代码
            //1.抛出线程，与云服务器建立socket长连接，本机是作为客户端来实现
            exp4 = new ECSSocket(this);//将实例进行初始化;
            //Thread ECSThread = new Thread(exp4.ConnectToServer);
            exp4.ConnectToServer();//连接云服务器


            
                       
        }


        
        //没有简化的定时器，
        //private System.Timers.Timer Timer_RefreshSensorFault = new System.Timers.Timer();//首页定时刷新采集值表格以及故障值表格
        
        //private System.Timers.Timer Timer_SendSensorData = new System.Timers.Timer();//按照一定的时间间隔将数据上传至数据库服务器
        //private System.Timers.Timer Timer_SendSensorStatus = new System.Timers.Timer();//按照一定的时间间隔将状态数据上传至数据库服务器

        public static System.Timers.Timer Timer_Command = new System.Timers.Timer();//按照一定的时间间隔，向溶解氧传感器定时要数据

        public static System.Timers.Timer Timer_ChlTur = new System.Timers.Timer();//按照一定的时间间隔，向叶绿素浊度传感器定时要取数据


        public static System.Timers.Timer Timer_Clean = new System.Timers.Timer();//按照一定的频率，向叶绿素浊度发送启动清洁刷的动作


        public static System.Timers.Timer Timer_Storage = new System.Timers.Timer();//用于定时生成供计算中心进行解析的文件


        
        //private int commandInterval = 5000;//定时给PIC单片机要数的时间间隔，时间间隔默认为5秒
        //采集值图形是否放大的标识位--2017-10-13可不要


        private bool changedACh1 = false;//A舱通道1是否进行放大的标志
        private bool changedACh2 = false;//A舱通道2是都进行放大的标志位
        private bool changedATemp = false;//A舱温度曲线是否进行放大的标志位

        private bool changedBCh1 = false;//B舱通道1是否进行放大的标志
        private bool changedBCh2 = false;//B舱通道2是否进行放大的标志
        private bool changedBTemp = false;//B舱温度曲线是否进行放大的标志

        //2018-01-29增加变量
        private bool changedDO = false;
        private bool changedADL = false;
        private bool changedCTD = false;
        private bool changedCDOM= false;

        public static int draw1000flag = 0;//初始化加载1000个点完成的标志
        public static int draw1000SensorFlag = 0;//传感器图形初始化加载1000个点完成标志
        public static int maxAndminFlag = 0;
        //2018-02-01新增变量-图像的坐标轴显示范围
        public static int maxDOValue = 0;//溶解氧图像的纵轴最大值，对应picDO图
        public static int minDOValue = 0; //溶解氧图像的纵轴最小值

        //public static int maxA1Value = 0;//A舱通道1图像纵轴最大值对应picACh1图
        //public static int minA1Value = 0;//A舱通道1图像纵轴最小值

        //public static int maxATemp = 0;//A舱温度曲线纵坐标轴最大值对应picATemp
        //public static int minATemp = 0;
        //public static int maxBTemp = 0;//B舱温度曲线纵坐标轴最小值对应picBTemp
        //public static int minBTemp = 0;

        public static int mark = 0;

        public _4MyClientClass2 expDO;//向溶解氧传感器发送要数的指令是建立一个长连接

        public _4MyClientClass2 expChlTur;//向叶绿素浊度传感器发送要数指令的长连接

        public _4MyClientClass2 expClean;//定时向叶绿素浊度发送清洁指令的长连接

        SerialPort sp1 = new SerialPort();//2020-12-17添加serialPort对象，注册datareceived事件

        /// <summary>
        /// 平台状态信息-电压、电流、功率/温度、前后端盖漏水值、通道发送包个数、故障时间实时显示，定时刷新的一系列操作
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void sysTimer_Tick(object sender, EventArgs e)
        {                                       
            this.systemTime.Text = "当前时间：" + Convert.ToString(DateTime.Now);

           // this.txtTime.Text = DateTime.Now.ToString("yyyy:MM:dd:HH:mm:ss");
        }

        private void Main_Load(object sender, EventArgs e)
        {



            //2021年5月12日16:24:17，初始化定时给计算中心进行访问的数据文件
            Timer_Storage.Interval = 60000;//定时生成文件的时间间隔为60s，1min
            Timer_Storage.Enabled = true;
            Timer_Storage.Elapsed += new System.Timers.ElapsedEventHandler(Timer_Storage_Elapsed);
            Timer_Storage.AutoReset = true;


            //定时器定时通过串口服务器给PIC单片机发送要数指令2020年8月18日10:21:05
            //Timer_Command.Elapsed += new System.Timers.ElapsedEventHandler(Timer_Command_Elapsed);
            //Timer_Command.AutoReset = true;//自动启动该定时器
            //Timer_Command.Interval = commandInterval;
            //Timer_Command.Enabled = true;

            //以下是关于向溶解氧定时要数的操作
            Timer_Command.Elapsed += new System.Timers.ElapsedEventHandler(Timer_Command_Elapsed);
            Timer_Command.Interval = 30000;//默认为30s
            Timer_Command.Enabled = true;

            //以下是关于向叶绿素浊度传感器定时要数的操作
            Timer_ChlTur.Elapsed += new System.Timers.ElapsedEventHandler(Timer_ChlTur_Elapsed);
            Timer_ChlTur.Interval = 30000;//默认为10s
            Timer_ChlTur.Enabled = true;



            Timer_Clean.Elapsed += new System.Timers.ElapsedEventHandler(Timer_Clean_Elapsed);
            Timer_Clean.Interval = 300000;
            Timer_Clean.Enabled = true;
           
            expDO.ConnectToServer(1);//连接服务器
            expChlTur.ConnectToServer(1);//连接服务器
            expClean.ConnectToServer(1);

            //2020年8月10日14:14:20   初始化将给数据采集器发送指令需要设置的IP地址以及端口信息在界面相应位置显示出来
            DataSet ds = new DataSet();
            ds.ReadXml(@".\IPandPortConfig.xml");
            IPAddress IP = IPAddress.Parse(ds.Tables[0].Rows[0]["srvIP"].ToString());
            int port = Convert.ToInt32(ds.Tables[0].Rows[0]["srvPort"].ToString());

            txtDataCollectIP.Text = IP.ToString();
            txtDataCollectPort.Text = port.ToString();


            //2020年7月3日11:30:03  增加百度地图

            webGPS.Url = new Uri(Path.Combine(Application.StartupPath, "baidu.html"));//界面加载时加载上百度地图
            //webGPS.Document.InvokeScript("clear");//清除标记
            //string a = Convert.ToString( 120.423293);
            //string b = Convert.ToString( 36.117387);
            //webGPS.Document.InvokeScript("setLocation", new object[] { a, b });

            button14.BackColor = Color.FromArgb(240,248,255);
            button20.BackColor = Color.FromArgb(240,248,255);
            button21.BackColor = Color.FromArgb(240,248,255);
            button22.BackColor = Color.FromArgb(240,248,255);

            
            //数据采集器1传感器图形的坐标轴初始范围设定
            picDO.Axes.Left.Maximum = 15;
            picDO.Axes.Left.Minimum = 0;

            picPH.Axes.Left.Maximum = 15;
            picPH.Axes.Left.Minimum = 0;

            picCTD.Axes.Left.Maximum = 50;
            picCTD.Axes.Left.Minimum = -5;

            //1.初始化页面label标签以及button按钮的初始化数值
            //initFont(this);           
            //2.使用代码方式改变datagridview中显示字体的大小
            Font font = new Font("Times New Roman", 12);//UTF-8是字体的编码格式，2是字体大小
           
            //dataGridView1.Font = font;//此时dataGridView的字体就已经设置完成
            dataGridView2.Font = font;
            dgwData.Font = font;
            dataGridView4.Font = font;
            dataGridView3.Font = font;

            //3.将通道个数位置初始化显示为个数0
            //txtACabinNum.Text = "0";
            //txtBCabinNum.Text = "0";
            txtTotalNum.Text = "0";
            txtCommandNum.Text = "0";


            //4.关于画图的一系列初始化操作,单独封装起来
            InitPicture();

            //求取1000个点最大值以及最小值
            //MaxandMin();


            //将以上初始化画数据库中1000个点操作单独抛出个线程来进行操作，这样不影响操作能加快界面显示，初始化的是主接驳盒高压舱以及次接驳盒低压舱的电状态信息以及主次舱内温度信息
            Thread threadDraw = new Thread(InitDraw);
            threadDraw.Start();


            //加载传感器数据初始化的1000个点单独抛线程实现(传感器包括山仪所溶解氧，安德拉溶解氧，CTD，多参数)
            Thread threadDrawSensor = new Thread(InitDrawSenor);
            threadDrawSensor.Start();

            //Thread threadAddDynamic = new Thread(InitAddDynamic);
            //threadAddDynamic.Start();

            //InitAddDynamic();

            //将数据库中最新的温度信息读取出来，方便温度状态数据长传至数据库服务器,将此操作放入线程中
            //string sqlTemp = "select statusdata,collectdate from cabinstatustemp order by savedate desc limit 1";
            //draw.addTemp(sqlTemp, this);



            //5.数据列表信息页-DateTimePicker控件能够对小时分钟以及秒进行选择
            // searchStartTime.Format = 
            searchStartTime.Value = DateTime.Now;
            searchStartTime.Format = DateTimePickerFormat.Custom;
            searchStartTime.CustomFormat = "yyyy年MM月dd日 HH:mm:ss";
            searchStartTime.ShowUpDown = true;

            //searchEndTime.Value = DateTime.Now;
            searchEndTime.Value = DateTime.Now.AddHours(1);
            searchEndTime.Format = DateTimePickerFormat.Custom;
            searchEndTime.CustomFormat = "yyyy年MM月dd日 HH:mm:ss";
            searchEndTime.ShowUpDown = true;
            dataType.Text = "主接驳盒状态数据";//数据列表查询下拉页的默认选项是“采集数据”

            //6.历史曲线信息页-DateTime控件能够对小时分钟以及秒进行选择
            picStartTime.Value = DateTime.Now.AddDays(-1);
            picStartTime.Format = DateTimePickerFormat.Custom;
            picStartTime.CustomFormat = "yyyy年MM月dd日 HH:mm:ss";
            picStartTime.ShowUpDown = true;

            picEndTime.Value = DateTime.Now;
            picEndTime.Format = DateTimePickerFormat.Custom;
            picEndTime.CustomFormat = "yyyy年MM月dd日 HH:mm:ss";
            picEndTime.ShowUpDown = true;
            pictureType.Text = "主接驳盒通道1电压";
            lblTotal.Visible = false;


            /***************************/
            this.systemTime.Text = "当前时间：" + Convert.ToString(DateTime.Now);
            this.canStartTime.Text = Convert.ToString(DateTime.Now);//接驳盒开始采样时间
            this.dataCollect1StartTime.Text = Convert.ToString(DateTime.Now);//数据采集器1开始采样时间
           

            this.sysTimer.Interval = 1000;//将刷新时间变小
            this.sysTimer.Start();

            //定时器初始化之前，将首页故障表格先显示出来
           // DataTable dtAFaultData = platformStatus.searchAFaultData();//首页显示A舱故障值表格，查询数据库
           //// platformStatus.listACabinFaultData(dtAFaultData, this); //将查询的A舱的故障值表格绑定至datagridview控件中
            
            
            //2020年11月10日11:00:21-在首页将接驳盒所有故障值在表格中显示出来
            DataTable dtBFaultData = platformStatus.searchBFaultData();
            platformStatus.listBCabinFaultData(dtBFaultData, this);
            
            //数据采集器1状态信息页显示数据采集器1故障信息
            DataTable dtRealTimeFaultData = platformStatus.searchRealTimeFault(1);//实时更新平台状态信息-故障值那一列信息
            platformStatus.listRealTimeFault(dtRealTimeFaultData, this.dataGridView4);

            //数据采集器1信息页显示采集值表格
            DataTable dtRealTimeSensorData = platformStatus.searchRealTimeSensor(1);//采集值表格//实时更新平台状态信息-采集值那一列信息
            platformStatus.listRealTimeData(dtRealTimeSensorData, this.dataGridView3);//采集值表格与界面上的相应控件进行绑定



            

            //7.load加载过程中就按照地址栏之中的地址加载摄像头网页
           // showWebContent();


            string sql = "select sign from programconfig";
            DataTable dtTable = SqlHelper.ExecuteDataTable(sql);

            mark = Convert.ToInt32(dtTable.Rows[0]["sign"]);


            string sql2 = "select latitude from programconfig";
            DataTable dt = SqlHelper.ExecuteDataTable(sql2);

            _3ReceieveMsgClass2.latitude = Convert.ToDouble(dt.Rows[0]["latitude"]);



            ///*2020年9月16日09:52:33新增*/
            // 需要启动的程序
            p.StartInfo.FileName = @"NetSDKDemo.exe";


            //2020-12-17增加与北斗模块的串口通信程序，解析收到的漂流浮标的数据

            btnSwitch.Text = "打开";
            btnSwitch.BackColor = Color.FromArgb(0, 192, 0);
            btnSwitch.ForeColor = Color.White;
            //1.检查是否含有串口
            string[] str = SerialPort.GetPortNames();
            if (str == null)
            {
                MessageBox.Show("本机没有串口！", "Error");
                return;
            }
            //2.添加串口项目，添加所有串口项目至comboBox下拉框中
            foreach (string s in System.IO.Ports.SerialPort.GetPortNames())
            {//获取有多少个COM口              
                cbSerial.Items.Add(s);
            }
            
            //3.串口默认选项的一些设置
           // cbSerial.SelectedIndex = 0;//不给串口任何默认的选择，防止上位机所在电脑没有任何默认串口，避免程序加载时出现错误
            
            
            //4.添加串口接收事件
            sp1.DataReceived += new SerialDataReceivedEventHandler(sp1_DataReceived);

        }
        /// <summary>
        /// 定时给叶绿素浊度传感器发送启动清洁刷指令
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        void Timer_Clean_Elapsed(object sender, System.Timers.ElapsedEventArgs e)
        {
            _4MyClientClass2 exp = new _4MyClientClass2();
            Thread.CurrentThread.IsBackground = true;
            Timer_Clean.Enabled = false;
            try
            {
                if ((expClean.tcpClient.Connected == false) || ((expClean.tcpClient.Poll(1000, SelectMode.SelectRead)) && (expClean.tcpClient.Available == 0)))
                {
                    if (expClean.ConnectToServer(1))
                        expClean.ExecuteCmd("#A0105\r\n", 2, 1);//使用长连接定时向叶绿素浊度传感器发送
                }
                else
                {
                    expClean.ExecuteCmd("#A0105\r\n", 2, 1);
                }
            }
            catch (Exception exp1)
            {
                LogClass.WriteLogFile("定时向叶绿素浊度发送清洁指令异常！" + exp1.Message);
            }
            ClearMemory();
            Timer_Clean.Enabled = true;    
        }
        /// <summary>
        /// 给计算中心定时生成文件可供访问操作
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        void Timer_Storage_Elapsed(object sender, System.Timers.ElapsedEventArgs e)
        {
            Thread.CurrentThread.IsBackground = true;
            Timer_Storage.Enabled = false;
            try
            {
                if(draw.arrayLCh1Vol.Count >0 && draw.arrayLCh1Cur.Count > 0 && draw.arrayLCh2Vol.Count > 0 && draw.arrayLCh2Cur.Count > 0 && draw.arrayLCh3Cur.Count > 0 && draw.arrayLCh3Vol.Count > 0 && draw.arrayLCh4Vol.Count > 0 && draw.arrayLCh4Cur.Count > 0 && draw.arrayLCh5Vol.Count > 0 && draw.arrayLCh5Cur.Count > 0 && draw.arrayLTemp.Count > 0 && draw.arrayDCCh1Vol.Count > 0 && draw.arrayDCCh1Cur.Count > 0 && draw.arrayDCCh2Cur.Count > 0 && draw.arrayDCCh2Vol.Count > 0 && draw.arrayDCCh3Cur.Count > 0 && draw.arrayDCCh3Vol.Count > 0 && draw.arrayDCCh4Vol.Count > 0 && draw.arrayDCCh4Cur.Count > 0 && draw.arrayDCCh5Cur.Count > 0 && draw.arrayDCCh5Vol.Count > 0 && draw.arrayDCTemp.Count > 0 && draw.arrayDOValue.Count > 0 && draw.arrayChlValue.Count > 0 && draw.arrayTurValue.Count > 0 && draw.arrayCTD_CValue.Count >0 && draw.arrayCTD_DValue.Count > 0 && draw.arrayCTD_SValue.Count > 0 && draw.arrayCTD_TValue.Count > 0)
                {

                    //次级接驳盒状态信息仅将动态数组中最新的数值取出来，取平均没有意义
                    object jBCh1Vol = draw.arrayLCh1Vol[draw.arrayLCh1Vol.Count - 1];//次级接驳盒通道1最新电压；
                    object jBCh2Vol = draw.arrayLCh2Vol[draw.arrayLCh2Vol.Count - 1];//次级接驳盒通道2最新电压；
                    object jBCh3Vol = draw.arrayLCh3Vol[draw.arrayLCh3Vol.Count - 1];//次级接驳盒通道3最新电压
                    object jBCh4Vol = draw.arrayLCh4Vol[draw.arrayLCh4Vol.Count - 1];
                    object jBCh5Vol = draw.arrayLCh5Vol[draw.arrayLCh5Vol.Count - 1];


                    object jBCh1Cur = draw.arrayLCh1Cur[draw.arrayLCh1Cur.Count - 1];//次级接驳盒通道1最新电流
                    object jBCh2Cur = draw.arrayLCh2Cur[draw.arrayLCh2Cur.Count - 1];
                    object jBCh3Cur = draw.arrayLCh3Cur[draw.arrayLCh3Cur.Count - 1];
                    object jBCh4Cur = draw.arrayLCh4Cur[draw.arrayLCh4Cur.Count - 1];
                    object jBCh5Cur = draw.arrayLCh5Cur[draw.arrayLCh5Cur.Count - 1];

                    object jBTemp = draw.arrayLTemp[draw.arrayLTemp.Count - 1];


                    object dCCh1Vol = draw.arrayDCCh1Vol[draw.arrayDCCh1Vol.Count - 1];//数据采集器通道1电压
                    object dCCh2Vol = draw.arrayDCCh2Vol[draw.arrayDCCh2Vol.Count - 1];//数据采集器通道2电压
                    object dCCh3Vol = draw.arrayDCCh3Vol[draw.arrayDCCh3Vol.Count - 1];//数据采集器通道3电压
                    object dCCh4Vol = draw.arrayDCCh4Vol[draw.arrayDCCh4Vol.Count - 1];//数据采集器通道4电压
                    object dCCh5Vol = draw.arrayDCCh5Vol[draw.arrayDCCh5Vol.Count - 1];//数据采集器通道5电压


                    object dCCh1Cur = draw.arrayDCCh1Cur[draw.arrayDCCh1Cur.Count - 1];//数据采集器通道1电流
                    object dCCh2Cur = draw.arrayDCCh2Cur[draw.arrayDCCh2Cur.Count - 1];//数据采集器通道2电流
                    object dCCh3Cur = draw.arrayDCCh3Cur[draw.arrayDCCh3Cur.Count - 1];//数据采集器通道3电流
                    object dCCh4Cur = draw.arrayDCCh4Cur[draw.arrayDCCh4Cur.Count - 1];//数据采集器通道4电流
                    object dCCh5Cur = draw.arrayDCCh5Cur[draw.arrayDCCh5Cur.Count - 1];//数据采集器通道5电流

                    object dCTemp = draw.arrayDCTemp[draw.arrayDCTemp.Count - 1];

                    //1.在xml文件中写入次级接驳盒的信息
                    XDocument document = new XDocument();
                    XElement root = new XElement("SeafloorObservatoryNetWorkDataFile-JiaozhouBay");//一级标签代表为海底观测网络数据
                    XElement jBData = new XElement("SecondaryJunctionBoxStatusData");//二级标签次级接驳盒状态数据

                    jBData.SetElementValue("JBCh1Vol", jBCh1Vol);
                    jBData.SetElementValue("JBCh2Vol", jBCh2Vol);
                    jBData.SetElementValue("JBCh3Vol", jBCh3Vol);
                    jBData.SetElementValue("JBCh4Vol", jBCh4Vol);
                    jBData.SetElementValue("JBCh5Vol", jBCh5Vol);

                    jBData.SetElementValue("JBCh1Cur", jBCh1Cur);
                    jBData.SetElementValue("JBCh2Cur", jBCh2Cur);
                    jBData.SetElementValue("JBCh3Cur", jBCh3Cur);
                    jBData.SetElementValue("JBCh4Cur", jBCh4Cur);
                    jBData.SetElementValue("JBCh5Cur", jBCh5Cur);

                    jBData.SetElementValue("JBTemp", jBTemp);

                    root.Add(jBData);

                    //2.在xml文件中写入数据采集器的信息
                    XElement dCData = new XElement("DataCollectorStatusData");//二级标签为数据采集器状态数据

                    dCData.SetElementValue("DCCh1Vol", dCCh1Vol);
                    dCData.SetElementValue("DCCh2Vol", dCCh2Vol);
                    dCData.SetElementValue("DCCh3Vol", dCCh3Vol);
                    dCData.SetElementValue("DCCh4Vol", dCCh4Vol);
                    dCData.SetElementValue("DCCh5Vol", dCCh5Vol);


                    dCData.SetElementValue("DCCh1Cur", dCCh1Cur);
                    dCData.SetElementValue("DCCh2Cur", dCCh2Cur);
                    dCData.SetElementValue("DCCh3Cur", dCCh3Cur);
                    dCData.SetElementValue("DCCh4Cur", dCCh4Cur);
                    dCData.SetElementValue("DCCh5Cur", dCCh5Cur);

                    dCData.SetElementValue("DCTemp", dCTemp);

                    root.Add(dCData);


                    //3.将数据采集器所接的传感器数据写入xml文件
                    XElement sensorData = new XElement("SensorData");//二级标签为数据采集器所接传感器数据


                    object doValue = draw.arrayDOValue[draw.arrayDOValue.Count - 1];//溶解氧数据
                    object chlValue = draw.arrayChlValue[draw.arrayChlValue.Count - 1];//叶绿素数据
                    object turValue = draw.arrayTurValue[draw.arrayTurValue.Count - 1];//浊度数据
                    object CTD_CValue = draw.arrayCTD_CValue[draw.arrayCTD_CValue.Count - 1];//CTD-电导率数据
                    object CTD_TValue = draw.arrayCTD_TValue[draw.arrayCTD_TValue.Count - 1];//CTD-温度数据
                    object CTD_DValue = draw.arrayCTD_DValue[draw.arrayCTD_DValue.Count - 1];//CTD-深度数据
                    object CTD_SValue = draw.arrayCTD_SValue[draw.arrayCTD_SValue.Count - 1];//CTD-盐度数据


                    sensorData.SetElementValue("DO", doValue);
                    sensorData.SetElementValue("Chlorophyll", chlValue);
                    sensorData.SetElementValue("Turbidity", turValue);
                    sensorData.SetElementValue("Conductivity", CTD_CValue);
                    sensorData.SetElementValue("Temperature", CTD_TValue);
                    sensorData.SetElementValue("Salinity", CTD_SValue);
                    sensorData.SetElementValue("Depth", CTD_DValue);

                    root.Add(sensorData);

                    DateTime dt = DateTime.Now;
                    root.Save(@"D:\SONData\" + dt.ToString("yyyy-MM-dd HHmmss") + "SONData" + ".xml");


                    //将
                    string sql = "insert into statuslog (jBCh1Vol,jBCh2Vol,jBCh3Vol,jBCh4Vol,jBCh5Vol,jBCh1Cur,jBCh2Cur,jBCh3Cur,jBCh4Cur,jBCh5Cur,jBTemp,dCCh1Vol,dCCh2Vol,dCCh3Vol,dCCh4Vol,dCCh5Vol,dCCh1Cur,dCCh2Cur,dCCh3Cur,dCCh4Cur,dCCh5Cur,dCTemp,do,chl,tur,con,temp,sal,depth,time) values('" + jBCh1Vol + "','" + jBCh2Vol + "','" + jBCh3Vol + "','" + jBCh4Vol + "','" + jBCh5Vol + "','" + jBCh1Cur + "','" + jBCh2Cur + "','" + jBCh3Cur + "','" + jBCh4Cur + "','" + jBCh5Cur + "','" + jBTemp + "','" + dCCh1Vol + "','" + dCCh2Vol + "','" + dCCh3Vol + "','" + dCCh4Vol + "','" + dCCh5Vol + "','" + dCCh1Cur + "','" + dCCh2Cur + "','" + dCCh3Cur + "','" + dCCh4Cur + "','" + dCCh5Cur + "','" + dCTemp + "','" + doValue + "','" + chlValue + "','" + turValue + "','" + CTD_CValue + "','" + CTD_TValue + "','" + CTD_SValue + "','" + CTD_DValue + "','" + dt + "')";//包编号存入数据库
                    SqlHelper.ExecuteNonQuery(sql); 

                }

            }
            catch(Exception exp)
            {
                LogClass.WriteLogFile("定时生成存储文件出现异常！"+exp.Message);
            }
            ClearMemory();
            Timer_Storage.Enabled = true;
        }
        /// <summary>
        /// 定时向叶绿素浊度传感器发送要数指令
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        void Timer_ChlTur_Elapsed(object sender, System.Timers.ElapsedEventArgs e)
        {
            _4MyClientClass2 exp = new _4MyClientClass2();
            Thread.CurrentThread.IsBackground = true;
            Timer_ChlTur.Enabled = false;
            try
            {
                if ((expChlTur.tcpClient.Connected == false) || ((expChlTur.tcpClient.Poll(1000, SelectMode.SelectRead)) && (expChlTur.tcpClient.Available == 0)))
                {
                    if (expChlTur.ConnectToServer(1))
                        expChlTur.ExecuteCmd("#A0102\r\n", 2, 1);//使用长连接定时向叶绿素浊度传感器发送
                }
                else
                {
                    expChlTur.ExecuteCmd("#A0102\r\n", 2, 1);
                }
            }
            catch (Exception exp1)
            {
                LogClass.WriteLogFile("定时向叶绿素浊度传感器要数据出现异常！" + exp1.Message);
            }
            ClearMemory();
            Timer_ChlTur.Enabled = true;
            
        }
        /// <summary>
        /// 定时向溶解氧传感器要数据
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        void Timer_Command_Elapsed(object sender, System.Timers.ElapsedEventArgs e)
        {
            _4MyClientClass2 exp = new _4MyClientClass2();
            Thread.CurrentThread.IsBackground = true;
            Timer_Command.Enabled = false;
            try
            {
                if ((expDO.tcpClient.Connected == false) || ((expDO.tcpClient.Poll(1000, SelectMode.SelectRead)) && (expDO.tcpClient.Available == 0)))
                {
                    if(expDO.ConnectToServer(1))
                        expDO.ExecuteCmd("$SETData#", 2, 1);               
                }
                else
                {
                    expDO.ExecuteCmd("$SETData#", 2, 1);
                }
            }
            catch (Exception exp1)
            {
                LogClass.WriteLogFile("定时向溶解氧传感器要数据出现异常！" + exp1.Message);
            }
            ClearMemory();
            Timer_Command.Enabled = true;
            
        }
        /// <summary>
        /// 串口接收事件
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        void sp1_DataReceived(object sender, SerialDataReceivedEventArgs e)
        {
            try
            {
                if(sp1.IsOpen)
                {
                    //暂时注释，换一种形式

                    //string message = sp1.ReadTo("$");//读到特定的$字符就结束
                    ////byte[] receiveData1 = StrToHexByte(StrToASCII("$"+message));//定义串口接收的缓冲区    
                    //message = "$" + message;
                    //sp1.DiscardInBuffer();//读到串口中的数据后，就要清空缓存

                    //if(message.Substring(0,5) =="$TXXX")//如果是$TXXX则代表发送过来的是漂流浮标的通信信息
                    //{
                    //    ThreadProcessBeidou tt = new ThreadProcessBeidou(this, message);
                    //    Thread thread = new Thread(new ThreadStart(tt.dealGPS));
                    //    thread.Start();
                    //}


                    string str = "";
                    do
                    {
                        int count = sp1.BytesToRead;
                        if (count <= 0)
                            break;
                        byte[] readBuffer = new byte[count];
                 
                        Application.DoEvents();
                        sp1.Read(readBuffer, 0, count);

                        string content = null;
                        for (int k = 0; k < readBuffer.Length; k++)
                            content += String.Format("{0:X2}", readBuffer[k]);//转换成对应的16进制的字符
                        str += content;

                    } while (sp1.BytesToRead > 0);

                    //将接收到的串口十六进制字符串存入数据库中
                    DateTime dt = DateTime.Now;
                    string sql = "insert into seafloor_beidouData (saveDate,collectRawInfo) values('" + dt + "','" + str + "')";//包编号存入数据库
                    SqlHelper.ExecuteNonQuery(sql);



                    if (str.Substring(0, 10) == "2454585858")//如果是$TXXX则代表发送过来的是漂流浮标的通信信息
                    {

                        int l = str.Length;

                        ThreadProcessBeidou tt = new ThreadProcessBeidou(this, str);
                        Thread thread = new Thread(new ThreadStart(tt.dealGPS));
                        thread.Start();
                    }

                }
            }
            catch(Exception exp)
            {
                LogClass.WriteLogFile("串口接收北斗模块数据异常！"+exp.Message);
            }
        }
                     
        /// <summary>
        /// 数据列表页-查询按钮对应的响应事件
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void button5_Click(object sender, EventArgs e)
        {

            Thread threadInquire = new Thread(InquireList);
            threadInquire.Start();
            
        }


        private delegate void delUICursor(int i);
        private delUICursor showUICursorcallback;
        /// <summary>
        /// 主界面鼠标显示等待状态的回调函数
        /// </summary>
        /// <param name="i"></param>
        private void ShowUICursorMethod(int i)
        {
            if (i == 1)
            {
                this.tabPage1.Cursor = Cursors.WaitCursor;
            }
            else
            {
                //this.Cursor = Cursors.Default;
                this.tabPage1.Cursor = Cursors.Default;
            }

        }


        /// <summary>
        /// 其中this.Invoke((EventHandler)delegate，用法用于跨线程访问主界面中的控件
        /// </summary>
        private void InquireList()
        {
            showUICursorcallback = new delUICursor(ShowUICursorMethod);
            this.Invoke(showUICursorcallback, 1);

            try
            {
                if (this.InvokeRequired)
                {
                    this.Invoke((EventHandler)delegate
                    {

                        switch (dataType.Text.ToString().Trim())
                        {
                            case "主接驳盒状态数据":
                                DataTable dtHighStsData = dataList.SearchACabinStatusData(this);//查询结果填入离线的数据集
                                Application.DoEvents();
                                dataList.listData(dtHighStsData, this);//在dataGridView控件中显示数据
                                Application.DoEvents();
                                break;
                            case "次接驳盒状态数据":
                                DataTable dtLowStsData = dataList.SearchBCabinStatusData(this);
                                dataList.listData(dtLowStsData, this);
                                break;
                            case "主接驳盒故障数据":
                                DataTable dtAFaultData = dataList.SearchACabinFaultData(this);
                                dataList.listData(dtAFaultData, this);
                                break;
                            case "次接驳盒故障数据":
                                DataTable dtBFaultData = dataList.SearchBCabinFaultData(this);
                                dataList.listData(dtBFaultData, this);
                                break;
                            //case "数据采集器采集数据":
                            //    DataTable dtDOData = dataList.SearchDOSensorData(this,1);
                            //    dataList.listData(dtDOData, this);
                            //    break;
                            case "数据采集器故障数据":
                                DataTable dtCollectFaultData = dataList.SearchCollectFaultData(this,1);
                                dataList.listData(dtCollectFaultData, this);
                                break;
                            case "数据采集舱内温度数据":
                                DataTable dtCollectStatusData = dataList.SearchCollectStatusData(this,1);
                                dataList.listData(dtCollectStatusData, this);
                                break;
                            case "数据采集器电参数数据":
                                DataTable dtCollectElectricalData = dataList.SearchCollectElectricalData(this,1);
                                dataList.listData(dtCollectElectricalData, this);
                                break;
                            case "溶解氧数据":
                                DataTable dtCollectDOData = dataList.SearchCollectDOData(this);
                                dataList.listData(dtCollectDOData, this);
                                break;
                            case"PH数据":
                                DataTable dtCollectPHData = dataList.SearchCollectPHData(this);
                                dataList.listData(dtCollectPHData,this);
                                break;
                            case "叶绿素浊度数据":
                                DataTable dtCollectChlTurData = dataList.SearchCollectChlTurData(this);
                                dataList.listData(dtCollectChlTurData,this);
                                break;
                            case "CTD数据":
                                DataTable dtCollectCTDData = dataList.SearchCollectCTDData(this);
                                dataList.listData(dtCollectCTDData, this);
                                break;

                        }
                    });
                }
            }
            catch (Exception exp)
            {
                LogClass.WriteLogFile("查询异常" + exp.Message);
            }

            this.Invoke(showUICursorcallback, 2);

        }
  
        
        /// <summary>
        /// 判断字符串是否符合IP的格式要求
        /// </summary>
        /// <param name="ip"></param>
        /// <returns></returns>
        public static bool IsIP(string ip)
        {
            return Regex.IsMatch(ip, @"^((2[0-4]\d|25[0-5]|[01]?\d\d?)\.){3}(2[0-4]\d|25[0-5]|[01]?\d\d?)$");
        }

        /// <summary>
        /// 执行按钮响应函数
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void button3_Click(object sender, EventArgs e)
        {

            cmdSet myCMD = new cmdSet(this);
            myCMD.Show();
            
        }
      

        /// <summary>
        /// 接驳盒节点配置
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void button2_Click(object sender, EventArgs e)
        {
            try
            {
                SensorConfig mySensorConfig = new SensorConfig();
                mySensorConfig.Show();
            }
            catch(Exception exp)
            {
                LogClass.WriteLogFile("配置节点信息出现异常！"+exp.Message);
            }
        }
        /// <summary>
        /// 表格开头添加行号
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        //private void dataGridView1_RowPostPaint(object sender, DataGridViewRowPostPaintEventArgs e)
        //{
        //    Color color = dataGridView1.RowHeadersDefaultCellStyle.ForeColor;
        //    if (dataGridView1.Rows[e.RowIndex].Selected)
        //        color = dataGridView1.RowHeadersDefaultCellStyle.SelectionForeColor;
        //    else
        //        color = dataGridView1.RowHeadersDefaultCellStyle.ForeColor;

        //    using (SolidBrush b = new SolidBrush(color))
        //    {
        //        e.Graphics.DrawString((e.RowIndex + 1).ToString(), e.InheritedRowStyle.Font, b, e.RowBounds.Location.X + 20, e.RowBounds.Location.Y + 6);
        //    }
        //}
        /// <summary>
        /// 表格添加行号
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void dataGridView2_RowPostPaint(object sender, DataGridViewRowPostPaintEventArgs e)
        {
            Color color = dataGridView2.RowHeadersDefaultCellStyle.ForeColor;
            if (dataGridView2.Rows[e.RowIndex].Selected)
                color = dataGridView2.RowHeadersDefaultCellStyle.SelectionForeColor;
            else
                color = dataGridView2.RowHeadersDefaultCellStyle.ForeColor;

            using (SolidBrush b = new SolidBrush(color))
            {
                e.Graphics.DrawString((e.RowIndex + 1).ToString(), e.InheritedRowStyle.Font, b, e.RowBounds.Location.X + 20, e.RowBounds.Location.Y + 6);
            }
        }
        /// <summary>
        /// 给表格在开头添加行号
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void dgwData_RowPostPaint(object sender, DataGridViewRowPostPaintEventArgs e)
        {
            Color color = dgwData.RowHeadersDefaultCellStyle.ForeColor;
            if (dgwData.Rows[e.RowIndex].Selected)
                color = dgwData.RowHeadersDefaultCellStyle.SelectionForeColor;
            else
                color = dgwData.RowHeadersDefaultCellStyle.ForeColor;

            using (SolidBrush b = new SolidBrush(color))
            {
                e.Graphics.DrawString((e.RowIndex + 1).ToString(), e.InheritedRowStyle.Font, b, e.RowBounds.Location.X + 7, e.RowBounds.Location.Y + 6);
            }
        }




        
        
        /// <summary>
        /// 高压舱通道1打开按钮
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void chOneOpen_Click(object sender, EventArgs e)
        {          
           this.Cursor = Cursors.WaitCursor;
           _3ReceieveMsgClass.flagOnA1 = 0;
           try
           {
               LogCommand.WriteLogFile("执行高压舱通道1打开！");
               if (canBConnect.Text == "连接")
               {
                   for (int i = _1MySerClass.userList.Count - 1; i >= 0; i--)
                   {
                       _3ReceieveMsgClass ct = _1MySerClass.userList[i];
                       if (!ct.tcpClient.Connected || ((ct.tcpClient.Poll(1000, SelectMode.SelectRead)) && (ct.tcpClient.Available == 0)))
                       {
                           _1MySerClass.userList.Remove(ct);
                           continue;
                       }
                       else if (ct.nodeIP == txtBIP.Text.Trim())
                       {
                           ct.SendMessage("A$SET CH1 Open#", 2);

                           //Thread.Sleep(10000);延时函数不能使用能导致系统休眠的时间

                           if (Delay(1))//延时10s
                           {
                               if (_3ReceieveMsgClass.flagOnA1 == 1)
                               {
                                   MessageBox.Show("执行成功！");
                                   LogCommand.WriteLogFile("执行高压舱通道1打开成功！");

                                   //this.txtACh1Status.Text = "打开";
                                   //this.txtACh1Status.BackColor = Color.DarkSeaGreen;
                                   //this.txtACh1Status.ForeColor = Color.White;

                                   //ACh1Open.Enabled = false;
                                   //ACh1Close.Enabled = true;
                               }

                               else
                               {
                                   ct.SendMessage("A$SET CH1 Open#", 2);//第二次指令chongfa
                                   Delay(2);

                                   if (_3ReceieveMsgClass.flagOnA1 == 1)
                                   {
                                       MessageBox.Show("执行成功！");
                                       LogCommand.WriteLogFile("执行高压舱通道1打开成功！");

                                       //this.txtACh1Status.Text = "打开";
                                       //this.txtACh1Status.BackColor = Color.DarkSeaGreen;
                                       //this.txtACh1Status.ForeColor = Color.White;

                                       //ACh1Open.Enabled = false;
                                       //ACh1Close.Enabled = true;
                                   }
                                   else
                                   {
                                       ct.SendMessage("A$SET CH1 Open#", 2);//第3次指令chongfa

                                       Delay(2);

                                       if (_3ReceieveMsgClass.flagOnA1 == 1)
                                       {
                                           MessageBox.Show("执行成功！");
                                           LogCommand.WriteLogFile("执行高压舱通道1打开成功！");

                                           //this.txtACh1Status.Text = "打开";
                                           //this.txtACh1Status.BackColor = Color.DarkSeaGreen;
                                           //this.txtACh1Status.ForeColor = Color.White;

                                           //ACh1Open.Enabled = false;
                                           //ACh1Close.Enabled = true;
                                       }
                                       else
                                       {
                                           MessageBox.Show("执行失败！");
                                           LogCommand.WriteLogFile("执行高压舱通道1打开失败！");
                                           //ACh1Open.Enabled = true;
                                           //ACh1Close.Enabled = false;
                                           //this.txtACh1Status.Text = "打开失败";
                                           //this.txtACh1Status.ForeColor = Color.Black;
                                           //this.txtACh1Status.BackColor = Color.Yellow;
                                       }
                                   }

                                   
                               }
                                   
                           }
                           break;
                       }
                       else
                       {
                           MessageBox.Show("无有效连接！");
                           LogCommand.WriteLogFile("执行高压舱通道1打开失败！");

                       }
                   }
               }
               else
               {
                   MessageBox.Show("无可用连接！");
               }
           }
           catch (Exception exp)
           {
               LogClass.WriteLogFile("执行高压舱通道1打开异常！" + exp.Message);
           }
           _3ReceieveMsgClass.flagOnA1 = 0;
            this.Cursor = Cursors.Default; 
        }
        /// <summary>
        /// 高压舱通道1关闭的响应函数
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void chOneClose_Click(object sender, EventArgs e)
        {
            this.Cursor = Cursors.WaitCursor;
            _3ReceieveMsgClass.flagOffA1 = 0;
            try
            {                
                LogCommand.WriteLogFile("执行高压舱通道1关闭！");
                if (canBConnect.Text == "连接")
                {
                    for (int i = _1MySerClass.userList.Count - 1; i >= 0; i--)
                    {
                        _3ReceieveMsgClass ct = _1MySerClass.userList[i];
                        if (!ct.tcpClient.Connected || ((ct.tcpClient.Poll(1000, SelectMode.SelectRead)) && (ct.tcpClient.Available == 0)))
                        {
                            _1MySerClass.userList.Remove(ct);
                            continue;
                        }
                        else if (ct.nodeIP == txtBIP.Text.Trim())//只通过最新的连接发送数据,找到最新的可用连接之后，发送指令完成之后，跳出循环
                        {
                            ct.SendMessage("A$SET CH1 Close#", 2);

                            if (Delay(1))//延时10s
                            {
                                if (_3ReceieveMsgClass.flagOffA1 == 1)
                                {
                                    MessageBox.Show("执行成功！");
                                    LogCommand.WriteLogFile("执行高压舱通道1关闭成功！");
                                    //ACh1Close.Enabled = false;
                                    //ACh1Open.Enabled = true;
                                    //this.txtACh1Status.Text = "关闭";
                                    //this.txtACh1Status.BackColor = Color.Red;
                                    //this.txtACh1Status.ForeColor = Color.White;

                                    //this.txtACh1Logo.Text = "正常";
                                    //this.txtACh1Logo.BackColor = Color.DarkSeaGreen;
                                    //this.txtACh1Logo.ForeColor = Color.White;
                                }

                                else
                                {
                                    ct.SendMessage("A$SET CH1 Close#", 2);//第二次重发指令
                                    Delay(2);

                                    if (_3ReceieveMsgClass.flagOffA1 == 1)
                                    {
                                        MessageBox.Show("执行成功！");
                                        LogCommand.WriteLogFile("执行高压舱通道1关闭成功！");
                                        //ACh1Close.Enabled = false;
                                        //ACh1Open.Enabled = true;
                                        //this.txtACh1Status.Text = "关闭";
                                        //this.txtACh1Status.BackColor = Color.Red;
                                        //this.txtACh1Status.ForeColor = Color.White;

                                        //this.txtACh1Logo.Text = "正常";
                                        //this.txtACh1Logo.BackColor = Color.DarkSeaGreen;
                                        //this.txtACh1Logo.ForeColor = Color.White;
                                    }
                                    else
                                    {
                                        ct.SendMessage("A$SET CH1 Close#", 2);//第三次重发指令
                                        Delay(2);

                                        if (_3ReceieveMsgClass.flagOffA1 == 1)
                                        {
                                            MessageBox.Show("执行成功！");
                                            LogCommand.WriteLogFile("执行高压舱通道1关闭成功！");
                                            //ACh1Close.Enabled = false;
                                            //ACh1Open.Enabled = true;
                                            //this.txtACh1Status.Text = "关闭";
                                            //this.txtACh1Status.BackColor = Color.Red;
                                            //this.txtACh1Status.ForeColor = Color.White;

                                            //this.txtACh1Logo.Text = "正常";
                                            //this.txtACh1Logo.BackColor = Color.DarkSeaGreen;
                                            //this.txtACh1Logo.ForeColor = Color.White;
                                        }
                                        else
                                        {
                                            MessageBox.Show("执行失败！");
                                            LogCommand.WriteLogFile("执行高压舱通道1关闭失败！");
                                            //this.txtACh1Status.Text = "关闭失败";
                                            //this.txtACh1Status.ForeColor = Color.Black;
                                            //this.txtACh1Status.BackColor = Color.Yellow;
                                            //ACh1Close.Enabled = true;
                                            //ACh1Open.Enabled = false;
                                        }
                                    }                                  
                                }                                    
                            }
                            break;
                        }
                        else
                        {
                            MessageBox.Show("无有效连接！");
                        }
                    }
                }
                else
                {
                    MessageBox.Show("无可用连接！");
                }
            }
            catch (Exception exp)
            {
                LogClass.WriteLogFile("执行高压舱通道1关闭异常！" + exp.Message);
            }
            _3ReceieveMsgClass.flagOffA1 = 0;
            this.Cursor = Cursors.Default; 
        }
        /// <summary>
        /// 高压舱通道2打开的响应函数
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void chTwoOpen_Click(object sender, EventArgs e)
        {
            this.Cursor = Cursors.WaitCursor;
            _3ReceieveMsgClass.flagOnA2 = 0;
            try
            {
                LogCommand.WriteLogFile("执行高压舱通道2打开！");
                if (canBConnect.Text == "连接")
                {
                    for (int i = _1MySerClass.userList.Count - 1; i >= 0; i--)
                    {
                        _3ReceieveMsgClass ct = _1MySerClass.userList[i];
                        if (!ct.tcpClient.Connected || ((ct.tcpClient.Poll(1000, SelectMode.SelectRead)) && (ct.tcpClient.Available == 0)))
                        {
                            _1MySerClass.userList.Remove(ct);
                            continue;
                        }
                        else if (ct.nodeIP == txtBIP.Text.Trim())
                        {
                            ct.SendMessage("A$SET CH2 Open#", 2);

                            if (Delay(1))//延时10s
                            {
                                if (_3ReceieveMsgClass.flagOnA2 == 1)
                                {
                                    MessageBox.Show("执行成功！");
                                    LogCommand.WriteLogFile("执行高压舱通道2打开成功！");
                                    //this.txtACh2Status.Text = "打开";
                                    //this.txtACh2Status.BackColor = Color.DarkSeaGreen;
                                    //this.txtACh2Status.ForeColor = Color.White;

                                    //ACh2Open.Enabled = false;
                                    //ACh2Close.Enabled = true;
                                }

                                else
                                {
                                    ct.SendMessage("A$SET CH2 Open#", 2);//第二次重发
                                    Delay(2);

                                    if (_3ReceieveMsgClass.flagOnA2 == 1)
                                    {
                                        MessageBox.Show("执行成功！");
                                        LogCommand.WriteLogFile("执行高压舱通道2打开成功！");
                                        //this.txtACh2Status.Text = "打开";
                                        //this.txtACh2Status.BackColor = Color.DarkSeaGreen;
                                        //this.txtACh2Status.ForeColor = Color.White;

                                        //ACh2Open.Enabled = false;
                                        //ACh2Close.Enabled = true;
                                    }
                                    else
                                    {
                                        ct.SendMessage("A$SET CH2 Open#", 2);//第3重发
                                        Delay(2);

                                        if (_3ReceieveMsgClass.flagOnA2 == 1)
                                        {
                                            MessageBox.Show("执行成功！");
                                            LogCommand.WriteLogFile("执行高压舱通道2打开成功！");
                                            //this.txtACh2Status.Text = "打开";
                                            //this.txtACh2Status.BackColor = Color.DarkSeaGreen;
                                            //this.txtACh2Status.ForeColor = Color.White;

                                            //ACh2Open.Enabled = false;
                                            //ACh2Close.Enabled = true;
                                        }
                                        else
                                        {
                                            MessageBox.Show("执行失败！");
                                            LogCommand.WriteLogFile("执行高压舱通道2打开失败！");
                                            //ACh2Open.Enabled = true;
                                            //ACh2Close.Enabled = false;
                                            //this.txtACh2Status.Text = "打开失败";
                                            //this.txtACh2Status.ForeColor = Color.Black;
                                            //this.txtACh2Status.BackColor = Color.Yellow;
                                        }
                                    }                                    
                                }
                            }
                            break;
                        }
                        else
                        {
                            MessageBox.Show("无有效连接！");
                        }
                    }
                }
                else
                {
                    MessageBox.Show("无可用连接！");
                }
            }
            catch (Exception exp)
            {
                LogClass.WriteLogFile("执行高压舱通道2打开异常！" + exp.Message);
            }
            _3ReceieveMsgClass.flagOnA2 = 0;
            this.Cursor = Cursors.Default;
        }
        /// <summary>
        /// 高压舱通道2关闭响应函数
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void chTwoClose_Click(object sender, EventArgs e)
        {
            this.Cursor = Cursors.WaitCursor;
            _3ReceieveMsgClass.flagOffA2 = 0;
            try
            {
                LogCommand.WriteLogFile("执行高压舱通道2关闭！");
                if (canBConnect.Text == "连接")
                {
                    for (int i = _1MySerClass.userList.Count - 1; i >= 0; i--)
                    {
                        _3ReceieveMsgClass ct = _1MySerClass.userList[i];
                        if (!ct.tcpClient.Connected || ((ct.tcpClient.Poll(1000, SelectMode.SelectRead)) && (ct.tcpClient.Available == 0)))
                        {
                            _1MySerClass.userList.Remove(ct);
                            continue;
                        }
                        else if (ct.nodeIP == txtBIP.Text.Trim())
                        {
                            ct.SendMessage("A$SET CH2 Close#", 2);

                            if (Delay(1))//延时10s
                            {
                                if (_3ReceieveMsgClass.flagOffA2 == 1)
                                {
                                    MessageBox.Show("执行成功！");
                                    LogCommand.WriteLogFile("执行高压舱通道2关闭成功！");
                                    //ACh2Close.Enabled = false;
                                    //ACh2Open.Enabled = true;
                                    //this.txtACh2Status.Text = "关闭";
                                    //this.txtACh2Status.BackColor = Color.Red;
                                    //this.txtACh2Status.ForeColor = Color.White;

                                    //this.txtACh2Logo.Text = "正常";
                                    //this.txtACh2Logo.BackColor = Color.DarkSeaGreen;
                                    //this.txtACh2Logo.ForeColor = Color.White;
                                }
                                else
                                {
                                    ct.SendMessage("A$SET CH2 Close#", 2);
                                    Delay(2);

                                    if (_3ReceieveMsgClass.flagOffA2 == 1)
                                    {
                                        MessageBox.Show("执行成功！");
                                        LogCommand.WriteLogFile("执行高压舱通道2关闭成功！");
                                        //ACh2Close.Enabled = false;
                                        //ACh2Open.Enabled = true;
                                        //this.txtACh2Status.Text = "关闭";
                                        //this.txtACh2Status.BackColor = Color.Red;
                                        //this.txtACh2Status.ForeColor = Color.White;

                                        //this.txtACh2Logo.Text = "正常";
                                        //this.txtACh2Logo.BackColor = Color.DarkSeaGreen;
                                        //this.txtACh2Logo.ForeColor = Color.White;
                                    }
                                    else
                                    {
                                        ct.SendMessage("A$SET CH2 Close#", 2);
                                        Delay(2);

                                        if (_3ReceieveMsgClass.flagOffA2 == 1)
                                        {
                                            MessageBox.Show("执行成功！");
                                            LogCommand.WriteLogFile("执行高压舱通道2关闭成功！");
                                            //ACh2Close.Enabled = false;
                                            //ACh2Open.Enabled = true;
                                            //this.txtACh2Status.Text = "关闭";
                                            //this.txtACh2Status.BackColor = Color.Red;
                                            //this.txtACh2Status.ForeColor = Color.White;

                                            //this.txtACh2Logo.Text = "正常";
                                            //this.txtACh2Logo.BackColor = Color.DarkSeaGreen;
                                            //this.txtACh2Logo.ForeColor = Color.White;
                                        }
                                        else
                                        {
                                            MessageBox.Show("执行失败！");
                                            LogCommand.WriteLogFile("执行高压舱通道2关闭失败！");
                                            //this.txtACh2Status.Text = "关闭失败";
                                            //this.txtACh2Status.ForeColor = Color.Black;
                                            //this.txtACh2Status.BackColor = Color.Yellow;
                                            //ACh2Close.Enabled = true;
                                            //ACh2Open.Enabled = false;
                                        }

                                    }                                    
                                }
                            }
                            break;
                        }
                        else
                        {
                            MessageBox.Show("无有效连接！");
                        }
                    }
                }
                else
                {
                    MessageBox.Show("无可用连接！");
                }
            }
            catch (Exception exp)
            {
                LogClass.WriteLogFile("执行高压舱通道2关闭异常！" + exp.Message);
            }
            _3ReceieveMsgClass.flagOffA2 = 0;
            this.Cursor = Cursors.Default;
        }
        /// <summary>
        /// 低压舱通道1接通响应函数
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void chThreeOpen_Click(object sender, EventArgs e)
        {
            this.Cursor = Cursors.WaitCursor;
            _3ReceieveMsgClass.flagOnA1 = 0;
            try
            {
                LogCommand.WriteLogFile("执行接驳盒通道1打开！");
                if (canBConnect.Text == "连接")
                {
                    for (int i = _1MySerClass.userList.Count - 1; i >= 0; i--)
                    {
                        _3ReceieveMsgClass ct = _1MySerClass.userList[i];
                        if (!ct.tcpClient.Connected || ((ct.tcpClient.Poll(1000, SelectMode.SelectRead)) && (ct.tcpClient.Available == 0)))
                        {
                            _1MySerClass.userList.Remove(ct);
                            continue;
                        }
                        else if (ct.nodeIP == txtBIP.Text.Trim())
                        {
                            ct.SendMessage("$SET+01+SIIM1+Power12V#", 2);

                            if (Delay(1))//延时10s
                            {
                                if (_3ReceieveMsgClass.flagOnA1 == 1)
                                {
                                    MessageBox.Show("执行成功！");
                                    LogCommand.WriteLogFile("接驳盒通道1打开成功！");
                                    this.txtBCh1Status.Text = "打开";
                                    this.txtBCh1Status.BackColor = Color.DarkSeaGreen;
                                    this.txtBCh1Status.ForeColor = Color.White;

                                    Ch1Open.Enabled = false;
                                    Ch1Close.Enabled = true;
                                }
                                else
                                {
                                    ct.SendMessage("$SET+01+SIIM1+Power12V#", 2);//第二次重发
                                    Delay(2);

                                    if (_3ReceieveMsgClass.flagOnA1 == 1)
                                    {
                                        MessageBox.Show("执行成功！");
                                        LogCommand.WriteLogFile("接驳盒执行通道1打开成功！");
                                        this.txtBCh1Status.Text = "打开";
                                        this.txtBCh1Status.BackColor = Color.DarkSeaGreen;
                                        this.txtBCh1Status.ForeColor = Color.White;

                                        Ch1Open.Enabled = false;
                                        Ch1Close.Enabled = true;
                                    }
                                    else
                                    {
                                        ct.SendMessage("$SET+01+SIIM1+Power12V#", 2);//第3次重发
                                        Delay(2);
                                        if (_3ReceieveMsgClass.flagOnA1 == 1)
                                        {
                                            MessageBox.Show("执行成功！");
                                            LogCommand.WriteLogFile("接驳盒执行通道1打开成功！");
                                            this.txtBCh1Status.Text = "打开";
                                            this.txtBCh1Status.BackColor = Color.DarkSeaGreen;
                                            this.txtBCh1Status.ForeColor = Color.White;

                                            Ch1Open.Enabled = false;
                                            Ch1Close.Enabled = true;
                                        }
                                        else
                                        {
                                            MessageBox.Show("执行失败！");
                                            LogCommand.WriteLogFile("接驳盒执行通道1打开失败！");
                                            Ch1Open.Enabled = true;
                                            Ch1Close.Enabled = false;
                                            this.txtBCh1Status.Text = "打开失败";
                                            this.txtBCh1Status.ForeColor = Color.Black;
                                            this.txtBCh1Status.BackColor = Color.Yellow;
                                        }
                                    }                                   
                                }
                            }
                            break;
                        }
                        //else
                        //{
                        //    MessageBox.Show("无有效连接！");
                        //}
                    }
                }
                else
                {
                    MessageBox.Show("无可用连接！");
                }
            }
            catch (Exception exp)
            {
                LogClass.WriteLogFile("接驳盒执行通道1打开异常！" + exp.Message);
            }
            _3ReceieveMsgClass.flagOnA1 = 0;
            this.Cursor = Cursors.Default;
        }
        /// <summary>
        /// 低压舱通道1关闭响应函数
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void chThreeClose_Click(object sender, EventArgs e)
        {
            this.Cursor = Cursors.WaitCursor;
            _3ReceieveMsgClass.flagOffA1 = 0;
            try
            {
                LogCommand.WriteLogFile("执行接驳盒执行通道1关闭！");
                if (canBConnect.Text == "连接")
                {
                    for (int i = _1MySerClass.userList.Count - 1; i >= 0; i--)
                    {
                        _3ReceieveMsgClass ct = _1MySerClass.userList[i];
                        if (!ct.tcpClient.Connected || ((ct.tcpClient.Poll(1000, SelectMode.SelectRead)) && (ct.tcpClient.Available == 0)))
                        {
                            _1MySerClass.userList.Remove(ct);
                            continue;
                        }
                        else if (ct.nodeIP == txtBIP.Text.Trim())
                        {
                            ct.SendMessage("$SET+01+SIIM1+Close#", 2);

                            if (Delay(1))//延时10s
                            {
                                if (_3ReceieveMsgClass.flagOffA1 == 1)
                                {
                                    MessageBox.Show("执行成功！");
                                    LogCommand.WriteLogFile("接驳盒执行通道1关闭成功！");
                                    Ch1Close.Enabled = false;
                                    Ch1Open.Enabled = true;
                                    this.txtBCh1Status.Text = "关闭";
                                    this.txtBCh1Status.BackColor = Color.Red;
                                    this.txtBCh1Status.ForeColor = Color.White;

                                    this.txtBCh1Logo.Text = "正常";
                                    this.txtBCh1Logo.BackColor = Color.DarkSeaGreen;
                                    this.txtBCh1Logo.ForeColor = Color.White;
                                }
                                else
                                {
                                    ct.SendMessage("$SET+01+SIIM1+Close#", 2);//第二次重发
                                    Delay(2);

                                    if (_3ReceieveMsgClass.flagOffA1 == 1)
                                    {
                                        MessageBox.Show("执行成功！");
                                        LogCommand.WriteLogFile("接驳盒执行通道1关闭成功！");
                                        Ch1Close.Enabled = false;
                                        Ch1Open.Enabled = true;
                                        this.txtBCh1Status.Text = "关闭";
                                        this.txtBCh1Status.BackColor = Color.Red;
                                        this.txtBCh1Status.ForeColor = Color.White;

                                        this.txtBCh1Logo.Text = "正常";
                                        this.txtBCh1Logo.BackColor = Color.DarkSeaGreen;
                                        this.txtBCh1Logo.ForeColor = Color.White;
                                    }
                                    else
                                    {
                                        ct.SendMessage("$SET+01+SIIM1+Close#", 2);//第三次重发
                                        Delay(2);
                                        if (_3ReceieveMsgClass.flagOffA1 == 1)
                                        {
                                            MessageBox.Show("执行成功！");
                                            LogCommand.WriteLogFile("接驳盒执行通道1关闭成功！");
                                            Ch1Close.Enabled = false;
                                            Ch1Open.Enabled = true;
                                            this.txtBCh1Status.Text = "关闭";
                                            this.txtBCh1Status.BackColor = Color.Red;
                                            this.txtBCh1Status.ForeColor = Color.White;

                                            this.txtBCh1Logo.Text = "正常";
                                            this.txtBCh1Logo.BackColor = Color.DarkSeaGreen;
                                            this.txtBCh1Logo.ForeColor = Color.White;
                                        }
                                        else
                                        {
                                            MessageBox.Show("执行失败！");
                                            LogCommand.WriteLogFile("接驳盒执行通道1关闭失败！");
                                            this.txtBCh1Status.Text = "关闭失败";
                                            this.txtBCh1Status.ForeColor = Color.Black;
                                            this.txtBCh1Status.BackColor = Color.Yellow;
                                            Ch1Close.Enabled = true;
                                            Ch1Open.Enabled = false;
                                        }
                                    }                                    
                                }
                            }
                            break;
                        }
                        //else
                        //{
                        //    MessageBox.Show("无有效连接！");
                        //}
                    }
                }
                else
                {
                    MessageBox.Show("无可用连接！");
                }
            }
            catch (Exception exp)
            {
                LogClass.WriteLogFile("低压舱执行通道1关闭异常！" + exp.Message);
            }
            _3ReceieveMsgClass.flagOffA1 = 0;
            this.Cursor = Cursors.Default;
        }
        /// <summary>
        /// 低压舱通道2接通响应函数
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void chFourOpen_Click(object sender, EventArgs e)
        {
            this.Cursor = Cursors.WaitCursor;
            _3ReceieveMsgClass.flagOnA2 = 0;
            try
            {
                LogCommand.WriteLogFile("执行接驳盒执行通道2打开！");
                if (canBConnect.Text == "连接")
                {
                    for (int i = _1MySerClass.userList.Count - 1; i >= 0; i--)
                    {
                        _3ReceieveMsgClass ct = _1MySerClass.userList[i];
                        if (!ct.tcpClient.Connected || ((ct.tcpClient.Poll(1000, SelectMode.SelectRead)) && (ct.tcpClient.Available == 0)))
                        {
                            _1MySerClass.userList.Remove(ct);
                            continue;
                        }
                        else if (ct.nodeIP == txtBIP.Text.Trim())
                        {
                            ct.SendMessage("$SET+01+SIIM2+Power12V#", 2);

                            if (Delay(1))//延时10s
                            {
                                if (_3ReceieveMsgClass.flagOnA2 == 1)
                                {
                                    MessageBox.Show("执行成功！");
                                    LogCommand.WriteLogFile("接驳盒执行通道2打开成功！");
                                    this.txtBCh2Status.Text = "打开";
                                    this.txtBCh2Status.BackColor = Color.DarkSeaGreen;
                                    this.txtBCh2Status.ForeColor = Color.White;

                                    Ch2Open.Enabled = false;
                                    Ch2Close.Enabled = true;
                                }
                                else
                                {
                                    ct.SendMessage("$SET+01+SIIM2+Power12V#", 2);//第二次重发
                                    Delay(2);

                                    if (_3ReceieveMsgClass.flagOnA2 == 1)
                                    {
                                        MessageBox.Show("执行成功！");
                                        LogCommand.WriteLogFile("接驳盒执行通道2打开成功！");
                                        this.txtBCh2Status.Text = "打开";
                                        this.txtBCh2Status.BackColor = Color.DarkSeaGreen;
                                        this.txtBCh2Status.ForeColor = Color.White;

                                        Ch2Open.Enabled = false;
                                        Ch2Close.Enabled = true;
                                    }
                                    else
                                    {
                                        ct.SendMessage("$SET+01+SIIM2+Power12V#", 2);//第3次重发
                                        Delay(2);

                                        if (_3ReceieveMsgClass.flagOnA2 == 1)
                                        {
                                            MessageBox.Show("执行成功！");
                                            LogCommand.WriteLogFile("接驳盒执行通道2打开成功！");
                                            this.txtBCh2Status.Text = "打开";
                                            this.txtBCh2Status.BackColor = Color.DarkSeaGreen;
                                            this.txtBCh2Status.ForeColor = Color.White;

                                            Ch2Open.Enabled = false;
                                            Ch2Close.Enabled = true;
                                        }
                                        else
                                        {
                                            MessageBox.Show("执行失败！");
                                            LogCommand.WriteLogFile("接驳盒执行通道2打开失败！");
                                            Ch2Open.Enabled = true;
                                            Ch2Close.Enabled = false;
                                            this.txtBCh2Status.Text = "打开失败";
                                            this.txtBCh2Status.ForeColor = Color.Black;
                                            this.txtBCh2Status.BackColor = Color.Yellow;
                                        }
                                    }                                  
                                }
                            }
                            break;
                        }
                        //else
                        //{
                        //    MessageBox.Show("无有效连接！");
                        //}
                    }
                }
                else
                {
                    MessageBox.Show("无可用连接！");
                }
            }
            catch (Exception exp)
            {
                LogClass.WriteLogFile("接驳盒执行通道2打开异常！" + exp.Message);
            }
            _3ReceieveMsgClass.flagOnA2 = 0;
            this.Cursor = Cursors.Default;
        }
        /// <summary>
        /// 低压舱通道2关闭响应函数
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void chFourClose_Click(object sender, EventArgs e)
        {
            this.Cursor = Cursors.WaitCursor;
            _3ReceieveMsgClass.flagOffA2 = 0;
            try
            {
                LogCommand.WriteLogFile("执行接驳盒执行通道2关闭！");
                if (canBConnect.Text == "连接")
                {
                    for (int i = _1MySerClass.userList.Count - 1; i >= 0; i--)
                    {
                        _3ReceieveMsgClass ct = _1MySerClass.userList[i];
                        if (!ct.tcpClient.Connected || ((ct.tcpClient.Poll(1000, SelectMode.SelectRead)) && (ct.tcpClient.Available == 0)))
                        {
                            _1MySerClass.userList.Remove(ct);
                            continue;
                        }
                        else if (ct.nodeIP == txtBIP.Text.Trim())
                        {
                            ct.SendMessage("$SET+01+SIIM2+Close#", 2);

                            if (Delay(1))//延时10s
                            {
                                if (_3ReceieveMsgClass.flagOffA2 == 1)
                                {
                                    MessageBox.Show("执行成功！");
                                    LogCommand.WriteLogFile("接驳盒执行通道2关闭成功！");
                                    Ch2Close.Enabled = false;
                                    Ch2Open.Enabled = true;
                                    this.txtBCh2Status.Text = "关闭";
                                    this.txtBCh2Status.BackColor = Color.Red;
                                    this.txtBCh2Status.ForeColor = Color.White;

                                    this.txtBCh2Logo.Text = "正常";
                                    this.txtBCh2Logo.BackColor = Color.DarkSeaGreen;
                                    this.txtBCh2Logo.ForeColor = Color.White;
                                }
                                else
                                {

                                    ct.SendMessage("$SET+01+SIIM2+Close#", 2);//第二次重发
                                    Delay(2);

                                    if (_3ReceieveMsgClass.flagOffA2 == 1)
                                    {
                                        MessageBox.Show("执行成功！");
                                        LogCommand.WriteLogFile("接驳盒执行通道2关闭成功！");
                                        Ch2Close.Enabled = false;
                                        Ch2Open.Enabled = true;
                                        this.txtBCh2Status.Text = "关闭";
                                        this.txtBCh2Status.BackColor = Color.Red;
                                        this.txtBCh2Status.ForeColor = Color.White;

                                        this.txtBCh2Logo.Text = "正常";
                                        this.txtBCh2Logo.BackColor = Color.DarkSeaGreen;
                                        this.txtBCh2Logo.ForeColor = Color.White;
                                    }
                                    else
                                    {
                                        ct.SendMessage("$SET+01+SIIM2+Close#", 2);//第3次重发
                                        Delay(2);

                                        if (_3ReceieveMsgClass.flagOffA2 == 1)
                                        {
                                            MessageBox.Show("执行成功！");
                                            LogCommand.WriteLogFile("接驳盒执行通道2关闭成功！");
                                            Ch2Close.Enabled = false;
                                            Ch2Open.Enabled = true;
                                            this.txtBCh2Status.Text = "关闭";
                                            this.txtBCh2Status.BackColor = Color.Red;
                                            this.txtBCh2Status.ForeColor = Color.White;

                                            this.txtBCh2Logo.Text = "正常";
                                            this.txtBCh2Logo.BackColor = Color.DarkSeaGreen;
                                            this.txtBCh2Logo.ForeColor = Color.White;
                                        }
                                        else
                                        {
                                            MessageBox.Show("执行失败！");
                                            LogCommand.WriteLogFile("接驳盒执行通道2关闭失败！");
                                            this.txtBCh2Status.Text = "关闭失败";
                                            this.txtBCh2Status.ForeColor = Color.Black;
                                            this.txtBCh2Status.BackColor = Color.Yellow;
                                            Ch2Close.Enabled = true;
                                            Ch2Open.Enabled = false;
                                        }
                                    }                                   
                                }                                   
                            }
                            break;
                        }
                        //else
                        //{
                        //    MessageBox.Show("无有效连接！");
                        //}
                    }
                }
                else
                {
                    MessageBox.Show("无可用连接！");
                }
            }
            catch (Exception exp)
            {
                LogClass.WriteLogFile("接驳盒执行通道2关闭异常！" + exp.Message);
            }
            _3ReceieveMsgClass.flagOffA2 = 0;
            this.Cursor = Cursors.Default; 
        }
        
        
        /// <summary>
        /// 历史曲线页面-“曲线绘制”按钮响应事件
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void button6_Click(object sender, EventArgs e)
        {
            this.Cursor = Cursors.WaitCursor;
            try
            {
                //绘制曲线之前，先判断开始时间以及结束时间的先后问题，
                string picbeginTime = picStartTime.Value.ToString();//曲线绘制起始时间
                string picendTime = picEndTime.Value.ToString();//曲线绘制结束终止时间

                if (picStartTime.Value > picEndTime.Value)//起始时间延后与结束时间，两个时间互换
                {
                    string tempTime = null;
                    tempTime = picbeginTime;
                    picbeginTime = picendTime;
                    picendTime = tempTime;
                }

                switch (pictureType.Text.ToString().Trim())
                {
                    case "主接驳盒前端电压":
                        string sql1 = "select Id,fVol,saveDate from seafloor_jBHighStsData where saveDate > '" + picbeginTime + "' and saveDate < '" + picendTime + "' and isDelete = 0 order by saveDate";
                        drawTotal.drawAllLine(sql1, this,"fVol");
                        break;
                    case "主接驳盒前端电流":
                        string sql2 = "select Id,fCur,saveDate from seafloor_jBHighStsData where saveDate > '" + picbeginTime + "' and saveDate < '" + picendTime + "' and isDelete = 0 order by saveDate";
                        drawTotal.drawAllLine(sql2, this, "fCur");
                        break;
                    case "主接驳盒后端通道1电压":
                        string sql3 = "select Id,bVol1,saveDate from seafloor_jBHighStsData where saveDate > '" + picbeginTime + "' and saveDate < '" + picendTime + "' and isDelete = 0 order by saveDate";
                        drawTotal.drawAllLine(sql3, this, "bVol1");
                        break;
                    case "主接驳盒后端通道1电流":
                        string sql4 = "select Id,bCur1,saveDate from seafloor_jBHighStsData where saveDate > '" + picbeginTime + "' and saveDate < '" + picendTime + "' and isDelete = 0 order by saveDate";
                        drawTotal.drawAllLine(sql4, this, "bCur1");
                        break;
                    case "主接驳盒后端通道2电压":
                        string sql5 = "select Id,bVol2,saveDate from seafloor_jBHighStsData where saveDate > '" + picbeginTime + "' and saveDate < '" + picendTime + "' and isDelete = 0 order by saveDate";
                        drawTotal.drawAllLine(sql5, this,"bVol2");
                        break;
                    case "主接驳盒后端通道2电流":
                        string sql6 = "select Id,bCur2,saveDate from seafloor_jBHighStsData where saveDate > '" + picbeginTime + "' and saveDate < '" + picendTime + "' and isDelete = 0 order by saveDate";
                        drawTotal.drawAllLine(sql6, this, "bCur2");
                        break;
                    case "主接驳盒舱体温度":
                        string sql7 = "select Id,temp,saveDate from seafloor_jBHighStsData where saveDate > '" + picbeginTime + "' and saveDate < '" + picendTime + "' and isDelete = 0 order by saveDate";
                        drawTotal.drawAllLine(sql7, this, "temp");
                        break;
                    case "次接驳盒通道1电压":
                        string sql8 = "select Id,ch1Vol,saveDate from seafloor_jBLowStsData where saveDate > '" + picbeginTime + "' and saveDate < '" + picendTime + "' and isDelete = 0 order by saveDate";
                        drawTotal.drawAllLine(sql8, this, "ch1Vol");
                        break;
                    case "次接驳盒通道1电流":
                        string sql9 = "select Id,ch1Cur,saveDate from seafloor_jBLowStsData where saveDate > '" + picbeginTime + "' and saveDate < '" + picendTime + "' and isDelete = 0 order by saveDate";
                        drawTotal.drawAllLine(sql9, this, "ch1Cur");
                        break;
                    case "次接驳盒通道2电压":
                        string sql10 = "select Id,ch2Vol,saveDate from seafloor_jBLowStsData where saveDate > '" + picbeginTime + "' and saveDate < '" + picendTime + "' and isDelete = 0 order by saveDate";
                        drawTotal.drawAllLine(sql10, this, "ch2Vol");
                        break;
                    case "次接驳盒通道2电流":
                        string sql11 = "select Id,ch2Cur,saveDate from seafloor_jBLowStsData where saveDate > '" + picbeginTime + "' and saveDate < '" + picendTime + "' and isDelete = 0 order by saveDate";
                        drawTotal.drawAllLine(sql11, this, "ch2Cur");
                        break;
                    case "次接驳盒舱体温度":
                        string sql12 = "select Id,temp,saveDate from seafloor_jBLowStsData where saveDate > '" + picbeginTime + "' and saveDate < '" + picendTime + "' and isDelete = 0  order by saveDate";
                        drawTotal.drawAllLine(sql12, this, "temp");
                        break;
                    case "数据采集器通道1电压":
                        string sql13 = "select Id,voltage,saveDate from seafloor_srcElecData where saveDate >'" + picbeginTime + "' and saveDate < '" + picendTime + "' and statusType = '通道1电参数' and isDelete =0  order by saveDate";
                        drawTotal.drawAllLine(sql13, this, "voltage");
                        break;
                    case "数据采集器通道1电流":
                        string sql14 = "select Id,current,saveDate from seafloor_srcElecData where saveDate >'" + picbeginTime + "' and saveDate < '" + picendTime + "' and statusType = '通道1电参数' and isDelete =0  order by saveDate";
                        drawTotal.drawAllLine(sql14, this, "current");
                        break;
                    case "数据采集器通道2电压":
                        string sql15 = "select Id,voltage,saveDate from seafloor_srcElecData where saveDate >'" + picbeginTime + "' and saveDate < '" + picendTime + "' and statusType = '通道2电参数' and isDelete =0  order by saveDate";
                        drawTotal.drawAllLine(sql15, this, "voltage");
                        break;
                    case "数据采集器通道2电流":
                        string sql16 = "select Id,current,saveDate from seafloor_srcElecData where saveDate >'" + picbeginTime + "' and saveDate < '" + picendTime + "' and statusType = '通道2电参数' and isDelete =0  order by saveDate";
                        drawTotal.drawAllLine(sql16, this, "current");
                        break;
                    case "数据采集器通道3电压":
                        string sql17 = "select Id,voltage,saveDate from seafloor_srcElecData where saveDate >'" + picbeginTime + "' and saveDate < '" + picendTime + "' and statusType = '通道3电参数' and isDelete =0  order by saveDate";
                        drawTotal.drawAllLine(sql17, this, "voltage");
                        break;
                    case "数据采集器通道3电流":
                        string sql18 = "select Id,current,saveDate from seafloor_srcElecData where saveDate >'" + picbeginTime + "' and saveDate < '" + picendTime + "' and statusType = '通道3电参数' and isDelete =0  order by saveDate";
                        drawTotal.drawAllLine(sql18, this, "current");
                        break;
                    case "数据采集器通道4电压":
                        string sql19 = "select Id,voltage,saveDate from seafloor_srcElecData where saveDate >'" + picbeginTime + "' and saveDate < '" + picendTime + "' and statusType = '通道4电参数' and isDelete =0  order by saveDate";
                        drawTotal.drawAllLine(sql19, this, "voltage");
                        break;
                    case "数据采集器通道4电流":
                        string sql20 = "select Id,current,saveDate from seafloor_srcElecData where saveDate >'" + picbeginTime + "' and saveDate < '" + picendTime + "' and statusType = '通道4电参数' and isDelete =0  order by saveDate";
                        drawTotal.drawAllLine(sql20, this, "current");
                        break;
                    case "数据采集器通道5电压":
                        string sql21 = "select Id,voltage,saveDate from seafloor_srcElecData where saveDate >'" + picbeginTime + "' and saveDate < '" + picendTime + "' and statusType = '通道5电参数' and isDelete =0  order by saveDate";
                        drawTotal.drawAllLine(sql21, this, "voltage");
                        break;
                    case "数据采集器通道5电流":
                        string sql22 = "select Id,current,saveDate from seafloor_srcElecData where saveDate >'" + picbeginTime + "' and saveDate < '" + picendTime + "' and statusType = '通道5电参数' and isDelete =0  order by saveDate";
                        drawTotal.drawAllLine(sql22, this, "current");
                        break;
                    case "数据采集器舱内温度":
                        string sql23 = "select Id,temp,saveDate from seafloor_srcTempData where saveDate >'" + picbeginTime + "' and saveDate < '" + picendTime + "' and isDelete =0  order by saveDate";
                        drawTotal.drawAllLine(sql23, this, "temp");
                        break;
                    case"溶解氧":
                        string sql24 = "select Id,collectData,saveDate from seafloor_srcsensordata where saveDate >'" + picbeginTime + "' and saveDate < '" + picendTime + "' and isDelete =0 and deviceID = '0001'  order by saveDate";
                        drawTotal.drawAllLine(sql24, this, "collectData");
                        break;
                    case "PH":
                        string sql25 = "select Id,collectData,saveDate from seafloor_srcsensordata where saveDate >'" + picbeginTime + "' and saveDate < '" + picendTime + "' and isDelete =0 and deviceID = '0002'  order by saveDate";
                        drawTotal.drawAllLine(sql25, this, "collectData");
                        break;
                    case "叶绿素":
                        string sql26 = "select Id,collectData,saveDate from seafloor_srcsensordata where saveDate >'" + picbeginTime + "' and saveDate < '" + picendTime + "' and isDelete =0 and deviceID = '0003'  order by saveDate";
                        drawTotal.drawAllLine(sql26, this, "collectData");
                        break;
                    case "浊度":
                        string sql27 = "select Id,collectData1,saveDate from seafloor_srcsensordata where saveDate >'" + picbeginTime + "' and saveDate < '" + picendTime + "' and isDelete =0 and deviceID = '0003'  order by saveDate";
                        drawTotal.drawAllLine(sql27, this, "collectData1");
                        break;
                    case "CTD-温度":
                        string sql28 = "select Id,collectData1,saveDate from seafloor_srcsensordata where saveDate >'" + picbeginTime + "' and saveDate < '" + picendTime + "' and isDelete =0 and deviceID = '0004'  order by saveDate";
                        drawTotal.drawAllLine(sql28, this, "collectData1");
                        break;
                    case "CTD-盐度":
                        string sql29 = "select Id,collectData3,saveDate from seafloor_srcsensordata where saveDate >'" + picbeginTime + "' and saveDate < '" + picendTime + "' and isDelete =0 and deviceID = '0004'  order by saveDate";
                        drawTotal.drawAllLine(sql29, this, "collectData3");
                        break;
                    case "CTD-深度":
                        string sql30 = "select Id,collectData2,saveDate from seafloor_srcsensordata where saveDate >'" + picbeginTime + "' and saveDate < '" + picendTime + "' and isDelete =0 and deviceID = '0004'  order by saveDate";
                        drawTotal.drawAllLine(sql30, this, "collectData2");
                        break;
                    case "CTD-电导率":
                        string sql31 = "select Id,collectData,saveDate from seafloor_srcsensordata where saveDate >'" + picbeginTime + "' and saveDate < '" + picendTime + "' and isDelete =0 and deviceID = '0004'  order by saveDate";
                        drawTotal.drawAllLine(sql31, this, "collectData");
                        break;
                    //case "安德拉溶解氧":
                    //    string sql114 = "select id,collectdata,collectdate from sensordata where collectdate >'" + picbeginTime + "' and collectdate < '" + picendTime + "' and platname = '安德拉溶解氧' and serial = 1 order by savedate";
                    //    drawTotal.drawAllLine(sql114, this, 6);
                    //    break;
                    //case"CTD-电导率":
                    //    string sql115 = "select id,collectdata,collectdate from sensordata where collectdate >'"+picbeginTime+"' and collectdate < '"+picendTime+"' and platname = 'CTD' and serial = 1 order by savedate";
                    //    drawTotal.drawAllLine(sql115,this,18);
                    //    break;
                    //case"CTD-温度":
                    //    string sql116 = "select id,collectdata2,collectdate from sensordata where collectdate >'"+picbeginTime+"' and collectdate < '"+picendTime+"' and platname = 'CTD' and serial = 1 order by savedate";
                    //    drawTotal.drawAllLine(sql116,this,19);
                    //    break;
                    //case "CTD-深度":
                    //    string sql117 = "select id,collectdata3,collectdate from sensordata where collectdate >'"+picbeginTime+"' and collectdate < '"+picendTime+"' and platname = 'CTD' and serial = 1 order by savedate";
                    //    drawTotal.drawAllLine(sql117,this,20);
                    //    break;
                    //case "CTD-盐度":
                    //    string sql118 = "select id,collectdata4,collectdate from sensordata where collectdate >'"+picbeginTime+"' and collectdate < '"+picendTime+"' and platname = 'CTD' and serial = 1 order by savedate";
                    //    drawTotal.drawAllLine(sql118,this,21);
                    //    break;
                    //case"多参数-叶绿素":
                    //    string sql119 = "select id,collectdata,collectdate from sensordata where collectdate >'"+picbeginTime+"' and collectdate < '"+picendTime+"' and platname = '多参数' and serial = 1 order by savedate";
                    //    drawTotal.drawAllLine(sql119,this,22);
                    //    break;
                    //case"多参数-浊度":
                    //    string sql120 = "select id,collectdata2,collectdate from sensordata where collectdate >'"+picbeginTime+"' and collectdate < '"+picendTime+"' and platname = '多参数' and serial = 1 order by savedate";
                    //    drawTotal.drawAllLine(sql120,this,23);
                    //    break;
                    //case"多参数-藻红蛋白":
                    //    string sql121 = "select id,collectdata3,collectdate from sensordata where collectdate >'"+picbeginTime+"' and collectdate < '"+picendTime+"' and platname = '多参数' and serial = 1 order by savedate";
                    //    drawTotal.drawAllLine(sql121,this,24);
                    //    break;
                    //case"数据采集器通道1电压":
                    //    string sql22 = "select id,voltage,collectdate from sensorelectrical where collectdate >'" + picbeginTime + "' and collectdate < '" + picendTime + "' and sensortype = '通道1电参数' and serial = 1 order by savedate";
                    //    drawTotal.drawAllLine(sql22,this,7);
                    //    break;
                    //case"数据采集器通道1电流":
                    //    string sql23 = "select id,current,collectdate from sensorelectrical where collectdate >'" + picbeginTime + "' and collectdate < '" + picendTime + "' and sensortype = '通道1电参数' and serial = 1 order by savedate";
                    //    drawTotal.drawAllLine(sql23,this,8);
                    //    break;
                    //case "数据采集器通道2电压":
                    //    string sql24 = "select id,voltage,collectdate from sensorelectrical where collectdate >'" + picbeginTime + "' and collectdate < '" + picendTime + "' and sensortype = '通道2电参数' and serial = 1 order by savedate";
                    //    drawTotal.drawAllLine(sql24,this,9);
                    //    break;
                    //case "数据采集器通道2电流":
                    //    string sql25 = "select id,current,collectdate from sensorelectrical where collectdate >'" + picbeginTime + "' and collectdate < '" + picendTime + "' and sensortype = '通道2电参数' and serial = 1 order by savedate";
                    //    drawTotal.drawAllLine(sql25,this,10);
                    //    break;
                    //case "数据采集器通道3电压":
                    //    string sql26 = "select id,voltage,collectdate from sensorelectrical where collectdate >'" + picbeginTime + "' and collectdate < '" + picendTime + "' and sensortype = '通道3电参数' and serial = 1 order by savedate";
                    //    drawTotal.drawAllLine(sql26,this,11);
                    //    break;
                    //case "数据采集器通道3电流":
                    //    string sql27 = "select id,current,collectdate from sensorelectrical where collectdate >'" + picbeginTime + "' and collectdate < '" + picendTime + "' and sensortype = '通道3电参数' and serial = 1 order by savedate";
                    //    drawTotal.drawAllLine(sql27,this,12);
                    //    break;
                    //case "数据采集器通道4电压":
                    //    string sql28 = "select id,voltage,collectdate from sensorelectrical where collectdate >'" + picbeginTime + "' and collectdate < '" + picendTime + "' and sensortype = '通道4电参数' and serial = 1 order by savedate";
                    //    drawTotal.drawAllLine(sql28,this,13);
                    //    break;
                    //case "数据采集器通道4电流":
                    //    string sql29 = "select id,current,collectdate from sensorelectrical where collectdate >'" + picbeginTime + "' and collectdate < '" + picendTime + "' and sensortype = '通道4电参数' and serial = 1 order by savedate";
                    //    drawTotal.drawAllLine(sql29,this,14);
                    //    break;
                    //case "数据采集器通道5电压":
                    //    string sql30 = "select id,voltage,collectdate from sensorelectrical where collectdate >'" + picbeginTime + "' and collectdate < '" + picendTime + "' and sensortype = '通道5电参数' and serial = 1 order by savedate";
                    //    drawTotal.drawAllLine(sql30,this,15);
                    //    break;
                    //case "数据采集器通道5电流":
                    //    string sql31 = "select id,current,collectdate from sensorelectrical where collectdate >'" + picbeginTime + "' and collectdate < '" + picendTime + "' and sensortype = '通道5电参数' and serial = 1 order by savedate";
                    //    drawTotal.drawAllLine(sql31,this,16);
                    //    break;
                    //case"数据采集器舱内温度":
                    //    string sql32 = "select Id,statusdata,collectdate from cabinstatus where collectdate > '" + picbeginTime + "' and collectdate < '" + picendTime + "'and serial = 1 order by savedate";
                    //    drawTotal.drawAllLine(sql32,this,17);
                    //    break;
                    //case "数据采集器2通道1电压":
                    //    string sql33 = "select id,voltage,collectdate from sensorelectrical where collectdate >'" + picbeginTime + "' and collectdate < '" + picendTime + "' and sensortype = '通道1电参数' and serial = 2 order by savedate";
                    //    drawTotal.drawAllLine(sql33, this, 7);
                    //    break;
                    //case "数据采集器2通道1电流":
                    //    string sql34 = "select id,current,collectdate from sensorelectrical where collectdate >'" + picbeginTime + "' and collectdate < '" + picendTime + "' and sensortype = '通道1电参数' and serial = 2 order by savedate";
                    //    drawTotal.drawAllLine(sql34, this, 8);
                    //    break;
                    //case "数据采集器2通道2电压":
                    //    string sql35 = "select id,voltage,collectdate from sensorelectrical where collectdate >'" + picbeginTime + "' and collectdate < '" + picendTime + "' and sensortype = '通道2电参数' and serial = 2 order by savedate";
                    //    drawTotal.drawAllLine(sql35, this, 9);
                    //    break;
                    //case "数据采集器2通道2电流":
                    //    string sql36 = "select id,current,collectdate from sensorelectrical where collectdate >'" + picbeginTime + "' and collectdate < '" + picendTime + "' and sensortype = '通道2电参数' and serial = 2 order by savedate";
                    //    drawTotal.drawAllLine(sql36, this, 10);
                    //    break;
                    //case "数据采集器2通道3电压":
                    //    string sql37 = "select id,voltage,collectdate from sensorelectrical where collectdate >'" + picbeginTime + "' and collectdate < '" + picendTime + "' and sensortype = '通道3电参数' and serial = 2 order by savedate";
                    //    drawTotal.drawAllLine(sql37, this, 11);
                    //    break;
                    //case "数据采集器2通道3电流":
                    //    string sql38 = "select id,current,collectdate from sensorelectrical where collectdate >'" + picbeginTime + "' and collectdate < '" + picendTime + "' and sensortype = '通道3电参数' and serial = 2 order by savedate";
                    //    drawTotal.drawAllLine(sql38, this, 12);
                    //    break;
                    //case "数据采集器2通道4电压":
                    //    string sql39 = "select id,voltage,collectdate from sensorelectrical where collectdate >'" + picbeginTime + "' and collectdate < '" + picendTime + "' and sensortype = '通道4电参数' and serial = 2 order by savedate";
                    //    drawTotal.drawAllLine(sql39, this, 13);
                    //    break;
                    //case "数据采集器2通道4电流":
                    //    string sql40 = "select id,current,collectdate from sensorelectrical where collectdate >'" + picbeginTime + "' and collectdate < '" + picendTime + "' and sensortype = '通道4电参数' and serial = 2 order by savedate";
                    //    drawTotal.drawAllLine(sql40, this, 14);
                    //    break;
                    //case "数据采集器2通道5电压":
                    //    string sql41 = "select id,voltage,collectdate from sensorelectrical where collectdate >'" + picbeginTime + "' and collectdate < '" + picendTime + "' and sensortype = '通道5电参数' and serial = 2 order by savedate";
                    //    drawTotal.drawAllLine(sql41, this, 15);
                    //    break;
                    //case "数据采集器2通道5电流":
                    //    string sql42 = "select id,current,collectdate from sensorelectrical where collectdate >'" + picbeginTime + "' and collectdate < '" + picendTime + "' and sensortype = '通道5电参数' and serial = 2 order by savedate";
                    //    drawTotal.drawAllLine(sql42, this, 16);
                    //    break;
                    //case "数据采集器2舱内温度":
                    //    string sql43 = "select Id,statusdata,collectdate from cabinstatus where collectdate > '" + picbeginTime + "' and collectdate < '" + picendTime + "'and serial = 2 order by savedate";
                    //    drawTotal.drawAllLine(sql43, this, 17);
                    //    break;

                }
            }
            catch (Exception exp)
            {
                //MessageBox.Show("查询异常！"+exp.Message);
                LogClass.WriteLogFile("查询异常" + exp.Message);
            }
            this.Cursor = Cursors.Default; 
          
           
        }
        /// <summary>
        /// 历史曲线图片，鼠标移动label值显示
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void totalPic_MouseMove(object sender, MouseEventArgs e)
        {
            try
            {

                if (drawTotal.arrayAllData.Count == 0)
                {
                    //MessageBox.Show("溶解氧没有采集数据！");
                    //lblDO.Visible = false;
                    // lblTotal.Visible = false;
                }
                else
                {
                    int tempx, tempy;
                    //tempx = e.X;//这样得到的是鼠标的坐标值还是真实的x值数据，尤其是放大之后，鼠标点击的是否是对应放大之后的坐标值，还是x轴的真实数据          
                    //tempy = e.Y;

                    //if (tempx >= 97 && tempx <= 1247 && tempy >= 40 && tempy <= 429)
                    //{

                    tempx = e.X + totalPic.Location.X;
                    tempy = e.Y + totalPic.Location.Y;

                    Rectangle rectangle = totalPic.RectangleToScreen(this.ClientRectangle);
                    if (rectangle.Contains(MousePosition))
                    {
                        double xValue = Convert.ToDouble(totalPic.Series[0].GetHorizAxis.CalcPosPoint(tempx).ToString());
                        int xRealValue = (int)(xValue + 0.5);

                        double yRealValue = Convert.ToDouble(drawTotal.arrayAllData[xRealValue - 1]);
                        string savedate = Convert.ToString(drawTotal.arrayAllSaveTime[xRealValue - 1]);


                        //if (e.X + 229 > 1247)
                        //{
                        //    tempx = 980;
                        //}

                        //if (e.Y + 40 > 429)
                        //{
                        //    tempy = 389;
                        //}

                        //if (e.X + 229 > 1247 && e.Y + 40 > 429)
                        //{
                        //    tempx = 980;
                        //    tempy = 389;
                        //}

                        //if (e.Y - 40 < 40)
                        //    tempy = 210;

                        if (e.Location.X + totalPic.Location.X + lblTotal.Width > totalPic.Width)
                        {
                            tempx = totalPic.Width - (int)(lblTotal.Width * 1.5);
                        }

                        if (e.Location.Y + totalPic.Location.Y + lblTotal.Height > totalPic.Height)
                        {
                            tempy = totalPic.Height - lblTotal.Height;
                        }

                        if (e.Location.Y + totalPic.Location.Y - lblTotal.Height < totalPic.Location.Y)
                        {
                            tempy = totalPic.Location.Y + totalPic.Height / 2;
                        }

                        lblTotal.Text = "Time:" + savedate + "\n" + "Data:" + yRealValue;

                        lblTotal.BackColor = Color.White;
                       // lblTotal.BackColor = Color.FromArgb(234, 234, 234);
                        lblTotal.Location = new Point(tempx + 30, tempy - 60);
                        lblTotal.Visible = true;


                    }

                    else
                        lblTotal.Visible = false;

                }

            }
            catch
            {
                //MessageBox.Show("鼠标点击值出现异常！" + exp.Message);
            }
        }
        /// <summary>
        /// 鼠标点击历史曲线控件时，调试使用
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void totalPic_MouseClick(object sender, MouseEventArgs e)
        {
           
        }
        /// <summary>
        /// 双击历史曲线控件时，所有的操作将被还原
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void totalPic_MouseDoubleClick(object sender, MouseEventArgs e)
        {
            totalPic.Zoom.Undo();
        }

        private void Main_MaximumSizeChanged(object sender, EventArgs e)
        {
            if (this.WindowState != FormWindowState.Maximized)
            {
                this.WindowState = FormWindowState.Maximized;
            } 
        }
        /// <summary>
        /// 保证窗口无论在什么状态下，都能保持最大化状态
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void Main_SizeChanged(object sender, EventArgs e)
        {
            if (this.WindowState != FormWindowState.Maximized && this.WindowState != FormWindowState.Minimized)
            {
                this.WindowState = FormWindowState.Normal;
            }

            if (this.WindowState == FormWindowState.Minimized)
                this.WindowState = FormWindowState.Minimized;
        }

       
        /// <summary>
        /// 窗体关闭之后，所有线程释放
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void Main_FormClosing(object sender, FormClosingEventArgs e)
        {
            DialogResult result = MessageBox.Show("是否退出？选否，最小化到托盘", "操作提示", MessageBoxButtons.YesNoCancel, MessageBoxIcon.Question);

            if (result == DialogResult.Yes)
            {
                //if (Timer_SendSensorData != null)//化学数据上传数据库服务器定时器关闭
                //{
                //    Timer_SendSensorData.Enabled = false;
                //    Timer_SendSensorData.Close();
                //    Timer_SendSensorData.Dispose();
                //}
                //if(Timer_SendSensorStatus != null)
                //{
                //    Timer_SendSensorStatus.Enabled = false;//状态数据上传数据库服务器定时器关闭
                //    Timer_SendSensorStatus.Close();
                //    Timer_SendSensorStatus.Dispose();
                //}

                //exp.CloseSocket();

                for (int i = _1MySerClass.userList.Count - 1; i >= 0; i--)
                {
                    _3ReceieveMsgClass ct = _1MySerClass.userList[i];
                    if (!ct.tcpClient.Connected || ((ct.tcpClient.Poll(1000, SelectMode.SelectRead)) && (ct.tcpClient.Available == 0)))
                    {
                        _1MySerClass.userList.Remove(ct);
                        continue;
                    }
                    else
                    {
                        ct.CloseSocket();
                    }
                   
                }

                System.Environment.Exit(0);//彻底退出软件
            }
            else
            {
                e.Cancel = true;
                this.WindowState = FormWindowState.Minimized;
                this.Visible = true;
                this.ShowInTaskbar = true;
            }

            ClearMemory();//将所有占用的资源释放
        }


        /// <summary>
        /// 1.load函数初始化操作：主要是将1)电参数实时显示部分的字体变成类似数码管液晶字体;2)五个通道按钮状态；3）五个通道一开启软件默认是关闭状态
        /// </summary>
        /// <param name="f"></param>
        private  void initFont(Main f)
        {

            try 
            {
                //将通道按钮起始状态进行更改
                //f.ACh1Open.Enabled = true;
                //f.ACh1Close.Enabled = false;

                //f.ACh2Open.Enabled = true;
                //f.ACh2Close.Enabled = false;

                f.Ch1Open.Enabled = true;
                f.Ch1Close.Enabled = false;

                f.Ch2Open.Enabled = true;
                f.Ch2Close.Enabled = false;

                //temp注释2017.10.11
                //f.txtACh1Status.Text = "关闭";
                //f.txtACh1Status.BackColor = Color.Red;
                //f.txtACh1Status.ForeColor = Color.White;


                //f.txtACh2Status.Text = "关闭";
                //f.txtACh2Status.BackColor = Color.Red;
                //f.txtACh2Status.ForeColor = Color.White;


                //temp注释2017.10.11
                f.txtBCh1Status.Text = "关闭";
                f.txtBCh1Status.BackColor = Color.Red;
                f.txtBCh1Status.ForeColor = Color.White;

                //temp注释2017.10.11
                f.txtBCh2Status.Text = "关闭";
                f.txtBCh2Status.BackColor = Color.Red;
                f.txtBCh2Status.ForeColor = Color.White;

                //数据采集器1  通道开关状态
                f.sensorOneStatus.Text = "关闭";
                f.sensorOneStatus.BackColor = Color.Red;
                f.sensorOneStatus.ForeColor = Color.White;

                f.sensorTwoStatus.Text = "关闭";
                f.sensorTwoStatus.BackColor = Color.Red;
                f.sensorTwoStatus.ForeColor = Color.White;

                f.sensorThreeStatus.Text = "关闭";
                f.sensorThreeStatus.BackColor = Color.Red;
                f.sensorThreeStatus.ForeColor = Color.White;

                f.sensorFourStatus.Text = "关闭";
                f.sensorFourStatus.BackColor = Color.Red;
                f.sensorFourStatus.ForeColor = Color.White;

                f.sensorFiveStatus.Text = "关闭";
                f.sensorFiveStatus.BackColor = Color.Red;
                f.sensorFiveStatus.ForeColor = Color.White;

                //数据采集器1通道按钮
                f.chOneOpen.Enabled = true;
                f.chOneClose.Enabled = false;

                f.chTwoOpen.Enabled = true;
                f.chTwoClose.Enabled = false;

                f.chThreeOpen.Enabled = true;
                f.chThreeClose.Enabled = false;

                f.chFourOpen.Enabled = true;
                f.chFourClose.Enabled = false;

                f.chFiveOpen.Enabled = true;
                f.chFiveClose.Enabled = false;

                /**********************************/
                
            }
            catch(Exception exp) 
            {
                MessageBox.Show("页面初始化状态异常！"+exp.Message);
            }          
        }
        
        /// <summary>
        /// 2.Load函数初始化中对数据曲线图以及状态曲线图的初始化操作
        /// </summary>
        private void InitPicture()
        {
            

            totalPic.Chart.Aspect.View3D = false;


            //接驳盒项目增添------2017-10-13
            picACh0.Chart.Aspect.View3D = false;//关闭A舱及B舱电参数曲线3D显示效果
            picACh1.Chart.Aspect.View3D = false;
            picACh2.Chart.Aspect.View3D = false;
            picBCh1.Chart.Aspect.View3D = false;
            picBCh2.Chart.Aspect.View3D = false;
            picTemp.Chart.Aspect.View3D = false;


            //新增接驳盒项目标签隐藏----2017-10-13
            lblACh0.Visible = false;
            lblACh0B.Visible = false;


           //传感器曲线关闭图形3D显示效果
            picDO.Chart.Aspect.View3D = false;
            picPH.Chart.Aspect.View3D = false;
            picCTD.Chart.Aspect.View3D = false;
            picMultiPara.Chart.Aspect.View3D = false;


           
        }

        

        

        /*******************************额外添加的数据*******************************************/
        /// <summary>
        /// 将下位机发送过来的时间格式处理成上传数据库服务器需要的格式要求
        /// </summary>
        /// <returns></returns>
        private string dealTime(string Time)
        {
            string dataTime = null;

            char[] separator = { ':' };

            string[] splitTime = new string[7];

            splitTime = Time.Split(separator);

            for (int i = 0; i < splitTime.Length - 1; i++)
            {
                dataTime += splitTime[i];
            }

            dataTime = dataTime + '0' + splitTime[6];

            return dataTime;
        }


        /// <summary>
        /// 将下位机发送过来的时间格式处理成上传数据库服务器需要的格式要求
        /// </summary>
        /// <returns></returns>
        private string dealTime1(string Time)
        {
            string dataTime = null;

            char[] separator = { ':' };

            string[] splitTime = new string[6];

            splitTime = Time.Split(separator);

            for (int i = 0; i < splitTime.Length - 1; i++)
            {
                dataTime += splitTime[i];
            }

            //dataTime = dataTime + '0' + splitTime[6];

            return dataTime;
        }

        /// <summary>
        /// 将溶解氧数据处理成上传数据库服务器需要的格式
        /// </summary>
        /// <param name="data"></param>
        /// <returns></returns>
        private string dealDataDO(string data)
        {
            string dataDO = "00000000";
            try
            {
                //data = data.Replace("mg/L","");
                double data1 = Convert.ToDouble(data);
                data1 = data1 * 10000;

                int data2 = (int)data1 / 10;

                dataDO = data2.ToString("X8");

                return dataDO;
            }
            catch (Exception exp)
            {
                LogClass.WriteLogFile("传感器数据处理成上传数据库服务器格式异常！" + exp.Message);
                return dataDO;
            }

        }

        /// <summary>
        /// 将十六进制字符串转换成字节类型存储在数组中
        /// </summary>
        /// <param name="val"></param>
        /// <returns></returns>
        private byte[] StrToHexByte(string val)
        {
            byte[] bytes = new byte[val.Length / 2];

            for (int i = 0; i < bytes.Length; i++)
            {
                bytes[i] = Convert.ToByte(val.Substring(i * 2, 2), 16);
            }
            return bytes;
        }

        /// <summary>
        /// 将字符串转换成16进制ASCII码对应的字符串
        /// </summary>
        /// <param name="input"></param>
        /// <returns></returns>
        private string StrToASCII(string input)
        {
            StringBuilder sb = new StringBuilder(input.Length * 2);
            for (int i = 0; i < input.Length; i++)
            {
                sb.Append(((int)input[i]).ToString("X2"));
            }
            return sb.ToString();
        }


        /// <summary>
        /// 将温度数据处理成上传数据库服务器所需要的格式
        /// </summary>
        /// <param name="temperature"></param>
        /// <returns></returns>
        private string dealDataTemperature(string temperature)
        {
            // string temperature1 = temperature.Substring(1,temperature.Length - 1);
            double temperature2 = Convert.ToDouble(temperature);
            temperature2 = temperature2 * 1000;

            int temperature3 = (int)temperature2;

            string dataTemperature = temperature3.ToString("X8");

            return dataTemperature;

        }

        /// <summary>
        /// 初始化加载图形界面时将，将数据库中接驳盒电参数最新的1000个点画在采集值图上以及状态图上
        /// </summary>
        private void InitDraw()
        {

            /*界面初始化加载，接驳盒舱内五路通道参数以及温度曲线参数绘制，数据库最新1000个点*/
            //string sqlPara = " select Id,ch1Vol,ch2Vol,ch3Vol,ch4Vol,ch5Vol,ch1Cur,ch2Cur,ch3Cur,ch4Cur,ch5Cur,temp,saveDate from seafloor_jBLowStsData where isDelete = 0 order by savedate desc limit 1000";//将数据库中最新的1000个点取出来，时间最新的排在最前面
            //drawExp.drawLine(sqlPara, picACh0, picACh1, picACh2,picCh4,picCh5,picTemp,1);



            string sqlHighStsPara = "select Id,fVol,fCur,bVol1,bCur1,bVol2,bCur2,temp,saveDate from seafloor_jBHighStsData where isDelete = 0 order by saveDate desc limit 1000";
            drawExp.drawJbHighStsLine(sqlHighStsPara, picACh0, picACh1, picACh2, picTemp,1);

            string sqlLowStsPara = "select ch1Vol,ch2Vol,ch1Cur,ch2Cur,ch3Vol,ch3Cur,ch4Vol,ch4Cur,ch5Vol,ch5Cur,temp,saveDate from seafloor_jBLowStsData where isDelete = 0 order by saveDate desc limit 1000";//将次级接驳盒通道1电压、通道1电流、通道2电压、通道2电流，加入到动态数组中去
            drawExp.drawJbLowStsLine(sqlLowStsPara, picBCh1, picBCh2, picTemp, 8);
            
            draw1000flag = 1;
        }


        private void InitAddDynamic()
        {
            try
            {
                //将数据采集器的电压电流状态信息存入到动态数组中
                string sqlDCch1Info = "select current,voltage,saveDate from seafloor_srcelecdata where statusType = '通道1电参数' order by saveDate desc limit 1";//查询数据采集器通道1的电参数信息
                drawExp.addDynamicArray(sqlDCch1Info, 1);

                string sqlDCch2Info = "select current,voltage,saveDate from seafloor_srcelecdata where statusType = '通道2电参数' order by saveDate desc limit 1";//查询数据采集器通道2的电参数信息
                drawExp.addDynamicArray(sqlDCch2Info, 2);

                string sqlDCch3Info = "select current,voltage,saveDate from seafloor_srcelecdata where statusType = '通道3电参数' order by saveDate desc limit 1";//查询数据采集器通道3的电参数信息
                drawExp.addDynamicArray(sqlDCch3Info, 3);

                string sqlDCch4Info = "select current,voltage,saveDate from seafloor_srcelecdata where statusType = '通道4电参数' order by saveDate desc limit 1";//查询数据采集器通道4的电参数信息
                drawExp.addDynamicArray(sqlDCch4Info, 4);

                string sqlDCch5Info = "select current,voltage,saveDate from seafloor_srcelecdata where statusType = '通道5电参数' order by saveDate desc limit 1";//查询数据采集器通道5的电参数信息
                drawExp.addDynamicArray(sqlDCch5Info, 5);


                string sqlDCTemp = "select temp,saveDate from seafloor_srctempdata order by saveDate desc limit 1";
                drawExp.addDynamicArray(sqlDCTemp, 6);
            }
            catch(Exception exp)
            {
                LogClass.WriteLogFile("数据采集器状态信息添加到动态数组中异常！"+exp.Message);
            }
            
        }


        /// <summary>
        /// 初始化加载页面时，将传感器数据库中最新的1000个点在图形上显示
        /// </summary>
        private void InitDrawSenor()
        {
           
            string sqlDO = "select collectData,collectDate,saveDate from seafloor_srcSensorData where deviceId = 0001 and isDelete = 0 order by saveDate desc limit 1000";
            drawSensorExp.drawSensorLine(sqlDO, picDO, 1);//查询溶解氧数据


            string sqlChlTur1 = "select collectData,collectDate,saveDate from seafloor_srcSensorData where deviceId = 0003 and isDelete = 0 order by saveDate desc limit 1000";
            drawSensorExp.drawSensorLine(sqlChlTur1, picMultiPara, 2);//查询叶绿素浊度数据-叶绿素数据


            string sqlChlTur2 = "select collectData1,collectDate,saveDate from seafloor_srcSensorData where deviceId = 0003 and isDelete = 0 order by saveDate desc limit 1000";
            drawSensorExp.drawSensorLine(sqlChlTur2, picMultiPara, 3);//查询叶绿素浊度数据-浊度数据



            string sqlChlTur3 = "select collectData2,collectDate,saveDate from seafloor_srcSensorData where deviceId = 0003 and isDelete = 0 order by saveDate desc limit 1000";
            drawSensorExp.drawSensorLine(sqlChlTur3,picMultiPara,4);//查询叶绿素浊度传感器-温度数据




            string sqlCTD = "select collectData,collectDate,saveDate from seafloor_srcSensorData where deviceId = 0004 and isDelete = 0 order by saveDate desc limit 1000";//CTD-电导率
            drawSensorExp.drawSensorLine(sqlCTD, picCTD, 5);

            string sqlCTD2 = "select collectData1,collectDate,saveDate from seafloor_srcSensorData where deviceId = 0004 and isDelete = 0 order by saveDate desc limit 1000";//CTD-温度
            drawSensorExp.drawSensorLine(sqlCTD2, picCTD, 6);

            string sqlCTD3 = "select collectData2,collectDate,saveDate from seafloor_srcSensorData where deviceId = 0004 and isDelete = 0 order by saveDate desc limit 1000";//CTD-深度
            drawSensorExp.drawSensorLine(sqlCTD3, picCTD, 7);

            string sqlCTD4 = "select collectData3,collectDate,saveDate from seafloor_srcSensorData where deviceId = 0004 and isDelete = 0 order by saveDate desc limit 1000";//CTD-盐度
            drawSensorExp.drawSensorLine(sqlCTD4, picCTD, 8);


            string sqlPh = "select collectData,collectDate,saveDate from seafloor_srcSensorData where deviceId = 0002 and isDelete = 0 order by saveDate desc limit 1000";//PH
            drawSensorExp.drawSensorLine(sqlPh, picPH, 9);





            draw1000SensorFlag = 1;


        }


        /// <summary>
        /// 高压仓通道1上电点击相应的按钮执行指令，还得用之前建立的连接，返回回去
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void button4_Click(object sender, EventArgs e)
        {
            this.Cursor = Cursors.WaitCursor;
            try
            {
                if (canBConnect.Text == "连接")
                {
                    for (int i = _1MySerClass.userList.Count - 1; i >= 0; i--)
                    {
                        _3ReceieveMsgClass ct = _1MySerClass.userList[i];
                        if (!ct.tcpClient.Connected || ((ct.tcpClient.Poll(1000, SelectMode.SelectRead)) && (ct.tcpClient.Available == 0)))
                        {
                            _1MySerClass.userList.Remove(ct);
                            continue;
                        }
                        else if (ct.nodeIP == txtBIP.Text.Trim())
                        {
                            ct.SendMessage("A$SET CH1 Open#", 2);

                            //Thread.Sleep(10000);延时函数不能使用能导致系统休眠的时间

                            if (Delay(1))//延时10s
                            {
                                if (_3ReceieveMsgClass.flagOnA1 == 1)
                                    MessageBox.Show("执行成功！");
                                else
                                    MessageBox.Show("执行失败！");
                            }                          
                            break;
                        }
                        else
                        {
                            MessageBox.Show("无有效连接！");
                        }
                    }
                }
                else
                {
                    MessageBox.Show("无可用连接！");
                }

            }
            catch(Exception exp)
            {
                LogClass.WriteLogFile("测试指令异常！"+exp.Message);
            }

            _3ReceieveMsgClass.flagOnA1 = 0;

            this.Cursor = Cursors.Default;
            
            
        }

        private void button7_Click(object sender, EventArgs e)
        {
            this.Cursor = Cursors.WaitCursor;
            try
            {
                if (canBConnect.Text == "连接")
                {
                    for (int i = _1MySerClass.userList.Count - 1; i >= 0; i--)
                    {
                        _3ReceieveMsgClass ct = _1MySerClass.userList[i];
                        if (!ct.tcpClient.Connected || ((ct.tcpClient.Poll(1000, SelectMode.SelectRead)) && (ct.tcpClient.Available == 0)))
                        {
                            _1MySerClass.userList.Remove(ct);
                            continue;
                        }
                        else if (ct.nodeIP == txtBIP.Text.Trim())
                        {
                            ct.SendMessage("s3", 2);
                        }
                        else
                        {
                            MessageBox.Show("无有效连接！");
                        }
                    }
                }
                else
                {
                    MessageBox.Show("无可用连接！");
                }

            }
            catch (Exception exp)
            {
                LogClass.WriteLogFile("测试指令异常！" + exp.Message);
            }

            this.Cursor = Cursors.Default;
        }

        private void button8_Click(object sender, EventArgs e)
        {
            this.Cursor = Cursors.WaitCursor;
            try
            {
                if (canBConnect.Text == "连接")
                {
                    for (int i = _1MySerClass.userList.Count - 1; i >= 0; i--)
                    {
                        _3ReceieveMsgClass ct = _1MySerClass.userList[i];
                        if (!ct.tcpClient.Connected || ((ct.tcpClient.Poll(1000, SelectMode.SelectRead)) && (ct.tcpClient.Available == 0)))
                        {
                            _1MySerClass.userList.Remove(ct);
                            continue;
                        }
                        else if (ct.nodeIP == txtBIP.Text.Trim())
                        {
                            ct.SendMessage("m2", 2);
                        }
                        else
                        {
                            MessageBox.Show("无有效连接！");
                        }
                    }
                }
                else
                {
                    MessageBox.Show("无可用连接！");
                }

            }
            catch (Exception exp)
            {
                LogClass.WriteLogFile("测试指令异常！" + exp.Message);
            }

            this.Cursor = Cursors.Default;
        }

        private void button9_Click(object sender, EventArgs e)
        {
            for (int i = _1MySerClass.userList.Count - 1; i >= 0; i--)
            {
                _3ReceieveMsgClass ct = _1MySerClass.userList[i];
                //if (!ct.tcpClient.Connected || ((ct.tcpClient.Poll(1000, SelectMode.SelectRead)) && (ct.tcpClient.Available == 0)))
                //{
                //    _1MySerClass.userList.Remove(ct);
                //    continue;
                //}
                //else 
                //{
                    ct.CloseSocket();
                //}
                
            }
        }

        private void button10_Click(object sender, EventArgs e)
        {
            this.Cursor = Cursors.WaitCursor;
            try
            {
                if (canBConnect.Text == "连接")
                {
                    for (int i = _1MySerClass.userList.Count - 1; i >= 0; i--)
                    {
                        _3ReceieveMsgClass ct = _1MySerClass.userList[i];
                        if (!ct.tcpClient.Connected || ((ct.tcpClient.Poll(1000, SelectMode.SelectRead)) && (ct.tcpClient.Available == 0)))
                        {
                            _1MySerClass.userList.Remove(ct);
                            continue;
                        }
                        else if (ct.nodeIP == txtBIP.Text.Trim())
                        {
                            ct.SendMessage("m3", 2);
                            break;
                        }
                        else
                        {
                            MessageBox.Show("无有效连接！");
                        }
                    }
                }
                else
                {
                    MessageBox.Show("无可用连接！");
                }

            }
            catch (Exception exp)
            {
                LogClass.WriteLogFile("测试指令异常！" + exp.Message);
            }

            this.Cursor = Cursors.Default;
        }
        /// <summary>
        /// 高压仓通道1关闭操作
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void button11_Click(object sender, EventArgs e)
        {
            this.Cursor = Cursors.WaitCursor;
            try
            {
                if (canBConnect.Text == "连接")
                {
                    for (int i = _1MySerClass.userList.Count - 1; i >= 0; i--)
                    {
                        _3ReceieveMsgClass ct = _1MySerClass.userList[i];
                        if (!ct.tcpClient.Connected || ((ct.tcpClient.Poll(1000, SelectMode.SelectRead)) && (ct.tcpClient.Available == 0)))
                        {
                            _1MySerClass.userList.Remove(ct);
                            continue;
                        }
                        else if (ct.nodeIP == txtBIP.Text.Trim())
                        {
                            ct.SendMessage("A$SET CH1 Close#", 2);

                            if (Delay(1))//延时10s
                            {
                                if (_3ReceieveMsgClass.flagOffA1 == 1)
                                    MessageBox.Show("执行成功！");
                                else
                                    MessageBox.Show("执行失败！");
                            }
                            break;                         
                        }
                        else
                        {
                            MessageBox.Show("无有效连接！");
                        }
                    }                   
                }
                else
                {
                    MessageBox.Show("无可用连接！");
                }

            }
            catch (Exception exp)
            {
                LogClass.WriteLogFile("测试指令异常！" + exp.Message);
            }
            _3ReceieveMsgClass.flagOffA1 = 0;
            this.Cursor = Cursors.Default;
        }
        /// <summary>
        /// 高压仓通道2打开
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void button7_Click_1(object sender, EventArgs e)
        {
            this.Cursor = Cursors.WaitCursor;
            try
            {
                if (canBConnect.Text == "连接")
                {
                    for (int i = _1MySerClass.userList.Count - 1; i >= 0; i--)
                    {
                        _3ReceieveMsgClass ct = _1MySerClass.userList[i];
                        if (!ct.tcpClient.Connected || ((ct.tcpClient.Poll(1000, SelectMode.SelectRead)) && (ct.tcpClient.Available == 0)))
                        {
                            _1MySerClass.userList.Remove(ct);
                            continue;
                        }
                        else if (ct.nodeIP == txtBIP.Text.Trim())
                        {
                            ct.SendMessage("A$SET CH2 Open#", 2);

                            if (Delay(1))//延时10s
                            {
                                if (_3ReceieveMsgClass.flagOnA2 == 1)
                                    MessageBox.Show("执行成功！");
                                else
                                    MessageBox.Show("执行失败！");
                            }

                            break;
                        }
                        else
                        {
                            MessageBox.Show("无有效连接！");
                        }
                    }
                }
                else
                {
                    MessageBox.Show("无可用连接！");
                }

            }
            catch (Exception exp)
            {
                LogClass.WriteLogFile("测试指令异常！" + exp.Message);
            }
            _3ReceieveMsgClass.flagOnA2 = 0;
            this.Cursor = Cursors.Default;
        }
        /// <summary>
        /// 高压仓通道2关闭
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void button8_Click_1(object sender, EventArgs e)
        {
            this.Cursor = Cursors.WaitCursor;
            try
            {
                if (canBConnect.Text == "连接")
                {
                    for (int i = _1MySerClass.userList.Count - 1; i >= 0; i--)
                    {
                        _3ReceieveMsgClass ct = _1MySerClass.userList[i];
                        if (!ct.tcpClient.Connected || ((ct.tcpClient.Poll(1000, SelectMode.SelectRead)) && (ct.tcpClient.Available == 0)))
                        {
                            _1MySerClass.userList.Remove(ct);
                            continue;
                        }
                        else if (ct.nodeIP == txtBIP.Text.Trim())
                        {
                            ct.SendMessage("A$SET CH2 Close#", 2);

                            if (Delay(1))//延时10s
                            {
                                if (_3ReceieveMsgClass.flagOffA2 == 1)
                                    MessageBox.Show("执行成功！");
                                else
                                    MessageBox.Show("执行失败！");
                            }

                            break;
                        }
                        else
                        {
                            MessageBox.Show("无有效连接！");
                        }
                    }
                }
                else
                {
                    MessageBox.Show("无可用连接！");
                }

            }
            catch (Exception exp)
            {
                LogClass.WriteLogFile("测试指令异常！" + exp.Message);
            }
            _3ReceieveMsgClass.flagOffA2 = 0;
            this.Cursor = Cursors.Default;
        }
       
        
       

        ///// <summary>
        ///// 设置开机自动启用
        ///// </summary>
        //private void SetAutoStart()
        //{
        //    try
        //    {
        //        string regPath = "SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Run";
        //        string path = Application.ExecutablePath.ToLower(); //将当前程序起动路径
        //        string name = Path.GetFileName(path);  //获得应用程序名称
        //        var regKey = Microsoft.Win32.Registry.LocalMachine.OpenSubKey(regPath, true);
        //        if (regKey == null) regKey = Microsoft.Win32.Registry.LocalMachine.CreateSubKey(regPath);
        //        regKey.SetValue(name, path);
        //    }
        //    catch
        //    {
        //    }
        //}




        public static bool Delay(int delayTime)
        {
            DateTime now = DateTime.Now;
            int s;
            do
            {
                TimeSpan spand = DateTime.Now - now;
                s = spand.Seconds;
                Application.DoEvents();
            }
            while (s < delayTime);
            return true;

        }     
        /// <summary>
        /// 主接驳盒通道1曲线控件双击放大还原函数
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void picACh1_DoubleClick(object sender, EventArgs e)
        {
            if (changedACh1)
            {
                //pnlACh1V.Visible = false;//picACh1控件下面的panel控件隐藏

                //lblACh1.Visible = true;

                picACh0.Zoom.Undo();//撤销缩放
                lblACh0B.Visible = false;
                changedACh1 = false;
                TabLPnlStatus.Controls.Add(picACh0);
                picACh0.Parent = pnlACh1V;

                picACh0.Dock = DockStyle.Fill;

                

                TabLPnlStatus.Show();

               // pnlACh1V.Show();
            }
            else
            {
                picACh0.Zoom.Undo();//撤销缩放
                changedACh1 = true;
                TabLPnlStatus.Controls.Remove(picACh0);
                picACh0.Parent = this;
                picACh0.BringToFront();

                TabLPnlStatus.Controls.Remove(lblACh0B);
                lblACh0B.Parent = this;
                lblACh0B.BringToFront();


                //增加改变坐标轴显示范围的按钮
                TabLPnlStatus.Controls.Remove(button8);
                button8.Parent = picACh0;
                button8.BringToFront();


                picACh0.Dock = DockStyle.Fill;

                TabLPnlStatus.Hide();

            }
        }
        /// <summary>
        /// 主接驳盒高压舱电参数曲线随着鼠标移动显示标签
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void picACh1_MouseMove(object sender, MouseEventArgs e)
        {
            try
            {                
                lblACh1.Visible = false;
                lblBCh1.Visible = false;
                lblBCh2.Visible = false;
                lblACh2.Visible = false;
                lblTemp.Visible = false;
                if (changedACh1 == false)
                {
                    if (draw.arrayHCh0Cur.Count == 0)
                    {
                        lblACh0.Visible = false;
                    }
                    else
                    {

                        int tempx, tempy;
                        tempx = e.X + picACh0.Location.X;//这样得到的是鼠标的坐标值还是真实的x值数据，尤其是放大之后，鼠标点击的是否是对应放大之后的坐标值，还是x轴的真实数据          
                        tempy = e.Y + picACh0.Location.Y;

                        Rectangle rectangle = picACh0.RectangleToClient(this.ClientRectangle);
                        if (rectangle.Contains(MousePosition))
                        {
                            
                            double xCurrentValue = Convert.ToDouble(picACh0.Series[0].GetHorizAxis.CalcPosPoint(tempx).ToString());//电流对应的x值
                            //double xVoltageValue = Convert.ToDouble(tctDO.Series[1].GetHorizAxis.CalcPosPoint(tempx).ToString());//电压对应的x值

                            int xRealCurrentValue = (int)(xCurrentValue + 0.5);


                            string savedate = Convert.ToString(draw.arrayHSaveDate[xRealCurrentValue - 1]);//得到采集时间

                            if (e.Location.X + picACh0.Location.X + lblACh0.Width > picACh0.Width)
                            {
                                tempx = picACh0.Width - (int)(lblACh0.Width * 1.5);
                            }

                            if (e.Location.Y + picACh0.Location.Y + lblACh0.Height > picACh0.Height)
                            {
                                tempy = picACh0.Height - (lblACh0.Height);
                            }

                            if (e.Location.Y + picACh0.Location.Y - lblACh0.Height < picACh0.Location.Y)
                            {
                                tempy = picACh0.Location.Y + picACh0.Height / 2;
                            }


                            double yRealCurrentValue = Convert.ToDouble(draw.arrayHCh0Cur[xRealCurrentValue - 1]);//通道1实际电流值


                            //int xRealVoltageValue = (int)(xVoltageValue + 0.5);
                            double yRealVoltageValue = Convert.ToDouble(draw.arrayHCh1Vol[xRealCurrentValue - 1]);

                            if (draw.arrayHCh0Cur.Count <= 1000)
                            {
                                savedate = Convert.ToString(draw.arrayHSaveDate[xRealCurrentValue - 1]);
                                yRealCurrentValue = Convert.ToDouble(draw.arrayHCh0Cur[xRealCurrentValue - 1]);
                                yRealVoltageValue = Convert.ToDouble(draw.arrayHCh0Vol[xRealCurrentValue - 1]);
                            }
                            else
                            {
                                savedate = Convert.ToString(draw.arrayHSaveDate[xRealCurrentValue - 1 + draw.arrayHSaveDate.Count - 1000]);
                                yRealCurrentValue = Convert.ToDouble(draw.arrayHCh0Cur[xRealCurrentValue - 1 + draw.arrayHCh0Cur.Count - 1000]);
                                yRealVoltageValue = Convert.ToDouble(draw.arrayHCh0Vol[xRealCurrentValue - 1 + draw.arrayHCh0Vol.Count - 1000]);
                            }

                            lblACh0.Text = "Time:" + savedate + "\n" + "Current:" + yRealCurrentValue + "A" + "\n" + "Voltage:" + yRealVoltageValue + "V";
                            lblACh0.Location = new Point(tempx + 30, tempy - 60);
                            lblACh0.Visible = true;
                            lblACh0.BackColor = Color.FromArgb(234, 234, 234);
                            //lblACh1.BackColor = Color.White;
                        }
                        else
                        {
                            lblACh0.Visible = false;
                        }

                    }
                }
                else
                {

                    if (draw.arrayHCh0Cur.Count == 0)
                    {
                        lblACh0B.Visible = false;
                    }
                    else
                    {

                        int tempx, tempy;                        
                        tempx = e.Location.X + picACh0.Location.X;
                        tempy = e.Location.Y + picACh0.Location.Y;

                        Rectangle rectangle1 = picACh0.RectangleToScreen(this.ClientRectangle);
                        if (rectangle1.Contains(MousePosition))
                        {                   
                            double xCurrentValue = Convert.ToDouble(picACh0.Series[0].GetHorizAxis.CalcPosPoint(tempx).ToString());//电流对应的x值                         
                            int xRealCurrentValue = (int)(xCurrentValue + 0.5);


                            string savedate = Convert.ToString(draw.arrayHSaveDate[xRealCurrentValue - 1]);

                            if (e.Location.X + picACh0.Location.X + lblACh0B.Width > picACh0.Width)
                            {
                                tempx = picACh0.Width - (int)(lblACh0B.Width * 2);
                            }

                            if (e.Location.Y + picACh0.Location.Y + lblACh0B.Height > picACh0.Height)
                            {
                                tempy = picACh0.Height - lblACh0B.Height;
                            }

                            if (e.Location.Y + picACh0.Location.Y - lblACh0B.Height < picACh0.Location.Y)
                            {
                                tempy = picACh0.Location.Y + 3*lblACh0B.Height ;
                            }


                            double yRealCurrentValue = Convert.ToDouble(draw.arrayHCh0Cur[xRealCurrentValue - 1]);


                            int xRealVoltageValue = (int)(xCurrentValue + 0.5);
                            double yRealVoltageValue = Convert.ToDouble(draw.arrayHCh0Vol[xRealVoltageValue - 1]);


                            if (draw.arrayHCh0Cur.Count <= 1000)
                            {
                                savedate = Convert.ToString(draw.arrayHSaveDate[xRealCurrentValue - 1]);
                                yRealCurrentValue = Convert.ToDouble(draw.arrayHCh0Cur[xRealCurrentValue - 1]);
                                yRealVoltageValue = Convert.ToDouble(draw.arrayHCh0Vol[xRealVoltageValue - 1]);
                            }
                            else
                            {
                                savedate = Convert.ToString(draw.arrayHSaveDate[xRealCurrentValue - 1 + draw.arrayHSaveDate.Count - 1000]);
                                yRealCurrentValue = Convert.ToDouble(draw.arrayHCh0Cur[xRealCurrentValue - 1 + draw.arrayHCh0Cur.Count - 1000]);
                                yRealVoltageValue = Convert.ToDouble(draw.arrayHCh0Vol[xRealVoltageValue - 1 + draw.arrayHCh0Vol.Count - 1000]);
                            }


                            lblACh0B.Text = "Time:" + savedate + "\n" + "Current:" + yRealCurrentValue + "A" + "\n" + "Voltage:" + yRealVoltageValue + "V";
                            lblACh0B.Location = new Point(tempx + 30, tempy - 80);
                            lblACh0B.Visible = true;
                            lblACh0B.BackColor = Color.FromArgb(234, 234, 234);
                            //lblACh1B.BackColor = Color.White;


                        }
                        else
                        {
                            lblACh0B.Visible = false;
                        }

                    }
                }

            }
            catch
            {
                //MessageBox.Show("鼠标点击值出现异常！" + exp.Message);
            }
        }
        /// <summary>
        /// 双击picACh2控件进行放大
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void picACh2_DoubleClick(object sender, EventArgs e)
        {
            if (changedACh2)
            {
              

                picACh1.Zoom.Undo();//撤销缩放
                lblACh1B.Visible = false;
                changedACh2 = false;
                TabLPnlStatus.Controls.Add(picACh1);
                picACh1.Parent = pnlACh1C;
                picACh1.Dock = DockStyle.Fill;



                TabLPnlStatus.Show();

                // pnlACh1V.Show();
            }
            else
            {
                picACh1.Zoom.Undo();//撤销缩放
                changedACh2 = true;
                TabLPnlStatus.Controls.Remove(picACh1);
                picACh1.Parent = this;
                picACh1.BringToFront();

                TabLPnlStatus.Controls.Remove(lblACh1B);
                lblACh1B.Parent = this;
                lblACh1B.BringToFront();


                //主接驳盒通道2放大后增加更改坐标轴显示范围的按钮
                TabLPnlStatus.Controls.Remove(button9);
                button9.Parent = picACh1;
                button9.BringToFront();


                picACh1.Dock = DockStyle.Fill;

                TabLPnlStatus.Hide();

            }
        }
        /// <summary>
        /// 鼠标在控件picACh2进行移动，label标签移动显示
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void picACh2_MouseMove(object sender, MouseEventArgs e)
        {
            try
            {
                //currentJW.Visible = false;
                //currentYLS.Visible = false;
                //currentZD.Visible = false;
                //currentCDOM.Visible = false;
                lblACh0.Visible = false;
                lblBCh1.Visible = false;
                lblBCh2.Visible = false;
                lblACh2.Visible = false;
                lblTemp.Visible = false;

                if (changedACh2 == false)
                {
                    if (draw.arrayHCh1Cur.Count == 0)
                    {
                        lblACh1.Visible = false;
                    }
                    else
                    {

                        int tempx, tempy;
                        tempx = e.X + picACh1.Location.X;//这样得到的是鼠标的坐标值还是真实的x值数据，尤其是放大之后，鼠标点击的是否是对应放大之后的坐标值，还是x轴的真实数据          
                        tempy = e.Y + picACh1.Location.Y;

                        Rectangle rectangle = picACh0.RectangleToClient(this.ClientRectangle);
                        if (rectangle.Contains(MousePosition))
                        {

                            double xCurrentValue = Convert.ToDouble(picACh1.Series[0].GetHorizAxis.CalcPosPoint(tempx).ToString());//电流对应的x值
                            //double xVoltageValue = Convert.ToDouble(tctDO.Series[1].GetHorizAxis.CalcPosPoint(tempx).ToString());//电压对应的x值

                            int xRealCurrentValue = (int)(xCurrentValue + 0.5);


                            string savedate = Convert.ToString(draw.arrayHSaveDate[xRealCurrentValue - 1]);//得到采集时间

                            if (e.Location.X + lblACh1.Width > picACh1.Width)
                            {
                                tempx = picACh1.Width - (int)(lblACh1.Width * 1.5);
                            }

                            if (e.Location.Y + picACh1.Location.Y + lblACh1.Height > picACh1.Height)
                            {
                                tempy = picACh1.Height - (lblACh1.Height);
                            }

                            if (e.Location.Y + picACh1.Location.Y - lblACh1.Height < picACh1.Location.Y)
                            {
                                tempy = picACh1.Location.Y + picACh1.Height / 2;
                            }


                            double yRealCurrentValue = Convert.ToDouble(draw.arrayHCh1Cur[xRealCurrentValue - 1]);//通道1实际电流值


                            //int xRealVoltageValue = (int)(xVoltageValue + 0.5);
                            double yRealVoltageValue = Convert.ToDouble(draw.arrayHCh1Vol[xRealCurrentValue - 1]);

                            if (draw.arrayHCh1Cur.Count <= 1000)
                            {
                                savedate = Convert.ToString(draw.arrayHSaveDate[xRealCurrentValue - 1]);
                                yRealCurrentValue = Convert.ToDouble(draw.arrayHCh1Cur[xRealCurrentValue - 1]);
                                yRealVoltageValue = Convert.ToDouble(draw.arrayHCh1Vol[xRealCurrentValue - 1]);
                            }
                            else
                            {
                                savedate = Convert.ToString(draw.arrayHSaveDate[xRealCurrentValue - 1 + draw.arrayHSaveDate.Count - 1000]);
                                yRealCurrentValue = Convert.ToDouble(draw.arrayHCh1Cur[xRealCurrentValue - 1 + draw.arrayHCh1Cur.Count - 1000]);
                                yRealVoltageValue = Convert.ToDouble(draw.arrayHCh1Vol[xRealCurrentValue - 1 + draw.arrayHCh1Vol.Count - 1000]);
                            }

                            lblACh1.Text = "Time:" + savedate + "\n" + "Current:" + yRealCurrentValue + "A" + "\n" + "Voltage:" + yRealVoltageValue + "V";
                            lblACh1.Location = new Point(tempx + 30 + picACh1.Location.X, tempy - 60);
                            lblACh1.Visible = true;
                            lblACh1.BackColor = Color.FromArgb(234, 234, 234);
                           // lblACh2.BackColor = Color.White;
                        }
                        else
                        {
                            lblACh1.Visible = false;
                        }

                    }
                }
                else
                {

                    if (draw.arrayHCh1Cur.Count == 0)
                    {
                        lblACh1B.Visible = false;
                    }
                    else
                    {

                        int tempx, tempy;
                        tempx = e.Location.X + picACh0.Location.X;
                        tempy = e.Location.Y + picACh0.Location.Y;

                        Rectangle rectangle1 = picACh1.RectangleToScreen(this.ClientRectangle);
                        if (rectangle1.Contains(MousePosition))
                        {

                            double xCurrentValue = Convert.ToDouble(picACh1.Series[0].GetHorizAxis.CalcPosPoint(tempx).ToString());//电流对应的x值
                            double xVoltageValue = Convert.ToDouble(picACh1.Series[1].GetHorizAxis.CalcPosPoint(tempx).ToString());//电压对应的x值

                            int xRealCurrentValue = (int)(xCurrentValue + 0.5);


                            string savedate = Convert.ToString(draw.arrayHSaveDate[xRealCurrentValue - 1]);

                            if (e.Location.X + picACh1.Location.X + lblACh1B.Width > picACh1.Width)
                            {
                                tempx = picACh1.Width - (int)(lblACh1B.Width * 2);
                            }

                            if (e.Location.Y + picACh1.Location.Y + lblACh1B.Height > picACh1.Height)
                            {
                                tempy = picACh1.Height - lblACh1B.Height;
                            }

                            if (e.Location.Y + picACh1.Location.Y - lblACh1B.Height < picACh1.Location.Y)
                            {
                                tempy = picACh1.Location.Y + picACh1.Height / 4;
                            }

                            double yRealCurrentValue = Convert.ToDouble(draw.arrayHCh1Cur[xRealCurrentValue - 1]);


                            int xRealVoltageValue = (int)(xVoltageValue + 0.5);
                            double yRealVoltageValue = Convert.ToDouble(draw.arrayHCh1Vol[xRealVoltageValue - 1]);

                            if (draw.arrayHCh1Cur.Count <= 1000)
                            {
                                savedate = Convert.ToString(draw.arrayHSaveDate[xRealCurrentValue - 1]);
                                yRealCurrentValue = Convert.ToDouble(draw.arrayHCh1Cur[xRealCurrentValue - 1]);
                                yRealVoltageValue = Convert.ToDouble(draw.arrayHCh1Vol[xRealVoltageValue - 1]);
                            }
                            else
                            {
                                savedate = Convert.ToString(draw.arrayHSaveDate[xRealCurrentValue - 1 + draw.arrayHSaveDate.Count - 1000]);
                                yRealCurrentValue = Convert.ToDouble(draw.arrayHCh1Cur[xRealCurrentValue - 1 + draw.arrayHCh1Cur.Count - 1000]);
                                yRealVoltageValue = Convert.ToDouble(draw.arrayHCh1Vol[xRealVoltageValue - 1 + draw.arrayHCh1Vol.Count - 1000]);
                            }


                            lblACh1B.Text = "Time:" + savedate + "\n" + "Current:" + yRealCurrentValue + "A" + "\n" + "Voltage:" + yRealVoltageValue + "V";
                            lblACh1B.Location = new Point(tempx + 30, tempy - 10);
                            lblACh1B.Visible = true;
                            lblACh1B.BackColor = Color.FromArgb(234, 234, 234);
                           // lblACh2B.BackColor = Color.White;


                        }
                        else
                        {
                            lblACh1B.Visible = false;
                        }

                    }
                }

            }
            catch
            {
                //MessageBox.Show("鼠标点击值出现异常！" + exp.Message);
            }
        }
        /// <summary>
        /// 双击B舱通道1画图控件使其放大或者还原
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>    
        private void picBCh1_DoubleClick(object sender, EventArgs e)
        {
            if (changedBCh1)
            {
               
                picBCh1.Zoom.Undo();//撤销缩放
                lblBCh1B.Visible = false;
                changedBCh1 = false;
                TabLPnlStatus.Controls.Add(picBCh1);
                picBCh1.Parent = pnlBCh1V;
                picBCh1.Dock = DockStyle.Fill;

                TabLPnlStatus.Show();

            }
            else
            {
                picBCh1.Zoom.Undo();//撤销缩放
                changedBCh1 = true;
                TabLPnlStatus.Controls.Remove(picBCh1);
                picBCh1.Parent = this;
                picBCh1.BringToFront();

                TabLPnlStatus.Controls.Remove(lblBCh1B);
                lblBCh1B.Parent = this;
                lblBCh1B.BringToFront();


                TabLPnlStatus.Controls.Remove(button11);
                button11.Parent = picBCh1;
                button11.BringToFront();


                picBCh1.Dock = DockStyle.Fill;

                TabLPnlStatus.Hide();

            }
        }
        /// <summary>
        /// 鼠标在B舱通道1画图控件上移动，有指示标签随着鼠标移动而移动
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void picBCh1_MouseMove(object sender, MouseEventArgs e)
        {
            try
            {
                lblACh0.Visible = false;
                lblACh1.Visible = false;
                lblBCh2.Visible = false;
                lblACh2.Visible = false;
                lblTemp.Visible = false;
                if (changedBCh1 == false)
                {
                    if (draw.arrayLCh1Cur.Count == 0)
                    {
                        lblBCh1.Visible = false;
                    }
                    else
                    {

                        int tempx, tempy;
                        tempx = e.X + picACh0.Location.X;
                        tempy = e.Y + picACh0.Location.Y;

                        Rectangle rectangle1 = picBCh1.RectangleToScreen(this.ClientRectangle);
                        if (rectangle1.Contains(MousePosition))
                        {

                            double xCurrentValue = Convert.ToDouble(picBCh1.Series[0].GetHorizAxis.CalcPosPoint(tempx).ToString());//电流对应的x值
                            double xVoltageValue = Convert.ToDouble(picBCh1.Series[1].GetHorizAxis.CalcPosPoint(tempx).ToString());//电压对应的x值

                            int xRealCurrentValue = (int)(xCurrentValue + 0.5);


                            string savedate = Convert.ToString(draw.arrayLSaveDate[xRealCurrentValue - 1]);

                            if (e.Location.X + picACh0.Location.X + lblBCh1.Width > picBCh1.Width)
                            {
                                tempx = picBCh1.Width - (int)(lblBCh1.Width * 1.5);
                            }

                            if (e.Location.Y + picACh0.Location.Y + lblBCh1.Height > picBCh1.Height)
                            {
                                tempy = picBCh1.Height - lblBCh1.Height;
                            }

                            if (e.Location.Y + picACh0.Location.Y - lblBCh1.Height < picBCh1.Location.Y)
                            {
                                tempy = picACh0.Location.Y + picBCh1.Height / 2;
                            }


                            double yRealCurrentValue = Convert.ToDouble(draw.arrayLCh1Cur[xRealCurrentValue - 1]);


                            int xRealVoltageValue = (int)(xVoltageValue + 0.5);
                            double yRealVoltageValue = Convert.ToDouble(draw.arrayLCh1Vol[xRealVoltageValue - 1]);


                            if (draw.arrayACh4Cur.Count <= 1000)
                            {
                                savedate = Convert.ToString(draw.arrayLSaveDate[xRealCurrentValue - 1]);
                                yRealCurrentValue = Convert.ToDouble(draw.arrayLCh1Cur[xRealCurrentValue - 1]);
                                yRealVoltageValue = Convert.ToDouble(draw.arrayLCh1Vol[xRealVoltageValue - 1]);
                            }
                            else
                            {
                                savedate = Convert.ToString(draw.arrayLSaveDate[xRealCurrentValue - 1 + draw.arrayLSaveDate.Count - 1000]);
                                yRealCurrentValue = Convert.ToDouble(draw.arrayLCh1Cur[xRealCurrentValue - 1 + draw.arrayLCh1Cur.Count - 1000]);
                                yRealVoltageValue = Convert.ToDouble(draw.arrayLCh1Vol[xRealVoltageValue - 1 + draw.arrayLCh1Vol.Count - 1000]);
                            }

                            lblBCh1.Text = "Time:" + savedate + "\n" + "Current:" + yRealCurrentValue + "A" + "\n" + "Voltage:" + yRealVoltageValue + "V";
                            lblBCh1.Location = new Point(tempx + 30, tempy + picBCh1.Location.Y - 60);
                            lblBCh1.Visible = true;
                           lblBCh1.BackColor = Color.FromArgb(234, 234, 234);
                            //lblBCh1.BackColor = Color.White;
                        }
                        else
                        {
                            lblBCh1.Visible = false;
                        }

                    }
                }
                else
                {

                    if (draw.arrayLCh1Cur.Count == 0)
                    {
                        lblBCh1B.Visible = false;
                    }
                    else
                    {

                        int tempx, tempy;
                        tempx = e.Location.X + picACh0.Location.X;
                        tempy = e.Location.Y + picACh0.Location.Y;


                        Rectangle rectangle1 = picBCh1.RectangleToScreen(this.ClientRectangle);
                        if (rectangle1.Contains(MousePosition))
                        {

                            double xCurrentValue = Convert.ToDouble(picBCh1.Series[0].GetHorizAxis.CalcPosPoint(tempx).ToString());//电流对应的x值
                            double xVoltageValue = Convert.ToDouble(picBCh1.Series[1].GetHorizAxis.CalcPosPoint(tempx).ToString());//电压对应的x值

                            int xRealCurrentValue = (int)(xCurrentValue + 0.5);
                            string savedate = Convert.ToString(draw.arrayLSaveDate[xRealCurrentValue - 1]);

                            if (e.Location.X + picBCh1.Location.X + lblBCh1B.Width > picBCh1.Width)
                            {
                                tempx = picBCh1.Width - (int)(lblBCh1B.Width * 2);
                            }

                            if (e.Location.Y + picBCh1.Location.Y + lblBCh1B.Height > picBCh1.Height)
                            {
                                tempy = picBCh1.Height - lblBCh1B.Height;
                            }

                            if (e.Location.Y + picBCh1.Location.Y - lblBCh1B.Height < picBCh1.Location.Y)
                            {
                                tempy = picBCh1.Location.Y + picBCh1.Height / 4;
                            }


                            double yRealCurrentValue = Convert.ToDouble(draw.arrayLCh1Cur[xRealCurrentValue - 1]);


                            int xRealVoltageValue = (int)(xVoltageValue + 0.5);
                            double yRealVoltageValue = Convert.ToDouble(draw.arrayLCh1Vol[xRealVoltageValue - 1]);

                            if (draw.arrayLCh1Cur.Count <= 1000)
                            {
                                savedate = Convert.ToString(draw.arrayLSaveDate[xRealCurrentValue - 1]);
                                yRealCurrentValue = Convert.ToDouble(draw.arrayLCh1Cur[xRealCurrentValue - 1]);
                                yRealVoltageValue = Convert.ToDouble(draw.arrayLCh1Vol[xRealVoltageValue - 1]);
                            }
                            else
                            {
                                savedate = Convert.ToString(draw.arrayLSaveDate[xRealCurrentValue - 1 + draw.arrayLSaveDate.Count - 1000]);
                                yRealCurrentValue = Convert.ToDouble(draw.arrayLCh1Cur[xRealCurrentValue - 1 + draw.arrayLCh1Cur.Count - 1000]);
                                yRealVoltageValue = Convert.ToDouble(draw.arrayLCh1Vol[xRealVoltageValue - 1 + draw.arrayLCh1Vol.Count - 1000]);
                            }


                            lblBCh1B.Text = "Time:" + savedate + "\n" + "Current:" + yRealCurrentValue + "A" + "\n" + "Voltage:" + yRealVoltageValue + "V";
                            lblBCh1B.Location = new Point(tempx + 30, tempy - 10);
                            lblBCh1B.Visible = true;
                            lblBCh1B.BackColor = Color.FromArgb(234, 234, 234);
                            //lblBCh1B.BackColor = Color.White;
                        }
                        else
                        {
                            lblBCh1B.Visible = false;
                        }

                    }
                }

            }
            catch
            {
                //MessageBox.Show("鼠标点击值出现异常！" + exp.Message);
            }
        }

        /// <summary>
        /// B舱通道2随着鼠标滑动移动显示标签
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void picBCh2_MouseMove(object sender, MouseEventArgs e)
        {
            try
            {                
                lblACh0.Visible = false;
                lblBCh1.Visible = false;
                lblACh1.Visible = false;
                lblACh2.Visible = false;
                lblTemp.Visible = false;

                if (changedBCh2 == false)
                {
                    if (draw.arrayLCh2Cur.Count == 0)
                    {
                        lblBCh2.Visible = false;
                    }
                    else
                    {

                        int tempx, tempy;                      
                        tempx = e.X + picBCh2.Location.X;
                        tempy = e.Y + picBCh2.Location.Y;

                        Rectangle rectangle1 = picBCh2.RectangleToScreen(this.ClientRectangle);
                        if (rectangle1.Contains(MousePosition))
                        {                         
                            double xCurrentValue = Convert.ToDouble(picBCh2.Series[0].GetHorizAxis.CalcPosPoint(tempx).ToString());//电流对应的x值
                            double xVoltageValue = Convert.ToDouble(picBCh2.Series[1].GetHorizAxis.CalcPosPoint(tempx).ToString());//电压对应的x值

                            int xRealCurrentValue = (int)(xCurrentValue + 0.5);


                            string savedate = Convert.ToString(draw.arrayLSaveDate[xRealCurrentValue - 1]);

                            if (e.Location.X + picBCh2.Location.X + lblBCh2.Width > picBCh2.Width)
                            {
                                tempx = picBCh2.Width - (int)(lblBCh2.Width * 1.5);
                            }

                            if (e.Location.Y + picBCh2.Location.Y + lblBCh2.Height > picBCh2.Height)
                            {
                                tempy = picBCh2.Height - lblBCh2.Height;
                            }

                            if (e.Location.Y + picBCh2.Location.Y - lblBCh2.Height < picBCh2.Location.Y)
                            {
                                tempy = picBCh2.Location.Y + picBCh2.Height / 2;
                            }

                            double yRealCurrentValue = Convert.ToDouble(draw.arrayLCh2Cur[xRealCurrentValue - 1]);


                            int xRealVoltageValue = (int)(xVoltageValue + 0.5);
                            double yRealVoltageValue = Convert.ToDouble(draw.arrayLCh2Vol[xRealVoltageValue - 1]);


                            if (draw.arrayLCh2Cur.Count <= 1000)
                            {
                                savedate = Convert.ToString(draw.arrayLSaveDate[xRealCurrentValue - 1]);
                                yRealCurrentValue = Convert.ToDouble(draw.arrayLCh2Cur[xRealCurrentValue - 1]);
                                yRealVoltageValue = Convert.ToDouble(draw.arrayLCh2Vol[xRealVoltageValue - 1]);
                            }
                            else
                            {
                                savedate = Convert.ToString(draw.arrayLSaveDate[xRealCurrentValue - 1 + draw.arrayLSaveDate.Count - 1000]);
                                yRealCurrentValue = Convert.ToDouble(draw.arrayLCh2Cur[xRealCurrentValue - 1 + draw.arrayLCh2Cur.Count - 1000]);
                                yRealVoltageValue = Convert.ToDouble(draw.arrayLCh2Vol[xRealVoltageValue - 1 + draw.arrayLCh2Vol.Count - 1000]);
                            }


                            lblBCh2.Text = "Time:" + savedate + "\n" + "Current:" + yRealCurrentValue + "A" + "\n" + "Voltage:" + yRealVoltageValue + "V";
                            lblBCh2.Location = new Point(tempx + 30 + picACh1.Location.X, tempy - 60 + picBCh1.Location.Y);
                            lblBCh2.Visible = true;
                            lblBCh2.BackColor = Color.FromArgb(234, 234, 234);
                           //lblBCh2.BackColor = Color.White;
                        }
                        else
                        {
                            lblBCh2.Visible = false;
                        }

                    }
                }
                else
                {

                    if (draw.arrayLCh2Cur.Count == 0)
                    {
                        lblBCh2B.Visible = false;
                    }
                    else
                    {

                        int tempx, tempy;

                        tempx = e.Location.X + picACh0.Location.X;
                        tempy = e.Location.Y + picACh0.Location.Y;

                        Rectangle rectangle1 = picBCh2.RectangleToScreen(this.ClientRectangle);
                        if (rectangle1.Contains(MousePosition))
                        {

                            double xCurrentValue = Convert.ToDouble(picBCh2.Series[0].GetHorizAxis.CalcPosPoint(tempx).ToString());//电流对应的x值
                            double xVoltageValue = Convert.ToDouble(picBCh2.Series[1].GetHorizAxis.CalcPosPoint(tempx).ToString());//电压对应的x值

                            int xRealCurrentValue = (int)(xCurrentValue + 0.5);


                            string savedate = Convert.ToString(draw.arrayLSaveDate[xRealCurrentValue - 1]);

                            if (e.Location.X + picBCh2.Location.X + lblBCh2B.Width > picBCh2.Width)
                            {
                                tempx = picBCh2.Width - (int)(lblBCh2B.Width * 2);
                            }

                            if (e.Location.Y + picBCh2.Location.Y + lblBCh2B.Height > picBCh2.Height)
                            {
                                tempy = picBCh2.Height - lblBCh2B.Height;
                            }

                            if (e.Location.Y + picBCh2.Location.Y - lblBCh2B.Height < picBCh2.Location.Y)
                            {
                                tempy = picBCh2.Location.Y + picBCh2.Height / 4;
                            }

                            double yRealCurrentValue = Convert.ToDouble(draw.arrayLCh2Cur[xRealCurrentValue - 1]);


                            int xRealVoltageValue = (int)(xVoltageValue + 0.5);
                            double yRealVoltageValue = Convert.ToDouble(draw.arrayLCh2Vol[xRealVoltageValue - 1]);

                            if (draw.arrayLCh2Cur.Count <= 1000)
                            {
                                savedate = Convert.ToString(draw.arrayLSaveDate[xRealCurrentValue - 1]);
                                yRealCurrentValue = Convert.ToDouble(draw.arrayLCh2Cur[xRealCurrentValue - 1]);
                                yRealVoltageValue = Convert.ToDouble(draw.arrayLCh2Vol[xRealVoltageValue - 1]);
                            }
                            else
                            {
                                savedate = Convert.ToString(draw.arrayLSaveDate[xRealCurrentValue - 1 + draw.arrayLSaveDate.Count - 1000]);
                                yRealCurrentValue = Convert.ToDouble(draw.arrayLCh2Cur[xRealCurrentValue - 1 + draw.arrayLCh2Cur.Count - 1000]);
                                yRealVoltageValue = Convert.ToDouble(draw.arrayLCh2Vol[xRealVoltageValue - 1 + draw.arrayLCh2Vol.Count - 1000]);
                            }

                            lblBCh2B.Text = "Time:" + savedate + "\n" + "Current:" + yRealCurrentValue + "A" + "\n" + "Voltage:" + yRealVoltageValue + "V";
                            lblBCh2B.Location = new Point(tempx + 30, tempy - 10);
                            lblBCh2B.Visible = true;
                            lblBCh2B.BackColor = Color.FromArgb(234, 234, 234);
                           // lblBCh2B.BackColor = Color.White;

                        }
                        else
                        {
                            lblBCh2B.Visible = false;
                        }

                    }
                }

            }
            catch
            {
                //MessageBox.Show("鼠标点击值出现异常！" + exp.Message);
            }
        }
        /// <summary>
        /// 双击B舱通道通道2曲线控件放大图形
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void picBCh2_DoubleClick(object sender, EventArgs e)
        {
            if (changedBCh2)
            {

                picBCh2.Zoom.Undo();//撤销缩放
                lblBCh2B.Visible = false;
                changedBCh2 = false;
                TabLPnlStatus.Controls.Add(picBCh2);
                picBCh2.Parent = pnlBCh1C;
                picBCh2.Dock = DockStyle.Fill;

                TabLPnlStatus.Show();

            }
            else
            {
                picBCh2.Zoom.Undo();//撤销缩放
                changedBCh2 = true;
                TabLPnlStatus.Controls.Remove(picBCh2);
                picBCh2.Parent = this;
                picBCh2.BringToFront();

                TabLPnlStatus.Controls.Remove(lblBCh2B);
                lblBCh2B.Parent = this;
                lblBCh2B.BringToFront();


                //增加图像控件放大之后仍然有改变坐标轴显示范围的按钮
                TabLPnlStatus.Controls.Remove(button12);
                button12.Parent = picBCh2;
                button12.BringToFront();


                picBCh2.Dock = DockStyle.Fill;

                TabLPnlStatus.Hide();

            }
        }
        /// <summary>
        /// 双击A舱温度曲线进行放大及还原
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void picATemp_DoubleClick(object sender, EventArgs e)
        {
            if (changedATemp)
            {


                picACh2.Zoom.Undo();//撤销缩放
                lblACh2B.Visible = false;
                changedATemp = false;
                TabLPnlStatus.Controls.Add(picACh2);
                picACh2.Parent = pnlACh2V;
                picACh2.Dock = DockStyle.Fill;

                TabLPnlStatus.Show();

             
            }
            else
            {
                picACh2.Zoom.Undo();//撤销缩放
                changedATemp = true;
                TabLPnlStatus.Controls.Remove(picACh2);
                picACh2.Parent = this;
                picACh2.BringToFront();

                TabLPnlStatus.Controls.Remove(lblACh2B);
                lblACh2B.Parent = this;
                lblACh2B.BringToFront();

                //放大后增添坐标轴
                TabLPnlStatus.Controls.Remove(button10);
                button10.Parent = picACh2;
                button10.BringToFront();


                picACh2.Dock = DockStyle.Fill;

                TabLPnlStatus.Hide();

            }
        }
        /// <summary>
        /// A舱温度曲线随着鼠标移动标签进行移动
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void picATemp_MouseMove(object sender, MouseEventArgs e)
        {
            try
            {
               
                lblACh0.Visible = false;
                lblACh1.Visible = false;
                lblBCh1.Visible = false;
                lblBCh2.Visible = false;
                lblTemp.Visible = false;
                if (changedATemp == false)
                {
                    if (draw.arrayHCh2Cur.Count == 0)
                    {
                        
                        lblACh2.Visible = false;
                    }
                    else
                    {
                        int tempx, tempy;
                        tempx = e.X;//这样得到的是鼠标的坐标值还是真实的x值数据，尤其是放大之后，鼠标点击的是否是对应放大之后的坐标值，还是x轴的真实数据          
                        tempy = e.Y;

                        Rectangle rectangle = picACh2.RectangleToScreen(this.ClientRectangle);
                        if (rectangle.Contains(MousePosition))
                        {
                           
                            double xCurrentValue = Convert.ToDouble(picACh2.Series[0].GetHorizAxis.CalcPosPoint(tempx).ToString());
                            double xVoltageValue = Convert.ToDouble(picACh2.Series[1].GetHorizAxis.CalcPosPoint(tempx).ToString());


                            int xRealCurrentValue = (int)(xCurrentValue + 0.5);
                            string savedate = Convert.ToString(draw.arrayHSaveDate[xRealCurrentValue - 1]);



                            double yRealCurrentValue = Convert.ToDouble(draw.arrayHCh2Cur[xRealCurrentValue - 1]);

                            int xRealVoltageValue = (int)(xVoltageValue + 0.5);
                            double yRealVoltageValue = Convert.ToDouble(draw.arrayHCh2Vol[xRealVoltageValue - 1]);



                            if (draw.arrayHCh2Cur.Count <= 1000)
                            {
                                yRealCurrentValue = Convert.ToDouble(draw.arrayHCh2Cur[xRealCurrentValue - 1]);
                                yRealVoltageValue = Convert.ToDouble(draw.arrayHCh2Vol[xRealVoltageValue - 1]);
                                savedate = Convert.ToString(draw.arrayHSaveDate[xRealCurrentValue - 1]);

                            }
                            else
                            {
                                savedate = Convert.ToString(draw.arrayHSaveDate[xRealCurrentValue - 1 + draw.arrayACollectDate.Count - 1000]);
                                yRealCurrentValue = Convert.ToDouble(draw.arrayHCh2Cur[xRealCurrentValue - 1 + draw.arrayHCh2Cur.Count - 1000]);
                                yRealVoltageValue = Convert.ToDouble(draw.arrayHCh2Vol[xRealVoltageValue - 1 + draw.arrayHCh2Vol.Count - 1000]);                              
                            }

                            
                            if (e.Location.X + lblACh2.Width > picACh2.Width)
                            {
                                tempx = picACh2.Width - (int)(lblACh2.Width * 1.5);
                            }

                            if (e.Location.Y + picACh2.Location.Y + lblACh2.Height > picACh2.Height)
                            {
                                tempy = picACh2.Height - lblACh2.Height;
                            }

                            if (e.Location.Y + picACh2.Location.Y - lblACh2.Height < picACh2.Location.Y)
                            {
                                tempy = picACh2.Location.Y + picACh2.Height / 2;
                            }







                            lblACh2.Text = "Time:" + savedate + "\n" + "Current:" + yRealCurrentValue + "A" + "\n" + "Voltage:" + yRealVoltageValue + "V";
                            lblACh2.Location = new Point(tempx + 30 + picACh2.Location.X, tempy - 60);
                            lblACh2.Visible = true;
                            lblACh2.BackColor = Color.FromArgb(234, 234, 234);
                           // lblATemp.BackColor = Color.White;
                        }
                        else
                            lblACh2.Visible = false;
                    }
                }

                else
                {


                    if (draw.arrayHCh2Cur.Count == 0)
                    {
                        lblACh2B.Visible = false;
                    }
                    else
                    {
                        int tempx, tempy;
                        tempx = e.Location.X + picACh0.Location.X;//这样得到的是鼠标的坐标值还是真实的x值数据，尤其是放大之后，鼠标点击的是否是对应放大之后的坐标值，还是x轴的真实数据          
                        tempy = e.Location.Y + picACh0.Location.Y;


                        Rectangle rectangle1 = picACh2.RectangleToScreen(this.ClientRectangle);
                        if (rectangle1.Contains(MousePosition))
                        {
                            
                            double xCurrentValue = Convert.ToDouble(picACh2.Series[0].GetHorizAxis.CalcPosPoint(tempx).ToString());
                            double xVoltageValue = Convert.ToDouble(picACh2.Series[1].GetHorizAxis.CalcPosPoint(tempx).ToString());

                            int xRealCurrentValue = (int)(xCurrentValue + 0.5);
                            string savedate = Convert.ToString(draw.arrayHSaveDate[xRealCurrentValue - 1]);
                            double yRealCurrentValue = Convert.ToDouble(draw.arrayHCh2Cur[xRealCurrentValue - 1]);

                            int xRealVoltageValue = (int)(xVoltageValue + 0.5);
                            double yRealVoltageValue = Convert.ToDouble(draw.arrayHCh2Vol[xRealVoltageValue - 1]);

                            if (draw.arrayHCh2Cur.Count <= 1000)
                            {
                                savedate = Convert.ToString(draw.arrayHSaveDate[xRealCurrentValue - 1]);
                                yRealCurrentValue = Convert.ToDouble(draw.arrayHCh2Cur[xRealCurrentValue - 1]);
                                yRealVoltageValue = Convert.ToDouble(draw.arrayHCh2Vol[xRealVoltageValue - 1]);

                            }
                            else
                            {
                                savedate = Convert.ToString(draw.arrayHSaveDate[xRealCurrentValue - 1 + draw.arrayACollectDate.Count - 1000]);
                                yRealCurrentValue = Convert.ToDouble(draw.arrayHCh2Cur[xRealCurrentValue - 1 + draw.arrayHCh2Cur.Count - 1000]);
                                yRealVoltageValue = Convert.ToDouble(draw.arrayHCh2Vol[xRealVoltageValue - 1 + draw.arrayHCh2Vol.Count - 1000]);
                            }

                            
                            if (e.Location.X + picACh2.Location.X + lblACh2B.Width > picACh2.Width)
                            {
                                tempx = picACh2.Width - (int)(lblACh2B.Width * 1.5);
                            }

                            if (e.Location.Y + picACh2.Location.Y + lblACh2B.Height > picACh2.Height)
                            {
                                tempy = picACh2.Height - lblACh2B.Height;
                            }

                            if (e.Location.Y + picACh2.Location.Y - lblACh2B.Height < picACh2.Location.Y)
                            {
                                tempy = picACh2.Location.Y + picACh2.Height / 4;
                            }

                            lblACh2B.Text = "Time:" + savedate + "\n" + "Current:" + yRealCurrentValue + "A" + "\n" + "Voltage:" + yRealVoltageValue + "V";
                            lblACh2B.BackColor = Color.FromArgb(234, 234, 234);
                           // lblATempB.BackColor = Color.White;
                            lblACh2B.Location = new Point(tempx + 30, tempy - 10);
                            lblACh2B.Visible = true;


                        }

                        else
                            lblACh2B.Visible = false;

                    }


                }


            }
            catch
            {
                //MessageBox.Show("鼠标点击值出现异常！" + exp.Message);
            }
        }
        /// <summary>
        /// 鼠标在B舱温度曲线上移动，动态标签随着移动
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void picBTemp_MouseMove(object sender, MouseEventArgs e)
        {
            try
            {

                lblACh0.Visible = false;
                lblACh1.Visible = false;
                lblBCh1.Visible = false;
                lblBCh2.Visible = false;
                lblACh2.Visible = false;
                if (changedBTemp == false)
                {
                    if (draw.arrayLTemp.Count == 0)
                    {

                        lblTemp.Visible = false;
                    }
                    else
                    {
                        int tempx, tempy;
                        tempx = e.X;//这样得到的是鼠标的坐标值还是真实的x值数据，尤其是放大之后，鼠标点击的是否是对应放大之后的坐标值，还是x轴的真实数据          
                        tempy = e.Y;

                        Rectangle rectangle = picTemp.RectangleToScreen(this.ClientRectangle);
                        if (rectangle.Contains(MousePosition))
                        {

                            double xValue = Convert.ToDouble(picTemp.Series[0].GetHorizAxis.CalcPosPoint(tempx).ToString());

                            int xRealValue = (int)(xValue + 0.5);
                            double yRealValue = Convert.ToDouble(draw.arrayLTemp[xRealValue - 1]);

                            string savedate = Convert.ToString(draw.arrayLSaveDate[xRealValue - 1]);

                            if (draw.arrayBTemp.Count <= 1000)
                            {
                                yRealValue = Convert.ToDouble(draw.arrayLTemp[xRealValue - 1]);

                                savedate = Convert.ToString(draw.arrayLSaveDate[xRealValue - 1]);

                            }
                            else
                            {
                                yRealValue = Convert.ToDouble(draw.arrayLTemp[xRealValue - 1 + draw.arrayLTemp.Count - 1000]);

                                savedate = Convert.ToString(draw.arrayLSaveDate[xRealValue - 1 + draw.arrayLSaveDate.Count - 1000]);
                            }


                            if (e.Location.X + lblACh2.Width > picTemp.Width)
                            {
                                tempx = picTemp.Width - (int)(lblTemp.Width * 1.5);
                            }

                            if (e.Location.Y + picTemp.Location.Y + lblTemp.Height > picTemp.Height)
                            {
                                tempy = picTemp.Height - lblTemp.Height;
                            }

                            if (e.Location.Y + picTemp.Location.Y - lblTemp.Height < picTemp.Location.Y)
                            {
                                tempy = picTemp.Location.Y + picTemp.Height / 3;
                            }

                            lblTemp.Text = "Time:" + savedate + "\n" + "Temp:" + yRealValue + "℃";
                            lblTemp.Location = new Point(tempx + 30 + picTemp.Location.X, tempy - 40);
                            lblTemp.Visible = true;
                            lblTemp.BackColor = Color.FromArgb(234, 234, 234);
                           // lblBTemp.BackColor = Color.White;
                        }
                        else
                            lblTemp.Visible = false;
                    }
                }

                else
                {


                    if (draw.arrayLTemp.Count == 0)
                    {
                        lblTempB.Visible = false;
                    }
                    else
                    {
                        int tempx, tempy;
                        tempx = e.Location.X + picACh0.Location.X;//这样得到的是鼠标的坐标值还是真实的x值数据，尤其是放大之后，鼠标点击的是否是对应放大之后的坐标值，还是x轴的真实数据          
                        tempy = e.Location.Y +picACh0.Location.Y;


                        Rectangle rectangle1 = picTemp.RectangleToScreen(this.ClientRectangle);
                        if (rectangle1.Contains(MousePosition))
                        {

                            double xValue = Convert.ToDouble(picTemp.Series[0].GetHorizAxis.CalcPosPoint(tempx).ToString());

                            int xRealValue = (int)(xValue + 0.5);

                            double yRealValue = Convert.ToDouble(draw.arrayLTemp[xRealValue - 1]);

                            string savedate = Convert.ToString(draw.arrayLSaveDate[xRealValue - 1]);

                            if (draw.arrayLTemp.Count <= 1000)
                            {
                                yRealValue = Convert.ToDouble(draw.arrayLTemp[xRealValue - 1]);

                                savedate = Convert.ToString(draw.arrayLSaveDate[xRealValue - 1]);

                            }
                            else
                            {
                                yRealValue = Convert.ToDouble(draw.arrayLTemp[xRealValue - 1 + draw.arrayLTemp.Count - 1000]);

                                savedate = Convert.ToString(draw.arrayLSaveDate[xRealValue - 1 + draw.arrayLSaveDate.Count - 1000]);
                            }


                            if (e.Location.X + picTemp.Location.X + lblTempB.Width > picTemp.Width)
                            {
                                tempx = picTemp.Width - (int)(lblTempB.Width * 1.5);
                            }

                            if (e.Location.Y + picTemp.Location.Y + lblTempB.Height > picTemp.Height)
                            {
                                tempy = picTemp.Height - lblTempB.Height;
                            }

                            if (e.Location.Y + picTemp.Location.Y - lblTempB.Height < picTemp.Location.Y)
                            {
                                tempy = picTemp.Location.Y + picTemp.Height / 4;
                            }

                            lblTempB.Text = "Time:" + savedate + "\n" + "Temp:" + yRealValue + "℃";
                            lblTempB.BackColor = Color.FromArgb(234, 234, 234);
                            //lblBTempB.BackColor = Color.White;
                            lblTempB.Location = new Point( tempx+30,  tempy-10);
                            lblTempB.Visible = true;


                        }

                        else
                            lblTempB.Visible = false;

                    }


                }


            }
            catch
            {
                //MessageBox.Show("鼠标点击值出现异常！" + exp.Message);
            }
        }
        /// <summary>
        /// 双击控件B舱无线进行放大及还原
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void picBTemp_DoubleClick(object sender, EventArgs e)
        {
            if (changedBTemp)
            {


                picTemp.Zoom.Undo();//撤销缩放
                lblTempB.Visible = false;
                changedBTemp = false;
                TabLPnlStatus.Controls.Add(picTemp);
                picTemp.Parent = pnlBCh2V;
                picTemp.Dock = DockStyle.Fill;

                TabLPnlStatus.Show();


            }
            else
            {
               
                picTemp.Zoom.Undo();//撤销缩放
                changedBTemp = true;
                TabLPnlStatus.Controls.Remove(picTemp);
                picTemp.Parent = this;
                picTemp.BringToFront();

                TabLPnlStatus.Controls.Remove(lblTempB);
                lblTempB.Parent = this;
                lblTempB.BringToFront();



                //图形控件放大后增加改变坐标轴显示范围的按钮
                TabLPnlStatus.Controls.Remove(button13);
                button13.Parent = picTemp;
                button13.BringToFront();

                picTemp.Dock = DockStyle.Fill;

                TabLPnlStatus.Hide();

            }
        }

        private void groupBox1_Paint(object sender, PaintEventArgs e)
        {
            e.Graphics.Clear(groupBox1.BackColor);
            e.Graphics.DrawString(groupBox1.Text, groupBox1.Font, Brushes.Orange, 10, 1);
            e.Graphics.DrawLine(Pens.Orange, 1, 7, 8, 7);
            e.Graphics.DrawLine(Pens.Orange, e.Graphics.MeasureString(groupBox1.Text, groupBox1.Font).Width + 8, 7, groupBox1.Width - 2, 7);
            e.Graphics.DrawLine(Pens.Orange, 1, 7, 1, groupBox1.Height - 2);
            e.Graphics.DrawLine(Pens.Orange, 1, groupBox1.Height - 2, groupBox1.Width - 2, groupBox1.Height - 2);
            e.Graphics.DrawLine(Pens.Orange, groupBox1.Width - 2, 7, groupBox1.Width - 2, groupBox1.Height - 2); 
        }

        private void groupBox8_Paint(object sender, PaintEventArgs e)
        {
            e.Graphics.Clear(groupBox8.BackColor);
            e.Graphics.DrawString(groupBox8.Text, groupBox8.Font, Brushes.Orange, 10, 1);
            e.Graphics.DrawLine(Pens.Orange, 1, 7, 8, 7);
            e.Graphics.DrawLine(Pens.Orange, e.Graphics.MeasureString(groupBox8.Text, groupBox8.Font).Width + 8, 7, groupBox8.Width - 2, 7);
            e.Graphics.DrawLine(Pens.Orange, 1, 7, 1, groupBox8.Height - 2);
            e.Graphics.DrawLine(Pens.Orange, 1, groupBox8.Height - 2, groupBox8.Width - 2, groupBox8.Height - 2);
            e.Graphics.DrawLine(Pens.Orange, groupBox8.Width - 2, 7, groupBox8.Width - 2, groupBox8.Height - 2); 
        }
        /// <summary>
        /// 双击溶解氧采集值曲线进行放大以及缩小
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void picDO_DoubleClick(object sender, EventArgs e)
        {
            if (changedDO)
            {
                picDO.Zoom.Undo();//撤销缩放
                lblDOB.Visible = false;
                changedDO = false;
                TabLPnlSensor.Controls.Add(picDO);
                picDO.Parent = pnlDO;
                picDO.Dock = DockStyle.Fill;
                TabLPnlSensor.Show();

            }
            else
            {
                picDO.Zoom.Undo();//撤销缩放
                changedDO = true;
                TabLPnlSensor.Controls.Remove(picDO);
                picDO.Parent = this;
                picDO.BringToFront();

                TabLPnlSensor.Controls.Remove(lblDOB);
                lblDOB.Parent = this;
                lblDOB.BringToFront();


                //图形放大之后增加改变坐标轴显示范围的按钮
                TabLPnlSensor.Controls.Remove(button14);
                button14.Parent = picDO;
                button14.BringToFront();


                picDO.Dock = DockStyle.Fill;

                TabLPnlSensor.Hide();

            }
        }
        /// <summary>
        ///安德拉曲线双击放大还原
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void picYLS_DoubleClick(object sender, EventArgs e)
        {
            if (changedADL)
            {
                picPH.Zoom.Undo();//撤销缩放
                lblADLB.Visible = false;
                changedADL = false;
                TabLPnlSensor.Controls.Add(picPH);
                picPH.Parent = pnlADL;
                picPH.Dock = DockStyle.Fill;
                TabLPnlSensor.Show();

            }
            else
            {
                picPH.Zoom.Undo();//撤销缩放
                changedADL = true;
                TabLPnlSensor.Controls.Remove(picPH);
                picPH.Parent = this;
                picPH.BringToFront();

                TabLPnlSensor.Controls.Remove(lblADLB);
                lblADLB.Parent = this;
                lblADLB.BringToFront();
                //增加图形放大之后改变坐标轴显示范围的按钮
                TabLPnlSensor.Controls.Remove(button20);
                button20.Parent = picPH;
                button20.BringToFront();

                picPH.Dock = DockStyle.Fill;

                TabLPnlSensor.Hide();

            }
        }
        /// <summary>
        /// 浊度采集值曲线双击进行放大以及还原
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void picZD_DoubleClick(object sender, EventArgs e)
        {
            if (changedCTD)
            {
                picCTD.Zoom.Undo();//撤销缩放
                lblCTDB.Visible = false;
                changedCTD = false;
                TabLPnlSensor.Controls.Add(picCTD);
                picCTD.Parent = pnlCTD;
                picCTD.Dock = DockStyle.Fill;
                TabLPnlSensor.Show();

            }
            else
            {
                picCTD.Zoom.Undo();//撤销缩放
                changedCTD = true;
                TabLPnlSensor.Controls.Remove(picCTD);
                picCTD.Parent = this;
                picCTD.BringToFront();

                TabLPnlSensor.Controls.Remove(lblCTDB);
                lblCTDB.Parent = this;
                lblCTDB.BringToFront();

                //增加图形放大之后改变坐标轴显示范围的按钮
                TabLPnlSensor.Controls.Remove(button21);
                button21.Parent = picCTD;
                button21.BringToFront();

                picCTD.Dock = DockStyle.Fill;

                TabLPnlSensor.Hide();

            }
        }
        /// <summary>
        /// CDOM采集值曲线双击进行放大以及还原
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void picCDOM_DoubleClick(object sender, EventArgs e)
        {
            if (changedCDOM)
            {
                picMultiPara.Zoom.Undo();//撤销缩放
                lblMultiB.Visible = false;
                changedCDOM = false;
                TabLPnlSensor.Controls.Add(picMultiPara);
                picMultiPara.Parent = pnlCDOM;
                picMultiPara.Dock = DockStyle.Fill;
                TabLPnlSensor.Show();

            }
            else
            {
                picMultiPara.Zoom.Undo();//撤销缩放
                changedCDOM = true;
                TabLPnlSensor.Controls.Remove(picMultiPara);
                picMultiPara.Parent = this;
                picMultiPara.BringToFront();

                TabLPnlSensor.Controls.Remove(lblMultiB);
                lblMultiB.Parent = this;
                lblMultiB.BringToFront();


                //增加图形放大之后改变坐标轴显示范围的按钮
                TabLPnlSensor.Controls.Remove(button22);
                button22.Parent = picMultiPara;
                button22.BringToFront();

                picMultiPara.Dock = DockStyle.Fill;

                TabLPnlSensor.Hide();

            }
        }
        /// <summary>
        /// 
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void picDO_MouseMove(object sender, MouseEventArgs e)
        {
            try
            {
                lblADL.Visible = false;
                lblCTD.Visible = false;
                lblMulti.Visible = false;

                if (changedDO == false)
                {
                    if (draw.arrayDOValue.Count == 0)
                    {
                        //MessageBox.Show("甲烷没有采集数据！");
                        lblDO.Visible = false;
                    }
                    else
                    {
                        int tempx, tempy;
                        tempx = e.X + pnlDO1.Location.X;//这样得到的是鼠标的坐标值还是真实的x值数据，尤其是放大之后，鼠标点击的是否是对应放大之后的坐标值，还是x轴的真实数据          
                        tempy = e.Y + pnlDO1.Location.Y;


                        Rectangle rectangle1 = pnlDO1.RectangleToScreen(this.ClientRectangle);
                        if (rectangle1.Contains(MousePosition))
                        {
                            //if (tempx >= 73 && tempx <= 410 && tempy >= 33 && tempy <= 240)
                            //{
                            double xValue = Convert.ToDouble(picDO.Series[0].GetHorizAxis.CalcPosPoint(tempx).ToString());

                            int xRealValue = (int)(xValue + 0.5);
                            double yRealValue = Convert.ToDouble(draw.arrayDOValue[xRealValue - 1]);

                            string savedate = Convert.ToString(draw.arrayDODate[xRealValue - 1]);

                            if (draw.arrayDOValue.Count <= 1000)
                            {
                                yRealValue = Convert.ToDouble(draw.arrayDOValue[xRealValue - 1]);

                                savedate = Convert.ToString(draw.arrayDODate[xRealValue - 1]);
                            }
                            else
                            {
                                yRealValue = Convert.ToDouble(draw.arrayDOValue[xRealValue - 1 + draw.arrayDOValue.Count - 1000]);

                                savedate = Convert.ToString(draw.arrayDODate[xRealValue - 1 + draw.arrayDODate.Count - 1000]);
                            }
                  
                            if (e.Location.X + pnlDO1.Location.X + lblDO.Width > picDO.Width)
                            {
                                tempx = picDO.Width - (int)(lblDO.Width * 1.5);
                            }

                            if (e.Location.Y + pnlDO1.Location.Y + lblDO.Height > picDO.Height)
                            {
                                tempy = picDO.Height - lblDO.Height;
                            }

                            if (e.Location.Y + pnlDO1.Location.Y - lblDO.Height < pnlDO1.Location.Y)
                            {
                                tempy = pnlDO1.Location.Y + picDO.Height / 3;
                            }

                            lblDO.Text = "Time:" + savedate + "\n" + "Data:" + yRealValue + "mg/L";
                            lblDO.Location = new Point(tempx + 30, tempy + picDO.Location.Y - 60);
                            lblDO.Visible = true;
                            lblDO.BackColor = Color.FromArgb(240, 248, 255);
                           // lblDO.BackColor = Color.White;
                        }
                        else
                            lblDO.Visible = false;
                    }
                }

                else//图形最大化之后鼠标移动，数据在周围进行显示
                {
                    if (draw.arrayDOValue.Count == 0)
                    {
                        //MessageBox.Show("溶解氧没有采集数据！");
                        lblDOB.Visible = false;
                    }
                    else
                    {
                        //int tempx, tempy;
                        //tempx = e.X;//这样得到的是鼠标的坐标值还是真实的x值数据，尤其是放大之后，鼠标点击的是否是对应放大之后的坐标值，还是x轴的真实数据          
                        //tempy = e.Y;

                        int tempx, tempy;

                        tempx = e.Location.X + picDO.Location.X;//这样得到的是鼠标的坐标值还是真实的x值数据，尤其是放大之后，鼠标点击的是否是对应放大之后的坐标值，还是x轴的真实数据          
                        tempy = e.Location.Y + picDO.Location.Y;


                        Rectangle rectangle1 = picDO.RectangleToScreen(this.ClientRectangle);
                        if (rectangle1.Contains(MousePosition))
                        {

                            double xValue = Convert.ToDouble(picDO.Series[0].GetHorizAxis.CalcPosPoint(tempx).ToString());

                            int xRealValue = (int)(xValue + 0.5);

                            double yRealValue = Convert.ToDouble(draw.arrayDOValue[xRealValue - 1]);

                            string savedate = Convert.ToString(draw.arrayDODate[xRealValue - 1]);

                            if (draw.arrayDOValue.Count <= 1000)
                            {
                                yRealValue = Convert.ToDouble(draw.arrayDOValue[xRealValue - 1]);

                                savedate = Convert.ToString(draw.arrayDODate[xRealValue - 1]);
                            }
                            else
                            {
                                yRealValue = Convert.ToDouble(draw.arrayDOValue[xRealValue - 1 + draw.arrayDOValue.Count - 1000]);

                                savedate = Convert.ToString(draw.arrayDODate[xRealValue - 1 + draw.arrayDODate.Count - 1000]);
                            }


                            if (e.Location.X + picDO.Location.X + lblDOB.Width > picDO.Width)
                            {
                                tempx = picDO.Width - (int)(lblDOB.Width * 1.5);
                            }

                            if (e.Location.Y + picDO.Location.Y + lblDO.Height > picDO.Height)
                            {
                                tempy = picDO.Height - lblDOB.Height;
                            }

                            if (e.Location.Y + picDO.Location.Y - lblDOB.Height < picDO.Location.Y)
                            {
                                tempy = picDO.Location.Y + picDO.Height / 2;
                            }

                            lblDOB.Text = "Time:" + savedate + "\n" + "Data:" + yRealValue + "mg/L";
                            lblDOB.BackColor = Color.FromArgb(240, 248, 255);
                           // lblDOB.BackColor = Color.White;
                            lblDOB.Location = new Point(tempx + 30, tempy - 60);
                            lblDOB.Visible = true;
                        }

                        else
                            lblDOB.Visible = false;


                    }

                }

            }
            catch
            {
                //MessageBox.Show("鼠标点击值出现异常！" + exp.Message);
            }
        }

        private void picDO_MouseClick(object sender, MouseEventArgs e)
        {
            try
            {
                lblADL.Visible = false;
                lblCTD.Visible = false;
                lblMulti.Visible = false;

                if (changedDO == false)
                {


                    if (draw.arrayDOValue.Count == 0)
                    {
                        //MessageBox.Show("溶解氧没有采集数据！");
                        lblDO.Visible = false;
                    }
                    else
                    {
                        int tempx, tempy;

                        tempx = e.Location.X + pnlDO1.Location.X;//这样得到的是鼠标的坐标值还是真实的x值数据，尤其是放大之后，鼠标点击的是否是对应放大之后的坐标值，还是x轴的真实数据          
                        tempy = e.Location.Y + pnlDO1.Location.Y;

                        Rectangle rectangle = picDO.RectangleToClient(this.ClientRectangle);
                        if (rectangle.Contains(MousePosition))
                        {
                            double xValue = Convert.ToDouble(picDO.Series[0].GetHorizAxis.CalcPosPoint(tempx).ToString());



                            int xRealValue = (int)(xValue + 0.5);
                            double yRealValue = Convert.ToDouble(draw.arrayDOValue[xRealValue - 1]);
                            string savedate = Convert.ToString(draw.arrayDODate[xRealValue - 1]);

                            if (draw.arrayDOValue.Count <= 1000)
                            {
                                yRealValue = Convert.ToDouble(draw.arrayDOValue[xRealValue - 1]);

                                savedate = Convert.ToString(draw.arrayDODate[xRealValue - 1]);
                            }
                            else
                            {
                                yRealValue = Convert.ToDouble(draw.arrayDOValue[xRealValue - 1 + draw.arrayDOValue.Count - 1000]);

                                savedate = Convert.ToString(draw.arrayDODate[xRealValue - 1 + draw.arrayDODate.Count - 1000]);
                            }


                            //if (e.Location.X + pnlDO1.Location.X + lblDO.Width > picDO.Width)
                            //{
                            //    tempx = picDO.Width - (int)(lblDO.Width * 1.5);
                            //}

                            //if (e.Location.Y +pnlDO1.Location.Y + lblDO.Height > picDO.Height)
                            //{
                            //    tempy = picDO.Height - lblDO.Height;
                            //}

                            //if (e.Location.Y + pnlDO1.Location.Y - lblDO.Height < pnlDO1.Location.Y)
                            //{
                            //    tempy = pnlDO1.Location.Y + picDO.Height / 3;
                            //}




                            lblDO.Text = "Time:" + savedate + "\n" + "Data:" + yRealValue + "mg/L";
                            //lblDO.BackColor = Color.White;
                            lblDO.BackColor = Color.FromArgb(234, 234, 234);
                            lblDO.Location = (new Point(tempx + 30, tempy - 40));
                            lblDO.Visible = true;
                        }

                        else
                        {
                            lblDO.Visible = false;
                        }

                    }
                }

                else//图形最大化之后鼠标移动，数据在周围进行显示
                {
                    if (draw.arrayDOValue.Count == 0)
                    {
                        //MessageBox.Show("溶解氧没有采集数据！");
                        lblDOB.Visible = false;
                    }
                    else
                    {
                        //int tempx, tempy;
                        //tempx = e.X;//这样得到的是鼠标的坐标值还是真实的x值数据，尤其是放大之后，鼠标点击的是否是对应放大之后的坐标值，还是x轴的真实数据          
                        //tempy = e.Y;

                        int tempx, tempy;

                        tempx = e.Location.X + picDO.Location.X;//这样得到的是鼠标的坐标值还是真实的x值数据，尤其是放大之后，鼠标点击的是否是对应放大之后的坐标值，还是x轴的真实数据          
                        tempy = e.Location.Y + picDO.Location.Y;


                        Rectangle rectangle1 = picDO.RectangleToScreen(this.ClientRectangle);
                        if (rectangle1.Contains(MousePosition))
                        {

                            double xValue = Convert.ToDouble(picDO.Series[0].GetHorizAxis.CalcPosPoint(tempx).ToString());

                            int xRealValue = (int)(xValue + 0.5);

                            double yRealValue = Convert.ToDouble(draw.arrayDOValue[xRealValue - 1]);

                            string savedate = Convert.ToString(draw.arrayDODate[xRealValue - 1]);

                            if (draw.arrayDOValue.Count <= 1000)
                            {
                                yRealValue = Convert.ToDouble(draw.arrayDOValue[xRealValue - 1]);

                                savedate = Convert.ToString(draw.arrayDODate[xRealValue - 1]);
                            }
                            else
                            {
                                yRealValue = Convert.ToDouble(draw.arrayDOValue[xRealValue - 1 + draw.arrayDOValue.Count - 1000]);

                                savedate = Convert.ToString(draw.arrayDODate[xRealValue - 1 + draw.arrayDODate.Count - 1000]);
                            }


                            if (e.Location.X + picDO.Location.X + lblDOB.Width > picDO.Width)
                            {
                                tempx = picDO.Width - (int)(lblDOB.Width * 1.5);
                            }

                            if (e.Location.Y + picDO.Location.Y + lblDO.Height > picDO.Height)
                            {
                                tempy = picDO.Height - lblDOB.Height;
                            }

                            if (e.Location.Y + picDO.Location.Y - lblDOB.Height < picDO.Location.Y)
                            {
                                tempy = picDO.Location.Y + picDO.Height / 2;
                            }

                            lblDOB.Text = "Time:" + savedate + "\n" + "Data:" + yRealValue + "mg/L";
                            //lblDOB.BackColor = Color.FromArgb(234, 234, 234);
                            lblDOB.BackColor = Color.White;
                            lblDOB.Location = new Point(tempx + 30, tempy - 60);
                            lblDOB.Visible = true;
                        }

                        else
                            lblDOB.Visible = false;


                    }

                }

            }
            catch
            {
                //MessageBox.Show("鼠标点击值出现异常！" + exp.Message);
            }
        }
        /// <summary>
        /// 转到摄像头地址
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void btnCamera_Click(object sender, EventArgs e)
        {
            if (camera)//判断一下窗口是否已经开启，若是开启之后则将窗口关闭
            {
                p.CloseMainWindow();//
            }
           
            this.Cursor = Cursors.WaitCursor;
            showWebContent(txtAddr1,wb1);
            this.Cursor = Cursors.Default;
        }
        /// <summary>
        /// 转到摄像头网页界面
        /// </summary>
        private void showWebContent(TextBox txtBoxAddr,WebBrowser wb)
        {
            string url = txtBoxAddr.Text.Trim();

            if (url != null && url.Length > 0)
            {
                wb.Navigate(url);
            }
        }
        /// <summary>
        /// 输入完成摄像头地址栏，按下回车键转入摄像头网页
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void txtAddr_KeyDown(object sender, KeyEventArgs e)
        {
            
            this.Cursor = Cursors.WaitCursor;


            if (camera)//判断一下窗口是否已经开启，若是开启之后则将窗口关闭
            {
                p.CloseMainWindow();//
            }


            if(e.KeyCode == Keys.Enter)
            {
                showWebContent(txtAddr1,wb1);
            }
            this.Cursor = Cursors.Default;
        }
        /// <summary>
        /// 为datagridview添加行号
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void dataGridView4_RowPostPaint(object sender, DataGridViewRowPostPaintEventArgs e)
        {
            Color color = dataGridView4.RowHeadersDefaultCellStyle.ForeColor;
            if (dataGridView4.Rows[e.RowIndex].Selected)
                color = dataGridView4.RowHeadersDefaultCellStyle.SelectionForeColor;
            else
                color = dataGridView4.RowHeadersDefaultCellStyle.ForeColor;

            using (SolidBrush b = new SolidBrush(color))
            {
                e.Graphics.DrawString((e.RowIndex + 1).ToString(), e.InheritedRowStyle.Font, b, e.RowBounds.Location.X + 20, e.RowBounds.Location.Y + 6);
            }
        }
        /// <summary>
        /// 通道1打开指令
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void chOneOpen_Click_1(object sender, EventArgs e)
        {
            this.Cursor = Cursors.WaitCursor;

            try
            {
                LogCommand.WriteLogFile("执行通道1打开！");

                _4MyClientClass expCmd = new _4MyClientClass(this);

                if (expCmd.ExecuteCmd("$SET+01+SIIM1+Power12V#", 2, 1))//按照字符串指令形式发送给MIO板子
                {
                    LogCommand.WriteLogFile("执行通道1打开成功！");

                    this.sensorOneStatus.Text = "打开";
                    this.sensorOneStatus.BackColor = Color.DarkSeaGreen;
                    this.sensorOneStatus.ForeColor = Color.White;

                    chOneOpen.Enabled = false;
                    chOneClose.Enabled = true;
                }
                else
                {
                    LogCommand.WriteLogFile("执行通道1打开失败！");
                    chOneOpen.Enabled = true;
                    chOneClose.Enabled = false;
                    this.sensorOneStatus.Text = "打开失败";
                    this.sensorOneStatus.ForeColor = Color.Black;
                    this.sensorOneStatus.BackColor = Color.Yellow;

                }

            }
            catch (Exception exp)
            {
                LogClass.WriteLogFile("执行通道1打开异常！" + exp.Message);
            }

            this.Cursor = Cursors.Default; 
        }
        /// <summary>
        /// 通道1关闭按钮
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void chOneClose_Click_1(object sender, EventArgs e)
        {
            this.Cursor = Cursors.WaitCursor;
            try
            {
                LogCommand.WriteLogFile("执行通道1关闭！");
                _3ReceieveMsgClass.flag = 0;//通道1关闭之后，关于溶解氧计算的flag能够重新清零
                _4MyClientClass expCmd = new _4MyClientClass(this);

                if (expCmd.ExecuteCmd("$SET+01+SIIM1+Close#", 2, 1))
                {
                    LogCommand.WriteLogFile("执行通道1关闭成功！");
                    chOneClose.Enabled = false;
                    chOneOpen.Enabled = true;
                    this.sensorOneStatus.Text = "关闭";
                    this.sensorOneStatus.BackColor = Color.Red;
                    this.sensorOneStatus.ForeColor = Color.White;

                }
                else
                {
                    LogCommand.WriteLogFile("执行通道1关闭失败！");
                    this.sensorOneStatus.Text = "关闭失败";
                    this.sensorOneStatus.ForeColor = Color.Black;
                    this.sensorOneStatus.BackColor = Color.Yellow;
                    chOneClose.Enabled = true;
                    chOneOpen.Enabled = false;
                }

            }
            catch (Exception exp)
            {
                LogClass.WriteLogFile("执行通道1关闭异常！" + exp.Message);
            }

            this.Cursor = Cursors.Default; 
        }
        /// <summary>
        /// 通道2接通
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void chTwoOpen_Click_1(object sender, EventArgs e)
        {
            this.Cursor = Cursors.WaitCursor;

            try
            {
                LogCommand.WriteLogFile("执行通道2打开！");
                _4MyClientClass expCmd = new _4MyClientClass(this);
                if (expCmd.ExecuteCmd("$SET+01+SIIM2+Power12V#", 2, 1))
                {
                    LogCommand.WriteLogFile("执行通道2打开成功！");
                    this.sensorTwoStatus.Text = "打开";
                    this.sensorTwoStatus.BackColor = Color.DarkSeaGreen;
                    this.sensorTwoStatus.ForeColor = Color.White;

                    chTwoOpen.Enabled = false;
                    chTwoClose.Enabled = true;
                }
                else
                {
                    LogCommand.WriteLogFile("执行通道2打开失败！");
                    chTwoOpen.Enabled = true;
                    chTwoClose.Enabled = false;
                    this.sensorTwoStatus.Text = "打开失败";
                    this.sensorTwoStatus.ForeColor = Color.Black;
                    this.sensorTwoStatus.BackColor = Color.Yellow;

                }

            }
            catch (Exception exp)
            {
                LogClass.WriteLogFile("执行通道2打开异常！" + exp.Message);
            }

            this.Cursor = Cursors.Default; 
        }
        /// <summary>
        /// 通道2关闭
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void chTwoClose_Click_1(object sender, EventArgs e)
        {
            this.Cursor = Cursors.WaitCursor;

            try
            {
                LogCommand.WriteLogFile("执行通道2关闭！");

                _4MyClientClass expCmd = new _4MyClientClass(this);

                if (expCmd.ExecuteCmd("$SET+01+SIIM2+Close#", 2, 1))
                {
                    LogCommand.WriteLogFile("执行通道2关闭成功！");
                    chTwoClose.Enabled = false;
                    chTwoOpen.Enabled = true;
                    this.sensorTwoStatus.Text = "关闭";
                    this.sensorTwoStatus.BackColor = Color.Red;
                    this.sensorTwoStatus.ForeColor = Color.White;

                }
                else
                {
                    LogCommand.WriteLogFile("执行通道2关闭失败！");
                    this.sensorTwoStatus.Text = "关闭失败";
                    this.sensorTwoStatus.ForeColor = Color.Black;
                    this.sensorTwoStatus.BackColor = Color.Yellow;
                    chTwoClose.Enabled = true;
                    chTwoOpen.Enabled = false;
                }


            }
            catch (Exception exp)
            {
                LogClass.WriteLogFile("执行通道2关闭异常！" + exp.Message);
            }

            this.Cursor = Cursors.Default; 
        }
        /// <summary>
        /// 通道3接通
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void chThreeOpen_Click_1(object sender, EventArgs e)
        {
            this.Cursor = Cursors.WaitCursor;

            try
            {
                LogCommand.WriteLogFile("执行通道3打开！");

                _4MyClientClass expCmd = new _4MyClientClass(this);

                if (expCmd.ExecuteCmd("$SET+01+SIIM3+Power12V#", 2, 1))
                {
                    LogCommand.WriteLogFile("执行通道3打开成功！");
                    this.sensorThreeStatus.Text = "打开";
                    this.sensorThreeStatus.BackColor = Color.DarkSeaGreen;
                    this.sensorThreeStatus.ForeColor = Color.White;

                    chThreeOpen.Enabled = false;
                    chThreeClose.Enabled = true;
                }
                else
                {
                    LogCommand.WriteLogFile("执行通道3打开失败！");
                    chThreeOpen.Enabled = true;
                    chThreeClose.Enabled = false;
                    this.sensorThreeStatus.Text = "打开失败";
                    this.sensorThreeStatus.ForeColor = Color.Black;
                    this.sensorThreeStatus.BackColor = Color.Yellow;

                }

            }
            catch (Exception exp)
            {
                LogClass.WriteLogFile("执行通道3打开异常！" + exp.Message);
            }

            this.Cursor = Cursors.Default; 
        }
        /// <summary>
        /// 通道3关闭
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void chThreeClose_Click_1(object sender, EventArgs e)
        {
            this.Cursor = Cursors.WaitCursor;

            try
            {
                LogCommand.WriteLogFile("执行通道3关闭！");

                _4MyClientClass expCmd = new _4MyClientClass(this);

                if (expCmd.ExecuteCmd("$SET+01+SIIM3+Close#", 2, 1))
                {
                    LogCommand.WriteLogFile("执行通道3关闭成功！");
                    chThreeClose.Enabled = false;
                    chThreeOpen.Enabled = true;
                    this.sensorThreeStatus.Text = "关闭";
                    this.sensorThreeStatus.BackColor = Color.Red;
                    this.sensorThreeStatus.ForeColor = Color.White;

                }
                else
                {
                    LogCommand.WriteLogFile("执行通道3关闭失败！");
                    this.sensorThreeStatus.Text = "关闭失败";
                    this.sensorThreeStatus.ForeColor = Color.Black;
                    this.sensorThreeStatus.BackColor = Color.Yellow;
                    chThreeClose.Enabled = true;
                    chThreeOpen.Enabled = false;
                }


            }
            catch (Exception exp)
            {
                LogClass.WriteLogFile("执行通道3关闭异常！" + exp.Message);
            }

            this.Cursor = Cursors.Default; 
        }
        /// <summary>
        /// 通道4接通
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void chFourOpen_Click_1(object sender, EventArgs e)
        {
            this.Cursor = Cursors.WaitCursor;
            try
            {
                LogCommand.WriteLogFile("执行通道4打开！");

                _4MyClientClass expCmd = new _4MyClientClass(this);

                if (expCmd.ExecuteCmd("$SET+01+SIIM4+Power12V#", 2, 1))
                {
                    LogCommand.WriteLogFile("执行通道4打开成功！");
                    this.sensorFourStatus.Text = "打开";
                    this.sensorFourStatus.BackColor = Color.DarkSeaGreen;
                    this.sensorFourStatus.ForeColor = Color.White;

                    chFourOpen.Enabled = false;
                    chFourClose.Enabled = true;
                }
                else
                {
                    LogCommand.WriteLogFile("执行通道4打开失败！");
                    chFourOpen.Enabled = true;
                    chFourClose.Enabled = false;
                    this.sensorFourStatus.Text = "打开失败";
                    this.sensorFourStatus.ForeColor = Color.Black;
                    this.sensorFourStatus.BackColor = Color.Yellow;

                }

            }
            catch (Exception exp)
            {
                LogClass.WriteLogFile("执行通道4打开异常！" + exp.Message);
            }
            this.Cursor = Cursors.Default;
        }
        /// <summary>
        /// 通道4关闭
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void chFourClose_Click_1(object sender, EventArgs e)
        {
            this.Cursor = Cursors.WaitCursor;

            try
            {
                LogCommand.WriteLogFile("执行通道4关闭！");

                _4MyClientClass expCmd = new _4MyClientClass(this);

                if (expCmd.ExecuteCmd("$SET+01+SIIM4+Close#", 2, 1))
                {
                    LogCommand.WriteLogFile("执行通道4关闭成功！");
                    chFourClose.Enabled = false;
                    chFourOpen.Enabled = true;
                    this.sensorFourStatus.Text = "关闭";
                    this.sensorFourStatus.BackColor = Color.Red;
                    this.sensorFourStatus.ForeColor = Color.White;

                }
                else
                {
                    LogCommand.WriteLogFile("执行通道4关闭失败！");
                    this.sensorFourStatus.Text = "关闭失败";
                    this.sensorFourStatus.ForeColor = Color.Black;
                    this.sensorFourStatus.BackColor = Color.Yellow;
                    chFourClose.Enabled = true;
                    chFourOpen.Enabled = false;
                }


            }
            catch (Exception exp)
            {
                LogClass.WriteLogFile("执行通道4关闭异常！" + exp.Message);
            }

            this.Cursor = Cursors.Default; 
        }
        /// <summary>
        /// 通道5打开
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void chFiveOpen_Click(object sender, EventArgs e)
        {
            this.Cursor = Cursors.WaitCursor;

            try
            {
                LogCommand.WriteLogFile("执行通道5打开！");
                _4MyClientClass expCmd = new _4MyClientClass(this);
                if (expCmd.ExecuteCmd("$SET+01+SIIM5+Power12V#", 2, 1))
                {
                    LogCommand.WriteLogFile("执行通道5打开成功！");
                    this.sensorFiveStatus.Text = "打开";
                    this.sensorFiveStatus.BackColor = Color.DarkSeaGreen;
                    this.sensorFiveStatus.ForeColor = Color.White;

                    chFiveOpen.Enabled = false;
                    chFiveClose.Enabled = true;
                }
                else
                {
                    LogCommand.WriteLogFile("执行通道5打开失败！");
                    chFiveOpen.Enabled = true;
                    chFiveClose.Enabled = false;
                    this.sensorFiveStatus.Text = "打开失败";
                    this.sensorFiveStatus.ForeColor = Color.Black;
                    this.sensorFiveStatus.BackColor = Color.Yellow;

                }

            }
            catch (Exception exp)
            {
                LogClass.WriteLogFile("执行通道5打开异常！" + exp.Message);
            }

            this.Cursor = Cursors.Default;
        }
        /// <summary>
        /// 通道5关闭
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void chFiveClose_Click(object sender, EventArgs e)
        {
            this.Cursor = Cursors.WaitCursor;

            try
            {
                LogCommand.WriteLogFile("执行通道5关闭！");

                _4MyClientClass expCmd = new _4MyClientClass(this);

                if (expCmd.ExecuteCmd("$SET+01+SIIM5+Close#", 2, 1))
                {
                    LogCommand.WriteLogFile("执行通道5关闭成功！");
                    chFiveClose.Enabled = false;
                    chFiveOpen.Enabled = true;
                    this.sensorFiveStatus.Text = "关闭";
                    this.sensorFiveStatus.BackColor = Color.Red;
                    this.sensorFiveStatus.ForeColor = Color.White;

                }
                else
                {
                    LogCommand.WriteLogFile("执行通道5关闭失败！");
                    this.sensorFiveStatus.Text = "关闭失败";
                    this.sensorFiveStatus.ForeColor = Color.Black;
                    this.sensorFiveStatus.BackColor = Color.Yellow;
                    chFiveClose.Enabled = true;
                    chFiveOpen.Enabled = false;
                }


            }
            catch (Exception exp)
            {
                LogClass.WriteLogFile("执行通道5关闭异常！" + exp.Message);
            }

            this.Cursor = Cursors.Default; 
        }
        /// <summary>
        /// 配置数据采集器1水下控制仓的IP地址以及port端口，将发指令的数据采集器的服务器IP以及port配置到文件中
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void button1_Click(object sender, EventArgs e)
        {
            try
            {
                DataTable dtConfig = new DataTable();
                dtConfig.Columns.Add("srvIP");
                dtConfig.Columns.Add("srvPort");
                DataRow rowConfig = dtConfig.NewRow();
                if (this.txtDataCollectIP.Text.Trim().Length <= 0 || this.txtDataCollectPort.Text.Trim().Length <= 0)
                {
                    MessageBox.Show("请输入IP以及端口号！", "提示");
                    return;
                }

                if (IsIP(this.txtDataCollectIP.Text.Trim()))
                {
                    rowConfig["srvIP"] = this.txtDataCollectIP.Text.Trim();
                    rowConfig["srvPort"] = this.txtDataCollectPort.Text.Trim();
                    Convert.ToInt32(txtDataCollectPort.Text.Trim());

                    dtConfig.Rows.Add(rowConfig);
                    DataSet dsConfig = new DataSet();
                    dsConfig.Tables.Add(dtConfig);
                    dsConfig.WriteXml(@".\IPandPortConfig.xml");//将下位机IP以及端口写入本地文件
                    //dtConfig.WriteXml(@".\IPandPortConfig.xml");
                    MessageBox.Show("配置成功！");
                }
                else
                {
                    MessageBox.Show("输入的IP格式有误！重新输入");
                    return;
                }

            }
            catch (Exception exp)
            {
                // MessageBox.Show("配置失败！" + exp.Message);
                LogClass.WriteLogFile("配置失败！" + exp.Message);
            }
        }
        /// <summary>
        /// 数据采集器1页面执行指令弹出指令执行界面
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void button7_Click_2(object sender, EventArgs e)
        {
            cmdCollectSet mycmdCollect = new cmdCollectSet(1,this);
            mycmdCollect.Text = "数据采集器1指令设置界面";
            mycmdCollect.BackColor = tableLayoutPanel2.BackColor;
            mycmdCollect.Show();
        }
        /// <summary>
        /// 更改主接驳盒通道1图显示范围
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void button8_Click_2(object sender, EventArgs e)
        {
            SetPicScope mySetPicScope = new SetPicScope(1,this);
            mySetPicScope.Show();

        }
        /// <summary>
        /// 更改主接驳盒通道2图像纵轴显示范围
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void button9_Click_2(object sender, EventArgs e)
        {
            SetPicScope mySetPicScope = new SetPicScope(2,this);
            mySetPicScope.Show();
        }
        /// <summary>
        /// 更改主接驳盒温度图像纵轴显示范围
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void button10_Click_2(object sender, EventArgs e)
        {
            SetPicScope mySetPicScope = new SetPicScope(3, this);
            mySetPicScope.Show();
        }
        /// <summary>
        /// 更改次接驳盒通道1图像显示范围
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void button11_Click_1(object sender, EventArgs e)
        {
            SetPicScope mySetPicScope = new SetPicScope(4, this);
            mySetPicScope.Show();
        }
        /// <summary>
        /// 更改次接驳盒通道2图像显示范围
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void button12_Click_1(object sender, EventArgs e)
        {
            SetPicScope mySetPicScope = new SetPicScope(5, this);
            mySetPicScope.Show();
        }
        /// <summary>
        /// 更改次接驳盒温度图像显示范围
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void button13_Click_1(object sender, EventArgs e)
        {
            SetPicScope mySetPicScope = new SetPicScope(6, this);
            mySetPicScope.Show();
        }

        private void button14_Click(object sender, EventArgs e)
        {
            SetPicScope mySetPicScope = new SetPicScope(7, this);
            mySetPicScope.Show();
        }
        /// <summary>
        /// 给数据采集器信息页数据采集值表格增添行号
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void dataGridView3_RowPostPaint(object sender, DataGridViewRowPostPaintEventArgs e)
        {
            Color color = dataGridView3.RowHeadersDefaultCellStyle.ForeColor;
            if (dataGridView3.Rows[e.RowIndex].Selected)
                color = dataGridView3.RowHeadersDefaultCellStyle.SelectionForeColor;
            else
                color = dataGridView3.RowHeadersDefaultCellStyle.ForeColor;

            using (SolidBrush b = new SolidBrush(color))
            {
                e.Graphics.DrawString((e.RowIndex + 1).ToString(), e.InheritedRowStyle.Font, b, e.RowBounds.Location.X + 20, e.RowBounds.Location.Y + 6);
            }
        }
        /// <summary>
        /// 总的绘制曲线的页更改显示的坐标
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void button15_Click(object sender, EventArgs e)
        {
            SetPicScope mySetPicScope = new SetPicScope(8, this);
            mySetPicScope.Show();
        }

        private void picYLS_MouseMove(object sender, MouseEventArgs e)
        {
            try
            {
                lblDO.Visible = false;
                lblCTD.Visible = false;
                lblMulti.Visible = false;

                if (changedADL == false)
                {
                    if (draw.arrayADLValue.Count == 0)
                    {
                        //MessageBox.Show("甲烷没有采集数据！");
                        lblADL.Visible = false;
                    }
                    else
                    {
                        int tempx, tempy;
                        tempx = e.X + pnlDO1.Location.X;//这样得到的是鼠标的坐标值还是真实的x值数据，尤其是放大之后，鼠标点击的是否是对应放大之后的坐标值，还是x轴的真实数据          
                        tempy = e.Y + pnlDO1.Location.Y;


                        Rectangle rectangle1 = pnlDO1.RectangleToScreen(this.ClientRectangle);
                        if (rectangle1.Contains(MousePosition))
                        {
                            //if (tempx >= 73 && tempx <= 410 && tempy >= 33 && tempy <= 240)
                            //{
                            double xValue = Convert.ToDouble(picPH.Series[0].GetHorizAxis.CalcPosPoint(tempx).ToString());

                            int xRealValue = (int)(xValue + 0.5);
                            double yRealValue = Convert.ToDouble(draw.arrayADLValue[xRealValue - 1]);

                            string savedate = Convert.ToString(draw.arrayADLDate[xRealValue - 1]);

                            if (draw.arrayADLValue.Count <= 1000)
                            {
                                yRealValue = Convert.ToDouble(draw.arrayADLValue[xRealValue - 1]);

                                savedate = Convert.ToString(draw.arrayADLDate[xRealValue - 1]);
                            }
                            else
                            {
                                yRealValue = Convert.ToDouble(draw.arrayADLValue[xRealValue - 1 + draw.arrayADLValue.Count - 1000]);

                                savedate = Convert.ToString(draw.arrayADLDate[xRealValue - 1 + draw.arrayADLDate.Count - 1000]);
                            }

                            if (e.Location.X + pnlADL1.Location.X + lblADL.Width > picPH.Width)
                            {
                                tempx = picPH.Width - (int)(lblADL.Width * 1.5);
                            }

                            if (e.Location.Y + pnlADL1.Location.Y + lblADL.Height > picPH.Height)
                            {
                                tempy = picPH.Height - lblADL.Height;
                            }

                            if (e.Location.Y + pnlADL1.Location.Y - lblADL.Height < pnlADL1.Location.Y)
                            {
                                tempy = pnlADL1.Location.Y + picPH.Height / 3;
                            }

                            lblADL.Text = "Time:" + savedate + "\n" + "Data:" + yRealValue;
                            lblADL.Location = new Point(tempx + 30, tempy + picPH.Location.Y - 60);
                            lblADL.Visible = true;
                            // lblDO.BackColor = Color.FromArgb(234, 234, 234);
                            //lblADL.BackColor = Color.White;
                        }
                        else
                            lblADL.Visible = false;
                    }
                }

                else//图形最大化之后鼠标移动，数据在周围进行显示
                {
                    if (draw.arrayADLValue.Count == 0)
                    {
                        //MessageBox.Show("溶解氧没有采集数据！");
                        lblADLB.Visible = false;
                    }
                    else
                    {
                        //int tempx, tempy;
                        //tempx = e.X;//这样得到的是鼠标的坐标值还是真实的x值数据，尤其是放大之后，鼠标点击的是否是对应放大之后的坐标值，还是x轴的真实数据          
                        //tempy = e.Y;

                        int tempx, tempy;

                        tempx = e.Location.X + picPH.Location.X;//这样得到的是鼠标的坐标值还是真实的x值数据，尤其是放大之后，鼠标点击的是否是对应放大之后的坐标值，还是x轴的真实数据          
                        tempy = e.Location.Y + picPH.Location.Y;


                        Rectangle rectangle1 = picPH.RectangleToScreen(this.ClientRectangle);
                        if (rectangle1.Contains(MousePosition))
                        {

                            double xValue = Convert.ToDouble(picPH.Series[0].GetHorizAxis.CalcPosPoint(tempx).ToString());

                            int xRealValue = (int)(xValue + 0.5);

                            double yRealValue = Convert.ToDouble(draw.arrayADLValue[xRealValue - 1]);

                            string savedate = Convert.ToString(draw.arrayADLDate[xRealValue - 1]);

                            if (draw.arrayADLValue.Count <= 1000)
                            {
                                yRealValue = Convert.ToDouble(draw.arrayADLValue[xRealValue - 1]);

                                savedate = Convert.ToString(draw.arrayADLDate[xRealValue - 1]);
                            }
                            else
                            {
                                yRealValue = Convert.ToDouble(draw.arrayADLValue[xRealValue - 1 + draw.arrayADLValue.Count - 1000]);

                                savedate = Convert.ToString(draw.arrayADLDate[xRealValue - 1 + draw.arrayADLDate.Count - 1000]);
                            }


                            if (e.Location.X + picPH.Location.X + lblADLB.Width > picPH.Width)
                            {
                                tempx = picPH.Width - (int)(lblADLB.Width * 1.5);
                            }

                            if (e.Location.Y + picPH.Location.Y + lblADL.Height > picPH.Height)
                            {
                                tempy = picPH.Height - lblADLB.Height;
                            }

                            if (e.Location.Y + picPH.Location.Y - lblADLB.Height < picPH.Location.Y)
                            {
                                tempy = picPH.Location.Y + picPH.Height / 2;
                            }

                            lblADLB.Text = "Time:" + savedate + "\n" + "Data:" + yRealValue;
                            lblADLB.BackColor = Color.FromArgb(240, 248, 255);
                            //lblADLB.BackColor = Color.White;
                            lblADLB.Location = new Point(tempx + 30, tempy-60);
                            lblADLB.Visible = true;
                        }

                        else
                            lblADLB.Visible = false;


                    }

                }

            }
            catch
            {
                //MessageBox.Show("鼠标点击值出现异常！" + exp.Message);
            }
        }
        

       
        /// <summary>
        /// 改变安德拉溶解氧坐标轴显示范围
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void button20_Click(object sender, EventArgs e)
        {
            SetPicScope mySetPicScope = new SetPicScope(9,this);
            mySetPicScope.Show();
        }
        /// <summary>
        /// 改变CTD坐标轴显示范围
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void button21_Click(object sender, EventArgs e)
        {
            SetPicScope mySetPicScope = new SetPicScope(10,this);
            mySetPicScope.Show();
        }
        /// <summary>
        /// 多参数坐标轴显示范围改变
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void button22_Click(object sender, EventArgs e)
        {
            SetPicScope mySetPicScope = new SetPicScope(11,this);
            mySetPicScope.Show();
        }

        private void picCTD_MouseMove(object sender, MouseEventArgs e)
        {
            try
            {
                lblDO.Visible = false;
                lblMulti.Visible = false;
                lblADL.Visible = false;


                if (changedCTD == false)
                {
                    if (draw.arrayCTD_CValue.Count == 0)
                    {

                        lblCTD.Visible = false;
                    }
                    else
                    {
                        int tempx, tempy;
                        tempx = e.X;//这样得到的是鼠标的坐标值还是真实的x值数据，尤其是放大之后，鼠标点击的是否是对应放大之后的坐标值，还是x轴的真实数据          
                        tempy = e.Y;

                        Rectangle rectangle = picCTD.RectangleToScreen(this.ClientRectangle);
                        if (rectangle.Contains(MousePosition))
                        {

                            double xValue = Convert.ToDouble(picCTD.Series[0].GetHorizAxis.CalcPosPoint(tempx).ToString());

                            int xRealValue = (int)(xValue + 0.5);
                            string savedate = Convert.ToString(draw.arrayCTDDate[xRealValue - 1]);
                            double yCTD_CValue = Convert.ToDouble(draw.arrayCTD_CValue[xRealValue - 1]);
                            double yCTD_TValue = Convert.ToDouble(draw.arrayCTD_TValue[xRealValue - 1]);
                            double yCTD_DValue = Convert.ToDouble(draw.arrayCTD_DValue[xRealValue - 1]);
                            double yCTD_SValue = Convert.ToDouble(draw.arrayCTD_SValue[xRealValue - 1]);

                            

                            if (draw.arrayCTD_CValue.Count <= 1000)
                            {
                                yCTD_CValue = Convert.ToDouble(draw.arrayCTD_CValue[xRealValue - 1]);
                                yCTD_TValue = Convert.ToDouble(draw.arrayCTD_TValue[xRealValue - 1]);
                                yCTD_DValue = Convert.ToDouble(draw.arrayCTD_DValue[xRealValue - 1]);
                                yCTD_SValue = Convert.ToDouble(draw.arrayCTD_SValue[xRealValue - 1]);

                                savedate = Convert.ToString(draw.arrayCTDDate[xRealValue - 1]);

                            }
                            else
                            {
                                yCTD_CValue = Convert.ToDouble(draw.arrayCTD_CValue[xRealValue - 1 + draw.arrayCTD_CValue.Count - 1000]);
                                yCTD_TValue = Convert.ToDouble(draw.arrayCTD_TValue[xRealValue - 1 + draw.arrayCTD_TValue.Count - 1000]);
                                yCTD_DValue = Convert.ToDouble(draw.arrayCTD_DValue[xRealValue - 1 + draw.arrayCTD_DValue.Count - 1000]);
                                yCTD_SValue = Convert.ToDouble(draw.arrayCTD_SValue[xRealValue - 1 + draw.arrayCTD_SValue.Count - 1000]);

                                savedate = Convert.ToString(draw.arrayCTDDate[xRealValue - 1 + draw.arrayCTDDate.Count - 1000]);
                            }


                            if (e.Location.X + lblCTD.Width > picCTD.Width)
                            {
                                tempx = picCTD.Width - (int)(lblCTD.Width * 1.5);
                            }

                            if (e.Location.Y + picCTD.Location.Y + lblCTD.Height > picCTD.Height)
                            {
                                tempy = picCTD.Height - lblCTD.Height;
                            }

                            if (e.Location.Y + picCTD.Location.Y - lblCTD.Height < picCTD.Location.Y)
                            {
                                tempy = picCTD.Location.Y + picCTD.Height / 3;
                            }

                            lblCTD.Text = "Time:" + savedate + "\n" + "Con:" + yCTD_CValue.ToString("0.00") +"mS/cm "+ "Tem:" + yCTD_TValue.ToString("0.00") +"℃"+ "\n" + "Dep:" + yCTD_DValue.ToString("0.00") +"m "+ "Sal:" + yCTD_SValue.ToString("0.00");
                            lblCTD.Location = new Point(tempx + 30, tempy + picCTD.Location.Y - 60);
                            lblCTD.Visible = true;
                           // lblCTD.BackColor = Color.FromArgb(234, 234, 234);
                            // lblBTemp.BackColor = Color.White;
                        }
                        else
                            lblCTD.Visible = false;
                    }
                }

                else
                {


                    if (draw.arrayCTD_CValue.Count == 0)
                    {
                        lblCTDB.Visible = false;
                    }
                    else
                    {
                        int tempx, tempy;
                        tempx = e.Location.X + picCTD.Location.X;//这样得到的是鼠标的坐标值还是真实的x值数据，尤其是放大之后，鼠标点击的是否是对应放大之后的坐标值，还是x轴的真实数据          
                        tempy = e.Location.Y + picCTD.Location.Y;


                        Rectangle rectangle1 = picCTD.RectangleToScreen(this.ClientRectangle);
                        if (rectangle1.Contains(MousePosition))
                        {

                            double xValue = Convert.ToDouble(picCTD.Series[0].GetHorizAxis.CalcPosPoint(tempx).ToString());

                            int xRealValue = (int)(xValue + 0.5);                        
                            string savedate = Convert.ToString(draw.arrayCTDDate[xRealValue - 1]);

                            double yCTD_CValue = Convert.ToDouble(draw.arrayCTD_CValue[xRealValue - 1]);
                            double yCTD_TValue = Convert.ToDouble(draw.arrayCTD_TValue[xRealValue - 1]);
                            double yCTD_DValue = Convert.ToDouble(draw.arrayCTD_DValue[xRealValue - 1]);
                            double yCTD_SValue = Convert.ToDouble(draw.arrayCTD_SValue[xRealValue - 1]);



                            if (draw.arrayCTD_CValue.Count <= 1000)
                            {                              
                                savedate = Convert.ToString(draw.arrayCTDDate[xRealValue - 1]);

                                yCTD_CValue = Convert.ToDouble(draw.arrayCTD_CValue[xRealValue - 1]);
                                yCTD_TValue = Convert.ToDouble(draw.arrayCTD_TValue[xRealValue - 1]);
                                yCTD_DValue = Convert.ToDouble(draw.arrayCTD_DValue[xRealValue - 1]);
                                yCTD_SValue = Convert.ToDouble(draw.arrayCTD_SValue[xRealValue - 1]);

                            }
                            else
                            {
                                //yRealValue = Convert.ToDouble(draw.arrayBTemp[xRealValue - 1 + draw.arrayBTemp.Count - 1000]);
                                yCTD_CValue = Convert.ToDouble(draw.arrayCTD_CValue[xRealValue - 1 + draw.arrayCTD_CValue.Count - 1000]);
                                yCTD_TValue = Convert.ToDouble(draw.arrayCTD_TValue[xRealValue - 1 + draw.arrayCTD_TValue.Count - 1000]);
                                yCTD_DValue = Convert.ToDouble(draw.arrayCTD_DValue[xRealValue - 1 + draw.arrayCTD_DValue.Count - 1000]);
                                yCTD_SValue = Convert.ToDouble(draw.arrayCTD_SValue[xRealValue - 1 + draw.arrayCTD_SValue.Count - 1000]);

                                savedate = Convert.ToString(draw.arrayCTDDate[xRealValue - 1 + draw.arrayCTDDate.Count - 1000]);
                            }


                            if (e.Location.X + picCTD.Location.X + lblCTDB.Width > picCTD.Width)
                            {
                                tempx = picCTD.Width - (int)(lblCTDB.Width * 1.5);
                            }

                            if (e.Location.Y + picCTD.Location.Y + lblCTD.Height > picCTD.Height)
                            {
                                tempy = picCTD.Height - lblCTDB.Height;
                            }

                            if (e.Location.Y + picCTD.Location.Y - lblCTDB.Height < picCTD.Location.Y)
                            {
                                tempy = picCTD.Location.Y + picCTD.Height / 2;
                            }

                            lblCTDB.Text = "Time:" + savedate + "\n" + "Con:" + yCTD_CValue.ToString("0.00")+"mS/cm "+"Tem:"+yCTD_TValue.ToString("0.00")+"℃"+"\n" + "Dep:"+yCTD_DValue.ToString("0.00")+"m "+"Sal:"+yCTD_SValue.ToString("0.00");
                           // lblCTDB.BackColor = Color.FromArgb(234, 234, 234);
                            //lblBTempB.BackColor = Color.White;
                            lblCTDB.Location = new Point(tempx + 30, tempy - 90);
                            lblCTDB.Visible = true;
                            lblCTDB.BackColor = Color.FromArgb(240, 248, 255);

                        }

                        else
                            lblCTDB.Visible = false;

                    }


                }




            }
            catch
            {
 
            }
        }
        /// <summary>
        /// 鼠标移动到标题栏上面时所有的图形备注标签全部隐藏
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void pictureBox1_MouseMove(object sender, MouseEventArgs e)
        {
            try
            {
                lblACh0.Visible = false;
                lblACh1.Visible = false;
                lblACh2.Visible = false;
                lblBCh1.Visible = false;
                lblBCh2.Visible = false;
                lblTemp.Visible = false;
                lblDO.Visible = false;
                lblCTD.Visible = false;
                lblADL.Visible = false;
                lblMulti.Visible = false;


                lblACh0B.Visible = false;
                lblACh1B.Visible = false;
                lblACh2B.Visible = false;
                lblBCh1B.Visible = false;
                lblBCh2B.Visible = false;
                lblTempB.Visible = false;

                lblDOB.Visible = false;
                lblADLB.Visible = false;
                lblMultiB.Visible = false;
                lblCTDB.Visible = false;
            }
            catch(Exception exp)
            {
                LogClass.WriteLogFile("异常！"+exp.Message);
            }
        }

        private void button14_Click_1(object sender, EventArgs e)
        {
            SetPicScope mySetPicScope = new SetPicScope(7, this);
            mySetPicScope.Show();
        }
        /// <summary>
        /// 数据采集器2地址栏按下回车键
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void textBox1_KeyDown(object sender, KeyEventArgs e)
        {
            this.Cursor = Cursors.WaitCursor;
            showWebContent(txtAddr2,wb2);
            this.Cursor = Cursors.Default;
        }
        /// <summary>
        /// 水下摄像头2按下执行按钮转到对应的网页中
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void button16_Click(object sender, EventArgs e)
        {
            this.Cursor = Cursors.WaitCursor;
            showWebContent(txtAddr2,wb2);
            this.Cursor = Cursors.Default;
        }
        /// <summary>
        /// 只显示电导率曲线
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void 显示电导率曲线ToolStripMenuItem_Click(object sender, EventArgs e)
        {
            picCTD.Series[0].Visible = true;
            picCTD.Series[1].Visible = false;
            picCTD.Series[2].Visible = false;
            picCTD.Series[3].Visible = false;
        }

        private void 显示温度曲线ToolStripMenuItem_Click(object sender, EventArgs e)
        {
            picCTD.Series[0].Visible = false;
            picCTD.Series[1].Visible = true;
            picCTD.Series[2].Visible = false;
            picCTD.Series[3].Visible = false;
        }

        private void 显示深度曲线ToolStripMenuItem_Click(object sender, EventArgs e)
        {
            picCTD.Series[0].Visible = false;
            picCTD.Series[1].Visible = false;
            picCTD.Series[2].Visible = true;
            picCTD.Series[3].Visible = false;
        }

        private void 显示盐度曲线ToolStripMenuItem_Click(object sender, EventArgs e)
        {
            picCTD.Series[0].Visible = false;
            picCTD.Series[1].Visible = false;
            picCTD.Series[2].Visible = false;
            picCTD.Series[3].Visible = true;
        }

        private void 全部显示ToolStripMenuItem_Click(object sender, EventArgs e)
        {
            picCTD.Series[0].Visible = true;
            picCTD.Series[1].Visible = true;
            picCTD.Series[2].Visible = true;
            picCTD.Series[3].Visible = true;
        }

        private void 显示配置ToolStripMenuItem_Click(object sender, EventArgs e)
        {
            ShowCTDFigure myShowCTDFigure = new ShowCTDFigure(picCTD);
            myShowCTDFigure.Show();
            myShowCTDFigure.BackColor = Color.FromArgb(240, 248, 255);
        }
        /// <summary>
        /// 多参数传感器随鼠标移动而进行变化
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void picMultiPara_MouseMove(object sender, MouseEventArgs e)
        {
            try
            {
                lblDO.Visible = false;
                lblCTD.Visible = false;
                lblADL.Visible = false;


                if (changedCDOM == false)
                {
                    if (draw.arrayChlValue.Count == 0)
                    {

                        lblMulti.Visible = false;
                    }
                    else
                    {
                        int tempx, tempy;
                        tempx = e.X;//这样得到的是鼠标的坐标值还是真实的x值数据，尤其是放大之后，鼠标点击的是否是对应放大之后的坐标值，还是x轴的真实数据          
                        tempy = e.Y;

                        Rectangle rectangle = picMultiPara.RectangleToScreen(this.ClientRectangle);
                        if (rectangle.Contains(MousePosition))
                        {

                            double xValue = Convert.ToDouble(picMultiPara.Series[0].GetHorizAxis.CalcPosPoint(tempx).ToString());

                            int xRealValue = (int)(xValue + 0.5);
                            string savedate = Convert.ToString(draw.arrayChlTurDate[xRealValue - 1]);
                            double yM_ChlValue = Convert.ToDouble(draw.arrayChlValue[xRealValue - 1]);
                            double yM_TurValue = Convert.ToDouble(draw.arrayTurValue[xRealValue - 1]);
                            double yM_PhyValue = Convert.ToDouble(draw.arrayCTTemp[xRealValue - 1]);
                           // double yCTD_SValue = Convert.ToDouble(draw.arrayCTD_SValue[xRealValue - 1]);



                            if (draw.arrayChlValue.Count <= 1000)
                            {
                                yM_ChlValue = Convert.ToDouble(draw.arrayChlValue[xRealValue - 1]);
                                yM_TurValue = Convert.ToDouble(draw.arrayTurValue[xRealValue - 1]);
                                yM_PhyValue = Convert.ToDouble(draw.arrayCTTemp[xRealValue - 1]);
                                //yCTD_SValue = Convert.ToDouble(draw.arrayCTD_SValue[xRealValue - 1]);

                                savedate = Convert.ToString(draw.arrayChlTurDate[xRealValue - 1]);

                            }
                            else
                            {
                                yM_ChlValue = Convert.ToDouble(draw.arrayChlValue[xRealValue - 1 + draw.arrayChlValue.Count - 1000]);
                                yM_TurValue = Convert.ToDouble(draw.arrayTurValue[xRealValue - 1 + draw.arrayTurValue.Count - 1000]);
                                yM_PhyValue = Convert.ToDouble(draw.arrayCTTemp[xRealValue - 1 + draw.arrayCTTemp.Count - 1000]);
                                //yCTD_SValue = Convert.ToDouble(draw.arrayCTD_SValue[xRealValue - 1 + draw.arrayCTD_SValue.Count - 1000]);

                                savedate = Convert.ToString(draw.arrayChlTurDate[xRealValue - 1 + draw.arrayChlTurDate.Count - 1000]);
                            }


                            if (e.Location.X + lblMulti.Width > picMultiPara.Width)
                            {
                                tempx = picMultiPara.Width - (int)(lblMulti.Width * 1.5);
                            }

                            if (e.Location.Y + picMultiPara.Location.Y + lblMulti.Height > picMultiPara.Height)
                            {
                                tempy = picMultiPara.Height - lblMulti.Height;
                            }

                            if (e.Location.Y + picMultiPara.Location.Y - lblMulti.Height < picMultiPara.Location.Y)
                            {
                                tempy = picMultiPara.Location.Y + picMultiPara.Height / 3;
                            }

                            lblMulti.Text = "Time:" + savedate + "\n" + "Chl:" + yM_ChlValue.ToString("0.000") + "μg/L " + "Tur:" + yM_TurValue.ToString("0.000") + "μg/L" + "\n" + "Temp:" + yM_PhyValue.ToString("0.000") + "℃";
                            lblMulti.Location = new Point(tempx + 30, tempy + picMultiPara.Location.Y - 60);
                            lblMulti.Visible = true;
                            // lblCTD.BackColor = Color.FromArgb(234, 234, 234);
                            // lblBTemp.BackColor = Color.White;
                        }
                        else
                            lblMulti.Visible = false;
                    }
                }

                else
                {


                    if (draw.arrayChlValue.Count == 0)
                    {
                        lblMultiB.Visible = false;
                    }
                    else
                    {
                        int tempx, tempy;
                        tempx = e.Location.X + picMultiPara.Location.X;//这样得到的是鼠标的坐标值还是真实的x值数据，尤其是放大之后，鼠标点击的是否是对应放大之后的坐标值，还是x轴的真实数据          
                        tempy = e.Location.Y + picMultiPara.Location.Y;


                        Rectangle rectangle1 = picMultiPara.RectangleToScreen(this.ClientRectangle);
                        if (rectangle1.Contains(MousePosition))
                        {

                            double xValue = Convert.ToDouble(picMultiPara.Series[0].GetHorizAxis.CalcPosPoint(tempx).ToString());

                            int xRealValue = (int)(xValue + 0.5);
                            string savedate = Convert.ToString(draw.arrayChlTurDate[xRealValue - 1]);

                            double yM_ChlValue = Convert.ToDouble(draw.arrayChlValue[xRealValue - 1]);
                            double yM_TurValue = Convert.ToDouble(draw.arrayTurValue[xRealValue - 1]);
                            double yM_PhyValue = Convert.ToDouble(draw.arrayCTTemp[xRealValue - 1]);
                            //double yCTD_SValue = Convert.ToDouble(draw.arrayCTD_SValue[xRealValue - 1]);



                            if (draw.arrayChlValue.Count <= 1000)
                            {
                                savedate = Convert.ToString(draw.arrayChlTurDate[xRealValue - 1]);

                                yM_ChlValue = Convert.ToDouble(draw.arrayChlValue[xRealValue - 1]);
                                yM_TurValue = Convert.ToDouble(draw.arrayTurValue[xRealValue - 1]);
                                yM_PhyValue = Convert.ToDouble(draw.arrayCTTemp[xRealValue - 1]);
                               

                            }
                            else
                            {
                                //yRealValue = Convert.ToDouble(draw.arrayBTemp[xRealValue - 1 + draw.arrayBTemp.Count - 1000]);
                                yM_ChlValue = Convert.ToDouble(draw.arrayChlValue[xRealValue - 1 + draw.arrayChlValue.Count - 1000]);
                                yM_TurValue = Convert.ToDouble(draw.arrayTurValue[xRealValue - 1 + draw.arrayTurValue.Count - 1000]);
                                yM_PhyValue = Convert.ToDouble(draw.arrayCTTemp[xRealValue - 1 + draw.arrayCTTemp.Count - 1000]);


                                savedate = Convert.ToString(draw.arrayChlTurDate[xRealValue - 1 + draw.arrayChlTurDate.Count - 1000]);
                            }


                            if (e.Location.X + picMultiPara.Location.X + lblMultiB.Width > picMultiPara.Width)
                            {
                                tempx = picMultiPara.Width - (int)(lblMultiB.Width * 1.5);
                            }

                            if (e.Location.Y + picMultiPara.Location.Y + lblMulti.Height > picMultiPara.Height)
                            {
                                tempy = picMultiPara.Height - lblMultiB.Height;
                            }

                            if (e.Location.Y + picMultiPara.Location.Y - lblMultiB.Height < picMultiPara.Location.Y)
                            {
                                tempy = picMultiPara.Location.Y + picMultiPara.Height / 2;
                            }

                            lblMultiB.Text = "Time:" + savedate + "\n" + "Chl:" + yM_ChlValue.ToString("0.000") + "μg/L " + "Tur:" + yM_TurValue.ToString("0.000") + "μg/L" + "\n" + "Temp:" + yM_PhyValue.ToString("0.000") + "℃ ";
                            // lblCTDB.BackColor = Color.FromArgb(234, 234, 234);
                            //lblBTempB.BackColor = Color.White;
                            lblMultiB.Location = new Point(tempx + 30, tempy - 90);
                            lblMultiB.Visible = true;
                            lblMultiB.BackColor = Color.FromArgb(240, 248, 255);

                        }

                        else
                            lblMultiB.Visible = false;

                    }


                }

            }
            catch
            {

            }
        }
        /// <summary>
        /// 执行接驳盒通道3打开指令
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void Ch3Open_Click(object sender, EventArgs e)
        {
            this.Cursor = Cursors.WaitCursor;
            _3ReceieveMsgClass.flagOnA3 = 0;
            try
            {
                LogCommand.WriteLogFile("执行接驳盒执行通道3打开！");
                if (canBConnect.Text == "连接")
                {
                    for (int i = _1MySerClass.userList.Count - 1; i >= 0; i--)
                    {
                        _3ReceieveMsgClass ct = _1MySerClass.userList[i];
                        if (!ct.tcpClient.Connected || ((ct.tcpClient.Poll(1000, SelectMode.SelectRead)) && (ct.tcpClient.Available == 0)))
                        {
                            _1MySerClass.userList.Remove(ct);
                            continue;
                        }
                        else if (ct.nodeIP == txtBIP.Text.Trim())
                        {
                            ct.SendMessage("$SET+01+SIIM3+Power12V#", 2);

                            if (Delay(1))//延时10s
                            {
                                if (_3ReceieveMsgClass.flagOnA3 == 1)
                                {
                                    MessageBox.Show("执行成功！");
                                    LogCommand.WriteLogFile("接驳盒执行通道3打开成功！");
                                    this.txtBCh3Status.Text = "打开";
                                    this.txtBCh3Status.BackColor = Color.DarkSeaGreen;
                                    this.txtBCh3Status.ForeColor = Color.White;

                                    Ch3Open.Enabled = false;
                                    Ch3Close.Enabled = true;
                                }
                                else
                                {
                                    ct.SendMessage("$SET+01+SIIM3+Power12V#", 2);//第二次重发
                                    Delay(2);

                                    if (_3ReceieveMsgClass.flagOnA3 == 1)
                                    {
                                        MessageBox.Show("执行成功！");
                                        LogCommand.WriteLogFile("接驳盒执行通道3打开成功！");
                                        this.txtBCh3Status.Text = "打开";
                                        this.txtBCh3Status.BackColor = Color.DarkSeaGreen;
                                        this.txtBCh3Status.ForeColor = Color.White;

                                        Ch3Open.Enabled = false;
                                        Ch3Close.Enabled = true;
                                    }
                                    else
                                    {
                                        ct.SendMessage("$SET+01+SIIM3+Power12V#", 2);//第3次重发
                                        Delay(2);

                                        if (_3ReceieveMsgClass.flagOnA3 == 1)
                                        {
                                            MessageBox.Show("执行成功！");
                                            LogCommand.WriteLogFile("接驳盒执行通道3打开成功！");
                                            this.txtBCh3Status.Text = "打开";
                                            this.txtBCh3Status.BackColor = Color.DarkSeaGreen;
                                            this.txtBCh3Status.ForeColor = Color.White;

                                            Ch3Open.Enabled = false;
                                            Ch3Close.Enabled = true;
                                        }
                                        else
                                        {
                                            MessageBox.Show("执行失败！");
                                            LogCommand.WriteLogFile("接驳盒执行通道3打开失败！");
                                            Ch3Open.Enabled = true;
                                            Ch3Close.Enabled = false;
                                            this.txtBCh3Status.Text = "打开失败";
                                            this.txtBCh3Status.ForeColor = Color.Black;
                                            this.txtBCh3Status.BackColor = Color.Yellow;
                                        }
                                    }
                                }
                            }
                            break;
                        }
                        //else
                        //{
                        //    MessageBox.Show("无有效连接！");
                        //}
                    }
                }
                else
                {
                    MessageBox.Show("无可用连接！");
                }
            }
            catch (Exception exp)
            {
                LogClass.WriteLogFile("接驳盒执行通道2打开异常！" + exp.Message);
            }
            _3ReceieveMsgClass.flagOnA3 = 0;
            this.Cursor = Cursors.Default;
        }
        /// <summary>
        /// 接驳盒舱内通道4打开
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void Ch4Open_Click(object sender, EventArgs e)
        {
            this.Cursor = Cursors.WaitCursor;
            _3ReceieveMsgClass.flagOnA4 = 0;
            try
            {
                LogCommand.WriteLogFile("执行接驳盒执行通道4打开！");
                if (canBConnect.Text == "连接")
                {
                    for (int i = _1MySerClass.userList.Count - 1; i >= 0; i--)
                    {
                        _3ReceieveMsgClass ct = _1MySerClass.userList[i];
                        if (!ct.tcpClient.Connected || ((ct.tcpClient.Poll(1000, SelectMode.SelectRead)) && (ct.tcpClient.Available == 0)))
                        {
                            _1MySerClass.userList.Remove(ct);
                            continue;
                        }
                        else if (ct.nodeIP == txtBIP.Text.Trim())
                        {
                            ct.SendMessage("$SET+01+SIIM4+Power12V#", 2);

                            if (Delay(1))//延时10s
                            {
                                if (_3ReceieveMsgClass.flagOnA4 == 1)
                                {
                                    MessageBox.Show("执行成功！");
                                    LogCommand.WriteLogFile("接驳盒执行通道4打开成功！");
                                    this.txtBCh4Status.Text = "打开";
                                    this.txtBCh4Status.BackColor = Color.DarkSeaGreen;
                                    this.txtBCh4Status.ForeColor = Color.White;

                                    Ch4Open.Enabled = false;
                                    Ch4Close.Enabled = true;
                                }
                                else
                                {
                                    ct.SendMessage("$SET+01+SIIM4+Power12V#", 2);//第二次重发
                                    Delay(2);

                                    if (_3ReceieveMsgClass.flagOnA4 == 1)
                                    {
                                        MessageBox.Show("执行成功！");
                                        LogCommand.WriteLogFile("接驳盒执行通道4打开成功！");
                                        this.txtBCh4Status.Text = "打开";
                                        this.txtBCh4Status.BackColor = Color.DarkSeaGreen;
                                        this.txtBCh4Status.ForeColor = Color.White;

                                        Ch4Open.Enabled = false;
                                        Ch4Close.Enabled = true;
                                    }
                                    else
                                    {
                                        ct.SendMessage("$SET+01+SIIM4+Power12V#", 2);//第3次重发
                                        Delay(2);

                                        if (_3ReceieveMsgClass.flagOnA4 == 1)
                                        {
                                            MessageBox.Show("执行成功！");
                                            LogCommand.WriteLogFile("接驳盒执行通道4打开成功！");
                                            this.txtBCh4Status.Text = "打开";
                                            this.txtBCh4Status.BackColor = Color.DarkSeaGreen;
                                            this.txtBCh4Status.ForeColor = Color.White;

                                            Ch4Open.Enabled = false;
                                            Ch4Close.Enabled = true;
                                        }
                                        else
                                        {
                                            MessageBox.Show("执行失败！");
                                            LogCommand.WriteLogFile("接驳盒执行通道4打开失败！");
                                            Ch4Open.Enabled = true;
                                            Ch4Close.Enabled = false;
                                            this.txtBCh4Status.Text = "打开失败";
                                            this.txtBCh4Status.ForeColor = Color.Black;
                                            this.txtBCh4Status.BackColor = Color.Yellow;
                                        }
                                    }
                                }
                            }
                            break;
                        }
                        //else
                        //{
                        //    MessageBox.Show("无有效连接！");
                        //}
                    }
                }
                else
                {
                    MessageBox.Show("无可用连接！");
                }
            }
            catch (Exception exp)
            {
                LogClass.WriteLogFile("接驳盒执行通道4打开异常！" + exp.Message);
            }
            _3ReceieveMsgClass.flagOnA4 = 0;
            this.Cursor = Cursors.Default;
        }
        /// <summary>
        /// 接驳盒舱内通道5打开
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void Ch5Open_Click(object sender, EventArgs e)
        {
            this.Cursor = Cursors.WaitCursor;
            _3ReceieveMsgClass.flagOnA5 = 0;
            try
            {
                LogCommand.WriteLogFile("执行接驳盒执行通道5打开！");
                if (canBConnect.Text == "连接")
                {
                    for (int i = _1MySerClass.userList.Count - 1; i >= 0; i--)
                    {
                        _3ReceieveMsgClass ct = _1MySerClass.userList[i];
                        if (!ct.tcpClient.Connected || ((ct.tcpClient.Poll(1000, SelectMode.SelectRead)) && (ct.tcpClient.Available == 0)))
                        {
                            _1MySerClass.userList.Remove(ct);
                            continue;
                        }
                        else if (ct.nodeIP == txtBIP.Text.Trim())
                        {
                            ct.SendMessage("$SET+01+SIIM5+Power12V#", 2);

                            if (Delay(1))//延时10s
                            {
                                if (_3ReceieveMsgClass.flagOnA5 == 1)
                                {
                                    MessageBox.Show("执行成功！");
                                    LogCommand.WriteLogFile("接驳盒执行通道5打开成功！");
                                    this.txtBCh5Status.Text = "打开";
                                    this.txtBCh5Status.BackColor = Color.DarkSeaGreen;
                                    this.txtBCh5Status.ForeColor = Color.White;

                                    Ch5Open.Enabled = false;
                                    Ch5Close.Enabled = true;
                                }
                                else
                                {
                                    ct.SendMessage("$SET+01+SIIM5+Power12V#", 2);//第二次重发
                                    Delay(2);

                                    if (_3ReceieveMsgClass.flagOnA5 == 1)
                                    {
                                        MessageBox.Show("执行成功！");
                                        LogCommand.WriteLogFile("接驳盒执行通道5打开成功！");
                                        this.txtBCh5Status.Text = "打开";
                                        this.txtBCh5Status.BackColor = Color.DarkSeaGreen;
                                        this.txtBCh5Status.ForeColor = Color.White;

                                        Ch5Open.Enabled = false;
                                        Ch5Close.Enabled = true;
                                    }
                                    else
                                    {
                                        ct.SendMessage("$SET+01+SIIM5+Power12V#", 2);//第3次重发
                                        Delay(2);

                                        if (_3ReceieveMsgClass.flagOnA5 == 1)
                                        {
                                            MessageBox.Show("执行成功！");
                                            LogCommand.WriteLogFile("接驳盒执行通道5打开成功！");
                                            this.txtBCh5Status.Text = "打开";
                                            this.txtBCh5Status.BackColor = Color.DarkSeaGreen;
                                            this.txtBCh5Status.ForeColor = Color.White;

                                            Ch5Open.Enabled = false;
                                            Ch5Close.Enabled = true;
                                        }
                                        else
                                        {
                                            MessageBox.Show("执行失败！");
                                            LogCommand.WriteLogFile("接驳盒执行通道5打开失败！");
                                            Ch5Open.Enabled = true;
                                            Ch5Close.Enabled = false;
                                            this.txtBCh5Status.Text = "打开失败";
                                            this.txtBCh5Status.ForeColor = Color.Black;
                                            this.txtBCh5Status.BackColor = Color.Yellow;
                                        }
                                    }
                                }
                            }
                            break;
                        }
                        //else
                        //{
                        //    MessageBox.Show("无有效连接！");
                        //}
                    }
                }
                else
                {
                    MessageBox.Show("无可用连接！");
                }
            }
            catch (Exception exp)
            {
                LogClass.WriteLogFile("接驳盒执行通道5打开异常！" + exp.Message);
            }
            _3ReceieveMsgClass.flagOnA5 = 0;
            this.Cursor = Cursors.Default;
        }
        /// <summary>
        /// 接驳盒通道3关闭
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void Ch3Close_Click(object sender, EventArgs e)
        {
            this.Cursor = Cursors.WaitCursor;
            _3ReceieveMsgClass.flagOffA3 = 0;
            try
            {
                LogCommand.WriteLogFile("执行接驳盒执行通道3关闭！");
                if (canBConnect.Text == "连接")
                {
                    for (int i = _1MySerClass.userList.Count - 1; i >= 0; i--)
                    {
                        _3ReceieveMsgClass ct = _1MySerClass.userList[i];
                        if (!ct.tcpClient.Connected || ((ct.tcpClient.Poll(1000, SelectMode.SelectRead)) && (ct.tcpClient.Available == 0)))
                        {
                            _1MySerClass.userList.Remove(ct);
                            continue;
                        }
                        else if (ct.nodeIP == txtBIP.Text.Trim())
                        {
                            ct.SendMessage("$SET+01+SIIM3+Close#", 2);

                            if (Delay(1))//延时10s
                            {
                                if (_3ReceieveMsgClass.flagOffA3 == 1)
                                {
                                    MessageBox.Show("执行成功！");
                                    LogCommand.WriteLogFile("接驳盒执行通道3关闭成功！");
                                    Ch3Close.Enabled = false;
                                    Ch3Open.Enabled = true;
                                    this.txtBCh3Status.Text = "关闭";
                                    this.txtBCh3Status.BackColor = Color.Red;
                                    this.txtBCh3Status.ForeColor = Color.White;

                                    this.txtBCh3Logo.Text = "正常";
                                    this.txtBCh3Logo.BackColor = Color.DarkSeaGreen;
                                    this.txtBCh3Logo.ForeColor = Color.White;
                                }
                                else
                                {

                                    ct.SendMessage("$SET+01+SIIM3+Close#", 2);//第二次重发
                                    Delay(2);

                                    if (_3ReceieveMsgClass.flagOffA3 == 1)
                                    {
                                        MessageBox.Show("执行成功！");
                                        LogCommand.WriteLogFile("接驳盒执行通道3关闭成功！");
                                        Ch3Close.Enabled = false;
                                        Ch3Open.Enabled = true;
                                        this.txtBCh3Status.Text = "关闭";
                                        this.txtBCh3Status.BackColor = Color.Red;
                                        this.txtBCh3Status.ForeColor = Color.White;

                                        this.txtBCh3Logo.Text = "正常";
                                        this.txtBCh3Logo.BackColor = Color.DarkSeaGreen;
                                        this.txtBCh3Logo.ForeColor = Color.White;
                                    }
                                    else
                                    {
                                        ct.SendMessage("$SET+01+SIIM3+Close#", 2);//第3次重发
                                        Delay(2);

                                        if (_3ReceieveMsgClass.flagOffA3 == 1)
                                        {
                                            MessageBox.Show("执行成功！");
                                            LogCommand.WriteLogFile("接驳盒执行通道3关闭成功！");
                                            Ch3Close.Enabled = false;
                                            Ch3Open.Enabled = true;
                                            this.txtBCh3Status.Text = "关闭";
                                            this.txtBCh3Status.BackColor = Color.Red;
                                            this.txtBCh3Status.ForeColor = Color.White;

                                            this.txtBCh3Logo.Text = "正常";
                                            this.txtBCh3Logo.BackColor = Color.DarkSeaGreen;
                                            this.txtBCh3Logo.ForeColor = Color.White;
                                        }
                                        else
                                        {
                                            MessageBox.Show("执行失败！");
                                            LogCommand.WriteLogFile("接驳盒执行通道3关闭失败！");
                                            this.txtBCh3Status.Text = "关闭失败";
                                            this.txtBCh3Status.ForeColor = Color.Black;
                                            this.txtBCh3Status.BackColor = Color.Yellow;
                                            Ch3Close.Enabled = true;
                                            Ch3Open.Enabled = false;
                                        }
                                    }
                                }
                            }
                            break;
                        }
                        //else
                        //{
                        //    MessageBox.Show("无有效连接！");
                        //}
                    }
                }
                else
                {
                    MessageBox.Show("无可用连接！");
                }
            }
            catch (Exception exp)
            {
                LogClass.WriteLogFile("接驳盒执行通道3关闭异常！" + exp.Message);
            }
            _3ReceieveMsgClass.flagOffA3 = 0;
            this.Cursor = Cursors.Default; 
        }
        /// <summary>
        /// 通道4关闭
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void Ch4Close_Click(object sender, EventArgs e)
        {
            this.Cursor = Cursors.WaitCursor;
            _3ReceieveMsgClass.flagOffA4 = 0;
            try
            {
                LogCommand.WriteLogFile("执行接驳盒执行通道4关闭！");
                if (canBConnect.Text == "连接")
                {
                    for (int i = _1MySerClass.userList.Count - 1; i >= 0; i--)
                    {
                        _3ReceieveMsgClass ct = _1MySerClass.userList[i];
                        if (!ct.tcpClient.Connected || ((ct.tcpClient.Poll(1000, SelectMode.SelectRead)) && (ct.tcpClient.Available == 0)))
                        {
                            _1MySerClass.userList.Remove(ct);
                            continue;
                        }
                        else if (ct.nodeIP == txtBIP.Text.Trim())
                        {
                            ct.SendMessage("$SET+01+SIIM4+Close#", 2);

                            if (Delay(1))//延时10s
                            {
                                if (_3ReceieveMsgClass.flagOffA4 == 1)
                                {
                                    MessageBox.Show("执行成功！");
                                    LogCommand.WriteLogFile("接驳盒执行通道4关闭成功！");
                                    Ch4Close.Enabled = false;
                                    Ch4Open.Enabled = true;
                                    this.txtBCh4Status.Text = "关闭";
                                    this.txtBCh4Status.BackColor = Color.Red;
                                    this.txtBCh4Status.ForeColor = Color.White;

                                    this.txtBCh4Logo.Text = "正常";
                                    this.txtBCh4Logo.BackColor = Color.DarkSeaGreen;
                                    this.txtBCh4Logo.ForeColor = Color.White;
                                }
                                else
                                {

                                    ct.SendMessage("$SET+01+SIIM4+Close#", 2);//第二次重发
                                    Delay(2);

                                    if (_3ReceieveMsgClass.flagOffA4 == 1)
                                    {
                                        MessageBox.Show("执行成功！");
                                        LogCommand.WriteLogFile("接驳盒执行通道4关闭成功！");
                                        Ch4Close.Enabled = false;
                                        Ch4Open.Enabled = true;
                                        this.txtBCh4Status.Text = "关闭";
                                        this.txtBCh4Status.BackColor = Color.Red;
                                        this.txtBCh4Status.ForeColor = Color.White;

                                        this.txtBCh4Logo.Text = "正常";
                                        this.txtBCh4Logo.BackColor = Color.DarkSeaGreen;
                                        this.txtBCh4Logo.ForeColor = Color.White;
                                    }
                                    else
                                    {
                                        ct.SendMessage("$SET+01+SIIM4+Close#", 2);//第3次重发
                                        Delay(2);

                                        if (_3ReceieveMsgClass.flagOffA4 == 1)
                                        {
                                            MessageBox.Show("执行成功！");
                                            LogCommand.WriteLogFile("接驳盒执行通道4关闭成功！");
                                            Ch4Close.Enabled = false;
                                            Ch4Open.Enabled = true;
                                            this.txtBCh4Status.Text = "关闭";
                                            this.txtBCh4Status.BackColor = Color.Red;
                                            this.txtBCh4Status.ForeColor = Color.White;

                                            this.txtBCh4Logo.Text = "正常";
                                            this.txtBCh4Logo.BackColor = Color.DarkSeaGreen;
                                            this.txtBCh4Logo.ForeColor = Color.White;
                                        }
                                        else
                                        {
                                            MessageBox.Show("执行失败！");
                                            LogCommand.WriteLogFile("接驳盒执行通道4关闭失败！");
                                            this.txtBCh4Status.Text = "关闭失败";
                                            this.txtBCh4Status.ForeColor = Color.Black;
                                            this.txtBCh4Status.BackColor = Color.Yellow;
                                            Ch4Close.Enabled = true;
                                            Ch4Open.Enabled = false;
                                        }
                                    }
                                }
                            }
                            break;
                        }
                        //else
                        //{
                        //    MessageBox.Show("无有效连接！");
                        //}
                    }
                }
                else
                {
                    MessageBox.Show("无可用连接！");
                }
            }
            catch (Exception exp)
            {
                LogClass.WriteLogFile("接驳盒执行通道4关闭异常！" + exp.Message);
            }
            _3ReceieveMsgClass.flagOffA4 = 0;
            this.Cursor = Cursors.Default; 
        }
        /// <summary>
        /// 通道5关闭
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void Ch5Close_Click(object sender, EventArgs e)
        {
            this.Cursor = Cursors.WaitCursor;
            _3ReceieveMsgClass.flagOffA5 = 0;
            try
            {
                LogCommand.WriteLogFile("执行接驳盒执行通道5关闭！");
                if (canBConnect.Text == "连接")
                {
                    for (int i = _1MySerClass.userList.Count - 1; i >= 0; i--)
                    {
                        _3ReceieveMsgClass ct = _1MySerClass.userList[i];
                        if (!ct.tcpClient.Connected || ((ct.tcpClient.Poll(1000, SelectMode.SelectRead)) && (ct.tcpClient.Available == 0)))
                        {
                            _1MySerClass.userList.Remove(ct);
                            continue;
                        }
                        else if (ct.nodeIP == txtBIP.Text.Trim())
                        {
                            ct.SendMessage("$SET+01+SIIM5+Close#", 2);

                            if (Delay(1))//延时10s
                            {
                                if (_3ReceieveMsgClass.flagOffA5 == 1)
                                {
                                    MessageBox.Show("执行成功！");
                                    LogCommand.WriteLogFile("接驳盒执行通道5关闭成功！");
                                    Ch5Close.Enabled = false;
                                    Ch5Open.Enabled = true;
                                    this.txtBCh5Status.Text = "关闭";
                                    this.txtBCh5Status.BackColor = Color.Red;
                                    this.txtBCh5Status.ForeColor = Color.White;

                                    this.txtBCh5Logo.Text = "正常";
                                    this.txtBCh5Logo.BackColor = Color.DarkSeaGreen;
                                    this.txtBCh5Logo.ForeColor = Color.White;
                                }
                                else
                                {

                                    ct.SendMessage("$SET+01+SIIM5+Close#", 2);//第二次重发
                                    Delay(2);

                                    if (_3ReceieveMsgClass.flagOffA5 == 1)
                                    {
                                        MessageBox.Show("执行成功！");
                                        LogCommand.WriteLogFile("接驳盒执行通道5关闭成功！");
                                        Ch5Close.Enabled = false;
                                        Ch5Open.Enabled = true;
                                        this.txtBCh5Status.Text = "关闭";
                                        this.txtBCh5Status.BackColor = Color.Red;
                                        this.txtBCh5Status.ForeColor = Color.White;

                                        this.txtBCh5Logo.Text = "正常";
                                        this.txtBCh5Logo.BackColor = Color.DarkSeaGreen;
                                        this.txtBCh5Logo.ForeColor = Color.White;
                                    }
                                    else
                                    {
                                        ct.SendMessage("$SET+01+SIIM5+Close#", 2);//第3次重发
                                        Delay(2);

                                        if (_3ReceieveMsgClass.flagOffA5 == 1)
                                        {
                                            MessageBox.Show("执行成功！");
                                            LogCommand.WriteLogFile("接驳盒执行通道5关闭成功！");
                                            Ch5Close.Enabled = false;
                                            Ch5Open.Enabled = true;
                                            this.txtBCh5Status.Text = "关闭";
                                            this.txtBCh5Status.BackColor = Color.Red;
                                            this.txtBCh5Status.ForeColor = Color.White;

                                            this.txtBCh5Logo.Text = "正常";
                                            this.txtBCh5Logo.BackColor = Color.DarkSeaGreen;
                                            this.txtBCh5Logo.ForeColor = Color.White;
                                        }
                                        else
                                        {
                                            MessageBox.Show("执行失败！");
                                            LogCommand.WriteLogFile("接驳盒执行通道5关闭失败！");
                                            this.txtBCh5Status.Text = "关闭失败";
                                            this.txtBCh5Status.ForeColor = Color.Black;
                                            this.txtBCh5Status.BackColor = Color.Yellow;
                                            Ch5Close.Enabled = true;
                                            Ch5Open.Enabled = false;
                                        }
                                    }
                                }
                            }
                            break;//break用于结束循环！
                        }
                        //else
                        //{
                        //    MessageBox.Show("无有效连接！");
                        //}
                    }
                }
                else
                {
                    MessageBox.Show("无可用连接！");
                }
            }
            catch (Exception exp)
            {
                LogClass.WriteLogFile("接驳盒执行通道5关闭异常！" + exp.Message);
            }
            _3ReceieveMsgClass.flagOffA5 = 0;
            this.Cursor = Cursors.Default; 
        }
        /// <summary>
        /// 将datagridview中的内容导出为excel表格形式
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void button17_Click(object sender, EventArgs e)
        {
            string fileName = "";

            string saveFileName = "";

            SaveFileDialog saveDialog = new SaveFileDialog();

            saveDialog.DefaultExt = "xlsx";

            saveDialog.Filter = "Excel文件|*.xlsx";

            saveDialog.FileName = fileName;

            saveDialog.ShowDialog();

            saveFileName = saveDialog.FileName;

            if (saveFileName.IndexOf(":") < 0) return; //被点了取消

            Microsoft.Office.Interop.Excel.Application xlApp = new Microsoft.Office.Interop.Excel.Application();

            if (xlApp == null)
            {

                MessageBox.Show("无法创建Excel对象，您的电脑可能未安装Excel");

                return;

            }

            Microsoft.Office.Interop.Excel.Workbooks workbooks = xlApp.Workbooks;

            Microsoft.Office.Interop.Excel.Workbook workbook = workbooks.Add(Microsoft.Office.Interop.Excel.XlWBATemplate.xlWBATWorksheet);

            Microsoft.Office.Interop.Excel.Worksheet worksheet = (Microsoft.Office.Interop.Excel.Worksheet)workbook.Worksheets[1];//取得sheet1 

            //写入标题             

            for (int i = 0; i < dgwData.ColumnCount; i++)

            { worksheet.Cells[1, i + 1] = dgwData.Columns[i].HeaderText; }

            //写入数值

            for (int r = 0; r < dgwData.Rows.Count; r++)
            {
                for (int i = 0; i < dgwData.ColumnCount; i++)
                {

                    worksheet.Cells[r + 2, i + 1] = dgwData.Rows[r].Cells[i].Value;

                }

                System.Windows.Forms.Application.DoEvents();

            }

            worksheet.Columns.EntireColumn.AutoFit();//列宽自适应

            MessageBox.Show(fileName + "导出成功!", "提示", MessageBoxButtons.OK);

            if (saveFileName != "")
            {

                try
                {
                    workbook.Saved = true;

                    workbook.SaveCopyAs(saveFileName);  //fileSaved = true;                 

                }

                catch (Exception ex)
                {//fileSaved = false;                      

                    MessageBox.Show("导出文件时出错,文件可能正被打开！\n" + ex.Message);

                }

            }

            xlApp.Quit();

            GC.Collect();          
        }
        /// <summary>
        /// 调取大华摄像头exe程序，将该exe程序内嵌到winform中
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void button18_Click(object sender, EventArgs e)
        {
            this.Cursor = Cursors.WaitCursor;
            try 
            {

                // 为了美观,启动的时候最小化程序
                p.StartInfo.WindowStyle = ProcessWindowStyle.Minimized;
                // 启动
                camera = p.Start();

                // 这里必须等待,否则启动程序的句柄还没有创建,不能控制程序
                Thread.Sleep(1000);
                // 最大化启动的程序
                ShowWindow(p.MainWindowHandle, (short)ShowWindowStyles.SW_MAXIMIZE);
                // 设置被绑架程序的父窗口
                SetParent(p.MainWindowHandle, this.wb1.Handle);
                ResizeControl(p);
            }
            catch(Exception exp) 
            {
                MessageBox.Show("加载exe程序出现异常！"+exp.Message);
            }
            this.Cursor = Cursors.Default;
        }


        /// <summary>
        /// 控制嵌入程序的位置和尺寸
        /// </summary>
        /// <param name="p"></param>
        private void ResizeControl(Process p)
        {
            SendMessage(p.MainWindowHandle, WM_COMMAND, WM_PAINT, 0);
            PostMessage(p.MainWindowHandle, WM_QT_PAINT, 0, 0);

            SetWindowPos(
                p.MainWindowHandle,
                HWND_TOP,
                0,  // 设置偏移量,把原来窗口的菜单遮住
                0,
                (int)this.Width,
                (int)this.Height,
                SWP_FRAMECHANGED);

            SendMessage(p.MainWindowHandle, WM_COMMAND, WM_SIZE, 0);
        }
        /// <summary>
        /// 读取高压舱电源值
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void button28_Click(object sender, EventArgs e)
        {
            try
            {
                if (canAConnect.Text == "连接")
                {
                    for (int i = _1MySerClass3.userList3.Count - 1; i >= 0; i--)
                    {
                        _3ReceieveMsgClass ct = _1MySerClass3.userList3[i];
                        if (!ct.tcpClient.Connected || ((ct.tcpClient.Poll(1000, SelectMode.SelectRead)) && (ct.tcpClient.Available == 0)))
                        {
                            _1MySerClass3.userList3.Remove(ct);
                            continue;
                        }
                        else if (ct.nodeIP == txtAIP.Text.Trim())
                        {
                            ct.SendMessage("0403000000098599", 1);
                            break;

                        }
                        else
                        {
                            MessageBox.Show("无有效连接！");
                        }
                    }
                }
                else
                {
                    MessageBox.Show("无可用连接！");
                  //  LogClass.WriteLogFile("读取高压舱电源数据指令无可用连接！");
                }
            }
            catch (Exception exp)
            {
                MessageBox.Show("读取高压舱电源数据指令出现异常！" + exp.Message);
            }
        }
        /// <summary>
        /// 高压舱主通道1打开指令
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void button19_Click(object sender, EventArgs e)
        {
            this.Cursor = Cursors.WaitCursor;
            _3ReceieveMsgClass.flagOnHighB1 = 0;
            try
            {
                LogCommand.WriteLogFile("执行主接驳盒通道1打开！");
                if (canAConnect.Text == "连接")
                {
                    for (int i = _1MySerClass3.userList3.Count - 1; i >= 0; i--)
                    {
                        _3ReceieveMsgClass ct = _1MySerClass3.userList3[i];
                        if (!ct.tcpClient.Connected || ((ct.tcpClient.Poll(1000, SelectMode.SelectRead)) && (ct.tcpClient.Available == 0)))
                        {
                            _1MySerClass3.userList3.Remove(ct);
                            continue;
                        }
                        else if (ct.nodeIP == txtAIP.Text.Trim())
                        {
                            ct.SendMessage("04050001FF00DDAF", 1);

                            if (Delay(1))//延时10s
                            {
                                if (_3ReceieveMsgClass.flagOnHighB1 == 1)
                                {
                                    MessageBox.Show("执行成功！");
                                    LogCommand.WriteLogFile("主接驳盒通道1打开成功！");
                                    this.txtACh1Status.Text = "打开";
                                    this.txtACh1Status.BackColor = Color.DarkSeaGreen;
                                    this.txtACh1Status.ForeColor = Color.White;

                                    HCh1Open.Enabled = false;
                                    HCh1Close.Enabled = true;
                                }
                                else
                                {
                                    ct.SendMessage("04050001FF00DDAF", 1);//第二次重发
                                    Delay(2);

                                    if (_3ReceieveMsgClass.flagOnHighB1 == 1)
                                    {
                                        MessageBox.Show("执行成功！");
                                        LogCommand.WriteLogFile("主接驳盒执行通道1打开成功！");
                                        this.txtACh1Status.Text = "打开";
                                        this.txtACh1Status.BackColor = Color.DarkSeaGreen;
                                        this.txtACh1Status.ForeColor = Color.White;

                                        HCh1Open.Enabled = false;
                                        HCh1Close.Enabled = true;
                                    }
                                    else
                                    {
                                        ct.SendMessage("04050001FF00DDAF", 1);//第3次重发
                                        Delay(2);
                                        if (_3ReceieveMsgClass.flagOnHighB1 == 1)
                                        {
                                            MessageBox.Show("执行成功！");
                                            LogCommand.WriteLogFile("主接驳盒执行通道1打开成功！");
                                            this.txtACh1Status.Text = "打开";
                                            this.txtACh1Status.BackColor = Color.DarkSeaGreen;
                                            this.txtACh1Status.ForeColor = Color.White;

                                            HCh1Open.Enabled = false;
                                            HCh1Close.Enabled = true;
                                        }
                                        else
                                        {
                                            MessageBox.Show("执行失败！");
                                            LogCommand.WriteLogFile("主接驳盒执行通道1打开失败！");
                                            HCh1Open.Enabled = true;
                                            HCh1Close.Enabled = false;
                                            this.txtACh1Status.Text = "打开失败";
                                            this.txtACh1Status.ForeColor = Color.Black;
                                            this.txtACh1Status.BackColor = Color.Yellow;
                                        }
                                    }
                                }
                            }
                            break;
                        }
                        else
                        {
                            MessageBox.Show("无有效连接！");
                        }
                    }
                }
                else
                {
                    MessageBox.Show("无可用连接！");
                }
            }
            catch (Exception exp)
            {
                LogClass.WriteLogFile("主接驳盒执行通道1打开异常！" + exp.Message);
            }
            _3ReceieveMsgClass.flagOnHighB1 = 0;
            this.Cursor = Cursors.Default;

        }
        /// <summary>
        /// 高压舱鑫宇航电源开机指令--高压舱电源也是默认包含发三遍指令
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void button26_Click(object sender, EventArgs e)
        {
            this.Cursor = Cursors.WaitCursor;
            _3ReceieveMsgClass.flagOnHighPower = 0;
            try
            {
                LogCommand.WriteLogFile("执行高压舱电源整体打开！");
                if (canAConnect.Text == "连接")
                {
                    for (int i = _1MySerClass3.userList3.Count - 1; i >= 0; i--)
                    {
                        _3ReceieveMsgClass ct = _1MySerClass3.userList3[i];
                        if (!ct.tcpClient.Connected || ((ct.tcpClient.Poll(1000, SelectMode.SelectRead)) && (ct.tcpClient.Available == 0)))
                        {
                            _1MySerClass3.userList3.Remove(ct);
                            continue;
                        }
                        else if (ct.nodeIP == txtAIP.Text.Trim())
                        {
                            ct.SendMessage("04050000FF008C6F", 1);

                            if (Delay(1))//延时10s
                            {
                                if (_3ReceieveMsgClass.flagOnHighPower == 1)
                                {                                  
                                    MessageBox.Show("执行成功！");
                                    LogCommand.WriteLogFile("高压舱电源整体打开成功！");

                                    this.txtACh0Status.Text = "打开";
                                    this.txtACh0Status.BackColor = Color.DarkSeaGreen;
                                    this.txtACh0Status.ForeColor = Color.White;

                                    btnHighPowOn.Enabled = false;
                                    btnHighPowOff.Enabled = true;
                                }
                                else
                                {
                                    ct.SendMessage("04050000FF008C6F", 1);//第二次重发
                                    Delay(2);

                                    if (_3ReceieveMsgClass.flagOnHighPower == 1)
                                    {
                                        MessageBox.Show("执行成功！");
                                        LogCommand.WriteLogFile("高压舱电源整体打开成功！");

                                        this.txtACh0Status.Text = "打开";
                                        this.txtACh0Status.BackColor = Color.DarkSeaGreen;
                                        this.txtACh0Status.ForeColor = Color.White;

                                        btnHighPowOn.Enabled = false;
                                        btnHighPowOff.Enabled = true;
                                    }
                                    else
                                    {
                                        ct.SendMessage("04050000FF008C6F", 1);//第3次重发
                                        Delay(2);

                                        if (_3ReceieveMsgClass.flagOnHighPower == 1)
                                        {
                                            MessageBox.Show("执行成功！");
                                            LogCommand.WriteLogFile("高压舱电源整体打开成功！");

                                            this.txtACh0Status.Text = "打开";
                                            this.txtACh0Status.BackColor = Color.DarkSeaGreen;
                                            this.txtACh0Status.ForeColor = Color.White;

                                            btnHighPowOn.Enabled = false;
                                            btnHighPowOff.Enabled = true;
                                        }
                                        else
                                        {
                                            MessageBox.Show("执行失败！");
                                            LogCommand.WriteLogFile("高压舱电源整体打开失败！");
                                            btnHighPowOn.Enabled = true;
                                            btnHighPowOff.Enabled = false;
                                            this.txtACh0Status.Text = "打开失败";
                                            this.txtACh0Status.ForeColor = Color.Black;
                                            this.txtACh0Status.BackColor = Color.Yellow;
                                        }
                                    }
                                }
                            }
                            break;
                        }
                        else
                        {
                            MessageBox.Show("无有效连接！");
                        }
                    }
                }
                else
                {
                    MessageBox.Show("无可用连接！");
                }
            }
            catch (Exception exp)
            {
                LogClass.WriteLogFile("高压舱电源整体打开异常！" + exp.Message);
            }
            _3ReceieveMsgClass.flagOnHighPower = 0;
            this.Cursor = Cursors.Default;
        }
        /// <summary>
        /// 高压舱电源整体关机
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void btnHighPowOff_Click(object sender, EventArgs e)
        {
            this.Cursor = Cursors.WaitCursor;
            _3ReceieveMsgClass.flagOffHighPower = 0;
            try
            {
                LogCommand.WriteLogFile("执行高压舱电源整体关机！");
                if (canAConnect.Text == "连接")
                {
                    for (int i = _1MySerClass3.userList3.Count - 1; i >= 0; i--)
                    {
                        _3ReceieveMsgClass ct = _1MySerClass3.userList3[i];
                        if (!ct.tcpClient.Connected || ((ct.tcpClient.Poll(1000, SelectMode.SelectRead)) && (ct.tcpClient.Available == 0)))
                        {
                            _1MySerClass3.userList3.Remove(ct);
                            continue;
                        }
                        else if (ct.nodeIP == txtAIP.Text.Trim())
                        {
                            ct.SendMessage("040500000000CD9F", 1);

                            if (Delay(1))//延时10s
                            {
                                if (_3ReceieveMsgClass.flagOffHighPower == 1)
                                {
                                    MessageBox.Show("执行成功！");
                                    LogCommand.WriteLogFile("高压舱电源整体关机成功！");

                                    this.txtACh0Status.Text = "关闭";
                                    this.txtACh0Status.BackColor = Color.Red;
                                    this.txtACh0Status.ForeColor = Color.White;


                                    //关机成功之后  主接驳盒前端后端所有的状态都应该变为正常
                                    this.txtACh0Logo.Text = "正常";
                                    this.txtACh0Logo.BackColor = Color.DarkSeaGreen;
                                    this.txtACh0Logo.ForeColor = Color.White;





                                    btnHighPowOff.Enabled = false;
                                    btnHighPowOn.Enabled = true;
                                }
                                else
                                {
                                    ct.SendMessage("040500000000CD9F", 1);//第二次重发
                                    Delay(2);

                                    if (_3ReceieveMsgClass.flagOffHighPower == 1)
                                    {
                                        MessageBox.Show("执行成功！");
                                        LogCommand.WriteLogFile("高压舱电源整体关机成功！");

                                        this.txtACh0Status.Text = "关闭";
                                        this.txtACh0Status.BackColor = Color.Red;
                                        this.txtACh0Status.ForeColor = Color.White;

                                        this.txtACh0Logo.Text = "正常";
                                        this.txtACh0Logo.BackColor = Color.DarkSeaGreen;
                                        this.txtACh0Logo.ForeColor = Color.White;


                                        this.txtACh1Logo.Text = "正常";
                                        this.txtACh1Logo.BackColor = Color.DarkSeaGreen;
                                        this.txtACh1Logo.ForeColor = Color.White;

                                        this.txtACh2Logo.Text = "正常";
                                        this.txtACh2Logo.BackColor = Color.DarkSeaGreen;
                                        this.txtACh2Logo.ForeColor = Color.White;

                                        btnHighPowOff.Enabled = false;
                                        btnHighPowOn.Enabled = true;
                                    }
                                    else
                                    {
                                        ct.SendMessage("040500000000CD9F", 1);//第3次重发
                                        Delay(2);

                                        if (_3ReceieveMsgClass.flagOffHighPower == 1)
                                        {
                                            MessageBox.Show("执行成功！");
                                            LogCommand.WriteLogFile("高压舱电源整体关机成功！");

                                            this.txtACh0Status.Text = "关闭";
                                            this.txtACh0Status.BackColor = Color.Red;
                                            this.txtACh0Status.ForeColor = Color.White;


                                            this.txtACh0Logo.Text = "正常";
                                            this.txtACh0Logo.BackColor = Color.DarkSeaGreen;
                                            this.txtACh0Logo.ForeColor = Color.White;


                                            this.txtACh1Logo.Text = "正常";
                                            this.txtACh1Logo.BackColor = Color.DarkSeaGreen;
                                            this.txtACh1Logo.ForeColor = Color.White;


                                            this.txtACh2Logo.Text = "正常";
                                            this.txtACh2Logo.BackColor = Color.DarkSeaGreen;
                                            this.txtACh2Logo.ForeColor = Color.White;


                                            btnHighPowOff.Enabled = false;
                                            btnHighPowOn.Enabled = true;
                                        }
                                        else
                                        {
                                            MessageBox.Show("执行失败！");
                                            LogCommand.WriteLogFile("高压舱电源整体关机失败！");
                                            btnHighPowOff.Enabled = true;
                                            btnHighPowOn.Enabled = false;

                                            this.txtACh0Status.Text = "关机失败";
                                            this.txtACh0Status.ForeColor = Color.Black;
                                            this.txtACh0Status.BackColor = Color.Yellow;


                                            this.txtACh1Status.Text = "关机失败";
                                            this.txtACh1Status.ForeColor = Color.Black;
                                            this.txtACh1Status.BackColor = Color.Yellow;

                                        }
                                    }
                                }
                            }
                            break;
                        }
                        else
                        {
                            MessageBox.Show("无有效连接！");
                        }
                    }
                }
                else
                {
                    MessageBox.Show("无可用连接！");
                }
            }
            catch (Exception exp)
            {
                LogClass.WriteLogFile("高压舱电源整体关机异常！" + exp.Message);
            }
            _3ReceieveMsgClass.flagOffHighPower = 0;
            this.Cursor = Cursors.Default;
        }
        /// <summary>
        /// 高压舱电源鑫宇航电源后端第一路关闭
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void HCh1Close_Click(object sender, EventArgs e)
        {
            this.Cursor = Cursors.WaitCursor;
            _3ReceieveMsgClass.flagOffHighB1 = 0;
            try
            {
                LogCommand.WriteLogFile("执行接驳盒执行通道1关闭！");
                if (canAConnect.Text == "连接")
                {
                    for (int i = _1MySerClass3.userList3.Count - 1; i >= 0; i--)
                    {
                        _3ReceieveMsgClass ct = _1MySerClass3.userList3[i];
                        if (!ct.tcpClient.Connected || ((ct.tcpClient.Poll(1000, SelectMode.SelectRead)) && (ct.tcpClient.Available == 0)))
                        {
                            _1MySerClass3.userList3.Remove(ct);
                            continue;
                        }
                        else if (ct.nodeIP == txtAIP.Text.Trim())
                        {
                            ct.SendMessage("0405000100009C5F", 1);

                            if (Delay(1))//延时10s
                            {
                                if (_3ReceieveMsgClass.flagOffHighB1 == 1)
                                {
                                    MessageBox.Show("执行成功！");
                                    LogCommand.WriteLogFile("主接驳盒执行通道1关闭成功！");

                                    HCh1Close.Enabled = false;
                                    HCh1Open.Enabled = true;
                                    this.txtACh1Status.Text = "关闭";
                                    this.txtACh1Status.BackColor = Color.Red;
                                    this.txtACh1Status.ForeColor = Color.White;

                                    this.txtACh1Logo.Text = "正常";
                                    this.txtACh1Logo.BackColor = Color.DarkSeaGreen;
                                    this.txtACh1Logo.ForeColor = Color.White;
                                }
                                else
                                {
                                    ct.SendMessage("0405000100009C5F", 1);//第二次重发
                                    Delay(2);

                                    if (_3ReceieveMsgClass.flagOffHighB1 == 1)
                                    {
                                        MessageBox.Show("执行成功！");
                                        LogCommand.WriteLogFile("主接驳盒执行通道1关闭成功！");
                                        HCh1Close.Enabled = false;
                                        HCh1Open.Enabled = true;
                                        this.txtACh1Status.Text = "关闭";
                                        this.txtACh1Status.BackColor = Color.Red;
                                        this.txtACh1Status.ForeColor = Color.White;

                                        this.txtACh1Logo.Text = "正常";
                                        this.txtACh1Logo.BackColor = Color.DarkSeaGreen;
                                        this.txtACh1Logo.ForeColor = Color.White;
                                    }
                                    else
                                    {
                                        ct.SendMessage("0405000100009C5F", 1);//第三次重发
                                        Delay(2);
                                        if (_3ReceieveMsgClass.flagOffHighB1 == 1)
                                        {
                                            MessageBox.Show("执行成功！");
                                            LogCommand.WriteLogFile("主接驳盒执行通道1关闭成功！");
                                            HCh1Close.Enabled = false;
                                            HCh1Open.Enabled = true;
                                            this.txtACh1Status.Text = "关闭";
                                            this.txtACh1Status.BackColor = Color.Red;
                                            this.txtACh1Status.ForeColor = Color.White;

                                            this.txtACh1Logo.Text = "正常";
                                            this.txtACh1Logo.BackColor = Color.DarkSeaGreen;
                                            this.txtACh1Logo.ForeColor = Color.White;
                                        }
                                        else
                                        {
                                            MessageBox.Show("执行失败！");
                                            LogCommand.WriteLogFile("主接驳盒执行通道1关闭失败！");
                                            this.txtACh1Status.Text = "关闭失败";
                                            this.txtACh1Status.ForeColor = Color.Black;
                                            this.txtACh1Status.BackColor = Color.Yellow;
                                            HCh1Close.Enabled = true;
                                            HCh1Open.Enabled = false;
                                        }
                                    }
                                }
                            }
                            break;
                        }
                        else
                        {
                            MessageBox.Show("无有效连接！");
                        }
                    }
                }
                else
                {
                    MessageBox.Show("无可用连接！");
                }
            }
            catch (Exception exp)
            {
                LogClass.WriteLogFile("高压舱执行通道1关闭异常！" + exp.Message);
            }
            _3ReceieveMsgClass.flagOffHighB1 = 0;
            this.Cursor = Cursors.Default;
        }
        /// <summary>
        /// 主接驳盒后端第二路打开
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void HCh2Open_Click(object sender, EventArgs e)
        {
            this.Cursor = Cursors.WaitCursor;
            _3ReceieveMsgClass.flagOnHighB2 = 0;
            try
            {
                LogCommand.WriteLogFile("执行主接驳盒通道2打开！");
                if (canAConnect.Text == "连接")
                {
                    for (int i = _1MySerClass3.userList3.Count - 1; i >= 0; i--)
                    {
                        _3ReceieveMsgClass ct = _1MySerClass3.userList3[i];
                        if (!ct.tcpClient.Connected || ((ct.tcpClient.Poll(1000, SelectMode.SelectRead)) && (ct.tcpClient.Available == 0)))
                        {
                            _1MySerClass3.userList3.Remove(ct);
                            continue;
                        }
                        else if (ct.nodeIP == txtAIP.Text.Trim())
                        {
                            ct.SendMessage("04050002FF002DAF", 1);

                            if (Delay(1))//延时10s
                            {
                                if (_3ReceieveMsgClass.flagOnHighB2 == 1)
                                {
                                    MessageBox.Show("执行成功！");
                                    LogCommand.WriteLogFile("主接驳盒通道2打开成功！");
                                    this.txtACh2Status.Text = "打开";
                                    this.txtACh2Status.BackColor = Color.DarkSeaGreen;
                                    this.txtACh2Status.ForeColor = Color.White;

                                    HCh2Open.Enabled = false;
                                    HCh2Close.Enabled = true;
                                }
                                else
                                {
                                    ct.SendMessage("04050002FF002DAF", 1);//第二次重发
                                    Delay(2);

                                    if (_3ReceieveMsgClass.flagOnHighB2 == 1)
                                    {
                                        MessageBox.Show("执行成功！");
                                        LogCommand.WriteLogFile("主接驳盒执行通道2打开成功！");
                                        this.txtACh2Status.Text = "打开";
                                        this.txtACh2Status.BackColor = Color.DarkSeaGreen;
                                        this.txtACh2Status.ForeColor = Color.White;

                                        HCh2Open.Enabled = false;
                                        HCh2Close.Enabled = true;
                                    }
                                    else
                                    {
                                        ct.SendMessage("04050002FF002DAF", 1);//第3次重发
                                        Delay(2);
                                        if (_3ReceieveMsgClass.flagOnHighB2 == 1)
                                        {
                                            MessageBox.Show("执行成功！");
                                            LogCommand.WriteLogFile("主接驳盒执行通道2打开成功！");
                                            this.txtACh2Status.Text = "打开";
                                            this.txtACh2Status.BackColor = Color.DarkSeaGreen;
                                            this.txtACh2Status.ForeColor = Color.White;

                                            HCh2Open.Enabled = false;
                                            HCh2Close.Enabled = true;
                                        }
                                        else
                                        {
                                            MessageBox.Show("执行失败！");
                                            LogCommand.WriteLogFile("主接驳盒执行通道2打开失败！");
                                            HCh2Open.Enabled = true;
                                            HCh2Close.Enabled = false;
                                            this.txtACh2Status.Text = "打开失败";
                                            this.txtACh2Status.ForeColor = Color.Black;
                                            this.txtACh2Status.BackColor = Color.Yellow;
                                        }
                                    }
                                }
                            }
                            break;
                        }
                        else
                        {
                            MessageBox.Show("无有效连接！");
                        }
                    }
                }
                else
                {
                    MessageBox.Show("无可用连接！");
                }
            }
            catch (Exception exp)
            {
                LogClass.WriteLogFile("主接驳盒执行通道2打开异常！" + exp.Message);
            }
            _3ReceieveMsgClass.flagOnHighB2 = 0;
            this.Cursor = Cursors.Default;
        }
        /// <summary>
        /// 主接驳盒通道2关闭指令
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void HCh2Close_Click(object sender, EventArgs e)
        {
            this.Cursor = Cursors.WaitCursor;
            _3ReceieveMsgClass.flagOffHighB2 = 0;
            try
            {
                LogCommand.WriteLogFile("执行接驳盒执行通道2关闭！");
                if (canAConnect.Text == "连接")
                {
                    for (int i = _1MySerClass3.userList3.Count - 1; i >= 0; i--)
                    {
                        _3ReceieveMsgClass ct = _1MySerClass3.userList3[i];
                        if (!ct.tcpClient.Connected || ((ct.tcpClient.Poll(1000, SelectMode.SelectRead)) && (ct.tcpClient.Available == 0)))
                        {
                            _1MySerClass3.userList3.Remove(ct);
                            continue;
                        }
                        else if (ct.nodeIP == txtAIP.Text.Trim())
                        {
                            ct.SendMessage("0405000200006C5F", 1);

                            if (Delay(1))//延时10s
                            {
                                if (_3ReceieveMsgClass.flagOffHighB2 == 1)
                                {
                                    MessageBox.Show("执行成功！");
                                    LogCommand.WriteLogFile("主接驳盒执行通道2关闭成功！");

                                    HCh2Close.Enabled = false;
                                    HCh2Open.Enabled = true;
                                    this.txtACh2Status.Text = "关闭";
                                    this.txtACh2Status.BackColor = Color.Red;
                                    this.txtACh2Status.ForeColor = Color.White;

                                    this.txtACh2Logo.Text = "正常";
                                    this.txtACh2Logo.BackColor = Color.DarkSeaGreen;
                                    this.txtACh2Logo.ForeColor = Color.White;
                                }
                                else
                                {
                                    ct.SendMessage("0405000200006C5F", 1);//第二次重发
                                    Delay(2);

                                    if (_3ReceieveMsgClass.flagOffHighB2 == 1)
                                    {
                                        MessageBox.Show("执行成功！");
                                        LogCommand.WriteLogFile("主接驳盒执行通道2关闭成功！");
                                        HCh2Close.Enabled = false;
                                        HCh2Open.Enabled = true;
                                        this.txtACh2Status.Text = "关闭";
                                        this.txtACh2Status.BackColor = Color.Red;
                                        this.txtACh2Status.ForeColor = Color.White;

                                        this.txtACh2Logo.Text = "正常";
                                        this.txtACh2Logo.BackColor = Color.DarkSeaGreen;
                                        this.txtACh2Logo.ForeColor = Color.White;
                                    }
                                    else
                                    {
                                        ct.SendMessage("0405000200006C5F", 1);//第三次重发
                                        Delay(2);
                                        if (_3ReceieveMsgClass.flagOffHighB2 == 1)
                                        {
                                            MessageBox.Show("执行成功！");
                                            LogCommand.WriteLogFile("主接驳盒执行通道2关闭成功！");
                                            HCh2Close.Enabled = false;
                                            HCh2Open.Enabled = true;
                                            this.txtACh2Status.Text = "关闭";
                                            this.txtACh2Status.BackColor = Color.Red;
                                            this.txtACh2Status.ForeColor = Color.White;

                                            this.txtACh2Logo.Text = "正常";
                                            this.txtACh2Logo.BackColor = Color.DarkSeaGreen;
                                            this.txtACh2Logo.ForeColor = Color.White;
                                        }
                                        else
                                        {
                                            MessageBox.Show("执行失败！");
                                            LogCommand.WriteLogFile("主接驳盒执行通道2关闭失败！");
                                            this.txtACh2Status.Text = "关闭失败";
                                            this.txtACh2Status.ForeColor = Color.Black;
                                            this.txtACh2Status.BackColor = Color.Yellow;
                                            HCh2Close.Enabled = true;
                                            HCh2Open.Enabled = false;
                                        }
                                    }
                                }
                            }
                            break;
                        }
                        else
                        {
                            MessageBox.Show("无有效连接！");
                        }
                    }
                }
                else
                {
                    MessageBox.Show("无可用连接！");
                }
            }
            catch (Exception exp)
            {
                LogClass.WriteLogFile("高压舱执行通道2关闭异常！" + exp.Message);
            }
            _3ReceieveMsgClass.flagOffHighB2 = 0;
            this.Cursor = Cursors.Default;
        }
        /// <summary>
        /// 首页执行按钮，弹出关于次级接驳盒指令设置的相关界面
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void button19_Click_1(object sender, EventArgs e)
        {
            cmdSet myCMD = new cmdSet(this);
            myCMD.ShowDialog();
        }
        /// <summary>
        /// 打开选中的对应串口，设置波特率、停止位、校验位等信息
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void button3_Click_1(object sender, EventArgs e)
        {
           // MessageBox.Show(cbSerial.Text);
            if(cbSerial.Text == "")
            {
                MessageBox.Show("请先选择串口！");
                return;
            }
            if (!sp1.IsOpen)//如果串口没有打开，将串口打开
            {
                try
                {

                    //设置串口号
                    string serialName = cbSerial.SelectedItem.ToString();
                    sp1.PortName = serialName;

                    //设置波特率，数据位以及停止位校验位
                    sp1.BaudRate = 19200;       //波特率
                    sp1.DataBits = 8;       //数据位
                    sp1.StopBits = StopBits.One;//停止位为1位
                    sp1.Parity = Parity.None;//无校验位

                    if (sp1.IsOpen == true)//如果打开状态，则先关闭一下
                    {
                        sp1.Close();
                    }

                    //设置必要控件不可用
                    cbSerial.Enabled = false;
                    sp1.Open();     //打开串口
                    //改变打开串口按钮状态改变
                    btnSwitch.Text = "关闭";
                    btnSwitch.BackColor = Color.Red;
                    btnSwitch.ForeColor = Color.White;

                }
                catch (System.Exception ex)
                {
                    MessageBox.Show("Error:" + ex.Message, "Error");
                    return;
                }
            }
            else
            {
                cbSerial.Enabled = true;
                sp1.Close(); //关闭串口

                btnSwitch.Text = "打开";
                btnSwitch.BackColor = Color.FromArgb(0, 192, 0);
                btnSwitch.ForeColor = Color.White;

            }

        }


        #region 内存回收
        [DllImport("kernel32.dll", EntryPoint = "SetProcessWorkingSetSize")]
        public static extern int SetProcessWorkingSetSize(IntPtr process, int minSize, int maxSize);
        /// <summary> 
        /// 释放内存
        /// </summary> 
        public static void ClearMemory()
        {
            try
            {
                GC.Collect();
                //GC.WaitForPendingFinalizers();
                if (Environment.OSVersion.Platform == PlatformID.Win32NT)
                {
                    SetProcessWorkingSetSize(System.Diagnostics.Process.GetCurrentProcess().Handle, -1, -1);
                }
            }
            catch(Exception exp)
            {
                LogClass.WriteLogFile("清理内存出现异常！"+exp.Message);
            }
            
        }
        #endregion
        

        

        

        


        

       

        



      
    }
}
